/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

























#include "../P2ElementwiseDiffusion.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDiffusion::computeInverseDiagonalOperatorValues_macro_2D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 0.66666666666666663;
       const real_t tmp_kernel_op_1 = 2.6666666666666665;
       const real_t tmp_kernel_op_2 = tmp_kernel_op_0 + tmp_kernel_op_1 - 3.0;
       const real_t tmp_kernel_op_3 = abs_det_jac_affine_GRAY*0.16666666666666666;
       const real_t tmp_kernel_op_4 = 2.6666666666666665;
       const real_t tmp_kernel_op_5 = 0.66666666666666663;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_4 + tmp_kernel_op_5 - 3.0;
       const real_t tmp_kernel_op_7 = abs_det_jac_affine_GRAY*0.16666666666666666;
       const real_t tmp_kernel_op_8 = 0.66666666666666663;
       const real_t tmp_kernel_op_9 = 0.66666666666666663;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_8 + tmp_kernel_op_9 - 3.0;
       const real_t tmp_kernel_op_11 = abs_det_jac_affine_GRAY*0.16666666666666666;
       const real_t tmp_kernel_op_12 = (jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY);
       const real_t tmp_kernel_op_13 = ((tmp_kernel_op_0 - 1.0)*(tmp_kernel_op_0 - 1.0));
       const real_t tmp_kernel_op_14 = (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY);
       const real_t tmp_kernel_op_15 = ((tmp_kernel_op_4 - 1.0)*(tmp_kernel_op_4 - 1.0));
       const real_t tmp_kernel_op_16 = ((tmp_kernel_op_8 - 1.0)*(tmp_kernel_op_8 - 1.0));
       const real_t tmp_kernel_op_17 = (jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY);
       const real_t tmp_kernel_op_18 = ((tmp_kernel_op_1 - 1.0)*(tmp_kernel_op_1 - 1.0));
       const real_t tmp_kernel_op_19 = (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY);
       const real_t tmp_kernel_op_20 = ((tmp_kernel_op_5 - 1.0)*(tmp_kernel_op_5 - 1.0));
       const real_t tmp_kernel_op_21 = ((tmp_kernel_op_9 - 1.0)*(tmp_kernel_op_9 - 1.0));
       const real_t tmp_kernel_op_22 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_23 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_24 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_25 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_26 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_5;
       const real_t tmp_kernel_op_27 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_4;
       const real_t tmp_kernel_op_28 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_5;
       const real_t tmp_kernel_op_29 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_4;
       const real_t tmp_kernel_op_30 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_9;
       const real_t tmp_kernel_op_31 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_8;
       const real_t tmp_kernel_op_32 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_9;
       const real_t tmp_kernel_op_33 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_8;
       const real_t tmp_kernel_op_34 = -tmp_kernel_op_0 - 1.333333333333333;
       const real_t tmp_kernel_op_35 = -tmp_kernel_op_4 + 2.666666666666667;
       const real_t tmp_kernel_op_36 = -tmp_kernel_op_8 + 2.666666666666667;
       const real_t tmp_kernel_op_37 = -tmp_kernel_op_1 + 2.666666666666667;
       const real_t tmp_kernel_op_38 = -tmp_kernel_op_5 - 1.333333333333333;
       const real_t tmp_kernel_op_39 = -tmp_kernel_op_9 + 2.666666666666667;
       const real_t elMatDiag_0 = tmp_kernel_op_11*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_10 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_10)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_10 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_10)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_10 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_10)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_10 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_10))) + tmp_kernel_op_3*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_2)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_2)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_2)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_2))) + tmp_kernel_op_7*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_6 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_6)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_6 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_6)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_6 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_6)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_6 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_6)));
       const real_t elMatDiag_1 = tmp_kernel_op_11*(tmp_kernel_op_12*tmp_kernel_op_16 + tmp_kernel_op_14*tmp_kernel_op_16) + tmp_kernel_op_3*(tmp_kernel_op_12*tmp_kernel_op_13 + tmp_kernel_op_13*tmp_kernel_op_14) + tmp_kernel_op_7*(tmp_kernel_op_12*tmp_kernel_op_15 + tmp_kernel_op_14*tmp_kernel_op_15);
       const real_t elMatDiag_2 = tmp_kernel_op_11*(tmp_kernel_op_17*tmp_kernel_op_21 + tmp_kernel_op_19*tmp_kernel_op_21) + tmp_kernel_op_3*(tmp_kernel_op_17*tmp_kernel_op_18 + tmp_kernel_op_18*tmp_kernel_op_19) + tmp_kernel_op_7*(tmp_kernel_op_17*tmp_kernel_op_20 + tmp_kernel_op_19*tmp_kernel_op_20);
       const real_t elMatDiag_3 = tmp_kernel_op_11*(((tmp_kernel_op_30 + tmp_kernel_op_31)*(tmp_kernel_op_30 + tmp_kernel_op_31)) + ((tmp_kernel_op_32 + tmp_kernel_op_33)*(tmp_kernel_op_32 + tmp_kernel_op_33))) + tmp_kernel_op_3*(((tmp_kernel_op_22 + tmp_kernel_op_23)*(tmp_kernel_op_22 + tmp_kernel_op_23)) + ((tmp_kernel_op_24 + tmp_kernel_op_25)*(tmp_kernel_op_24 + tmp_kernel_op_25))) + tmp_kernel_op_7*(((tmp_kernel_op_26 + tmp_kernel_op_27)*(tmp_kernel_op_26 + tmp_kernel_op_27)) + ((tmp_kernel_op_28 + tmp_kernel_op_29)*(tmp_kernel_op_28 + tmp_kernel_op_29)));
       const real_t elMatDiag_4 = tmp_kernel_op_11*(((jac_affine_inv_1_0_GRAY*tmp_kernel_op_36 - tmp_kernel_op_30)*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_36 - tmp_kernel_op_30)) + ((jac_affine_inv_1_1_GRAY*tmp_kernel_op_36 - tmp_kernel_op_32)*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_36 - tmp_kernel_op_32))) + tmp_kernel_op_3*(((jac_affine_inv_1_0_GRAY*tmp_kernel_op_34 - tmp_kernel_op_22)*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_34 - tmp_kernel_op_22)) + ((jac_affine_inv_1_1_GRAY*tmp_kernel_op_34 - tmp_kernel_op_24)*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_34 - tmp_kernel_op_24))) + tmp_kernel_op_7*(((jac_affine_inv_1_0_GRAY*tmp_kernel_op_35 - tmp_kernel_op_26)*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_35 - tmp_kernel_op_26)) + ((jac_affine_inv_1_1_GRAY*tmp_kernel_op_35 - tmp_kernel_op_28)*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_35 - tmp_kernel_op_28)));
       const real_t elMatDiag_5 = tmp_kernel_op_11*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_39 - tmp_kernel_op_31)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_39 - tmp_kernel_op_31)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_39 - tmp_kernel_op_33)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_39 - tmp_kernel_op_33))) + tmp_kernel_op_3*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_37 - tmp_kernel_op_23)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_37 - tmp_kernel_op_23)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_37 - tmp_kernel_op_25)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_37 - tmp_kernel_op_25))) + tmp_kernel_op_7*(((jac_affine_inv_0_0_GRAY*tmp_kernel_op_38 - tmp_kernel_op_27)*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_38 - tmp_kernel_op_27)) + ((jac_affine_inv_0_1_GRAY*tmp_kernel_op_38 - tmp_kernel_op_29)*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_38 - tmp_kernel_op_29)));
       const real_t tmp_moved_constant_0 = abs_det_jac_affine_BLUE*0.16666666666666666;
       const real_t tmp_moved_constant_1 = abs_det_jac_affine_BLUE*0.16666666666666666;
       const real_t tmp_moved_constant_2 = abs_det_jac_affine_BLUE*0.16666666666666666;
       const real_t tmp_moved_constant_3 = (jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE);
       const real_t tmp_moved_constant_4 = (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE);
       const real_t tmp_moved_constant_5 = (jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE);
       const real_t tmp_moved_constant_6 = (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE);
       const real_t tmp_moved_constant_7 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_8 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_9 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_10 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_11 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_5;
       const real_t tmp_moved_constant_12 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_4;
       const real_t tmp_moved_constant_13 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_5;
       const real_t tmp_moved_constant_14 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_4;
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_9;
       const real_t tmp_moved_constant_16 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_8;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_9;
       const real_t tmp_moved_constant_18 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_8;
       const real_t tmp_moved_constant_19 = tmp_moved_constant_0*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_2)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_2)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_2)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_2))) + tmp_moved_constant_1*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_6 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_6)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_6 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_6)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_6 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_6)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_6 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_6))) + tmp_moved_constant_2*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_10 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_10)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_10 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_10)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_10 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_10)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_10 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_10)));
       const real_t tmp_moved_constant_20 = tmp_moved_constant_0*(tmp_kernel_op_13*tmp_moved_constant_3 + tmp_kernel_op_13*tmp_moved_constant_4) + tmp_moved_constant_1*(tmp_kernel_op_15*tmp_moved_constant_3 + tmp_kernel_op_15*tmp_moved_constant_4) + tmp_moved_constant_2*(tmp_kernel_op_16*tmp_moved_constant_3 + tmp_kernel_op_16*tmp_moved_constant_4);
       const real_t tmp_moved_constant_21 = tmp_moved_constant_0*(tmp_kernel_op_18*tmp_moved_constant_5 + tmp_kernel_op_18*tmp_moved_constant_6) + tmp_moved_constant_1*(tmp_kernel_op_20*tmp_moved_constant_5 + tmp_kernel_op_20*tmp_moved_constant_6) + tmp_moved_constant_2*(tmp_kernel_op_21*tmp_moved_constant_5 + tmp_kernel_op_21*tmp_moved_constant_6);
       const real_t tmp_moved_constant_22 = tmp_moved_constant_0*(((tmp_moved_constant_10 + tmp_moved_constant_9)*(tmp_moved_constant_10 + tmp_moved_constant_9)) + ((tmp_moved_constant_7 + tmp_moved_constant_8)*(tmp_moved_constant_7 + tmp_moved_constant_8))) + tmp_moved_constant_1*(((tmp_moved_constant_11 + tmp_moved_constant_12)*(tmp_moved_constant_11 + tmp_moved_constant_12)) + ((tmp_moved_constant_13 + tmp_moved_constant_14)*(tmp_moved_constant_13 + tmp_moved_constant_14))) + tmp_moved_constant_2*(((tmp_moved_constant_15 + tmp_moved_constant_16)*(tmp_moved_constant_15 + tmp_moved_constant_16)) + ((tmp_moved_constant_17 + tmp_moved_constant_18)*(tmp_moved_constant_17 + tmp_moved_constant_18)));
       const real_t tmp_moved_constant_23 = tmp_moved_constant_0*(((jac_affine_inv_1_0_BLUE*tmp_kernel_op_34 - tmp_moved_constant_7)*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_34 - tmp_moved_constant_7)) + ((jac_affine_inv_1_1_BLUE*tmp_kernel_op_34 - tmp_moved_constant_9)*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_34 - tmp_moved_constant_9))) + tmp_moved_constant_1*(((jac_affine_inv_1_0_BLUE*tmp_kernel_op_35 - tmp_moved_constant_11)*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_35 - tmp_moved_constant_11)) + ((jac_affine_inv_1_1_BLUE*tmp_kernel_op_35 - tmp_moved_constant_13)*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_35 - tmp_moved_constant_13))) + tmp_moved_constant_2*(((jac_affine_inv_1_0_BLUE*tmp_kernel_op_36 - tmp_moved_constant_15)*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_36 - tmp_moved_constant_15)) + ((jac_affine_inv_1_1_BLUE*tmp_kernel_op_36 - tmp_moved_constant_17)*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_36 - tmp_moved_constant_17)));
       const real_t tmp_moved_constant_24 = tmp_moved_constant_0*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_37 - tmp_moved_constant_8)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_37 - tmp_moved_constant_8)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_37 - tmp_moved_constant_10)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_37 - tmp_moved_constant_10))) + tmp_moved_constant_1*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_38 - tmp_moved_constant_12)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_38 - tmp_moved_constant_12)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_38 - tmp_moved_constant_14)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_38 - tmp_moved_constant_14))) + tmp_moved_constant_2*(((jac_affine_inv_0_0_BLUE*tmp_kernel_op_39 - tmp_moved_constant_16)*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_39 - tmp_moved_constant_16)) + ((jac_affine_inv_0_1_BLUE*tmp_kernel_op_39 - tmp_moved_constant_18)*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_39 - tmp_moved_constant_18)));
       for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
       {
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(_mm256_set_pd(elMatDiag_0,elMatDiag_0,elMatDiag_0,elMatDiag_0),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(_mm256_set_pd(elMatDiag_1,elMatDiag_1,elMatDiag_1,elMatDiag_1),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(_mm256_set_pd(elMatDiag_2,elMatDiag_2,elMatDiag_2,elMatDiag_2),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(_mm256_set_pd(elMatDiag_3,elMatDiag_3,elMatDiag_3,elMatDiag_3),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(_mm256_set_pd(elMatDiag_4,elMatDiag_4,elMatDiag_4,elMatDiag_4),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(_mm256_set_pd(elMatDiag_5,elMatDiag_5,elMatDiag_5,elMatDiag_5),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                   }
                }
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21),_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24),_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                   }
                }
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                {
                   {
                      _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                      _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                      _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                      _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_3 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                      _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                      _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                   }
                }
                {
                   {
                      _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = tmp_moved_constant_19 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                      _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = tmp_moved_constant_20 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                      _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = tmp_moved_constant_21 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                      _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = tmp_moved_constant_22 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                      _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = tmp_moved_constant_23 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                      _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = tmp_moved_constant_24 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                   }
                }
             }
          }
          {
             {
                {
                   _data_invDiag_Vertex[ctr_1*(micro_edges_per_macro_edge + 2) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_1*(micro_edges_per_macro_edge + 2) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - 1];
                   _data_invDiag_Vertex[ctr_1*(micro_edges_per_macro_edge + 2) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_1*(micro_edges_per_macro_edge + 2) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2))];
                   _data_invDiag_Vertex[-ctr_1 + micro_edges_per_macro_edge + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - 1] = elMatDiag_2 + _data_invDiag_Vertex[-ctr_1 + micro_edges_per_macro_edge + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - 1];
                   _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) - 1] = elMatDiag_3 + _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) - 1];
                   _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) - 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) - 1];
                   _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_1*(micro_edges_per_macro_edge + 1) - ctr_1 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - 1];
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
