/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2VectorToP1ElementwiseDivergenceRotationAnnulusMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorToP1ElementwiseDivergenceRotationAnnulusMap::apply_macro_2D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_nxEdge, real_t * RESTRICT  _data_nxVertex, real_t * RESTRICT  _data_nyEdge, real_t * RESTRICT  _data_nyVertex, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t refVertex_0, real_t refVertex_1, real_t thrVertex_0, real_t thrVertex_1 ) const
{
    {
       const real_t _data_q_w [] = {-0.28125, 0.26041666666666669, 0.26041666666666669, 0.26041666666666669};
   
       const real_t _data_q_p_0 [] = {0.33333333333333331, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001};
   
       const real_t _data_q_p_1 [] = {0.33333333333333331, 0.59999999999999998, 0.20000000000000001, 0.20000000000000001};
   
       {
          /* FaceType.GRAY */
          const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
          const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
          const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
          const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
          const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
          const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
          const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
          const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
          const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_3 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_9 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 - p_affine_1_0;
                const real_t tmp_qloop_1 = p_affine_0_0 - p_affine_2_0;
                const real_t tmp_qloop_2 = p_affine_0_0 - tmp_qloop_0*_data_q_p_0[q] - tmp_qloop_1*_data_q_p_1[q];
                const real_t tmp_qloop_3 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_4 = -tmp_qloop_3;
                const real_t tmp_qloop_5 = (tmp_qloop_2*tmp_qloop_2);
                const real_t tmp_qloop_6 = p_affine_0_1 - p_affine_1_1;
                const real_t tmp_qloop_7 = p_affine_0_1 - p_affine_2_1;
                const real_t tmp_qloop_8 = p_affine_0_1 - tmp_qloop_6*_data_q_p_0[q] - tmp_qloop_7*_data_q_p_1[q];
                const real_t tmp_qloop_9 = (tmp_qloop_8*tmp_qloop_8);
                const real_t tmp_qloop_10 = tmp_qloop_5 + tmp_qloop_9;
                const real_t tmp_qloop_11 = pow(tmp_qloop_10, -0.50000000000000000);
                const real_t tmp_qloop_12 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_13 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_14 = -tmp_qloop_13;
                const real_t tmp_qloop_15 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_16 = 1.0 / (-tmp_qloop_12*tmp_qloop_4 + tmp_qloop_14*tmp_qloop_15);
                const real_t tmp_qloop_17 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_18 = -tmp_qloop_17;
                const real_t tmp_qloop_19 = tmp_qloop_16*tmp_qloop_18;
                const real_t tmp_qloop_20 = tmp_qloop_19*1.0;
                const real_t tmp_qloop_21 = tmp_qloop_11*tmp_qloop_20;
                const real_t tmp_qloop_22 = tmp_qloop_21*tmp_qloop_4;
                const real_t tmp_qloop_23 = pow(tmp_qloop_10, -1.5000000000000000);
                const real_t tmp_qloop_24 = radRayVertex + tmp_qloop_19*(-tmp_qloop_14*(-rayVertex_1 + tmp_qloop_8) + tmp_qloop_4*(-rayVertex_0 + tmp_qloop_2));
                const real_t tmp_qloop_25 = tmp_qloop_23*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_25*1.0;
                const real_t tmp_qloop_27 = tmp_qloop_2*tmp_qloop_22 + tmp_qloop_26*tmp_qloop_9;
                const real_t tmp_qloop_28 = tmp_qloop_14*tmp_qloop_21;
                const real_t tmp_qloop_29 = tmp_qloop_2*tmp_qloop_23*tmp_qloop_24*tmp_qloop_8*1.0 + tmp_qloop_2*tmp_qloop_28;
                const real_t tmp_qloop_30 = -tmp_qloop_29;
                const real_t tmp_qloop_31 = tmp_qloop_2*tmp_qloop_26;
                const real_t tmp_qloop_32 = tmp_qloop_22*tmp_qloop_8 - tmp_qloop_31*tmp_qloop_8;
                const real_t tmp_qloop_33 = tmp_qloop_23*tmp_qloop_24*tmp_qloop_5*1.0 - tmp_qloop_28*tmp_qloop_8;
                const real_t tmp_qloop_36 = tmp_qloop_20*tmp_qloop_23;
                const real_t tmp_qloop_37 = tmp_qloop_36*tmp_qloop_4;
                const real_t tmp_qloop_38 = tmp_qloop_37*tmp_qloop_5;
                const real_t tmp_qloop_39 = pow(tmp_qloop_10, -2.5000000000000000)*tmp_qloop_24*3.0;
                const real_t tmp_qloop_40 = tmp_qloop_2*tmp_qloop_39*tmp_qloop_9;
                const real_t tmp_qloop_41 = tmp_qloop_37*tmp_qloop_9 - tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_13*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_2*tmp_qloop_8;
                const real_t tmp_qloop_44 = tmp_qloop_37*tmp_qloop_43;
                const real_t tmp_qloop_45 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_46 = tmp_qloop_39*tmp_qloop_5*tmp_qloop_8;
                const real_t tmp_qloop_47 = tmp_qloop_26*tmp_qloop_8 - tmp_qloop_46;
                const real_t tmp_qloop_48 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_49 = tmp_qloop_14*tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_51 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_52 = tmp_qloop_50 + tmp_qloop_51 - 3.0;
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_27*tmp_qloop_33 - tmp_qloop_30*tmp_qloop_32);
                const real_t tmp_qloop_54 = tmp_qloop_33*tmp_qloop_53;
                const real_t tmp_qloop_55 = -tmp_qloop_32*tmp_qloop_53;
                const real_t tmp_qloop_56 = jac_affine_inv_0_0_GRAY*tmp_qloop_54 + jac_affine_inv_0_1_GRAY*tmp_qloop_55;
                const real_t tmp_qloop_57 = jac_affine_inv_1_0_GRAY*tmp_qloop_54 + jac_affine_inv_1_1_GRAY*tmp_qloop_55;
                const real_t tmp_qloop_58 = -tmp_qloop_52*tmp_qloop_56 - tmp_qloop_52*tmp_qloop_57;
                const real_t tmp_qloop_59 = -p_affine_0_0 + tmp_qloop_0*_data_q_p_0[q] + tmp_qloop_1*_data_q_p_1[q];
                const real_t tmp_qloop_60 = (tmp_qloop_59*tmp_qloop_59);
                const real_t tmp_qloop_61 = -p_affine_0_1 + tmp_qloop_6*_data_q_p_0[q] + tmp_qloop_7*_data_q_p_1[q];
                const real_t tmp_qloop_62 = (tmp_qloop_61*tmp_qloop_61);
                const real_t tmp_qloop_63 = tmp_qloop_60 + tmp_qloop_62;
                const real_t tmp_qloop_64 = tmp_qloop_17*1.0 / (tmp_qloop_12*tmp_qloop_3 - tmp_qloop_13*tmp_qloop_15);
                const real_t tmp_qloop_65 = pow(tmp_qloop_63, -0.50000000000000000)*tmp_qloop_64*1.0;
                const real_t tmp_qloop_66 = tmp_qloop_59*tmp_qloop_65;
                const real_t tmp_qloop_67 = tmp_qloop_13*(rayVertex_1 + tmp_qloop_61) - tmp_qloop_3*(rayVertex_0 + tmp_qloop_59);
                const real_t tmp_qloop_68 = pow(tmp_qloop_63, -1.5000000000000000)*1.0;
                const real_t tmp_qloop_69 = tmp_qloop_68*(radRayVertex + tmp_qloop_64*tmp_qloop_67);
                const real_t tmp_qloop_70 = tmp_qloop_61*tmp_qloop_65;
                const real_t tmp_qloop_71 = tmp_qloop_68*(radRayVertex + tmp_qloop_64*tmp_qloop_67);
                const real_t tmp_qloop_72 = tmp_qloop_59*tmp_qloop_61;
                const real_t tmp_qloop_73 = abs_det_jac_affine_GRAY*abs((tmp_qloop_13*tmp_qloop_66 - tmp_qloop_71*tmp_qloop_72)*(tmp_qloop_3*tmp_qloop_70 + tmp_qloop_69*tmp_qloop_72) - (tmp_qloop_13*tmp_qloop_70 + tmp_qloop_60*tmp_qloop_71)*(tmp_qloop_3*tmp_qloop_66 - tmp_qloop_62*tmp_qloop_69))*_data_q_w[q];
                const real_t tmp_qloop_74 = tmp_qloop_73*(1.0 - _data_q_p_0[q] - _data_q_p_1[q]);
                const real_t tmp_qloop_75 = tmp_qloop_50 - 1.0;
                const real_t tmp_qloop_76 = tmp_qloop_74*tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_51 - 1.0;
                const real_t tmp_qloop_78 = tmp_qloop_74*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_50*tmp_qloop_57;
                const real_t tmp_qloop_80 = tmp_qloop_51*tmp_qloop_56;
                const real_t tmp_qloop_81 = -tmp_qloop_79 - tmp_qloop_80;
                const real_t tmp_qloop_82 = -tmp_qloop_50 - 8.0*_data_q_p_1[q] + 4.0;
                const real_t tmp_qloop_83 = -tmp_qloop_57*tmp_qloop_82 + tmp_qloop_80;
                const real_t tmp_qloop_84 = -tmp_qloop_51 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_85 = -tmp_qloop_56*tmp_qloop_84 + tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_27*tmp_qloop_53;
                const real_t tmp_qloop_87 = tmp_qloop_29*tmp_qloop_53;
                const real_t tmp_qloop_88 = jac_affine_inv_0_0_GRAY*tmp_qloop_87 + jac_affine_inv_0_1_GRAY*tmp_qloop_86;
                const real_t tmp_qloop_89 = jac_affine_inv_1_0_GRAY*tmp_qloop_87 + jac_affine_inv_1_1_GRAY*tmp_qloop_86;
                const real_t tmp_qloop_90 = -tmp_qloop_52*tmp_qloop_88 - tmp_qloop_52*tmp_qloop_89;
                const real_t tmp_qloop_91 = tmp_qloop_50*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_51*tmp_qloop_88;
                const real_t tmp_qloop_93 = -tmp_qloop_91 - tmp_qloop_92;
                const real_t tmp_qloop_94 = -tmp_qloop_82*tmp_qloop_89 + tmp_qloop_92;
                const real_t tmp_qloop_95 = -tmp_qloop_84*tmp_qloop_88 + tmp_qloop_91;
                const real_t tmp_qloop_96 = tmp_qloop_73*_data_q_p_0[q];
                const real_t tmp_qloop_97 = tmp_qloop_75*tmp_qloop_96;
                const real_t tmp_qloop_98 = tmp_qloop_77*tmp_qloop_96;
                const real_t tmp_qloop_99 = tmp_qloop_73*_data_q_p_1[q];
                const real_t tmp_qloop_100 = tmp_qloop_75*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_77*tmp_qloop_99;
                const real_t jac_blending_0_0 = tmp_qloop_27;
                const real_t jac_blending_0_1 = tmp_qloop_30;
                const real_t jac_blending_1_0 = tmp_qloop_32;
                const real_t jac_blending_1_1 = tmp_qloop_33;
                const real_t tmp_qloop_34 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_35 = 1.0 / (tmp_qloop_34);
                const real_t abs_det_jac_blending = tmp_qloop_34;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_35;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_35;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_35;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_35;
                const real_t hessian_blending_0_0_0 = tmp_qloop_22 - tmp_qloop_38 + tmp_qloop_41;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_39*(tmp_qloop_8*tmp_qloop_8*tmp_qloop_8) + tmp_qloop_42*tmp_qloop_9 - tmp_qloop_44 + tmp_qloop_45*tmp_qloop_8;
                const real_t hessian_blending_0_0_1 = tmp_qloop_19*tmp_qloop_23*tmp_qloop_4*tmp_qloop_43*-2.0 - tmp_qloop_47;
                const real_t hessian_blending_1_0_1 = tmp_qloop_11*tmp_qloop_16*tmp_qloop_18*tmp_qloop_4*1.0 - tmp_qloop_31 - tmp_qloop_41 - tmp_qloop_48;
                const real_t hessian_blending_0_1_0 = tmp_qloop_14*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_5*1.0 - tmp_qloop_28 - tmp_qloop_44 - tmp_qloop_47;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_31 + tmp_qloop_40 - tmp_qloop_48 + tmp_qloop_49;
                const real_t hessian_blending_0_1_1 = tmp_qloop_2*tmp_qloop_45 - (tmp_qloop_2*tmp_qloop_2*tmp_qloop_2)*tmp_qloop_39 + tmp_qloop_38 + tmp_qloop_49;
                const real_t hessian_blending_1_1_1 = tmp_qloop_13*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_5*1.0 + tmp_qloop_14*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_9*1.0 - tmp_qloop_28 - tmp_qloop_46;
                const real_t q_tmp_0_0 = tmp_qloop_58*tmp_qloop_74;
                const real_t q_tmp_0_1 = -tmp_qloop_56*tmp_qloop_76;
                const real_t q_tmp_0_2 = -tmp_qloop_57*tmp_qloop_78;
                const real_t q_tmp_0_3 = tmp_qloop_74*tmp_qloop_81;
                const real_t q_tmp_0_4 = tmp_qloop_74*tmp_qloop_83;
                const real_t q_tmp_0_5 = tmp_qloop_74*tmp_qloop_85;
                const real_t q_tmp_0_6 = tmp_qloop_74*tmp_qloop_90;
                const real_t q_tmp_0_7 = -tmp_qloop_76*tmp_qloop_88;
                const real_t q_tmp_0_8 = -tmp_qloop_78*tmp_qloop_89;
                const real_t q_tmp_0_9 = tmp_qloop_74*tmp_qloop_93;
                const real_t q_tmp_0_10 = tmp_qloop_74*tmp_qloop_94;
                const real_t q_tmp_0_11 = tmp_qloop_74*tmp_qloop_95;
                const real_t q_tmp_1_0 = tmp_qloop_58*tmp_qloop_96;
                const real_t q_tmp_1_1 = -tmp_qloop_56*tmp_qloop_97;
                const real_t q_tmp_1_2 = -tmp_qloop_57*tmp_qloop_98;
                const real_t q_tmp_1_3 = tmp_qloop_81*tmp_qloop_96;
                const real_t q_tmp_1_4 = tmp_qloop_83*tmp_qloop_96;
                const real_t q_tmp_1_5 = tmp_qloop_85*tmp_qloop_96;
                const real_t q_tmp_1_6 = tmp_qloop_90*tmp_qloop_96;
                const real_t q_tmp_1_7 = -tmp_qloop_88*tmp_qloop_97;
                const real_t q_tmp_1_8 = -tmp_qloop_89*tmp_qloop_98;
                const real_t q_tmp_1_9 = tmp_qloop_93*tmp_qloop_96;
                const real_t q_tmp_1_10 = tmp_qloop_94*tmp_qloop_96;
                const real_t q_tmp_1_11 = tmp_qloop_95*tmp_qloop_96;
                const real_t q_tmp_2_0 = tmp_qloop_58*tmp_qloop_99;
                const real_t q_tmp_2_1 = -tmp_qloop_100*tmp_qloop_56;
                const real_t q_tmp_2_2 = -tmp_qloop_101*tmp_qloop_57;
                const real_t q_tmp_2_3 = tmp_qloop_81*tmp_qloop_99;
                const real_t q_tmp_2_4 = tmp_qloop_83*tmp_qloop_99;
                const real_t q_tmp_2_5 = tmp_qloop_85*tmp_qloop_99;
                const real_t q_tmp_2_6 = tmp_qloop_90*tmp_qloop_99;
                const real_t q_tmp_2_7 = -tmp_qloop_100*tmp_qloop_88;
                const real_t q_tmp_2_8 = -tmp_qloop_101*tmp_qloop_89;
                const real_t q_tmp_2_9 = tmp_qloop_93*tmp_qloop_99;
                const real_t q_tmp_2_10 = tmp_qloop_94*tmp_qloop_99;
                const real_t q_tmp_2_11 = tmp_qloop_95*tmp_qloop_99;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (nx_dof_4): (0.0));
             const bool tmp_kernel_op_3 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (ny_dof_5): (1.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (nx_dof_5): (0.0));
             const bool tmp_kernel_op_6 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_7 = ((tmp_kernel_op_6) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_8 = ((tmp_kernel_op_6) ? (ny_dof_0): (1.0));
             const bool tmp_kernel_op_9 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_10 = ((tmp_kernel_op_9) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_9) ? (ny_dof_1): (1.0));
             const bool tmp_kernel_op_12 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_12) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_12) ? (ny_dof_2): (1.0));
             const bool tmp_kernel_op_15 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_16 = ((tmp_kernel_op_15) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_15) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_6) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_9) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_12) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = ((tmp_kernel_op_15) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_0) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_23 = ((tmp_kernel_op_3) ? (-ny_dof_5): (1.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_18 + q_acc_0_6*tmp_kernel_op_7) + src_dof_1*(q_acc_0_1*tmp_kernel_op_19 + q_acc_0_7*tmp_kernel_op_10) + src_dof_10*(q_acc_0_10*tmp_kernel_op_1 + q_acc_0_4*tmp_kernel_op_2) + src_dof_11*(q_acc_0_11*tmp_kernel_op_4 + q_acc_0_5*tmp_kernel_op_5) + src_dof_2*(q_acc_0_2*tmp_kernel_op_20 + q_acc_0_8*tmp_kernel_op_13) + src_dof_3*(q_acc_0_3*tmp_kernel_op_21 + q_acc_0_9*tmp_kernel_op_16) + src_dof_4*(q_acc_0_10*tmp_kernel_op_2 + q_acc_0_4*tmp_kernel_op_22) + src_dof_5*(q_acc_0_11*tmp_kernel_op_5 + q_acc_0_5*tmp_kernel_op_23) + src_dof_6*(q_acc_0_0*tmp_kernel_op_7 + q_acc_0_6*tmp_kernel_op_8) + src_dof_7*(q_acc_0_1*tmp_kernel_op_10 + q_acc_0_7*tmp_kernel_op_11) + src_dof_8*(q_acc_0_2*tmp_kernel_op_13 + q_acc_0_8*tmp_kernel_op_14) + src_dof_9*(q_acc_0_3*tmp_kernel_op_16 + q_acc_0_9*tmp_kernel_op_17);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_18 + q_acc_1_6*tmp_kernel_op_7) + src_dof_1*(q_acc_1_1*tmp_kernel_op_19 + q_acc_1_7*tmp_kernel_op_10) + src_dof_10*(q_acc_1_10*tmp_kernel_op_1 + q_acc_1_4*tmp_kernel_op_2) + src_dof_11*(q_acc_1_11*tmp_kernel_op_4 + q_acc_1_5*tmp_kernel_op_5) + src_dof_2*(q_acc_1_2*tmp_kernel_op_20 + q_acc_1_8*tmp_kernel_op_13) + src_dof_3*(q_acc_1_3*tmp_kernel_op_21 + q_acc_1_9*tmp_kernel_op_16) + src_dof_4*(q_acc_1_10*tmp_kernel_op_2 + q_acc_1_4*tmp_kernel_op_22) + src_dof_5*(q_acc_1_11*tmp_kernel_op_5 + q_acc_1_5*tmp_kernel_op_23) + src_dof_6*(q_acc_1_0*tmp_kernel_op_7 + q_acc_1_6*tmp_kernel_op_8) + src_dof_7*(q_acc_1_1*tmp_kernel_op_10 + q_acc_1_7*tmp_kernel_op_11) + src_dof_8*(q_acc_1_2*tmp_kernel_op_13 + q_acc_1_8*tmp_kernel_op_14) + src_dof_9*(q_acc_1_3*tmp_kernel_op_16 + q_acc_1_9*tmp_kernel_op_17);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_18 + q_acc_2_6*tmp_kernel_op_7) + src_dof_1*(q_acc_2_1*tmp_kernel_op_19 + q_acc_2_7*tmp_kernel_op_10) + src_dof_10*(q_acc_2_10*tmp_kernel_op_1 + q_acc_2_4*tmp_kernel_op_2) + src_dof_11*(q_acc_2_11*tmp_kernel_op_4 + q_acc_2_5*tmp_kernel_op_5) + src_dof_2*(q_acc_2_2*tmp_kernel_op_20 + q_acc_2_8*tmp_kernel_op_13) + src_dof_3*(q_acc_2_3*tmp_kernel_op_21 + q_acc_2_9*tmp_kernel_op_16) + src_dof_4*(q_acc_2_10*tmp_kernel_op_2 + q_acc_2_4*tmp_kernel_op_22) + src_dof_5*(q_acc_2_11*tmp_kernel_op_5 + q_acc_2_5*tmp_kernel_op_23) + src_dof_6*(q_acc_2_0*tmp_kernel_op_7 + q_acc_2_6*tmp_kernel_op_8) + src_dof_7*(q_acc_2_1*tmp_kernel_op_10 + q_acc_2_7*tmp_kernel_op_11) + src_dof_8*(q_acc_2_2*tmp_kernel_op_13 + q_acc_2_8*tmp_kernel_op_14) + src_dof_9*(q_acc_2_3*tmp_kernel_op_16 + q_acc_2_9*tmp_kernel_op_17);
             _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
          }
       }
       {
          /* FaceType.BLUE */
          const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
          const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
          const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
          const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
          const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
          const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
          const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
          const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
          const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
          const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
          const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t src_dof_3 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t src_dof_9 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 - p_affine_1_0;
                const real_t tmp_qloop_1 = p_affine_0_0 - p_affine_2_0;
                const real_t tmp_qloop_2 = p_affine_0_0 - tmp_qloop_0*_data_q_p_0[q] - tmp_qloop_1*_data_q_p_1[q];
                const real_t tmp_qloop_3 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_4 = -tmp_qloop_3;
                const real_t tmp_qloop_5 = (tmp_qloop_2*tmp_qloop_2);
                const real_t tmp_qloop_6 = p_affine_0_1 - p_affine_1_1;
                const real_t tmp_qloop_7 = p_affine_0_1 - p_affine_2_1;
                const real_t tmp_qloop_8 = p_affine_0_1 - tmp_qloop_6*_data_q_p_0[q] - tmp_qloop_7*_data_q_p_1[q];
                const real_t tmp_qloop_9 = (tmp_qloop_8*tmp_qloop_8);
                const real_t tmp_qloop_10 = tmp_qloop_5 + tmp_qloop_9;
                const real_t tmp_qloop_11 = pow(tmp_qloop_10, -0.50000000000000000);
                const real_t tmp_qloop_12 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_13 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_14 = -tmp_qloop_13;
                const real_t tmp_qloop_15 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_16 = 1.0 / (-tmp_qloop_12*tmp_qloop_4 + tmp_qloop_14*tmp_qloop_15);
                const real_t tmp_qloop_17 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_18 = -tmp_qloop_17;
                const real_t tmp_qloop_19 = tmp_qloop_16*tmp_qloop_18;
                const real_t tmp_qloop_20 = tmp_qloop_19*1.0;
                const real_t tmp_qloop_21 = tmp_qloop_11*tmp_qloop_20;
                const real_t tmp_qloop_22 = tmp_qloop_21*tmp_qloop_4;
                const real_t tmp_qloop_23 = pow(tmp_qloop_10, -1.5000000000000000);
                const real_t tmp_qloop_24 = radRayVertex + tmp_qloop_19*(-tmp_qloop_14*(-rayVertex_1 + tmp_qloop_8) + tmp_qloop_4*(-rayVertex_0 + tmp_qloop_2));
                const real_t tmp_qloop_25 = tmp_qloop_23*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_25*1.0;
                const real_t tmp_qloop_27 = tmp_qloop_2*tmp_qloop_22 + tmp_qloop_26*tmp_qloop_9;
                const real_t tmp_qloop_28 = tmp_qloop_14*tmp_qloop_21;
                const real_t tmp_qloop_29 = tmp_qloop_2*tmp_qloop_23*tmp_qloop_24*tmp_qloop_8*1.0 + tmp_qloop_2*tmp_qloop_28;
                const real_t tmp_qloop_30 = -tmp_qloop_29;
                const real_t tmp_qloop_31 = tmp_qloop_2*tmp_qloop_26;
                const real_t tmp_qloop_32 = tmp_qloop_22*tmp_qloop_8 - tmp_qloop_31*tmp_qloop_8;
                const real_t tmp_qloop_33 = tmp_qloop_23*tmp_qloop_24*tmp_qloop_5*1.0 - tmp_qloop_28*tmp_qloop_8;
                const real_t tmp_qloop_36 = tmp_qloop_20*tmp_qloop_23;
                const real_t tmp_qloop_37 = tmp_qloop_36*tmp_qloop_4;
                const real_t tmp_qloop_38 = tmp_qloop_37*tmp_qloop_5;
                const real_t tmp_qloop_39 = pow(tmp_qloop_10, -2.5000000000000000)*tmp_qloop_24*3.0;
                const real_t tmp_qloop_40 = tmp_qloop_2*tmp_qloop_39*tmp_qloop_9;
                const real_t tmp_qloop_41 = tmp_qloop_37*tmp_qloop_9 - tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_13*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_2*tmp_qloop_8;
                const real_t tmp_qloop_44 = tmp_qloop_37*tmp_qloop_43;
                const real_t tmp_qloop_45 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_46 = tmp_qloop_39*tmp_qloop_5*tmp_qloop_8;
                const real_t tmp_qloop_47 = tmp_qloop_26*tmp_qloop_8 - tmp_qloop_46;
                const real_t tmp_qloop_48 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_49 = tmp_qloop_14*tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_51 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_52 = tmp_qloop_50 + tmp_qloop_51 - 3.0;
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_27*tmp_qloop_33 - tmp_qloop_30*tmp_qloop_32);
                const real_t tmp_qloop_54 = tmp_qloop_33*tmp_qloop_53;
                const real_t tmp_qloop_55 = -tmp_qloop_32*tmp_qloop_53;
                const real_t tmp_qloop_56 = jac_affine_inv_0_0_BLUE*tmp_qloop_54 + jac_affine_inv_0_1_BLUE*tmp_qloop_55;
                const real_t tmp_qloop_57 = jac_affine_inv_1_0_BLUE*tmp_qloop_54 + jac_affine_inv_1_1_BLUE*tmp_qloop_55;
                const real_t tmp_qloop_58 = -tmp_qloop_52*tmp_qloop_56 - tmp_qloop_52*tmp_qloop_57;
                const real_t tmp_qloop_59 = -p_affine_0_0 + tmp_qloop_0*_data_q_p_0[q] + tmp_qloop_1*_data_q_p_1[q];
                const real_t tmp_qloop_60 = (tmp_qloop_59*tmp_qloop_59);
                const real_t tmp_qloop_61 = -p_affine_0_1 + tmp_qloop_6*_data_q_p_0[q] + tmp_qloop_7*_data_q_p_1[q];
                const real_t tmp_qloop_62 = (tmp_qloop_61*tmp_qloop_61);
                const real_t tmp_qloop_63 = tmp_qloop_60 + tmp_qloop_62;
                const real_t tmp_qloop_64 = tmp_qloop_17*1.0 / (tmp_qloop_12*tmp_qloop_3 - tmp_qloop_13*tmp_qloop_15);
                const real_t tmp_qloop_65 = pow(tmp_qloop_63, -0.50000000000000000)*tmp_qloop_64*1.0;
                const real_t tmp_qloop_66 = tmp_qloop_59*tmp_qloop_65;
                const real_t tmp_qloop_67 = tmp_qloop_13*(rayVertex_1 + tmp_qloop_61) - tmp_qloop_3*(rayVertex_0 + tmp_qloop_59);
                const real_t tmp_qloop_68 = pow(tmp_qloop_63, -1.5000000000000000)*1.0;
                const real_t tmp_qloop_69 = tmp_qloop_68*(radRayVertex + tmp_qloop_64*tmp_qloop_67);
                const real_t tmp_qloop_70 = tmp_qloop_61*tmp_qloop_65;
                const real_t tmp_qloop_71 = tmp_qloop_68*(radRayVertex + tmp_qloop_64*tmp_qloop_67);
                const real_t tmp_qloop_72 = tmp_qloop_59*tmp_qloop_61;
                const real_t tmp_qloop_73 = abs_det_jac_affine_BLUE*abs((tmp_qloop_13*tmp_qloop_66 - tmp_qloop_71*tmp_qloop_72)*(tmp_qloop_3*tmp_qloop_70 + tmp_qloop_69*tmp_qloop_72) - (tmp_qloop_13*tmp_qloop_70 + tmp_qloop_60*tmp_qloop_71)*(tmp_qloop_3*tmp_qloop_66 - tmp_qloop_62*tmp_qloop_69))*_data_q_w[q];
                const real_t tmp_qloop_74 = tmp_qloop_73*(1.0 - _data_q_p_0[q] - _data_q_p_1[q]);
                const real_t tmp_qloop_75 = tmp_qloop_50 - 1.0;
                const real_t tmp_qloop_76 = tmp_qloop_74*tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_51 - 1.0;
                const real_t tmp_qloop_78 = tmp_qloop_74*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_50*tmp_qloop_57;
                const real_t tmp_qloop_80 = tmp_qloop_51*tmp_qloop_56;
                const real_t tmp_qloop_81 = -tmp_qloop_79 - tmp_qloop_80;
                const real_t tmp_qloop_82 = -tmp_qloop_50 - 8.0*_data_q_p_1[q] + 4.0;
                const real_t tmp_qloop_83 = -tmp_qloop_57*tmp_qloop_82 + tmp_qloop_80;
                const real_t tmp_qloop_84 = -tmp_qloop_51 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_85 = -tmp_qloop_56*tmp_qloop_84 + tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_27*tmp_qloop_53;
                const real_t tmp_qloop_87 = tmp_qloop_29*tmp_qloop_53;
                const real_t tmp_qloop_88 = jac_affine_inv_0_0_BLUE*tmp_qloop_87 + jac_affine_inv_0_1_BLUE*tmp_qloop_86;
                const real_t tmp_qloop_89 = jac_affine_inv_1_0_BLUE*tmp_qloop_87 + jac_affine_inv_1_1_BLUE*tmp_qloop_86;
                const real_t tmp_qloop_90 = -tmp_qloop_52*tmp_qloop_88 - tmp_qloop_52*tmp_qloop_89;
                const real_t tmp_qloop_91 = tmp_qloop_50*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_51*tmp_qloop_88;
                const real_t tmp_qloop_93 = -tmp_qloop_91 - tmp_qloop_92;
                const real_t tmp_qloop_94 = -tmp_qloop_82*tmp_qloop_89 + tmp_qloop_92;
                const real_t tmp_qloop_95 = -tmp_qloop_84*tmp_qloop_88 + tmp_qloop_91;
                const real_t tmp_qloop_96 = tmp_qloop_73*_data_q_p_0[q];
                const real_t tmp_qloop_97 = tmp_qloop_75*tmp_qloop_96;
                const real_t tmp_qloop_98 = tmp_qloop_77*tmp_qloop_96;
                const real_t tmp_qloop_99 = tmp_qloop_73*_data_q_p_1[q];
                const real_t tmp_qloop_100 = tmp_qloop_75*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_77*tmp_qloop_99;
                const real_t jac_blending_0_0 = tmp_qloop_27;
                const real_t jac_blending_0_1 = tmp_qloop_30;
                const real_t jac_blending_1_0 = tmp_qloop_32;
                const real_t jac_blending_1_1 = tmp_qloop_33;
                const real_t tmp_qloop_34 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_35 = 1.0 / (tmp_qloop_34);
                const real_t abs_det_jac_blending = tmp_qloop_34;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_35;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_35;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_35;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_35;
                const real_t hessian_blending_0_0_0 = tmp_qloop_22 - tmp_qloop_38 + tmp_qloop_41;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_39*(tmp_qloop_8*tmp_qloop_8*tmp_qloop_8) + tmp_qloop_42*tmp_qloop_9 - tmp_qloop_44 + tmp_qloop_45*tmp_qloop_8;
                const real_t hessian_blending_0_0_1 = tmp_qloop_19*tmp_qloop_23*tmp_qloop_4*tmp_qloop_43*-2.0 - tmp_qloop_47;
                const real_t hessian_blending_1_0_1 = tmp_qloop_11*tmp_qloop_16*tmp_qloop_18*tmp_qloop_4*1.0 - tmp_qloop_31 - tmp_qloop_41 - tmp_qloop_48;
                const real_t hessian_blending_0_1_0 = tmp_qloop_14*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_5*1.0 - tmp_qloop_28 - tmp_qloop_44 - tmp_qloop_47;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_31 + tmp_qloop_40 - tmp_qloop_48 + tmp_qloop_49;
                const real_t hessian_blending_0_1_1 = tmp_qloop_2*tmp_qloop_45 - (tmp_qloop_2*tmp_qloop_2*tmp_qloop_2)*tmp_qloop_39 + tmp_qloop_38 + tmp_qloop_49;
                const real_t hessian_blending_1_1_1 = tmp_qloop_13*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_5*1.0 + tmp_qloop_14*tmp_qloop_16*tmp_qloop_18*tmp_qloop_23*tmp_qloop_9*1.0 - tmp_qloop_28 - tmp_qloop_46;
                const real_t q_tmp_0_0 = tmp_qloop_58*tmp_qloop_74;
                const real_t q_tmp_0_1 = -tmp_qloop_56*tmp_qloop_76;
                const real_t q_tmp_0_2 = -tmp_qloop_57*tmp_qloop_78;
                const real_t q_tmp_0_3 = tmp_qloop_74*tmp_qloop_81;
                const real_t q_tmp_0_4 = tmp_qloop_74*tmp_qloop_83;
                const real_t q_tmp_0_5 = tmp_qloop_74*tmp_qloop_85;
                const real_t q_tmp_0_6 = tmp_qloop_74*tmp_qloop_90;
                const real_t q_tmp_0_7 = -tmp_qloop_76*tmp_qloop_88;
                const real_t q_tmp_0_8 = -tmp_qloop_78*tmp_qloop_89;
                const real_t q_tmp_0_9 = tmp_qloop_74*tmp_qloop_93;
                const real_t q_tmp_0_10 = tmp_qloop_74*tmp_qloop_94;
                const real_t q_tmp_0_11 = tmp_qloop_74*tmp_qloop_95;
                const real_t q_tmp_1_0 = tmp_qloop_58*tmp_qloop_96;
                const real_t q_tmp_1_1 = -tmp_qloop_56*tmp_qloop_97;
                const real_t q_tmp_1_2 = -tmp_qloop_57*tmp_qloop_98;
                const real_t q_tmp_1_3 = tmp_qloop_81*tmp_qloop_96;
                const real_t q_tmp_1_4 = tmp_qloop_83*tmp_qloop_96;
                const real_t q_tmp_1_5 = tmp_qloop_85*tmp_qloop_96;
                const real_t q_tmp_1_6 = tmp_qloop_90*tmp_qloop_96;
                const real_t q_tmp_1_7 = -tmp_qloop_88*tmp_qloop_97;
                const real_t q_tmp_1_8 = -tmp_qloop_89*tmp_qloop_98;
                const real_t q_tmp_1_9 = tmp_qloop_93*tmp_qloop_96;
                const real_t q_tmp_1_10 = tmp_qloop_94*tmp_qloop_96;
                const real_t q_tmp_1_11 = tmp_qloop_95*tmp_qloop_96;
                const real_t q_tmp_2_0 = tmp_qloop_58*tmp_qloop_99;
                const real_t q_tmp_2_1 = -tmp_qloop_100*tmp_qloop_56;
                const real_t q_tmp_2_2 = -tmp_qloop_101*tmp_qloop_57;
                const real_t q_tmp_2_3 = tmp_qloop_81*tmp_qloop_99;
                const real_t q_tmp_2_4 = tmp_qloop_83*tmp_qloop_99;
                const real_t q_tmp_2_5 = tmp_qloop_85*tmp_qloop_99;
                const real_t q_tmp_2_6 = tmp_qloop_90*tmp_qloop_99;
                const real_t q_tmp_2_7 = -tmp_qloop_100*tmp_qloop_88;
                const real_t q_tmp_2_8 = -tmp_qloop_101*tmp_qloop_89;
                const real_t q_tmp_2_9 = tmp_qloop_93*tmp_qloop_99;
                const real_t q_tmp_2_10 = tmp_qloop_94*tmp_qloop_99;
                const real_t q_tmp_2_11 = tmp_qloop_95*tmp_qloop_99;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (nx_dof_4): (0.0));
             const bool tmp_kernel_op_3 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (ny_dof_5): (1.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (nx_dof_5): (0.0));
             const bool tmp_kernel_op_6 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_7 = ((tmp_kernel_op_6) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_8 = ((tmp_kernel_op_6) ? (ny_dof_0): (1.0));
             const bool tmp_kernel_op_9 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_10 = ((tmp_kernel_op_9) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_9) ? (ny_dof_1): (1.0));
             const bool tmp_kernel_op_12 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_12) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_12) ? (ny_dof_2): (1.0));
             const bool tmp_kernel_op_15 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_16 = ((tmp_kernel_op_15) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_15) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_6) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_9) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_12) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = ((tmp_kernel_op_15) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_0) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_23 = ((tmp_kernel_op_3) ? (-ny_dof_5): (1.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_18 + q_acc_0_6*tmp_kernel_op_7) + src_dof_1*(q_acc_0_1*tmp_kernel_op_19 + q_acc_0_7*tmp_kernel_op_10) + src_dof_10*(q_acc_0_10*tmp_kernel_op_1 + q_acc_0_4*tmp_kernel_op_2) + src_dof_11*(q_acc_0_11*tmp_kernel_op_4 + q_acc_0_5*tmp_kernel_op_5) + src_dof_2*(q_acc_0_2*tmp_kernel_op_20 + q_acc_0_8*tmp_kernel_op_13) + src_dof_3*(q_acc_0_3*tmp_kernel_op_21 + q_acc_0_9*tmp_kernel_op_16) + src_dof_4*(q_acc_0_10*tmp_kernel_op_2 + q_acc_0_4*tmp_kernel_op_22) + src_dof_5*(q_acc_0_11*tmp_kernel_op_5 + q_acc_0_5*tmp_kernel_op_23) + src_dof_6*(q_acc_0_0*tmp_kernel_op_7 + q_acc_0_6*tmp_kernel_op_8) + src_dof_7*(q_acc_0_1*tmp_kernel_op_10 + q_acc_0_7*tmp_kernel_op_11) + src_dof_8*(q_acc_0_2*tmp_kernel_op_13 + q_acc_0_8*tmp_kernel_op_14) + src_dof_9*(q_acc_0_3*tmp_kernel_op_16 + q_acc_0_9*tmp_kernel_op_17);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_18 + q_acc_1_6*tmp_kernel_op_7) + src_dof_1*(q_acc_1_1*tmp_kernel_op_19 + q_acc_1_7*tmp_kernel_op_10) + src_dof_10*(q_acc_1_10*tmp_kernel_op_1 + q_acc_1_4*tmp_kernel_op_2) + src_dof_11*(q_acc_1_11*tmp_kernel_op_4 + q_acc_1_5*tmp_kernel_op_5) + src_dof_2*(q_acc_1_2*tmp_kernel_op_20 + q_acc_1_8*tmp_kernel_op_13) + src_dof_3*(q_acc_1_3*tmp_kernel_op_21 + q_acc_1_9*tmp_kernel_op_16) + src_dof_4*(q_acc_1_10*tmp_kernel_op_2 + q_acc_1_4*tmp_kernel_op_22) + src_dof_5*(q_acc_1_11*tmp_kernel_op_5 + q_acc_1_5*tmp_kernel_op_23) + src_dof_6*(q_acc_1_0*tmp_kernel_op_7 + q_acc_1_6*tmp_kernel_op_8) + src_dof_7*(q_acc_1_1*tmp_kernel_op_10 + q_acc_1_7*tmp_kernel_op_11) + src_dof_8*(q_acc_1_2*tmp_kernel_op_13 + q_acc_1_8*tmp_kernel_op_14) + src_dof_9*(q_acc_1_3*tmp_kernel_op_16 + q_acc_1_9*tmp_kernel_op_17);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_18 + q_acc_2_6*tmp_kernel_op_7) + src_dof_1*(q_acc_2_1*tmp_kernel_op_19 + q_acc_2_7*tmp_kernel_op_10) + src_dof_10*(q_acc_2_10*tmp_kernel_op_1 + q_acc_2_4*tmp_kernel_op_2) + src_dof_11*(q_acc_2_11*tmp_kernel_op_4 + q_acc_2_5*tmp_kernel_op_5) + src_dof_2*(q_acc_2_2*tmp_kernel_op_20 + q_acc_2_8*tmp_kernel_op_13) + src_dof_3*(q_acc_2_3*tmp_kernel_op_21 + q_acc_2_9*tmp_kernel_op_16) + src_dof_4*(q_acc_2_10*tmp_kernel_op_2 + q_acc_2_4*tmp_kernel_op_22) + src_dof_5*(q_acc_2_11*tmp_kernel_op_5 + q_acc_2_5*tmp_kernel_op_23) + src_dof_6*(q_acc_2_0*tmp_kernel_op_7 + q_acc_2_6*tmp_kernel_op_8) + src_dof_7*(q_acc_2_1*tmp_kernel_op_10 + q_acc_2_7*tmp_kernel_op_11) + src_dof_8*(q_acc_2_2*tmp_kernel_op_13 + q_acc_2_8*tmp_kernel_op_14) + src_dof_9*(q_acc_2_3*tmp_kernel_op_16 + q_acc_2_9*tmp_kernel_op_17);
             _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
