/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2VectorElementwiseEpsilonRotationAnnulusMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonRotationAnnulusMap::computeInverseDiagonalOperatorValues_macro_2D( real_t * RESTRICT  _data_invDiag__edge_0, real_t * RESTRICT  _data_invDiag__edge_1, real_t * RESTRICT  _data_invDiag__vertex_0, real_t * RESTRICT  _data_invDiag__vertex_1, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_nxEdge, real_t * RESTRICT  _data_nxVertex, real_t * RESTRICT  _data_nyEdge, real_t * RESTRICT  _data_nyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t refVertex_0, real_t refVertex_1, real_t thrVertex_0, real_t thrVertex_1 ) const
{
    {
       const real_t _data_q_w [] = {-0.28125, 0.26041666666666669, 0.26041666666666669, 0.26041666666666669};
   
       const real_t _data_q_p_0 [] = {0.33333333333333331, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001};
   
       const real_t _data_q_p_1 [] = {0.33333333333333331, 0.59999999999999998, 0.20000000000000001, 0.20000000000000001};
   
       {
          /* FaceType.GRAY */
          const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
          const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
          const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
          const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
          const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
          const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
          const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
          const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
          const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_3 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_8 = -tmp_qloop_7;
                const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
                const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
                const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
                const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_37 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_38 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38 - 3.0;
                const real_t tmp_qloop_40 = jac_affine_inv_0_0_GRAY*tmp_qloop_39 + jac_affine_inv_1_0_GRAY*tmp_qloop_39;
                const real_t tmp_qloop_42 = jac_affine_inv_0_1_GRAY*tmp_qloop_39 + jac_affine_inv_1_1_GRAY*tmp_qloop_39;
                const real_t tmp_qloop_44 = 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_45 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_46 = tmp_qloop_45*2.0;
                const real_t tmp_qloop_47 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_48 = tmp_qloop_47*2.0;
                const real_t tmp_qloop_49 = tmp_qloop_37*_data_q_p_1[q];
                const real_t tmp_qloop_50 = mu_dof_0*(tmp_qloop_46 + tmp_qloop_48 + tmp_qloop_49 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] + 1.0)*2.0 + mu_dof_1*(tmp_qloop_46 - _data_q_p_0[q])*2.0 + mu_dof_2*(tmp_qloop_48 - _data_q_p_1[q])*2.0 + mu_dof_3*tmp_qloop_44*_data_q_p_0[q] + mu_dof_4*(tmp_qloop_38 + tmp_qloop_47*-4.0 - tmp_qloop_49)*2.0 + mu_dof_5*(tmp_qloop_37 + tmp_qloop_45*-4.0 - tmp_qloop_49)*2.0;
                const real_t tmp_qloop_51 = tmp_qloop_50*0.5;
                const real_t tmp_qloop_56 = tmp_qloop_37 - 1.0;
                const real_t tmp_qloop_57 = jac_affine_inv_0_0_GRAY*tmp_qloop_56;
                const real_t tmp_qloop_59 = jac_affine_inv_0_1_GRAY*tmp_qloop_56;
                const real_t tmp_qloop_63 = tmp_qloop_38 - 1.0;
                const real_t tmp_qloop_64 = jac_affine_inv_1_0_GRAY*tmp_qloop_63;
                const real_t tmp_qloop_66 = jac_affine_inv_1_1_GRAY*tmp_qloop_63;
                const real_t tmp_qloop_70 = jac_affine_inv_1_0_GRAY*tmp_qloop_37;
                const real_t tmp_qloop_71 = jac_affine_inv_0_0_GRAY*tmp_qloop_38;
                const real_t tmp_qloop_72 = tmp_qloop_70 + tmp_qloop_71;
                const real_t tmp_qloop_74 = jac_affine_inv_1_1_GRAY*tmp_qloop_37;
                const real_t tmp_qloop_75 = jac_affine_inv_0_1_GRAY*tmp_qloop_38;
                const real_t tmp_qloop_76 = tmp_qloop_74 + tmp_qloop_75;
                const real_t tmp_qloop_80 = -tmp_qloop_37 - tmp_qloop_44 + 4.0;
                const real_t tmp_qloop_81 = jac_affine_inv_1_0_GRAY*tmp_qloop_80 - tmp_qloop_71;
                const real_t tmp_qloop_83 = jac_affine_inv_1_1_GRAY*tmp_qloop_80 - tmp_qloop_75;
                const real_t tmp_qloop_87 = -tmp_qloop_38 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_88 = jac_affine_inv_0_0_GRAY*tmp_qloop_87 - tmp_qloop_70;
                const real_t tmp_qloop_90 = jac_affine_inv_0_1_GRAY*tmp_qloop_87 - tmp_qloop_74;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_54 = abs_det_jac_affine_GRAY*abs_det_jac_blending*_data_q_w[q];
                const real_t tmp_qloop_55 = tmp_qloop_50*tmp_qloop_54*2.0;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_52 = jac_blending_inv_0_0*tmp_qloop_40;
                const real_t tmp_qloop_61 = jac_blending_inv_0_0*tmp_qloop_57;
                const real_t tmp_qloop_68 = jac_blending_inv_0_0*tmp_qloop_64;
                const real_t tmp_qloop_78 = jac_blending_inv_0_0*tmp_qloop_72;
                const real_t tmp_qloop_85 = jac_blending_inv_0_0*tmp_qloop_81;
                const real_t tmp_qloop_92 = jac_blending_inv_0_0*tmp_qloop_88;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_41 = jac_blending_inv_0_1*tmp_qloop_40;
                const real_t tmp_qloop_58 = jac_blending_inv_0_1*tmp_qloop_57;
                const real_t tmp_qloop_65 = jac_blending_inv_0_1*tmp_qloop_64;
                const real_t tmp_qloop_73 = jac_blending_inv_0_1*tmp_qloop_72;
                const real_t tmp_qloop_82 = jac_blending_inv_0_1*tmp_qloop_81;
                const real_t tmp_qloop_89 = jac_blending_inv_0_1*tmp_qloop_88;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_53 = jac_blending_inv_1_0*tmp_qloop_42;
                const real_t tmp_qloop_62 = jac_blending_inv_1_0*tmp_qloop_59;
                const real_t tmp_qloop_69 = jac_blending_inv_1_0*tmp_qloop_66;
                const real_t tmp_qloop_79 = jac_blending_inv_1_0*tmp_qloop_76;
                const real_t tmp_qloop_86 = jac_blending_inv_1_0*tmp_qloop_83;
                const real_t tmp_qloop_93 = jac_blending_inv_1_0*tmp_qloop_90;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_43 = jac_blending_inv_1_1*tmp_qloop_42;
                const real_t tmp_qloop_60 = jac_blending_inv_1_1*tmp_qloop_59;
                const real_t tmp_qloop_67 = jac_blending_inv_1_1*tmp_qloop_66;
                const real_t tmp_qloop_77 = jac_blending_inv_1_1*tmp_qloop_76;
                const real_t tmp_qloop_84 = jac_blending_inv_1_1*tmp_qloop_83;
                const real_t tmp_qloop_91 = jac_blending_inv_1_1*tmp_qloop_90;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_52*1.0 + tmp_qloop_53*1.0)*(tmp_qloop_52*1.0 + tmp_qloop_53*1.0)) + tmp_qloop_51*((tmp_qloop_41 + tmp_qloop_43)*(tmp_qloop_41 + tmp_qloop_43)));
                const real_t q_tmp_0_6 = tmp_qloop_55*(tmp_qloop_41*0.5 + tmp_qloop_43*0.5)*(tmp_qloop_52*0.5 + tmp_qloop_53*0.5);
                const real_t q_tmp_1_1 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_61*1.0 + tmp_qloop_62*1.0)*(tmp_qloop_61*1.0 + tmp_qloop_62*1.0)) + tmp_qloop_51*((tmp_qloop_58 + tmp_qloop_60)*(tmp_qloop_58 + tmp_qloop_60)));
                const real_t q_tmp_1_7 = tmp_qloop_55*(tmp_qloop_58*0.5 + tmp_qloop_60*0.5)*(tmp_qloop_61*0.5 + tmp_qloop_62*0.5);
                const real_t q_tmp_2_2 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_68*1.0 + tmp_qloop_69*1.0)*(tmp_qloop_68*1.0 + tmp_qloop_69*1.0)) + tmp_qloop_51*((tmp_qloop_65 + tmp_qloop_67)*(tmp_qloop_65 + tmp_qloop_67)));
                const real_t q_tmp_2_8 = tmp_qloop_55*(tmp_qloop_65*0.5 + tmp_qloop_67*0.5)*(tmp_qloop_68*0.5 + tmp_qloop_69*0.5);
                const real_t q_tmp_3_3 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_78*1.0 + tmp_qloop_79*1.0)*(tmp_qloop_78*1.0 + tmp_qloop_79*1.0)) + tmp_qloop_51*((tmp_qloop_73 + tmp_qloop_77)*(tmp_qloop_73 + tmp_qloop_77)));
                const real_t q_tmp_3_9 = tmp_qloop_55*(tmp_qloop_73*0.5 + tmp_qloop_77*0.5)*(tmp_qloop_78*0.5 + tmp_qloop_79*0.5);
                const real_t q_tmp_4_4 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_85*1.0 + tmp_qloop_86*1.0)*(tmp_qloop_85*1.0 + tmp_qloop_86*1.0)) + tmp_qloop_51*((tmp_qloop_82 + tmp_qloop_84)*(tmp_qloop_82 + tmp_qloop_84)));
                const real_t q_tmp_4_10 = tmp_qloop_55*(tmp_qloop_82*0.5 + tmp_qloop_84*0.5)*(tmp_qloop_85*0.5 + tmp_qloop_86*0.5);
                const real_t q_tmp_5_5 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_92*1.0 + tmp_qloop_93*1.0)*(tmp_qloop_92*1.0 + tmp_qloop_93*1.0)) + tmp_qloop_51*((tmp_qloop_89 + tmp_qloop_91)*(tmp_qloop_89 + tmp_qloop_91)));
                const real_t q_tmp_5_11 = tmp_qloop_55*(tmp_qloop_89*0.5 + tmp_qloop_91*0.5)*(tmp_qloop_92*0.5 + tmp_qloop_93*0.5);
                const real_t q_tmp_6_6 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_41*1.0 + tmp_qloop_43*1.0)*(tmp_qloop_41*1.0 + tmp_qloop_43*1.0)) + tmp_qloop_51*((tmp_qloop_52 + tmp_qloop_53)*(tmp_qloop_52 + tmp_qloop_53)));
                const real_t q_tmp_7_7 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_58*1.0 + tmp_qloop_60*1.0)*(tmp_qloop_58*1.0 + tmp_qloop_60*1.0)) + tmp_qloop_51*((tmp_qloop_61 + tmp_qloop_62)*(tmp_qloop_61 + tmp_qloop_62)));
                const real_t q_tmp_8_8 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_65*1.0 + tmp_qloop_67*1.0)*(tmp_qloop_65*1.0 + tmp_qloop_67*1.0)) + tmp_qloop_51*((tmp_qloop_68 + tmp_qloop_69)*(tmp_qloop_68 + tmp_qloop_69)));
                const real_t q_tmp_9_9 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_73*1.0 + tmp_qloop_77*1.0)*(tmp_qloop_73*1.0 + tmp_qloop_77*1.0)) + tmp_qloop_51*((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79)));
                const real_t q_tmp_10_10 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_82*1.0 + tmp_qloop_84*1.0)*(tmp_qloop_82*1.0 + tmp_qloop_84*1.0)) + tmp_qloop_51*((tmp_qloop_85 + tmp_qloop_86)*(tmp_qloop_85 + tmp_qloop_86)));
                const real_t q_tmp_11_11 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_89*1.0 + tmp_qloop_91*1.0)*(tmp_qloop_89*1.0 + tmp_qloop_91*1.0)) + tmp_qloop_51*((tmp_qloop_92 + tmp_qloop_93)*(tmp_qloop_92 + tmp_qloop_93)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_3 = q_acc_0_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_4 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_4) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_4) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_7 = q_acc_1_7*tmp_kernel_op_5;
             const bool tmp_kernel_op_8 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_9 = ((tmp_kernel_op_8) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_10 = ((tmp_kernel_op_8) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_11 = q_acc_2_8*tmp_kernel_op_9;
             const bool tmp_kernel_op_12 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_12) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_12) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_15 = q_acc_3_9*tmp_kernel_op_13;
             const bool tmp_kernel_op_16 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_16) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_16) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_19 = q_acc_4_10*tmp_kernel_op_17;
             const bool tmp_kernel_op_20 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_21 = ((tmp_kernel_op_20) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_20) ? (-ny_dof_5): (1.0));
             const real_t tmp_kernel_op_23 = q_acc_5_11*tmp_kernel_op_21;
             const real_t tmp_kernel_op_24 = ((tmp_kernel_op_0) ? (ny_dof_0): (1.0));
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_4) ? (ny_dof_1): (1.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_8) ? (ny_dof_2): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_12) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_28 = ((tmp_kernel_op_16) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_29 = ((tmp_kernel_op_20) ? (ny_dof_5): (1.0));
             const real_t elMatDiag_0 = tmp_kernel_op_1*(q_acc_0_6*tmp_kernel_op_2 + q_acc_6_6*tmp_kernel_op_1) + tmp_kernel_op_2*(q_acc_0_0*tmp_kernel_op_2 + tmp_kernel_op_3);
             const real_t elMatDiag_1 = tmp_kernel_op_5*(q_acc_1_7*tmp_kernel_op_6 + q_acc_7_7*tmp_kernel_op_5) + tmp_kernel_op_6*(q_acc_1_1*tmp_kernel_op_6 + tmp_kernel_op_7);
             const real_t elMatDiag_2 = tmp_kernel_op_10*(q_acc_2_2*tmp_kernel_op_10 + tmp_kernel_op_11) + tmp_kernel_op_9*(q_acc_2_8*tmp_kernel_op_10 + q_acc_8_8*tmp_kernel_op_9);
             const real_t elMatDiag_3 = tmp_kernel_op_13*(q_acc_3_9*tmp_kernel_op_14 + q_acc_9_9*tmp_kernel_op_13) + tmp_kernel_op_14*(q_acc_3_3*tmp_kernel_op_14 + tmp_kernel_op_15);
             const real_t elMatDiag_4 = tmp_kernel_op_17*(q_acc_10_10*tmp_kernel_op_17 + q_acc_4_10*tmp_kernel_op_18) + tmp_kernel_op_18*(q_acc_4_4*tmp_kernel_op_18 + tmp_kernel_op_19);
             const real_t elMatDiag_5 = tmp_kernel_op_21*(q_acc_11_11*tmp_kernel_op_21 + q_acc_5_11*tmp_kernel_op_22) + tmp_kernel_op_22*(q_acc_5_5*tmp_kernel_op_22 + tmp_kernel_op_23);
             const real_t elMatDiag_6 = tmp_kernel_op_1*(q_acc_0_0*tmp_kernel_op_1 + q_acc_0_6*tmp_kernel_op_24) + tmp_kernel_op_24*(q_acc_6_6*tmp_kernel_op_24 + tmp_kernel_op_3);
             const real_t elMatDiag_7 = tmp_kernel_op_25*(q_acc_7_7*tmp_kernel_op_25 + tmp_kernel_op_7) + tmp_kernel_op_5*(q_acc_1_1*tmp_kernel_op_5 + q_acc_1_7*tmp_kernel_op_25);
             const real_t elMatDiag_8 = tmp_kernel_op_26*(q_acc_8_8*tmp_kernel_op_26 + tmp_kernel_op_11) + tmp_kernel_op_9*(q_acc_2_2*tmp_kernel_op_9 + q_acc_2_8*tmp_kernel_op_26);
             const real_t elMatDiag_9 = tmp_kernel_op_13*(q_acc_3_3*tmp_kernel_op_13 + q_acc_3_9*tmp_kernel_op_27) + tmp_kernel_op_27*(q_acc_9_9*tmp_kernel_op_27 + tmp_kernel_op_15);
             const real_t elMatDiag_10 = tmp_kernel_op_17*(q_acc_4_10*tmp_kernel_op_28 + q_acc_4_4*tmp_kernel_op_17) + tmp_kernel_op_28*(q_acc_10_10*tmp_kernel_op_28 + tmp_kernel_op_19);
             const real_t elMatDiag_11 = tmp_kernel_op_21*(q_acc_5_11*tmp_kernel_op_29 + q_acc_5_5*tmp_kernel_op_21) + tmp_kernel_op_29*(q_acc_11_11*tmp_kernel_op_29 + tmp_kernel_op_23);
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_3 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_6 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_7 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_8 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_9 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_10 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_11 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
          }
       }
       {
          /* FaceType.BLUE */
          const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
          const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
          const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
          const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
          const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
          const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
          const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
          const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
          const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
          const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
          const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t mu_dof_3 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_8 = -tmp_qloop_7;
                const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
                const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
                const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
                const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_37 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_38 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38 - 3.0;
                const real_t tmp_qloop_40 = jac_affine_inv_0_0_BLUE*tmp_qloop_39 + jac_affine_inv_1_0_BLUE*tmp_qloop_39;
                const real_t tmp_qloop_42 = jac_affine_inv_0_1_BLUE*tmp_qloop_39 + jac_affine_inv_1_1_BLUE*tmp_qloop_39;
                const real_t tmp_qloop_44 = 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_45 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_46 = tmp_qloop_45*2.0;
                const real_t tmp_qloop_47 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_48 = tmp_qloop_47*2.0;
                const real_t tmp_qloop_49 = tmp_qloop_37*_data_q_p_1[q];
                const real_t tmp_qloop_50 = mu_dof_0*(tmp_qloop_46 + tmp_qloop_48 + tmp_qloop_49 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] + 1.0)*2.0 + mu_dof_1*(tmp_qloop_46 - _data_q_p_0[q])*2.0 + mu_dof_2*(tmp_qloop_48 - _data_q_p_1[q])*2.0 + mu_dof_3*tmp_qloop_44*_data_q_p_0[q] + mu_dof_4*(tmp_qloop_38 + tmp_qloop_47*-4.0 - tmp_qloop_49)*2.0 + mu_dof_5*(tmp_qloop_37 + tmp_qloop_45*-4.0 - tmp_qloop_49)*2.0;
                const real_t tmp_qloop_51 = tmp_qloop_50*0.5;
                const real_t tmp_qloop_56 = tmp_qloop_37 - 1.0;
                const real_t tmp_qloop_57 = jac_affine_inv_0_0_BLUE*tmp_qloop_56;
                const real_t tmp_qloop_59 = jac_affine_inv_0_1_BLUE*tmp_qloop_56;
                const real_t tmp_qloop_63 = tmp_qloop_38 - 1.0;
                const real_t tmp_qloop_64 = jac_affine_inv_1_0_BLUE*tmp_qloop_63;
                const real_t tmp_qloop_66 = jac_affine_inv_1_1_BLUE*tmp_qloop_63;
                const real_t tmp_qloop_70 = jac_affine_inv_1_0_BLUE*tmp_qloop_37;
                const real_t tmp_qloop_71 = jac_affine_inv_0_0_BLUE*tmp_qloop_38;
                const real_t tmp_qloop_72 = tmp_qloop_70 + tmp_qloop_71;
                const real_t tmp_qloop_74 = jac_affine_inv_1_1_BLUE*tmp_qloop_37;
                const real_t tmp_qloop_75 = jac_affine_inv_0_1_BLUE*tmp_qloop_38;
                const real_t tmp_qloop_76 = tmp_qloop_74 + tmp_qloop_75;
                const real_t tmp_qloop_80 = -tmp_qloop_37 - tmp_qloop_44 + 4.0;
                const real_t tmp_qloop_81 = jac_affine_inv_1_0_BLUE*tmp_qloop_80 - tmp_qloop_71;
                const real_t tmp_qloop_83 = jac_affine_inv_1_1_BLUE*tmp_qloop_80 - tmp_qloop_75;
                const real_t tmp_qloop_87 = -tmp_qloop_38 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_88 = jac_affine_inv_0_0_BLUE*tmp_qloop_87 - tmp_qloop_70;
                const real_t tmp_qloop_90 = jac_affine_inv_0_1_BLUE*tmp_qloop_87 - tmp_qloop_74;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_54 = abs_det_jac_affine_BLUE*abs_det_jac_blending*_data_q_w[q];
                const real_t tmp_qloop_55 = tmp_qloop_50*tmp_qloop_54*2.0;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_52 = jac_blending_inv_0_0*tmp_qloop_40;
                const real_t tmp_qloop_61 = jac_blending_inv_0_0*tmp_qloop_57;
                const real_t tmp_qloop_68 = jac_blending_inv_0_0*tmp_qloop_64;
                const real_t tmp_qloop_78 = jac_blending_inv_0_0*tmp_qloop_72;
                const real_t tmp_qloop_85 = jac_blending_inv_0_0*tmp_qloop_81;
                const real_t tmp_qloop_92 = jac_blending_inv_0_0*tmp_qloop_88;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_41 = jac_blending_inv_0_1*tmp_qloop_40;
                const real_t tmp_qloop_58 = jac_blending_inv_0_1*tmp_qloop_57;
                const real_t tmp_qloop_65 = jac_blending_inv_0_1*tmp_qloop_64;
                const real_t tmp_qloop_73 = jac_blending_inv_0_1*tmp_qloop_72;
                const real_t tmp_qloop_82 = jac_blending_inv_0_1*tmp_qloop_81;
                const real_t tmp_qloop_89 = jac_blending_inv_0_1*tmp_qloop_88;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_53 = jac_blending_inv_1_0*tmp_qloop_42;
                const real_t tmp_qloop_62 = jac_blending_inv_1_0*tmp_qloop_59;
                const real_t tmp_qloop_69 = jac_blending_inv_1_0*tmp_qloop_66;
                const real_t tmp_qloop_79 = jac_blending_inv_1_0*tmp_qloop_76;
                const real_t tmp_qloop_86 = jac_blending_inv_1_0*tmp_qloop_83;
                const real_t tmp_qloop_93 = jac_blending_inv_1_0*tmp_qloop_90;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_43 = jac_blending_inv_1_1*tmp_qloop_42;
                const real_t tmp_qloop_60 = jac_blending_inv_1_1*tmp_qloop_59;
                const real_t tmp_qloop_67 = jac_blending_inv_1_1*tmp_qloop_66;
                const real_t tmp_qloop_77 = jac_blending_inv_1_1*tmp_qloop_76;
                const real_t tmp_qloop_84 = jac_blending_inv_1_1*tmp_qloop_83;
                const real_t tmp_qloop_91 = jac_blending_inv_1_1*tmp_qloop_90;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_52*1.0 + tmp_qloop_53*1.0)*(tmp_qloop_52*1.0 + tmp_qloop_53*1.0)) + tmp_qloop_51*((tmp_qloop_41 + tmp_qloop_43)*(tmp_qloop_41 + tmp_qloop_43)));
                const real_t q_tmp_0_6 = tmp_qloop_55*(tmp_qloop_41*0.5 + tmp_qloop_43*0.5)*(tmp_qloop_52*0.5 + tmp_qloop_53*0.5);
                const real_t q_tmp_1_1 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_61*1.0 + tmp_qloop_62*1.0)*(tmp_qloop_61*1.0 + tmp_qloop_62*1.0)) + tmp_qloop_51*((tmp_qloop_58 + tmp_qloop_60)*(tmp_qloop_58 + tmp_qloop_60)));
                const real_t q_tmp_1_7 = tmp_qloop_55*(tmp_qloop_58*0.5 + tmp_qloop_60*0.5)*(tmp_qloop_61*0.5 + tmp_qloop_62*0.5);
                const real_t q_tmp_2_2 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_68*1.0 + tmp_qloop_69*1.0)*(tmp_qloop_68*1.0 + tmp_qloop_69*1.0)) + tmp_qloop_51*((tmp_qloop_65 + tmp_qloop_67)*(tmp_qloop_65 + tmp_qloop_67)));
                const real_t q_tmp_2_8 = tmp_qloop_55*(tmp_qloop_65*0.5 + tmp_qloop_67*0.5)*(tmp_qloop_68*0.5 + tmp_qloop_69*0.5);
                const real_t q_tmp_3_3 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_78*1.0 + tmp_qloop_79*1.0)*(tmp_qloop_78*1.0 + tmp_qloop_79*1.0)) + tmp_qloop_51*((tmp_qloop_73 + tmp_qloop_77)*(tmp_qloop_73 + tmp_qloop_77)));
                const real_t q_tmp_3_9 = tmp_qloop_55*(tmp_qloop_73*0.5 + tmp_qloop_77*0.5)*(tmp_qloop_78*0.5 + tmp_qloop_79*0.5);
                const real_t q_tmp_4_4 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_85*1.0 + tmp_qloop_86*1.0)*(tmp_qloop_85*1.0 + tmp_qloop_86*1.0)) + tmp_qloop_51*((tmp_qloop_82 + tmp_qloop_84)*(tmp_qloop_82 + tmp_qloop_84)));
                const real_t q_tmp_4_10 = tmp_qloop_55*(tmp_qloop_82*0.5 + tmp_qloop_84*0.5)*(tmp_qloop_85*0.5 + tmp_qloop_86*0.5);
                const real_t q_tmp_5_5 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_92*1.0 + tmp_qloop_93*1.0)*(tmp_qloop_92*1.0 + tmp_qloop_93*1.0)) + tmp_qloop_51*((tmp_qloop_89 + tmp_qloop_91)*(tmp_qloop_89 + tmp_qloop_91)));
                const real_t q_tmp_5_11 = tmp_qloop_55*(tmp_qloop_89*0.5 + tmp_qloop_91*0.5)*(tmp_qloop_92*0.5 + tmp_qloop_93*0.5);
                const real_t q_tmp_6_6 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_41*1.0 + tmp_qloop_43*1.0)*(tmp_qloop_41*1.0 + tmp_qloop_43*1.0)) + tmp_qloop_51*((tmp_qloop_52 + tmp_qloop_53)*(tmp_qloop_52 + tmp_qloop_53)));
                const real_t q_tmp_7_7 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_58*1.0 + tmp_qloop_60*1.0)*(tmp_qloop_58*1.0 + tmp_qloop_60*1.0)) + tmp_qloop_51*((tmp_qloop_61 + tmp_qloop_62)*(tmp_qloop_61 + tmp_qloop_62)));
                const real_t q_tmp_8_8 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_65*1.0 + tmp_qloop_67*1.0)*(tmp_qloop_65*1.0 + tmp_qloop_67*1.0)) + tmp_qloop_51*((tmp_qloop_68 + tmp_qloop_69)*(tmp_qloop_68 + tmp_qloop_69)));
                const real_t q_tmp_9_9 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_73*1.0 + tmp_qloop_77*1.0)*(tmp_qloop_73*1.0 + tmp_qloop_77*1.0)) + tmp_qloop_51*((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79)));
                const real_t q_tmp_10_10 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_82*1.0 + tmp_qloop_84*1.0)*(tmp_qloop_82*1.0 + tmp_qloop_84*1.0)) + tmp_qloop_51*((tmp_qloop_85 + tmp_qloop_86)*(tmp_qloop_85 + tmp_qloop_86)));
                const real_t q_tmp_11_11 = tmp_qloop_54*(tmp_qloop_50*((tmp_qloop_89*1.0 + tmp_qloop_91*1.0)*(tmp_qloop_89*1.0 + tmp_qloop_91*1.0)) + tmp_qloop_51*((tmp_qloop_92 + tmp_qloop_93)*(tmp_qloop_92 + tmp_qloop_93)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_3 = q_acc_0_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_4 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_4) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_4) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_7 = q_acc_1_7*tmp_kernel_op_5;
             const bool tmp_kernel_op_8 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_9 = ((tmp_kernel_op_8) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_10 = ((tmp_kernel_op_8) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_11 = q_acc_2_8*tmp_kernel_op_9;
             const bool tmp_kernel_op_12 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_12) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_12) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_15 = q_acc_3_9*tmp_kernel_op_13;
             const bool tmp_kernel_op_16 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_16) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_16) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_19 = q_acc_4_10*tmp_kernel_op_17;
             const bool tmp_kernel_op_20 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_21 = ((tmp_kernel_op_20) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_20) ? (-ny_dof_5): (1.0));
             const real_t tmp_kernel_op_23 = q_acc_5_11*tmp_kernel_op_21;
             const real_t tmp_kernel_op_24 = ((tmp_kernel_op_0) ? (ny_dof_0): (1.0));
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_4) ? (ny_dof_1): (1.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_8) ? (ny_dof_2): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_12) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_28 = ((tmp_kernel_op_16) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_29 = ((tmp_kernel_op_20) ? (ny_dof_5): (1.0));
             const real_t elMatDiag_0 = tmp_kernel_op_1*(q_acc_0_6*tmp_kernel_op_2 + q_acc_6_6*tmp_kernel_op_1) + tmp_kernel_op_2*(q_acc_0_0*tmp_kernel_op_2 + tmp_kernel_op_3);
             const real_t elMatDiag_1 = tmp_kernel_op_5*(q_acc_1_7*tmp_kernel_op_6 + q_acc_7_7*tmp_kernel_op_5) + tmp_kernel_op_6*(q_acc_1_1*tmp_kernel_op_6 + tmp_kernel_op_7);
             const real_t elMatDiag_2 = tmp_kernel_op_10*(q_acc_2_2*tmp_kernel_op_10 + tmp_kernel_op_11) + tmp_kernel_op_9*(q_acc_2_8*tmp_kernel_op_10 + q_acc_8_8*tmp_kernel_op_9);
             const real_t elMatDiag_3 = tmp_kernel_op_13*(q_acc_3_9*tmp_kernel_op_14 + q_acc_9_9*tmp_kernel_op_13) + tmp_kernel_op_14*(q_acc_3_3*tmp_kernel_op_14 + tmp_kernel_op_15);
             const real_t elMatDiag_4 = tmp_kernel_op_17*(q_acc_10_10*tmp_kernel_op_17 + q_acc_4_10*tmp_kernel_op_18) + tmp_kernel_op_18*(q_acc_4_4*tmp_kernel_op_18 + tmp_kernel_op_19);
             const real_t elMatDiag_5 = tmp_kernel_op_21*(q_acc_11_11*tmp_kernel_op_21 + q_acc_5_11*tmp_kernel_op_22) + tmp_kernel_op_22*(q_acc_5_5*tmp_kernel_op_22 + tmp_kernel_op_23);
             const real_t elMatDiag_6 = tmp_kernel_op_1*(q_acc_0_0*tmp_kernel_op_1 + q_acc_0_6*tmp_kernel_op_24) + tmp_kernel_op_24*(q_acc_6_6*tmp_kernel_op_24 + tmp_kernel_op_3);
             const real_t elMatDiag_7 = tmp_kernel_op_25*(q_acc_7_7*tmp_kernel_op_25 + tmp_kernel_op_7) + tmp_kernel_op_5*(q_acc_1_1*tmp_kernel_op_5 + q_acc_1_7*tmp_kernel_op_25);
             const real_t elMatDiag_8 = tmp_kernel_op_26*(q_acc_8_8*tmp_kernel_op_26 + tmp_kernel_op_11) + tmp_kernel_op_9*(q_acc_2_2*tmp_kernel_op_9 + q_acc_2_8*tmp_kernel_op_26);
             const real_t elMatDiag_9 = tmp_kernel_op_13*(q_acc_3_3*tmp_kernel_op_13 + q_acc_3_9*tmp_kernel_op_27) + tmp_kernel_op_27*(q_acc_9_9*tmp_kernel_op_27 + tmp_kernel_op_15);
             const real_t elMatDiag_10 = tmp_kernel_op_17*(q_acc_4_10*tmp_kernel_op_28 + q_acc_4_4*tmp_kernel_op_17) + tmp_kernel_op_28*(q_acc_10_10*tmp_kernel_op_28 + tmp_kernel_op_19);
             const real_t elMatDiag_11 = tmp_kernel_op_21*(q_acc_5_11*tmp_kernel_op_29 + q_acc_5_5*tmp_kernel_op_21) + tmp_kernel_op_29*(q_acc_11_11*tmp_kernel_op_29 + tmp_kernel_op_23);
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_3 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_6 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_7 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatDiag_8 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_9 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatDiag_10 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_11 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
