/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



























#include "../P2ElementwiseDivKGradIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDivKGradIcosahedralShellMap::computeInverseDiagonalOperatorValues_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_kEdge, real_t * RESTRICT  _data_kVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_2 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_3 = -rayVertex_0;
       const real_t tmp_qloop_4 = -forVertex_0 - tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_6 = tmp_qloop_4*tmp_qloop_5;
       const real_t tmp_qloop_7 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_8 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_9 = tmp_qloop_4*tmp_qloop_8;
       const real_t tmp_qloop_10 = -rayVertex_1;
       const real_t tmp_qloop_11 = -forVertex_1 - tmp_qloop_10;
       const real_t tmp_qloop_12 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_13 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_14 = -rayVertex_2;
       const real_t tmp_qloop_15 = -forVertex_2 - tmp_qloop_14;
       const real_t tmp_qloop_16 = tmp_qloop_11*tmp_qloop_5;
       const real_t tmp_qloop_17 = tmp_qloop_12*tmp_qloop_15;
       const real_t tmp_qloop_18 = tmp_qloop_11*tmp_qloop_12*tmp_qloop_7 + tmp_qloop_13*tmp_qloop_15*tmp_qloop_8 - tmp_qloop_13*tmp_qloop_16 - tmp_qloop_17*tmp_qloop_2 + tmp_qloop_2*tmp_qloop_6 - tmp_qloop_7*tmp_qloop_9;
       const real_t tmp_qloop_19 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_29 = tmp_qloop_19*(tmp_qloop_15*tmp_qloop_8 - tmp_qloop_16);
       const real_t tmp_qloop_33 = tmp_qloop_12*tmp_qloop_15 - tmp_qloop_6;
       const real_t tmp_qloop_38 = tmp_qloop_11*tmp_qloop_12 - tmp_qloop_9;
       const real_t tmp_qloop_54 = 1.0 / (tmp_qloop_18*tmp_qloop_18);
       const real_t tmp_qloop_61 = 1.0 / (tmp_qloop_18*tmp_qloop_18*tmp_qloop_18);
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_WHITE_UP*tmp_qloop_74 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_74 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_WHITE_UP*tmp_qloop_74 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_74 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_WHITE_UP*tmp_qloop_74 + jac_affine_inv_1_0_WHITE_UP*tmp_qloop_74 + jac_affine_inv_2_0_WHITE_UP*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_WHITE_UP*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_WHITE_UP*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_WHITE_UP*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_WHITE_UP*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_WHITE_UP*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_WHITE_UP*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_WHITE_UP*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_WHITE_UP*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_WHITE_UP*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_WHITE_UP*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_74 + jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_WHITE_DOWN*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_BLUE_UP*tmp_qloop_74 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_74 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_BLUE_UP*tmp_qloop_74 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_74 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_BLUE_UP*tmp_qloop_74 + jac_affine_inv_1_0_BLUE_UP*tmp_qloop_74 + jac_affine_inv_2_0_BLUE_UP*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_BLUE_UP*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_BLUE_UP*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_BLUE_UP*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_BLUE_UP*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_BLUE_UP*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_BLUE_UP*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_BLUE_UP*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_BLUE_UP*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_BLUE_UP*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_BLUE_UP*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_74 + jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_BLUE_DOWN*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_GREEN_UP*tmp_qloop_74 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_74 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_GREEN_UP*tmp_qloop_74 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_74 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_GREEN_UP*tmp_qloop_74 + jac_affine_inv_1_0_GREEN_UP*tmp_qloop_74 + jac_affine_inv_2_0_GREEN_UP*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_GREEN_UP*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_GREEN_UP*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_GREEN_UP*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_GREEN_UP*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_GREEN_UP*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_GREEN_UP*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_GREEN_UP*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_GREEN_UP*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_GREEN_UP*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_GREEN_UP*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                const real_t tmp_qloop_39 = -tmp_qloop_25;
                const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_55*1.0;
                const real_t tmp_qloop_57 = tmp_qloop_41*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_23*tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_58;
                const real_t tmp_qloop_60 = pow(tmp_qloop_28, -4.5000000000000000);
                const real_t tmp_qloop_62 = tmp_qloop_60*tmp_qloop_61;
                const real_t tmp_qloop_63 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_62*1.0;
                const real_t tmp_qloop_64 = tmp_qloop_35*tmp_qloop_45;
                const real_t tmp_qloop_65 = tmp_qloop_23*tmp_qloop_40;
                const real_t tmp_qloop_66 = tmp_qloop_20*tmp_qloop_35;
                const real_t tmp_qloop_67 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_60*tmp_qloop_61*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_63 - tmp_qloop_23*tmp_qloop_63*tmp_qloop_64 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_60*tmp_qloop_61*1.0 - tmp_qloop_31*tmp_qloop_62*tmp_qloop_67;
                const real_t tmp_qloop_69 = 1.0 / (tmp_qloop_68);
                const real_t tmp_qloop_70 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_71 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_72 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_73 = tmp_qloop_71 + tmp_qloop_72;
                const real_t tmp_qloop_74 = tmp_qloop_70 + tmp_qloop_73 - 3.0;
                const real_t tmp_qloop_75 = tmp_qloop_69*(jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_76 = tmp_qloop_20*tmp_qloop_57;
                const real_t tmp_qloop_77 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_69*(jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_79 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_56 - tmp_qloop_56*tmp_qloop_67;
                const real_t tmp_qloop_80 = tmp_qloop_69*(jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_74 + jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_74);
                const real_t tmp_qloop_81 = tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_82 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_65*tmp_qloop_81;
                const real_t tmp_qloop_83 = tmp_qloop_0*tmp_qloop_56;
                const real_t tmp_qloop_84 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_58 + tmp_qloop_43*tmp_qloop_81;
                const real_t tmp_qloop_86 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_64*tmp_qloop_83;
                const real_t tmp_qloop_87 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_66*tmp_qloop_81;
                const real_t tmp_qloop_88 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_76 + tmp_qloop_45*tmp_qloop_81;
                const real_t tmp_qloop_89 = tmp_qloop_71*_data_q_p_1[q];
                const real_t tmp_qloop_90 = tmp_qloop_71*_data_q_p_2[q];
                const real_t tmp_qloop_91 = tmp_qloop_72*_data_q_p_2[q];
                const real_t tmp_qloop_92 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_93 = tmp_qloop_92*2.0;
                const real_t tmp_qloop_94 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_95 = tmp_qloop_94*2.0;
                const real_t tmp_qloop_96 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_97 = tmp_qloop_96*2.0;
                const real_t tmp_qloop_98 = tmp_qloop_89 + tmp_qloop_90;
                const real_t tmp_qloop_99 = abs_det_jac_affine_GREEN_DOWN*(k_dof_0*(tmp_qloop_91 + tmp_qloop_93 + tmp_qloop_95 + tmp_qloop_97 + tmp_qloop_98 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_93 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_95 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_97 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_91 + k_dof_5*tmp_qloop_90 + k_dof_6*tmp_qloop_89 + k_dof_7*(tmp_qloop_70 - tmp_qloop_90 - tmp_qloop_91 + tmp_qloop_96*-4.0) + k_dof_8*(tmp_qloop_72 - tmp_qloop_89 - tmp_qloop_91 + tmp_qloop_94*-4.0) + k_dof_9*(tmp_qloop_71 + tmp_qloop_92*-4.0 - tmp_qloop_98))*abs(tmp_qloop_68)*_data_q_w[q];
                const real_t tmp_qloop_100 = tmp_qloop_69*(tmp_qloop_71 - 1.0);
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_102 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_103 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_100;
                const real_t tmp_qloop_104 = tmp_qloop_69*(tmp_qloop_72 - 1.0);
                const real_t tmp_qloop_105 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_106 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_107 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_104;
                const real_t tmp_qloop_108 = tmp_qloop_69*(tmp_qloop_70 - 1.0);
                const real_t tmp_qloop_109 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_110 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_111 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_108;
                const real_t tmp_qloop_112 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_113 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_114 = tmp_qloop_69*(tmp_qloop_112 + tmp_qloop_113);
                const real_t tmp_qloop_115 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_116 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_117 = tmp_qloop_69*(tmp_qloop_115 + tmp_qloop_116);
                const real_t tmp_qloop_118 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_119 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_120 = tmp_qloop_69*(tmp_qloop_118 + tmp_qloop_119);
                const real_t tmp_qloop_121 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_122 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_123 = tmp_qloop_69*(tmp_qloop_121 + tmp_qloop_122);
                const real_t tmp_qloop_124 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_125 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_126 = tmp_qloop_69*(tmp_qloop_124 + tmp_qloop_125);
                const real_t tmp_qloop_127 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_128 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_70;
                const real_t tmp_qloop_129 = tmp_qloop_69*(tmp_qloop_127 + tmp_qloop_128);
                const real_t tmp_qloop_130 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_131 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_132 = tmp_qloop_69*(tmp_qloop_130 + tmp_qloop_131);
                const real_t tmp_qloop_133 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_134 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_135 = tmp_qloop_69*(tmp_qloop_133 + tmp_qloop_134);
                const real_t tmp_qloop_136 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_71;
                const real_t tmp_qloop_137 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_72;
                const real_t tmp_qloop_138 = tmp_qloop_69*(tmp_qloop_136 + tmp_qloop_137);
                const real_t tmp_qloop_139 = -tmp_qloop_73 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_140 = tmp_qloop_69*(jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_139 - tmp_qloop_113 - tmp_qloop_122);
                const real_t tmp_qloop_141 = tmp_qloop_69*(jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_139 - tmp_qloop_116 - tmp_qloop_125);
                const real_t tmp_qloop_142 = tmp_qloop_69*(jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_139 - tmp_qloop_119 - tmp_qloop_128);
                const real_t tmp_qloop_143 = tmp_qloop_70 - 4.0;
                const real_t tmp_qloop_144 = -tmp_qloop_143 - tmp_qloop_71 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_145 = tmp_qloop_69*(jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_144 - tmp_qloop_112 - tmp_qloop_131);
                const real_t tmp_qloop_146 = tmp_qloop_69*(jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_144 - tmp_qloop_115 - tmp_qloop_134);
                const real_t tmp_qloop_147 = tmp_qloop_69*(jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_144 - tmp_qloop_118 - tmp_qloop_137);
                const real_t tmp_qloop_148 = -tmp_qloop_143 - tmp_qloop_72 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_149 = tmp_qloop_69*(jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_148 - tmp_qloop_121 - tmp_qloop_130);
                const real_t tmp_qloop_150 = tmp_qloop_69*(jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_148 - tmp_qloop_124 - tmp_qloop_133);
                const real_t tmp_qloop_151 = tmp_qloop_69*(jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_148 - tmp_qloop_127 - tmp_qloop_136);
                const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                const real_t abs_det_jac_blending = tmp_qloop_51;
                const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t q_tmp_0_0 = tmp_qloop_99*(((tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)*(tmp_qloop_59*tmp_qloop_75 + tmp_qloop_77*tmp_qloop_78 + tmp_qloop_79*tmp_qloop_80)) + ((tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)*(tmp_qloop_75*tmp_qloop_82 + tmp_qloop_78*tmp_qloop_85 + tmp_qloop_80*tmp_qloop_84)) + ((tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)*(tmp_qloop_75*tmp_qloop_88 + tmp_qloop_78*tmp_qloop_87 + tmp_qloop_80*tmp_qloop_86)));
                const real_t q_tmp_1_1 = tmp_qloop_99*(((tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)*(tmp_qloop_101*tmp_qloop_59 + tmp_qloop_102*tmp_qloop_77 + tmp_qloop_103*tmp_qloop_79)) + ((tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)*(tmp_qloop_101*tmp_qloop_82 + tmp_qloop_102*tmp_qloop_85 + tmp_qloop_103*tmp_qloop_84)) + ((tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)*(tmp_qloop_101*tmp_qloop_88 + tmp_qloop_102*tmp_qloop_87 + tmp_qloop_103*tmp_qloop_86)));
                const real_t q_tmp_2_2 = tmp_qloop_99*(((tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)*(tmp_qloop_105*tmp_qloop_59 + tmp_qloop_106*tmp_qloop_77 + tmp_qloop_107*tmp_qloop_79)) + ((tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)*(tmp_qloop_105*tmp_qloop_82 + tmp_qloop_106*tmp_qloop_85 + tmp_qloop_107*tmp_qloop_84)) + ((tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)*(tmp_qloop_105*tmp_qloop_88 + tmp_qloop_106*tmp_qloop_87 + tmp_qloop_107*tmp_qloop_86)));
                const real_t q_tmp_3_3 = tmp_qloop_99*(((tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)*(tmp_qloop_109*tmp_qloop_59 + tmp_qloop_110*tmp_qloop_77 + tmp_qloop_111*tmp_qloop_79)) + ((tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)*(tmp_qloop_109*tmp_qloop_82 + tmp_qloop_110*tmp_qloop_85 + tmp_qloop_111*tmp_qloop_84)) + ((tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)*(tmp_qloop_109*tmp_qloop_88 + tmp_qloop_110*tmp_qloop_87 + tmp_qloop_111*tmp_qloop_86)));
                const real_t q_tmp_4_4 = tmp_qloop_99*(((tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)*(tmp_qloop_114*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_77 + tmp_qloop_120*tmp_qloop_79)) + ((tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)*(tmp_qloop_114*tmp_qloop_82 + tmp_qloop_117*tmp_qloop_85 + tmp_qloop_120*tmp_qloop_84)) + ((tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)*(tmp_qloop_114*tmp_qloop_88 + tmp_qloop_117*tmp_qloop_87 + tmp_qloop_120*tmp_qloop_86)));
                const real_t q_tmp_5_5 = tmp_qloop_99*(((tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)*(tmp_qloop_123*tmp_qloop_59 + tmp_qloop_126*tmp_qloop_77 + tmp_qloop_129*tmp_qloop_79)) + ((tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)*(tmp_qloop_123*tmp_qloop_82 + tmp_qloop_126*tmp_qloop_85 + tmp_qloop_129*tmp_qloop_84)) + ((tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)*(tmp_qloop_123*tmp_qloop_88 + tmp_qloop_126*tmp_qloop_87 + tmp_qloop_129*tmp_qloop_86)));
                const real_t q_tmp_6_6 = tmp_qloop_99*(((tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)*(tmp_qloop_132*tmp_qloop_59 + tmp_qloop_135*tmp_qloop_77 + tmp_qloop_138*tmp_qloop_79)) + ((tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)*(tmp_qloop_132*tmp_qloop_82 + tmp_qloop_135*tmp_qloop_85 + tmp_qloop_138*tmp_qloop_84)) + ((tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)*(tmp_qloop_132*tmp_qloop_88 + tmp_qloop_135*tmp_qloop_87 + tmp_qloop_138*tmp_qloop_86)));
                const real_t q_tmp_7_7 = tmp_qloop_99*(((tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)*(tmp_qloop_140*tmp_qloop_59 + tmp_qloop_141*tmp_qloop_77 + tmp_qloop_142*tmp_qloop_79)) + ((tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)*(tmp_qloop_140*tmp_qloop_82 + tmp_qloop_141*tmp_qloop_85 + tmp_qloop_142*tmp_qloop_84)) + ((tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)*(tmp_qloop_140*tmp_qloop_88 + tmp_qloop_141*tmp_qloop_87 + tmp_qloop_142*tmp_qloop_86)));
                const real_t q_tmp_8_8 = tmp_qloop_99*(((tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)*(tmp_qloop_145*tmp_qloop_59 + tmp_qloop_146*tmp_qloop_77 + tmp_qloop_147*tmp_qloop_79)) + ((tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)*(tmp_qloop_145*tmp_qloop_82 + tmp_qloop_146*tmp_qloop_85 + tmp_qloop_147*tmp_qloop_84)) + ((tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)*(tmp_qloop_145*tmp_qloop_88 + tmp_qloop_146*tmp_qloop_87 + tmp_qloop_147*tmp_qloop_86)));
                const real_t q_tmp_9_9 = tmp_qloop_99*(((tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)*(tmp_qloop_149*tmp_qloop_59 + tmp_qloop_150*tmp_qloop_77 + tmp_qloop_151*tmp_qloop_79)) + ((tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)*(tmp_qloop_149*tmp_qloop_82 + tmp_qloop_150*tmp_qloop_85 + tmp_qloop_151*tmp_qloop_84)) + ((tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)*(tmp_qloop_149*tmp_qloop_88 + tmp_qloop_150*tmp_qloop_87 + tmp_qloop_151*tmp_qloop_86)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
