/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

























#include "../P2ToP1ElementwiseDivergence_0_0.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ToP1ElementwiseDivergence_0_0::toMatrix_macro_3D( idx_t * RESTRICT  _data_dst, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP - jac_affine_0_1_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_0_2_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_0_2_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP - jac_affine_0_1_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_0_2_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_0_2_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP - jac_affine_0_1_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_0_2_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_0_2_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_kernel_op_0 = 2.3416407864998736;
       const real_t tmp_kernel_op_1 = 0.55278640450004202;
       const real_t tmp_kernel_op_2 = 0.55278640450004202;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
       const real_t tmp_kernel_op_5 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_6 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_7 = tmp_kernel_op_6*0.13819660112501053;
       const real_t tmp_kernel_op_8 = 0.55278640450004202;
       const real_t tmp_kernel_op_9 = 0.55278640450004202;
       const real_t tmp_kernel_op_10 = 2.3416407864998736;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_10 + tmp_kernel_op_9;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_11 + tmp_kernel_op_8 - 3.0;
       const real_t tmp_kernel_op_13 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_12;
       const real_t tmp_kernel_op_14 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_15 = tmp_kernel_op_14*0.13819660112501056;
       const real_t tmp_kernel_op_16 = 0.55278640450004202;
       const real_t tmp_kernel_op_17 = 2.3416407864998736;
       const real_t tmp_kernel_op_18 = 0.55278640450004202;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_17 + tmp_kernel_op_18;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_16 + tmp_kernel_op_19 - 3.0;
       const real_t tmp_kernel_op_21 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_22 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_22*0.13819660112501056;
       const real_t tmp_kernel_op_24 = 0.55278640450004202;
       const real_t tmp_kernel_op_25 = 0.55278640450004202;
       const real_t tmp_kernel_op_26 = 0.55278640450004202;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_25 + tmp_kernel_op_26;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_24 + tmp_kernel_op_27 - 3.0;
       const real_t tmp_kernel_op_29 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_30 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_31 = tmp_kernel_op_30*0.5854101966249684;
       const real_t tmp_kernel_op_32 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_kernel_op_33 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_kernel_op_34 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_kernel_op_35 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_kernel_op_36 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_kernel_op_37 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_kernel_op_38 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_kernel_op_39 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_kernel_op_40 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_kernel_op_41 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_kernel_op_42 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_kernel_op_43 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_kernel_op_44 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_45 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
       const real_t tmp_kernel_op_47 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_48 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
       const real_t tmp_kernel_op_50 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_51 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
       const real_t tmp_kernel_op_53 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_54 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
       const real_t tmp_kernel_op_56 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_57 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
       const real_t tmp_kernel_op_59 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_60 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
       const real_t tmp_kernel_op_62 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_63 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_17;
       const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
       const real_t tmp_kernel_op_65 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_66 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
       const real_t tmp_kernel_op_68 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_69 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_70 = -tmp_kernel_op_68 - tmp_kernel_op_69;
       const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_72 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_73 = -tmp_kernel_op_71 - tmp_kernel_op_72;
       const real_t tmp_kernel_op_74 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_75 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_17;
       const real_t tmp_kernel_op_76 = -tmp_kernel_op_74 - tmp_kernel_op_75;
       const real_t tmp_kernel_op_77 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_78 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_79 = -tmp_kernel_op_77 - tmp_kernel_op_78;
       const real_t tmp_kernel_op_80 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_kernel_op_44 + tmp_kernel_op_56;
       const real_t tmp_kernel_op_81 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_kernel_op_47 + tmp_kernel_op_59;
       const real_t tmp_kernel_op_82 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_kernel_op_50 + tmp_kernel_op_62;
       const real_t tmp_kernel_op_83 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_kernel_op_53 + tmp_kernel_op_65;
       const real_t tmp_kernel_op_84 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_85 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_kernel_op_45 + tmp_kernel_op_68;
       const real_t tmp_kernel_op_86 = tmp_kernel_op_8 - 4.0;
       const real_t tmp_kernel_op_87 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_kernel_op_48 + tmp_kernel_op_71;
       const real_t tmp_kernel_op_88 = tmp_kernel_op_16 - 4.0;
       const real_t tmp_kernel_op_89 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_kernel_op_51 + tmp_kernel_op_74;
       const real_t tmp_kernel_op_90 = tmp_kernel_op_24 - 4.0;
       const real_t tmp_kernel_op_91 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_kernel_op_54 + tmp_kernel_op_77;
       const real_t tmp_kernel_op_92 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_kernel_op_57 + tmp_kernel_op_69;
       const real_t tmp_kernel_op_93 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_kernel_op_60 + tmp_kernel_op_72;
       const real_t tmp_kernel_op_94 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_kernel_op_63 + tmp_kernel_op_75;
       const real_t tmp_kernel_op_95 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_kernel_op_66 + tmp_kernel_op_78;
       const real_t tmp_kernel_op_96 = tmp_kernel_op_6*0.1381966011250105;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_14*0.1381966011250105;
       const real_t tmp_kernel_op_98 = tmp_kernel_op_22*0.5854101966249684;
       const real_t tmp_kernel_op_99 = tmp_kernel_op_30*0.1381966011250105;
       const real_t tmp_kernel_op_100 = tmp_kernel_op_6*0.1381966011250105;
       const real_t tmp_kernel_op_101 = tmp_kernel_op_14*0.5854101966249684;
       const real_t tmp_kernel_op_102 = tmp_kernel_op_22*0.1381966011250105;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_30*0.1381966011250105;
       const real_t tmp_kernel_op_104 = tmp_kernel_op_6*0.5854101966249684;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_14*0.1381966011250105;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_22*0.1381966011250105;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_30*0.1381966011250105;
       const real_t elMat_0_0 = tmp_kernel_op_13*tmp_kernel_op_15 + tmp_kernel_op_21*tmp_kernel_op_23 + tmp_kernel_op_29*tmp_kernel_op_31 + tmp_kernel_op_5*tmp_kernel_op_7;
       const real_t elMat_0_1 = -tmp_kernel_op_15*tmp_kernel_op_33 - tmp_kernel_op_23*tmp_kernel_op_34 - tmp_kernel_op_31*tmp_kernel_op_35 - tmp_kernel_op_32*tmp_kernel_op_7;
       const real_t elMat_0_2 = -tmp_kernel_op_15*tmp_kernel_op_37 - tmp_kernel_op_23*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_36*tmp_kernel_op_7;
       const real_t elMat_0_3 = -tmp_kernel_op_15*tmp_kernel_op_41 - tmp_kernel_op_23*tmp_kernel_op_42 - tmp_kernel_op_31*tmp_kernel_op_43 - tmp_kernel_op_40*tmp_kernel_op_7;
       const real_t elMat_0_4 = tmp_kernel_op_15*tmp_kernel_op_49 + tmp_kernel_op_23*tmp_kernel_op_52 + tmp_kernel_op_31*tmp_kernel_op_55 + tmp_kernel_op_46*tmp_kernel_op_7;
       const real_t elMat_0_5 = tmp_kernel_op_15*tmp_kernel_op_61 + tmp_kernel_op_23*tmp_kernel_op_64 + tmp_kernel_op_31*tmp_kernel_op_67 + tmp_kernel_op_58*tmp_kernel_op_7;
       const real_t elMat_0_6 = tmp_kernel_op_15*tmp_kernel_op_73 + tmp_kernel_op_23*tmp_kernel_op_76 + tmp_kernel_op_31*tmp_kernel_op_79 + tmp_kernel_op_7*tmp_kernel_op_70;
       const real_t elMat_0_7 = tmp_kernel_op_15*tmp_kernel_op_81 + tmp_kernel_op_23*tmp_kernel_op_82 + tmp_kernel_op_31*tmp_kernel_op_83 + tmp_kernel_op_7*tmp_kernel_op_80;
       const real_t elMat_0_8 = tmp_kernel_op_15*tmp_kernel_op_87 + tmp_kernel_op_23*tmp_kernel_op_89 + tmp_kernel_op_31*tmp_kernel_op_91 + tmp_kernel_op_7*tmp_kernel_op_85;
       const real_t elMat_0_9 = tmp_kernel_op_15*tmp_kernel_op_93 + tmp_kernel_op_23*tmp_kernel_op_94 + tmp_kernel_op_31*tmp_kernel_op_95 + tmp_kernel_op_7*tmp_kernel_op_92;
       const real_t elMat_1_0 = tmp_kernel_op_13*tmp_kernel_op_97 + tmp_kernel_op_21*tmp_kernel_op_98 + tmp_kernel_op_29*tmp_kernel_op_99 + tmp_kernel_op_5*tmp_kernel_op_96;
       const real_t elMat_1_1 = -tmp_kernel_op_32*tmp_kernel_op_96 - tmp_kernel_op_33*tmp_kernel_op_97 - tmp_kernel_op_34*tmp_kernel_op_98 - tmp_kernel_op_35*tmp_kernel_op_99;
       const real_t elMat_1_2 = -tmp_kernel_op_36*tmp_kernel_op_96 - tmp_kernel_op_37*tmp_kernel_op_97 - tmp_kernel_op_38*tmp_kernel_op_98 - tmp_kernel_op_39*tmp_kernel_op_99;
       const real_t elMat_1_3 = -tmp_kernel_op_40*tmp_kernel_op_96 - tmp_kernel_op_41*tmp_kernel_op_97 - tmp_kernel_op_42*tmp_kernel_op_98 - tmp_kernel_op_43*tmp_kernel_op_99;
       const real_t elMat_1_4 = tmp_kernel_op_46*tmp_kernel_op_96 + tmp_kernel_op_49*tmp_kernel_op_97 + tmp_kernel_op_52*tmp_kernel_op_98 + tmp_kernel_op_55*tmp_kernel_op_99;
       const real_t elMat_1_5 = tmp_kernel_op_58*tmp_kernel_op_96 + tmp_kernel_op_61*tmp_kernel_op_97 + tmp_kernel_op_64*tmp_kernel_op_98 + tmp_kernel_op_67*tmp_kernel_op_99;
       const real_t elMat_1_6 = tmp_kernel_op_70*tmp_kernel_op_96 + tmp_kernel_op_73*tmp_kernel_op_97 + tmp_kernel_op_76*tmp_kernel_op_98 + tmp_kernel_op_79*tmp_kernel_op_99;
       const real_t elMat_1_7 = tmp_kernel_op_80*tmp_kernel_op_96 + tmp_kernel_op_81*tmp_kernel_op_97 + tmp_kernel_op_82*tmp_kernel_op_98 + tmp_kernel_op_83*tmp_kernel_op_99;
       const real_t elMat_1_8 = tmp_kernel_op_85*tmp_kernel_op_96 + tmp_kernel_op_87*tmp_kernel_op_97 + tmp_kernel_op_89*tmp_kernel_op_98 + tmp_kernel_op_91*tmp_kernel_op_99;
       const real_t elMat_1_9 = tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_93*tmp_kernel_op_97 + tmp_kernel_op_94*tmp_kernel_op_98 + tmp_kernel_op_95*tmp_kernel_op_99;
       const real_t elMat_2_0 = tmp_kernel_op_100*tmp_kernel_op_5 + tmp_kernel_op_101*tmp_kernel_op_13 + tmp_kernel_op_102*tmp_kernel_op_21 + tmp_kernel_op_103*tmp_kernel_op_29;
       const real_t elMat_2_1 = -tmp_kernel_op_100*tmp_kernel_op_32 - tmp_kernel_op_101*tmp_kernel_op_33 - tmp_kernel_op_102*tmp_kernel_op_34 - tmp_kernel_op_103*tmp_kernel_op_35;
       const real_t elMat_2_2 = -tmp_kernel_op_100*tmp_kernel_op_36 - tmp_kernel_op_101*tmp_kernel_op_37 - tmp_kernel_op_102*tmp_kernel_op_38 - tmp_kernel_op_103*tmp_kernel_op_39;
       const real_t elMat_2_3 = -tmp_kernel_op_100*tmp_kernel_op_40 - tmp_kernel_op_101*tmp_kernel_op_41 - tmp_kernel_op_102*tmp_kernel_op_42 - tmp_kernel_op_103*tmp_kernel_op_43;
       const real_t elMat_2_4 = tmp_kernel_op_100*tmp_kernel_op_46 + tmp_kernel_op_101*tmp_kernel_op_49 + tmp_kernel_op_102*tmp_kernel_op_52 + tmp_kernel_op_103*tmp_kernel_op_55;
       const real_t elMat_2_5 = tmp_kernel_op_100*tmp_kernel_op_58 + tmp_kernel_op_101*tmp_kernel_op_61 + tmp_kernel_op_102*tmp_kernel_op_64 + tmp_kernel_op_103*tmp_kernel_op_67;
       const real_t elMat_2_6 = tmp_kernel_op_100*tmp_kernel_op_70 + tmp_kernel_op_101*tmp_kernel_op_73 + tmp_kernel_op_102*tmp_kernel_op_76 + tmp_kernel_op_103*tmp_kernel_op_79;
       const real_t elMat_2_7 = tmp_kernel_op_100*tmp_kernel_op_80 + tmp_kernel_op_101*tmp_kernel_op_81 + tmp_kernel_op_102*tmp_kernel_op_82 + tmp_kernel_op_103*tmp_kernel_op_83;
       const real_t elMat_2_8 = tmp_kernel_op_100*tmp_kernel_op_85 + tmp_kernel_op_101*tmp_kernel_op_87 + tmp_kernel_op_102*tmp_kernel_op_89 + tmp_kernel_op_103*tmp_kernel_op_91;
       const real_t elMat_2_9 = tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_101*tmp_kernel_op_93 + tmp_kernel_op_102*tmp_kernel_op_94 + tmp_kernel_op_103*tmp_kernel_op_95;
       const real_t elMat_3_0 = tmp_kernel_op_104*tmp_kernel_op_5 + tmp_kernel_op_105*tmp_kernel_op_13 + tmp_kernel_op_106*tmp_kernel_op_21 + tmp_kernel_op_107*tmp_kernel_op_29;
       const real_t elMat_3_1 = -tmp_kernel_op_104*tmp_kernel_op_32 - tmp_kernel_op_105*tmp_kernel_op_33 - tmp_kernel_op_106*tmp_kernel_op_34 - tmp_kernel_op_107*tmp_kernel_op_35;
       const real_t elMat_3_2 = -tmp_kernel_op_104*tmp_kernel_op_36 - tmp_kernel_op_105*tmp_kernel_op_37 - tmp_kernel_op_106*tmp_kernel_op_38 - tmp_kernel_op_107*tmp_kernel_op_39;
       const real_t elMat_3_3 = -tmp_kernel_op_104*tmp_kernel_op_40 - tmp_kernel_op_105*tmp_kernel_op_41 - tmp_kernel_op_106*tmp_kernel_op_42 - tmp_kernel_op_107*tmp_kernel_op_43;
       const real_t elMat_3_4 = tmp_kernel_op_104*tmp_kernel_op_46 + tmp_kernel_op_105*tmp_kernel_op_49 + tmp_kernel_op_106*tmp_kernel_op_52 + tmp_kernel_op_107*tmp_kernel_op_55;
       const real_t elMat_3_5 = tmp_kernel_op_104*tmp_kernel_op_58 + tmp_kernel_op_105*tmp_kernel_op_61 + tmp_kernel_op_106*tmp_kernel_op_64 + tmp_kernel_op_107*tmp_kernel_op_67;
       const real_t elMat_3_6 = tmp_kernel_op_104*tmp_kernel_op_70 + tmp_kernel_op_105*tmp_kernel_op_73 + tmp_kernel_op_106*tmp_kernel_op_76 + tmp_kernel_op_107*tmp_kernel_op_79;
       const real_t elMat_3_7 = tmp_kernel_op_104*tmp_kernel_op_80 + tmp_kernel_op_105*tmp_kernel_op_81 + tmp_kernel_op_106*tmp_kernel_op_82 + tmp_kernel_op_107*tmp_kernel_op_83;
       const real_t elMat_3_8 = tmp_kernel_op_104*tmp_kernel_op_85 + tmp_kernel_op_105*tmp_kernel_op_87 + tmp_kernel_op_106*tmp_kernel_op_89 + tmp_kernel_op_107*tmp_kernel_op_91;
       const real_t elMat_3_9 = tmp_kernel_op_104*tmp_kernel_op_92 + tmp_kernel_op_105*tmp_kernel_op_93 + tmp_kernel_op_106*tmp_kernel_op_94 + tmp_kernel_op_107*tmp_kernel_op_95;
       const real_t tmp_moved_constant_0 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_1 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_2 = tmp_moved_constant_1*0.13819660112501053;
       const real_t tmp_moved_constant_3 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_12 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_12 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_12;
       const real_t tmp_moved_constant_4 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_5 = tmp_moved_constant_4*0.13819660112501056;
       const real_t tmp_moved_constant_6 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_20 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_20 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_7 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_8 = tmp_moved_constant_7*0.13819660112501056;
       const real_t tmp_moved_constant_9 = -jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_28 - jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_10 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_11 = tmp_moved_constant_10*0.5854101966249684;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_0_WHITE_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_13 = jac_affine_inv_0_0_WHITE_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_0_WHITE_DOWN*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_WHITE_DOWN*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_moved_constant_16 = jac_affine_inv_1_0_WHITE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_17 = jac_affine_inv_1_0_WHITE_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_18 = jac_affine_inv_1_0_WHITE_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_19 = jac_affine_inv_1_0_WHITE_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_20 = jac_affine_inv_2_0_WHITE_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_21 = jac_affine_inv_2_0_WHITE_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_22 = jac_affine_inv_2_0_WHITE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_23 = jac_affine_inv_2_0_WHITE_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_24 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_25 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_26 = -tmp_moved_constant_24 - tmp_moved_constant_25;
       const real_t tmp_moved_constant_27 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_28 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_29 = -tmp_moved_constant_27 - tmp_moved_constant_28;
       const real_t tmp_moved_constant_30 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_31 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_32 = -tmp_moved_constant_30 - tmp_moved_constant_31;
       const real_t tmp_moved_constant_33 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_34 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_35 = -tmp_moved_constant_33 - tmp_moved_constant_34;
       const real_t tmp_moved_constant_36 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_37 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_38 = -tmp_moved_constant_36 - tmp_moved_constant_37;
       const real_t tmp_moved_constant_39 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_40 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_41 = -tmp_moved_constant_39 - tmp_moved_constant_40;
       const real_t tmp_moved_constant_42 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_43 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_44 = -tmp_moved_constant_42 - tmp_moved_constant_43;
       const real_t tmp_moved_constant_45 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_46 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_47 = -tmp_moved_constant_45 - tmp_moved_constant_46;
       const real_t tmp_moved_constant_48 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_49 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_50 = -tmp_moved_constant_48 - tmp_moved_constant_49;
       const real_t tmp_moved_constant_51 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_52 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_53 = -tmp_moved_constant_51 - tmp_moved_constant_52;
       const real_t tmp_moved_constant_54 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_55 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_56 = -tmp_moved_constant_54 - tmp_moved_constant_55;
       const real_t tmp_moved_constant_57 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_58 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_59 = -tmp_moved_constant_57 - tmp_moved_constant_58;
       const real_t tmp_moved_constant_60 = -jac_affine_inv_2_0_WHITE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_24 + tmp_moved_constant_36;
       const real_t tmp_moved_constant_61 = -jac_affine_inv_2_0_WHITE_DOWN*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_27 + tmp_moved_constant_39;
       const real_t tmp_moved_constant_62 = -jac_affine_inv_2_0_WHITE_DOWN*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_30 + tmp_moved_constant_42;
       const real_t tmp_moved_constant_63 = -jac_affine_inv_2_0_WHITE_DOWN*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_33 + tmp_moved_constant_45;
       const real_t tmp_moved_constant_64 = -jac_affine_inv_1_0_WHITE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_25 + tmp_moved_constant_48;
       const real_t tmp_moved_constant_65 = -jac_affine_inv_1_0_WHITE_DOWN*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_28 + tmp_moved_constant_51;
       const real_t tmp_moved_constant_66 = -jac_affine_inv_1_0_WHITE_DOWN*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_31 + tmp_moved_constant_54;
       const real_t tmp_moved_constant_67 = -jac_affine_inv_1_0_WHITE_DOWN*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_34 + tmp_moved_constant_57;
       const real_t tmp_moved_constant_68 = -jac_affine_inv_0_0_WHITE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_37 + tmp_moved_constant_49;
       const real_t tmp_moved_constant_69 = -jac_affine_inv_0_0_WHITE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_40 + tmp_moved_constant_52;
       const real_t tmp_moved_constant_70 = -jac_affine_inv_0_0_WHITE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_43 + tmp_moved_constant_55;
       const real_t tmp_moved_constant_71 = -jac_affine_inv_0_0_WHITE_DOWN*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_46 + tmp_moved_constant_58;
       const real_t tmp_moved_constant_72 = tmp_moved_constant_1*0.1381966011250105;
       const real_t tmp_moved_constant_73 = tmp_moved_constant_4*0.1381966011250105;
       const real_t tmp_moved_constant_74 = tmp_moved_constant_7*0.5854101966249684;
       const real_t tmp_moved_constant_75 = tmp_moved_constant_10*0.1381966011250105;
       const real_t tmp_moved_constant_76 = tmp_moved_constant_1*0.1381966011250105;
       const real_t tmp_moved_constant_77 = tmp_moved_constant_4*0.5854101966249684;
       const real_t tmp_moved_constant_78 = tmp_moved_constant_7*0.1381966011250105;
       const real_t tmp_moved_constant_79 = tmp_moved_constant_10*0.1381966011250105;
       const real_t tmp_moved_constant_80 = tmp_moved_constant_1*0.5854101966249684;
       const real_t tmp_moved_constant_81 = tmp_moved_constant_4*0.1381966011250105;
       const real_t tmp_moved_constant_82 = tmp_moved_constant_7*0.1381966011250105;
       const real_t tmp_moved_constant_83 = tmp_moved_constant_10*0.1381966011250105;
       const real_t tmp_moved_constant_84 = tmp_moved_constant_0*tmp_moved_constant_2 + tmp_moved_constant_11*tmp_moved_constant_9 + tmp_moved_constant_3*tmp_moved_constant_5 + tmp_moved_constant_6*tmp_moved_constant_8;
       const real_t tmp_moved_constant_85 = -tmp_moved_constant_11*tmp_moved_constant_15 - tmp_moved_constant_12*tmp_moved_constant_2 - tmp_moved_constant_13*tmp_moved_constant_5 - tmp_moved_constant_14*tmp_moved_constant_8;
       const real_t tmp_moved_constant_86 = -tmp_moved_constant_11*tmp_moved_constant_19 - tmp_moved_constant_16*tmp_moved_constant_2 - tmp_moved_constant_17*tmp_moved_constant_5 - tmp_moved_constant_18*tmp_moved_constant_8;
       const real_t tmp_moved_constant_87 = -tmp_moved_constant_11*tmp_moved_constant_23 - tmp_moved_constant_2*tmp_moved_constant_20 - tmp_moved_constant_21*tmp_moved_constant_5 - tmp_moved_constant_22*tmp_moved_constant_8;
       const real_t tmp_moved_constant_88 = tmp_moved_constant_11*tmp_moved_constant_35 + tmp_moved_constant_2*tmp_moved_constant_26 + tmp_moved_constant_29*tmp_moved_constant_5 + tmp_moved_constant_32*tmp_moved_constant_8;
       const real_t tmp_moved_constant_89 = tmp_moved_constant_11*tmp_moved_constant_47 + tmp_moved_constant_2*tmp_moved_constant_38 + tmp_moved_constant_41*tmp_moved_constant_5 + tmp_moved_constant_44*tmp_moved_constant_8;
       const real_t tmp_moved_constant_90 = tmp_moved_constant_11*tmp_moved_constant_59 + tmp_moved_constant_2*tmp_moved_constant_50 + tmp_moved_constant_5*tmp_moved_constant_53 + tmp_moved_constant_56*tmp_moved_constant_8;
       const real_t tmp_moved_constant_91 = tmp_moved_constant_11*tmp_moved_constant_63 + tmp_moved_constant_2*tmp_moved_constant_60 + tmp_moved_constant_5*tmp_moved_constant_61 + tmp_moved_constant_62*tmp_moved_constant_8;
       const real_t tmp_moved_constant_92 = tmp_moved_constant_11*tmp_moved_constant_67 + tmp_moved_constant_2*tmp_moved_constant_64 + tmp_moved_constant_5*tmp_moved_constant_65 + tmp_moved_constant_66*tmp_moved_constant_8;
       const real_t tmp_moved_constant_93 = tmp_moved_constant_11*tmp_moved_constant_71 + tmp_moved_constant_2*tmp_moved_constant_68 + tmp_moved_constant_5*tmp_moved_constant_69 + tmp_moved_constant_70*tmp_moved_constant_8;
       const real_t tmp_moved_constant_94 = tmp_moved_constant_0*tmp_moved_constant_72 + tmp_moved_constant_3*tmp_moved_constant_73 + tmp_moved_constant_6*tmp_moved_constant_74 + tmp_moved_constant_75*tmp_moved_constant_9;
       const real_t tmp_moved_constant_95 = -tmp_moved_constant_12*tmp_moved_constant_72 - tmp_moved_constant_13*tmp_moved_constant_73 - tmp_moved_constant_14*tmp_moved_constant_74 - tmp_moved_constant_15*tmp_moved_constant_75;
       const real_t tmp_moved_constant_96 = -tmp_moved_constant_16*tmp_moved_constant_72 - tmp_moved_constant_17*tmp_moved_constant_73 - tmp_moved_constant_18*tmp_moved_constant_74 - tmp_moved_constant_19*tmp_moved_constant_75;
       const real_t tmp_moved_constant_97 = -tmp_moved_constant_20*tmp_moved_constant_72 - tmp_moved_constant_21*tmp_moved_constant_73 - tmp_moved_constant_22*tmp_moved_constant_74 - tmp_moved_constant_23*tmp_moved_constant_75;
       const real_t tmp_moved_constant_98 = tmp_moved_constant_26*tmp_moved_constant_72 + tmp_moved_constant_29*tmp_moved_constant_73 + tmp_moved_constant_32*tmp_moved_constant_74 + tmp_moved_constant_35*tmp_moved_constant_75;
       const real_t tmp_moved_constant_99 = tmp_moved_constant_38*tmp_moved_constant_72 + tmp_moved_constant_41*tmp_moved_constant_73 + tmp_moved_constant_44*tmp_moved_constant_74 + tmp_moved_constant_47*tmp_moved_constant_75;
       const real_t tmp_moved_constant_100 = tmp_moved_constant_50*tmp_moved_constant_72 + tmp_moved_constant_53*tmp_moved_constant_73 + tmp_moved_constant_56*tmp_moved_constant_74 + tmp_moved_constant_59*tmp_moved_constant_75;
       const real_t tmp_moved_constant_101 = tmp_moved_constant_60*tmp_moved_constant_72 + tmp_moved_constant_61*tmp_moved_constant_73 + tmp_moved_constant_62*tmp_moved_constant_74 + tmp_moved_constant_63*tmp_moved_constant_75;
       const real_t tmp_moved_constant_102 = tmp_moved_constant_64*tmp_moved_constant_72 + tmp_moved_constant_65*tmp_moved_constant_73 + tmp_moved_constant_66*tmp_moved_constant_74 + tmp_moved_constant_67*tmp_moved_constant_75;
       const real_t tmp_moved_constant_103 = tmp_moved_constant_68*tmp_moved_constant_72 + tmp_moved_constant_69*tmp_moved_constant_73 + tmp_moved_constant_70*tmp_moved_constant_74 + tmp_moved_constant_71*tmp_moved_constant_75;
       const real_t tmp_moved_constant_104 = tmp_moved_constant_0*tmp_moved_constant_76 + tmp_moved_constant_3*tmp_moved_constant_77 + tmp_moved_constant_6*tmp_moved_constant_78 + tmp_moved_constant_79*tmp_moved_constant_9;
       const real_t tmp_moved_constant_105 = -tmp_moved_constant_12*tmp_moved_constant_76 - tmp_moved_constant_13*tmp_moved_constant_77 - tmp_moved_constant_14*tmp_moved_constant_78 - tmp_moved_constant_15*tmp_moved_constant_79;
       const real_t tmp_moved_constant_106 = -tmp_moved_constant_16*tmp_moved_constant_76 - tmp_moved_constant_17*tmp_moved_constant_77 - tmp_moved_constant_18*tmp_moved_constant_78 - tmp_moved_constant_19*tmp_moved_constant_79;
       const real_t tmp_moved_constant_107 = -tmp_moved_constant_20*tmp_moved_constant_76 - tmp_moved_constant_21*tmp_moved_constant_77 - tmp_moved_constant_22*tmp_moved_constant_78 - tmp_moved_constant_23*tmp_moved_constant_79;
       const real_t tmp_moved_constant_108 = tmp_moved_constant_26*tmp_moved_constant_76 + tmp_moved_constant_29*tmp_moved_constant_77 + tmp_moved_constant_32*tmp_moved_constant_78 + tmp_moved_constant_35*tmp_moved_constant_79;
       const real_t tmp_moved_constant_109 = tmp_moved_constant_38*tmp_moved_constant_76 + tmp_moved_constant_41*tmp_moved_constant_77 + tmp_moved_constant_44*tmp_moved_constant_78 + tmp_moved_constant_47*tmp_moved_constant_79;
       const real_t tmp_moved_constant_110 = tmp_moved_constant_50*tmp_moved_constant_76 + tmp_moved_constant_53*tmp_moved_constant_77 + tmp_moved_constant_56*tmp_moved_constant_78 + tmp_moved_constant_59*tmp_moved_constant_79;
       const real_t tmp_moved_constant_111 = tmp_moved_constant_60*tmp_moved_constant_76 + tmp_moved_constant_61*tmp_moved_constant_77 + tmp_moved_constant_62*tmp_moved_constant_78 + tmp_moved_constant_63*tmp_moved_constant_79;
       const real_t tmp_moved_constant_112 = tmp_moved_constant_64*tmp_moved_constant_76 + tmp_moved_constant_65*tmp_moved_constant_77 + tmp_moved_constant_66*tmp_moved_constant_78 + tmp_moved_constant_67*tmp_moved_constant_79;
       const real_t tmp_moved_constant_113 = tmp_moved_constant_68*tmp_moved_constant_76 + tmp_moved_constant_69*tmp_moved_constant_77 + tmp_moved_constant_70*tmp_moved_constant_78 + tmp_moved_constant_71*tmp_moved_constant_79;
       const real_t tmp_moved_constant_114 = tmp_moved_constant_0*tmp_moved_constant_80 + tmp_moved_constant_3*tmp_moved_constant_81 + tmp_moved_constant_6*tmp_moved_constant_82 + tmp_moved_constant_83*tmp_moved_constant_9;
       const real_t tmp_moved_constant_115 = -tmp_moved_constant_12*tmp_moved_constant_80 - tmp_moved_constant_13*tmp_moved_constant_81 - tmp_moved_constant_14*tmp_moved_constant_82 - tmp_moved_constant_15*tmp_moved_constant_83;
       const real_t tmp_moved_constant_116 = -tmp_moved_constant_16*tmp_moved_constant_80 - tmp_moved_constant_17*tmp_moved_constant_81 - tmp_moved_constant_18*tmp_moved_constant_82 - tmp_moved_constant_19*tmp_moved_constant_83;
       const real_t tmp_moved_constant_117 = -tmp_moved_constant_20*tmp_moved_constant_80 - tmp_moved_constant_21*tmp_moved_constant_81 - tmp_moved_constant_22*tmp_moved_constant_82 - tmp_moved_constant_23*tmp_moved_constant_83;
       const real_t tmp_moved_constant_118 = tmp_moved_constant_26*tmp_moved_constant_80 + tmp_moved_constant_29*tmp_moved_constant_81 + tmp_moved_constant_32*tmp_moved_constant_82 + tmp_moved_constant_35*tmp_moved_constant_83;
       const real_t tmp_moved_constant_119 = tmp_moved_constant_38*tmp_moved_constant_80 + tmp_moved_constant_41*tmp_moved_constant_81 + tmp_moved_constant_44*tmp_moved_constant_82 + tmp_moved_constant_47*tmp_moved_constant_83;
       const real_t tmp_moved_constant_120 = tmp_moved_constant_50*tmp_moved_constant_80 + tmp_moved_constant_53*tmp_moved_constant_81 + tmp_moved_constant_56*tmp_moved_constant_82 + tmp_moved_constant_59*tmp_moved_constant_83;
       const real_t tmp_moved_constant_121 = tmp_moved_constant_60*tmp_moved_constant_80 + tmp_moved_constant_61*tmp_moved_constant_81 + tmp_moved_constant_62*tmp_moved_constant_82 + tmp_moved_constant_63*tmp_moved_constant_83;
       const real_t tmp_moved_constant_122 = tmp_moved_constant_64*tmp_moved_constant_80 + tmp_moved_constant_65*tmp_moved_constant_81 + tmp_moved_constant_66*tmp_moved_constant_82 + tmp_moved_constant_67*tmp_moved_constant_83;
       const real_t tmp_moved_constant_123 = tmp_moved_constant_68*tmp_moved_constant_80 + tmp_moved_constant_69*tmp_moved_constant_81 + tmp_moved_constant_70*tmp_moved_constant_82 + tmp_moved_constant_71*tmp_moved_constant_83;
       const real_t tmp_moved_constant_124 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_125 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_126 = tmp_moved_constant_125*0.13819660112501053;
       const real_t tmp_moved_constant_127 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_12;
       const real_t tmp_moved_constant_128 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_129 = tmp_moved_constant_128*0.13819660112501056;
       const real_t tmp_moved_constant_130 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_131 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_132 = tmp_moved_constant_131*0.13819660112501056;
       const real_t tmp_moved_constant_133 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_134 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_135 = tmp_moved_constant_134*0.5854101966249684;
       const real_t tmp_moved_constant_136 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_137 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_138 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_moved_constant_139 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_moved_constant_140 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_141 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_142 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_143 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_144 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_145 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_146 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_147 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_148 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_149 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_150 = -tmp_moved_constant_148 - tmp_moved_constant_149;
       const real_t tmp_moved_constant_151 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_152 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_153 = -tmp_moved_constant_151 - tmp_moved_constant_152;
       const real_t tmp_moved_constant_154 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_155 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_156 = -tmp_moved_constant_154 - tmp_moved_constant_155;
       const real_t tmp_moved_constant_157 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_158 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_159 = -tmp_moved_constant_157 - tmp_moved_constant_158;
       const real_t tmp_moved_constant_160 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_161 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_162 = -tmp_moved_constant_160 - tmp_moved_constant_161;
       const real_t tmp_moved_constant_163 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_164 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_165 = -tmp_moved_constant_163 - tmp_moved_constant_164;
       const real_t tmp_moved_constant_166 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_167 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_17;
       const real_t tmp_moved_constant_168 = -tmp_moved_constant_166 - tmp_moved_constant_167;
       const real_t tmp_moved_constant_169 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_170 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_171 = -tmp_moved_constant_169 - tmp_moved_constant_170;
       const real_t tmp_moved_constant_172 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_173 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_174 = -tmp_moved_constant_172 - tmp_moved_constant_173;
       const real_t tmp_moved_constant_175 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_176 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_177 = -tmp_moved_constant_175 - tmp_moved_constant_176;
       const real_t tmp_moved_constant_178 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_179 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_17;
       const real_t tmp_moved_constant_180 = -tmp_moved_constant_178 - tmp_moved_constant_179;
       const real_t tmp_moved_constant_181 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_182 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_183 = -tmp_moved_constant_181 - tmp_moved_constant_182;
       const real_t tmp_moved_constant_184 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_148 + tmp_moved_constant_160;
       const real_t tmp_moved_constant_185 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_151 + tmp_moved_constant_163;
       const real_t tmp_moved_constant_186 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_154 + tmp_moved_constant_166;
       const real_t tmp_moved_constant_187 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_157 + tmp_moved_constant_169;
       const real_t tmp_moved_constant_188 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_149 + tmp_moved_constant_172;
       const real_t tmp_moved_constant_189 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_152 + tmp_moved_constant_175;
       const real_t tmp_moved_constant_190 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_155 + tmp_moved_constant_178;
       const real_t tmp_moved_constant_191 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_158 + tmp_moved_constant_181;
       const real_t tmp_moved_constant_192 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_161 + tmp_moved_constant_173;
       const real_t tmp_moved_constant_193 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_164 + tmp_moved_constant_176;
       const real_t tmp_moved_constant_194 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_167 + tmp_moved_constant_179;
       const real_t tmp_moved_constant_195 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_170 + tmp_moved_constant_182;
       const real_t tmp_moved_constant_196 = tmp_moved_constant_125*0.1381966011250105;
       const real_t tmp_moved_constant_197 = tmp_moved_constant_128*0.1381966011250105;
       const real_t tmp_moved_constant_198 = tmp_moved_constant_131*0.5854101966249684;
       const real_t tmp_moved_constant_199 = tmp_moved_constant_134*0.1381966011250105;
       const real_t tmp_moved_constant_200 = tmp_moved_constant_125*0.1381966011250105;
       const real_t tmp_moved_constant_201 = tmp_moved_constant_128*0.5854101966249684;
       const real_t tmp_moved_constant_202 = tmp_moved_constant_131*0.1381966011250105;
       const real_t tmp_moved_constant_203 = tmp_moved_constant_134*0.1381966011250105;
       const real_t tmp_moved_constant_204 = tmp_moved_constant_125*0.5854101966249684;
       const real_t tmp_moved_constant_205 = tmp_moved_constant_128*0.1381966011250105;
       const real_t tmp_moved_constant_206 = tmp_moved_constant_131*0.1381966011250105;
       const real_t tmp_moved_constant_207 = tmp_moved_constant_134*0.1381966011250105;
       const real_t tmp_moved_constant_208 = tmp_moved_constant_124*tmp_moved_constant_126 + tmp_moved_constant_127*tmp_moved_constant_129 + tmp_moved_constant_130*tmp_moved_constant_132 + tmp_moved_constant_133*tmp_moved_constant_135;
       const real_t tmp_moved_constant_209 = -tmp_moved_constant_126*tmp_moved_constant_136 - tmp_moved_constant_129*tmp_moved_constant_137 - tmp_moved_constant_132*tmp_moved_constant_138 - tmp_moved_constant_135*tmp_moved_constant_139;
       const real_t tmp_moved_constant_210 = -tmp_moved_constant_126*tmp_moved_constant_140 - tmp_moved_constant_129*tmp_moved_constant_141 - tmp_moved_constant_132*tmp_moved_constant_142 - tmp_moved_constant_135*tmp_moved_constant_143;
       const real_t tmp_moved_constant_211 = -tmp_moved_constant_126*tmp_moved_constant_144 - tmp_moved_constant_129*tmp_moved_constant_145 - tmp_moved_constant_132*tmp_moved_constant_146 - tmp_moved_constant_135*tmp_moved_constant_147;
       const real_t tmp_moved_constant_212 = tmp_moved_constant_126*tmp_moved_constant_150 + tmp_moved_constant_129*tmp_moved_constant_153 + tmp_moved_constant_132*tmp_moved_constant_156 + tmp_moved_constant_135*tmp_moved_constant_159;
       const real_t tmp_moved_constant_213 = tmp_moved_constant_126*tmp_moved_constant_162 + tmp_moved_constant_129*tmp_moved_constant_165 + tmp_moved_constant_132*tmp_moved_constant_168 + tmp_moved_constant_135*tmp_moved_constant_171;
       const real_t tmp_moved_constant_214 = tmp_moved_constant_126*tmp_moved_constant_174 + tmp_moved_constant_129*tmp_moved_constant_177 + tmp_moved_constant_132*tmp_moved_constant_180 + tmp_moved_constant_135*tmp_moved_constant_183;
       const real_t tmp_moved_constant_215 = tmp_moved_constant_126*tmp_moved_constant_184 + tmp_moved_constant_129*tmp_moved_constant_185 + tmp_moved_constant_132*tmp_moved_constant_186 + tmp_moved_constant_135*tmp_moved_constant_187;
       const real_t tmp_moved_constant_216 = tmp_moved_constant_126*tmp_moved_constant_188 + tmp_moved_constant_129*tmp_moved_constant_189 + tmp_moved_constant_132*tmp_moved_constant_190 + tmp_moved_constant_135*tmp_moved_constant_191;
       const real_t tmp_moved_constant_217 = tmp_moved_constant_126*tmp_moved_constant_192 + tmp_moved_constant_129*tmp_moved_constant_193 + tmp_moved_constant_132*tmp_moved_constant_194 + tmp_moved_constant_135*tmp_moved_constant_195;
       const real_t tmp_moved_constant_218 = tmp_moved_constant_124*tmp_moved_constant_196 + tmp_moved_constant_127*tmp_moved_constant_197 + tmp_moved_constant_130*tmp_moved_constant_198 + tmp_moved_constant_133*tmp_moved_constant_199;
       const real_t tmp_moved_constant_219 = -tmp_moved_constant_136*tmp_moved_constant_196 - tmp_moved_constant_137*tmp_moved_constant_197 - tmp_moved_constant_138*tmp_moved_constant_198 - tmp_moved_constant_139*tmp_moved_constant_199;
       const real_t tmp_moved_constant_220 = -tmp_moved_constant_140*tmp_moved_constant_196 - tmp_moved_constant_141*tmp_moved_constant_197 - tmp_moved_constant_142*tmp_moved_constant_198 - tmp_moved_constant_143*tmp_moved_constant_199;
       const real_t tmp_moved_constant_221 = -tmp_moved_constant_144*tmp_moved_constant_196 - tmp_moved_constant_145*tmp_moved_constant_197 - tmp_moved_constant_146*tmp_moved_constant_198 - tmp_moved_constant_147*tmp_moved_constant_199;
       const real_t tmp_moved_constant_222 = tmp_moved_constant_150*tmp_moved_constant_196 + tmp_moved_constant_153*tmp_moved_constant_197 + tmp_moved_constant_156*tmp_moved_constant_198 + tmp_moved_constant_159*tmp_moved_constant_199;
       const real_t tmp_moved_constant_223 = tmp_moved_constant_162*tmp_moved_constant_196 + tmp_moved_constant_165*tmp_moved_constant_197 + tmp_moved_constant_168*tmp_moved_constant_198 + tmp_moved_constant_171*tmp_moved_constant_199;
       const real_t tmp_moved_constant_224 = tmp_moved_constant_174*tmp_moved_constant_196 + tmp_moved_constant_177*tmp_moved_constant_197 + tmp_moved_constant_180*tmp_moved_constant_198 + tmp_moved_constant_183*tmp_moved_constant_199;
       const real_t tmp_moved_constant_225 = tmp_moved_constant_184*tmp_moved_constant_196 + tmp_moved_constant_185*tmp_moved_constant_197 + tmp_moved_constant_186*tmp_moved_constant_198 + tmp_moved_constant_187*tmp_moved_constant_199;
       const real_t tmp_moved_constant_226 = tmp_moved_constant_188*tmp_moved_constant_196 + tmp_moved_constant_189*tmp_moved_constant_197 + tmp_moved_constant_190*tmp_moved_constant_198 + tmp_moved_constant_191*tmp_moved_constant_199;
       const real_t tmp_moved_constant_227 = tmp_moved_constant_192*tmp_moved_constant_196 + tmp_moved_constant_193*tmp_moved_constant_197 + tmp_moved_constant_194*tmp_moved_constant_198 + tmp_moved_constant_195*tmp_moved_constant_199;
       const real_t tmp_moved_constant_228 = tmp_moved_constant_124*tmp_moved_constant_200 + tmp_moved_constant_127*tmp_moved_constant_201 + tmp_moved_constant_130*tmp_moved_constant_202 + tmp_moved_constant_133*tmp_moved_constant_203;
       const real_t tmp_moved_constant_229 = -tmp_moved_constant_136*tmp_moved_constant_200 - tmp_moved_constant_137*tmp_moved_constant_201 - tmp_moved_constant_138*tmp_moved_constant_202 - tmp_moved_constant_139*tmp_moved_constant_203;
       const real_t tmp_moved_constant_230 = -tmp_moved_constant_140*tmp_moved_constant_200 - tmp_moved_constant_141*tmp_moved_constant_201 - tmp_moved_constant_142*tmp_moved_constant_202 - tmp_moved_constant_143*tmp_moved_constant_203;
       const real_t tmp_moved_constant_231 = -tmp_moved_constant_144*tmp_moved_constant_200 - tmp_moved_constant_145*tmp_moved_constant_201 - tmp_moved_constant_146*tmp_moved_constant_202 - tmp_moved_constant_147*tmp_moved_constant_203;
       const real_t tmp_moved_constant_232 = tmp_moved_constant_150*tmp_moved_constant_200 + tmp_moved_constant_153*tmp_moved_constant_201 + tmp_moved_constant_156*tmp_moved_constant_202 + tmp_moved_constant_159*tmp_moved_constant_203;
       const real_t tmp_moved_constant_233 = tmp_moved_constant_162*tmp_moved_constant_200 + tmp_moved_constant_165*tmp_moved_constant_201 + tmp_moved_constant_168*tmp_moved_constant_202 + tmp_moved_constant_171*tmp_moved_constant_203;
       const real_t tmp_moved_constant_234 = tmp_moved_constant_174*tmp_moved_constant_200 + tmp_moved_constant_177*tmp_moved_constant_201 + tmp_moved_constant_180*tmp_moved_constant_202 + tmp_moved_constant_183*tmp_moved_constant_203;
       const real_t tmp_moved_constant_235 = tmp_moved_constant_184*tmp_moved_constant_200 + tmp_moved_constant_185*tmp_moved_constant_201 + tmp_moved_constant_186*tmp_moved_constant_202 + tmp_moved_constant_187*tmp_moved_constant_203;
       const real_t tmp_moved_constant_236 = tmp_moved_constant_188*tmp_moved_constant_200 + tmp_moved_constant_189*tmp_moved_constant_201 + tmp_moved_constant_190*tmp_moved_constant_202 + tmp_moved_constant_191*tmp_moved_constant_203;
       const real_t tmp_moved_constant_237 = tmp_moved_constant_192*tmp_moved_constant_200 + tmp_moved_constant_193*tmp_moved_constant_201 + tmp_moved_constant_194*tmp_moved_constant_202 + tmp_moved_constant_195*tmp_moved_constant_203;
       const real_t tmp_moved_constant_238 = tmp_moved_constant_124*tmp_moved_constant_204 + tmp_moved_constant_127*tmp_moved_constant_205 + tmp_moved_constant_130*tmp_moved_constant_206 + tmp_moved_constant_133*tmp_moved_constant_207;
       const real_t tmp_moved_constant_239 = -tmp_moved_constant_136*tmp_moved_constant_204 - tmp_moved_constant_137*tmp_moved_constant_205 - tmp_moved_constant_138*tmp_moved_constant_206 - tmp_moved_constant_139*tmp_moved_constant_207;
       const real_t tmp_moved_constant_240 = -tmp_moved_constant_140*tmp_moved_constant_204 - tmp_moved_constant_141*tmp_moved_constant_205 - tmp_moved_constant_142*tmp_moved_constant_206 - tmp_moved_constant_143*tmp_moved_constant_207;
       const real_t tmp_moved_constant_241 = -tmp_moved_constant_144*tmp_moved_constant_204 - tmp_moved_constant_145*tmp_moved_constant_205 - tmp_moved_constant_146*tmp_moved_constant_206 - tmp_moved_constant_147*tmp_moved_constant_207;
       const real_t tmp_moved_constant_242 = tmp_moved_constant_150*tmp_moved_constant_204 + tmp_moved_constant_153*tmp_moved_constant_205 + tmp_moved_constant_156*tmp_moved_constant_206 + tmp_moved_constant_159*tmp_moved_constant_207;
       const real_t tmp_moved_constant_243 = tmp_moved_constant_162*tmp_moved_constant_204 + tmp_moved_constant_165*tmp_moved_constant_205 + tmp_moved_constant_168*tmp_moved_constant_206 + tmp_moved_constant_171*tmp_moved_constant_207;
       const real_t tmp_moved_constant_244 = tmp_moved_constant_174*tmp_moved_constant_204 + tmp_moved_constant_177*tmp_moved_constant_205 + tmp_moved_constant_180*tmp_moved_constant_206 + tmp_moved_constant_183*tmp_moved_constant_207;
       const real_t tmp_moved_constant_245 = tmp_moved_constant_184*tmp_moved_constant_204 + tmp_moved_constant_185*tmp_moved_constant_205 + tmp_moved_constant_186*tmp_moved_constant_206 + tmp_moved_constant_187*tmp_moved_constant_207;
       const real_t tmp_moved_constant_246 = tmp_moved_constant_188*tmp_moved_constant_204 + tmp_moved_constant_189*tmp_moved_constant_205 + tmp_moved_constant_190*tmp_moved_constant_206 + tmp_moved_constant_191*tmp_moved_constant_207;
       const real_t tmp_moved_constant_247 = tmp_moved_constant_192*tmp_moved_constant_204 + tmp_moved_constant_193*tmp_moved_constant_205 + tmp_moved_constant_194*tmp_moved_constant_206 + tmp_moved_constant_195*tmp_moved_constant_207;
       const real_t tmp_moved_constant_248 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_249 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_250 = tmp_moved_constant_249*0.13819660112501053;
       const real_t tmp_moved_constant_251 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_12 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_12 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_12;
       const real_t tmp_moved_constant_252 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_253 = tmp_moved_constant_252*0.13819660112501056;
       const real_t tmp_moved_constant_254 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_20 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_255 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_256 = tmp_moved_constant_255*0.13819660112501056;
       const real_t tmp_moved_constant_257 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_28 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_28 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_258 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_259 = tmp_moved_constant_258*0.5854101966249684;
       const real_t tmp_moved_constant_260 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_261 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_262 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_moved_constant_263 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_moved_constant_264 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_265 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_266 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_267 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_268 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_269 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_270 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_271 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_272 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_273 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_274 = -tmp_moved_constant_272 - tmp_moved_constant_273;
       const real_t tmp_moved_constant_275 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_276 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_277 = -tmp_moved_constant_275 - tmp_moved_constant_276;
       const real_t tmp_moved_constant_278 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_279 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_280 = -tmp_moved_constant_278 - tmp_moved_constant_279;
       const real_t tmp_moved_constant_281 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_282 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_283 = -tmp_moved_constant_281 - tmp_moved_constant_282;
       const real_t tmp_moved_constant_284 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_285 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_286 = -tmp_moved_constant_284 - tmp_moved_constant_285;
       const real_t tmp_moved_constant_287 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_288 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_289 = -tmp_moved_constant_287 - tmp_moved_constant_288;
       const real_t tmp_moved_constant_290 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_291 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_292 = -tmp_moved_constant_290 - tmp_moved_constant_291;
       const real_t tmp_moved_constant_293 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_294 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_295 = -tmp_moved_constant_293 - tmp_moved_constant_294;
       const real_t tmp_moved_constant_296 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_297 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_298 = -tmp_moved_constant_296 - tmp_moved_constant_297;
       const real_t tmp_moved_constant_299 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_300 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_301 = -tmp_moved_constant_299 - tmp_moved_constant_300;
       const real_t tmp_moved_constant_302 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_303 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_304 = -tmp_moved_constant_302 - tmp_moved_constant_303;
       const real_t tmp_moved_constant_305 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_306 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_307 = -tmp_moved_constant_305 - tmp_moved_constant_306;
       const real_t tmp_moved_constant_308 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_272 + tmp_moved_constant_284;
       const real_t tmp_moved_constant_309 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_275 + tmp_moved_constant_287;
       const real_t tmp_moved_constant_310 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_278 + tmp_moved_constant_290;
       const real_t tmp_moved_constant_311 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_281 + tmp_moved_constant_293;
       const real_t tmp_moved_constant_312 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_273 + tmp_moved_constant_296;
       const real_t tmp_moved_constant_313 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_276 + tmp_moved_constant_299;
       const real_t tmp_moved_constant_314 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_279 + tmp_moved_constant_302;
       const real_t tmp_moved_constant_315 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_282 + tmp_moved_constant_305;
       const real_t tmp_moved_constant_316 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_285 + tmp_moved_constant_297;
       const real_t tmp_moved_constant_317 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_288 + tmp_moved_constant_300;
       const real_t tmp_moved_constant_318 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_291 + tmp_moved_constant_303;
       const real_t tmp_moved_constant_319 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_294 + tmp_moved_constant_306;
       const real_t tmp_moved_constant_320 = tmp_moved_constant_249*0.1381966011250105;
       const real_t tmp_moved_constant_321 = tmp_moved_constant_252*0.1381966011250105;
       const real_t tmp_moved_constant_322 = tmp_moved_constant_255*0.5854101966249684;
       const real_t tmp_moved_constant_323 = tmp_moved_constant_258*0.1381966011250105;
       const real_t tmp_moved_constant_324 = tmp_moved_constant_249*0.1381966011250105;
       const real_t tmp_moved_constant_325 = tmp_moved_constant_252*0.5854101966249684;
       const real_t tmp_moved_constant_326 = tmp_moved_constant_255*0.1381966011250105;
       const real_t tmp_moved_constant_327 = tmp_moved_constant_258*0.1381966011250105;
       const real_t tmp_moved_constant_328 = tmp_moved_constant_249*0.5854101966249684;
       const real_t tmp_moved_constant_329 = tmp_moved_constant_252*0.1381966011250105;
       const real_t tmp_moved_constant_330 = tmp_moved_constant_255*0.1381966011250105;
       const real_t tmp_moved_constant_331 = tmp_moved_constant_258*0.1381966011250105;
       const real_t tmp_moved_constant_332 = tmp_moved_constant_248*tmp_moved_constant_250 + tmp_moved_constant_251*tmp_moved_constant_253 + tmp_moved_constant_254*tmp_moved_constant_256 + tmp_moved_constant_257*tmp_moved_constant_259;
       const real_t tmp_moved_constant_333 = -tmp_moved_constant_250*tmp_moved_constant_260 - tmp_moved_constant_253*tmp_moved_constant_261 - tmp_moved_constant_256*tmp_moved_constant_262 - tmp_moved_constant_259*tmp_moved_constant_263;
       const real_t tmp_moved_constant_334 = -tmp_moved_constant_250*tmp_moved_constant_264 - tmp_moved_constant_253*tmp_moved_constant_265 - tmp_moved_constant_256*tmp_moved_constant_266 - tmp_moved_constant_259*tmp_moved_constant_267;
       const real_t tmp_moved_constant_335 = -tmp_moved_constant_250*tmp_moved_constant_268 - tmp_moved_constant_253*tmp_moved_constant_269 - tmp_moved_constant_256*tmp_moved_constant_270 - tmp_moved_constant_259*tmp_moved_constant_271;
       const real_t tmp_moved_constant_336 = tmp_moved_constant_250*tmp_moved_constant_274 + tmp_moved_constant_253*tmp_moved_constant_277 + tmp_moved_constant_256*tmp_moved_constant_280 + tmp_moved_constant_259*tmp_moved_constant_283;
       const real_t tmp_moved_constant_337 = tmp_moved_constant_250*tmp_moved_constant_286 + tmp_moved_constant_253*tmp_moved_constant_289 + tmp_moved_constant_256*tmp_moved_constant_292 + tmp_moved_constant_259*tmp_moved_constant_295;
       const real_t tmp_moved_constant_338 = tmp_moved_constant_250*tmp_moved_constant_298 + tmp_moved_constant_253*tmp_moved_constant_301 + tmp_moved_constant_256*tmp_moved_constant_304 + tmp_moved_constant_259*tmp_moved_constant_307;
       const real_t tmp_moved_constant_339 = tmp_moved_constant_250*tmp_moved_constant_308 + tmp_moved_constant_253*tmp_moved_constant_309 + tmp_moved_constant_256*tmp_moved_constant_310 + tmp_moved_constant_259*tmp_moved_constant_311;
       const real_t tmp_moved_constant_340 = tmp_moved_constant_250*tmp_moved_constant_312 + tmp_moved_constant_253*tmp_moved_constant_313 + tmp_moved_constant_256*tmp_moved_constant_314 + tmp_moved_constant_259*tmp_moved_constant_315;
       const real_t tmp_moved_constant_341 = tmp_moved_constant_250*tmp_moved_constant_316 + tmp_moved_constant_253*tmp_moved_constant_317 + tmp_moved_constant_256*tmp_moved_constant_318 + tmp_moved_constant_259*tmp_moved_constant_319;
       const real_t tmp_moved_constant_342 = tmp_moved_constant_248*tmp_moved_constant_320 + tmp_moved_constant_251*tmp_moved_constant_321 + tmp_moved_constant_254*tmp_moved_constant_322 + tmp_moved_constant_257*tmp_moved_constant_323;
       const real_t tmp_moved_constant_343 = -tmp_moved_constant_260*tmp_moved_constant_320 - tmp_moved_constant_261*tmp_moved_constant_321 - tmp_moved_constant_262*tmp_moved_constant_322 - tmp_moved_constant_263*tmp_moved_constant_323;
       const real_t tmp_moved_constant_344 = -tmp_moved_constant_264*tmp_moved_constant_320 - tmp_moved_constant_265*tmp_moved_constant_321 - tmp_moved_constant_266*tmp_moved_constant_322 - tmp_moved_constant_267*tmp_moved_constant_323;
       const real_t tmp_moved_constant_345 = -tmp_moved_constant_268*tmp_moved_constant_320 - tmp_moved_constant_269*tmp_moved_constant_321 - tmp_moved_constant_270*tmp_moved_constant_322 - tmp_moved_constant_271*tmp_moved_constant_323;
       const real_t tmp_moved_constant_346 = tmp_moved_constant_274*tmp_moved_constant_320 + tmp_moved_constant_277*tmp_moved_constant_321 + tmp_moved_constant_280*tmp_moved_constant_322 + tmp_moved_constant_283*tmp_moved_constant_323;
       const real_t tmp_moved_constant_347 = tmp_moved_constant_286*tmp_moved_constant_320 + tmp_moved_constant_289*tmp_moved_constant_321 + tmp_moved_constant_292*tmp_moved_constant_322 + tmp_moved_constant_295*tmp_moved_constant_323;
       const real_t tmp_moved_constant_348 = tmp_moved_constant_298*tmp_moved_constant_320 + tmp_moved_constant_301*tmp_moved_constant_321 + tmp_moved_constant_304*tmp_moved_constant_322 + tmp_moved_constant_307*tmp_moved_constant_323;
       const real_t tmp_moved_constant_349 = tmp_moved_constant_308*tmp_moved_constant_320 + tmp_moved_constant_309*tmp_moved_constant_321 + tmp_moved_constant_310*tmp_moved_constant_322 + tmp_moved_constant_311*tmp_moved_constant_323;
       const real_t tmp_moved_constant_350 = tmp_moved_constant_312*tmp_moved_constant_320 + tmp_moved_constant_313*tmp_moved_constant_321 + tmp_moved_constant_314*tmp_moved_constant_322 + tmp_moved_constant_315*tmp_moved_constant_323;
       const real_t tmp_moved_constant_351 = tmp_moved_constant_316*tmp_moved_constant_320 + tmp_moved_constant_317*tmp_moved_constant_321 + tmp_moved_constant_318*tmp_moved_constant_322 + tmp_moved_constant_319*tmp_moved_constant_323;
       const real_t tmp_moved_constant_352 = tmp_moved_constant_248*tmp_moved_constant_324 + tmp_moved_constant_251*tmp_moved_constant_325 + tmp_moved_constant_254*tmp_moved_constant_326 + tmp_moved_constant_257*tmp_moved_constant_327;
       const real_t tmp_moved_constant_353 = -tmp_moved_constant_260*tmp_moved_constant_324 - tmp_moved_constant_261*tmp_moved_constant_325 - tmp_moved_constant_262*tmp_moved_constant_326 - tmp_moved_constant_263*tmp_moved_constant_327;
       const real_t tmp_moved_constant_354 = -tmp_moved_constant_264*tmp_moved_constant_324 - tmp_moved_constant_265*tmp_moved_constant_325 - tmp_moved_constant_266*tmp_moved_constant_326 - tmp_moved_constant_267*tmp_moved_constant_327;
       const real_t tmp_moved_constant_355 = -tmp_moved_constant_268*tmp_moved_constant_324 - tmp_moved_constant_269*tmp_moved_constant_325 - tmp_moved_constant_270*tmp_moved_constant_326 - tmp_moved_constant_271*tmp_moved_constant_327;
       const real_t tmp_moved_constant_356 = tmp_moved_constant_274*tmp_moved_constant_324 + tmp_moved_constant_277*tmp_moved_constant_325 + tmp_moved_constant_280*tmp_moved_constant_326 + tmp_moved_constant_283*tmp_moved_constant_327;
       const real_t tmp_moved_constant_357 = tmp_moved_constant_286*tmp_moved_constant_324 + tmp_moved_constant_289*tmp_moved_constant_325 + tmp_moved_constant_292*tmp_moved_constant_326 + tmp_moved_constant_295*tmp_moved_constant_327;
       const real_t tmp_moved_constant_358 = tmp_moved_constant_298*tmp_moved_constant_324 + tmp_moved_constant_301*tmp_moved_constant_325 + tmp_moved_constant_304*tmp_moved_constant_326 + tmp_moved_constant_307*tmp_moved_constant_327;
       const real_t tmp_moved_constant_359 = tmp_moved_constant_308*tmp_moved_constant_324 + tmp_moved_constant_309*tmp_moved_constant_325 + tmp_moved_constant_310*tmp_moved_constant_326 + tmp_moved_constant_311*tmp_moved_constant_327;
       const real_t tmp_moved_constant_360 = tmp_moved_constant_312*tmp_moved_constant_324 + tmp_moved_constant_313*tmp_moved_constant_325 + tmp_moved_constant_314*tmp_moved_constant_326 + tmp_moved_constant_315*tmp_moved_constant_327;
       const real_t tmp_moved_constant_361 = tmp_moved_constant_316*tmp_moved_constant_324 + tmp_moved_constant_317*tmp_moved_constant_325 + tmp_moved_constant_318*tmp_moved_constant_326 + tmp_moved_constant_319*tmp_moved_constant_327;
       const real_t tmp_moved_constant_362 = tmp_moved_constant_248*tmp_moved_constant_328 + tmp_moved_constant_251*tmp_moved_constant_329 + tmp_moved_constant_254*tmp_moved_constant_330 + tmp_moved_constant_257*tmp_moved_constant_331;
       const real_t tmp_moved_constant_363 = -tmp_moved_constant_260*tmp_moved_constant_328 - tmp_moved_constant_261*tmp_moved_constant_329 - tmp_moved_constant_262*tmp_moved_constant_330 - tmp_moved_constant_263*tmp_moved_constant_331;
       const real_t tmp_moved_constant_364 = -tmp_moved_constant_264*tmp_moved_constant_328 - tmp_moved_constant_265*tmp_moved_constant_329 - tmp_moved_constant_266*tmp_moved_constant_330 - tmp_moved_constant_267*tmp_moved_constant_331;
       const real_t tmp_moved_constant_365 = -tmp_moved_constant_268*tmp_moved_constant_328 - tmp_moved_constant_269*tmp_moved_constant_329 - tmp_moved_constant_270*tmp_moved_constant_330 - tmp_moved_constant_271*tmp_moved_constant_331;
       const real_t tmp_moved_constant_366 = tmp_moved_constant_274*tmp_moved_constant_328 + tmp_moved_constant_277*tmp_moved_constant_329 + tmp_moved_constant_280*tmp_moved_constant_330 + tmp_moved_constant_283*tmp_moved_constant_331;
       const real_t tmp_moved_constant_367 = tmp_moved_constant_286*tmp_moved_constant_328 + tmp_moved_constant_289*tmp_moved_constant_329 + tmp_moved_constant_292*tmp_moved_constant_330 + tmp_moved_constant_295*tmp_moved_constant_331;
       const real_t tmp_moved_constant_368 = tmp_moved_constant_298*tmp_moved_constant_328 + tmp_moved_constant_301*tmp_moved_constant_329 + tmp_moved_constant_304*tmp_moved_constant_330 + tmp_moved_constant_307*tmp_moved_constant_331;
       const real_t tmp_moved_constant_369 = tmp_moved_constant_308*tmp_moved_constant_328 + tmp_moved_constant_309*tmp_moved_constant_329 + tmp_moved_constant_310*tmp_moved_constant_330 + tmp_moved_constant_311*tmp_moved_constant_331;
       const real_t tmp_moved_constant_370 = tmp_moved_constant_312*tmp_moved_constant_328 + tmp_moved_constant_313*tmp_moved_constant_329 + tmp_moved_constant_314*tmp_moved_constant_330 + tmp_moved_constant_315*tmp_moved_constant_331;
       const real_t tmp_moved_constant_371 = tmp_moved_constant_316*tmp_moved_constant_328 + tmp_moved_constant_317*tmp_moved_constant_329 + tmp_moved_constant_318*tmp_moved_constant_330 + tmp_moved_constant_319*tmp_moved_constant_331;
       const real_t tmp_moved_constant_372 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_373 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_374 = tmp_moved_constant_373*0.13819660112501053;
       const real_t tmp_moved_constant_375 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_12;
       const real_t tmp_moved_constant_376 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_377 = tmp_moved_constant_376*0.13819660112501056;
       const real_t tmp_moved_constant_378 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_379 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_380 = tmp_moved_constant_379*0.13819660112501056;
       const real_t tmp_moved_constant_381 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_382 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_383 = tmp_moved_constant_382*0.5854101966249684;
       const real_t tmp_moved_constant_384 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_385 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_386 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_moved_constant_387 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_moved_constant_388 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_389 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_390 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_391 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_392 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_393 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_394 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_395 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_396 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_397 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_398 = -tmp_moved_constant_396 - tmp_moved_constant_397;
       const real_t tmp_moved_constant_399 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_400 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_401 = -tmp_moved_constant_399 - tmp_moved_constant_400;
       const real_t tmp_moved_constant_402 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_403 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_404 = -tmp_moved_constant_402 - tmp_moved_constant_403;
       const real_t tmp_moved_constant_405 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_406 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_407 = -tmp_moved_constant_405 - tmp_moved_constant_406;
       const real_t tmp_moved_constant_408 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_409 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_410 = -tmp_moved_constant_408 - tmp_moved_constant_409;
       const real_t tmp_moved_constant_411 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_412 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_413 = -tmp_moved_constant_411 - tmp_moved_constant_412;
       const real_t tmp_moved_constant_414 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_415 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_17;
       const real_t tmp_moved_constant_416 = -tmp_moved_constant_414 - tmp_moved_constant_415;
       const real_t tmp_moved_constant_417 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_418 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_419 = -tmp_moved_constant_417 - tmp_moved_constant_418;
       const real_t tmp_moved_constant_420 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_421 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_422 = -tmp_moved_constant_420 - tmp_moved_constant_421;
       const real_t tmp_moved_constant_423 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_424 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_425 = -tmp_moved_constant_423 - tmp_moved_constant_424;
       const real_t tmp_moved_constant_426 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_427 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_17;
       const real_t tmp_moved_constant_428 = -tmp_moved_constant_426 - tmp_moved_constant_427;
       const real_t tmp_moved_constant_429 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_430 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_431 = -tmp_moved_constant_429 - tmp_moved_constant_430;
       const real_t tmp_moved_constant_432 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_396 + tmp_moved_constant_408;
       const real_t tmp_moved_constant_433 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_399 + tmp_moved_constant_411;
       const real_t tmp_moved_constant_434 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_402 + tmp_moved_constant_414;
       const real_t tmp_moved_constant_435 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_405 + tmp_moved_constant_417;
       const real_t tmp_moved_constant_436 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_397 + tmp_moved_constant_420;
       const real_t tmp_moved_constant_437 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_400 + tmp_moved_constant_423;
       const real_t tmp_moved_constant_438 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_403 + tmp_moved_constant_426;
       const real_t tmp_moved_constant_439 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_406 + tmp_moved_constant_429;
       const real_t tmp_moved_constant_440 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_409 + tmp_moved_constant_421;
       const real_t tmp_moved_constant_441 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_412 + tmp_moved_constant_424;
       const real_t tmp_moved_constant_442 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_415 + tmp_moved_constant_427;
       const real_t tmp_moved_constant_443 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_418 + tmp_moved_constant_430;
       const real_t tmp_moved_constant_444 = tmp_moved_constant_373*0.1381966011250105;
       const real_t tmp_moved_constant_445 = tmp_moved_constant_376*0.1381966011250105;
       const real_t tmp_moved_constant_446 = tmp_moved_constant_379*0.5854101966249684;
       const real_t tmp_moved_constant_447 = tmp_moved_constant_382*0.1381966011250105;
       const real_t tmp_moved_constant_448 = tmp_moved_constant_373*0.1381966011250105;
       const real_t tmp_moved_constant_449 = tmp_moved_constant_376*0.5854101966249684;
       const real_t tmp_moved_constant_450 = tmp_moved_constant_379*0.1381966011250105;
       const real_t tmp_moved_constant_451 = tmp_moved_constant_382*0.1381966011250105;
       const real_t tmp_moved_constant_452 = tmp_moved_constant_373*0.5854101966249684;
       const real_t tmp_moved_constant_453 = tmp_moved_constant_376*0.1381966011250105;
       const real_t tmp_moved_constant_454 = tmp_moved_constant_379*0.1381966011250105;
       const real_t tmp_moved_constant_455 = tmp_moved_constant_382*0.1381966011250105;
       const real_t tmp_moved_constant_456 = tmp_moved_constant_372*tmp_moved_constant_374 + tmp_moved_constant_375*tmp_moved_constant_377 + tmp_moved_constant_378*tmp_moved_constant_380 + tmp_moved_constant_381*tmp_moved_constant_383;
       const real_t tmp_moved_constant_457 = -tmp_moved_constant_374*tmp_moved_constant_384 - tmp_moved_constant_377*tmp_moved_constant_385 - tmp_moved_constant_380*tmp_moved_constant_386 - tmp_moved_constant_383*tmp_moved_constant_387;
       const real_t tmp_moved_constant_458 = -tmp_moved_constant_374*tmp_moved_constant_388 - tmp_moved_constant_377*tmp_moved_constant_389 - tmp_moved_constant_380*tmp_moved_constant_390 - tmp_moved_constant_383*tmp_moved_constant_391;
       const real_t tmp_moved_constant_459 = -tmp_moved_constant_374*tmp_moved_constant_392 - tmp_moved_constant_377*tmp_moved_constant_393 - tmp_moved_constant_380*tmp_moved_constant_394 - tmp_moved_constant_383*tmp_moved_constant_395;
       const real_t tmp_moved_constant_460 = tmp_moved_constant_374*tmp_moved_constant_398 + tmp_moved_constant_377*tmp_moved_constant_401 + tmp_moved_constant_380*tmp_moved_constant_404 + tmp_moved_constant_383*tmp_moved_constant_407;
       const real_t tmp_moved_constant_461 = tmp_moved_constant_374*tmp_moved_constant_410 + tmp_moved_constant_377*tmp_moved_constant_413 + tmp_moved_constant_380*tmp_moved_constant_416 + tmp_moved_constant_383*tmp_moved_constant_419;
       const real_t tmp_moved_constant_462 = tmp_moved_constant_374*tmp_moved_constant_422 + tmp_moved_constant_377*tmp_moved_constant_425 + tmp_moved_constant_380*tmp_moved_constant_428 + tmp_moved_constant_383*tmp_moved_constant_431;
       const real_t tmp_moved_constant_463 = tmp_moved_constant_374*tmp_moved_constant_432 + tmp_moved_constant_377*tmp_moved_constant_433 + tmp_moved_constant_380*tmp_moved_constant_434 + tmp_moved_constant_383*tmp_moved_constant_435;
       const real_t tmp_moved_constant_464 = tmp_moved_constant_374*tmp_moved_constant_436 + tmp_moved_constant_377*tmp_moved_constant_437 + tmp_moved_constant_380*tmp_moved_constant_438 + tmp_moved_constant_383*tmp_moved_constant_439;
       const real_t tmp_moved_constant_465 = tmp_moved_constant_374*tmp_moved_constant_440 + tmp_moved_constant_377*tmp_moved_constant_441 + tmp_moved_constant_380*tmp_moved_constant_442 + tmp_moved_constant_383*tmp_moved_constant_443;
       const real_t tmp_moved_constant_466 = tmp_moved_constant_372*tmp_moved_constant_444 + tmp_moved_constant_375*tmp_moved_constant_445 + tmp_moved_constant_378*tmp_moved_constant_446 + tmp_moved_constant_381*tmp_moved_constant_447;
       const real_t tmp_moved_constant_467 = -tmp_moved_constant_384*tmp_moved_constant_444 - tmp_moved_constant_385*tmp_moved_constant_445 - tmp_moved_constant_386*tmp_moved_constant_446 - tmp_moved_constant_387*tmp_moved_constant_447;
       const real_t tmp_moved_constant_468 = -tmp_moved_constant_388*tmp_moved_constant_444 - tmp_moved_constant_389*tmp_moved_constant_445 - tmp_moved_constant_390*tmp_moved_constant_446 - tmp_moved_constant_391*tmp_moved_constant_447;
       const real_t tmp_moved_constant_469 = -tmp_moved_constant_392*tmp_moved_constant_444 - tmp_moved_constant_393*tmp_moved_constant_445 - tmp_moved_constant_394*tmp_moved_constant_446 - tmp_moved_constant_395*tmp_moved_constant_447;
       const real_t tmp_moved_constant_470 = tmp_moved_constant_398*tmp_moved_constant_444 + tmp_moved_constant_401*tmp_moved_constant_445 + tmp_moved_constant_404*tmp_moved_constant_446 + tmp_moved_constant_407*tmp_moved_constant_447;
       const real_t tmp_moved_constant_471 = tmp_moved_constant_410*tmp_moved_constant_444 + tmp_moved_constant_413*tmp_moved_constant_445 + tmp_moved_constant_416*tmp_moved_constant_446 + tmp_moved_constant_419*tmp_moved_constant_447;
       const real_t tmp_moved_constant_472 = tmp_moved_constant_422*tmp_moved_constant_444 + tmp_moved_constant_425*tmp_moved_constant_445 + tmp_moved_constant_428*tmp_moved_constant_446 + tmp_moved_constant_431*tmp_moved_constant_447;
       const real_t tmp_moved_constant_473 = tmp_moved_constant_432*tmp_moved_constant_444 + tmp_moved_constant_433*tmp_moved_constant_445 + tmp_moved_constant_434*tmp_moved_constant_446 + tmp_moved_constant_435*tmp_moved_constant_447;
       const real_t tmp_moved_constant_474 = tmp_moved_constant_436*tmp_moved_constant_444 + tmp_moved_constant_437*tmp_moved_constant_445 + tmp_moved_constant_438*tmp_moved_constant_446 + tmp_moved_constant_439*tmp_moved_constant_447;
       const real_t tmp_moved_constant_475 = tmp_moved_constant_440*tmp_moved_constant_444 + tmp_moved_constant_441*tmp_moved_constant_445 + tmp_moved_constant_442*tmp_moved_constant_446 + tmp_moved_constant_443*tmp_moved_constant_447;
       const real_t tmp_moved_constant_476 = tmp_moved_constant_372*tmp_moved_constant_448 + tmp_moved_constant_375*tmp_moved_constant_449 + tmp_moved_constant_378*tmp_moved_constant_450 + tmp_moved_constant_381*tmp_moved_constant_451;
       const real_t tmp_moved_constant_477 = -tmp_moved_constant_384*tmp_moved_constant_448 - tmp_moved_constant_385*tmp_moved_constant_449 - tmp_moved_constant_386*tmp_moved_constant_450 - tmp_moved_constant_387*tmp_moved_constant_451;
       const real_t tmp_moved_constant_478 = -tmp_moved_constant_388*tmp_moved_constant_448 - tmp_moved_constant_389*tmp_moved_constant_449 - tmp_moved_constant_390*tmp_moved_constant_450 - tmp_moved_constant_391*tmp_moved_constant_451;
       const real_t tmp_moved_constant_479 = -tmp_moved_constant_392*tmp_moved_constant_448 - tmp_moved_constant_393*tmp_moved_constant_449 - tmp_moved_constant_394*tmp_moved_constant_450 - tmp_moved_constant_395*tmp_moved_constant_451;
       const real_t tmp_moved_constant_480 = tmp_moved_constant_398*tmp_moved_constant_448 + tmp_moved_constant_401*tmp_moved_constant_449 + tmp_moved_constant_404*tmp_moved_constant_450 + tmp_moved_constant_407*tmp_moved_constant_451;
       const real_t tmp_moved_constant_481 = tmp_moved_constant_410*tmp_moved_constant_448 + tmp_moved_constant_413*tmp_moved_constant_449 + tmp_moved_constant_416*tmp_moved_constant_450 + tmp_moved_constant_419*tmp_moved_constant_451;
       const real_t tmp_moved_constant_482 = tmp_moved_constant_422*tmp_moved_constant_448 + tmp_moved_constant_425*tmp_moved_constant_449 + tmp_moved_constant_428*tmp_moved_constant_450 + tmp_moved_constant_431*tmp_moved_constant_451;
       const real_t tmp_moved_constant_483 = tmp_moved_constant_432*tmp_moved_constant_448 + tmp_moved_constant_433*tmp_moved_constant_449 + tmp_moved_constant_434*tmp_moved_constant_450 + tmp_moved_constant_435*tmp_moved_constant_451;
       const real_t tmp_moved_constant_484 = tmp_moved_constant_436*tmp_moved_constant_448 + tmp_moved_constant_437*tmp_moved_constant_449 + tmp_moved_constant_438*tmp_moved_constant_450 + tmp_moved_constant_439*tmp_moved_constant_451;
       const real_t tmp_moved_constant_485 = tmp_moved_constant_440*tmp_moved_constant_448 + tmp_moved_constant_441*tmp_moved_constant_449 + tmp_moved_constant_442*tmp_moved_constant_450 + tmp_moved_constant_443*tmp_moved_constant_451;
       const real_t tmp_moved_constant_486 = tmp_moved_constant_372*tmp_moved_constant_452 + tmp_moved_constant_375*tmp_moved_constant_453 + tmp_moved_constant_378*tmp_moved_constant_454 + tmp_moved_constant_381*tmp_moved_constant_455;
       const real_t tmp_moved_constant_487 = -tmp_moved_constant_384*tmp_moved_constant_452 - tmp_moved_constant_385*tmp_moved_constant_453 - tmp_moved_constant_386*tmp_moved_constant_454 - tmp_moved_constant_387*tmp_moved_constant_455;
       const real_t tmp_moved_constant_488 = -tmp_moved_constant_388*tmp_moved_constant_452 - tmp_moved_constant_389*tmp_moved_constant_453 - tmp_moved_constant_390*tmp_moved_constant_454 - tmp_moved_constant_391*tmp_moved_constant_455;
       const real_t tmp_moved_constant_489 = -tmp_moved_constant_392*tmp_moved_constant_452 - tmp_moved_constant_393*tmp_moved_constant_453 - tmp_moved_constant_394*tmp_moved_constant_454 - tmp_moved_constant_395*tmp_moved_constant_455;
       const real_t tmp_moved_constant_490 = tmp_moved_constant_398*tmp_moved_constant_452 + tmp_moved_constant_401*tmp_moved_constant_453 + tmp_moved_constant_404*tmp_moved_constant_454 + tmp_moved_constant_407*tmp_moved_constant_455;
       const real_t tmp_moved_constant_491 = tmp_moved_constant_410*tmp_moved_constant_452 + tmp_moved_constant_413*tmp_moved_constant_453 + tmp_moved_constant_416*tmp_moved_constant_454 + tmp_moved_constant_419*tmp_moved_constant_455;
       const real_t tmp_moved_constant_492 = tmp_moved_constant_422*tmp_moved_constant_452 + tmp_moved_constant_425*tmp_moved_constant_453 + tmp_moved_constant_428*tmp_moved_constant_454 + tmp_moved_constant_431*tmp_moved_constant_455;
       const real_t tmp_moved_constant_493 = tmp_moved_constant_432*tmp_moved_constant_452 + tmp_moved_constant_433*tmp_moved_constant_453 + tmp_moved_constant_434*tmp_moved_constant_454 + tmp_moved_constant_435*tmp_moved_constant_455;
       const real_t tmp_moved_constant_494 = tmp_moved_constant_436*tmp_moved_constant_452 + tmp_moved_constant_437*tmp_moved_constant_453 + tmp_moved_constant_438*tmp_moved_constant_454 + tmp_moved_constant_439*tmp_moved_constant_455;
       const real_t tmp_moved_constant_495 = tmp_moved_constant_440*tmp_moved_constant_452 + tmp_moved_constant_441*tmp_moved_constant_453 + tmp_moved_constant_442*tmp_moved_constant_454 + tmp_moved_constant_443*tmp_moved_constant_455;
       const real_t tmp_moved_constant_496 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_497 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_498 = tmp_moved_constant_497*0.13819660112501053;
       const real_t tmp_moved_constant_499 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_12 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_12 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_12;
       const real_t tmp_moved_constant_500 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_501 = tmp_moved_constant_500*0.13819660112501056;
       const real_t tmp_moved_constant_502 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_20 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_503 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_504 = tmp_moved_constant_503*0.13819660112501056;
       const real_t tmp_moved_constant_505 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_28 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_28 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_506 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_507 = tmp_moved_constant_506*0.5854101966249684;
       const real_t tmp_moved_constant_508 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_509 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_510 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_17 - 1.0);
       const real_t tmp_moved_constant_511 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_25 - 1.0);
       const real_t tmp_moved_constant_512 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_513 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_10 - 1.0);
       const real_t tmp_moved_constant_514 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_18 - 1.0);
       const real_t tmp_moved_constant_515 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_26 - 1.0);
       const real_t tmp_moved_constant_516 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_517 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_518 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_519 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_24 - 1.0);
       const real_t tmp_moved_constant_520 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_521 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_522 = -tmp_moved_constant_520 - tmp_moved_constant_521;
       const real_t tmp_moved_constant_523 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_524 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_525 = -tmp_moved_constant_523 - tmp_moved_constant_524;
       const real_t tmp_moved_constant_526 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_527 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_528 = -tmp_moved_constant_526 - tmp_moved_constant_527;
       const real_t tmp_moved_constant_529 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_530 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_531 = -tmp_moved_constant_529 - tmp_moved_constant_530;
       const real_t tmp_moved_constant_532 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_533 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_534 = -tmp_moved_constant_532 - tmp_moved_constant_533;
       const real_t tmp_moved_constant_535 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_536 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_537 = -tmp_moved_constant_535 - tmp_moved_constant_536;
       const real_t tmp_moved_constant_538 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_539 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_540 = -tmp_moved_constant_538 - tmp_moved_constant_539;
       const real_t tmp_moved_constant_541 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_542 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_543 = -tmp_moved_constant_541 - tmp_moved_constant_542;
       const real_t tmp_moved_constant_544 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_545 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_546 = -tmp_moved_constant_544 - tmp_moved_constant_545;
       const real_t tmp_moved_constant_547 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_548 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_549 = -tmp_moved_constant_547 - tmp_moved_constant_548;
       const real_t tmp_moved_constant_550 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_551 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_17;
       const real_t tmp_moved_constant_552 = -tmp_moved_constant_550 - tmp_moved_constant_551;
       const real_t tmp_moved_constant_553 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_554 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_555 = -tmp_moved_constant_553 - tmp_moved_constant_554;
       const real_t tmp_moved_constant_556 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_520 + tmp_moved_constant_532;
       const real_t tmp_moved_constant_557 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_523 + tmp_moved_constant_535;
       const real_t tmp_moved_constant_558 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_526 + tmp_moved_constant_538;
       const real_t tmp_moved_constant_559 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_529 + tmp_moved_constant_541;
       const real_t tmp_moved_constant_560 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_521 + tmp_moved_constant_544;
       const real_t tmp_moved_constant_561 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_524 + tmp_moved_constant_547;
       const real_t tmp_moved_constant_562 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_527 + tmp_moved_constant_550;
       const real_t tmp_moved_constant_563 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_530 + tmp_moved_constant_553;
       const real_t tmp_moved_constant_564 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_533 + tmp_moved_constant_545;
       const real_t tmp_moved_constant_565 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_536 + tmp_moved_constant_548;
       const real_t tmp_moved_constant_566 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_539 + tmp_moved_constant_551;
       const real_t tmp_moved_constant_567 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_542 + tmp_moved_constant_554;
       const real_t tmp_moved_constant_568 = tmp_moved_constant_497*0.1381966011250105;
       const real_t tmp_moved_constant_569 = tmp_moved_constant_500*0.1381966011250105;
       const real_t tmp_moved_constant_570 = tmp_moved_constant_503*0.5854101966249684;
       const real_t tmp_moved_constant_571 = tmp_moved_constant_506*0.1381966011250105;
       const real_t tmp_moved_constant_572 = tmp_moved_constant_497*0.1381966011250105;
       const real_t tmp_moved_constant_573 = tmp_moved_constant_500*0.5854101966249684;
       const real_t tmp_moved_constant_574 = tmp_moved_constant_503*0.1381966011250105;
       const real_t tmp_moved_constant_575 = tmp_moved_constant_506*0.1381966011250105;
       const real_t tmp_moved_constant_576 = tmp_moved_constant_497*0.5854101966249684;
       const real_t tmp_moved_constant_577 = tmp_moved_constant_500*0.1381966011250105;
       const real_t tmp_moved_constant_578 = tmp_moved_constant_503*0.1381966011250105;
       const real_t tmp_moved_constant_579 = tmp_moved_constant_506*0.1381966011250105;
       const real_t tmp_moved_constant_580 = tmp_moved_constant_496*tmp_moved_constant_498 + tmp_moved_constant_499*tmp_moved_constant_501 + tmp_moved_constant_502*tmp_moved_constant_504 + tmp_moved_constant_505*tmp_moved_constant_507;
       const real_t tmp_moved_constant_581 = -tmp_moved_constant_498*tmp_moved_constant_508 - tmp_moved_constant_501*tmp_moved_constant_509 - tmp_moved_constant_504*tmp_moved_constant_510 - tmp_moved_constant_507*tmp_moved_constant_511;
       const real_t tmp_moved_constant_582 = -tmp_moved_constant_498*tmp_moved_constant_512 - tmp_moved_constant_501*tmp_moved_constant_513 - tmp_moved_constant_504*tmp_moved_constant_514 - tmp_moved_constant_507*tmp_moved_constant_515;
       const real_t tmp_moved_constant_583 = -tmp_moved_constant_498*tmp_moved_constant_516 - tmp_moved_constant_501*tmp_moved_constant_517 - tmp_moved_constant_504*tmp_moved_constant_518 - tmp_moved_constant_507*tmp_moved_constant_519;
       const real_t tmp_moved_constant_584 = tmp_moved_constant_498*tmp_moved_constant_522 + tmp_moved_constant_501*tmp_moved_constant_525 + tmp_moved_constant_504*tmp_moved_constant_528 + tmp_moved_constant_507*tmp_moved_constant_531;
       const real_t tmp_moved_constant_585 = tmp_moved_constant_498*tmp_moved_constant_534 + tmp_moved_constant_501*tmp_moved_constant_537 + tmp_moved_constant_504*tmp_moved_constant_540 + tmp_moved_constant_507*tmp_moved_constant_543;
       const real_t tmp_moved_constant_586 = tmp_moved_constant_498*tmp_moved_constant_546 + tmp_moved_constant_501*tmp_moved_constant_549 + tmp_moved_constant_504*tmp_moved_constant_552 + tmp_moved_constant_507*tmp_moved_constant_555;
       const real_t tmp_moved_constant_587 = tmp_moved_constant_498*tmp_moved_constant_556 + tmp_moved_constant_501*tmp_moved_constant_557 + tmp_moved_constant_504*tmp_moved_constant_558 + tmp_moved_constant_507*tmp_moved_constant_559;
       const real_t tmp_moved_constant_588 = tmp_moved_constant_498*tmp_moved_constant_560 + tmp_moved_constant_501*tmp_moved_constant_561 + tmp_moved_constant_504*tmp_moved_constant_562 + tmp_moved_constant_507*tmp_moved_constant_563;
       const real_t tmp_moved_constant_589 = tmp_moved_constant_498*tmp_moved_constant_564 + tmp_moved_constant_501*tmp_moved_constant_565 + tmp_moved_constant_504*tmp_moved_constant_566 + tmp_moved_constant_507*tmp_moved_constant_567;
       const real_t tmp_moved_constant_590 = tmp_moved_constant_496*tmp_moved_constant_568 + tmp_moved_constant_499*tmp_moved_constant_569 + tmp_moved_constant_502*tmp_moved_constant_570 + tmp_moved_constant_505*tmp_moved_constant_571;
       const real_t tmp_moved_constant_591 = -tmp_moved_constant_508*tmp_moved_constant_568 - tmp_moved_constant_509*tmp_moved_constant_569 - tmp_moved_constant_510*tmp_moved_constant_570 - tmp_moved_constant_511*tmp_moved_constant_571;
       const real_t tmp_moved_constant_592 = -tmp_moved_constant_512*tmp_moved_constant_568 - tmp_moved_constant_513*tmp_moved_constant_569 - tmp_moved_constant_514*tmp_moved_constant_570 - tmp_moved_constant_515*tmp_moved_constant_571;
       const real_t tmp_moved_constant_593 = -tmp_moved_constant_516*tmp_moved_constant_568 - tmp_moved_constant_517*tmp_moved_constant_569 - tmp_moved_constant_518*tmp_moved_constant_570 - tmp_moved_constant_519*tmp_moved_constant_571;
       const real_t tmp_moved_constant_594 = tmp_moved_constant_522*tmp_moved_constant_568 + tmp_moved_constant_525*tmp_moved_constant_569 + tmp_moved_constant_528*tmp_moved_constant_570 + tmp_moved_constant_531*tmp_moved_constant_571;
       const real_t tmp_moved_constant_595 = tmp_moved_constant_534*tmp_moved_constant_568 + tmp_moved_constant_537*tmp_moved_constant_569 + tmp_moved_constant_540*tmp_moved_constant_570 + tmp_moved_constant_543*tmp_moved_constant_571;
       const real_t tmp_moved_constant_596 = tmp_moved_constant_546*tmp_moved_constant_568 + tmp_moved_constant_549*tmp_moved_constant_569 + tmp_moved_constant_552*tmp_moved_constant_570 + tmp_moved_constant_555*tmp_moved_constant_571;
       const real_t tmp_moved_constant_597 = tmp_moved_constant_556*tmp_moved_constant_568 + tmp_moved_constant_557*tmp_moved_constant_569 + tmp_moved_constant_558*tmp_moved_constant_570 + tmp_moved_constant_559*tmp_moved_constant_571;
       const real_t tmp_moved_constant_598 = tmp_moved_constant_560*tmp_moved_constant_568 + tmp_moved_constant_561*tmp_moved_constant_569 + tmp_moved_constant_562*tmp_moved_constant_570 + tmp_moved_constant_563*tmp_moved_constant_571;
       const real_t tmp_moved_constant_599 = tmp_moved_constant_564*tmp_moved_constant_568 + tmp_moved_constant_565*tmp_moved_constant_569 + tmp_moved_constant_566*tmp_moved_constant_570 + tmp_moved_constant_567*tmp_moved_constant_571;
       const real_t tmp_moved_constant_600 = tmp_moved_constant_496*tmp_moved_constant_572 + tmp_moved_constant_499*tmp_moved_constant_573 + tmp_moved_constant_502*tmp_moved_constant_574 + tmp_moved_constant_505*tmp_moved_constant_575;
       const real_t tmp_moved_constant_601 = -tmp_moved_constant_508*tmp_moved_constant_572 - tmp_moved_constant_509*tmp_moved_constant_573 - tmp_moved_constant_510*tmp_moved_constant_574 - tmp_moved_constant_511*tmp_moved_constant_575;
       const real_t tmp_moved_constant_602 = -tmp_moved_constant_512*tmp_moved_constant_572 - tmp_moved_constant_513*tmp_moved_constant_573 - tmp_moved_constant_514*tmp_moved_constant_574 - tmp_moved_constant_515*tmp_moved_constant_575;
       const real_t tmp_moved_constant_603 = -tmp_moved_constant_516*tmp_moved_constant_572 - tmp_moved_constant_517*tmp_moved_constant_573 - tmp_moved_constant_518*tmp_moved_constant_574 - tmp_moved_constant_519*tmp_moved_constant_575;
       const real_t tmp_moved_constant_604 = tmp_moved_constant_522*tmp_moved_constant_572 + tmp_moved_constant_525*tmp_moved_constant_573 + tmp_moved_constant_528*tmp_moved_constant_574 + tmp_moved_constant_531*tmp_moved_constant_575;
       const real_t tmp_moved_constant_605 = tmp_moved_constant_534*tmp_moved_constant_572 + tmp_moved_constant_537*tmp_moved_constant_573 + tmp_moved_constant_540*tmp_moved_constant_574 + tmp_moved_constant_543*tmp_moved_constant_575;
       const real_t tmp_moved_constant_606 = tmp_moved_constant_546*tmp_moved_constant_572 + tmp_moved_constant_549*tmp_moved_constant_573 + tmp_moved_constant_552*tmp_moved_constant_574 + tmp_moved_constant_555*tmp_moved_constant_575;
       const real_t tmp_moved_constant_607 = tmp_moved_constant_556*tmp_moved_constant_572 + tmp_moved_constant_557*tmp_moved_constant_573 + tmp_moved_constant_558*tmp_moved_constant_574 + tmp_moved_constant_559*tmp_moved_constant_575;
       const real_t tmp_moved_constant_608 = tmp_moved_constant_560*tmp_moved_constant_572 + tmp_moved_constant_561*tmp_moved_constant_573 + tmp_moved_constant_562*tmp_moved_constant_574 + tmp_moved_constant_563*tmp_moved_constant_575;
       const real_t tmp_moved_constant_609 = tmp_moved_constant_564*tmp_moved_constant_572 + tmp_moved_constant_565*tmp_moved_constant_573 + tmp_moved_constant_566*tmp_moved_constant_574 + tmp_moved_constant_567*tmp_moved_constant_575;
       const real_t tmp_moved_constant_610 = tmp_moved_constant_496*tmp_moved_constant_576 + tmp_moved_constant_499*tmp_moved_constant_577 + tmp_moved_constant_502*tmp_moved_constant_578 + tmp_moved_constant_505*tmp_moved_constant_579;
       const real_t tmp_moved_constant_611 = -tmp_moved_constant_508*tmp_moved_constant_576 - tmp_moved_constant_509*tmp_moved_constant_577 - tmp_moved_constant_510*tmp_moved_constant_578 - tmp_moved_constant_511*tmp_moved_constant_579;
       const real_t tmp_moved_constant_612 = -tmp_moved_constant_512*tmp_moved_constant_576 - tmp_moved_constant_513*tmp_moved_constant_577 - tmp_moved_constant_514*tmp_moved_constant_578 - tmp_moved_constant_515*tmp_moved_constant_579;
       const real_t tmp_moved_constant_613 = -tmp_moved_constant_516*tmp_moved_constant_576 - tmp_moved_constant_517*tmp_moved_constant_577 - tmp_moved_constant_518*tmp_moved_constant_578 - tmp_moved_constant_519*tmp_moved_constant_579;
       const real_t tmp_moved_constant_614 = tmp_moved_constant_522*tmp_moved_constant_576 + tmp_moved_constant_525*tmp_moved_constant_577 + tmp_moved_constant_528*tmp_moved_constant_578 + tmp_moved_constant_531*tmp_moved_constant_579;
       const real_t tmp_moved_constant_615 = tmp_moved_constant_534*tmp_moved_constant_576 + tmp_moved_constant_537*tmp_moved_constant_577 + tmp_moved_constant_540*tmp_moved_constant_578 + tmp_moved_constant_543*tmp_moved_constant_579;
       const real_t tmp_moved_constant_616 = tmp_moved_constant_546*tmp_moved_constant_576 + tmp_moved_constant_549*tmp_moved_constant_577 + tmp_moved_constant_552*tmp_moved_constant_578 + tmp_moved_constant_555*tmp_moved_constant_579;
       const real_t tmp_moved_constant_617 = tmp_moved_constant_556*tmp_moved_constant_576 + tmp_moved_constant_557*tmp_moved_constant_577 + tmp_moved_constant_558*tmp_moved_constant_578 + tmp_moved_constant_559*tmp_moved_constant_579;
       const real_t tmp_moved_constant_618 = tmp_moved_constant_560*tmp_moved_constant_576 + tmp_moved_constant_561*tmp_moved_constant_577 + tmp_moved_constant_562*tmp_moved_constant_578 + tmp_moved_constant_563*tmp_moved_constant_579;
       const real_t tmp_moved_constant_619 = tmp_moved_constant_564*tmp_moved_constant_576 + tmp_moved_constant_565*tmp_moved_constant_577 + tmp_moved_constant_566*tmp_moved_constant_578 + tmp_moved_constant_567*tmp_moved_constant_579;
       for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
       for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
       {
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(elMat_0_0));
                   _data_mat[1] = ((real_t)(elMat_0_1));
                   _data_mat[2] = ((real_t)(elMat_0_2));
                   _data_mat[3] = ((real_t)(elMat_0_3));
                   _data_mat[4] = ((real_t)(elMat_0_4));
                   _data_mat[5] = ((real_t)(elMat_0_5));
                   _data_mat[6] = ((real_t)(elMat_0_6));
                   _data_mat[7] = ((real_t)(elMat_0_7));
                   _data_mat[8] = ((real_t)(elMat_0_8));
                   _data_mat[9] = ((real_t)(elMat_0_9));
                   _data_mat[10] = ((real_t)(elMat_1_0));
                   _data_mat[11] = ((real_t)(elMat_1_1));
                   _data_mat[12] = ((real_t)(elMat_1_2));
                   _data_mat[13] = ((real_t)(elMat_1_3));
                   _data_mat[14] = ((real_t)(elMat_1_4));
                   _data_mat[15] = ((real_t)(elMat_1_5));
                   _data_mat[16] = ((real_t)(elMat_1_6));
                   _data_mat[17] = ((real_t)(elMat_1_7));
                   _data_mat[18] = ((real_t)(elMat_1_8));
                   _data_mat[19] = ((real_t)(elMat_1_9));
                   _data_mat[20] = ((real_t)(elMat_2_0));
                   _data_mat[21] = ((real_t)(elMat_2_1));
                   _data_mat[22] = ((real_t)(elMat_2_2));
                   _data_mat[23] = ((real_t)(elMat_2_3));
                   _data_mat[24] = ((real_t)(elMat_2_4));
                   _data_mat[25] = ((real_t)(elMat_2_5));
                   _data_mat[26] = ((real_t)(elMat_2_6));
                   _data_mat[27] = ((real_t)(elMat_2_7));
                   _data_mat[28] = ((real_t)(elMat_2_8));
                   _data_mat[29] = ((real_t)(elMat_2_9));
                   _data_mat[30] = ((real_t)(elMat_3_0));
                   _data_mat[31] = ((real_t)(elMat_3_1));
                   _data_mat[32] = ((real_t)(elMat_3_2));
                   _data_mat[33] = ((real_t)(elMat_3_3));
                   _data_mat[34] = ((real_t)(elMat_3_4));
                   _data_mat[35] = ((real_t)(elMat_3_5));
                   _data_mat[36] = ((real_t)(elMat_3_6));
                   _data_mat[37] = ((real_t)(elMat_3_7));
                   _data_mat[38] = ((real_t)(elMat_3_8));
                   _data_mat[39] = ((real_t)(elMat_3_9));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_84));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_85));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_86));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_87));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_88));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_89));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_90));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_91));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_92));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_93));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_94));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_95));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_96));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_97));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_98));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_99));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_100));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_101));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_102));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_103));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_104));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_105));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_106));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_107));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_108));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_109));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_110));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_111));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_112));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_113));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_114));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_115));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_116));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_117));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_118));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_119));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_120));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_121));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_122));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_123));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_208));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_209));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_210));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_211));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_212));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_213));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_214));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_215));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_216));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_217));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_218));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_219));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_220));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_221));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_222));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_223));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_224));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_225));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_226));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_227));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_228));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_229));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_230));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_231));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_232));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_233));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_234));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_235));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_236));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_237));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_238));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_239));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_240));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_241));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_242));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_243));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_244));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_245));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_246));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_247));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_332));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_333));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_334));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_335));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_336));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_337));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_338));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_339));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_340));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_341));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_342));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_343));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_344));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_345));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_346));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_347));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_348));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_349));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_350));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_351));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_352));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_353));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_354));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_355));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_356));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_357));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_358));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_359));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_360));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_361));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_362));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_363));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_364));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_365));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_366));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_367));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_368));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_369));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_370));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_371));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_456));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_457));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_458));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_459));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_460));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_461));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_462));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_463));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_464));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_465));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_466));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_467));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_468));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_469));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_470));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_471));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_472));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_473));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_474));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_475));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_476));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_477));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_478));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_479));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_480));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_481));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_482));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_483));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_484));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_485));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_486));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_487));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_488));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_489));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_490));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_491));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_492));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_493));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_494));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_495));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_580));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_581));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_582));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_583));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_584));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_585));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_586));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_587));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_588));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_589));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_590));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_591));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_592));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_593));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_594));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_595));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_596));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_597));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_598));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_599));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_600));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_601));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_602));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_603));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_604));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_605));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_606));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_607));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_608));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_609));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_610));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_611));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_612));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_613));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_614));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_615));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_616));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_617));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_618));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_619));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
          }
          if (-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2 >= 0)
          {
             const real_t tmp_kernel_op_0 = 2.3416407864998736;
             const real_t tmp_kernel_op_1 = 0.55278640450004202;
             const real_t tmp_kernel_op_2 = 0.55278640450004202;
             const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
             const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
             const real_t tmp_kernel_op_5 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_4;
             const real_t tmp_kernel_op_6 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_7 = tmp_kernel_op_6*0.13819660112501053;
             const real_t tmp_kernel_op_8 = 0.55278640450004202;
             const real_t tmp_kernel_op_9 = 0.55278640450004202;
             const real_t tmp_kernel_op_10 = 2.3416407864998736;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_10 + tmp_kernel_op_9;
             const real_t tmp_kernel_op_12 = tmp_kernel_op_11 + tmp_kernel_op_8 - 3.0;
             const real_t tmp_kernel_op_13 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_12;
             const real_t tmp_kernel_op_14 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_15 = tmp_kernel_op_14*0.13819660112501056;
             const real_t tmp_kernel_op_16 = 0.55278640450004202;
             const real_t tmp_kernel_op_17 = 2.3416407864998736;
             const real_t tmp_kernel_op_18 = 0.55278640450004202;
             const real_t tmp_kernel_op_19 = tmp_kernel_op_17 + tmp_kernel_op_18;
             const real_t tmp_kernel_op_20 = tmp_kernel_op_16 + tmp_kernel_op_19 - 3.0;
             const real_t tmp_kernel_op_21 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
             const real_t tmp_kernel_op_22 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_23 = tmp_kernel_op_22*0.13819660112501056;
             const real_t tmp_kernel_op_24 = 0.55278640450004202;
             const real_t tmp_kernel_op_25 = 0.55278640450004202;
             const real_t tmp_kernel_op_26 = 0.55278640450004202;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_25 + tmp_kernel_op_26;
             const real_t tmp_kernel_op_28 = tmp_kernel_op_24 + tmp_kernel_op_27 - 3.0;
             const real_t tmp_kernel_op_29 = -jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_28;
             const real_t tmp_kernel_op_30 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_31 = tmp_kernel_op_30*0.5854101966249684;
             const real_t tmp_kernel_op_32 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_kernel_op_33 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_kernel_op_34 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_17 - 1.0);
             const real_t tmp_kernel_op_35 = jac_affine_inv_0_0_WHITE_UP*(tmp_kernel_op_25 - 1.0);
             const real_t tmp_kernel_op_36 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_kernel_op_37 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_10 - 1.0);
             const real_t tmp_kernel_op_38 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_18 - 1.0);
             const real_t tmp_kernel_op_39 = jac_affine_inv_1_0_WHITE_UP*(tmp_kernel_op_26 - 1.0);
             const real_t tmp_kernel_op_40 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_kernel_op_41 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_kernel_op_42 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_kernel_op_43 = jac_affine_inv_2_0_WHITE_UP*(tmp_kernel_op_24 - 1.0);
             const real_t tmp_kernel_op_44 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
             const real_t tmp_kernel_op_45 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_2;
             const real_t tmp_kernel_op_46 = -tmp_kernel_op_44 - tmp_kernel_op_45;
             const real_t tmp_kernel_op_47 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_8;
             const real_t tmp_kernel_op_48 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
             const real_t tmp_kernel_op_49 = -tmp_kernel_op_47 - tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_16;
             const real_t tmp_kernel_op_51 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_18;
             const real_t tmp_kernel_op_52 = -tmp_kernel_op_50 - tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_24;
             const real_t tmp_kernel_op_54 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
             const real_t tmp_kernel_op_55 = -tmp_kernel_op_53 - tmp_kernel_op_54;
             const real_t tmp_kernel_op_56 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_0;
             const real_t tmp_kernel_op_57 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_1;
             const real_t tmp_kernel_op_58 = -tmp_kernel_op_56 - tmp_kernel_op_57;
             const real_t tmp_kernel_op_59 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_8;
             const real_t tmp_kernel_op_60 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_9;
             const real_t tmp_kernel_op_61 = -tmp_kernel_op_59 - tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_16;
             const real_t tmp_kernel_op_63 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_17;
             const real_t tmp_kernel_op_64 = -tmp_kernel_op_62 - tmp_kernel_op_63;
             const real_t tmp_kernel_op_65 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_24;
             const real_t tmp_kernel_op_66 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_25;
             const real_t tmp_kernel_op_67 = -tmp_kernel_op_65 - tmp_kernel_op_66;
             const real_t tmp_kernel_op_68 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_2;
             const real_t tmp_kernel_op_69 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_1;
             const real_t tmp_kernel_op_70 = -tmp_kernel_op_68 - tmp_kernel_op_69;
             const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_10;
             const real_t tmp_kernel_op_72 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_9;
             const real_t tmp_kernel_op_73 = -tmp_kernel_op_71 - tmp_kernel_op_72;
             const real_t tmp_kernel_op_74 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_18;
             const real_t tmp_kernel_op_75 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_17;
             const real_t tmp_kernel_op_76 = -tmp_kernel_op_74 - tmp_kernel_op_75;
             const real_t tmp_kernel_op_77 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
             const real_t tmp_kernel_op_78 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25;
             const real_t tmp_kernel_op_79 = -tmp_kernel_op_77 - tmp_kernel_op_78;
             const real_t tmp_kernel_op_80 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_kernel_op_44 + tmp_kernel_op_56;
             const real_t tmp_kernel_op_81 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_kernel_op_47 + tmp_kernel_op_59;
             const real_t tmp_kernel_op_82 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_kernel_op_50 + tmp_kernel_op_62;
             const real_t tmp_kernel_op_83 = -jac_affine_inv_2_0_WHITE_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_kernel_op_53 + tmp_kernel_op_65;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_0 - 4.0;
             const real_t tmp_kernel_op_85 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_kernel_op_45 + tmp_kernel_op_68;
             const real_t tmp_kernel_op_86 = tmp_kernel_op_8 - 4.0;
             const real_t tmp_kernel_op_87 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_kernel_op_48 + tmp_kernel_op_71;
             const real_t tmp_kernel_op_88 = tmp_kernel_op_16 - 4.0;
             const real_t tmp_kernel_op_89 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_kernel_op_51 + tmp_kernel_op_74;
             const real_t tmp_kernel_op_90 = tmp_kernel_op_24 - 4.0;
             const real_t tmp_kernel_op_91 = -jac_affine_inv_1_0_WHITE_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_kernel_op_54 + tmp_kernel_op_77;
             const real_t tmp_kernel_op_92 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_kernel_op_57 + tmp_kernel_op_69;
             const real_t tmp_kernel_op_93 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_kernel_op_60 + tmp_kernel_op_72;
             const real_t tmp_kernel_op_94 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_kernel_op_63 + tmp_kernel_op_75;
             const real_t tmp_kernel_op_95 = -jac_affine_inv_0_0_WHITE_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_kernel_op_66 + tmp_kernel_op_78;
             const real_t tmp_kernel_op_96 = tmp_kernel_op_6*0.1381966011250105;
             const real_t tmp_kernel_op_97 = tmp_kernel_op_14*0.1381966011250105;
             const real_t tmp_kernel_op_98 = tmp_kernel_op_22*0.5854101966249684;
             const real_t tmp_kernel_op_99 = tmp_kernel_op_30*0.1381966011250105;
             const real_t tmp_kernel_op_100 = tmp_kernel_op_6*0.1381966011250105;
             const real_t tmp_kernel_op_101 = tmp_kernel_op_14*0.5854101966249684;
             const real_t tmp_kernel_op_102 = tmp_kernel_op_22*0.1381966011250105;
             const real_t tmp_kernel_op_103 = tmp_kernel_op_30*0.1381966011250105;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_6*0.5854101966249684;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_14*0.1381966011250105;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_22*0.1381966011250105;
             const real_t tmp_kernel_op_107 = tmp_kernel_op_30*0.1381966011250105;
             const real_t elMat_0_0 = tmp_kernel_op_13*tmp_kernel_op_15 + tmp_kernel_op_21*tmp_kernel_op_23 + tmp_kernel_op_29*tmp_kernel_op_31 + tmp_kernel_op_5*tmp_kernel_op_7;
             const real_t elMat_0_1 = -tmp_kernel_op_15*tmp_kernel_op_33 - tmp_kernel_op_23*tmp_kernel_op_34 - tmp_kernel_op_31*tmp_kernel_op_35 - tmp_kernel_op_32*tmp_kernel_op_7;
             const real_t elMat_0_2 = -tmp_kernel_op_15*tmp_kernel_op_37 - tmp_kernel_op_23*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_36*tmp_kernel_op_7;
             const real_t elMat_0_3 = -tmp_kernel_op_15*tmp_kernel_op_41 - tmp_kernel_op_23*tmp_kernel_op_42 - tmp_kernel_op_31*tmp_kernel_op_43 - tmp_kernel_op_40*tmp_kernel_op_7;
             const real_t elMat_0_4 = tmp_kernel_op_15*tmp_kernel_op_49 + tmp_kernel_op_23*tmp_kernel_op_52 + tmp_kernel_op_31*tmp_kernel_op_55 + tmp_kernel_op_46*tmp_kernel_op_7;
             const real_t elMat_0_5 = tmp_kernel_op_15*tmp_kernel_op_61 + tmp_kernel_op_23*tmp_kernel_op_64 + tmp_kernel_op_31*tmp_kernel_op_67 + tmp_kernel_op_58*tmp_kernel_op_7;
             const real_t elMat_0_6 = tmp_kernel_op_15*tmp_kernel_op_73 + tmp_kernel_op_23*tmp_kernel_op_76 + tmp_kernel_op_31*tmp_kernel_op_79 + tmp_kernel_op_7*tmp_kernel_op_70;
             const real_t elMat_0_7 = tmp_kernel_op_15*tmp_kernel_op_81 + tmp_kernel_op_23*tmp_kernel_op_82 + tmp_kernel_op_31*tmp_kernel_op_83 + tmp_kernel_op_7*tmp_kernel_op_80;
             const real_t elMat_0_8 = tmp_kernel_op_15*tmp_kernel_op_87 + tmp_kernel_op_23*tmp_kernel_op_89 + tmp_kernel_op_31*tmp_kernel_op_91 + tmp_kernel_op_7*tmp_kernel_op_85;
             const real_t elMat_0_9 = tmp_kernel_op_15*tmp_kernel_op_93 + tmp_kernel_op_23*tmp_kernel_op_94 + tmp_kernel_op_31*tmp_kernel_op_95 + tmp_kernel_op_7*tmp_kernel_op_92;
             const real_t elMat_1_0 = tmp_kernel_op_13*tmp_kernel_op_97 + tmp_kernel_op_21*tmp_kernel_op_98 + tmp_kernel_op_29*tmp_kernel_op_99 + tmp_kernel_op_5*tmp_kernel_op_96;
             const real_t elMat_1_1 = -tmp_kernel_op_32*tmp_kernel_op_96 - tmp_kernel_op_33*tmp_kernel_op_97 - tmp_kernel_op_34*tmp_kernel_op_98 - tmp_kernel_op_35*tmp_kernel_op_99;
             const real_t elMat_1_2 = -tmp_kernel_op_36*tmp_kernel_op_96 - tmp_kernel_op_37*tmp_kernel_op_97 - tmp_kernel_op_38*tmp_kernel_op_98 - tmp_kernel_op_39*tmp_kernel_op_99;
             const real_t elMat_1_3 = -tmp_kernel_op_40*tmp_kernel_op_96 - tmp_kernel_op_41*tmp_kernel_op_97 - tmp_kernel_op_42*tmp_kernel_op_98 - tmp_kernel_op_43*tmp_kernel_op_99;
             const real_t elMat_1_4 = tmp_kernel_op_46*tmp_kernel_op_96 + tmp_kernel_op_49*tmp_kernel_op_97 + tmp_kernel_op_52*tmp_kernel_op_98 + tmp_kernel_op_55*tmp_kernel_op_99;
             const real_t elMat_1_5 = tmp_kernel_op_58*tmp_kernel_op_96 + tmp_kernel_op_61*tmp_kernel_op_97 + tmp_kernel_op_64*tmp_kernel_op_98 + tmp_kernel_op_67*tmp_kernel_op_99;
             const real_t elMat_1_6 = tmp_kernel_op_70*tmp_kernel_op_96 + tmp_kernel_op_73*tmp_kernel_op_97 + tmp_kernel_op_76*tmp_kernel_op_98 + tmp_kernel_op_79*tmp_kernel_op_99;
             const real_t elMat_1_7 = tmp_kernel_op_80*tmp_kernel_op_96 + tmp_kernel_op_81*tmp_kernel_op_97 + tmp_kernel_op_82*tmp_kernel_op_98 + tmp_kernel_op_83*tmp_kernel_op_99;
             const real_t elMat_1_8 = tmp_kernel_op_85*tmp_kernel_op_96 + tmp_kernel_op_87*tmp_kernel_op_97 + tmp_kernel_op_89*tmp_kernel_op_98 + tmp_kernel_op_91*tmp_kernel_op_99;
             const real_t elMat_1_9 = tmp_kernel_op_92*tmp_kernel_op_96 + tmp_kernel_op_93*tmp_kernel_op_97 + tmp_kernel_op_94*tmp_kernel_op_98 + tmp_kernel_op_95*tmp_kernel_op_99;
             const real_t elMat_2_0 = tmp_kernel_op_100*tmp_kernel_op_5 + tmp_kernel_op_101*tmp_kernel_op_13 + tmp_kernel_op_102*tmp_kernel_op_21 + tmp_kernel_op_103*tmp_kernel_op_29;
             const real_t elMat_2_1 = -tmp_kernel_op_100*tmp_kernel_op_32 - tmp_kernel_op_101*tmp_kernel_op_33 - tmp_kernel_op_102*tmp_kernel_op_34 - tmp_kernel_op_103*tmp_kernel_op_35;
             const real_t elMat_2_2 = -tmp_kernel_op_100*tmp_kernel_op_36 - tmp_kernel_op_101*tmp_kernel_op_37 - tmp_kernel_op_102*tmp_kernel_op_38 - tmp_kernel_op_103*tmp_kernel_op_39;
             const real_t elMat_2_3 = -tmp_kernel_op_100*tmp_kernel_op_40 - tmp_kernel_op_101*tmp_kernel_op_41 - tmp_kernel_op_102*tmp_kernel_op_42 - tmp_kernel_op_103*tmp_kernel_op_43;
             const real_t elMat_2_4 = tmp_kernel_op_100*tmp_kernel_op_46 + tmp_kernel_op_101*tmp_kernel_op_49 + tmp_kernel_op_102*tmp_kernel_op_52 + tmp_kernel_op_103*tmp_kernel_op_55;
             const real_t elMat_2_5 = tmp_kernel_op_100*tmp_kernel_op_58 + tmp_kernel_op_101*tmp_kernel_op_61 + tmp_kernel_op_102*tmp_kernel_op_64 + tmp_kernel_op_103*tmp_kernel_op_67;
             const real_t elMat_2_6 = tmp_kernel_op_100*tmp_kernel_op_70 + tmp_kernel_op_101*tmp_kernel_op_73 + tmp_kernel_op_102*tmp_kernel_op_76 + tmp_kernel_op_103*tmp_kernel_op_79;
             const real_t elMat_2_7 = tmp_kernel_op_100*tmp_kernel_op_80 + tmp_kernel_op_101*tmp_kernel_op_81 + tmp_kernel_op_102*tmp_kernel_op_82 + tmp_kernel_op_103*tmp_kernel_op_83;
             const real_t elMat_2_8 = tmp_kernel_op_100*tmp_kernel_op_85 + tmp_kernel_op_101*tmp_kernel_op_87 + tmp_kernel_op_102*tmp_kernel_op_89 + tmp_kernel_op_103*tmp_kernel_op_91;
             const real_t elMat_2_9 = tmp_kernel_op_100*tmp_kernel_op_92 + tmp_kernel_op_101*tmp_kernel_op_93 + tmp_kernel_op_102*tmp_kernel_op_94 + tmp_kernel_op_103*tmp_kernel_op_95;
             const real_t elMat_3_0 = tmp_kernel_op_104*tmp_kernel_op_5 + tmp_kernel_op_105*tmp_kernel_op_13 + tmp_kernel_op_106*tmp_kernel_op_21 + tmp_kernel_op_107*tmp_kernel_op_29;
             const real_t elMat_3_1 = -tmp_kernel_op_104*tmp_kernel_op_32 - tmp_kernel_op_105*tmp_kernel_op_33 - tmp_kernel_op_106*tmp_kernel_op_34 - tmp_kernel_op_107*tmp_kernel_op_35;
             const real_t elMat_3_2 = -tmp_kernel_op_104*tmp_kernel_op_36 - tmp_kernel_op_105*tmp_kernel_op_37 - tmp_kernel_op_106*tmp_kernel_op_38 - tmp_kernel_op_107*tmp_kernel_op_39;
             const real_t elMat_3_3 = -tmp_kernel_op_104*tmp_kernel_op_40 - tmp_kernel_op_105*tmp_kernel_op_41 - tmp_kernel_op_106*tmp_kernel_op_42 - tmp_kernel_op_107*tmp_kernel_op_43;
             const real_t elMat_3_4 = tmp_kernel_op_104*tmp_kernel_op_46 + tmp_kernel_op_105*tmp_kernel_op_49 + tmp_kernel_op_106*tmp_kernel_op_52 + tmp_kernel_op_107*tmp_kernel_op_55;
             const real_t elMat_3_5 = tmp_kernel_op_104*tmp_kernel_op_58 + tmp_kernel_op_105*tmp_kernel_op_61 + tmp_kernel_op_106*tmp_kernel_op_64 + tmp_kernel_op_107*tmp_kernel_op_67;
             const real_t elMat_3_6 = tmp_kernel_op_104*tmp_kernel_op_70 + tmp_kernel_op_105*tmp_kernel_op_73 + tmp_kernel_op_106*tmp_kernel_op_76 + tmp_kernel_op_107*tmp_kernel_op_79;
             const real_t elMat_3_7 = tmp_kernel_op_104*tmp_kernel_op_80 + tmp_kernel_op_105*tmp_kernel_op_81 + tmp_kernel_op_106*tmp_kernel_op_82 + tmp_kernel_op_107*tmp_kernel_op_83;
             const real_t elMat_3_8 = tmp_kernel_op_104*tmp_kernel_op_85 + tmp_kernel_op_105*tmp_kernel_op_87 + tmp_kernel_op_106*tmp_kernel_op_89 + tmp_kernel_op_107*tmp_kernel_op_91;
             const real_t elMat_3_9 = tmp_kernel_op_104*tmp_kernel_op_92 + tmp_kernel_op_105*tmp_kernel_op_93 + tmp_kernel_op_106*tmp_kernel_op_94 + tmp_kernel_op_107*tmp_kernel_op_95;
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(elMat_0_0));
                   _data_mat[1] = ((real_t)(elMat_0_1));
                   _data_mat[2] = ((real_t)(elMat_0_2));
                   _data_mat[3] = ((real_t)(elMat_0_3));
                   _data_mat[4] = ((real_t)(elMat_0_4));
                   _data_mat[5] = ((real_t)(elMat_0_5));
                   _data_mat[6] = ((real_t)(elMat_0_6));
                   _data_mat[7] = ((real_t)(elMat_0_7));
                   _data_mat[8] = ((real_t)(elMat_0_8));
                   _data_mat[9] = ((real_t)(elMat_0_9));
                   _data_mat[10] = ((real_t)(elMat_1_0));
                   _data_mat[11] = ((real_t)(elMat_1_1));
                   _data_mat[12] = ((real_t)(elMat_1_2));
                   _data_mat[13] = ((real_t)(elMat_1_3));
                   _data_mat[14] = ((real_t)(elMat_1_4));
                   _data_mat[15] = ((real_t)(elMat_1_5));
                   _data_mat[16] = ((real_t)(elMat_1_6));
                   _data_mat[17] = ((real_t)(elMat_1_7));
                   _data_mat[18] = ((real_t)(elMat_1_8));
                   _data_mat[19] = ((real_t)(elMat_1_9));
                   _data_mat[20] = ((real_t)(elMat_2_0));
                   _data_mat[21] = ((real_t)(elMat_2_1));
                   _data_mat[22] = ((real_t)(elMat_2_2));
                   _data_mat[23] = ((real_t)(elMat_2_3));
                   _data_mat[24] = ((real_t)(elMat_2_4));
                   _data_mat[25] = ((real_t)(elMat_2_5));
                   _data_mat[26] = ((real_t)(elMat_2_6));
                   _data_mat[27] = ((real_t)(elMat_2_7));
                   _data_mat[28] = ((real_t)(elMat_2_8));
                   _data_mat[29] = ((real_t)(elMat_2_9));
                   _data_mat[30] = ((real_t)(elMat_3_0));
                   _data_mat[31] = ((real_t)(elMat_3_1));
                   _data_mat[32] = ((real_t)(elMat_3_2));
                   _data_mat[33] = ((real_t)(elMat_3_3));
                   _data_mat[34] = ((real_t)(elMat_3_4));
                   _data_mat[35] = ((real_t)(elMat_3_5));
                   _data_mat[36] = ((real_t)(elMat_3_6));
                   _data_mat[37] = ((real_t)(elMat_3_7));
                   _data_mat[38] = ((real_t)(elMat_3_8));
                   _data_mat[39] = ((real_t)(elMat_3_9));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             const real_t tmp_moved_constant_620 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_4;
             const real_t tmp_moved_constant_621 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_622 = tmp_moved_constant_621*0.13819660112501053;
             const real_t tmp_moved_constant_623 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_12;
             const real_t tmp_moved_constant_624 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_625 = tmp_moved_constant_624*0.13819660112501056;
             const real_t tmp_moved_constant_626 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
             const real_t tmp_moved_constant_627 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_628 = tmp_moved_constant_627*0.13819660112501056;
             const real_t tmp_moved_constant_629 = -jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_28;
             const real_t tmp_moved_constant_630 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_631 = tmp_moved_constant_630*0.5854101966249684;
             const real_t tmp_moved_constant_632 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_633 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_634 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_17 - 1.0);
             const real_t tmp_moved_constant_635 = jac_affine_inv_0_0_BLUE_UP*(tmp_kernel_op_25 - 1.0);
             const real_t tmp_moved_constant_636 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_637 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_10 - 1.0);
             const real_t tmp_moved_constant_638 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_18 - 1.0);
             const real_t tmp_moved_constant_639 = jac_affine_inv_1_0_BLUE_UP*(tmp_kernel_op_26 - 1.0);
             const real_t tmp_moved_constant_640 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_641 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_642 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_643 = jac_affine_inv_2_0_BLUE_UP*(tmp_kernel_op_24 - 1.0);
             const real_t tmp_moved_constant_644 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_645 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_646 = -tmp_moved_constant_644 - tmp_moved_constant_645;
             const real_t tmp_moved_constant_647 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_648 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
             const real_t tmp_moved_constant_649 = -tmp_moved_constant_647 - tmp_moved_constant_648;
             const real_t tmp_moved_constant_650 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_651 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_18;
             const real_t tmp_moved_constant_652 = -tmp_moved_constant_650 - tmp_moved_constant_651;
             const real_t tmp_moved_constant_653 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_24;
             const real_t tmp_moved_constant_654 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
             const real_t tmp_moved_constant_655 = -tmp_moved_constant_653 - tmp_moved_constant_654;
             const real_t tmp_moved_constant_656 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_657 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_658 = -tmp_moved_constant_656 - tmp_moved_constant_657;
             const real_t tmp_moved_constant_659 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_660 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_661 = -tmp_moved_constant_659 - tmp_moved_constant_660;
             const real_t tmp_moved_constant_662 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_663 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_17;
             const real_t tmp_moved_constant_664 = -tmp_moved_constant_662 - tmp_moved_constant_663;
             const real_t tmp_moved_constant_665 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_24;
             const real_t tmp_moved_constant_666 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_25;
             const real_t tmp_moved_constant_667 = -tmp_moved_constant_665 - tmp_moved_constant_666;
             const real_t tmp_moved_constant_668 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_669 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_670 = -tmp_moved_constant_668 - tmp_moved_constant_669;
             const real_t tmp_moved_constant_671 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_10;
             const real_t tmp_moved_constant_672 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_673 = -tmp_moved_constant_671 - tmp_moved_constant_672;
             const real_t tmp_moved_constant_674 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_18;
             const real_t tmp_moved_constant_675 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_17;
             const real_t tmp_moved_constant_676 = -tmp_moved_constant_674 - tmp_moved_constant_675;
             const real_t tmp_moved_constant_677 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
             const real_t tmp_moved_constant_678 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_25;
             const real_t tmp_moved_constant_679 = -tmp_moved_constant_677 - tmp_moved_constant_678;
             const real_t tmp_moved_constant_680 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_644 + tmp_moved_constant_656;
             const real_t tmp_moved_constant_681 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_647 + tmp_moved_constant_659;
             const real_t tmp_moved_constant_682 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_650 + tmp_moved_constant_662;
             const real_t tmp_moved_constant_683 = -jac_affine_inv_2_0_BLUE_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_653 + tmp_moved_constant_665;
             const real_t tmp_moved_constant_684 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_645 + tmp_moved_constant_668;
             const real_t tmp_moved_constant_685 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_648 + tmp_moved_constant_671;
             const real_t tmp_moved_constant_686 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_651 + tmp_moved_constant_674;
             const real_t tmp_moved_constant_687 = -jac_affine_inv_1_0_BLUE_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_654 + tmp_moved_constant_677;
             const real_t tmp_moved_constant_688 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_657 + tmp_moved_constant_669;
             const real_t tmp_moved_constant_689 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_660 + tmp_moved_constant_672;
             const real_t tmp_moved_constant_690 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_663 + tmp_moved_constant_675;
             const real_t tmp_moved_constant_691 = -jac_affine_inv_0_0_BLUE_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_666 + tmp_moved_constant_678;
             const real_t tmp_moved_constant_692 = tmp_moved_constant_621*0.1381966011250105;
             const real_t tmp_moved_constant_693 = tmp_moved_constant_624*0.1381966011250105;
             const real_t tmp_moved_constant_694 = tmp_moved_constant_627*0.5854101966249684;
             const real_t tmp_moved_constant_695 = tmp_moved_constant_630*0.1381966011250105;
             const real_t tmp_moved_constant_696 = tmp_moved_constant_621*0.1381966011250105;
             const real_t tmp_moved_constant_697 = tmp_moved_constant_624*0.5854101966249684;
             const real_t tmp_moved_constant_698 = tmp_moved_constant_627*0.1381966011250105;
             const real_t tmp_moved_constant_699 = tmp_moved_constant_630*0.1381966011250105;
             const real_t tmp_moved_constant_700 = tmp_moved_constant_621*0.5854101966249684;
             const real_t tmp_moved_constant_701 = tmp_moved_constant_624*0.1381966011250105;
             const real_t tmp_moved_constant_702 = tmp_moved_constant_627*0.1381966011250105;
             const real_t tmp_moved_constant_703 = tmp_moved_constant_630*0.1381966011250105;
             const real_t tmp_moved_constant_704 = tmp_moved_constant_620*tmp_moved_constant_622 + tmp_moved_constant_623*tmp_moved_constant_625 + tmp_moved_constant_626*tmp_moved_constant_628 + tmp_moved_constant_629*tmp_moved_constant_631;
             const real_t tmp_moved_constant_705 = -tmp_moved_constant_622*tmp_moved_constant_632 - tmp_moved_constant_625*tmp_moved_constant_633 - tmp_moved_constant_628*tmp_moved_constant_634 - tmp_moved_constant_631*tmp_moved_constant_635;
             const real_t tmp_moved_constant_706 = -tmp_moved_constant_622*tmp_moved_constant_636 - tmp_moved_constant_625*tmp_moved_constant_637 - tmp_moved_constant_628*tmp_moved_constant_638 - tmp_moved_constant_631*tmp_moved_constant_639;
             const real_t tmp_moved_constant_707 = -tmp_moved_constant_622*tmp_moved_constant_640 - tmp_moved_constant_625*tmp_moved_constant_641 - tmp_moved_constant_628*tmp_moved_constant_642 - tmp_moved_constant_631*tmp_moved_constant_643;
             const real_t tmp_moved_constant_708 = tmp_moved_constant_622*tmp_moved_constant_646 + tmp_moved_constant_625*tmp_moved_constant_649 + tmp_moved_constant_628*tmp_moved_constant_652 + tmp_moved_constant_631*tmp_moved_constant_655;
             const real_t tmp_moved_constant_709 = tmp_moved_constant_622*tmp_moved_constant_658 + tmp_moved_constant_625*tmp_moved_constant_661 + tmp_moved_constant_628*tmp_moved_constant_664 + tmp_moved_constant_631*tmp_moved_constant_667;
             const real_t tmp_moved_constant_710 = tmp_moved_constant_622*tmp_moved_constant_670 + tmp_moved_constant_625*tmp_moved_constant_673 + tmp_moved_constant_628*tmp_moved_constant_676 + tmp_moved_constant_631*tmp_moved_constant_679;
             const real_t tmp_moved_constant_711 = tmp_moved_constant_622*tmp_moved_constant_680 + tmp_moved_constant_625*tmp_moved_constant_681 + tmp_moved_constant_628*tmp_moved_constant_682 + tmp_moved_constant_631*tmp_moved_constant_683;
             const real_t tmp_moved_constant_712 = tmp_moved_constant_622*tmp_moved_constant_684 + tmp_moved_constant_625*tmp_moved_constant_685 + tmp_moved_constant_628*tmp_moved_constant_686 + tmp_moved_constant_631*tmp_moved_constant_687;
             const real_t tmp_moved_constant_713 = tmp_moved_constant_622*tmp_moved_constant_688 + tmp_moved_constant_625*tmp_moved_constant_689 + tmp_moved_constant_628*tmp_moved_constant_690 + tmp_moved_constant_631*tmp_moved_constant_691;
             const real_t tmp_moved_constant_714 = tmp_moved_constant_620*tmp_moved_constant_692 + tmp_moved_constant_623*tmp_moved_constant_693 + tmp_moved_constant_626*tmp_moved_constant_694 + tmp_moved_constant_629*tmp_moved_constant_695;
             const real_t tmp_moved_constant_715 = -tmp_moved_constant_632*tmp_moved_constant_692 - tmp_moved_constant_633*tmp_moved_constant_693 - tmp_moved_constant_634*tmp_moved_constant_694 - tmp_moved_constant_635*tmp_moved_constant_695;
             const real_t tmp_moved_constant_716 = -tmp_moved_constant_636*tmp_moved_constant_692 - tmp_moved_constant_637*tmp_moved_constant_693 - tmp_moved_constant_638*tmp_moved_constant_694 - tmp_moved_constant_639*tmp_moved_constant_695;
             const real_t tmp_moved_constant_717 = -tmp_moved_constant_640*tmp_moved_constant_692 - tmp_moved_constant_641*tmp_moved_constant_693 - tmp_moved_constant_642*tmp_moved_constant_694 - tmp_moved_constant_643*tmp_moved_constant_695;
             const real_t tmp_moved_constant_718 = tmp_moved_constant_646*tmp_moved_constant_692 + tmp_moved_constant_649*tmp_moved_constant_693 + tmp_moved_constant_652*tmp_moved_constant_694 + tmp_moved_constant_655*tmp_moved_constant_695;
             const real_t tmp_moved_constant_719 = tmp_moved_constant_658*tmp_moved_constant_692 + tmp_moved_constant_661*tmp_moved_constant_693 + tmp_moved_constant_664*tmp_moved_constant_694 + tmp_moved_constant_667*tmp_moved_constant_695;
             const real_t tmp_moved_constant_720 = tmp_moved_constant_670*tmp_moved_constant_692 + tmp_moved_constant_673*tmp_moved_constant_693 + tmp_moved_constant_676*tmp_moved_constant_694 + tmp_moved_constant_679*tmp_moved_constant_695;
             const real_t tmp_moved_constant_721 = tmp_moved_constant_680*tmp_moved_constant_692 + tmp_moved_constant_681*tmp_moved_constant_693 + tmp_moved_constant_682*tmp_moved_constant_694 + tmp_moved_constant_683*tmp_moved_constant_695;
             const real_t tmp_moved_constant_722 = tmp_moved_constant_684*tmp_moved_constant_692 + tmp_moved_constant_685*tmp_moved_constant_693 + tmp_moved_constant_686*tmp_moved_constant_694 + tmp_moved_constant_687*tmp_moved_constant_695;
             const real_t tmp_moved_constant_723 = tmp_moved_constant_688*tmp_moved_constant_692 + tmp_moved_constant_689*tmp_moved_constant_693 + tmp_moved_constant_690*tmp_moved_constant_694 + tmp_moved_constant_691*tmp_moved_constant_695;
             const real_t tmp_moved_constant_724 = tmp_moved_constant_620*tmp_moved_constant_696 + tmp_moved_constant_623*tmp_moved_constant_697 + tmp_moved_constant_626*tmp_moved_constant_698 + tmp_moved_constant_629*tmp_moved_constant_699;
             const real_t tmp_moved_constant_725 = -tmp_moved_constant_632*tmp_moved_constant_696 - tmp_moved_constant_633*tmp_moved_constant_697 - tmp_moved_constant_634*tmp_moved_constant_698 - tmp_moved_constant_635*tmp_moved_constant_699;
             const real_t tmp_moved_constant_726 = -tmp_moved_constant_636*tmp_moved_constant_696 - tmp_moved_constant_637*tmp_moved_constant_697 - tmp_moved_constant_638*tmp_moved_constant_698 - tmp_moved_constant_639*tmp_moved_constant_699;
             const real_t tmp_moved_constant_727 = -tmp_moved_constant_640*tmp_moved_constant_696 - tmp_moved_constant_641*tmp_moved_constant_697 - tmp_moved_constant_642*tmp_moved_constant_698 - tmp_moved_constant_643*tmp_moved_constant_699;
             const real_t tmp_moved_constant_728 = tmp_moved_constant_646*tmp_moved_constant_696 + tmp_moved_constant_649*tmp_moved_constant_697 + tmp_moved_constant_652*tmp_moved_constant_698 + tmp_moved_constant_655*tmp_moved_constant_699;
             const real_t tmp_moved_constant_729 = tmp_moved_constant_658*tmp_moved_constant_696 + tmp_moved_constant_661*tmp_moved_constant_697 + tmp_moved_constant_664*tmp_moved_constant_698 + tmp_moved_constant_667*tmp_moved_constant_699;
             const real_t tmp_moved_constant_730 = tmp_moved_constant_670*tmp_moved_constant_696 + tmp_moved_constant_673*tmp_moved_constant_697 + tmp_moved_constant_676*tmp_moved_constant_698 + tmp_moved_constant_679*tmp_moved_constant_699;
             const real_t tmp_moved_constant_731 = tmp_moved_constant_680*tmp_moved_constant_696 + tmp_moved_constant_681*tmp_moved_constant_697 + tmp_moved_constant_682*tmp_moved_constant_698 + tmp_moved_constant_683*tmp_moved_constant_699;
             const real_t tmp_moved_constant_732 = tmp_moved_constant_684*tmp_moved_constant_696 + tmp_moved_constant_685*tmp_moved_constant_697 + tmp_moved_constant_686*tmp_moved_constant_698 + tmp_moved_constant_687*tmp_moved_constant_699;
             const real_t tmp_moved_constant_733 = tmp_moved_constant_688*tmp_moved_constant_696 + tmp_moved_constant_689*tmp_moved_constant_697 + tmp_moved_constant_690*tmp_moved_constant_698 + tmp_moved_constant_691*tmp_moved_constant_699;
             const real_t tmp_moved_constant_734 = tmp_moved_constant_620*tmp_moved_constant_700 + tmp_moved_constant_623*tmp_moved_constant_701 + tmp_moved_constant_626*tmp_moved_constant_702 + tmp_moved_constant_629*tmp_moved_constant_703;
             const real_t tmp_moved_constant_735 = -tmp_moved_constant_632*tmp_moved_constant_700 - tmp_moved_constant_633*tmp_moved_constant_701 - tmp_moved_constant_634*tmp_moved_constant_702 - tmp_moved_constant_635*tmp_moved_constant_703;
             const real_t tmp_moved_constant_736 = -tmp_moved_constant_636*tmp_moved_constant_700 - tmp_moved_constant_637*tmp_moved_constant_701 - tmp_moved_constant_638*tmp_moved_constant_702 - tmp_moved_constant_639*tmp_moved_constant_703;
             const real_t tmp_moved_constant_737 = -tmp_moved_constant_640*tmp_moved_constant_700 - tmp_moved_constant_641*tmp_moved_constant_701 - tmp_moved_constant_642*tmp_moved_constant_702 - tmp_moved_constant_643*tmp_moved_constant_703;
             const real_t tmp_moved_constant_738 = tmp_moved_constant_646*tmp_moved_constant_700 + tmp_moved_constant_649*tmp_moved_constant_701 + tmp_moved_constant_652*tmp_moved_constant_702 + tmp_moved_constant_655*tmp_moved_constant_703;
             const real_t tmp_moved_constant_739 = tmp_moved_constant_658*tmp_moved_constant_700 + tmp_moved_constant_661*tmp_moved_constant_701 + tmp_moved_constant_664*tmp_moved_constant_702 + tmp_moved_constant_667*tmp_moved_constant_703;
             const real_t tmp_moved_constant_740 = tmp_moved_constant_670*tmp_moved_constant_700 + tmp_moved_constant_673*tmp_moved_constant_701 + tmp_moved_constant_676*tmp_moved_constant_702 + tmp_moved_constant_679*tmp_moved_constant_703;
             const real_t tmp_moved_constant_741 = tmp_moved_constant_680*tmp_moved_constant_700 + tmp_moved_constant_681*tmp_moved_constant_701 + tmp_moved_constant_682*tmp_moved_constant_702 + tmp_moved_constant_683*tmp_moved_constant_703;
             const real_t tmp_moved_constant_742 = tmp_moved_constant_684*tmp_moved_constant_700 + tmp_moved_constant_685*tmp_moved_constant_701 + tmp_moved_constant_686*tmp_moved_constant_702 + tmp_moved_constant_687*tmp_moved_constant_703;
             const real_t tmp_moved_constant_743 = tmp_moved_constant_688*tmp_moved_constant_700 + tmp_moved_constant_689*tmp_moved_constant_701 + tmp_moved_constant_690*tmp_moved_constant_702 + tmp_moved_constant_691*tmp_moved_constant_703;
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_704));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_705));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_706));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_707));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_708));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_709));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_710));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_711));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_712));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_713));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_714));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_715));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_716));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_717));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_718));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_719));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_720));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_721));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_722));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_723));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_724));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_725));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_726));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_727));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_728));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_729));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_730));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_731));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_732));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_733));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_734));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_735));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_736));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_737));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_738));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_739));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_740));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_741));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_742));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_743));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             const real_t tmp_moved_constant_744 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_4;
             const real_t tmp_moved_constant_745 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_746 = tmp_moved_constant_745*0.13819660112501053;
             const real_t tmp_moved_constant_747 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_12 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_12 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_12;
             const real_t tmp_moved_constant_748 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_749 = tmp_moved_constant_748*0.13819660112501056;
             const real_t tmp_moved_constant_750 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_20 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
             const real_t tmp_moved_constant_751 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_752 = tmp_moved_constant_751*0.13819660112501056;
             const real_t tmp_moved_constant_753 = -jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_28 - jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_28 - jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_28;
             const real_t tmp_moved_constant_754 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_755 = tmp_moved_constant_754*0.5854101966249684;
             const real_t tmp_moved_constant_756 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_757 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_758 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_17 - 1.0);
             const real_t tmp_moved_constant_759 = jac_affine_inv_0_0_BLUE_DOWN*(tmp_kernel_op_25 - 1.0);
             const real_t tmp_moved_constant_760 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_761 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_10 - 1.0);
             const real_t tmp_moved_constant_762 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_18 - 1.0);
             const real_t tmp_moved_constant_763 = jac_affine_inv_1_0_BLUE_DOWN*(tmp_kernel_op_26 - 1.0);
             const real_t tmp_moved_constant_764 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_765 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_766 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_767 = jac_affine_inv_2_0_BLUE_DOWN*(tmp_kernel_op_24 - 1.0);
             const real_t tmp_moved_constant_768 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_769 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_770 = -tmp_moved_constant_768 - tmp_moved_constant_769;
             const real_t tmp_moved_constant_771 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_772 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
             const real_t tmp_moved_constant_773 = -tmp_moved_constant_771 - tmp_moved_constant_772;
             const real_t tmp_moved_constant_774 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_775 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_18;
             const real_t tmp_moved_constant_776 = -tmp_moved_constant_774 - tmp_moved_constant_775;
             const real_t tmp_moved_constant_777 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_24;
             const real_t tmp_moved_constant_778 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
             const real_t tmp_moved_constant_779 = -tmp_moved_constant_777 - tmp_moved_constant_778;
             const real_t tmp_moved_constant_780 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_781 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_782 = -tmp_moved_constant_780 - tmp_moved_constant_781;
             const real_t tmp_moved_constant_783 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_784 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_785 = -tmp_moved_constant_783 - tmp_moved_constant_784;
             const real_t tmp_moved_constant_786 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_787 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_17;
             const real_t tmp_moved_constant_788 = -tmp_moved_constant_786 - tmp_moved_constant_787;
             const real_t tmp_moved_constant_789 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_24;
             const real_t tmp_moved_constant_790 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_25;
             const real_t tmp_moved_constant_791 = -tmp_moved_constant_789 - tmp_moved_constant_790;
             const real_t tmp_moved_constant_792 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_793 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_794 = -tmp_moved_constant_792 - tmp_moved_constant_793;
             const real_t tmp_moved_constant_795 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_10;
             const real_t tmp_moved_constant_796 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_797 = -tmp_moved_constant_795 - tmp_moved_constant_796;
             const real_t tmp_moved_constant_798 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_18;
             const real_t tmp_moved_constant_799 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_17;
             const real_t tmp_moved_constant_800 = -tmp_moved_constant_798 - tmp_moved_constant_799;
             const real_t tmp_moved_constant_801 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
             const real_t tmp_moved_constant_802 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_25;
             const real_t tmp_moved_constant_803 = -tmp_moved_constant_801 - tmp_moved_constant_802;
             const real_t tmp_moved_constant_804 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_768 + tmp_moved_constant_780;
             const real_t tmp_moved_constant_805 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_771 + tmp_moved_constant_783;
             const real_t tmp_moved_constant_806 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_774 + tmp_moved_constant_786;
             const real_t tmp_moved_constant_807 = -jac_affine_inv_2_0_BLUE_DOWN*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_777 + tmp_moved_constant_789;
             const real_t tmp_moved_constant_808 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_769 + tmp_moved_constant_792;
             const real_t tmp_moved_constant_809 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_772 + tmp_moved_constant_795;
             const real_t tmp_moved_constant_810 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_775 + tmp_moved_constant_798;
             const real_t tmp_moved_constant_811 = -jac_affine_inv_1_0_BLUE_DOWN*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_778 + tmp_moved_constant_801;
             const real_t tmp_moved_constant_812 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_781 + tmp_moved_constant_793;
             const real_t tmp_moved_constant_813 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_784 + tmp_moved_constant_796;
             const real_t tmp_moved_constant_814 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_787 + tmp_moved_constant_799;
             const real_t tmp_moved_constant_815 = -jac_affine_inv_0_0_BLUE_DOWN*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_790 + tmp_moved_constant_802;
             const real_t tmp_moved_constant_816 = tmp_moved_constant_745*0.1381966011250105;
             const real_t tmp_moved_constant_817 = tmp_moved_constant_748*0.1381966011250105;
             const real_t tmp_moved_constant_818 = tmp_moved_constant_751*0.5854101966249684;
             const real_t tmp_moved_constant_819 = tmp_moved_constant_754*0.1381966011250105;
             const real_t tmp_moved_constant_820 = tmp_moved_constant_745*0.1381966011250105;
             const real_t tmp_moved_constant_821 = tmp_moved_constant_748*0.5854101966249684;
             const real_t tmp_moved_constant_822 = tmp_moved_constant_751*0.1381966011250105;
             const real_t tmp_moved_constant_823 = tmp_moved_constant_754*0.1381966011250105;
             const real_t tmp_moved_constant_824 = tmp_moved_constant_745*0.5854101966249684;
             const real_t tmp_moved_constant_825 = tmp_moved_constant_748*0.1381966011250105;
             const real_t tmp_moved_constant_826 = tmp_moved_constant_751*0.1381966011250105;
             const real_t tmp_moved_constant_827 = tmp_moved_constant_754*0.1381966011250105;
             const real_t tmp_moved_constant_828 = tmp_moved_constant_744*tmp_moved_constant_746 + tmp_moved_constant_747*tmp_moved_constant_749 + tmp_moved_constant_750*tmp_moved_constant_752 + tmp_moved_constant_753*tmp_moved_constant_755;
             const real_t tmp_moved_constant_829 = -tmp_moved_constant_746*tmp_moved_constant_756 - tmp_moved_constant_749*tmp_moved_constant_757 - tmp_moved_constant_752*tmp_moved_constant_758 - tmp_moved_constant_755*tmp_moved_constant_759;
             const real_t tmp_moved_constant_830 = -tmp_moved_constant_746*tmp_moved_constant_760 - tmp_moved_constant_749*tmp_moved_constant_761 - tmp_moved_constant_752*tmp_moved_constant_762 - tmp_moved_constant_755*tmp_moved_constant_763;
             const real_t tmp_moved_constant_831 = -tmp_moved_constant_746*tmp_moved_constant_764 - tmp_moved_constant_749*tmp_moved_constant_765 - tmp_moved_constant_752*tmp_moved_constant_766 - tmp_moved_constant_755*tmp_moved_constant_767;
             const real_t tmp_moved_constant_832 = tmp_moved_constant_746*tmp_moved_constant_770 + tmp_moved_constant_749*tmp_moved_constant_773 + tmp_moved_constant_752*tmp_moved_constant_776 + tmp_moved_constant_755*tmp_moved_constant_779;
             const real_t tmp_moved_constant_833 = tmp_moved_constant_746*tmp_moved_constant_782 + tmp_moved_constant_749*tmp_moved_constant_785 + tmp_moved_constant_752*tmp_moved_constant_788 + tmp_moved_constant_755*tmp_moved_constant_791;
             const real_t tmp_moved_constant_834 = tmp_moved_constant_746*tmp_moved_constant_794 + tmp_moved_constant_749*tmp_moved_constant_797 + tmp_moved_constant_752*tmp_moved_constant_800 + tmp_moved_constant_755*tmp_moved_constant_803;
             const real_t tmp_moved_constant_835 = tmp_moved_constant_746*tmp_moved_constant_804 + tmp_moved_constant_749*tmp_moved_constant_805 + tmp_moved_constant_752*tmp_moved_constant_806 + tmp_moved_constant_755*tmp_moved_constant_807;
             const real_t tmp_moved_constant_836 = tmp_moved_constant_746*tmp_moved_constant_808 + tmp_moved_constant_749*tmp_moved_constant_809 + tmp_moved_constant_752*tmp_moved_constant_810 + tmp_moved_constant_755*tmp_moved_constant_811;
             const real_t tmp_moved_constant_837 = tmp_moved_constant_746*tmp_moved_constant_812 + tmp_moved_constant_749*tmp_moved_constant_813 + tmp_moved_constant_752*tmp_moved_constant_814 + tmp_moved_constant_755*tmp_moved_constant_815;
             const real_t tmp_moved_constant_838 = tmp_moved_constant_744*tmp_moved_constant_816 + tmp_moved_constant_747*tmp_moved_constant_817 + tmp_moved_constant_750*tmp_moved_constant_818 + tmp_moved_constant_753*tmp_moved_constant_819;
             const real_t tmp_moved_constant_839 = -tmp_moved_constant_756*tmp_moved_constant_816 - tmp_moved_constant_757*tmp_moved_constant_817 - tmp_moved_constant_758*tmp_moved_constant_818 - tmp_moved_constant_759*tmp_moved_constant_819;
             const real_t tmp_moved_constant_840 = -tmp_moved_constant_760*tmp_moved_constant_816 - tmp_moved_constant_761*tmp_moved_constant_817 - tmp_moved_constant_762*tmp_moved_constant_818 - tmp_moved_constant_763*tmp_moved_constant_819;
             const real_t tmp_moved_constant_841 = -tmp_moved_constant_764*tmp_moved_constant_816 - tmp_moved_constant_765*tmp_moved_constant_817 - tmp_moved_constant_766*tmp_moved_constant_818 - tmp_moved_constant_767*tmp_moved_constant_819;
             const real_t tmp_moved_constant_842 = tmp_moved_constant_770*tmp_moved_constant_816 + tmp_moved_constant_773*tmp_moved_constant_817 + tmp_moved_constant_776*tmp_moved_constant_818 + tmp_moved_constant_779*tmp_moved_constant_819;
             const real_t tmp_moved_constant_843 = tmp_moved_constant_782*tmp_moved_constant_816 + tmp_moved_constant_785*tmp_moved_constant_817 + tmp_moved_constant_788*tmp_moved_constant_818 + tmp_moved_constant_791*tmp_moved_constant_819;
             const real_t tmp_moved_constant_844 = tmp_moved_constant_794*tmp_moved_constant_816 + tmp_moved_constant_797*tmp_moved_constant_817 + tmp_moved_constant_800*tmp_moved_constant_818 + tmp_moved_constant_803*tmp_moved_constant_819;
             const real_t tmp_moved_constant_845 = tmp_moved_constant_804*tmp_moved_constant_816 + tmp_moved_constant_805*tmp_moved_constant_817 + tmp_moved_constant_806*tmp_moved_constant_818 + tmp_moved_constant_807*tmp_moved_constant_819;
             const real_t tmp_moved_constant_846 = tmp_moved_constant_808*tmp_moved_constant_816 + tmp_moved_constant_809*tmp_moved_constant_817 + tmp_moved_constant_810*tmp_moved_constant_818 + tmp_moved_constant_811*tmp_moved_constant_819;
             const real_t tmp_moved_constant_847 = tmp_moved_constant_812*tmp_moved_constant_816 + tmp_moved_constant_813*tmp_moved_constant_817 + tmp_moved_constant_814*tmp_moved_constant_818 + tmp_moved_constant_815*tmp_moved_constant_819;
             const real_t tmp_moved_constant_848 = tmp_moved_constant_744*tmp_moved_constant_820 + tmp_moved_constant_747*tmp_moved_constant_821 + tmp_moved_constant_750*tmp_moved_constant_822 + tmp_moved_constant_753*tmp_moved_constant_823;
             const real_t tmp_moved_constant_849 = -tmp_moved_constant_756*tmp_moved_constant_820 - tmp_moved_constant_757*tmp_moved_constant_821 - tmp_moved_constant_758*tmp_moved_constant_822 - tmp_moved_constant_759*tmp_moved_constant_823;
             const real_t tmp_moved_constant_850 = -tmp_moved_constant_760*tmp_moved_constant_820 - tmp_moved_constant_761*tmp_moved_constant_821 - tmp_moved_constant_762*tmp_moved_constant_822 - tmp_moved_constant_763*tmp_moved_constant_823;
             const real_t tmp_moved_constant_851 = -tmp_moved_constant_764*tmp_moved_constant_820 - tmp_moved_constant_765*tmp_moved_constant_821 - tmp_moved_constant_766*tmp_moved_constant_822 - tmp_moved_constant_767*tmp_moved_constant_823;
             const real_t tmp_moved_constant_852 = tmp_moved_constant_770*tmp_moved_constant_820 + tmp_moved_constant_773*tmp_moved_constant_821 + tmp_moved_constant_776*tmp_moved_constant_822 + tmp_moved_constant_779*tmp_moved_constant_823;
             const real_t tmp_moved_constant_853 = tmp_moved_constant_782*tmp_moved_constant_820 + tmp_moved_constant_785*tmp_moved_constant_821 + tmp_moved_constant_788*tmp_moved_constant_822 + tmp_moved_constant_791*tmp_moved_constant_823;
             const real_t tmp_moved_constant_854 = tmp_moved_constant_794*tmp_moved_constant_820 + tmp_moved_constant_797*tmp_moved_constant_821 + tmp_moved_constant_800*tmp_moved_constant_822 + tmp_moved_constant_803*tmp_moved_constant_823;
             const real_t tmp_moved_constant_855 = tmp_moved_constant_804*tmp_moved_constant_820 + tmp_moved_constant_805*tmp_moved_constant_821 + tmp_moved_constant_806*tmp_moved_constant_822 + tmp_moved_constant_807*tmp_moved_constant_823;
             const real_t tmp_moved_constant_856 = tmp_moved_constant_808*tmp_moved_constant_820 + tmp_moved_constant_809*tmp_moved_constant_821 + tmp_moved_constant_810*tmp_moved_constant_822 + tmp_moved_constant_811*tmp_moved_constant_823;
             const real_t tmp_moved_constant_857 = tmp_moved_constant_812*tmp_moved_constant_820 + tmp_moved_constant_813*tmp_moved_constant_821 + tmp_moved_constant_814*tmp_moved_constant_822 + tmp_moved_constant_815*tmp_moved_constant_823;
             const real_t tmp_moved_constant_858 = tmp_moved_constant_744*tmp_moved_constant_824 + tmp_moved_constant_747*tmp_moved_constant_825 + tmp_moved_constant_750*tmp_moved_constant_826 + tmp_moved_constant_753*tmp_moved_constant_827;
             const real_t tmp_moved_constant_859 = -tmp_moved_constant_756*tmp_moved_constant_824 - tmp_moved_constant_757*tmp_moved_constant_825 - tmp_moved_constant_758*tmp_moved_constant_826 - tmp_moved_constant_759*tmp_moved_constant_827;
             const real_t tmp_moved_constant_860 = -tmp_moved_constant_760*tmp_moved_constant_824 - tmp_moved_constant_761*tmp_moved_constant_825 - tmp_moved_constant_762*tmp_moved_constant_826 - tmp_moved_constant_763*tmp_moved_constant_827;
             const real_t tmp_moved_constant_861 = -tmp_moved_constant_764*tmp_moved_constant_824 - tmp_moved_constant_765*tmp_moved_constant_825 - tmp_moved_constant_766*tmp_moved_constant_826 - tmp_moved_constant_767*tmp_moved_constant_827;
             const real_t tmp_moved_constant_862 = tmp_moved_constant_770*tmp_moved_constant_824 + tmp_moved_constant_773*tmp_moved_constant_825 + tmp_moved_constant_776*tmp_moved_constant_826 + tmp_moved_constant_779*tmp_moved_constant_827;
             const real_t tmp_moved_constant_863 = tmp_moved_constant_782*tmp_moved_constant_824 + tmp_moved_constant_785*tmp_moved_constant_825 + tmp_moved_constant_788*tmp_moved_constant_826 + tmp_moved_constant_791*tmp_moved_constant_827;
             const real_t tmp_moved_constant_864 = tmp_moved_constant_794*tmp_moved_constant_824 + tmp_moved_constant_797*tmp_moved_constant_825 + tmp_moved_constant_800*tmp_moved_constant_826 + tmp_moved_constant_803*tmp_moved_constant_827;
             const real_t tmp_moved_constant_865 = tmp_moved_constant_804*tmp_moved_constant_824 + tmp_moved_constant_805*tmp_moved_constant_825 + tmp_moved_constant_806*tmp_moved_constant_826 + tmp_moved_constant_807*tmp_moved_constant_827;
             const real_t tmp_moved_constant_866 = tmp_moved_constant_808*tmp_moved_constant_824 + tmp_moved_constant_809*tmp_moved_constant_825 + tmp_moved_constant_810*tmp_moved_constant_826 + tmp_moved_constant_811*tmp_moved_constant_827;
             const real_t tmp_moved_constant_867 = tmp_moved_constant_812*tmp_moved_constant_824 + tmp_moved_constant_813*tmp_moved_constant_825 + tmp_moved_constant_814*tmp_moved_constant_826 + tmp_moved_constant_815*tmp_moved_constant_827;
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_828));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_829));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_830));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_831));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_832));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_833));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_834));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_835));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_836));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_837));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_838));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_839));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_840));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_841));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_842));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_843));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_844));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_845));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_846));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_847));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_848));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_849));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_850));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_851));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_852));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_853));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_854));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_855));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_856));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_857));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_858));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_859));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_860));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_861));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_862));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_863));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_864));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_865));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_866));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_867));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             const real_t tmp_moved_constant_868 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_4;
             const real_t tmp_moved_constant_869 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_870 = tmp_moved_constant_869*0.13819660112501053;
             const real_t tmp_moved_constant_871 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_12 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_12 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_12;
             const real_t tmp_moved_constant_872 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_873 = tmp_moved_constant_872*0.13819660112501056;
             const real_t tmp_moved_constant_874 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_20 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
             const real_t tmp_moved_constant_875 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_876 = tmp_moved_constant_875*0.13819660112501056;
             const real_t tmp_moved_constant_877 = -jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_28 - jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_28 - jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_28;
             const real_t tmp_moved_constant_878 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_879 = tmp_moved_constant_878*0.5854101966249684;
             const real_t tmp_moved_constant_880 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_881 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_882 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_17 - 1.0);
             const real_t tmp_moved_constant_883 = jac_affine_inv_0_0_GREEN_UP*(tmp_kernel_op_25 - 1.0);
             const real_t tmp_moved_constant_884 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_885 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_10 - 1.0);
             const real_t tmp_moved_constant_886 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_18 - 1.0);
             const real_t tmp_moved_constant_887 = jac_affine_inv_1_0_GREEN_UP*(tmp_kernel_op_26 - 1.0);
             const real_t tmp_moved_constant_888 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_889 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_890 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_891 = jac_affine_inv_2_0_GREEN_UP*(tmp_kernel_op_24 - 1.0);
             const real_t tmp_moved_constant_892 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_893 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_894 = -tmp_moved_constant_892 - tmp_moved_constant_893;
             const real_t tmp_moved_constant_895 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_896 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
             const real_t tmp_moved_constant_897 = -tmp_moved_constant_895 - tmp_moved_constant_896;
             const real_t tmp_moved_constant_898 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_899 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_18;
             const real_t tmp_moved_constant_900 = -tmp_moved_constant_898 - tmp_moved_constant_899;
             const real_t tmp_moved_constant_901 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_24;
             const real_t tmp_moved_constant_902 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
             const real_t tmp_moved_constant_903 = -tmp_moved_constant_901 - tmp_moved_constant_902;
             const real_t tmp_moved_constant_904 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_905 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_906 = -tmp_moved_constant_904 - tmp_moved_constant_905;
             const real_t tmp_moved_constant_907 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_908 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_909 = -tmp_moved_constant_907 - tmp_moved_constant_908;
             const real_t tmp_moved_constant_910 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_911 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_17;
             const real_t tmp_moved_constant_912 = -tmp_moved_constant_910 - tmp_moved_constant_911;
             const real_t tmp_moved_constant_913 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_24;
             const real_t tmp_moved_constant_914 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_25;
             const real_t tmp_moved_constant_915 = -tmp_moved_constant_913 - tmp_moved_constant_914;
             const real_t tmp_moved_constant_916 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_917 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_918 = -tmp_moved_constant_916 - tmp_moved_constant_917;
             const real_t tmp_moved_constant_919 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_10;
             const real_t tmp_moved_constant_920 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_921 = -tmp_moved_constant_919 - tmp_moved_constant_920;
             const real_t tmp_moved_constant_922 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_18;
             const real_t tmp_moved_constant_923 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_17;
             const real_t tmp_moved_constant_924 = -tmp_moved_constant_922 - tmp_moved_constant_923;
             const real_t tmp_moved_constant_925 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
             const real_t tmp_moved_constant_926 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_25;
             const real_t tmp_moved_constant_927 = -tmp_moved_constant_925 - tmp_moved_constant_926;
             const real_t tmp_moved_constant_928 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_892 + tmp_moved_constant_904;
             const real_t tmp_moved_constant_929 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_895 + tmp_moved_constant_907;
             const real_t tmp_moved_constant_930 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_898 + tmp_moved_constant_910;
             const real_t tmp_moved_constant_931 = -jac_affine_inv_2_0_GREEN_UP*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_901 + tmp_moved_constant_913;
             const real_t tmp_moved_constant_932 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_893 + tmp_moved_constant_916;
             const real_t tmp_moved_constant_933 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_896 + tmp_moved_constant_919;
             const real_t tmp_moved_constant_934 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_899 + tmp_moved_constant_922;
             const real_t tmp_moved_constant_935 = -jac_affine_inv_1_0_GREEN_UP*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_902 + tmp_moved_constant_925;
             const real_t tmp_moved_constant_936 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_905 + tmp_moved_constant_917;
             const real_t tmp_moved_constant_937 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_908 + tmp_moved_constant_920;
             const real_t tmp_moved_constant_938 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_911 + tmp_moved_constant_923;
             const real_t tmp_moved_constant_939 = -jac_affine_inv_0_0_GREEN_UP*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_914 + tmp_moved_constant_926;
             const real_t tmp_moved_constant_940 = tmp_moved_constant_869*0.1381966011250105;
             const real_t tmp_moved_constant_941 = tmp_moved_constant_872*0.1381966011250105;
             const real_t tmp_moved_constant_942 = tmp_moved_constant_875*0.5854101966249684;
             const real_t tmp_moved_constant_943 = tmp_moved_constant_878*0.1381966011250105;
             const real_t tmp_moved_constant_944 = tmp_moved_constant_869*0.1381966011250105;
             const real_t tmp_moved_constant_945 = tmp_moved_constant_872*0.5854101966249684;
             const real_t tmp_moved_constant_946 = tmp_moved_constant_875*0.1381966011250105;
             const real_t tmp_moved_constant_947 = tmp_moved_constant_878*0.1381966011250105;
             const real_t tmp_moved_constant_948 = tmp_moved_constant_869*0.5854101966249684;
             const real_t tmp_moved_constant_949 = tmp_moved_constant_872*0.1381966011250105;
             const real_t tmp_moved_constant_950 = tmp_moved_constant_875*0.1381966011250105;
             const real_t tmp_moved_constant_951 = tmp_moved_constant_878*0.1381966011250105;
             const real_t tmp_moved_constant_952 = tmp_moved_constant_868*tmp_moved_constant_870 + tmp_moved_constant_871*tmp_moved_constant_873 + tmp_moved_constant_874*tmp_moved_constant_876 + tmp_moved_constant_877*tmp_moved_constant_879;
             const real_t tmp_moved_constant_953 = -tmp_moved_constant_870*tmp_moved_constant_880 - tmp_moved_constant_873*tmp_moved_constant_881 - tmp_moved_constant_876*tmp_moved_constant_882 - tmp_moved_constant_879*tmp_moved_constant_883;
             const real_t tmp_moved_constant_954 = -tmp_moved_constant_870*tmp_moved_constant_884 - tmp_moved_constant_873*tmp_moved_constant_885 - tmp_moved_constant_876*tmp_moved_constant_886 - tmp_moved_constant_879*tmp_moved_constant_887;
             const real_t tmp_moved_constant_955 = -tmp_moved_constant_870*tmp_moved_constant_888 - tmp_moved_constant_873*tmp_moved_constant_889 - tmp_moved_constant_876*tmp_moved_constant_890 - tmp_moved_constant_879*tmp_moved_constant_891;
             const real_t tmp_moved_constant_956 = tmp_moved_constant_870*tmp_moved_constant_894 + tmp_moved_constant_873*tmp_moved_constant_897 + tmp_moved_constant_876*tmp_moved_constant_900 + tmp_moved_constant_879*tmp_moved_constant_903;
             const real_t tmp_moved_constant_957 = tmp_moved_constant_870*tmp_moved_constant_906 + tmp_moved_constant_873*tmp_moved_constant_909 + tmp_moved_constant_876*tmp_moved_constant_912 + tmp_moved_constant_879*tmp_moved_constant_915;
             const real_t tmp_moved_constant_958 = tmp_moved_constant_870*tmp_moved_constant_918 + tmp_moved_constant_873*tmp_moved_constant_921 + tmp_moved_constant_876*tmp_moved_constant_924 + tmp_moved_constant_879*tmp_moved_constant_927;
             const real_t tmp_moved_constant_959 = tmp_moved_constant_870*tmp_moved_constant_928 + tmp_moved_constant_873*tmp_moved_constant_929 + tmp_moved_constant_876*tmp_moved_constant_930 + tmp_moved_constant_879*tmp_moved_constant_931;
             const real_t tmp_moved_constant_960 = tmp_moved_constant_870*tmp_moved_constant_932 + tmp_moved_constant_873*tmp_moved_constant_933 + tmp_moved_constant_876*tmp_moved_constant_934 + tmp_moved_constant_879*tmp_moved_constant_935;
             const real_t tmp_moved_constant_961 = tmp_moved_constant_870*tmp_moved_constant_936 + tmp_moved_constant_873*tmp_moved_constant_937 + tmp_moved_constant_876*tmp_moved_constant_938 + tmp_moved_constant_879*tmp_moved_constant_939;
             const real_t tmp_moved_constant_962 = tmp_moved_constant_868*tmp_moved_constant_940 + tmp_moved_constant_871*tmp_moved_constant_941 + tmp_moved_constant_874*tmp_moved_constant_942 + tmp_moved_constant_877*tmp_moved_constant_943;
             const real_t tmp_moved_constant_963 = -tmp_moved_constant_880*tmp_moved_constant_940 - tmp_moved_constant_881*tmp_moved_constant_941 - tmp_moved_constant_882*tmp_moved_constant_942 - tmp_moved_constant_883*tmp_moved_constant_943;
             const real_t tmp_moved_constant_964 = -tmp_moved_constant_884*tmp_moved_constant_940 - tmp_moved_constant_885*tmp_moved_constant_941 - tmp_moved_constant_886*tmp_moved_constant_942 - tmp_moved_constant_887*tmp_moved_constant_943;
             const real_t tmp_moved_constant_965 = -tmp_moved_constant_888*tmp_moved_constant_940 - tmp_moved_constant_889*tmp_moved_constant_941 - tmp_moved_constant_890*tmp_moved_constant_942 - tmp_moved_constant_891*tmp_moved_constant_943;
             const real_t tmp_moved_constant_966 = tmp_moved_constant_894*tmp_moved_constant_940 + tmp_moved_constant_897*tmp_moved_constant_941 + tmp_moved_constant_900*tmp_moved_constant_942 + tmp_moved_constant_903*tmp_moved_constant_943;
             const real_t tmp_moved_constant_967 = tmp_moved_constant_906*tmp_moved_constant_940 + tmp_moved_constant_909*tmp_moved_constant_941 + tmp_moved_constant_912*tmp_moved_constant_942 + tmp_moved_constant_915*tmp_moved_constant_943;
             const real_t tmp_moved_constant_968 = tmp_moved_constant_918*tmp_moved_constant_940 + tmp_moved_constant_921*tmp_moved_constant_941 + tmp_moved_constant_924*tmp_moved_constant_942 + tmp_moved_constant_927*tmp_moved_constant_943;
             const real_t tmp_moved_constant_969 = tmp_moved_constant_928*tmp_moved_constant_940 + tmp_moved_constant_929*tmp_moved_constant_941 + tmp_moved_constant_930*tmp_moved_constant_942 + tmp_moved_constant_931*tmp_moved_constant_943;
             const real_t tmp_moved_constant_970 = tmp_moved_constant_932*tmp_moved_constant_940 + tmp_moved_constant_933*tmp_moved_constant_941 + tmp_moved_constant_934*tmp_moved_constant_942 + tmp_moved_constant_935*tmp_moved_constant_943;
             const real_t tmp_moved_constant_971 = tmp_moved_constant_936*tmp_moved_constant_940 + tmp_moved_constant_937*tmp_moved_constant_941 + tmp_moved_constant_938*tmp_moved_constant_942 + tmp_moved_constant_939*tmp_moved_constant_943;
             const real_t tmp_moved_constant_972 = tmp_moved_constant_868*tmp_moved_constant_944 + tmp_moved_constant_871*tmp_moved_constant_945 + tmp_moved_constant_874*tmp_moved_constant_946 + tmp_moved_constant_877*tmp_moved_constant_947;
             const real_t tmp_moved_constant_973 = -tmp_moved_constant_880*tmp_moved_constant_944 - tmp_moved_constant_881*tmp_moved_constant_945 - tmp_moved_constant_882*tmp_moved_constant_946 - tmp_moved_constant_883*tmp_moved_constant_947;
             const real_t tmp_moved_constant_974 = -tmp_moved_constant_884*tmp_moved_constant_944 - tmp_moved_constant_885*tmp_moved_constant_945 - tmp_moved_constant_886*tmp_moved_constant_946 - tmp_moved_constant_887*tmp_moved_constant_947;
             const real_t tmp_moved_constant_975 = -tmp_moved_constant_888*tmp_moved_constant_944 - tmp_moved_constant_889*tmp_moved_constant_945 - tmp_moved_constant_890*tmp_moved_constant_946 - tmp_moved_constant_891*tmp_moved_constant_947;
             const real_t tmp_moved_constant_976 = tmp_moved_constant_894*tmp_moved_constant_944 + tmp_moved_constant_897*tmp_moved_constant_945 + tmp_moved_constant_900*tmp_moved_constant_946 + tmp_moved_constant_903*tmp_moved_constant_947;
             const real_t tmp_moved_constant_977 = tmp_moved_constant_906*tmp_moved_constant_944 + tmp_moved_constant_909*tmp_moved_constant_945 + tmp_moved_constant_912*tmp_moved_constant_946 + tmp_moved_constant_915*tmp_moved_constant_947;
             const real_t tmp_moved_constant_978 = tmp_moved_constant_918*tmp_moved_constant_944 + tmp_moved_constant_921*tmp_moved_constant_945 + tmp_moved_constant_924*tmp_moved_constant_946 + tmp_moved_constant_927*tmp_moved_constant_947;
             const real_t tmp_moved_constant_979 = tmp_moved_constant_928*tmp_moved_constant_944 + tmp_moved_constant_929*tmp_moved_constant_945 + tmp_moved_constant_930*tmp_moved_constant_946 + tmp_moved_constant_931*tmp_moved_constant_947;
             const real_t tmp_moved_constant_980 = tmp_moved_constant_932*tmp_moved_constant_944 + tmp_moved_constant_933*tmp_moved_constant_945 + tmp_moved_constant_934*tmp_moved_constant_946 + tmp_moved_constant_935*tmp_moved_constant_947;
             const real_t tmp_moved_constant_981 = tmp_moved_constant_936*tmp_moved_constant_944 + tmp_moved_constant_937*tmp_moved_constant_945 + tmp_moved_constant_938*tmp_moved_constant_946 + tmp_moved_constant_939*tmp_moved_constant_947;
             const real_t tmp_moved_constant_982 = tmp_moved_constant_868*tmp_moved_constant_948 + tmp_moved_constant_871*tmp_moved_constant_949 + tmp_moved_constant_874*tmp_moved_constant_950 + tmp_moved_constant_877*tmp_moved_constant_951;
             const real_t tmp_moved_constant_983 = -tmp_moved_constant_880*tmp_moved_constant_948 - tmp_moved_constant_881*tmp_moved_constant_949 - tmp_moved_constant_882*tmp_moved_constant_950 - tmp_moved_constant_883*tmp_moved_constant_951;
             const real_t tmp_moved_constant_984 = -tmp_moved_constant_884*tmp_moved_constant_948 - tmp_moved_constant_885*tmp_moved_constant_949 - tmp_moved_constant_886*tmp_moved_constant_950 - tmp_moved_constant_887*tmp_moved_constant_951;
             const real_t tmp_moved_constant_985 = -tmp_moved_constant_888*tmp_moved_constant_948 - tmp_moved_constant_889*tmp_moved_constant_949 - tmp_moved_constant_890*tmp_moved_constant_950 - tmp_moved_constant_891*tmp_moved_constant_951;
             const real_t tmp_moved_constant_986 = tmp_moved_constant_894*tmp_moved_constant_948 + tmp_moved_constant_897*tmp_moved_constant_949 + tmp_moved_constant_900*tmp_moved_constant_950 + tmp_moved_constant_903*tmp_moved_constant_951;
             const real_t tmp_moved_constant_987 = tmp_moved_constant_906*tmp_moved_constant_948 + tmp_moved_constant_909*tmp_moved_constant_949 + tmp_moved_constant_912*tmp_moved_constant_950 + tmp_moved_constant_915*tmp_moved_constant_951;
             const real_t tmp_moved_constant_988 = tmp_moved_constant_918*tmp_moved_constant_948 + tmp_moved_constant_921*tmp_moved_constant_949 + tmp_moved_constant_924*tmp_moved_constant_950 + tmp_moved_constant_927*tmp_moved_constant_951;
             const real_t tmp_moved_constant_989 = tmp_moved_constant_928*tmp_moved_constant_948 + tmp_moved_constant_929*tmp_moved_constant_949 + tmp_moved_constant_930*tmp_moved_constant_950 + tmp_moved_constant_931*tmp_moved_constant_951;
             const real_t tmp_moved_constant_990 = tmp_moved_constant_932*tmp_moved_constant_948 + tmp_moved_constant_933*tmp_moved_constant_949 + tmp_moved_constant_934*tmp_moved_constant_950 + tmp_moved_constant_935*tmp_moved_constant_951;
             const real_t tmp_moved_constant_991 = tmp_moved_constant_936*tmp_moved_constant_948 + tmp_moved_constant_937*tmp_moved_constant_949 + tmp_moved_constant_938*tmp_moved_constant_950 + tmp_moved_constant_939*tmp_moved_constant_951;
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_952));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_953));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_954));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_955));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_956));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_957));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_958));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_959));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_960));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_961));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_962));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_963));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_964));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_965));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_966));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_967));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_968));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_969));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_970));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_971));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_972));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_973));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_974));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_975));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_976));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_977));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_978));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_979));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_980));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_981));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_982));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_983));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_984));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_985));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_986));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_987));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_988));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_989));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_990));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_991));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
             const real_t tmp_moved_constant_992 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_4;
             const real_t tmp_moved_constant_993 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_994 = tmp_moved_constant_993*0.13819660112501053;
             const real_t tmp_moved_constant_995 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_12 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_12 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_12;
             const real_t tmp_moved_constant_996 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_997 = tmp_moved_constant_996*0.13819660112501056;
             const real_t tmp_moved_constant_998 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_20 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
             const real_t tmp_moved_constant_999 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_1000 = tmp_moved_constant_999*0.13819660112501056;
             const real_t tmp_moved_constant_1001 = -jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_28 - jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_28 - jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_28;
             const real_t tmp_moved_constant_1002 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_1003 = tmp_moved_constant_1002*0.5854101966249684;
             const real_t tmp_moved_constant_1004 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_1005 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_1006 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_17 - 1.0);
             const real_t tmp_moved_constant_1007 = jac_affine_inv_0_0_GREEN_DOWN*(tmp_kernel_op_25 - 1.0);
             const real_t tmp_moved_constant_1008 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_1009 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_10 - 1.0);
             const real_t tmp_moved_constant_1010 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_18 - 1.0);
             const real_t tmp_moved_constant_1011 = jac_affine_inv_1_0_GREEN_DOWN*(tmp_kernel_op_26 - 1.0);
             const real_t tmp_moved_constant_1012 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_1013 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_1014 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_1015 = jac_affine_inv_2_0_GREEN_DOWN*(tmp_kernel_op_24 - 1.0);
             const real_t tmp_moved_constant_1016 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_1017 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_1018 = -tmp_moved_constant_1016 - tmp_moved_constant_1017;
             const real_t tmp_moved_constant_1019 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_1020 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
             const real_t tmp_moved_constant_1021 = -tmp_moved_constant_1019 - tmp_moved_constant_1020;
             const real_t tmp_moved_constant_1022 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_1023 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_18;
             const real_t tmp_moved_constant_1024 = -tmp_moved_constant_1022 - tmp_moved_constant_1023;
             const real_t tmp_moved_constant_1025 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_24;
             const real_t tmp_moved_constant_1026 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
             const real_t tmp_moved_constant_1027 = -tmp_moved_constant_1025 - tmp_moved_constant_1026;
             const real_t tmp_moved_constant_1028 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_1029 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_1030 = -tmp_moved_constant_1028 - tmp_moved_constant_1029;
             const real_t tmp_moved_constant_1031 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_1032 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_1033 = -tmp_moved_constant_1031 - tmp_moved_constant_1032;
             const real_t tmp_moved_constant_1034 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_1035 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_17;
             const real_t tmp_moved_constant_1036 = -tmp_moved_constant_1034 - tmp_moved_constant_1035;
             const real_t tmp_moved_constant_1037 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_24;
             const real_t tmp_moved_constant_1038 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_25;
             const real_t tmp_moved_constant_1039 = -tmp_moved_constant_1037 - tmp_moved_constant_1038;
             const real_t tmp_moved_constant_1040 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_1041 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_1042 = -tmp_moved_constant_1040 - tmp_moved_constant_1041;
             const real_t tmp_moved_constant_1043 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_10;
             const real_t tmp_moved_constant_1044 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_1045 = -tmp_moved_constant_1043 - tmp_moved_constant_1044;
             const real_t tmp_moved_constant_1046 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_18;
             const real_t tmp_moved_constant_1047 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_17;
             const real_t tmp_moved_constant_1048 = -tmp_moved_constant_1046 - tmp_moved_constant_1047;
             const real_t tmp_moved_constant_1049 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
             const real_t tmp_moved_constant_1050 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_25;
             const real_t tmp_moved_constant_1051 = -tmp_moved_constant_1049 - tmp_moved_constant_1050;
             const real_t tmp_moved_constant_1052 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_1016 + tmp_moved_constant_1028;
             const real_t tmp_moved_constant_1053 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_11 + 2.8944271909999157) + tmp_moved_constant_1019 + tmp_moved_constant_1031;
             const real_t tmp_moved_constant_1054 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_19 + 2.8944271909999157) + tmp_moved_constant_1022 + tmp_moved_constant_1034;
             const real_t tmp_moved_constant_1055 = -jac_affine_inv_2_0_GREEN_DOWN*(-tmp_kernel_op_27 + 2.8944271909999157) + tmp_moved_constant_1025 + tmp_moved_constant_1037;
             const real_t tmp_moved_constant_1056 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_1017 + tmp_moved_constant_1040;
             const real_t tmp_moved_constant_1057 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_86 - tmp_kernel_op_9 - 4.6832815729997472) + tmp_moved_constant_1020 + tmp_moved_constant_1043;
             const real_t tmp_moved_constant_1058 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_17 - tmp_kernel_op_88 - 1.105572809000084) + tmp_moved_constant_1023 + tmp_moved_constant_1046;
             const real_t tmp_moved_constant_1059 = -jac_affine_inv_1_0_GREEN_DOWN*(-tmp_kernel_op_25 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_1026 + tmp_moved_constant_1049;
             const real_t tmp_moved_constant_1060 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_2 - tmp_kernel_op_84 - 1.105572809000084) + tmp_moved_constant_1029 + tmp_moved_constant_1041;
             const real_t tmp_moved_constant_1061 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_10 - tmp_kernel_op_86 - 1.105572809000084) + tmp_moved_constant_1032 + tmp_moved_constant_1044;
             const real_t tmp_moved_constant_1062 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_18 - tmp_kernel_op_88 - 4.6832815729997472) + tmp_moved_constant_1035 + tmp_moved_constant_1047;
             const real_t tmp_moved_constant_1063 = -jac_affine_inv_0_0_GREEN_DOWN*(-tmp_kernel_op_26 - tmp_kernel_op_90 - 1.105572809000084) + tmp_moved_constant_1038 + tmp_moved_constant_1050;
             const real_t tmp_moved_constant_1064 = tmp_moved_constant_993*0.1381966011250105;
             const real_t tmp_moved_constant_1065 = tmp_moved_constant_996*0.1381966011250105;
             const real_t tmp_moved_constant_1066 = tmp_moved_constant_999*0.5854101966249684;
             const real_t tmp_moved_constant_1067 = tmp_moved_constant_1002*0.1381966011250105;
             const real_t tmp_moved_constant_1068 = tmp_moved_constant_993*0.1381966011250105;
             const real_t tmp_moved_constant_1069 = tmp_moved_constant_996*0.5854101966249684;
             const real_t tmp_moved_constant_1070 = tmp_moved_constant_999*0.1381966011250105;
             const real_t tmp_moved_constant_1071 = tmp_moved_constant_1002*0.1381966011250105;
             const real_t tmp_moved_constant_1072 = tmp_moved_constant_993*0.5854101966249684;
             const real_t tmp_moved_constant_1073 = tmp_moved_constant_996*0.1381966011250105;
             const real_t tmp_moved_constant_1074 = tmp_moved_constant_999*0.1381966011250105;
             const real_t tmp_moved_constant_1075 = tmp_moved_constant_1002*0.1381966011250105;
             const real_t tmp_moved_constant_1076 = tmp_moved_constant_1000*tmp_moved_constant_998 + tmp_moved_constant_1001*tmp_moved_constant_1003 + tmp_moved_constant_992*tmp_moved_constant_994 + tmp_moved_constant_995*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1077 = -tmp_moved_constant_1000*tmp_moved_constant_1006 - tmp_moved_constant_1003*tmp_moved_constant_1007 - tmp_moved_constant_1004*tmp_moved_constant_994 - tmp_moved_constant_1005*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1078 = -tmp_moved_constant_1000*tmp_moved_constant_1010 - tmp_moved_constant_1003*tmp_moved_constant_1011 - tmp_moved_constant_1008*tmp_moved_constant_994 - tmp_moved_constant_1009*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1079 = -tmp_moved_constant_1000*tmp_moved_constant_1014 - tmp_moved_constant_1003*tmp_moved_constant_1015 - tmp_moved_constant_1012*tmp_moved_constant_994 - tmp_moved_constant_1013*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1080 = tmp_moved_constant_1000*tmp_moved_constant_1024 + tmp_moved_constant_1003*tmp_moved_constant_1027 + tmp_moved_constant_1018*tmp_moved_constant_994 + tmp_moved_constant_1021*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1081 = tmp_moved_constant_1000*tmp_moved_constant_1036 + tmp_moved_constant_1003*tmp_moved_constant_1039 + tmp_moved_constant_1030*tmp_moved_constant_994 + tmp_moved_constant_1033*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1082 = tmp_moved_constant_1000*tmp_moved_constant_1048 + tmp_moved_constant_1003*tmp_moved_constant_1051 + tmp_moved_constant_1042*tmp_moved_constant_994 + tmp_moved_constant_1045*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1083 = tmp_moved_constant_1000*tmp_moved_constant_1054 + tmp_moved_constant_1003*tmp_moved_constant_1055 + tmp_moved_constant_1052*tmp_moved_constant_994 + tmp_moved_constant_1053*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1084 = tmp_moved_constant_1000*tmp_moved_constant_1058 + tmp_moved_constant_1003*tmp_moved_constant_1059 + tmp_moved_constant_1056*tmp_moved_constant_994 + tmp_moved_constant_1057*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1085 = tmp_moved_constant_1000*tmp_moved_constant_1062 + tmp_moved_constant_1003*tmp_moved_constant_1063 + tmp_moved_constant_1060*tmp_moved_constant_994 + tmp_moved_constant_1061*tmp_moved_constant_997;
             const real_t tmp_moved_constant_1086 = tmp_moved_constant_1001*tmp_moved_constant_1067 + tmp_moved_constant_1064*tmp_moved_constant_992 + tmp_moved_constant_1065*tmp_moved_constant_995 + tmp_moved_constant_1066*tmp_moved_constant_998;
             const real_t tmp_moved_constant_1087 = -tmp_moved_constant_1004*tmp_moved_constant_1064 - tmp_moved_constant_1005*tmp_moved_constant_1065 - tmp_moved_constant_1006*tmp_moved_constant_1066 - tmp_moved_constant_1007*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1088 = -tmp_moved_constant_1008*tmp_moved_constant_1064 - tmp_moved_constant_1009*tmp_moved_constant_1065 - tmp_moved_constant_1010*tmp_moved_constant_1066 - tmp_moved_constant_1011*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1089 = -tmp_moved_constant_1012*tmp_moved_constant_1064 - tmp_moved_constant_1013*tmp_moved_constant_1065 - tmp_moved_constant_1014*tmp_moved_constant_1066 - tmp_moved_constant_1015*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1090 = tmp_moved_constant_1018*tmp_moved_constant_1064 + tmp_moved_constant_1021*tmp_moved_constant_1065 + tmp_moved_constant_1024*tmp_moved_constant_1066 + tmp_moved_constant_1027*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1091 = tmp_moved_constant_1030*tmp_moved_constant_1064 + tmp_moved_constant_1033*tmp_moved_constant_1065 + tmp_moved_constant_1036*tmp_moved_constant_1066 + tmp_moved_constant_1039*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1092 = tmp_moved_constant_1042*tmp_moved_constant_1064 + tmp_moved_constant_1045*tmp_moved_constant_1065 + tmp_moved_constant_1048*tmp_moved_constant_1066 + tmp_moved_constant_1051*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1093 = tmp_moved_constant_1052*tmp_moved_constant_1064 + tmp_moved_constant_1053*tmp_moved_constant_1065 + tmp_moved_constant_1054*tmp_moved_constant_1066 + tmp_moved_constant_1055*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1094 = tmp_moved_constant_1056*tmp_moved_constant_1064 + tmp_moved_constant_1057*tmp_moved_constant_1065 + tmp_moved_constant_1058*tmp_moved_constant_1066 + tmp_moved_constant_1059*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1095 = tmp_moved_constant_1060*tmp_moved_constant_1064 + tmp_moved_constant_1061*tmp_moved_constant_1065 + tmp_moved_constant_1062*tmp_moved_constant_1066 + tmp_moved_constant_1063*tmp_moved_constant_1067;
             const real_t tmp_moved_constant_1096 = tmp_moved_constant_1001*tmp_moved_constant_1071 + tmp_moved_constant_1068*tmp_moved_constant_992 + tmp_moved_constant_1069*tmp_moved_constant_995 + tmp_moved_constant_1070*tmp_moved_constant_998;
             const real_t tmp_moved_constant_1097 = -tmp_moved_constant_1004*tmp_moved_constant_1068 - tmp_moved_constant_1005*tmp_moved_constant_1069 - tmp_moved_constant_1006*tmp_moved_constant_1070 - tmp_moved_constant_1007*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1098 = -tmp_moved_constant_1008*tmp_moved_constant_1068 - tmp_moved_constant_1009*tmp_moved_constant_1069 - tmp_moved_constant_1010*tmp_moved_constant_1070 - tmp_moved_constant_1011*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1099 = -tmp_moved_constant_1012*tmp_moved_constant_1068 - tmp_moved_constant_1013*tmp_moved_constant_1069 - tmp_moved_constant_1014*tmp_moved_constant_1070 - tmp_moved_constant_1015*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1100 = tmp_moved_constant_1018*tmp_moved_constant_1068 + tmp_moved_constant_1021*tmp_moved_constant_1069 + tmp_moved_constant_1024*tmp_moved_constant_1070 + tmp_moved_constant_1027*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1101 = tmp_moved_constant_1030*tmp_moved_constant_1068 + tmp_moved_constant_1033*tmp_moved_constant_1069 + tmp_moved_constant_1036*tmp_moved_constant_1070 + tmp_moved_constant_1039*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1102 = tmp_moved_constant_1042*tmp_moved_constant_1068 + tmp_moved_constant_1045*tmp_moved_constant_1069 + tmp_moved_constant_1048*tmp_moved_constant_1070 + tmp_moved_constant_1051*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1103 = tmp_moved_constant_1052*tmp_moved_constant_1068 + tmp_moved_constant_1053*tmp_moved_constant_1069 + tmp_moved_constant_1054*tmp_moved_constant_1070 + tmp_moved_constant_1055*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1104 = tmp_moved_constant_1056*tmp_moved_constant_1068 + tmp_moved_constant_1057*tmp_moved_constant_1069 + tmp_moved_constant_1058*tmp_moved_constant_1070 + tmp_moved_constant_1059*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1105 = tmp_moved_constant_1060*tmp_moved_constant_1068 + tmp_moved_constant_1061*tmp_moved_constant_1069 + tmp_moved_constant_1062*tmp_moved_constant_1070 + tmp_moved_constant_1063*tmp_moved_constant_1071;
             const real_t tmp_moved_constant_1106 = tmp_moved_constant_1001*tmp_moved_constant_1075 + tmp_moved_constant_1072*tmp_moved_constant_992 + tmp_moved_constant_1073*tmp_moved_constant_995 + tmp_moved_constant_1074*tmp_moved_constant_998;
             const real_t tmp_moved_constant_1107 = -tmp_moved_constant_1004*tmp_moved_constant_1072 - tmp_moved_constant_1005*tmp_moved_constant_1073 - tmp_moved_constant_1006*tmp_moved_constant_1074 - tmp_moved_constant_1007*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1108 = -tmp_moved_constant_1008*tmp_moved_constant_1072 - tmp_moved_constant_1009*tmp_moved_constant_1073 - tmp_moved_constant_1010*tmp_moved_constant_1074 - tmp_moved_constant_1011*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1109 = -tmp_moved_constant_1012*tmp_moved_constant_1072 - tmp_moved_constant_1013*tmp_moved_constant_1073 - tmp_moved_constant_1014*tmp_moved_constant_1074 - tmp_moved_constant_1015*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1110 = tmp_moved_constant_1018*tmp_moved_constant_1072 + tmp_moved_constant_1021*tmp_moved_constant_1073 + tmp_moved_constant_1024*tmp_moved_constant_1074 + tmp_moved_constant_1027*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1111 = tmp_moved_constant_1030*tmp_moved_constant_1072 + tmp_moved_constant_1033*tmp_moved_constant_1073 + tmp_moved_constant_1036*tmp_moved_constant_1074 + tmp_moved_constant_1039*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1112 = tmp_moved_constant_1042*tmp_moved_constant_1072 + tmp_moved_constant_1045*tmp_moved_constant_1073 + tmp_moved_constant_1048*tmp_moved_constant_1074 + tmp_moved_constant_1051*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1113 = tmp_moved_constant_1052*tmp_moved_constant_1072 + tmp_moved_constant_1053*tmp_moved_constant_1073 + tmp_moved_constant_1054*tmp_moved_constant_1074 + tmp_moved_constant_1055*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1114 = tmp_moved_constant_1056*tmp_moved_constant_1072 + tmp_moved_constant_1057*tmp_moved_constant_1073 + tmp_moved_constant_1058*tmp_moved_constant_1074 + tmp_moved_constant_1059*tmp_moved_constant_1075;
             const real_t tmp_moved_constant_1115 = tmp_moved_constant_1060*tmp_moved_constant_1072 + tmp_moved_constant_1061*tmp_moved_constant_1073 + tmp_moved_constant_1062*tmp_moved_constant_1074 + tmp_moved_constant_1063*tmp_moved_constant_1075;
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(tmp_moved_constant_1076));
                   _data_mat[1] = ((real_t)(tmp_moved_constant_1077));
                   _data_mat[2] = ((real_t)(tmp_moved_constant_1078));
                   _data_mat[3] = ((real_t)(tmp_moved_constant_1079));
                   _data_mat[4] = ((real_t)(tmp_moved_constant_1080));
                   _data_mat[5] = ((real_t)(tmp_moved_constant_1081));
                   _data_mat[6] = ((real_t)(tmp_moved_constant_1082));
                   _data_mat[7] = ((real_t)(tmp_moved_constant_1083));
                   _data_mat[8] = ((real_t)(tmp_moved_constant_1084));
                   _data_mat[9] = ((real_t)(tmp_moved_constant_1085));
                   _data_mat[10] = ((real_t)(tmp_moved_constant_1086));
                   _data_mat[11] = ((real_t)(tmp_moved_constant_1087));
                   _data_mat[12] = ((real_t)(tmp_moved_constant_1088));
                   _data_mat[13] = ((real_t)(tmp_moved_constant_1089));
                   _data_mat[14] = ((real_t)(tmp_moved_constant_1090));
                   _data_mat[15] = ((real_t)(tmp_moved_constant_1091));
                   _data_mat[16] = ((real_t)(tmp_moved_constant_1092));
                   _data_mat[17] = ((real_t)(tmp_moved_constant_1093));
                   _data_mat[18] = ((real_t)(tmp_moved_constant_1094));
                   _data_mat[19] = ((real_t)(tmp_moved_constant_1095));
                   _data_mat[20] = ((real_t)(tmp_moved_constant_1096));
                   _data_mat[21] = ((real_t)(tmp_moved_constant_1097));
                   _data_mat[22] = ((real_t)(tmp_moved_constant_1098));
                   _data_mat[23] = ((real_t)(tmp_moved_constant_1099));
                   _data_mat[24] = ((real_t)(tmp_moved_constant_1100));
                   _data_mat[25] = ((real_t)(tmp_moved_constant_1101));
                   _data_mat[26] = ((real_t)(tmp_moved_constant_1102));
                   _data_mat[27] = ((real_t)(tmp_moved_constant_1103));
                   _data_mat[28] = ((real_t)(tmp_moved_constant_1104));
                   _data_mat[29] = ((real_t)(tmp_moved_constant_1105));
                   _data_mat[30] = ((real_t)(tmp_moved_constant_1106));
                   _data_mat[31] = ((real_t)(tmp_moved_constant_1107));
                   _data_mat[32] = ((real_t)(tmp_moved_constant_1108));
                   _data_mat[33] = ((real_t)(tmp_moved_constant_1109));
                   _data_mat[34] = ((real_t)(tmp_moved_constant_1110));
                   _data_mat[35] = ((real_t)(tmp_moved_constant_1111));
                   _data_mat[36] = ((real_t)(tmp_moved_constant_1112));
                   _data_mat[37] = ((real_t)(tmp_moved_constant_1113));
                   _data_mat[38] = ((real_t)(tmp_moved_constant_1114));
                   _data_mat[39] = ((real_t)(tmp_moved_constant_1115));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
          } 
          {
             {
                {
               
                   std::vector< uint_t > _data_rowIdx( 4 );
                   std::vector< uint_t > _data_colIdx( 10 );
                   std::vector< real_t > _data_mat( 40 );
               
                   _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_rowIdx[2] = ((uint64_t)(_data_dst[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
                   _data_colIdx[2] = ((uint64_t)(_data_srcVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1]));
                   _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
                   _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1]));
               
                   /* Apply basis transformation */
               
               
               
                   _data_mat[0] = ((real_t)(elMat_0_0));
                   _data_mat[1] = ((real_t)(elMat_0_1));
                   _data_mat[2] = ((real_t)(elMat_0_2));
                   _data_mat[3] = ((real_t)(elMat_0_3));
                   _data_mat[4] = ((real_t)(elMat_0_4));
                   _data_mat[5] = ((real_t)(elMat_0_5));
                   _data_mat[6] = ((real_t)(elMat_0_6));
                   _data_mat[7] = ((real_t)(elMat_0_7));
                   _data_mat[8] = ((real_t)(elMat_0_8));
                   _data_mat[9] = ((real_t)(elMat_0_9));
                   _data_mat[10] = ((real_t)(elMat_1_0));
                   _data_mat[11] = ((real_t)(elMat_1_1));
                   _data_mat[12] = ((real_t)(elMat_1_2));
                   _data_mat[13] = ((real_t)(elMat_1_3));
                   _data_mat[14] = ((real_t)(elMat_1_4));
                   _data_mat[15] = ((real_t)(elMat_1_5));
                   _data_mat[16] = ((real_t)(elMat_1_6));
                   _data_mat[17] = ((real_t)(elMat_1_7));
                   _data_mat[18] = ((real_t)(elMat_1_8));
                   _data_mat[19] = ((real_t)(elMat_1_9));
                   _data_mat[20] = ((real_t)(elMat_2_0));
                   _data_mat[21] = ((real_t)(elMat_2_1));
                   _data_mat[22] = ((real_t)(elMat_2_2));
                   _data_mat[23] = ((real_t)(elMat_2_3));
                   _data_mat[24] = ((real_t)(elMat_2_4));
                   _data_mat[25] = ((real_t)(elMat_2_5));
                   _data_mat[26] = ((real_t)(elMat_2_6));
                   _data_mat[27] = ((real_t)(elMat_2_7));
                   _data_mat[28] = ((real_t)(elMat_2_8));
                   _data_mat[29] = ((real_t)(elMat_2_9));
                   _data_mat[30] = ((real_t)(elMat_3_0));
                   _data_mat[31] = ((real_t)(elMat_3_1));
                   _data_mat[32] = ((real_t)(elMat_3_2));
                   _data_mat[33] = ((real_t)(elMat_3_3));
                   _data_mat[34] = ((real_t)(elMat_3_4));
                   _data_mat[35] = ((real_t)(elMat_3_5));
                   _data_mat[36] = ((real_t)(elMat_3_6));
                   _data_mat[37] = ((real_t)(elMat_3_7));
                   _data_mat[38] = ((real_t)(elMat_3_8));
                   _data_mat[39] = ((real_t)(elMat_3_9));
               
               
                   mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
