/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2VectorToP1ElementwiseDivergenceRotationIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorToP1ElementwiseDivergenceRotationIcosahedralShellMap::apply_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_nxEdge, real_t * RESTRICT  _data_nxVertex, real_t * RESTRICT  _data_nyEdge, real_t * RESTRICT  _data_nyVertex, real_t * RESTRICT  _data_nzEdge, real_t * RESTRICT  _data_nzVertex, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_edge_2, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t * RESTRICT  _data_src_vertex_2, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       {
          /* CellType.WHITE_UP */
          const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
          const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
          const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
          const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
          const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
          const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
          const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
          const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
          const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
          const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
          const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
          const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
          const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
          const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
          const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
          const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
          const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
          const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
          const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
          const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
          const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
          const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
          const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
          const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
          const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_128 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_126 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_128 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_126 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_128 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_126 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_WHITE_UP*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_158 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_162 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_158 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_162 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_158 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_162 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_180 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_179 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_180 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_179 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_180 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_179 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
       {
          /* CellType.WHITE_DOWN */
          const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
          const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
          const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
          const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
          const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
          const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
          const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
          const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
          const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
          const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
          const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
          const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
          const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
          const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
          const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
          const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
          const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
          const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
          const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
          const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
          const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
          const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
          const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
          const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
          const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
          const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
          const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
          const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
          const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
          const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
          const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
          const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
          const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_128 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_126 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_128 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_126 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_128 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_126 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_WHITE_DOWN*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_158 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_158 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_158 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_180 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_179 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_180 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_179 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_180 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_179 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       {
          /* CellType.BLUE_UP */
          const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
          const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
          const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
          const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
          const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
          const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
          const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
          const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
          const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
          const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
          const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
          const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
          const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
          const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
          const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
          const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
          const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
          const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
          const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
          const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
          const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
          const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
          const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
          const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
          const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
          const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
          const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
          const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
          const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
          const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
          const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
          const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
          const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
          const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_128 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_126 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_128 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_126 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_128 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_126 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_BLUE_UP*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_158 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_162 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_158 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_162 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_158 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_162 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_180 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_179 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_180 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_179 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_180 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_179 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       {
          /* CellType.BLUE_DOWN */
          const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
          const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
          const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
          const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
          const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
          const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
          const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
          const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
          const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
          const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
          const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
          const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
          const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
          const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
          const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
          const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
          const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
          const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
          const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
          const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
          const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
          const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
          const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
          const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
          const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
          const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
          const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
          const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
          const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
          const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
          const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
          const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
          const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_128 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_126 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_128 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_126 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_128 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_126 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_BLUE_DOWN*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_158 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_158 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_158 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_180 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_179 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_180 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_179 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_180 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_179 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
       {
          /* CellType.GREEN_UP */
          const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
          const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
          const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
          const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
          const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
          const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
          const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
          const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
          const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
          const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
          const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
          const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
          const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
          const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
          const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
          const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
          const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
          const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
          const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
          const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
          const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
          const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
          const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
          const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
          const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
          const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
          const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
          const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
          const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
          const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
          const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_128 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_126 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_128 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_126 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_128 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_126 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_GREEN_UP*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_158 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_162 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_158 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_162 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_158 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_162 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_180 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_179 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_180 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_179 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_180 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_179 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       {
          /* CellType.GREEN_DOWN */
          const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
          const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
          const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
          const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
          const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
          const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
          const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
          const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
          const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
          const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
          const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
          const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
          const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
          const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
          const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
          const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
          const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
          const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
          const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
          const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
          const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
          const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
          const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
          const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
          const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
          const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
          const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
          const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
          const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
          const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_107 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_108 = tmp_qloop_104 + tmp_qloop_107 - 3.0;
                const real_t tmp_qloop_109 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_110 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_111 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_112 = tmp_qloop_111*tmp_qloop_50;
                const real_t tmp_qloop_113 = tmp_qloop_109*tmp_qloop_110;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_52;
                const real_t tmp_qloop_115 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_116 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_116*tmp_qloop_117*1.0;
                const real_t tmp_qloop_119 = tmp_qloop_109*tmp_qloop_110*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_109*tmp_qloop_110*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_112*tmp_qloop_114*tmp_qloop_86 - tmp_qloop_113*tmp_qloop_118*tmp_qloop_36 - tmp_qloop_114*tmp_qloop_115*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_120 = 1.0 / (tmp_qloop_119);
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_123 = tmp_qloop_121*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_52;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_25;
                const real_t tmp_qloop_126 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_125 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_127 = tmp_qloop_120*(-tmp_qloop_111*tmp_qloop_124*tmp_qloop_22 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_123*tmp_qloop_59 - tmp_qloop_118*tmp_qloop_123);
                const real_t tmp_qloop_129 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_128 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_126 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_130 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_128 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_126 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_131 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_128 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_126 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_127;
                const real_t tmp_qloop_132 = -tmp_qloop_108*tmp_qloop_129 - tmp_qloop_108*tmp_qloop_130 - tmp_qloop_108*tmp_qloop_131;
                const real_t tmp_qloop_133 = abs_det_jac_affine_GREEN_DOWN*abs(tmp_qloop_119)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q]);
                const real_t tmp_qloop_135 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_136 = tmp_qloop_134*tmp_qloop_135;
                const real_t tmp_qloop_137 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_138 = tmp_qloop_134*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_104 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_134*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_142 = tmp_qloop_104*tmp_qloop_130;
                const real_t tmp_qloop_143 = -tmp_qloop_141 - tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_145 = tmp_qloop_104*tmp_qloop_129;
                const real_t tmp_qloop_146 = -tmp_qloop_144 - tmp_qloop_145;
                const real_t tmp_qloop_147 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_129;
                const real_t tmp_qloop_149 = -tmp_qloop_147 - tmp_qloop_148;
                const real_t tmp_qloop_150 = -tmp_qloop_107 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_151 = -tmp_qloop_131*tmp_qloop_150 + tmp_qloop_142 + tmp_qloop_145;
                const real_t tmp_qloop_152 = tmp_qloop_104 - 4.0;
                const real_t tmp_qloop_153 = -tmp_qloop_105 - tmp_qloop_152 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_154 = -tmp_qloop_130*tmp_qloop_153 + tmp_qloop_141 + tmp_qloop_148;
                const real_t tmp_qloop_155 = -tmp_qloop_106 - tmp_qloop_152 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_156 = -tmp_qloop_129*tmp_qloop_155 + tmp_qloop_144 + tmp_qloop_147;
                const real_t tmp_qloop_157 = tmp_qloop_123*tmp_qloop_18;
                const real_t tmp_qloop_158 = tmp_qloop_120*(-tmp_qloop_115*tmp_qloop_157*tmp_qloop_43 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_159 = tmp_qloop_123*tmp_qloop_36;
                const real_t tmp_qloop_160 = tmp_qloop_159*1.0;
                const real_t tmp_qloop_161 = tmp_qloop_120*(-tmp_qloop_117*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_162 = tmp_qloop_120*(tmp_qloop_115*tmp_qloop_159 - tmp_qloop_124*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_163 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_158 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_164 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_158 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_165 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_158 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_161;
                const real_t tmp_qloop_166 = -tmp_qloop_108*tmp_qloop_163 - tmp_qloop_108*tmp_qloop_164 - tmp_qloop_108*tmp_qloop_165;
                const real_t tmp_qloop_167 = tmp_qloop_106*tmp_qloop_165;
                const real_t tmp_qloop_168 = tmp_qloop_104*tmp_qloop_164;
                const real_t tmp_qloop_169 = -tmp_qloop_167 - tmp_qloop_168;
                const real_t tmp_qloop_170 = tmp_qloop_105*tmp_qloop_165;
                const real_t tmp_qloop_171 = tmp_qloop_104*tmp_qloop_163;
                const real_t tmp_qloop_172 = -tmp_qloop_170 - tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_105*tmp_qloop_164;
                const real_t tmp_qloop_174 = tmp_qloop_106*tmp_qloop_163;
                const real_t tmp_qloop_175 = -tmp_qloop_173 - tmp_qloop_174;
                const real_t tmp_qloop_176 = -tmp_qloop_150*tmp_qloop_165 + tmp_qloop_168 + tmp_qloop_171;
                const real_t tmp_qloop_177 = -tmp_qloop_153*tmp_qloop_164 + tmp_qloop_167 + tmp_qloop_174;
                const real_t tmp_qloop_178 = -tmp_qloop_155*tmp_qloop_163 + tmp_qloop_170 + tmp_qloop_173;
                const real_t tmp_qloop_179 = tmp_qloop_120*(-tmp_qloop_116*tmp_qloop_160 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_180 = tmp_qloop_120*(-tmp_qloop_112*tmp_qloop_157 + tmp_qloop_121*tmp_qloop_122*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_181 = tmp_qloop_120*(tmp_qloop_111*tmp_qloop_159 - tmp_qloop_125*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_182 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_180 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_179 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_183 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_180 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_179 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_184 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_180 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_179 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_181;
                const real_t tmp_qloop_185 = -tmp_qloop_108*tmp_qloop_182 - tmp_qloop_108*tmp_qloop_183 - tmp_qloop_108*tmp_qloop_184;
                const real_t tmp_qloop_186 = tmp_qloop_106*tmp_qloop_184;
                const real_t tmp_qloop_187 = tmp_qloop_104*tmp_qloop_183;
                const real_t tmp_qloop_188 = -tmp_qloop_186 - tmp_qloop_187;
                const real_t tmp_qloop_189 = tmp_qloop_105*tmp_qloop_184;
                const real_t tmp_qloop_190 = tmp_qloop_104*tmp_qloop_182;
                const real_t tmp_qloop_191 = -tmp_qloop_189 - tmp_qloop_190;
                const real_t tmp_qloop_192 = tmp_qloop_105*tmp_qloop_183;
                const real_t tmp_qloop_193 = tmp_qloop_106*tmp_qloop_182;
                const real_t tmp_qloop_194 = -tmp_qloop_192 - tmp_qloop_193;
                const real_t tmp_qloop_195 = -tmp_qloop_150*tmp_qloop_184 + tmp_qloop_187 + tmp_qloop_190;
                const real_t tmp_qloop_196 = -tmp_qloop_153*tmp_qloop_183 + tmp_qloop_186 + tmp_qloop_193;
                const real_t tmp_qloop_197 = -tmp_qloop_155*tmp_qloop_182 + tmp_qloop_189 + tmp_qloop_192;
                const real_t tmp_qloop_198 = tmp_qloop_133*_data_q_p_0[q];
                const real_t tmp_qloop_199 = tmp_qloop_135*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_137*tmp_qloop_198;
                const real_t tmp_qloop_201 = tmp_qloop_139*tmp_qloop_198;
                const real_t tmp_qloop_202 = tmp_qloop_133*_data_q_p_1[q];
                const real_t tmp_qloop_203 = tmp_qloop_135*tmp_qloop_202;
                const real_t tmp_qloop_204 = tmp_qloop_137*tmp_qloop_202;
                const real_t tmp_qloop_205 = tmp_qloop_139*tmp_qloop_202;
                const real_t tmp_qloop_206 = tmp_qloop_133*_data_q_p_2[q];
                const real_t tmp_qloop_207 = tmp_qloop_135*tmp_qloop_206;
                const real_t tmp_qloop_208 = tmp_qloop_137*tmp_qloop_206;
                const real_t tmp_qloop_209 = tmp_qloop_139*tmp_qloop_206;
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_132*tmp_qloop_134;
                const real_t q_tmp_0_1 = -tmp_qloop_129*tmp_qloop_136;
                const real_t q_tmp_0_2 = -tmp_qloop_130*tmp_qloop_138;
                const real_t q_tmp_0_3 = -tmp_qloop_131*tmp_qloop_140;
                const real_t q_tmp_0_4 = tmp_qloop_134*tmp_qloop_143;
                const real_t q_tmp_0_5 = tmp_qloop_134*tmp_qloop_146;
                const real_t q_tmp_0_6 = tmp_qloop_134*tmp_qloop_149;
                const real_t q_tmp_0_7 = tmp_qloop_134*tmp_qloop_151;
                const real_t q_tmp_0_8 = tmp_qloop_134*tmp_qloop_154;
                const real_t q_tmp_0_9 = tmp_qloop_134*tmp_qloop_156;
                const real_t q_tmp_0_10 = tmp_qloop_134*tmp_qloop_166;
                const real_t q_tmp_0_11 = -tmp_qloop_136*tmp_qloop_163;
                const real_t q_tmp_0_12 = -tmp_qloop_138*tmp_qloop_164;
                const real_t q_tmp_0_13 = -tmp_qloop_140*tmp_qloop_165;
                const real_t q_tmp_0_14 = tmp_qloop_134*tmp_qloop_169;
                const real_t q_tmp_0_15 = tmp_qloop_134*tmp_qloop_172;
                const real_t q_tmp_0_16 = tmp_qloop_134*tmp_qloop_175;
                const real_t q_tmp_0_17 = tmp_qloop_134*tmp_qloop_176;
                const real_t q_tmp_0_18 = tmp_qloop_134*tmp_qloop_177;
                const real_t q_tmp_0_19 = tmp_qloop_134*tmp_qloop_178;
                const real_t q_tmp_0_20 = tmp_qloop_134*tmp_qloop_185;
                const real_t q_tmp_0_21 = -tmp_qloop_136*tmp_qloop_182;
                const real_t q_tmp_0_22 = -tmp_qloop_138*tmp_qloop_183;
                const real_t q_tmp_0_23 = -tmp_qloop_140*tmp_qloop_184;
                const real_t q_tmp_0_24 = tmp_qloop_134*tmp_qloop_188;
                const real_t q_tmp_0_25 = tmp_qloop_134*tmp_qloop_191;
                const real_t q_tmp_0_26 = tmp_qloop_134*tmp_qloop_194;
                const real_t q_tmp_0_27 = tmp_qloop_134*tmp_qloop_195;
                const real_t q_tmp_0_28 = tmp_qloop_134*tmp_qloop_196;
                const real_t q_tmp_0_29 = tmp_qloop_134*tmp_qloop_197;
                const real_t q_tmp_1_0 = tmp_qloop_132*tmp_qloop_198;
                const real_t q_tmp_1_1 = -tmp_qloop_129*tmp_qloop_199;
                const real_t q_tmp_1_2 = -tmp_qloop_130*tmp_qloop_200;
                const real_t q_tmp_1_3 = -tmp_qloop_131*tmp_qloop_201;
                const real_t q_tmp_1_4 = tmp_qloop_143*tmp_qloop_198;
                const real_t q_tmp_1_5 = tmp_qloop_146*tmp_qloop_198;
                const real_t q_tmp_1_6 = tmp_qloop_149*tmp_qloop_198;
                const real_t q_tmp_1_7 = tmp_qloop_151*tmp_qloop_198;
                const real_t q_tmp_1_8 = tmp_qloop_154*tmp_qloop_198;
                const real_t q_tmp_1_9 = tmp_qloop_156*tmp_qloop_198;
                const real_t q_tmp_1_10 = tmp_qloop_166*tmp_qloop_198;
                const real_t q_tmp_1_11 = -tmp_qloop_163*tmp_qloop_199;
                const real_t q_tmp_1_12 = -tmp_qloop_164*tmp_qloop_200;
                const real_t q_tmp_1_13 = -tmp_qloop_165*tmp_qloop_201;
                const real_t q_tmp_1_14 = tmp_qloop_169*tmp_qloop_198;
                const real_t q_tmp_1_15 = tmp_qloop_172*tmp_qloop_198;
                const real_t q_tmp_1_16 = tmp_qloop_175*tmp_qloop_198;
                const real_t q_tmp_1_17 = tmp_qloop_176*tmp_qloop_198;
                const real_t q_tmp_1_18 = tmp_qloop_177*tmp_qloop_198;
                const real_t q_tmp_1_19 = tmp_qloop_178*tmp_qloop_198;
                const real_t q_tmp_1_20 = tmp_qloop_185*tmp_qloop_198;
                const real_t q_tmp_1_21 = -tmp_qloop_182*tmp_qloop_199;
                const real_t q_tmp_1_22 = -tmp_qloop_183*tmp_qloop_200;
                const real_t q_tmp_1_23 = -tmp_qloop_184*tmp_qloop_201;
                const real_t q_tmp_1_24 = tmp_qloop_188*tmp_qloop_198;
                const real_t q_tmp_1_25 = tmp_qloop_191*tmp_qloop_198;
                const real_t q_tmp_1_26 = tmp_qloop_194*tmp_qloop_198;
                const real_t q_tmp_1_27 = tmp_qloop_195*tmp_qloop_198;
                const real_t q_tmp_1_28 = tmp_qloop_196*tmp_qloop_198;
                const real_t q_tmp_1_29 = tmp_qloop_197*tmp_qloop_198;
                const real_t q_tmp_2_0 = tmp_qloop_132*tmp_qloop_202;
                const real_t q_tmp_2_1 = -tmp_qloop_129*tmp_qloop_203;
                const real_t q_tmp_2_2 = -tmp_qloop_130*tmp_qloop_204;
                const real_t q_tmp_2_3 = -tmp_qloop_131*tmp_qloop_205;
                const real_t q_tmp_2_4 = tmp_qloop_143*tmp_qloop_202;
                const real_t q_tmp_2_5 = tmp_qloop_146*tmp_qloop_202;
                const real_t q_tmp_2_6 = tmp_qloop_149*tmp_qloop_202;
                const real_t q_tmp_2_7 = tmp_qloop_151*tmp_qloop_202;
                const real_t q_tmp_2_8 = tmp_qloop_154*tmp_qloop_202;
                const real_t q_tmp_2_9 = tmp_qloop_156*tmp_qloop_202;
                const real_t q_tmp_2_10 = tmp_qloop_166*tmp_qloop_202;
                const real_t q_tmp_2_11 = -tmp_qloop_163*tmp_qloop_203;
                const real_t q_tmp_2_12 = -tmp_qloop_164*tmp_qloop_204;
                const real_t q_tmp_2_13 = -tmp_qloop_165*tmp_qloop_205;
                const real_t q_tmp_2_14 = tmp_qloop_169*tmp_qloop_202;
                const real_t q_tmp_2_15 = tmp_qloop_172*tmp_qloop_202;
                const real_t q_tmp_2_16 = tmp_qloop_175*tmp_qloop_202;
                const real_t q_tmp_2_17 = tmp_qloop_176*tmp_qloop_202;
                const real_t q_tmp_2_18 = tmp_qloop_177*tmp_qloop_202;
                const real_t q_tmp_2_19 = tmp_qloop_178*tmp_qloop_202;
                const real_t q_tmp_2_20 = tmp_qloop_185*tmp_qloop_202;
                const real_t q_tmp_2_21 = -tmp_qloop_182*tmp_qloop_203;
                const real_t q_tmp_2_22 = -tmp_qloop_183*tmp_qloop_204;
                const real_t q_tmp_2_23 = -tmp_qloop_184*tmp_qloop_205;
                const real_t q_tmp_2_24 = tmp_qloop_188*tmp_qloop_202;
                const real_t q_tmp_2_25 = tmp_qloop_191*tmp_qloop_202;
                const real_t q_tmp_2_26 = tmp_qloop_194*tmp_qloop_202;
                const real_t q_tmp_2_27 = tmp_qloop_195*tmp_qloop_202;
                const real_t q_tmp_2_28 = tmp_qloop_196*tmp_qloop_202;
                const real_t q_tmp_2_29 = tmp_qloop_197*tmp_qloop_202;
                const real_t q_tmp_3_0 = tmp_qloop_132*tmp_qloop_206;
                const real_t q_tmp_3_1 = -tmp_qloop_129*tmp_qloop_207;
                const real_t q_tmp_3_2 = -tmp_qloop_130*tmp_qloop_208;
                const real_t q_tmp_3_3 = -tmp_qloop_131*tmp_qloop_209;
                const real_t q_tmp_3_4 = tmp_qloop_143*tmp_qloop_206;
                const real_t q_tmp_3_5 = tmp_qloop_146*tmp_qloop_206;
                const real_t q_tmp_3_6 = tmp_qloop_149*tmp_qloop_206;
                const real_t q_tmp_3_7 = tmp_qloop_151*tmp_qloop_206;
                const real_t q_tmp_3_8 = tmp_qloop_154*tmp_qloop_206;
                const real_t q_tmp_3_9 = tmp_qloop_156*tmp_qloop_206;
                const real_t q_tmp_3_10 = tmp_qloop_166*tmp_qloop_206;
                const real_t q_tmp_3_11 = -tmp_qloop_163*tmp_qloop_207;
                const real_t q_tmp_3_12 = -tmp_qloop_164*tmp_qloop_208;
                const real_t q_tmp_3_13 = -tmp_qloop_165*tmp_qloop_209;
                const real_t q_tmp_3_14 = tmp_qloop_169*tmp_qloop_206;
                const real_t q_tmp_3_15 = tmp_qloop_172*tmp_qloop_206;
                const real_t q_tmp_3_16 = tmp_qloop_175*tmp_qloop_206;
                const real_t q_tmp_3_17 = tmp_qloop_176*tmp_qloop_206;
                const real_t q_tmp_3_18 = tmp_qloop_177*tmp_qloop_206;
                const real_t q_tmp_3_19 = tmp_qloop_178*tmp_qloop_206;
                const real_t q_tmp_3_20 = tmp_qloop_185*tmp_qloop_206;
                const real_t q_tmp_3_21 = -tmp_qloop_182*tmp_qloop_207;
                const real_t q_tmp_3_22 = -tmp_qloop_183*tmp_qloop_208;
                const real_t q_tmp_3_23 = -tmp_qloop_184*tmp_qloop_209;
                const real_t q_tmp_3_24 = tmp_qloop_188*tmp_qloop_206;
                const real_t q_tmp_3_25 = tmp_qloop_191*tmp_qloop_206;
                const real_t q_tmp_3_26 = tmp_qloop_194*tmp_qloop_206;
                const real_t q_tmp_3_27 = tmp_qloop_195*tmp_qloop_206;
                const real_t q_tmp_3_28 = tmp_qloop_196*tmp_qloop_206;
                const real_t q_tmp_3_29 = tmp_qloop_197*tmp_qloop_206;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
             }
             const real_t tmp_kernel_op_0 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_1 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_2 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_3 = pow(tmp_kernel_op_0 + tmp_kernel_op_1 + tmp_kernel_op_2, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_4 = ((tmp_kernel_op_3) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_5 = ((tmp_kernel_op_3) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_6 = ((tmp_kernel_op_3) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_7 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_8 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_9 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_10 = pow(tmp_kernel_op_7 + tmp_kernel_op_8 + tmp_kernel_op_9, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_11 = ((tmp_kernel_op_10) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_10) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_13 = ((tmp_kernel_op_10) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_14 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_15 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_16 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_17 = pow(tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_16, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_18 = ((tmp_kernel_op_17) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_17) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_20 = ((tmp_kernel_op_17) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_21 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_22 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_23 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_24 = pow(tmp_kernel_op_21 + tmp_kernel_op_22 + tmp_kernel_op_23, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_25 = ((tmp_kernel_op_24) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_26 = ((tmp_kernel_op_24) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_24) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_28 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_29 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_30 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_31 = pow(tmp_kernel_op_28 + tmp_kernel_op_29 + tmp_kernel_op_30, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_31) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_31) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_31) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_35 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_36 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_37 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_38 = pow(tmp_kernel_op_35 + tmp_kernel_op_36 + tmp_kernel_op_37, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_39 = ((tmp_kernel_op_38) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_40 = ((tmp_kernel_op_38) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_41 = ((tmp_kernel_op_38) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_42 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_43 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_44 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_45 = pow(tmp_kernel_op_42 + tmp_kernel_op_43 + tmp_kernel_op_44, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_46 = ((tmp_kernel_op_45) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_45) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_48 = ((tmp_kernel_op_45) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_49 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_50 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_51 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_52 = pow(tmp_kernel_op_49 + tmp_kernel_op_50 + tmp_kernel_op_51, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_53 = ((tmp_kernel_op_52) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_54 = ((tmp_kernel_op_52) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_52) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_56 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_57 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_58 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_59 = pow(tmp_kernel_op_56 + tmp_kernel_op_57 + tmp_kernel_op_58, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_60 = ((tmp_kernel_op_59) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_61 = ((tmp_kernel_op_59) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_62 = ((tmp_kernel_op_59) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_63 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_64 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_65 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_66 = pow(tmp_kernel_op_63 + tmp_kernel_op_64 + tmp_kernel_op_65, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_67 = ((tmp_kernel_op_66) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_68 = ((tmp_kernel_op_66) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_69 = ((tmp_kernel_op_66) ? (nx_dof_9): (0.0));
             const real_t tmp_kernel_op_70 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_71 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_72 = pow(tmp_kernel_op_70 + tmp_kernel_op_71, 0.50000000000000000);
             const real_t tmp_kernel_op_73 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_73, 0.50000000000000000);
             const real_t tmp_kernel_op_75 = tmp_kernel_op_74 + 1.0e-10;
             const real_t tmp_kernel_op_76 = pow(tmp_kernel_op_70 + tmp_kernel_op_73, 0.50000000000000000);
             const bool tmp_kernel_op_77 = tmp_kernel_op_72 < tmp_kernel_op_75 && tmp_kernel_op_76 < tmp_kernel_op_75;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_76);
             const real_t tmp_kernel_op_79 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = tmp_kernel_op_76 + 1.0e-10;
             const bool tmp_kernel_op_82 = tmp_kernel_op_72 < tmp_kernel_op_81 && tmp_kernel_op_74 < tmp_kernel_op_81;
             const real_t tmp_kernel_op_83 = 1.0 / (tmp_kernel_op_72);
             const real_t tmp_kernel_op_84 = tmp_kernel_op_83*1.0;
             const real_t tmp_kernel_op_85 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (0.0): ((tmp_kernel_op_82) ? (-tmp_kernel_op_80): (ny_dof_0*tmp_kernel_op_84)))): (1.0));
             const real_t tmp_kernel_op_86 = 1.0 / (tmp_kernel_op_74);
             const real_t tmp_kernel_op_87 = tmp_kernel_op_79*tmp_kernel_op_86;
             const real_t tmp_kernel_op_88 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (tmp_kernel_op_87): ((tmp_kernel_op_82) ? (0.0): (-nx_dof_0*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_86*1.0;
             const real_t tmp_kernel_op_90 = ny_dof_0*tmp_kernel_op_89;
             const real_t tmp_kernel_op_91 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_92 = nx_dof_0*tmp_kernel_op_91;
             const real_t tmp_kernel_op_93 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_90): ((tmp_kernel_op_82) ? (tmp_kernel_op_92): (0.0)))): (0.0));
             const real_t tmp_kernel_op_94 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_95 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_96 = pow(tmp_kernel_op_94 + tmp_kernel_op_95, 0.50000000000000000);
             const real_t tmp_kernel_op_97 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_98 = pow(tmp_kernel_op_95 + tmp_kernel_op_97, 0.50000000000000000);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_98 + 1.0e-10;
             const real_t tmp_kernel_op_100 = pow(tmp_kernel_op_94 + tmp_kernel_op_97, 0.50000000000000000);
             const bool tmp_kernel_op_101 = tmp_kernel_op_100 < tmp_kernel_op_99 && tmp_kernel_op_96 < tmp_kernel_op_99;
             const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_100);
             const real_t tmp_kernel_op_103 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_104 = tmp_kernel_op_102*tmp_kernel_op_103;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100 + 1.0e-10;
             const bool tmp_kernel_op_106 = tmp_kernel_op_96 < tmp_kernel_op_105 && tmp_kernel_op_98 < tmp_kernel_op_105;
             const real_t tmp_kernel_op_107 = 1.0 / (tmp_kernel_op_96);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*1.0;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (0.0): ((tmp_kernel_op_106) ? (-tmp_kernel_op_104): (ny_dof_1*tmp_kernel_op_108)))): (1.0));
             const real_t tmp_kernel_op_110 = 1.0 / (tmp_kernel_op_98);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_103*tmp_kernel_op_110;
             const real_t tmp_kernel_op_112 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (tmp_kernel_op_111): ((tmp_kernel_op_106) ? (0.0): (-nx_dof_1*tmp_kernel_op_108)))): (0.0));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_110*1.0;
             const real_t tmp_kernel_op_114 = ny_dof_1*tmp_kernel_op_113;
             const real_t tmp_kernel_op_115 = tmp_kernel_op_102*1.0;
             const real_t tmp_kernel_op_116 = nx_dof_1*tmp_kernel_op_115;
             const real_t tmp_kernel_op_117 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_114): ((tmp_kernel_op_106) ? (tmp_kernel_op_116): (0.0)))): (0.0));
             const real_t tmp_kernel_op_118 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_119 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_120 = pow(tmp_kernel_op_118 + tmp_kernel_op_119, 0.50000000000000000);
             const real_t tmp_kernel_op_121 = 1.0 / (tmp_kernel_op_120)*1.0;
             const real_t tmp_kernel_op_122 = nz_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_123 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_124 = pow(tmp_kernel_op_118 + tmp_kernel_op_123, 0.50000000000000000);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_120 + 1.0e-10;
             const real_t tmp_kernel_op_126 = pow(tmp_kernel_op_119 + tmp_kernel_op_123, 0.50000000000000000);
             const bool tmp_kernel_op_127 = tmp_kernel_op_124 < tmp_kernel_op_125 && tmp_kernel_op_126 < tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + 1.0e-10;
             const bool tmp_kernel_op_129 = tmp_kernel_op_120 < tmp_kernel_op_128 && tmp_kernel_op_124 < tmp_kernel_op_128;
             const real_t tmp_kernel_op_130 = 1.0 / (tmp_kernel_op_124)*1.0;
             const real_t tmp_kernel_op_131 = nx_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_132 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (tmp_kernel_op_122): ((tmp_kernel_op_129) ? (0.0): (-tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_133 = 1.0 / (tmp_kernel_op_126)*1.0;
             const real_t tmp_kernel_op_134 = nz_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_135 = ny_dof_2*tmp_kernel_op_130;
             const real_t tmp_kernel_op_136 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (0.0): ((tmp_kernel_op_129) ? (-tmp_kernel_op_134): (tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_137 = ny_dof_2*tmp_kernel_op_121;
             const real_t tmp_kernel_op_138 = nx_dof_2*tmp_kernel_op_133;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_137): ((tmp_kernel_op_129) ? (tmp_kernel_op_138): (0.0)))): (0.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142)*1.0;
             const real_t tmp_kernel_op_144 = nz_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_146 = pow(tmp_kernel_op_140 + tmp_kernel_op_145, 0.50000000000000000);
             const real_t tmp_kernel_op_147 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_148 = pow(tmp_kernel_op_141 + tmp_kernel_op_145, 0.50000000000000000);
             const bool tmp_kernel_op_149 = tmp_kernel_op_146 < tmp_kernel_op_147 && tmp_kernel_op_148 < tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_148 + 1.0e-10;
             const bool tmp_kernel_op_151 = tmp_kernel_op_142 < tmp_kernel_op_150 && tmp_kernel_op_146 < tmp_kernel_op_150;
             const real_t tmp_kernel_op_152 = 1.0 / (tmp_kernel_op_146)*1.0;
             const real_t tmp_kernel_op_153 = nx_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_154 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (tmp_kernel_op_144): ((tmp_kernel_op_151) ? (0.0): (-tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_155 = ny_dof_3*tmp_kernel_op_143;
             const real_t tmp_kernel_op_156 = 1.0 / (tmp_kernel_op_148)*1.0;
             const real_t tmp_kernel_op_157 = nx_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_158 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_155): ((tmp_kernel_op_151) ? (tmp_kernel_op_157): (0.0)))): (0.0));
             const real_t tmp_kernel_op_159 = nz_dof_3*tmp_kernel_op_156;
             const real_t tmp_kernel_op_160 = ny_dof_3*tmp_kernel_op_152;
             const real_t tmp_kernel_op_161 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (0.0): ((tmp_kernel_op_151) ? (-tmp_kernel_op_159): (tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_162 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_163 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_164 = pow(tmp_kernel_op_162 + tmp_kernel_op_163, 0.50000000000000000);
             const real_t tmp_kernel_op_165 = 1.0 / (tmp_kernel_op_164)*1.0;
             const real_t tmp_kernel_op_166 = nz_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_167 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_168 = pow(tmp_kernel_op_162 + tmp_kernel_op_167, 0.50000000000000000);
             const real_t tmp_kernel_op_169 = tmp_kernel_op_164 + 1.0e-10;
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_163 + tmp_kernel_op_167, 0.50000000000000000);
             const bool tmp_kernel_op_171 = tmp_kernel_op_168 < tmp_kernel_op_169 && tmp_kernel_op_170 < tmp_kernel_op_169;
             const real_t tmp_kernel_op_172 = tmp_kernel_op_170 + 1.0e-10;
             const bool tmp_kernel_op_173 = tmp_kernel_op_164 < tmp_kernel_op_172 && tmp_kernel_op_168 < tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0 / (tmp_kernel_op_168)*1.0;
             const real_t tmp_kernel_op_175 = nx_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_176 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (tmp_kernel_op_166): ((tmp_kernel_op_173) ? (0.0): (-tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_177 = ny_dof_4*tmp_kernel_op_165;
             const real_t tmp_kernel_op_178 = 1.0 / (tmp_kernel_op_170)*1.0;
             const real_t tmp_kernel_op_179 = nx_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_180 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_177): ((tmp_kernel_op_173) ? (tmp_kernel_op_179): (0.0)))): (0.0));
             const real_t tmp_kernel_op_181 = nz_dof_4*tmp_kernel_op_178;
             const real_t tmp_kernel_op_182 = ny_dof_4*tmp_kernel_op_174;
             const real_t tmp_kernel_op_183 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (0.0): ((tmp_kernel_op_173) ? (-tmp_kernel_op_181): (tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_184 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_185 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_186 = pow(tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000);
             const real_t tmp_kernel_op_187 = 1.0 / (tmp_kernel_op_186)*1.0;
             const real_t tmp_kernel_op_188 = nz_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_189 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_190 = pow(tmp_kernel_op_184 + tmp_kernel_op_189, 0.50000000000000000);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_186 + 1.0e-10;
             const real_t tmp_kernel_op_192 = pow(tmp_kernel_op_185 + tmp_kernel_op_189, 0.50000000000000000);
             const bool tmp_kernel_op_193 = tmp_kernel_op_190 < tmp_kernel_op_191 && tmp_kernel_op_192 < tmp_kernel_op_191;
             const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + 1.0e-10;
             const bool tmp_kernel_op_195 = tmp_kernel_op_186 < tmp_kernel_op_194 && tmp_kernel_op_190 < tmp_kernel_op_194;
             const real_t tmp_kernel_op_196 = 1.0 / (tmp_kernel_op_190)*1.0;
             const real_t tmp_kernel_op_197 = nx_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_198 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (tmp_kernel_op_188): ((tmp_kernel_op_195) ? (0.0): (-tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_199 = ny_dof_5*tmp_kernel_op_187;
             const real_t tmp_kernel_op_200 = 1.0 / (tmp_kernel_op_192)*1.0;
             const real_t tmp_kernel_op_201 = nx_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_199): ((tmp_kernel_op_195) ? (tmp_kernel_op_201): (0.0)))): (0.0));
             const real_t tmp_kernel_op_203 = nz_dof_5*tmp_kernel_op_200;
             const real_t tmp_kernel_op_204 = ny_dof_5*tmp_kernel_op_196;
             const real_t tmp_kernel_op_205 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (0.0): ((tmp_kernel_op_195) ? (-tmp_kernel_op_203): (tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_206 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_207 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_208 = pow(tmp_kernel_op_206 + tmp_kernel_op_207, 0.50000000000000000);
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_208)*1.0;
             const real_t tmp_kernel_op_210 = nz_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_211 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_212 = pow(tmp_kernel_op_206 + tmp_kernel_op_211, 0.50000000000000000);
             const real_t tmp_kernel_op_213 = tmp_kernel_op_208 + 1.0e-10;
             const real_t tmp_kernel_op_214 = pow(tmp_kernel_op_207 + tmp_kernel_op_211, 0.50000000000000000);
             const bool tmp_kernel_op_215 = tmp_kernel_op_212 < tmp_kernel_op_213 && tmp_kernel_op_214 < tmp_kernel_op_213;
             const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + 1.0e-10;
             const bool tmp_kernel_op_217 = tmp_kernel_op_208 < tmp_kernel_op_216 && tmp_kernel_op_212 < tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_212)*1.0;
             const real_t tmp_kernel_op_219 = nx_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_220 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (tmp_kernel_op_210): ((tmp_kernel_op_217) ? (0.0): (-tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_221 = ny_dof_6*tmp_kernel_op_209;
             const real_t tmp_kernel_op_222 = 1.0 / (tmp_kernel_op_214)*1.0;
             const real_t tmp_kernel_op_223 = nx_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_221): ((tmp_kernel_op_217) ? (tmp_kernel_op_223): (0.0)))): (0.0));
             const real_t tmp_kernel_op_225 = nz_dof_6*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = ny_dof_6*tmp_kernel_op_218;
             const real_t tmp_kernel_op_227 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (0.0): ((tmp_kernel_op_217) ? (-tmp_kernel_op_225): (tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_228 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_229 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_230 = pow(tmp_kernel_op_228 + tmp_kernel_op_229, 0.50000000000000000);
             const real_t tmp_kernel_op_231 = 1.0 / (tmp_kernel_op_230)*1.0;
             const real_t tmp_kernel_op_232 = nz_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_233 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_234 = pow(tmp_kernel_op_228 + tmp_kernel_op_233, 0.50000000000000000);
             const real_t tmp_kernel_op_235 = tmp_kernel_op_230 + 1.0e-10;
             const real_t tmp_kernel_op_236 = pow(tmp_kernel_op_229 + tmp_kernel_op_233, 0.50000000000000000);
             const bool tmp_kernel_op_237 = tmp_kernel_op_234 < tmp_kernel_op_235 && tmp_kernel_op_236 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_238 = tmp_kernel_op_236 + 1.0e-10;
             const bool tmp_kernel_op_239 = tmp_kernel_op_230 < tmp_kernel_op_238 && tmp_kernel_op_234 < tmp_kernel_op_238;
             const real_t tmp_kernel_op_240 = 1.0 / (tmp_kernel_op_234)*1.0;
             const real_t tmp_kernel_op_241 = nx_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (tmp_kernel_op_232): ((tmp_kernel_op_239) ? (0.0): (-tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_243 = ny_dof_7*tmp_kernel_op_231;
             const real_t tmp_kernel_op_244 = 1.0 / (tmp_kernel_op_236)*1.0;
             const real_t tmp_kernel_op_245 = nx_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_243): ((tmp_kernel_op_239) ? (tmp_kernel_op_245): (0.0)))): (0.0));
             const real_t tmp_kernel_op_247 = nz_dof_7*tmp_kernel_op_244;
             const real_t tmp_kernel_op_248 = ny_dof_7*tmp_kernel_op_240;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (0.0): ((tmp_kernel_op_239) ? (-tmp_kernel_op_247): (tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_250 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_251 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_252 = pow(tmp_kernel_op_250 + tmp_kernel_op_251, 0.50000000000000000);
             const real_t tmp_kernel_op_253 = 1.0 / (tmp_kernel_op_252)*1.0;
             const real_t tmp_kernel_op_254 = nz_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_255 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_256 = pow(tmp_kernel_op_250 + tmp_kernel_op_255, 0.50000000000000000);
             const real_t tmp_kernel_op_257 = tmp_kernel_op_252 + 1.0e-10;
             const real_t tmp_kernel_op_258 = pow(tmp_kernel_op_251 + tmp_kernel_op_255, 0.50000000000000000);
             const bool tmp_kernel_op_259 = tmp_kernel_op_256 < tmp_kernel_op_257 && tmp_kernel_op_258 < tmp_kernel_op_257;
             const real_t tmp_kernel_op_260 = tmp_kernel_op_258 + 1.0e-10;
             const bool tmp_kernel_op_261 = tmp_kernel_op_252 < tmp_kernel_op_260 && tmp_kernel_op_256 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_262 = 1.0 / (tmp_kernel_op_256)*1.0;
             const real_t tmp_kernel_op_263 = nx_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_264 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (tmp_kernel_op_254): ((tmp_kernel_op_261) ? (0.0): (-tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_265 = ny_dof_8*tmp_kernel_op_253;
             const real_t tmp_kernel_op_266 = 1.0 / (tmp_kernel_op_258)*1.0;
             const real_t tmp_kernel_op_267 = nx_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_268 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_265): ((tmp_kernel_op_261) ? (tmp_kernel_op_267): (0.0)))): (0.0));
             const real_t tmp_kernel_op_269 = nz_dof_8*tmp_kernel_op_266;
             const real_t tmp_kernel_op_270 = ny_dof_8*tmp_kernel_op_262;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (0.0): ((tmp_kernel_op_261) ? (-tmp_kernel_op_269): (tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_272 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_273 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_274 = pow(tmp_kernel_op_272 + tmp_kernel_op_273, 0.50000000000000000);
             const real_t tmp_kernel_op_275 = 1.0 / (tmp_kernel_op_274)*1.0;
             const real_t tmp_kernel_op_276 = nz_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_278 = pow(tmp_kernel_op_272 + tmp_kernel_op_277, 0.50000000000000000);
             const real_t tmp_kernel_op_279 = tmp_kernel_op_274 + 1.0e-10;
             const real_t tmp_kernel_op_280 = pow(tmp_kernel_op_273 + tmp_kernel_op_277, 0.50000000000000000);
             const bool tmp_kernel_op_281 = tmp_kernel_op_278 < tmp_kernel_op_279 && tmp_kernel_op_280 < tmp_kernel_op_279;
             const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + 1.0e-10;
             const bool tmp_kernel_op_283 = tmp_kernel_op_274 < tmp_kernel_op_282 && tmp_kernel_op_278 < tmp_kernel_op_282;
             const real_t tmp_kernel_op_284 = 1.0 / (tmp_kernel_op_278)*1.0;
             const real_t tmp_kernel_op_285 = nx_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (tmp_kernel_op_276): ((tmp_kernel_op_283) ? (0.0): (-tmp_kernel_op_285)))): (0.0));
             const real_t tmp_kernel_op_287 = ny_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_288 = 1.0 / (tmp_kernel_op_280)*1.0;
             const real_t tmp_kernel_op_289 = nx_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_287): ((tmp_kernel_op_283) ? (tmp_kernel_op_289): (0.0)))): (0.0));
             const real_t tmp_kernel_op_291 = nz_dof_9*tmp_kernel_op_288;
             const real_t tmp_kernel_op_292 = ny_dof_9*tmp_kernel_op_284;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (0.0): ((tmp_kernel_op_283) ? (-tmp_kernel_op_291): (tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = tmp_kernel_op_79*tmp_kernel_op_83;
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (-tmp_kernel_op_1*tmp_kernel_op_89 - tmp_kernel_op_2*tmp_kernel_op_89): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_92): (nx_dof_0*tmp_kernel_op_294)))): (0.0));
             const real_t tmp_kernel_op_296 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_90): ((tmp_kernel_op_82) ? (-tmp_kernel_op_0*tmp_kernel_op_91 - tmp_kernel_op_2*tmp_kernel_op_91): (ny_dof_0*tmp_kernel_op_294)))): (1.0));
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_3) ? (((tmp_kernel_op_77) ? (nx_dof_0*tmp_kernel_op_87): ((tmp_kernel_op_82) ? (ny_dof_0*tmp_kernel_op_80): (-tmp_kernel_op_0*tmp_kernel_op_84 - tmp_kernel_op_1*tmp_kernel_op_84)))): (0.0));
             const real_t tmp_kernel_op_298 = tmp_kernel_op_103*tmp_kernel_op_107;
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (-tmp_kernel_op_113*tmp_kernel_op_8 - tmp_kernel_op_113*tmp_kernel_op_9): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_116): (nx_dof_1*tmp_kernel_op_298)))): (0.0));
             const real_t tmp_kernel_op_300 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_114): ((tmp_kernel_op_106) ? (-tmp_kernel_op_115*tmp_kernel_op_7 - tmp_kernel_op_115*tmp_kernel_op_9): (ny_dof_1*tmp_kernel_op_298)))): (1.0));
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_10) ? (((tmp_kernel_op_101) ? (nx_dof_1*tmp_kernel_op_111): ((tmp_kernel_op_106) ? (ny_dof_1*tmp_kernel_op_104): (-tmp_kernel_op_108*tmp_kernel_op_7 - tmp_kernel_op_108*tmp_kernel_op_8)))): (0.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_137): ((tmp_kernel_op_129) ? (-tmp_kernel_op_133*tmp_kernel_op_14 - tmp_kernel_op_133*tmp_kernel_op_16): (nz_dof_2*tmp_kernel_op_135)))): (1.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (-tmp_kernel_op_121*tmp_kernel_op_15 - tmp_kernel_op_121*tmp_kernel_op_16): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_138): (nz_dof_2*tmp_kernel_op_131)))): (0.0));
             const real_t tmp_kernel_op_304 = ((tmp_kernel_op_17) ? (((tmp_kernel_op_127) ? (nx_dof_2*tmp_kernel_op_122): ((tmp_kernel_op_129) ? (ny_dof_2*tmp_kernel_op_134): (-tmp_kernel_op_130*tmp_kernel_op_14 - tmp_kernel_op_130*tmp_kernel_op_15)))): (0.0));
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_155): ((tmp_kernel_op_151) ? (-tmp_kernel_op_156*tmp_kernel_op_21 - tmp_kernel_op_156*tmp_kernel_op_23): (nz_dof_3*tmp_kernel_op_160)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (nx_dof_3*tmp_kernel_op_144): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_159): (-tmp_kernel_op_152*tmp_kernel_op_21 - tmp_kernel_op_152*tmp_kernel_op_22)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_24) ? (((tmp_kernel_op_149) ? (-tmp_kernel_op_143*tmp_kernel_op_22 - tmp_kernel_op_143*tmp_kernel_op_23): ((tmp_kernel_op_151) ? (ny_dof_3*tmp_kernel_op_157): (nz_dof_3*tmp_kernel_op_153)))): (0.0));
             const real_t tmp_kernel_op_308 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_177): ((tmp_kernel_op_173) ? (-tmp_kernel_op_178*tmp_kernel_op_28 - tmp_kernel_op_178*tmp_kernel_op_30): (nz_dof_4*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (nx_dof_4*tmp_kernel_op_166): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_181): (-tmp_kernel_op_174*tmp_kernel_op_28 - tmp_kernel_op_174*tmp_kernel_op_29)))): (0.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_31) ? (((tmp_kernel_op_171) ? (-tmp_kernel_op_165*tmp_kernel_op_29 - tmp_kernel_op_165*tmp_kernel_op_30): ((tmp_kernel_op_173) ? (ny_dof_4*tmp_kernel_op_179): (nz_dof_4*tmp_kernel_op_175)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_199): ((tmp_kernel_op_195) ? (-tmp_kernel_op_200*tmp_kernel_op_35 - tmp_kernel_op_200*tmp_kernel_op_37): (nz_dof_5*tmp_kernel_op_204)))): (1.0));
             const real_t tmp_kernel_op_312 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (nx_dof_5*tmp_kernel_op_188): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_203): (-tmp_kernel_op_196*tmp_kernel_op_35 - tmp_kernel_op_196*tmp_kernel_op_36)))): (0.0));
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_38) ? (((tmp_kernel_op_193) ? (-tmp_kernel_op_187*tmp_kernel_op_36 - tmp_kernel_op_187*tmp_kernel_op_37): ((tmp_kernel_op_195) ? (ny_dof_5*tmp_kernel_op_201): (nz_dof_5*tmp_kernel_op_197)))): (0.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_221): ((tmp_kernel_op_217) ? (-tmp_kernel_op_222*tmp_kernel_op_42 - tmp_kernel_op_222*tmp_kernel_op_44): (nz_dof_6*tmp_kernel_op_226)))): (1.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (nx_dof_6*tmp_kernel_op_210): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_225): (-tmp_kernel_op_218*tmp_kernel_op_42 - tmp_kernel_op_218*tmp_kernel_op_43)))): (0.0));
             const real_t tmp_kernel_op_316 = ((tmp_kernel_op_45) ? (((tmp_kernel_op_215) ? (-tmp_kernel_op_209*tmp_kernel_op_43 - tmp_kernel_op_209*tmp_kernel_op_44): ((tmp_kernel_op_217) ? (ny_dof_6*tmp_kernel_op_223): (nz_dof_6*tmp_kernel_op_219)))): (0.0));
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_243): ((tmp_kernel_op_239) ? (-tmp_kernel_op_244*tmp_kernel_op_49 - tmp_kernel_op_244*tmp_kernel_op_51): (nz_dof_7*tmp_kernel_op_248)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (nx_dof_7*tmp_kernel_op_232): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_247): (-tmp_kernel_op_240*tmp_kernel_op_49 - tmp_kernel_op_240*tmp_kernel_op_50)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_52) ? (((tmp_kernel_op_237) ? (-tmp_kernel_op_231*tmp_kernel_op_50 - tmp_kernel_op_231*tmp_kernel_op_51): ((tmp_kernel_op_239) ? (ny_dof_7*tmp_kernel_op_245): (nz_dof_7*tmp_kernel_op_241)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_265): ((tmp_kernel_op_261) ? (-tmp_kernel_op_266*tmp_kernel_op_56 - tmp_kernel_op_266*tmp_kernel_op_58): (nz_dof_8*tmp_kernel_op_270)))): (1.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (nx_dof_8*tmp_kernel_op_254): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_269): (-tmp_kernel_op_262*tmp_kernel_op_56 - tmp_kernel_op_262*tmp_kernel_op_57)))): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_59) ? (((tmp_kernel_op_259) ? (-tmp_kernel_op_253*tmp_kernel_op_57 - tmp_kernel_op_253*tmp_kernel_op_58): ((tmp_kernel_op_261) ? (ny_dof_8*tmp_kernel_op_267): (nz_dof_8*tmp_kernel_op_263)))): (0.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_287): ((tmp_kernel_op_283) ? (-tmp_kernel_op_288*tmp_kernel_op_63 - tmp_kernel_op_288*tmp_kernel_op_65): (nz_dof_9*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (nx_dof_9*tmp_kernel_op_276): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_291): (-tmp_kernel_op_284*tmp_kernel_op_63 - tmp_kernel_op_284*tmp_kernel_op_64)))): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_66) ? (((tmp_kernel_op_281) ? (-tmp_kernel_op_275*tmp_kernel_op_64 - tmp_kernel_op_275*tmp_kernel_op_65): ((tmp_kernel_op_283) ? (ny_dof_9*tmp_kernel_op_289): (nz_dof_9*tmp_kernel_op_285)))): (0.0));
             const real_t elMatVec_0 = src_dof_0*(q_acc_0_0*tmp_kernel_op_85 + q_acc_0_10*tmp_kernel_op_88 + q_acc_0_20*tmp_kernel_op_93) + src_dof_1*(q_acc_0_1*tmp_kernel_op_109 + q_acc_0_11*tmp_kernel_op_112 + q_acc_0_21*tmp_kernel_op_117) + src_dof_10*(q_acc_0_0*tmp_kernel_op_295 + q_acc_0_10*tmp_kernel_op_296 + q_acc_0_20*tmp_kernel_op_297) + src_dof_11*(q_acc_0_1*tmp_kernel_op_299 + q_acc_0_11*tmp_kernel_op_300 + q_acc_0_21*tmp_kernel_op_301) + src_dof_12*(q_acc_0_12*tmp_kernel_op_302 + q_acc_0_2*tmp_kernel_op_303 + q_acc_0_22*tmp_kernel_op_304) + src_dof_13*(q_acc_0_13*tmp_kernel_op_305 + q_acc_0_23*tmp_kernel_op_306 + q_acc_0_3*tmp_kernel_op_307) + src_dof_14*(q_acc_0_14*tmp_kernel_op_308 + q_acc_0_24*tmp_kernel_op_309 + q_acc_0_4*tmp_kernel_op_310) + src_dof_15*(q_acc_0_15*tmp_kernel_op_311 + q_acc_0_25*tmp_kernel_op_312 + q_acc_0_5*tmp_kernel_op_313) + src_dof_16*(q_acc_0_16*tmp_kernel_op_314 + q_acc_0_26*tmp_kernel_op_315 + q_acc_0_6*tmp_kernel_op_316) + src_dof_17*(q_acc_0_17*tmp_kernel_op_317 + q_acc_0_27*tmp_kernel_op_318 + q_acc_0_7*tmp_kernel_op_319) + src_dof_18*(q_acc_0_18*tmp_kernel_op_320 + q_acc_0_28*tmp_kernel_op_321 + q_acc_0_8*tmp_kernel_op_322) + src_dof_19*(q_acc_0_19*tmp_kernel_op_323 + q_acc_0_29*tmp_kernel_op_324 + q_acc_0_9*tmp_kernel_op_325) + src_dof_2*(q_acc_0_12*tmp_kernel_op_132 + q_acc_0_2*tmp_kernel_op_136 + q_acc_0_22*tmp_kernel_op_139) + src_dof_20*(q_acc_0_0*tmp_kernel_op_4 + q_acc_0_10*tmp_kernel_op_5 + q_acc_0_20*tmp_kernel_op_6) + src_dof_21*(q_acc_0_1*tmp_kernel_op_11 + q_acc_0_11*tmp_kernel_op_12 + q_acc_0_21*tmp_kernel_op_13) + src_dof_22*(q_acc_0_12*tmp_kernel_op_18 + q_acc_0_2*tmp_kernel_op_19 + q_acc_0_22*tmp_kernel_op_20) + src_dof_23*(q_acc_0_13*tmp_kernel_op_25 + q_acc_0_23*tmp_kernel_op_26 + q_acc_0_3*tmp_kernel_op_27) + src_dof_24*(q_acc_0_14*tmp_kernel_op_32 + q_acc_0_24*tmp_kernel_op_33 + q_acc_0_4*tmp_kernel_op_34) + src_dof_25*(q_acc_0_15*tmp_kernel_op_39 + q_acc_0_25*tmp_kernel_op_40 + q_acc_0_5*tmp_kernel_op_41) + src_dof_26*(q_acc_0_16*tmp_kernel_op_46 + q_acc_0_26*tmp_kernel_op_47 + q_acc_0_6*tmp_kernel_op_48) + src_dof_27*(q_acc_0_17*tmp_kernel_op_53 + q_acc_0_27*tmp_kernel_op_54 + q_acc_0_7*tmp_kernel_op_55) + src_dof_28*(q_acc_0_18*tmp_kernel_op_60 + q_acc_0_28*tmp_kernel_op_61 + q_acc_0_8*tmp_kernel_op_62) + src_dof_29*(q_acc_0_19*tmp_kernel_op_67 + q_acc_0_29*tmp_kernel_op_68 + q_acc_0_9*tmp_kernel_op_69) + src_dof_3*(q_acc_0_13*tmp_kernel_op_154 + q_acc_0_23*tmp_kernel_op_158 + q_acc_0_3*tmp_kernel_op_161) + src_dof_4*(q_acc_0_14*tmp_kernel_op_176 + q_acc_0_24*tmp_kernel_op_180 + q_acc_0_4*tmp_kernel_op_183) + src_dof_5*(q_acc_0_15*tmp_kernel_op_198 + q_acc_0_25*tmp_kernel_op_202 + q_acc_0_5*tmp_kernel_op_205) + src_dof_6*(q_acc_0_16*tmp_kernel_op_220 + q_acc_0_26*tmp_kernel_op_224 + q_acc_0_6*tmp_kernel_op_227) + src_dof_7*(q_acc_0_17*tmp_kernel_op_242 + q_acc_0_27*tmp_kernel_op_246 + q_acc_0_7*tmp_kernel_op_249) + src_dof_8*(q_acc_0_18*tmp_kernel_op_264 + q_acc_0_28*tmp_kernel_op_268 + q_acc_0_8*tmp_kernel_op_271) + src_dof_9*(q_acc_0_19*tmp_kernel_op_286 + q_acc_0_29*tmp_kernel_op_290 + q_acc_0_9*tmp_kernel_op_293);
             const real_t elMatVec_1 = src_dof_0*(q_acc_1_0*tmp_kernel_op_85 + q_acc_1_10*tmp_kernel_op_88 + q_acc_1_20*tmp_kernel_op_93) + src_dof_1*(q_acc_1_1*tmp_kernel_op_109 + q_acc_1_11*tmp_kernel_op_112 + q_acc_1_21*tmp_kernel_op_117) + src_dof_10*(q_acc_1_0*tmp_kernel_op_295 + q_acc_1_10*tmp_kernel_op_296 + q_acc_1_20*tmp_kernel_op_297) + src_dof_11*(q_acc_1_1*tmp_kernel_op_299 + q_acc_1_11*tmp_kernel_op_300 + q_acc_1_21*tmp_kernel_op_301) + src_dof_12*(q_acc_1_12*tmp_kernel_op_302 + q_acc_1_2*tmp_kernel_op_303 + q_acc_1_22*tmp_kernel_op_304) + src_dof_13*(q_acc_1_13*tmp_kernel_op_305 + q_acc_1_23*tmp_kernel_op_306 + q_acc_1_3*tmp_kernel_op_307) + src_dof_14*(q_acc_1_14*tmp_kernel_op_308 + q_acc_1_24*tmp_kernel_op_309 + q_acc_1_4*tmp_kernel_op_310) + src_dof_15*(q_acc_1_15*tmp_kernel_op_311 + q_acc_1_25*tmp_kernel_op_312 + q_acc_1_5*tmp_kernel_op_313) + src_dof_16*(q_acc_1_16*tmp_kernel_op_314 + q_acc_1_26*tmp_kernel_op_315 + q_acc_1_6*tmp_kernel_op_316) + src_dof_17*(q_acc_1_17*tmp_kernel_op_317 + q_acc_1_27*tmp_kernel_op_318 + q_acc_1_7*tmp_kernel_op_319) + src_dof_18*(q_acc_1_18*tmp_kernel_op_320 + q_acc_1_28*tmp_kernel_op_321 + q_acc_1_8*tmp_kernel_op_322) + src_dof_19*(q_acc_1_19*tmp_kernel_op_323 + q_acc_1_29*tmp_kernel_op_324 + q_acc_1_9*tmp_kernel_op_325) + src_dof_2*(q_acc_1_12*tmp_kernel_op_132 + q_acc_1_2*tmp_kernel_op_136 + q_acc_1_22*tmp_kernel_op_139) + src_dof_20*(q_acc_1_0*tmp_kernel_op_4 + q_acc_1_10*tmp_kernel_op_5 + q_acc_1_20*tmp_kernel_op_6) + src_dof_21*(q_acc_1_1*tmp_kernel_op_11 + q_acc_1_11*tmp_kernel_op_12 + q_acc_1_21*tmp_kernel_op_13) + src_dof_22*(q_acc_1_12*tmp_kernel_op_18 + q_acc_1_2*tmp_kernel_op_19 + q_acc_1_22*tmp_kernel_op_20) + src_dof_23*(q_acc_1_13*tmp_kernel_op_25 + q_acc_1_23*tmp_kernel_op_26 + q_acc_1_3*tmp_kernel_op_27) + src_dof_24*(q_acc_1_14*tmp_kernel_op_32 + q_acc_1_24*tmp_kernel_op_33 + q_acc_1_4*tmp_kernel_op_34) + src_dof_25*(q_acc_1_15*tmp_kernel_op_39 + q_acc_1_25*tmp_kernel_op_40 + q_acc_1_5*tmp_kernel_op_41) + src_dof_26*(q_acc_1_16*tmp_kernel_op_46 + q_acc_1_26*tmp_kernel_op_47 + q_acc_1_6*tmp_kernel_op_48) + src_dof_27*(q_acc_1_17*tmp_kernel_op_53 + q_acc_1_27*tmp_kernel_op_54 + q_acc_1_7*tmp_kernel_op_55) + src_dof_28*(q_acc_1_18*tmp_kernel_op_60 + q_acc_1_28*tmp_kernel_op_61 + q_acc_1_8*tmp_kernel_op_62) + src_dof_29*(q_acc_1_19*tmp_kernel_op_67 + q_acc_1_29*tmp_kernel_op_68 + q_acc_1_9*tmp_kernel_op_69) + src_dof_3*(q_acc_1_13*tmp_kernel_op_154 + q_acc_1_23*tmp_kernel_op_158 + q_acc_1_3*tmp_kernel_op_161) + src_dof_4*(q_acc_1_14*tmp_kernel_op_176 + q_acc_1_24*tmp_kernel_op_180 + q_acc_1_4*tmp_kernel_op_183) + src_dof_5*(q_acc_1_15*tmp_kernel_op_198 + q_acc_1_25*tmp_kernel_op_202 + q_acc_1_5*tmp_kernel_op_205) + src_dof_6*(q_acc_1_16*tmp_kernel_op_220 + q_acc_1_26*tmp_kernel_op_224 + q_acc_1_6*tmp_kernel_op_227) + src_dof_7*(q_acc_1_17*tmp_kernel_op_242 + q_acc_1_27*tmp_kernel_op_246 + q_acc_1_7*tmp_kernel_op_249) + src_dof_8*(q_acc_1_18*tmp_kernel_op_264 + q_acc_1_28*tmp_kernel_op_268 + q_acc_1_8*tmp_kernel_op_271) + src_dof_9*(q_acc_1_19*tmp_kernel_op_286 + q_acc_1_29*tmp_kernel_op_290 + q_acc_1_9*tmp_kernel_op_293);
             const real_t elMatVec_2 = src_dof_0*(q_acc_2_0*tmp_kernel_op_85 + q_acc_2_10*tmp_kernel_op_88 + q_acc_2_20*tmp_kernel_op_93) + src_dof_1*(q_acc_2_1*tmp_kernel_op_109 + q_acc_2_11*tmp_kernel_op_112 + q_acc_2_21*tmp_kernel_op_117) + src_dof_10*(q_acc_2_0*tmp_kernel_op_295 + q_acc_2_10*tmp_kernel_op_296 + q_acc_2_20*tmp_kernel_op_297) + src_dof_11*(q_acc_2_1*tmp_kernel_op_299 + q_acc_2_11*tmp_kernel_op_300 + q_acc_2_21*tmp_kernel_op_301) + src_dof_12*(q_acc_2_12*tmp_kernel_op_302 + q_acc_2_2*tmp_kernel_op_303 + q_acc_2_22*tmp_kernel_op_304) + src_dof_13*(q_acc_2_13*tmp_kernel_op_305 + q_acc_2_23*tmp_kernel_op_306 + q_acc_2_3*tmp_kernel_op_307) + src_dof_14*(q_acc_2_14*tmp_kernel_op_308 + q_acc_2_24*tmp_kernel_op_309 + q_acc_2_4*tmp_kernel_op_310) + src_dof_15*(q_acc_2_15*tmp_kernel_op_311 + q_acc_2_25*tmp_kernel_op_312 + q_acc_2_5*tmp_kernel_op_313) + src_dof_16*(q_acc_2_16*tmp_kernel_op_314 + q_acc_2_26*tmp_kernel_op_315 + q_acc_2_6*tmp_kernel_op_316) + src_dof_17*(q_acc_2_17*tmp_kernel_op_317 + q_acc_2_27*tmp_kernel_op_318 + q_acc_2_7*tmp_kernel_op_319) + src_dof_18*(q_acc_2_18*tmp_kernel_op_320 + q_acc_2_28*tmp_kernel_op_321 + q_acc_2_8*tmp_kernel_op_322) + src_dof_19*(q_acc_2_19*tmp_kernel_op_323 + q_acc_2_29*tmp_kernel_op_324 + q_acc_2_9*tmp_kernel_op_325) + src_dof_2*(q_acc_2_12*tmp_kernel_op_132 + q_acc_2_2*tmp_kernel_op_136 + q_acc_2_22*tmp_kernel_op_139) + src_dof_20*(q_acc_2_0*tmp_kernel_op_4 + q_acc_2_10*tmp_kernel_op_5 + q_acc_2_20*tmp_kernel_op_6) + src_dof_21*(q_acc_2_1*tmp_kernel_op_11 + q_acc_2_11*tmp_kernel_op_12 + q_acc_2_21*tmp_kernel_op_13) + src_dof_22*(q_acc_2_12*tmp_kernel_op_18 + q_acc_2_2*tmp_kernel_op_19 + q_acc_2_22*tmp_kernel_op_20) + src_dof_23*(q_acc_2_13*tmp_kernel_op_25 + q_acc_2_23*tmp_kernel_op_26 + q_acc_2_3*tmp_kernel_op_27) + src_dof_24*(q_acc_2_14*tmp_kernel_op_32 + q_acc_2_24*tmp_kernel_op_33 + q_acc_2_4*tmp_kernel_op_34) + src_dof_25*(q_acc_2_15*tmp_kernel_op_39 + q_acc_2_25*tmp_kernel_op_40 + q_acc_2_5*tmp_kernel_op_41) + src_dof_26*(q_acc_2_16*tmp_kernel_op_46 + q_acc_2_26*tmp_kernel_op_47 + q_acc_2_6*tmp_kernel_op_48) + src_dof_27*(q_acc_2_17*tmp_kernel_op_53 + q_acc_2_27*tmp_kernel_op_54 + q_acc_2_7*tmp_kernel_op_55) + src_dof_28*(q_acc_2_18*tmp_kernel_op_60 + q_acc_2_28*tmp_kernel_op_61 + q_acc_2_8*tmp_kernel_op_62) + src_dof_29*(q_acc_2_19*tmp_kernel_op_67 + q_acc_2_29*tmp_kernel_op_68 + q_acc_2_9*tmp_kernel_op_69) + src_dof_3*(q_acc_2_13*tmp_kernel_op_154 + q_acc_2_23*tmp_kernel_op_158 + q_acc_2_3*tmp_kernel_op_161) + src_dof_4*(q_acc_2_14*tmp_kernel_op_176 + q_acc_2_24*tmp_kernel_op_180 + q_acc_2_4*tmp_kernel_op_183) + src_dof_5*(q_acc_2_15*tmp_kernel_op_198 + q_acc_2_25*tmp_kernel_op_202 + q_acc_2_5*tmp_kernel_op_205) + src_dof_6*(q_acc_2_16*tmp_kernel_op_220 + q_acc_2_26*tmp_kernel_op_224 + q_acc_2_6*tmp_kernel_op_227) + src_dof_7*(q_acc_2_17*tmp_kernel_op_242 + q_acc_2_27*tmp_kernel_op_246 + q_acc_2_7*tmp_kernel_op_249) + src_dof_8*(q_acc_2_18*tmp_kernel_op_264 + q_acc_2_28*tmp_kernel_op_268 + q_acc_2_8*tmp_kernel_op_271) + src_dof_9*(q_acc_2_19*tmp_kernel_op_286 + q_acc_2_29*tmp_kernel_op_290 + q_acc_2_9*tmp_kernel_op_293);
             const real_t elMatVec_3 = src_dof_0*(q_acc_3_0*tmp_kernel_op_85 + q_acc_3_10*tmp_kernel_op_88 + q_acc_3_20*tmp_kernel_op_93) + src_dof_1*(q_acc_3_1*tmp_kernel_op_109 + q_acc_3_11*tmp_kernel_op_112 + q_acc_3_21*tmp_kernel_op_117) + src_dof_10*(q_acc_3_0*tmp_kernel_op_295 + q_acc_3_10*tmp_kernel_op_296 + q_acc_3_20*tmp_kernel_op_297) + src_dof_11*(q_acc_3_1*tmp_kernel_op_299 + q_acc_3_11*tmp_kernel_op_300 + q_acc_3_21*tmp_kernel_op_301) + src_dof_12*(q_acc_3_12*tmp_kernel_op_302 + q_acc_3_2*tmp_kernel_op_303 + q_acc_3_22*tmp_kernel_op_304) + src_dof_13*(q_acc_3_13*tmp_kernel_op_305 + q_acc_3_23*tmp_kernel_op_306 + q_acc_3_3*tmp_kernel_op_307) + src_dof_14*(q_acc_3_14*tmp_kernel_op_308 + q_acc_3_24*tmp_kernel_op_309 + q_acc_3_4*tmp_kernel_op_310) + src_dof_15*(q_acc_3_15*tmp_kernel_op_311 + q_acc_3_25*tmp_kernel_op_312 + q_acc_3_5*tmp_kernel_op_313) + src_dof_16*(q_acc_3_16*tmp_kernel_op_314 + q_acc_3_26*tmp_kernel_op_315 + q_acc_3_6*tmp_kernel_op_316) + src_dof_17*(q_acc_3_17*tmp_kernel_op_317 + q_acc_3_27*tmp_kernel_op_318 + q_acc_3_7*tmp_kernel_op_319) + src_dof_18*(q_acc_3_18*tmp_kernel_op_320 + q_acc_3_28*tmp_kernel_op_321 + q_acc_3_8*tmp_kernel_op_322) + src_dof_19*(q_acc_3_19*tmp_kernel_op_323 + q_acc_3_29*tmp_kernel_op_324 + q_acc_3_9*tmp_kernel_op_325) + src_dof_2*(q_acc_3_12*tmp_kernel_op_132 + q_acc_3_2*tmp_kernel_op_136 + q_acc_3_22*tmp_kernel_op_139) + src_dof_20*(q_acc_3_0*tmp_kernel_op_4 + q_acc_3_10*tmp_kernel_op_5 + q_acc_3_20*tmp_kernel_op_6) + src_dof_21*(q_acc_3_1*tmp_kernel_op_11 + q_acc_3_11*tmp_kernel_op_12 + q_acc_3_21*tmp_kernel_op_13) + src_dof_22*(q_acc_3_12*tmp_kernel_op_18 + q_acc_3_2*tmp_kernel_op_19 + q_acc_3_22*tmp_kernel_op_20) + src_dof_23*(q_acc_3_13*tmp_kernel_op_25 + q_acc_3_23*tmp_kernel_op_26 + q_acc_3_3*tmp_kernel_op_27) + src_dof_24*(q_acc_3_14*tmp_kernel_op_32 + q_acc_3_24*tmp_kernel_op_33 + q_acc_3_4*tmp_kernel_op_34) + src_dof_25*(q_acc_3_15*tmp_kernel_op_39 + q_acc_3_25*tmp_kernel_op_40 + q_acc_3_5*tmp_kernel_op_41) + src_dof_26*(q_acc_3_16*tmp_kernel_op_46 + q_acc_3_26*tmp_kernel_op_47 + q_acc_3_6*tmp_kernel_op_48) + src_dof_27*(q_acc_3_17*tmp_kernel_op_53 + q_acc_3_27*tmp_kernel_op_54 + q_acc_3_7*tmp_kernel_op_55) + src_dof_28*(q_acc_3_18*tmp_kernel_op_60 + q_acc_3_28*tmp_kernel_op_61 + q_acc_3_8*tmp_kernel_op_62) + src_dof_29*(q_acc_3_19*tmp_kernel_op_67 + q_acc_3_29*tmp_kernel_op_68 + q_acc_3_9*tmp_kernel_op_69) + src_dof_3*(q_acc_3_13*tmp_kernel_op_154 + q_acc_3_23*tmp_kernel_op_158 + q_acc_3_3*tmp_kernel_op_161) + src_dof_4*(q_acc_3_14*tmp_kernel_op_176 + q_acc_3_24*tmp_kernel_op_180 + q_acc_3_4*tmp_kernel_op_183) + src_dof_5*(q_acc_3_15*tmp_kernel_op_198 + q_acc_3_25*tmp_kernel_op_202 + q_acc_3_5*tmp_kernel_op_205) + src_dof_6*(q_acc_3_16*tmp_kernel_op_220 + q_acc_3_26*tmp_kernel_op_224 + q_acc_3_6*tmp_kernel_op_227) + src_dof_7*(q_acc_3_17*tmp_kernel_op_242 + q_acc_3_27*tmp_kernel_op_246 + q_acc_3_7*tmp_kernel_op_249) + src_dof_8*(q_acc_3_18*tmp_kernel_op_264 + q_acc_3_28*tmp_kernel_op_268 + q_acc_3_8*tmp_kernel_op_271) + src_dof_9*(q_acc_3_19*tmp_kernel_op_286 + q_acc_3_29*tmp_kernel_op_290 + q_acc_3_9*tmp_kernel_op_293);
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
