/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



























#include "../P2ElementwiseEpsilonIcosahedralShellMap_2_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseEpsilonIcosahedralShellMap_2_2::apply_macro_3D( real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_2 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_3 = -rayVertex_0;
       const real_t tmp_qloop_4 = -forVertex_0 - tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_6 = tmp_qloop_4*tmp_qloop_5;
       const real_t tmp_qloop_7 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_8 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_9 = tmp_qloop_4*tmp_qloop_8;
       const real_t tmp_qloop_10 = -rayVertex_1;
       const real_t tmp_qloop_11 = -forVertex_1 - tmp_qloop_10;
       const real_t tmp_qloop_12 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_13 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_14 = -rayVertex_2;
       const real_t tmp_qloop_15 = -forVertex_2 - tmp_qloop_14;
       const real_t tmp_qloop_16 = tmp_qloop_11*tmp_qloop_5;
       const real_t tmp_qloop_17 = tmp_qloop_12*tmp_qloop_15;
       const real_t tmp_qloop_18 = tmp_qloop_11*tmp_qloop_12*tmp_qloop_7 + tmp_qloop_13*tmp_qloop_15*tmp_qloop_8 - tmp_qloop_13*tmp_qloop_16 - tmp_qloop_17*tmp_qloop_2 + tmp_qloop_2*tmp_qloop_6 - tmp_qloop_7*tmp_qloop_9;
       const real_t tmp_qloop_19 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_29 = tmp_qloop_19*(tmp_qloop_15*tmp_qloop_8 - tmp_qloop_16);
       const real_t tmp_qloop_33 = tmp_qloop_12*tmp_qloop_15 - tmp_qloop_6;
       const real_t tmp_qloop_38 = tmp_qloop_11*tmp_qloop_12 - tmp_qloop_9;
       const real_t tmp_qloop_54 = 1.0 / (tmp_qloop_18*tmp_qloop_18);
       const real_t tmp_qloop_60 = 1.0 / (tmp_qloop_18*tmp_qloop_18*tmp_qloop_18);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q],_data_phi_0_0_WHITE_UP[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1],_data_phi_0_0_WHITE_UP[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2],_data_phi_0_0_WHITE_UP[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3],_data_phi_0_0_WHITE_UP[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4],_data_phi_0_0_WHITE_UP[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5],_data_phi_0_0_WHITE_UP[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6],_data_phi_0_0_WHITE_UP[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7],_data_phi_0_0_WHITE_UP[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8],_data_phi_0_0_WHITE_UP[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9],_data_phi_0_0_WHITE_UP[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*2.0*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_WHITE_UP[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_WHITE_UP*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q],_data_phi_0_0_WHITE_DOWN[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1],_data_phi_0_0_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2],_data_phi_0_0_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3],_data_phi_0_0_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4],_data_phi_0_0_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5],_data_phi_0_0_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6],_data_phi_0_0_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7],_data_phi_0_0_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8],_data_phi_0_0_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9],_data_phi_0_0_WHITE_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_WHITE_DOWN[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_WHITE_DOWN*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q],_data_phi_0_0_BLUE_UP[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1],_data_phi_0_0_BLUE_UP[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2],_data_phi_0_0_BLUE_UP[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3],_data_phi_0_0_BLUE_UP[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4],_data_phi_0_0_BLUE_UP[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5],_data_phi_0_0_BLUE_UP[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6],_data_phi_0_0_BLUE_UP[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7],_data_phi_0_0_BLUE_UP[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8],_data_phi_0_0_BLUE_UP[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9],_data_phi_0_0_BLUE_UP[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*2.0*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_BLUE_UP[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_BLUE_UP*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q],_data_phi_0_0_BLUE_DOWN[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1],_data_phi_0_0_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2],_data_phi_0_0_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3],_data_phi_0_0_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4],_data_phi_0_0_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5],_data_phi_0_0_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6],_data_phi_0_0_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7],_data_phi_0_0_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8],_data_phi_0_0_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9],_data_phi_0_0_BLUE_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_BLUE_DOWN[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_BLUE_DOWN*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q],_data_phi_0_0_GREEN_UP[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1],_data_phi_0_0_GREEN_UP[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2],_data_phi_0_0_GREEN_UP[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3],_data_phi_0_0_GREEN_UP[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4],_data_phi_0_0_GREEN_UP[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5],_data_phi_0_0_GREEN_UP[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6],_data_phi_0_0_GREEN_UP[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7],_data_phi_0_0_GREEN_UP[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8],_data_phi_0_0_GREEN_UP[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9],_data_phi_0_0_GREEN_UP[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*2.0*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_GREEN_UP[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_GREEN_UP*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_4 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_5 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_6 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_7 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_8 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d mu_dof_9 = _mm256_loadu_pd(& _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_1 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3)),_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_16,tmp_qloop_16,tmp_qloop_16,tmp_qloop_16)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_21,_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_4,tmp_qloop_4,tmp_qloop_4,tmp_qloop_4)),_mm256_set_pd(tmp_qloop_5,tmp_qloop_5,tmp_qloop_5,tmp_qloop_5))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)));
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_23);
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_20);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_1,tmp_qloop_26),tmp_qloop_27);
                   const __m256d tmp_qloop_30 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),tmp_qloop_25)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_1,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(tmp_qloop_18,tmp_qloop_18,tmp_qloop_18,tmp_qloop_18)));
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(tmp_qloop_32,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_36);
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_40 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),_mm256_mul_pd(tmp_qloop_20,tmp_qloop_39));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(tmp_qloop_29,tmp_qloop_29,tmp_qloop_29,tmp_qloop_29)),_mm256_mul_pd(tmp_qloop_0,tmp_qloop_39));
                   const __m256d tmp_qloop_42 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_36);
                   const __m256d tmp_qloop_43 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_26,tmp_qloop_39));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_36);
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(tmp_qloop_19,tmp_qloop_19,tmp_qloop_19,tmp_qloop_19)),_mm256_set_pd(tmp_qloop_38,tmp_qloop_38,tmp_qloop_38,tmp_qloop_38)),tmp_qloop_25)),_mm256_mul_pd(tmp_qloop_27,tmp_qloop_39));
                   const __m256d tmp_qloop_53 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_28));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_55);
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_40);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_59 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_28),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_28),tmp_qloop_28),tmp_qloop_28),tmp_qloop_28));
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(tmp_qloop_59,_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60));
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_41),tmp_qloop_61),_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_45);
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_35);
                   const __m256d tmp_qloop_65 = _mm256_mul_pd(tmp_qloop_57,tmp_qloop_64);
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_62),tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_61),tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_40),tmp_qloop_43),tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_43),tmp_qloop_45),tmp_qloop_59),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_41),tmp_qloop_59),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_qloop_60,tmp_qloop_60,tmp_qloop_60,tmp_qloop_60)));
                   const __m256d tmp_qloop_67 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_66);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_68);
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_55,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_70);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_40,tmp_qloop_43),tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_23),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_72);
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_70);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(tmp_qloop_23,tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_35),tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q],_data_phi_0_0_GREEN_DOWN[10*q])),_mm256_mul_pd(_mm256_mul_pd(mu_dof_1,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1],_data_phi_0_0_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_2,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2],_data_phi_0_0_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_3,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3],_data_phi_0_0_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_4,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4],_data_phi_0_0_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_5,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5],_data_phi_0_0_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_6,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6],_data_phi_0_0_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_7,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7],_data_phi_0_0_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_8,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8],_data_phi_0_0_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(_mm256_mul_pd(mu_dof_9,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9],_data_phi_0_0_GREEN_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q]))));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_65,tmp_qloop_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_45),tmp_qloop_70));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_67,_mm256_set_pd(0.5,0.5,0.5,0.5));
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_80,tmp_qloop_81);
                   const __m256d tmp_qloop_83 = _mm256_mul_pd(tmp_qloop_20,tmp_qloop_74);
                   const __m256d tmp_qloop_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_43,tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_84);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_75),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_23),tmp_qloop_40),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_87 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_86);
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_76,tmp_qloop_81);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_72,tmp_qloop_81);
                   const __m256d tmp_qloop_90 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_81);
                   const __m256d tmp_qloop_91 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q])));
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q])));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q]))),tmp_qloop_92));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_56),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_40),tmp_qloop_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_96 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_95);
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_63,tmp_qloop_71),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_40),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_97);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_56,tmp_qloop_64),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_20),tmp_qloop_35),tmp_qloop_41),tmp_qloop_53),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_54,tmp_qloop_54,tmp_qloop_54,tmp_qloop_54)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_81,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q])));
                   const __m256d tmp_qloop_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_89,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_90,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_88,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q])));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q]))),tmp_qloop_102));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_86);
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_84);
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_80);
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_97);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_99);
                   const __m256d tmp_qloop_109 = _mm256_mul_pd(tmp_qloop_68,tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_109,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q]))))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q])))),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q])),_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q],_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q])))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_qloop_66))));
                   const __m256d tmp_qloop_112 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1])));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1]))),tmp_qloop_91);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1]))),tmp_qloop_101);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2])));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2]))),tmp_qloop_91);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2]))),tmp_qloop_101);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3])));
                   const __m256d tmp_qloop_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3]))),tmp_qloop_91);
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3]))),tmp_qloop_101);
                   const __m256d tmp_qloop_121 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4])));
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4]))),tmp_qloop_91);
                   const __m256d tmp_qloop_123 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4]))),tmp_qloop_101);
                   const __m256d tmp_qloop_124 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5])));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5]))),tmp_qloop_91);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5]))),tmp_qloop_101);
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6])));
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6]))),tmp_qloop_91);
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6]))),tmp_qloop_101);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7])));
                   const __m256d tmp_qloop_131 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7]))),tmp_qloop_91);
                   const __m256d tmp_qloop_132 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7]))),tmp_qloop_101);
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8])));
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8]))),tmp_qloop_91);
                   const __m256d tmp_qloop_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8]))),tmp_qloop_101);
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9])));
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9]))),tmp_qloop_91);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9]))),tmp_qloop_101);
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1]))));
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1]))),tmp_qloop_92));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1]))),tmp_qloop_102));
                   const __m256d tmp_qloop_142 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2]))));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2]))),tmp_qloop_92));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2]))),tmp_qloop_102));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3]))));
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3]))),tmp_qloop_92));
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3]))),tmp_qloop_102));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4]))));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4]))),tmp_qloop_92));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4]))),tmp_qloop_102));
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5]))));
                   const __m256d tmp_qloop_152 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5]))),tmp_qloop_92));
                   const __m256d tmp_qloop_153 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5]))),tmp_qloop_102));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6]))));
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6]))),tmp_qloop_92));
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6]))),tmp_qloop_102));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7]))));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7]))),tmp_qloop_92));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7]))),tmp_qloop_102));
                   const __m256d tmp_qloop_160 = _mm256_mul_pd(tmp_qloop_78,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8]))));
                   const __m256d tmp_qloop_161 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8]))),tmp_qloop_92));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_93,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8]))),tmp_qloop_102));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_31,tmp_qloop_32);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_37);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_37,tmp_qloop_40);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_42);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_43);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_40,tmp_qloop_42);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_41,tmp_qloop_44);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_35,tmp_qloop_44);
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_45);
                   const __m256d tmp_qloop_46 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_46),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_48),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_49),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_50),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_52 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_51);
                   const __m256d abs_det_jac_blending = tmp_qloop_51;
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_46));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_49,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_47));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_52,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q])))),_mm256_mul_pd(tmp_qloop_94,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q]))),tmp_qloop_91))),_mm256_mul_pd(tmp_qloop_103,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q],_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q]))),tmp_qloop_101))),tmp_qloop_110));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_114),_mm256_mul_pd(tmp_qloop_112,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_117),_mm256_mul_pd(tmp_qloop_115,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_120),_mm256_mul_pd(tmp_qloop_118,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_123),_mm256_mul_pd(tmp_qloop_121,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_126),_mm256_mul_pd(tmp_qloop_124,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_129),_mm256_mul_pd(tmp_qloop_127,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_132),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_135),_mm256_mul_pd(tmp_qloop_133,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,tmp_qloop_138),_mm256_mul_pd(tmp_qloop_136,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_94)),tmp_qloop_110));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_112,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_113,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_139),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_140)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_141)),tmp_qloop_110));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_116,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_117,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_142),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_143)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_144)),tmp_qloop_110));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_119,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_120,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_145),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_146)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_147)),tmp_qloop_110));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_121,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_123,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_148),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_149)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_150)),tmp_qloop_110));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_125,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_126,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_151),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_152)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153)),tmp_qloop_110));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_127,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_128,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_154),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_155)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_156)),tmp_qloop_110));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_131,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_132,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_157),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_158)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_159)),tmp_qloop_110));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_134,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_135,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_160),_mm256_mul_pd(tmp_qloop_137,tmp_qloop_161)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_162)),tmp_qloop_110));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_111,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_136,tmp_qloop_78),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_73,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9])))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_137,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_87,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9]))),tmp_qloop_92))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_93),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_98,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9])),_mm256_mul_pd(tmp_qloop_96,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9]))),_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9],_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9]))),tmp_qloop_102))),tmp_qloop_110));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_9_9 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_1 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_20 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_21 = -tmp_qloop_14 - tmp_qloop_20;
                   const real_t tmp_qloop_22 = -tmp_qloop_0 - tmp_qloop_3;
                   const real_t tmp_qloop_23 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_24 = -tmp_qloop_10 - tmp_qloop_23;
                   const real_t tmp_qloop_25 = radRayVertex*tmp_qloop_18 - tmp_qloop_19*(tmp_qloop_11*tmp_qloop_12*tmp_qloop_21 + tmp_qloop_15*tmp_qloop_22*tmp_qloop_8 - tmp_qloop_16*tmp_qloop_22 - tmp_qloop_17*tmp_qloop_24 - tmp_qloop_21*tmp_qloop_9 + tmp_qloop_24*tmp_qloop_4*tmp_qloop_5);
                   const real_t tmp_qloop_26 = (tmp_qloop_23*tmp_qloop_23);
                   const real_t tmp_qloop_27 = (tmp_qloop_20*tmp_qloop_20);
                   const real_t tmp_qloop_28 = tmp_qloop_1 + tmp_qloop_26 + tmp_qloop_27;
                   const real_t tmp_qloop_30 = -tmp_qloop_1*tmp_qloop_25 + tmp_qloop_28*(tmp_qloop_0*tmp_qloop_29 + tmp_qloop_25);
                   const real_t tmp_qloop_31 = tmp_qloop_30*1.0;
                   const real_t tmp_qloop_32 = 1.0 / (tmp_qloop_18)*pow(tmp_qloop_28, -1.5000000000000000);
                   const real_t tmp_qloop_34 = tmp_qloop_19*tmp_qloop_28;
                   const real_t tmp_qloop_35 = -tmp_qloop_23*tmp_qloop_25 - tmp_qloop_33*tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_32*1.0;
                   const real_t tmp_qloop_37 = tmp_qloop_0*tmp_qloop_36;
                   const real_t tmp_qloop_39 = -tmp_qloop_25;
                   const real_t tmp_qloop_40 = tmp_qloop_20*tmp_qloop_39 + tmp_qloop_34*tmp_qloop_38;
                   const real_t tmp_qloop_41 = tmp_qloop_0*tmp_qloop_39 + tmp_qloop_28*tmp_qloop_29;
                   const real_t tmp_qloop_42 = tmp_qloop_23*tmp_qloop_36;
                   const real_t tmp_qloop_43 = tmp_qloop_26*tmp_qloop_39 + tmp_qloop_28*(-tmp_qloop_19*tmp_qloop_23*tmp_qloop_33 + tmp_qloop_25);
                   const real_t tmp_qloop_44 = tmp_qloop_20*tmp_qloop_36;
                   const real_t tmp_qloop_45 = tmp_qloop_27*tmp_qloop_39 + tmp_qloop_28*(tmp_qloop_19*tmp_qloop_20*tmp_qloop_38 + tmp_qloop_25);
                   const real_t tmp_qloop_53 = 1.0 / (tmp_qloop_28*tmp_qloop_28*tmp_qloop_28);
                   const real_t tmp_qloop_55 = tmp_qloop_53*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_31*tmp_qloop_55;
                   const real_t tmp_qloop_57 = tmp_qloop_23*tmp_qloop_40;
                   const real_t tmp_qloop_58 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_57;
                   const real_t tmp_qloop_59 = pow(tmp_qloop_28, -4.5000000000000000);
                   const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                   const real_t tmp_qloop_62 = tmp_qloop_0*tmp_qloop_41*tmp_qloop_61*1.0;
                   const real_t tmp_qloop_63 = tmp_qloop_35*tmp_qloop_45;
                   const real_t tmp_qloop_64 = tmp_qloop_20*tmp_qloop_35;
                   const real_t tmp_qloop_65 = tmp_qloop_57*tmp_qloop_64;
                   const real_t tmp_qloop_66 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_41*tmp_qloop_59*tmp_qloop_60*2.0 - tmp_qloop_20*tmp_qloop_40*tmp_qloop_43*tmp_qloop_62 - tmp_qloop_23*tmp_qloop_62*tmp_qloop_63 + tmp_qloop_30*tmp_qloop_43*tmp_qloop_45*tmp_qloop_59*tmp_qloop_60*1.0 - tmp_qloop_31*tmp_qloop_61*tmp_qloop_65;
                   const real_t tmp_qloop_67 = 1.0 / (tmp_qloop_66);
                   const real_t tmp_qloop_68 = tmp_qloop_67*1.0;
                   const real_t tmp_qloop_69 = tmp_qloop_58*tmp_qloop_68;
                   const real_t tmp_qloop_70 = tmp_qloop_55*1.0;
                   const real_t tmp_qloop_71 = tmp_qloop_0*tmp_qloop_70;
                   const real_t tmp_qloop_72 = tmp_qloop_0*tmp_qloop_23*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_40*tmp_qloop_43*tmp_qloop_71;
                   const real_t tmp_qloop_73 = tmp_qloop_68*tmp_qloop_72;
                   const real_t tmp_qloop_74 = tmp_qloop_41*tmp_qloop_70;
                   const real_t tmp_qloop_75 = tmp_qloop_23*tmp_qloop_74;
                   const real_t tmp_qloop_76 = -tmp_qloop_0*tmp_qloop_35*tmp_qloop_75 + tmp_qloop_43*tmp_qloop_56;
                   const real_t tmp_qloop_77 = tmp_qloop_68*tmp_qloop_76;
                   const real_t tmp_qloop_78 = mu_dof_0*2.0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*2.0*_data_phi_0_0_GREEN_DOWN[10*q + 9];
                   const real_t tmp_qloop_79 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q]);
                   const real_t tmp_qloop_80 = tmp_qloop_43*tmp_qloop_45*tmp_qloop_70 - tmp_qloop_65*tmp_qloop_70;
                   const real_t tmp_qloop_81 = tmp_qloop_67*0.5;
                   const real_t tmp_qloop_82 = tmp_qloop_80*tmp_qloop_81;
                   const real_t tmp_qloop_83 = tmp_qloop_20*tmp_qloop_74;
                   const real_t tmp_qloop_84 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_43*tmp_qloop_83;
                   const real_t tmp_qloop_85 = tmp_qloop_81*tmp_qloop_84;
                   const real_t tmp_qloop_86 = tmp_qloop_20*tmp_qloop_23*tmp_qloop_40*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_45*tmp_qloop_75;
                   const real_t tmp_qloop_87 = tmp_qloop_81*tmp_qloop_86;
                   const real_t tmp_qloop_88 = tmp_qloop_76*tmp_qloop_81;
                   const real_t tmp_qloop_89 = tmp_qloop_72*tmp_qloop_81;
                   const real_t tmp_qloop_90 = tmp_qloop_58*tmp_qloop_81;
                   const real_t tmp_qloop_91 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q];
                   const real_t tmp_qloop_92 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q];
                   const real_t tmp_qloop_93 = tmp_qloop_78*2.0;
                   const real_t tmp_qloop_94 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q] + tmp_qloop_92);
                   const real_t tmp_qloop_95 = -tmp_qloop_0*tmp_qloop_40*tmp_qloop_83 + tmp_qloop_45*tmp_qloop_56;
                   const real_t tmp_qloop_96 = tmp_qloop_81*tmp_qloop_95;
                   const real_t tmp_qloop_97 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_40*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_63*tmp_qloop_71;
                   const real_t tmp_qloop_98 = tmp_qloop_81*tmp_qloop_97;
                   const real_t tmp_qloop_99 = tmp_qloop_0*tmp_qloop_20*tmp_qloop_35*tmp_qloop_41*tmp_qloop_53*tmp_qloop_54*1.0 - tmp_qloop_56*tmp_qloop_64;
                   const real_t tmp_qloop_100 = tmp_qloop_81*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_88*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q];
                   const real_t tmp_qloop_102 = tmp_qloop_88*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q] + tmp_qloop_89*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_90*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q];
                   const real_t tmp_qloop_103 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q]);
                   const real_t tmp_qloop_104 = tmp_qloop_68*tmp_qloop_86;
                   const real_t tmp_qloop_105 = tmp_qloop_68*tmp_qloop_84;
                   const real_t tmp_qloop_106 = tmp_qloop_68*tmp_qloop_80;
                   const real_t tmp_qloop_107 = tmp_qloop_68*tmp_qloop_97;
                   const real_t tmp_qloop_108 = tmp_qloop_68*tmp_qloop_99;
                   const real_t tmp_qloop_109 = tmp_qloop_68*tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_78*(tmp_qloop_104*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q])*(tmp_qloop_104*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q] + tmp_qloop_105*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q] + tmp_qloop_106*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q]) + tmp_qloop_78*(tmp_qloop_107*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q])*(tmp_qloop_107*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_108*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q] + tmp_qloop_109*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q]) + tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[q])*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[q] + tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q] + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[q]);
                   const real_t tmp_qloop_111 = abs_det_jac_affine_GREEN_DOWN*abs(tmp_qloop_66)*_data_q_w[q];
                   const real_t tmp_qloop_112 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1];
                   const real_t tmp_qloop_113 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_91;
                   const real_t tmp_qloop_114 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 1] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 1];
                   const real_t tmp_qloop_115 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2];
                   const real_t tmp_qloop_116 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_91;
                   const real_t tmp_qloop_117 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 2] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 2];
                   const real_t tmp_qloop_118 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3];
                   const real_t tmp_qloop_119 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_91;
                   const real_t tmp_qloop_120 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 3] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 3];
                   const real_t tmp_qloop_121 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4];
                   const real_t tmp_qloop_122 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_91;
                   const real_t tmp_qloop_123 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 4] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 4];
                   const real_t tmp_qloop_124 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5];
                   const real_t tmp_qloop_125 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_91;
                   const real_t tmp_qloop_126 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 5] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 5];
                   const real_t tmp_qloop_127 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6];
                   const real_t tmp_qloop_128 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_91;
                   const real_t tmp_qloop_129 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 6] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 6];
                   const real_t tmp_qloop_130 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7];
                   const real_t tmp_qloop_131 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_91;
                   const real_t tmp_qloop_132 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 7] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 7];
                   const real_t tmp_qloop_133 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8];
                   const real_t tmp_qloop_134 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_91;
                   const real_t tmp_qloop_135 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 8] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 8];
                   const real_t tmp_qloop_136 = tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9];
                   const real_t tmp_qloop_137 = tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_91;
                   const real_t tmp_qloop_138 = tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q + 9] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q + 9];
                   const real_t tmp_qloop_139 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1]);
                   const real_t tmp_qloop_140 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_92);
                   const real_t tmp_qloop_141 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 1] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 1] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 1]);
                   const real_t tmp_qloop_142 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2]);
                   const real_t tmp_qloop_143 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_92);
                   const real_t tmp_qloop_144 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 2] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 2] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 2]);
                   const real_t tmp_qloop_145 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3]);
                   const real_t tmp_qloop_146 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_92);
                   const real_t tmp_qloop_147 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 3] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 3] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 3]);
                   const real_t tmp_qloop_148 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4]);
                   const real_t tmp_qloop_149 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_92);
                   const real_t tmp_qloop_150 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 4] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 4] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 4]);
                   const real_t tmp_qloop_151 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5]);
                   const real_t tmp_qloop_152 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_92);
                   const real_t tmp_qloop_153 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 5] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 5] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 5]);
                   const real_t tmp_qloop_154 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6]);
                   const real_t tmp_qloop_155 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_92);
                   const real_t tmp_qloop_156 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 6] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 6] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 6]);
                   const real_t tmp_qloop_157 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7]);
                   const real_t tmp_qloop_158 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_92);
                   const real_t tmp_qloop_159 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 7] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 7] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 7]);
                   const real_t tmp_qloop_160 = tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8]);
                   const real_t tmp_qloop_161 = tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_92);
                   const real_t tmp_qloop_162 = tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 8] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 8] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 8]);
                   const real_t jac_blending_0_0 = tmp_qloop_31*tmp_qloop_32;
                   const real_t jac_blending_0_1 = tmp_qloop_35*tmp_qloop_37;
                   const real_t jac_blending_0_2 = tmp_qloop_37*tmp_qloop_40;
                   const real_t jac_blending_1_0 = tmp_qloop_41*tmp_qloop_42;
                   const real_t jac_blending_1_1 = tmp_qloop_36*tmp_qloop_43;
                   const real_t tmp_qloop_50 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_40*tmp_qloop_42;
                   const real_t tmp_qloop_47 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_41*tmp_qloop_44;
                   const real_t jac_blending_2_1 = tmp_qloop_35*tmp_qloop_44;
                   const real_t tmp_qloop_48 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_36*tmp_qloop_45;
                   const real_t tmp_qloop_46 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_49 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_51 = jac_blending_0_0*tmp_qloop_46 - jac_blending_0_0*tmp_qloop_48 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_49 + jac_blending_2_0*tmp_qloop_47 - jac_blending_2_0*tmp_qloop_50;
                   const real_t tmp_qloop_52 = 1.0 / (tmp_qloop_51);
                   const real_t abs_det_jac_blending = tmp_qloop_51;
                   const real_t jac_blending_inv_0_0 = tmp_qloop_52*(tmp_qloop_46 - tmp_qloop_48);
                   const real_t jac_blending_inv_0_1 = tmp_qloop_52*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_49);
                   const real_t jac_blending_inv_0_2 = tmp_qloop_52*(tmp_qloop_47 - tmp_qloop_50);
                   const real_t jac_blending_inv_1_0 = tmp_qloop_52*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_1 = tmp_qloop_52*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t jac_blending_inv_1_2 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t jac_blending_inv_2_0 = tmp_qloop_52*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_52*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t jac_blending_inv_2_2 = tmp_qloop_52*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t q_tmp_0_0 = tmp_qloop_111*(tmp_qloop_103*(tmp_qloop_100*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q] + tmp_qloop_101 + tmp_qloop_96*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q] + tmp_qloop_98*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q]) + tmp_qloop_110 + tmp_qloop_79*(tmp_qloop_69*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q] + tmp_qloop_73*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q] + tmp_qloop_77*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q]) + tmp_qloop_94*(tmp_qloop_82*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[10*q] + tmp_qloop_85*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[10*q] + tmp_qloop_87*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[10*q] + tmp_qloop_91));
                   const real_t q_tmp_0_1 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_110 + tmp_qloop_112*tmp_qloop_79 + tmp_qloop_113*tmp_qloop_94);
                   const real_t q_tmp_0_2 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_110 + tmp_qloop_115*tmp_qloop_79 + tmp_qloop_116*tmp_qloop_94);
                   const real_t q_tmp_0_3 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_110 + tmp_qloop_118*tmp_qloop_79 + tmp_qloop_119*tmp_qloop_94);
                   const real_t q_tmp_0_4 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_123 + tmp_qloop_110 + tmp_qloop_121*tmp_qloop_79 + tmp_qloop_122*tmp_qloop_94);
                   const real_t q_tmp_0_5 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_126 + tmp_qloop_110 + tmp_qloop_124*tmp_qloop_79 + tmp_qloop_125*tmp_qloop_94);
                   const real_t q_tmp_0_6 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_129 + tmp_qloop_110 + tmp_qloop_127*tmp_qloop_79 + tmp_qloop_128*tmp_qloop_94);
                   const real_t q_tmp_0_7 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_132 + tmp_qloop_110 + tmp_qloop_130*tmp_qloop_79 + tmp_qloop_131*tmp_qloop_94);
                   const real_t q_tmp_0_8 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_135 + tmp_qloop_110 + tmp_qloop_133*tmp_qloop_79 + tmp_qloop_134*tmp_qloop_94);
                   const real_t q_tmp_0_9 = tmp_qloop_111*(tmp_qloop_103*tmp_qloop_138 + tmp_qloop_110 + tmp_qloop_136*tmp_qloop_79 + tmp_qloop_137*tmp_qloop_94);
                   const real_t q_tmp_1_1 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_112*tmp_qloop_139 + tmp_qloop_113*tmp_qloop_140 + tmp_qloop_114*tmp_qloop_141);
                   const real_t q_tmp_1_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_139 + tmp_qloop_116*tmp_qloop_140 + tmp_qloop_117*tmp_qloop_141);
                   const real_t q_tmp_1_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_139 + tmp_qloop_119*tmp_qloop_140 + tmp_qloop_120*tmp_qloop_141);
                   const real_t q_tmp_1_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_139 + tmp_qloop_122*tmp_qloop_140 + tmp_qloop_123*tmp_qloop_141);
                   const real_t q_tmp_1_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_139 + tmp_qloop_125*tmp_qloop_140 + tmp_qloop_126*tmp_qloop_141);
                   const real_t q_tmp_1_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_139 + tmp_qloop_128*tmp_qloop_140 + tmp_qloop_129*tmp_qloop_141);
                   const real_t q_tmp_1_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_139 + tmp_qloop_131*tmp_qloop_140 + tmp_qloop_132*tmp_qloop_141);
                   const real_t q_tmp_1_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_139 + tmp_qloop_134*tmp_qloop_140 + tmp_qloop_135*tmp_qloop_141);
                   const real_t q_tmp_1_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_139 + tmp_qloop_137*tmp_qloop_140 + tmp_qloop_138*tmp_qloop_141);
                   const real_t q_tmp_2_2 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_115*tmp_qloop_142 + tmp_qloop_116*tmp_qloop_143 + tmp_qloop_117*tmp_qloop_144);
                   const real_t q_tmp_2_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_142 + tmp_qloop_119*tmp_qloop_143 + tmp_qloop_120*tmp_qloop_144);
                   const real_t q_tmp_2_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_142 + tmp_qloop_122*tmp_qloop_143 + tmp_qloop_123*tmp_qloop_144);
                   const real_t q_tmp_2_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_142 + tmp_qloop_125*tmp_qloop_143 + tmp_qloop_126*tmp_qloop_144);
                   const real_t q_tmp_2_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_142 + tmp_qloop_128*tmp_qloop_143 + tmp_qloop_129*tmp_qloop_144);
                   const real_t q_tmp_2_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_142 + tmp_qloop_131*tmp_qloop_143 + tmp_qloop_132*tmp_qloop_144);
                   const real_t q_tmp_2_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_142 + tmp_qloop_134*tmp_qloop_143 + tmp_qloop_135*tmp_qloop_144);
                   const real_t q_tmp_2_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_142 + tmp_qloop_137*tmp_qloop_143 + tmp_qloop_138*tmp_qloop_144);
                   const real_t q_tmp_3_3 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_118*tmp_qloop_145 + tmp_qloop_119*tmp_qloop_146 + tmp_qloop_120*tmp_qloop_147);
                   const real_t q_tmp_3_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_145 + tmp_qloop_122*tmp_qloop_146 + tmp_qloop_123*tmp_qloop_147);
                   const real_t q_tmp_3_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_145 + tmp_qloop_125*tmp_qloop_146 + tmp_qloop_126*tmp_qloop_147);
                   const real_t q_tmp_3_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_145 + tmp_qloop_128*tmp_qloop_146 + tmp_qloop_129*tmp_qloop_147);
                   const real_t q_tmp_3_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_145 + tmp_qloop_131*tmp_qloop_146 + tmp_qloop_132*tmp_qloop_147);
                   const real_t q_tmp_3_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_145 + tmp_qloop_134*tmp_qloop_146 + tmp_qloop_135*tmp_qloop_147);
                   const real_t q_tmp_3_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_145 + tmp_qloop_137*tmp_qloop_146 + tmp_qloop_138*tmp_qloop_147);
                   const real_t q_tmp_4_4 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_121*tmp_qloop_148 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_123*tmp_qloop_150);
                   const real_t q_tmp_4_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_148 + tmp_qloop_125*tmp_qloop_149 + tmp_qloop_126*tmp_qloop_150);
                   const real_t q_tmp_4_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_148 + tmp_qloop_128*tmp_qloop_149 + tmp_qloop_129*tmp_qloop_150);
                   const real_t q_tmp_4_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_148 + tmp_qloop_131*tmp_qloop_149 + tmp_qloop_132*tmp_qloop_150);
                   const real_t q_tmp_4_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_148 + tmp_qloop_134*tmp_qloop_149 + tmp_qloop_135*tmp_qloop_150);
                   const real_t q_tmp_4_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_148 + tmp_qloop_137*tmp_qloop_149 + tmp_qloop_138*tmp_qloop_150);
                   const real_t q_tmp_5_5 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_124*tmp_qloop_151 + tmp_qloop_125*tmp_qloop_152 + tmp_qloop_126*tmp_qloop_153);
                   const real_t q_tmp_5_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_151 + tmp_qloop_128*tmp_qloop_152 + tmp_qloop_129*tmp_qloop_153);
                   const real_t q_tmp_5_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_151 + tmp_qloop_131*tmp_qloop_152 + tmp_qloop_132*tmp_qloop_153);
                   const real_t q_tmp_5_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_151 + tmp_qloop_134*tmp_qloop_152 + tmp_qloop_135*tmp_qloop_153);
                   const real_t q_tmp_5_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_151 + tmp_qloop_137*tmp_qloop_152 + tmp_qloop_138*tmp_qloop_153);
                   const real_t q_tmp_6_6 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_127*tmp_qloop_154 + tmp_qloop_128*tmp_qloop_155 + tmp_qloop_129*tmp_qloop_156);
                   const real_t q_tmp_6_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_154 + tmp_qloop_131*tmp_qloop_155 + tmp_qloop_132*tmp_qloop_156);
                   const real_t q_tmp_6_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_154 + tmp_qloop_134*tmp_qloop_155 + tmp_qloop_135*tmp_qloop_156);
                   const real_t q_tmp_6_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_154 + tmp_qloop_137*tmp_qloop_155 + tmp_qloop_138*tmp_qloop_156);
                   const real_t q_tmp_7_7 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_131*tmp_qloop_158 + tmp_qloop_132*tmp_qloop_159);
                   const real_t q_tmp_7_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_157 + tmp_qloop_134*tmp_qloop_158 + tmp_qloop_135*tmp_qloop_159);
                   const real_t q_tmp_7_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_157 + tmp_qloop_137*tmp_qloop_158 + tmp_qloop_138*tmp_qloop_159);
                   const real_t q_tmp_8_8 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_133*tmp_qloop_160 + tmp_qloop_134*tmp_qloop_161 + tmp_qloop_135*tmp_qloop_162);
                   const real_t q_tmp_8_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_160 + tmp_qloop_137*tmp_qloop_161 + tmp_qloop_138*tmp_qloop_162);
                   const real_t q_tmp_9_9 = tmp_qloop_111*(tmp_qloop_110 + tmp_qloop_136*tmp_qloop_78*(tmp_qloop_69*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_73*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9] + tmp_qloop_77*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9]) + tmp_qloop_137*tmp_qloop_93*(tmp_qloop_82*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9] + tmp_qloop_85*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9] + tmp_qloop_87*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_92) + tmp_qloop_138*tmp_qloop_93*(tmp_qloop_100*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[10*q + 9] + tmp_qloop_102 + tmp_qloop_96*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[10*q + 9] + tmp_qloop_98*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[10*q + 9]));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
