/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2VectorElementwiseEpsilonRotationAnnulusMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonRotationAnnulusMap::toMatrix_macro_2D( idx_t * RESTRICT  _data_dst_edge_0, idx_t * RESTRICT  _data_dst_edge_1, idx_t * RESTRICT  _data_dst_vertex_0, idx_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_nxEdge, real_t * RESTRICT  _data_nxVertex, real_t * RESTRICT  _data_nyEdge, real_t * RESTRICT  _data_nyVertex, idx_t * RESTRICT  _data_src_edge_0, idx_t * RESTRICT  _data_src_edge_1, idx_t * RESTRICT  _data_src_vertex_0, idx_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t refVertex_0, real_t refVertex_1, real_t thrVertex_0, real_t thrVertex_1 ) const
{
    {
       const real_t _data_q_w [] = {-0.28125, 0.26041666666666669, 0.26041666666666669, 0.26041666666666669};
   
       const real_t _data_q_p_0 [] = {0.33333333333333331, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001};
   
       const real_t _data_q_p_1 [] = {0.33333333333333331, 0.59999999999999998, 0.20000000000000001, 0.20000000000000001};
   
       {
          /* FaceType.GRAY */
          const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
          const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
          const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
          const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
          const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
          const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
          const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
          const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
          const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
          const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_3 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_8 = -tmp_qloop_7;
                const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
                const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
                const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
                const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_37 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_38 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38 - 3.0;
                const real_t tmp_qloop_40 = jac_affine_inv_0_0_GRAY*tmp_qloop_39 + jac_affine_inv_1_0_GRAY*tmp_qloop_39;
                const real_t tmp_qloop_42 = jac_affine_inv_0_1_GRAY*tmp_qloop_39 + jac_affine_inv_1_1_GRAY*tmp_qloop_39;
                const real_t tmp_qloop_44 = 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_45 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_46 = tmp_qloop_45*2.0;
                const real_t tmp_qloop_47 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_48 = tmp_qloop_47*2.0;
                const real_t tmp_qloop_49 = tmp_qloop_37*_data_q_p_1[q];
                const real_t tmp_qloop_50 = mu_dof_0*(tmp_qloop_46 + tmp_qloop_48 + tmp_qloop_49 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] + 1.0)*2.0 + mu_dof_1*(tmp_qloop_46 - _data_q_p_0[q])*2.0 + mu_dof_2*(tmp_qloop_48 - _data_q_p_1[q])*2.0 + mu_dof_3*tmp_qloop_44*_data_q_p_0[q] + mu_dof_4*(tmp_qloop_38 + tmp_qloop_47*-4.0 - tmp_qloop_49)*2.0 + mu_dof_5*(tmp_qloop_37 + tmp_qloop_45*-4.0 - tmp_qloop_49)*2.0;
                const real_t tmp_qloop_51 = tmp_qloop_50*0.5;
                const real_t tmp_qloop_56 = tmp_qloop_37 - 1.0;
                const real_t tmp_qloop_57 = jac_affine_inv_0_0_GRAY*tmp_qloop_56;
                const real_t tmp_qloop_59 = jac_affine_inv_0_1_GRAY*tmp_qloop_56;
                const real_t tmp_qloop_66 = tmp_qloop_50*2.0;
                const real_t tmp_qloop_68 = tmp_qloop_38 - 1.0;
                const real_t tmp_qloop_69 = jac_affine_inv_1_0_GRAY*tmp_qloop_68;
                const real_t tmp_qloop_71 = jac_affine_inv_1_1_GRAY*tmp_qloop_68;
                const real_t tmp_qloop_77 = jac_affine_inv_1_0_GRAY*tmp_qloop_37;
                const real_t tmp_qloop_78 = jac_affine_inv_0_0_GRAY*tmp_qloop_38;
                const real_t tmp_qloop_79 = tmp_qloop_77 + tmp_qloop_78;
                const real_t tmp_qloop_81 = jac_affine_inv_1_1_GRAY*tmp_qloop_37;
                const real_t tmp_qloop_82 = jac_affine_inv_0_1_GRAY*tmp_qloop_38;
                const real_t tmp_qloop_83 = tmp_qloop_81 + tmp_qloop_82;
                const real_t tmp_qloop_89 = -tmp_qloop_37 - tmp_qloop_44 + 4.0;
                const real_t tmp_qloop_90 = jac_affine_inv_1_0_GRAY*tmp_qloop_89 - tmp_qloop_78;
                const real_t tmp_qloop_92 = jac_affine_inv_1_1_GRAY*tmp_qloop_89 - tmp_qloop_82;
                const real_t tmp_qloop_98 = -tmp_qloop_38 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_99 = jac_affine_inv_0_0_GRAY*tmp_qloop_98 - tmp_qloop_77;
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_GRAY*tmp_qloop_98 - tmp_qloop_81;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_55 = abs_det_jac_affine_GRAY*abs_det_jac_blending*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_52 = jac_blending_inv_0_0*tmp_qloop_40;
                const real_t tmp_qloop_58 = jac_blending_inv_0_0*tmp_qloop_57;
                const real_t tmp_qloop_70 = jac_blending_inv_0_0*tmp_qloop_69;
                const real_t tmp_qloop_80 = jac_blending_inv_0_0*tmp_qloop_79;
                const real_t tmp_qloop_91 = jac_blending_inv_0_0*tmp_qloop_90;
                const real_t tmp_qloop_100 = jac_blending_inv_0_0*tmp_qloop_99;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_41 = jac_blending_inv_0_1*tmp_qloop_40;
                const real_t tmp_qloop_63 = jac_blending_inv_0_1*tmp_qloop_57;
                const real_t tmp_qloop_74 = jac_blending_inv_0_1*tmp_qloop_69;
                const real_t tmp_qloop_86 = jac_blending_inv_0_1*tmp_qloop_79;
                const real_t tmp_qloop_95 = jac_blending_inv_0_1*tmp_qloop_90;
                const real_t tmp_qloop_104 = jac_blending_inv_0_1*tmp_qloop_99;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_53 = jac_blending_inv_1_0*tmp_qloop_42;
                const real_t tmp_qloop_54 = tmp_qloop_52*1.0 + tmp_qloop_53*1.0;
                const real_t tmp_qloop_60 = jac_blending_inv_1_0*tmp_qloop_59;
                const real_t tmp_qloop_61 = tmp_qloop_58*1.0 + tmp_qloop_60*1.0;
                const real_t tmp_qloop_62 = tmp_qloop_50*tmp_qloop_54;
                const real_t tmp_qloop_72 = jac_blending_inv_1_0*tmp_qloop_71;
                const real_t tmp_qloop_73 = tmp_qloop_70*1.0 + tmp_qloop_72*1.0;
                const real_t tmp_qloop_84 = jac_blending_inv_1_0*tmp_qloop_83;
                const real_t tmp_qloop_85 = tmp_qloop_80*1.0 + tmp_qloop_84*1.0;
                const real_t tmp_qloop_93 = jac_blending_inv_1_0*tmp_qloop_92;
                const real_t tmp_qloop_94 = tmp_qloop_91*1.0 + tmp_qloop_93*1.0;
                const real_t tmp_qloop_102 = jac_blending_inv_1_0*tmp_qloop_101;
                const real_t tmp_qloop_103 = tmp_qloop_100*1.0 + tmp_qloop_102*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_52*0.5 + tmp_qloop_53*0.5;
                const real_t tmp_qloop_109 = tmp_qloop_58*0.5 + tmp_qloop_60*0.5;
                const real_t tmp_qloop_110 = tmp_qloop_70*0.5 + tmp_qloop_72*0.5;
                const real_t tmp_qloop_111 = tmp_qloop_80*0.5 + tmp_qloop_84*0.5;
                const real_t tmp_qloop_112 = tmp_qloop_91*0.5 + tmp_qloop_93*0.5;
                const real_t tmp_qloop_113 = tmp_qloop_100*0.5 + tmp_qloop_102*0.5;
                const real_t tmp_qloop_114 = tmp_qloop_50*tmp_qloop_61;
                const real_t tmp_qloop_117 = tmp_qloop_50*tmp_qloop_73;
                const real_t tmp_qloop_120 = tmp_qloop_50*tmp_qloop_85;
                const real_t tmp_qloop_125 = tmp_qloop_107*tmp_qloop_66;
                const real_t tmp_qloop_127 = tmp_qloop_109*tmp_qloop_66;
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_66;
                const real_t tmp_qloop_129 = tmp_qloop_111*tmp_qloop_66;
                const real_t tmp_qloop_130 = tmp_qloop_112*tmp_qloop_66;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_43 = jac_blending_inv_1_1*tmp_qloop_42;
                const real_t tmp_qloop_64 = jac_blending_inv_1_1*tmp_qloop_59;
                const real_t tmp_qloop_65 = tmp_qloop_63*0.5 + tmp_qloop_64*0.5;
                const real_t tmp_qloop_67 = tmp_qloop_66*(tmp_qloop_41*0.5 + tmp_qloop_43*0.5);
                const real_t tmp_qloop_75 = jac_blending_inv_1_1*tmp_qloop_71;
                const real_t tmp_qloop_76 = tmp_qloop_74*0.5 + tmp_qloop_75*0.5;
                const real_t tmp_qloop_87 = jac_blending_inv_1_1*tmp_qloop_83;
                const real_t tmp_qloop_88 = tmp_qloop_86*0.5 + tmp_qloop_87*0.5;
                const real_t tmp_qloop_96 = jac_blending_inv_1_1*tmp_qloop_92;
                const real_t tmp_qloop_97 = tmp_qloop_95*0.5 + tmp_qloop_96*0.5;
                const real_t tmp_qloop_105 = jac_blending_inv_1_1*tmp_qloop_101;
                const real_t tmp_qloop_106 = tmp_qloop_104*0.5 + tmp_qloop_105*0.5;
                const real_t tmp_qloop_108 = tmp_qloop_55*tmp_qloop_67;
                const real_t tmp_qloop_115 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_55;
                const real_t tmp_qloop_118 = tmp_qloop_66*tmp_qloop_76;
                const real_t tmp_qloop_119 = tmp_qloop_118*tmp_qloop_55;
                const real_t tmp_qloop_121 = tmp_qloop_66*tmp_qloop_88;
                const real_t tmp_qloop_122 = tmp_qloop_121*tmp_qloop_55;
                const real_t tmp_qloop_123 = tmp_qloop_66*tmp_qloop_97;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_55;
                const real_t tmp_qloop_126 = tmp_qloop_106*tmp_qloop_55;
                const real_t tmp_qloop_131 = tmp_qloop_41*1.0 + tmp_qloop_43*1.0;
                const real_t tmp_qloop_132 = tmp_qloop_63*1.0 + tmp_qloop_64*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_131*tmp_qloop_50;
                const real_t tmp_qloop_134 = tmp_qloop_74*1.0 + tmp_qloop_75*1.0;
                const real_t tmp_qloop_135 = tmp_qloop_86*1.0 + tmp_qloop_87*1.0;
                const real_t tmp_qloop_136 = tmp_qloop_95*1.0 + tmp_qloop_96*1.0;
                const real_t tmp_qloop_137 = tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                const real_t tmp_qloop_138 = tmp_qloop_132*tmp_qloop_50;
                const real_t tmp_qloop_139 = tmp_qloop_134*tmp_qloop_50;
                const real_t tmp_qloop_140 = tmp_qloop_135*tmp_qloop_50;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_54*tmp_qloop_54) + tmp_qloop_51*((tmp_qloop_41 + tmp_qloop_43)*(tmp_qloop_41 + tmp_qloop_43)));
                const real_t q_tmp_0_1 = tmp_qloop_55*(tmp_qloop_61*tmp_qloop_62 + tmp_qloop_65*tmp_qloop_67);
                const real_t q_tmp_0_2 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_73 + tmp_qloop_67*tmp_qloop_76);
                const real_t q_tmp_0_3 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_85 + tmp_qloop_67*tmp_qloop_88);
                const real_t q_tmp_0_4 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_94 + tmp_qloop_67*tmp_qloop_97);
                const real_t q_tmp_0_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_62 + tmp_qloop_106*tmp_qloop_67);
                const real_t q_tmp_0_6 = tmp_qloop_107*tmp_qloop_108;
                const real_t q_tmp_0_7 = tmp_qloop_108*tmp_qloop_109;
                const real_t q_tmp_0_8 = tmp_qloop_108*tmp_qloop_110;
                const real_t q_tmp_0_9 = tmp_qloop_108*tmp_qloop_111;
                const real_t q_tmp_0_10 = tmp_qloop_108*tmp_qloop_112;
                const real_t q_tmp_0_11 = tmp_qloop_108*tmp_qloop_113;
                const real_t q_tmp_1_1 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_61*tmp_qloop_61) + tmp_qloop_51*((tmp_qloop_63 + tmp_qloop_64)*(tmp_qloop_63 + tmp_qloop_64)));
                const real_t q_tmp_1_2 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_73 + tmp_qloop_115*tmp_qloop_76);
                const real_t q_tmp_1_3 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_85 + tmp_qloop_115*tmp_qloop_88);
                const real_t q_tmp_1_4 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_94 + tmp_qloop_115*tmp_qloop_97);
                const real_t q_tmp_1_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_106*tmp_qloop_115);
                const real_t q_tmp_1_6 = tmp_qloop_107*tmp_qloop_116;
                const real_t q_tmp_1_7 = tmp_qloop_109*tmp_qloop_116;
                const real_t q_tmp_1_8 = tmp_qloop_110*tmp_qloop_116;
                const real_t q_tmp_1_9 = tmp_qloop_111*tmp_qloop_116;
                const real_t q_tmp_1_10 = tmp_qloop_112*tmp_qloop_116;
                const real_t q_tmp_1_11 = tmp_qloop_113*tmp_qloop_116;
                const real_t q_tmp_2_2 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_73*tmp_qloop_73) + tmp_qloop_51*((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75)));
                const real_t q_tmp_2_3 = tmp_qloop_55*(tmp_qloop_117*tmp_qloop_85 + tmp_qloop_118*tmp_qloop_88);
                const real_t q_tmp_2_4 = tmp_qloop_55*(tmp_qloop_117*tmp_qloop_94 + tmp_qloop_118*tmp_qloop_97);
                const real_t q_tmp_2_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_106*tmp_qloop_118);
                const real_t q_tmp_2_6 = tmp_qloop_107*tmp_qloop_119;
                const real_t q_tmp_2_7 = tmp_qloop_109*tmp_qloop_119;
                const real_t q_tmp_2_8 = tmp_qloop_110*tmp_qloop_119;
                const real_t q_tmp_2_9 = tmp_qloop_111*tmp_qloop_119;
                const real_t q_tmp_2_10 = tmp_qloop_112*tmp_qloop_119;
                const real_t q_tmp_2_11 = tmp_qloop_113*tmp_qloop_119;
                const real_t q_tmp_3_3 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_85*tmp_qloop_85) + tmp_qloop_51*((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87)));
                const real_t q_tmp_3_4 = tmp_qloop_55*(tmp_qloop_120*tmp_qloop_94 + tmp_qloop_121*tmp_qloop_97);
                const real_t q_tmp_3_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_106*tmp_qloop_121);
                const real_t q_tmp_3_6 = tmp_qloop_107*tmp_qloop_122;
                const real_t q_tmp_3_7 = tmp_qloop_109*tmp_qloop_122;
                const real_t q_tmp_3_8 = tmp_qloop_110*tmp_qloop_122;
                const real_t q_tmp_3_9 = tmp_qloop_111*tmp_qloop_122;
                const real_t q_tmp_3_10 = tmp_qloop_112*tmp_qloop_122;
                const real_t q_tmp_3_11 = tmp_qloop_113*tmp_qloop_122;
                const real_t q_tmp_4_4 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_94*tmp_qloop_94) + tmp_qloop_51*((tmp_qloop_95 + tmp_qloop_96)*(tmp_qloop_95 + tmp_qloop_96)));
                const real_t q_tmp_4_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_50*tmp_qloop_94 + tmp_qloop_106*tmp_qloop_123);
                const real_t q_tmp_4_6 = tmp_qloop_107*tmp_qloop_124;
                const real_t q_tmp_4_7 = tmp_qloop_109*tmp_qloop_124;
                const real_t q_tmp_4_8 = tmp_qloop_110*tmp_qloop_124;
                const real_t q_tmp_4_9 = tmp_qloop_111*tmp_qloop_124;
                const real_t q_tmp_4_10 = tmp_qloop_112*tmp_qloop_124;
                const real_t q_tmp_4_11 = tmp_qloop_113*tmp_qloop_124;
                const real_t q_tmp_5_5 = tmp_qloop_55*((tmp_qloop_103*tmp_qloop_103)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_104 + tmp_qloop_105)*(tmp_qloop_104 + tmp_qloop_105)));
                const real_t q_tmp_5_6 = tmp_qloop_125*tmp_qloop_126;
                const real_t q_tmp_5_7 = tmp_qloop_126*tmp_qloop_127;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_128;
                const real_t q_tmp_5_9 = tmp_qloop_126*tmp_qloop_129;
                const real_t q_tmp_5_10 = tmp_qloop_126*tmp_qloop_130;
                const real_t q_tmp_5_11 = tmp_qloop_113*tmp_qloop_126*tmp_qloop_66;
                const real_t q_tmp_6_6 = tmp_qloop_55*((tmp_qloop_131*tmp_qloop_131)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_52 + tmp_qloop_53)*(tmp_qloop_52 + tmp_qloop_53)));
                const real_t q_tmp_6_7 = tmp_qloop_55*(tmp_qloop_109*tmp_qloop_125 + tmp_qloop_132*tmp_qloop_133);
                const real_t q_tmp_6_8 = tmp_qloop_55*(tmp_qloop_110*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_134);
                const real_t q_tmp_6_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_135);
                const real_t q_tmp_6_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_136);
                const real_t q_tmp_6_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_137);
                const real_t q_tmp_7_7 = tmp_qloop_55*((tmp_qloop_132*tmp_qloop_132)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_58 + tmp_qloop_60)*(tmp_qloop_58 + tmp_qloop_60)));
                const real_t q_tmp_7_8 = tmp_qloop_55*(tmp_qloop_110*tmp_qloop_127 + tmp_qloop_134*tmp_qloop_138);
                const real_t q_tmp_7_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_127 + tmp_qloop_135*tmp_qloop_138);
                const real_t q_tmp_7_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_127 + tmp_qloop_136*tmp_qloop_138);
                const real_t q_tmp_7_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_127 + tmp_qloop_137*tmp_qloop_138);
                const real_t q_tmp_8_8 = tmp_qloop_55*((tmp_qloop_134*tmp_qloop_134)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_70 + tmp_qloop_72)*(tmp_qloop_70 + tmp_qloop_72)));
                const real_t q_tmp_8_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_128 + tmp_qloop_135*tmp_qloop_139);
                const real_t q_tmp_8_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_128 + tmp_qloop_136*tmp_qloop_139);
                const real_t q_tmp_8_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_128 + tmp_qloop_137*tmp_qloop_139);
                const real_t q_tmp_9_9 = tmp_qloop_55*((tmp_qloop_135*tmp_qloop_135)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_80 + tmp_qloop_84)*(tmp_qloop_80 + tmp_qloop_84)));
                const real_t q_tmp_9_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_129 + tmp_qloop_136*tmp_qloop_140);
                const real_t q_tmp_9_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_129 + tmp_qloop_137*tmp_qloop_140);
                const real_t q_tmp_10_10 = tmp_qloop_55*((tmp_qloop_136*tmp_qloop_136)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_91 + tmp_qloop_93)*(tmp_qloop_91 + tmp_qloop_93)));
                const real_t q_tmp_10_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_130 + tmp_qloop_136*tmp_qloop_137*tmp_qloop_50);
                const real_t q_tmp_11_11 = tmp_qloop_55*((tmp_qloop_137*tmp_qloop_137)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_100 + tmp_qloop_102)*(tmp_qloop_100 + tmp_qloop_102)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_3 = q_acc_0_6*tmp_kernel_op_2 + q_acc_6_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_4 = q_acc_0_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_5 = q_acc_0_0*tmp_kernel_op_2 + tmp_kernel_op_4;
             const bool tmp_kernel_op_6 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_7 = ((tmp_kernel_op_6) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_8 = q_acc_0_7*tmp_kernel_op_2 + q_acc_6_7*tmp_kernel_op_1;
             const real_t tmp_kernel_op_9 = ((tmp_kernel_op_6) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_10 = q_acc_0_1*tmp_kernel_op_2 + q_acc_1_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_11 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_11) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_13 = q_acc_0_8*tmp_kernel_op_2 + q_acc_6_8*tmp_kernel_op_1;
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_11) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_15 = q_acc_0_2*tmp_kernel_op_2 + q_acc_2_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_16 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_16) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_18 = q_acc_0_9*tmp_kernel_op_2 + q_acc_6_9*tmp_kernel_op_1;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_16) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_20 = q_acc_0_3*tmp_kernel_op_2 + q_acc_3_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_21 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_21) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_23 = q_acc_0_10*tmp_kernel_op_2 + q_acc_6_10*tmp_kernel_op_1;
             const real_t tmp_kernel_op_24 = ((tmp_kernel_op_21) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_25 = q_acc_0_4*tmp_kernel_op_2 + q_acc_4_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_26 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_26) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_28 = q_acc_0_11*tmp_kernel_op_2 + q_acc_6_11*tmp_kernel_op_1;
             const real_t tmp_kernel_op_29 = ((tmp_kernel_op_26) ? (-ny_dof_5): (1.0));
             const real_t tmp_kernel_op_30 = q_acc_0_5*tmp_kernel_op_2 + q_acc_5_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_31 = ((tmp_kernel_op_0) ? (ny_dof_0): (1.0));
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_6) ? (ny_dof_1): (1.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_11) ? (ny_dof_2): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_16) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_35 = ((tmp_kernel_op_21) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_36 = ((tmp_kernel_op_26) ? (ny_dof_5): (1.0));
             const real_t tmp_kernel_op_37 = q_acc_1_6*tmp_kernel_op_9 + q_acc_6_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_38 = q_acc_0_1*tmp_kernel_op_9 + q_acc_0_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_39 = q_acc_1_7*tmp_kernel_op_9 + q_acc_7_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_40 = q_acc_1_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_41 = q_acc_1_1*tmp_kernel_op_9 + tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = q_acc_1_8*tmp_kernel_op_9 + q_acc_7_8*tmp_kernel_op_7;
             const real_t tmp_kernel_op_43 = q_acc_1_2*tmp_kernel_op_9 + q_acc_2_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_44 = q_acc_1_9*tmp_kernel_op_9 + q_acc_7_9*tmp_kernel_op_7;
             const real_t tmp_kernel_op_45 = q_acc_1_3*tmp_kernel_op_9 + q_acc_3_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_46 = q_acc_1_10*tmp_kernel_op_9 + q_acc_7_10*tmp_kernel_op_7;
             const real_t tmp_kernel_op_47 = q_acc_1_4*tmp_kernel_op_9 + q_acc_4_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_48 = q_acc_1_11*tmp_kernel_op_9 + q_acc_7_11*tmp_kernel_op_7;
             const real_t tmp_kernel_op_49 = q_acc_1_5*tmp_kernel_op_9 + q_acc_5_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_50 = q_acc_2_6*tmp_kernel_op_14 + q_acc_6_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_51 = q_acc_0_2*tmp_kernel_op_14 + q_acc_0_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_52 = q_acc_2_7*tmp_kernel_op_14 + q_acc_7_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_53 = q_acc_1_2*tmp_kernel_op_14 + q_acc_1_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_54 = q_acc_2_8*tmp_kernel_op_14 + q_acc_8_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_55 = q_acc_2_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_56 = q_acc_2_2*tmp_kernel_op_14 + tmp_kernel_op_55;
             const real_t tmp_kernel_op_57 = q_acc_2_9*tmp_kernel_op_14 + q_acc_8_9*tmp_kernel_op_12;
             const real_t tmp_kernel_op_58 = q_acc_2_3*tmp_kernel_op_14 + q_acc_3_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_59 = q_acc_2_10*tmp_kernel_op_14 + q_acc_8_10*tmp_kernel_op_12;
             const real_t tmp_kernel_op_60 = q_acc_2_4*tmp_kernel_op_14 + q_acc_4_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_61 = q_acc_2_11*tmp_kernel_op_14 + q_acc_8_11*tmp_kernel_op_12;
             const real_t tmp_kernel_op_62 = q_acc_2_5*tmp_kernel_op_14 + q_acc_5_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_63 = q_acc_3_6*tmp_kernel_op_19 + q_acc_6_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_64 = q_acc_0_3*tmp_kernel_op_19 + q_acc_0_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_65 = q_acc_3_7*tmp_kernel_op_19 + q_acc_7_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_66 = q_acc_1_3*tmp_kernel_op_19 + q_acc_1_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_67 = q_acc_3_8*tmp_kernel_op_19 + q_acc_8_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_68 = q_acc_2_3*tmp_kernel_op_19 + q_acc_2_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_69 = q_acc_3_9*tmp_kernel_op_19 + q_acc_9_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_70 = q_acc_3_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_71 = q_acc_3_3*tmp_kernel_op_19 + tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = q_acc_3_10*tmp_kernel_op_19 + q_acc_9_10*tmp_kernel_op_17;
             const real_t tmp_kernel_op_73 = q_acc_3_4*tmp_kernel_op_19 + q_acc_4_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_74 = q_acc_3_11*tmp_kernel_op_19 + q_acc_9_11*tmp_kernel_op_17;
             const real_t tmp_kernel_op_75 = q_acc_3_5*tmp_kernel_op_19 + q_acc_5_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_76 = q_acc_4_6*tmp_kernel_op_24 + q_acc_6_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_77 = q_acc_0_10*tmp_kernel_op_22 + q_acc_0_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_78 = q_acc_4_7*tmp_kernel_op_24 + q_acc_7_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_79 = q_acc_1_10*tmp_kernel_op_22 + q_acc_1_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_80 = q_acc_4_8*tmp_kernel_op_24 + q_acc_8_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_81 = q_acc_2_10*tmp_kernel_op_22 + q_acc_2_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_82 = q_acc_4_9*tmp_kernel_op_24 + q_acc_9_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_83 = q_acc_3_10*tmp_kernel_op_22 + q_acc_3_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_84 = q_acc_10_10*tmp_kernel_op_22 + q_acc_4_10*tmp_kernel_op_24;
             const real_t tmp_kernel_op_85 = q_acc_4_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_86 = q_acc_4_4*tmp_kernel_op_24 + tmp_kernel_op_85;
             const real_t tmp_kernel_op_87 = q_acc_10_11*tmp_kernel_op_22 + q_acc_4_11*tmp_kernel_op_24;
             const real_t tmp_kernel_op_88 = q_acc_4_5*tmp_kernel_op_24 + q_acc_5_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_89 = q_acc_5_6*tmp_kernel_op_29 + q_acc_6_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_90 = q_acc_0_11*tmp_kernel_op_27 + q_acc_0_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_91 = q_acc_5_7*tmp_kernel_op_29 + q_acc_7_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_92 = q_acc_1_11*tmp_kernel_op_27 + q_acc_1_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_93 = q_acc_5_8*tmp_kernel_op_29 + q_acc_8_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_94 = q_acc_2_11*tmp_kernel_op_27 + q_acc_2_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_95 = q_acc_5_9*tmp_kernel_op_29 + q_acc_9_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_96 = q_acc_3_11*tmp_kernel_op_27 + q_acc_3_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_97 = q_acc_10_11*tmp_kernel_op_27 + q_acc_5_10*tmp_kernel_op_29;
             const real_t tmp_kernel_op_98 = q_acc_4_11*tmp_kernel_op_27 + q_acc_4_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_99 = q_acc_11_11*tmp_kernel_op_27 + q_acc_5_11*tmp_kernel_op_29;
             const real_t tmp_kernel_op_100 = q_acc_5_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_101 = q_acc_5_5*tmp_kernel_op_29 + tmp_kernel_op_100;
             const real_t tmp_kernel_op_102 = q_acc_6_6*tmp_kernel_op_31 + tmp_kernel_op_4;
             const real_t tmp_kernel_op_103 = q_acc_0_0*tmp_kernel_op_1 + q_acc_0_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_104 = q_acc_0_7*tmp_kernel_op_1 + q_acc_6_7*tmp_kernel_op_31;
             const real_t tmp_kernel_op_105 = q_acc_0_1*tmp_kernel_op_1 + q_acc_1_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_106 = q_acc_0_8*tmp_kernel_op_1 + q_acc_6_8*tmp_kernel_op_31;
             const real_t tmp_kernel_op_107 = q_acc_0_2*tmp_kernel_op_1 + q_acc_2_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_108 = q_acc_0_9*tmp_kernel_op_1 + q_acc_6_9*tmp_kernel_op_31;
             const real_t tmp_kernel_op_109 = q_acc_0_3*tmp_kernel_op_1 + q_acc_3_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_110 = q_acc_0_10*tmp_kernel_op_1 + q_acc_6_10*tmp_kernel_op_31;
             const real_t tmp_kernel_op_111 = q_acc_0_4*tmp_kernel_op_1 + q_acc_4_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_112 = q_acc_0_11*tmp_kernel_op_1 + q_acc_6_11*tmp_kernel_op_31;
             const real_t tmp_kernel_op_113 = q_acc_0_5*tmp_kernel_op_1 + q_acc_5_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_114 = q_acc_1_6*tmp_kernel_op_7 + q_acc_6_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_115 = q_acc_0_1*tmp_kernel_op_7 + q_acc_0_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_116 = q_acc_7_7*tmp_kernel_op_32 + tmp_kernel_op_40;
             const real_t tmp_kernel_op_117 = q_acc_1_1*tmp_kernel_op_7 + q_acc_1_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_118 = q_acc_1_8*tmp_kernel_op_7 + q_acc_7_8*tmp_kernel_op_32;
             const real_t tmp_kernel_op_119 = q_acc_1_2*tmp_kernel_op_7 + q_acc_2_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_120 = q_acc_1_9*tmp_kernel_op_7 + q_acc_7_9*tmp_kernel_op_32;
             const real_t tmp_kernel_op_121 = q_acc_1_3*tmp_kernel_op_7 + q_acc_3_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_122 = q_acc_1_10*tmp_kernel_op_7 + q_acc_7_10*tmp_kernel_op_32;
             const real_t tmp_kernel_op_123 = q_acc_1_4*tmp_kernel_op_7 + q_acc_4_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_124 = q_acc_1_11*tmp_kernel_op_7 + q_acc_7_11*tmp_kernel_op_32;
             const real_t tmp_kernel_op_125 = q_acc_1_5*tmp_kernel_op_7 + q_acc_5_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_126 = q_acc_2_6*tmp_kernel_op_12 + q_acc_6_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_127 = q_acc_0_2*tmp_kernel_op_12 + q_acc_0_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_128 = q_acc_2_7*tmp_kernel_op_12 + q_acc_7_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_129 = q_acc_1_2*tmp_kernel_op_12 + q_acc_1_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_130 = q_acc_8_8*tmp_kernel_op_33 + tmp_kernel_op_55;
             const real_t tmp_kernel_op_131 = q_acc_2_2*tmp_kernel_op_12 + q_acc_2_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_132 = q_acc_2_9*tmp_kernel_op_12 + q_acc_8_9*tmp_kernel_op_33;
             const real_t tmp_kernel_op_133 = q_acc_2_3*tmp_kernel_op_12 + q_acc_3_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_134 = q_acc_2_10*tmp_kernel_op_12 + q_acc_8_10*tmp_kernel_op_33;
             const real_t tmp_kernel_op_135 = q_acc_2_4*tmp_kernel_op_12 + q_acc_4_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_136 = q_acc_2_11*tmp_kernel_op_12 + q_acc_8_11*tmp_kernel_op_33;
             const real_t tmp_kernel_op_137 = q_acc_2_5*tmp_kernel_op_12 + q_acc_5_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_138 = q_acc_3_6*tmp_kernel_op_17 + q_acc_6_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_139 = q_acc_0_3*tmp_kernel_op_17 + q_acc_0_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_140 = q_acc_3_7*tmp_kernel_op_17 + q_acc_7_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_141 = q_acc_1_3*tmp_kernel_op_17 + q_acc_1_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_142 = q_acc_3_8*tmp_kernel_op_17 + q_acc_8_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_143 = q_acc_2_3*tmp_kernel_op_17 + q_acc_2_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_144 = q_acc_9_9*tmp_kernel_op_34 + tmp_kernel_op_70;
             const real_t tmp_kernel_op_145 = q_acc_3_3*tmp_kernel_op_17 + q_acc_3_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_146 = q_acc_3_10*tmp_kernel_op_17 + q_acc_9_10*tmp_kernel_op_34;
             const real_t tmp_kernel_op_147 = q_acc_3_4*tmp_kernel_op_17 + q_acc_4_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_148 = q_acc_3_11*tmp_kernel_op_17 + q_acc_9_11*tmp_kernel_op_34;
             const real_t tmp_kernel_op_149 = q_acc_3_5*tmp_kernel_op_17 + q_acc_5_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_150 = q_acc_4_6*tmp_kernel_op_22 + q_acc_6_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_151 = q_acc_0_10*tmp_kernel_op_35 + q_acc_0_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_152 = q_acc_4_7*tmp_kernel_op_22 + q_acc_7_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_153 = q_acc_1_10*tmp_kernel_op_35 + q_acc_1_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_154 = q_acc_4_8*tmp_kernel_op_22 + q_acc_8_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_155 = q_acc_2_10*tmp_kernel_op_35 + q_acc_2_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_156 = q_acc_4_9*tmp_kernel_op_22 + q_acc_9_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_157 = q_acc_3_10*tmp_kernel_op_35 + q_acc_3_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_158 = q_acc_10_10*tmp_kernel_op_35 + tmp_kernel_op_85;
             const real_t tmp_kernel_op_159 = q_acc_4_10*tmp_kernel_op_35 + q_acc_4_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_160 = q_acc_10_11*tmp_kernel_op_35 + q_acc_4_11*tmp_kernel_op_22;
             const real_t tmp_kernel_op_161 = q_acc_4_5*tmp_kernel_op_22 + q_acc_5_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_162 = q_acc_5_6*tmp_kernel_op_27 + q_acc_6_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_163 = q_acc_0_11*tmp_kernel_op_36 + q_acc_0_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_164 = q_acc_5_7*tmp_kernel_op_27 + q_acc_7_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_165 = q_acc_1_11*tmp_kernel_op_36 + q_acc_1_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_166 = q_acc_5_8*tmp_kernel_op_27 + q_acc_8_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_167 = q_acc_2_11*tmp_kernel_op_36 + q_acc_2_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_168 = q_acc_5_9*tmp_kernel_op_27 + q_acc_9_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_169 = q_acc_3_11*tmp_kernel_op_36 + q_acc_3_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_170 = q_acc_10_11*tmp_kernel_op_36 + q_acc_5_10*tmp_kernel_op_27;
             const real_t tmp_kernel_op_171 = q_acc_4_11*tmp_kernel_op_36 + q_acc_4_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_172 = q_acc_11_11*tmp_kernel_op_36 + tmp_kernel_op_100;
             const real_t tmp_kernel_op_173 = q_acc_5_11*tmp_kernel_op_36 + q_acc_5_5*tmp_kernel_op_27;
             const real_t elMat_0_0 = tmp_kernel_op_1*tmp_kernel_op_3 + tmp_kernel_op_2*tmp_kernel_op_5;
             const real_t elMat_0_1 = tmp_kernel_op_10*tmp_kernel_op_9 + tmp_kernel_op_7*tmp_kernel_op_8;
             const real_t elMat_0_2 = tmp_kernel_op_12*tmp_kernel_op_13 + tmp_kernel_op_14*tmp_kernel_op_15;
             const real_t elMat_0_3 = tmp_kernel_op_17*tmp_kernel_op_18 + tmp_kernel_op_19*tmp_kernel_op_20;
             const real_t elMat_0_4 = tmp_kernel_op_22*tmp_kernel_op_23 + tmp_kernel_op_24*tmp_kernel_op_25;
             const real_t elMat_0_5 = tmp_kernel_op_27*tmp_kernel_op_28 + tmp_kernel_op_29*tmp_kernel_op_30;
             const real_t elMat_0_6 = tmp_kernel_op_1*tmp_kernel_op_5 + tmp_kernel_op_3*tmp_kernel_op_31;
             const real_t elMat_0_7 = tmp_kernel_op_10*tmp_kernel_op_7 + tmp_kernel_op_32*tmp_kernel_op_8;
             const real_t elMat_0_8 = tmp_kernel_op_12*tmp_kernel_op_15 + tmp_kernel_op_13*tmp_kernel_op_33;
             const real_t elMat_0_9 = tmp_kernel_op_17*tmp_kernel_op_20 + tmp_kernel_op_18*tmp_kernel_op_34;
             const real_t elMat_0_10 = tmp_kernel_op_22*tmp_kernel_op_25 + tmp_kernel_op_23*tmp_kernel_op_35;
             const real_t elMat_0_11 = tmp_kernel_op_27*tmp_kernel_op_30 + tmp_kernel_op_28*tmp_kernel_op_36;
             const real_t elMat_1_0 = tmp_kernel_op_1*tmp_kernel_op_37 + tmp_kernel_op_2*tmp_kernel_op_38;
             const real_t elMat_1_1 = tmp_kernel_op_39*tmp_kernel_op_7 + tmp_kernel_op_41*tmp_kernel_op_9;
             const real_t elMat_1_2 = tmp_kernel_op_12*tmp_kernel_op_42 + tmp_kernel_op_14*tmp_kernel_op_43;
             const real_t elMat_1_3 = tmp_kernel_op_17*tmp_kernel_op_44 + tmp_kernel_op_19*tmp_kernel_op_45;
             const real_t elMat_1_4 = tmp_kernel_op_22*tmp_kernel_op_46 + tmp_kernel_op_24*tmp_kernel_op_47;
             const real_t elMat_1_5 = tmp_kernel_op_27*tmp_kernel_op_48 + tmp_kernel_op_29*tmp_kernel_op_49;
             const real_t elMat_1_6 = tmp_kernel_op_1*tmp_kernel_op_38 + tmp_kernel_op_31*tmp_kernel_op_37;
             const real_t elMat_1_7 = tmp_kernel_op_32*tmp_kernel_op_39 + tmp_kernel_op_41*tmp_kernel_op_7;
             const real_t elMat_1_8 = tmp_kernel_op_12*tmp_kernel_op_43 + tmp_kernel_op_33*tmp_kernel_op_42;
             const real_t elMat_1_9 = tmp_kernel_op_17*tmp_kernel_op_45 + tmp_kernel_op_34*tmp_kernel_op_44;
             const real_t elMat_1_10 = tmp_kernel_op_22*tmp_kernel_op_47 + tmp_kernel_op_35*tmp_kernel_op_46;
             const real_t elMat_1_11 = tmp_kernel_op_27*tmp_kernel_op_49 + tmp_kernel_op_36*tmp_kernel_op_48;
             const real_t elMat_2_0 = tmp_kernel_op_1*tmp_kernel_op_50 + tmp_kernel_op_2*tmp_kernel_op_51;
             const real_t elMat_2_1 = tmp_kernel_op_52*tmp_kernel_op_7 + tmp_kernel_op_53*tmp_kernel_op_9;
             const real_t elMat_2_2 = tmp_kernel_op_12*tmp_kernel_op_54 + tmp_kernel_op_14*tmp_kernel_op_56;
             const real_t elMat_2_3 = tmp_kernel_op_17*tmp_kernel_op_57 + tmp_kernel_op_19*tmp_kernel_op_58;
             const real_t elMat_2_4 = tmp_kernel_op_22*tmp_kernel_op_59 + tmp_kernel_op_24*tmp_kernel_op_60;
             const real_t elMat_2_5 = tmp_kernel_op_27*tmp_kernel_op_61 + tmp_kernel_op_29*tmp_kernel_op_62;
             const real_t elMat_2_6 = tmp_kernel_op_1*tmp_kernel_op_51 + tmp_kernel_op_31*tmp_kernel_op_50;
             const real_t elMat_2_7 = tmp_kernel_op_32*tmp_kernel_op_52 + tmp_kernel_op_53*tmp_kernel_op_7;
             const real_t elMat_2_8 = tmp_kernel_op_12*tmp_kernel_op_56 + tmp_kernel_op_33*tmp_kernel_op_54;
             const real_t elMat_2_9 = tmp_kernel_op_17*tmp_kernel_op_58 + tmp_kernel_op_34*tmp_kernel_op_57;
             const real_t elMat_2_10 = tmp_kernel_op_22*tmp_kernel_op_60 + tmp_kernel_op_35*tmp_kernel_op_59;
             const real_t elMat_2_11 = tmp_kernel_op_27*tmp_kernel_op_62 + tmp_kernel_op_36*tmp_kernel_op_61;
             const real_t elMat_3_0 = tmp_kernel_op_1*tmp_kernel_op_63 + tmp_kernel_op_2*tmp_kernel_op_64;
             const real_t elMat_3_1 = tmp_kernel_op_65*tmp_kernel_op_7 + tmp_kernel_op_66*tmp_kernel_op_9;
             const real_t elMat_3_2 = tmp_kernel_op_12*tmp_kernel_op_67 + tmp_kernel_op_14*tmp_kernel_op_68;
             const real_t elMat_3_3 = tmp_kernel_op_17*tmp_kernel_op_69 + tmp_kernel_op_19*tmp_kernel_op_71;
             const real_t elMat_3_4 = tmp_kernel_op_22*tmp_kernel_op_72 + tmp_kernel_op_24*tmp_kernel_op_73;
             const real_t elMat_3_5 = tmp_kernel_op_27*tmp_kernel_op_74 + tmp_kernel_op_29*tmp_kernel_op_75;
             const real_t elMat_3_6 = tmp_kernel_op_1*tmp_kernel_op_64 + tmp_kernel_op_31*tmp_kernel_op_63;
             const real_t elMat_3_7 = tmp_kernel_op_32*tmp_kernel_op_65 + tmp_kernel_op_66*tmp_kernel_op_7;
             const real_t elMat_3_8 = tmp_kernel_op_12*tmp_kernel_op_68 + tmp_kernel_op_33*tmp_kernel_op_67;
             const real_t elMat_3_9 = tmp_kernel_op_17*tmp_kernel_op_71 + tmp_kernel_op_34*tmp_kernel_op_69;
             const real_t elMat_3_10 = tmp_kernel_op_22*tmp_kernel_op_73 + tmp_kernel_op_35*tmp_kernel_op_72;
             const real_t elMat_3_11 = tmp_kernel_op_27*tmp_kernel_op_75 + tmp_kernel_op_36*tmp_kernel_op_74;
             const real_t elMat_4_0 = tmp_kernel_op_1*tmp_kernel_op_76 + tmp_kernel_op_2*tmp_kernel_op_77;
             const real_t elMat_4_1 = tmp_kernel_op_7*tmp_kernel_op_78 + tmp_kernel_op_79*tmp_kernel_op_9;
             const real_t elMat_4_2 = tmp_kernel_op_12*tmp_kernel_op_80 + tmp_kernel_op_14*tmp_kernel_op_81;
             const real_t elMat_4_3 = tmp_kernel_op_17*tmp_kernel_op_82 + tmp_kernel_op_19*tmp_kernel_op_83;
             const real_t elMat_4_4 = tmp_kernel_op_22*tmp_kernel_op_84 + tmp_kernel_op_24*tmp_kernel_op_86;
             const real_t elMat_4_5 = tmp_kernel_op_27*tmp_kernel_op_87 + tmp_kernel_op_29*tmp_kernel_op_88;
             const real_t elMat_4_6 = tmp_kernel_op_1*tmp_kernel_op_77 + tmp_kernel_op_31*tmp_kernel_op_76;
             const real_t elMat_4_7 = tmp_kernel_op_32*tmp_kernel_op_78 + tmp_kernel_op_7*tmp_kernel_op_79;
             const real_t elMat_4_8 = tmp_kernel_op_12*tmp_kernel_op_81 + tmp_kernel_op_33*tmp_kernel_op_80;
             const real_t elMat_4_9 = tmp_kernel_op_17*tmp_kernel_op_83 + tmp_kernel_op_34*tmp_kernel_op_82;
             const real_t elMat_4_10 = tmp_kernel_op_22*tmp_kernel_op_86 + tmp_kernel_op_35*tmp_kernel_op_84;
             const real_t elMat_4_11 = tmp_kernel_op_27*tmp_kernel_op_88 + tmp_kernel_op_36*tmp_kernel_op_87;
             const real_t elMat_5_0 = tmp_kernel_op_1*tmp_kernel_op_89 + tmp_kernel_op_2*tmp_kernel_op_90;
             const real_t elMat_5_1 = tmp_kernel_op_7*tmp_kernel_op_91 + tmp_kernel_op_9*tmp_kernel_op_92;
             const real_t elMat_5_2 = tmp_kernel_op_12*tmp_kernel_op_93 + tmp_kernel_op_14*tmp_kernel_op_94;
             const real_t elMat_5_3 = tmp_kernel_op_17*tmp_kernel_op_95 + tmp_kernel_op_19*tmp_kernel_op_96;
             const real_t elMat_5_4 = tmp_kernel_op_22*tmp_kernel_op_97 + tmp_kernel_op_24*tmp_kernel_op_98;
             const real_t elMat_5_5 = tmp_kernel_op_101*tmp_kernel_op_29 + tmp_kernel_op_27*tmp_kernel_op_99;
             const real_t elMat_5_6 = tmp_kernel_op_1*tmp_kernel_op_90 + tmp_kernel_op_31*tmp_kernel_op_89;
             const real_t elMat_5_7 = tmp_kernel_op_32*tmp_kernel_op_91 + tmp_kernel_op_7*tmp_kernel_op_92;
             const real_t elMat_5_8 = tmp_kernel_op_12*tmp_kernel_op_94 + tmp_kernel_op_33*tmp_kernel_op_93;
             const real_t elMat_5_9 = tmp_kernel_op_17*tmp_kernel_op_96 + tmp_kernel_op_34*tmp_kernel_op_95;
             const real_t elMat_5_10 = tmp_kernel_op_22*tmp_kernel_op_98 + tmp_kernel_op_35*tmp_kernel_op_97;
             const real_t elMat_5_11 = tmp_kernel_op_101*tmp_kernel_op_27 + tmp_kernel_op_36*tmp_kernel_op_99;
             const real_t elMat_6_0 = tmp_kernel_op_1*tmp_kernel_op_102 + tmp_kernel_op_103*tmp_kernel_op_2;
             const real_t elMat_6_1 = tmp_kernel_op_104*tmp_kernel_op_7 + tmp_kernel_op_105*tmp_kernel_op_9;
             const real_t elMat_6_2 = tmp_kernel_op_106*tmp_kernel_op_12 + tmp_kernel_op_107*tmp_kernel_op_14;
             const real_t elMat_6_3 = tmp_kernel_op_108*tmp_kernel_op_17 + tmp_kernel_op_109*tmp_kernel_op_19;
             const real_t elMat_6_4 = tmp_kernel_op_110*tmp_kernel_op_22 + tmp_kernel_op_111*tmp_kernel_op_24;
             const real_t elMat_6_5 = tmp_kernel_op_112*tmp_kernel_op_27 + tmp_kernel_op_113*tmp_kernel_op_29;
             const real_t elMat_6_6 = tmp_kernel_op_1*tmp_kernel_op_103 + tmp_kernel_op_102*tmp_kernel_op_31;
             const real_t elMat_6_7 = tmp_kernel_op_104*tmp_kernel_op_32 + tmp_kernel_op_105*tmp_kernel_op_7;
             const real_t elMat_6_8 = tmp_kernel_op_106*tmp_kernel_op_33 + tmp_kernel_op_107*tmp_kernel_op_12;
             const real_t elMat_6_9 = tmp_kernel_op_108*tmp_kernel_op_34 + tmp_kernel_op_109*tmp_kernel_op_17;
             const real_t elMat_6_10 = tmp_kernel_op_110*tmp_kernel_op_35 + tmp_kernel_op_111*tmp_kernel_op_22;
             const real_t elMat_6_11 = tmp_kernel_op_112*tmp_kernel_op_36 + tmp_kernel_op_113*tmp_kernel_op_27;
             const real_t elMat_7_0 = tmp_kernel_op_1*tmp_kernel_op_114 + tmp_kernel_op_115*tmp_kernel_op_2;
             const real_t elMat_7_1 = tmp_kernel_op_116*tmp_kernel_op_7 + tmp_kernel_op_117*tmp_kernel_op_9;
             const real_t elMat_7_2 = tmp_kernel_op_118*tmp_kernel_op_12 + tmp_kernel_op_119*tmp_kernel_op_14;
             const real_t elMat_7_3 = tmp_kernel_op_120*tmp_kernel_op_17 + tmp_kernel_op_121*tmp_kernel_op_19;
             const real_t elMat_7_4 = tmp_kernel_op_122*tmp_kernel_op_22 + tmp_kernel_op_123*tmp_kernel_op_24;
             const real_t elMat_7_5 = tmp_kernel_op_124*tmp_kernel_op_27 + tmp_kernel_op_125*tmp_kernel_op_29;
             const real_t elMat_7_6 = tmp_kernel_op_1*tmp_kernel_op_115 + tmp_kernel_op_114*tmp_kernel_op_31;
             const real_t elMat_7_7 = tmp_kernel_op_116*tmp_kernel_op_32 + tmp_kernel_op_117*tmp_kernel_op_7;
             const real_t elMat_7_8 = tmp_kernel_op_118*tmp_kernel_op_33 + tmp_kernel_op_119*tmp_kernel_op_12;
             const real_t elMat_7_9 = tmp_kernel_op_120*tmp_kernel_op_34 + tmp_kernel_op_121*tmp_kernel_op_17;
             const real_t elMat_7_10 = tmp_kernel_op_122*tmp_kernel_op_35 + tmp_kernel_op_123*tmp_kernel_op_22;
             const real_t elMat_7_11 = tmp_kernel_op_124*tmp_kernel_op_36 + tmp_kernel_op_125*tmp_kernel_op_27;
             const real_t elMat_8_0 = tmp_kernel_op_1*tmp_kernel_op_126 + tmp_kernel_op_127*tmp_kernel_op_2;
             const real_t elMat_8_1 = tmp_kernel_op_128*tmp_kernel_op_7 + tmp_kernel_op_129*tmp_kernel_op_9;
             const real_t elMat_8_2 = tmp_kernel_op_12*tmp_kernel_op_130 + tmp_kernel_op_131*tmp_kernel_op_14;
             const real_t elMat_8_3 = tmp_kernel_op_132*tmp_kernel_op_17 + tmp_kernel_op_133*tmp_kernel_op_19;
             const real_t elMat_8_4 = tmp_kernel_op_134*tmp_kernel_op_22 + tmp_kernel_op_135*tmp_kernel_op_24;
             const real_t elMat_8_5 = tmp_kernel_op_136*tmp_kernel_op_27 + tmp_kernel_op_137*tmp_kernel_op_29;
             const real_t elMat_8_6 = tmp_kernel_op_1*tmp_kernel_op_127 + tmp_kernel_op_126*tmp_kernel_op_31;
             const real_t elMat_8_7 = tmp_kernel_op_128*tmp_kernel_op_32 + tmp_kernel_op_129*tmp_kernel_op_7;
             const real_t elMat_8_8 = tmp_kernel_op_12*tmp_kernel_op_131 + tmp_kernel_op_130*tmp_kernel_op_33;
             const real_t elMat_8_9 = tmp_kernel_op_132*tmp_kernel_op_34 + tmp_kernel_op_133*tmp_kernel_op_17;
             const real_t elMat_8_10 = tmp_kernel_op_134*tmp_kernel_op_35 + tmp_kernel_op_135*tmp_kernel_op_22;
             const real_t elMat_8_11 = tmp_kernel_op_136*tmp_kernel_op_36 + tmp_kernel_op_137*tmp_kernel_op_27;
             const real_t elMat_9_0 = tmp_kernel_op_1*tmp_kernel_op_138 + tmp_kernel_op_139*tmp_kernel_op_2;
             const real_t elMat_9_1 = tmp_kernel_op_140*tmp_kernel_op_7 + tmp_kernel_op_141*tmp_kernel_op_9;
             const real_t elMat_9_2 = tmp_kernel_op_12*tmp_kernel_op_142 + tmp_kernel_op_14*tmp_kernel_op_143;
             const real_t elMat_9_3 = tmp_kernel_op_144*tmp_kernel_op_17 + tmp_kernel_op_145*tmp_kernel_op_19;
             const real_t elMat_9_4 = tmp_kernel_op_146*tmp_kernel_op_22 + tmp_kernel_op_147*tmp_kernel_op_24;
             const real_t elMat_9_5 = tmp_kernel_op_148*tmp_kernel_op_27 + tmp_kernel_op_149*tmp_kernel_op_29;
             const real_t elMat_9_6 = tmp_kernel_op_1*tmp_kernel_op_139 + tmp_kernel_op_138*tmp_kernel_op_31;
             const real_t elMat_9_7 = tmp_kernel_op_140*tmp_kernel_op_32 + tmp_kernel_op_141*tmp_kernel_op_7;
             const real_t elMat_9_8 = tmp_kernel_op_12*tmp_kernel_op_143 + tmp_kernel_op_142*tmp_kernel_op_33;
             const real_t elMat_9_9 = tmp_kernel_op_144*tmp_kernel_op_34 + tmp_kernel_op_145*tmp_kernel_op_17;
             const real_t elMat_9_10 = tmp_kernel_op_146*tmp_kernel_op_35 + tmp_kernel_op_147*tmp_kernel_op_22;
             const real_t elMat_9_11 = tmp_kernel_op_148*tmp_kernel_op_36 + tmp_kernel_op_149*tmp_kernel_op_27;
             const real_t elMat_10_0 = tmp_kernel_op_1*tmp_kernel_op_150 + tmp_kernel_op_151*tmp_kernel_op_2;
             const real_t elMat_10_1 = tmp_kernel_op_152*tmp_kernel_op_7 + tmp_kernel_op_153*tmp_kernel_op_9;
             const real_t elMat_10_2 = tmp_kernel_op_12*tmp_kernel_op_154 + tmp_kernel_op_14*tmp_kernel_op_155;
             const real_t elMat_10_3 = tmp_kernel_op_156*tmp_kernel_op_17 + tmp_kernel_op_157*tmp_kernel_op_19;
             const real_t elMat_10_4 = tmp_kernel_op_158*tmp_kernel_op_22 + tmp_kernel_op_159*tmp_kernel_op_24;
             const real_t elMat_10_5 = tmp_kernel_op_160*tmp_kernel_op_27 + tmp_kernel_op_161*tmp_kernel_op_29;
             const real_t elMat_10_6 = tmp_kernel_op_1*tmp_kernel_op_151 + tmp_kernel_op_150*tmp_kernel_op_31;
             const real_t elMat_10_7 = tmp_kernel_op_152*tmp_kernel_op_32 + tmp_kernel_op_153*tmp_kernel_op_7;
             const real_t elMat_10_8 = tmp_kernel_op_12*tmp_kernel_op_155 + tmp_kernel_op_154*tmp_kernel_op_33;
             const real_t elMat_10_9 = tmp_kernel_op_156*tmp_kernel_op_34 + tmp_kernel_op_157*tmp_kernel_op_17;
             const real_t elMat_10_10 = tmp_kernel_op_158*tmp_kernel_op_35 + tmp_kernel_op_159*tmp_kernel_op_22;
             const real_t elMat_10_11 = tmp_kernel_op_160*tmp_kernel_op_36 + tmp_kernel_op_161*tmp_kernel_op_27;
             const real_t elMat_11_0 = tmp_kernel_op_1*tmp_kernel_op_162 + tmp_kernel_op_163*tmp_kernel_op_2;
             const real_t elMat_11_1 = tmp_kernel_op_164*tmp_kernel_op_7 + tmp_kernel_op_165*tmp_kernel_op_9;
             const real_t elMat_11_2 = tmp_kernel_op_12*tmp_kernel_op_166 + tmp_kernel_op_14*tmp_kernel_op_167;
             const real_t elMat_11_3 = tmp_kernel_op_168*tmp_kernel_op_17 + tmp_kernel_op_169*tmp_kernel_op_19;
             const real_t elMat_11_4 = tmp_kernel_op_170*tmp_kernel_op_22 + tmp_kernel_op_171*tmp_kernel_op_24;
             const real_t elMat_11_5 = tmp_kernel_op_172*tmp_kernel_op_27 + tmp_kernel_op_173*tmp_kernel_op_29;
             const real_t elMat_11_6 = tmp_kernel_op_1*tmp_kernel_op_163 + tmp_kernel_op_162*tmp_kernel_op_31;
             const real_t elMat_11_7 = tmp_kernel_op_164*tmp_kernel_op_32 + tmp_kernel_op_165*tmp_kernel_op_7;
             const real_t elMat_11_8 = tmp_kernel_op_12*tmp_kernel_op_167 + tmp_kernel_op_166*tmp_kernel_op_33;
             const real_t elMat_11_9 = tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_17;
             const real_t elMat_11_10 = tmp_kernel_op_170*tmp_kernel_op_35 + tmp_kernel_op_171*tmp_kernel_op_22;
             const real_t elMat_11_11 = tmp_kernel_op_172*tmp_kernel_op_36 + tmp_kernel_op_173*tmp_kernel_op_27;
         
             std::vector< uint_t > _data_rowIdx( 12 );
             std::vector< uint_t > _data_colIdx( 12 );
             std::vector< real_t > _data_mat( 144 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[3] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[11] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_1_0));
             _data_mat[13] = ((real_t)(elMat_1_1));
             _data_mat[14] = ((real_t)(elMat_1_2));
             _data_mat[15] = ((real_t)(elMat_1_3));
             _data_mat[16] = ((real_t)(elMat_1_4));
             _data_mat[17] = ((real_t)(elMat_1_5));
             _data_mat[18] = ((real_t)(elMat_1_6));
             _data_mat[19] = ((real_t)(elMat_1_7));
             _data_mat[20] = ((real_t)(elMat_1_8));
             _data_mat[21] = ((real_t)(elMat_1_9));
             _data_mat[22] = ((real_t)(elMat_1_10));
             _data_mat[23] = ((real_t)(elMat_1_11));
             _data_mat[24] = ((real_t)(elMat_2_0));
             _data_mat[25] = ((real_t)(elMat_2_1));
             _data_mat[26] = ((real_t)(elMat_2_2));
             _data_mat[27] = ((real_t)(elMat_2_3));
             _data_mat[28] = ((real_t)(elMat_2_4));
             _data_mat[29] = ((real_t)(elMat_2_5));
             _data_mat[30] = ((real_t)(elMat_2_6));
             _data_mat[31] = ((real_t)(elMat_2_7));
             _data_mat[32] = ((real_t)(elMat_2_8));
             _data_mat[33] = ((real_t)(elMat_2_9));
             _data_mat[34] = ((real_t)(elMat_2_10));
             _data_mat[35] = ((real_t)(elMat_2_11));
             _data_mat[36] = ((real_t)(elMat_3_0));
             _data_mat[37] = ((real_t)(elMat_3_1));
             _data_mat[38] = ((real_t)(elMat_3_2));
             _data_mat[39] = ((real_t)(elMat_3_3));
             _data_mat[40] = ((real_t)(elMat_3_4));
             _data_mat[41] = ((real_t)(elMat_3_5));
             _data_mat[42] = ((real_t)(elMat_3_6));
             _data_mat[43] = ((real_t)(elMat_3_7));
             _data_mat[44] = ((real_t)(elMat_3_8));
             _data_mat[45] = ((real_t)(elMat_3_9));
             _data_mat[46] = ((real_t)(elMat_3_10));
             _data_mat[47] = ((real_t)(elMat_3_11));
             _data_mat[48] = ((real_t)(elMat_4_0));
             _data_mat[49] = ((real_t)(elMat_4_1));
             _data_mat[50] = ((real_t)(elMat_4_2));
             _data_mat[51] = ((real_t)(elMat_4_3));
             _data_mat[52] = ((real_t)(elMat_4_4));
             _data_mat[53] = ((real_t)(elMat_4_5));
             _data_mat[54] = ((real_t)(elMat_4_6));
             _data_mat[55] = ((real_t)(elMat_4_7));
             _data_mat[56] = ((real_t)(elMat_4_8));
             _data_mat[57] = ((real_t)(elMat_4_9));
             _data_mat[58] = ((real_t)(elMat_4_10));
             _data_mat[59] = ((real_t)(elMat_4_11));
             _data_mat[60] = ((real_t)(elMat_5_0));
             _data_mat[61] = ((real_t)(elMat_5_1));
             _data_mat[62] = ((real_t)(elMat_5_2));
             _data_mat[63] = ((real_t)(elMat_5_3));
             _data_mat[64] = ((real_t)(elMat_5_4));
             _data_mat[65] = ((real_t)(elMat_5_5));
             _data_mat[66] = ((real_t)(elMat_5_6));
             _data_mat[67] = ((real_t)(elMat_5_7));
             _data_mat[68] = ((real_t)(elMat_5_8));
             _data_mat[69] = ((real_t)(elMat_5_9));
             _data_mat[70] = ((real_t)(elMat_5_10));
             _data_mat[71] = ((real_t)(elMat_5_11));
             _data_mat[72] = ((real_t)(elMat_6_0));
             _data_mat[73] = ((real_t)(elMat_6_1));
             _data_mat[74] = ((real_t)(elMat_6_2));
             _data_mat[75] = ((real_t)(elMat_6_3));
             _data_mat[76] = ((real_t)(elMat_6_4));
             _data_mat[77] = ((real_t)(elMat_6_5));
             _data_mat[78] = ((real_t)(elMat_6_6));
             _data_mat[79] = ((real_t)(elMat_6_7));
             _data_mat[80] = ((real_t)(elMat_6_8));
             _data_mat[81] = ((real_t)(elMat_6_9));
             _data_mat[82] = ((real_t)(elMat_6_10));
             _data_mat[83] = ((real_t)(elMat_6_11));
             _data_mat[84] = ((real_t)(elMat_7_0));
             _data_mat[85] = ((real_t)(elMat_7_1));
             _data_mat[86] = ((real_t)(elMat_7_2));
             _data_mat[87] = ((real_t)(elMat_7_3));
             _data_mat[88] = ((real_t)(elMat_7_4));
             _data_mat[89] = ((real_t)(elMat_7_5));
             _data_mat[90] = ((real_t)(elMat_7_6));
             _data_mat[91] = ((real_t)(elMat_7_7));
             _data_mat[92] = ((real_t)(elMat_7_8));
             _data_mat[93] = ((real_t)(elMat_7_9));
             _data_mat[94] = ((real_t)(elMat_7_10));
             _data_mat[95] = ((real_t)(elMat_7_11));
             _data_mat[96] = ((real_t)(elMat_8_0));
             _data_mat[97] = ((real_t)(elMat_8_1));
             _data_mat[98] = ((real_t)(elMat_8_2));
             _data_mat[99] = ((real_t)(elMat_8_3));
             _data_mat[100] = ((real_t)(elMat_8_4));
             _data_mat[101] = ((real_t)(elMat_8_5));
             _data_mat[102] = ((real_t)(elMat_8_6));
             _data_mat[103] = ((real_t)(elMat_8_7));
             _data_mat[104] = ((real_t)(elMat_8_8));
             _data_mat[105] = ((real_t)(elMat_8_9));
             _data_mat[106] = ((real_t)(elMat_8_10));
             _data_mat[107] = ((real_t)(elMat_8_11));
             _data_mat[108] = ((real_t)(elMat_9_0));
             _data_mat[109] = ((real_t)(elMat_9_1));
             _data_mat[110] = ((real_t)(elMat_9_2));
             _data_mat[111] = ((real_t)(elMat_9_3));
             _data_mat[112] = ((real_t)(elMat_9_4));
             _data_mat[113] = ((real_t)(elMat_9_5));
             _data_mat[114] = ((real_t)(elMat_9_6));
             _data_mat[115] = ((real_t)(elMat_9_7));
             _data_mat[116] = ((real_t)(elMat_9_8));
             _data_mat[117] = ((real_t)(elMat_9_9));
             _data_mat[118] = ((real_t)(elMat_9_10));
             _data_mat[119] = ((real_t)(elMat_9_11));
             _data_mat[120] = ((real_t)(elMat_10_0));
             _data_mat[121] = ((real_t)(elMat_10_1));
             _data_mat[122] = ((real_t)(elMat_10_2));
             _data_mat[123] = ((real_t)(elMat_10_3));
             _data_mat[124] = ((real_t)(elMat_10_4));
             _data_mat[125] = ((real_t)(elMat_10_5));
             _data_mat[126] = ((real_t)(elMat_10_6));
             _data_mat[127] = ((real_t)(elMat_10_7));
             _data_mat[128] = ((real_t)(elMat_10_8));
             _data_mat[129] = ((real_t)(elMat_10_9));
             _data_mat[130] = ((real_t)(elMat_10_10));
             _data_mat[131] = ((real_t)(elMat_10_11));
             _data_mat[132] = ((real_t)(elMat_11_0));
             _data_mat[133] = ((real_t)(elMat_11_1));
             _data_mat[134] = ((real_t)(elMat_11_2));
             _data_mat[135] = ((real_t)(elMat_11_3));
             _data_mat[136] = ((real_t)(elMat_11_4));
             _data_mat[137] = ((real_t)(elMat_11_5));
             _data_mat[138] = ((real_t)(elMat_11_6));
             _data_mat[139] = ((real_t)(elMat_11_7));
             _data_mat[140] = ((real_t)(elMat_11_8));
             _data_mat[141] = ((real_t)(elMat_11_9));
             _data_mat[142] = ((real_t)(elMat_11_10));
             _data_mat[143] = ((real_t)(elMat_11_11));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* FaceType.BLUE */
          const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
          const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
          const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
          const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
          const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
          const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
          const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
          const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
          const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
          const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
          const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
          const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
          const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t mu_dof_3 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t nx_dof_3 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ny_dof_3 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_8 = -tmp_qloop_7;
                const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
                const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
                const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
                const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_37 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_38 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38 - 3.0;
                const real_t tmp_qloop_40 = jac_affine_inv_0_0_BLUE*tmp_qloop_39 + jac_affine_inv_1_0_BLUE*tmp_qloop_39;
                const real_t tmp_qloop_42 = jac_affine_inv_0_1_BLUE*tmp_qloop_39 + jac_affine_inv_1_1_BLUE*tmp_qloop_39;
                const real_t tmp_qloop_44 = 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_45 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_46 = tmp_qloop_45*2.0;
                const real_t tmp_qloop_47 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_48 = tmp_qloop_47*2.0;
                const real_t tmp_qloop_49 = tmp_qloop_37*_data_q_p_1[q];
                const real_t tmp_qloop_50 = mu_dof_0*(tmp_qloop_46 + tmp_qloop_48 + tmp_qloop_49 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] + 1.0)*2.0 + mu_dof_1*(tmp_qloop_46 - _data_q_p_0[q])*2.0 + mu_dof_2*(tmp_qloop_48 - _data_q_p_1[q])*2.0 + mu_dof_3*tmp_qloop_44*_data_q_p_0[q] + mu_dof_4*(tmp_qloop_38 + tmp_qloop_47*-4.0 - tmp_qloop_49)*2.0 + mu_dof_5*(tmp_qloop_37 + tmp_qloop_45*-4.0 - tmp_qloop_49)*2.0;
                const real_t tmp_qloop_51 = tmp_qloop_50*0.5;
                const real_t tmp_qloop_56 = tmp_qloop_37 - 1.0;
                const real_t tmp_qloop_57 = jac_affine_inv_0_0_BLUE*tmp_qloop_56;
                const real_t tmp_qloop_59 = jac_affine_inv_0_1_BLUE*tmp_qloop_56;
                const real_t tmp_qloop_66 = tmp_qloop_50*2.0;
                const real_t tmp_qloop_68 = tmp_qloop_38 - 1.0;
                const real_t tmp_qloop_69 = jac_affine_inv_1_0_BLUE*tmp_qloop_68;
                const real_t tmp_qloop_71 = jac_affine_inv_1_1_BLUE*tmp_qloop_68;
                const real_t tmp_qloop_77 = jac_affine_inv_1_0_BLUE*tmp_qloop_37;
                const real_t tmp_qloop_78 = jac_affine_inv_0_0_BLUE*tmp_qloop_38;
                const real_t tmp_qloop_79 = tmp_qloop_77 + tmp_qloop_78;
                const real_t tmp_qloop_81 = jac_affine_inv_1_1_BLUE*tmp_qloop_37;
                const real_t tmp_qloop_82 = jac_affine_inv_0_1_BLUE*tmp_qloop_38;
                const real_t tmp_qloop_83 = tmp_qloop_81 + tmp_qloop_82;
                const real_t tmp_qloop_89 = -tmp_qloop_37 - tmp_qloop_44 + 4.0;
                const real_t tmp_qloop_90 = jac_affine_inv_1_0_BLUE*tmp_qloop_89 - tmp_qloop_78;
                const real_t tmp_qloop_92 = jac_affine_inv_1_1_BLUE*tmp_qloop_89 - tmp_qloop_82;
                const real_t tmp_qloop_98 = -tmp_qloop_38 - 8.0*_data_q_p_0[q] + 4.0;
                const real_t tmp_qloop_99 = jac_affine_inv_0_0_BLUE*tmp_qloop_98 - tmp_qloop_77;
                const real_t tmp_qloop_101 = jac_affine_inv_0_1_BLUE*tmp_qloop_98 - tmp_qloop_81;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_55 = abs_det_jac_affine_BLUE*abs_det_jac_blending*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_52 = jac_blending_inv_0_0*tmp_qloop_40;
                const real_t tmp_qloop_58 = jac_blending_inv_0_0*tmp_qloop_57;
                const real_t tmp_qloop_70 = jac_blending_inv_0_0*tmp_qloop_69;
                const real_t tmp_qloop_80 = jac_blending_inv_0_0*tmp_qloop_79;
                const real_t tmp_qloop_91 = jac_blending_inv_0_0*tmp_qloop_90;
                const real_t tmp_qloop_100 = jac_blending_inv_0_0*tmp_qloop_99;
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_41 = jac_blending_inv_0_1*tmp_qloop_40;
                const real_t tmp_qloop_63 = jac_blending_inv_0_1*tmp_qloop_57;
                const real_t tmp_qloop_74 = jac_blending_inv_0_1*tmp_qloop_69;
                const real_t tmp_qloop_86 = jac_blending_inv_0_1*tmp_qloop_79;
                const real_t tmp_qloop_95 = jac_blending_inv_0_1*tmp_qloop_90;
                const real_t tmp_qloop_104 = jac_blending_inv_0_1*tmp_qloop_99;
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_53 = jac_blending_inv_1_0*tmp_qloop_42;
                const real_t tmp_qloop_54 = tmp_qloop_52*1.0 + tmp_qloop_53*1.0;
                const real_t tmp_qloop_60 = jac_blending_inv_1_0*tmp_qloop_59;
                const real_t tmp_qloop_61 = tmp_qloop_58*1.0 + tmp_qloop_60*1.0;
                const real_t tmp_qloop_62 = tmp_qloop_50*tmp_qloop_54;
                const real_t tmp_qloop_72 = jac_blending_inv_1_0*tmp_qloop_71;
                const real_t tmp_qloop_73 = tmp_qloop_70*1.0 + tmp_qloop_72*1.0;
                const real_t tmp_qloop_84 = jac_blending_inv_1_0*tmp_qloop_83;
                const real_t tmp_qloop_85 = tmp_qloop_80*1.0 + tmp_qloop_84*1.0;
                const real_t tmp_qloop_93 = jac_blending_inv_1_0*tmp_qloop_92;
                const real_t tmp_qloop_94 = tmp_qloop_91*1.0 + tmp_qloop_93*1.0;
                const real_t tmp_qloop_102 = jac_blending_inv_1_0*tmp_qloop_101;
                const real_t tmp_qloop_103 = tmp_qloop_100*1.0 + tmp_qloop_102*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_52*0.5 + tmp_qloop_53*0.5;
                const real_t tmp_qloop_109 = tmp_qloop_58*0.5 + tmp_qloop_60*0.5;
                const real_t tmp_qloop_110 = tmp_qloop_70*0.5 + tmp_qloop_72*0.5;
                const real_t tmp_qloop_111 = tmp_qloop_80*0.5 + tmp_qloop_84*0.5;
                const real_t tmp_qloop_112 = tmp_qloop_91*0.5 + tmp_qloop_93*0.5;
                const real_t tmp_qloop_113 = tmp_qloop_100*0.5 + tmp_qloop_102*0.5;
                const real_t tmp_qloop_114 = tmp_qloop_50*tmp_qloop_61;
                const real_t tmp_qloop_117 = tmp_qloop_50*tmp_qloop_73;
                const real_t tmp_qloop_120 = tmp_qloop_50*tmp_qloop_85;
                const real_t tmp_qloop_125 = tmp_qloop_107*tmp_qloop_66;
                const real_t tmp_qloop_127 = tmp_qloop_109*tmp_qloop_66;
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_66;
                const real_t tmp_qloop_129 = tmp_qloop_111*tmp_qloop_66;
                const real_t tmp_qloop_130 = tmp_qloop_112*tmp_qloop_66;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_43 = jac_blending_inv_1_1*tmp_qloop_42;
                const real_t tmp_qloop_64 = jac_blending_inv_1_1*tmp_qloop_59;
                const real_t tmp_qloop_65 = tmp_qloop_63*0.5 + tmp_qloop_64*0.5;
                const real_t tmp_qloop_67 = tmp_qloop_66*(tmp_qloop_41*0.5 + tmp_qloop_43*0.5);
                const real_t tmp_qloop_75 = jac_blending_inv_1_1*tmp_qloop_71;
                const real_t tmp_qloop_76 = tmp_qloop_74*0.5 + tmp_qloop_75*0.5;
                const real_t tmp_qloop_87 = jac_blending_inv_1_1*tmp_qloop_83;
                const real_t tmp_qloop_88 = tmp_qloop_86*0.5 + tmp_qloop_87*0.5;
                const real_t tmp_qloop_96 = jac_blending_inv_1_1*tmp_qloop_92;
                const real_t tmp_qloop_97 = tmp_qloop_95*0.5 + tmp_qloop_96*0.5;
                const real_t tmp_qloop_105 = jac_blending_inv_1_1*tmp_qloop_101;
                const real_t tmp_qloop_106 = tmp_qloop_104*0.5 + tmp_qloop_105*0.5;
                const real_t tmp_qloop_108 = tmp_qloop_55*tmp_qloop_67;
                const real_t tmp_qloop_115 = tmp_qloop_65*tmp_qloop_66;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_55;
                const real_t tmp_qloop_118 = tmp_qloop_66*tmp_qloop_76;
                const real_t tmp_qloop_119 = tmp_qloop_118*tmp_qloop_55;
                const real_t tmp_qloop_121 = tmp_qloop_66*tmp_qloop_88;
                const real_t tmp_qloop_122 = tmp_qloop_121*tmp_qloop_55;
                const real_t tmp_qloop_123 = tmp_qloop_66*tmp_qloop_97;
                const real_t tmp_qloop_124 = tmp_qloop_123*tmp_qloop_55;
                const real_t tmp_qloop_126 = tmp_qloop_106*tmp_qloop_55;
                const real_t tmp_qloop_131 = tmp_qloop_41*1.0 + tmp_qloop_43*1.0;
                const real_t tmp_qloop_132 = tmp_qloop_63*1.0 + tmp_qloop_64*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_131*tmp_qloop_50;
                const real_t tmp_qloop_134 = tmp_qloop_74*1.0 + tmp_qloop_75*1.0;
                const real_t tmp_qloop_135 = tmp_qloop_86*1.0 + tmp_qloop_87*1.0;
                const real_t tmp_qloop_136 = tmp_qloop_95*1.0 + tmp_qloop_96*1.0;
                const real_t tmp_qloop_137 = tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                const real_t tmp_qloop_138 = tmp_qloop_132*tmp_qloop_50;
                const real_t tmp_qloop_139 = tmp_qloop_134*tmp_qloop_50;
                const real_t tmp_qloop_140 = tmp_qloop_135*tmp_qloop_50;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_54*tmp_qloop_54) + tmp_qloop_51*((tmp_qloop_41 + tmp_qloop_43)*(tmp_qloop_41 + tmp_qloop_43)));
                const real_t q_tmp_0_1 = tmp_qloop_55*(tmp_qloop_61*tmp_qloop_62 + tmp_qloop_65*tmp_qloop_67);
                const real_t q_tmp_0_2 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_73 + tmp_qloop_67*tmp_qloop_76);
                const real_t q_tmp_0_3 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_85 + tmp_qloop_67*tmp_qloop_88);
                const real_t q_tmp_0_4 = tmp_qloop_55*(tmp_qloop_62*tmp_qloop_94 + tmp_qloop_67*tmp_qloop_97);
                const real_t q_tmp_0_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_62 + tmp_qloop_106*tmp_qloop_67);
                const real_t q_tmp_0_6 = tmp_qloop_107*tmp_qloop_108;
                const real_t q_tmp_0_7 = tmp_qloop_108*tmp_qloop_109;
                const real_t q_tmp_0_8 = tmp_qloop_108*tmp_qloop_110;
                const real_t q_tmp_0_9 = tmp_qloop_108*tmp_qloop_111;
                const real_t q_tmp_0_10 = tmp_qloop_108*tmp_qloop_112;
                const real_t q_tmp_0_11 = tmp_qloop_108*tmp_qloop_113;
                const real_t q_tmp_1_1 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_61*tmp_qloop_61) + tmp_qloop_51*((tmp_qloop_63 + tmp_qloop_64)*(tmp_qloop_63 + tmp_qloop_64)));
                const real_t q_tmp_1_2 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_73 + tmp_qloop_115*tmp_qloop_76);
                const real_t q_tmp_1_3 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_85 + tmp_qloop_115*tmp_qloop_88);
                const real_t q_tmp_1_4 = tmp_qloop_55*(tmp_qloop_114*tmp_qloop_94 + tmp_qloop_115*tmp_qloop_97);
                const real_t q_tmp_1_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_114 + tmp_qloop_106*tmp_qloop_115);
                const real_t q_tmp_1_6 = tmp_qloop_107*tmp_qloop_116;
                const real_t q_tmp_1_7 = tmp_qloop_109*tmp_qloop_116;
                const real_t q_tmp_1_8 = tmp_qloop_110*tmp_qloop_116;
                const real_t q_tmp_1_9 = tmp_qloop_111*tmp_qloop_116;
                const real_t q_tmp_1_10 = tmp_qloop_112*tmp_qloop_116;
                const real_t q_tmp_1_11 = tmp_qloop_113*tmp_qloop_116;
                const real_t q_tmp_2_2 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_73*tmp_qloop_73) + tmp_qloop_51*((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75)));
                const real_t q_tmp_2_3 = tmp_qloop_55*(tmp_qloop_117*tmp_qloop_85 + tmp_qloop_118*tmp_qloop_88);
                const real_t q_tmp_2_4 = tmp_qloop_55*(tmp_qloop_117*tmp_qloop_94 + tmp_qloop_118*tmp_qloop_97);
                const real_t q_tmp_2_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_117 + tmp_qloop_106*tmp_qloop_118);
                const real_t q_tmp_2_6 = tmp_qloop_107*tmp_qloop_119;
                const real_t q_tmp_2_7 = tmp_qloop_109*tmp_qloop_119;
                const real_t q_tmp_2_8 = tmp_qloop_110*tmp_qloop_119;
                const real_t q_tmp_2_9 = tmp_qloop_111*tmp_qloop_119;
                const real_t q_tmp_2_10 = tmp_qloop_112*tmp_qloop_119;
                const real_t q_tmp_2_11 = tmp_qloop_113*tmp_qloop_119;
                const real_t q_tmp_3_3 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_85*tmp_qloop_85) + tmp_qloop_51*((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87)));
                const real_t q_tmp_3_4 = tmp_qloop_55*(tmp_qloop_120*tmp_qloop_94 + tmp_qloop_121*tmp_qloop_97);
                const real_t q_tmp_3_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_120 + tmp_qloop_106*tmp_qloop_121);
                const real_t q_tmp_3_6 = tmp_qloop_107*tmp_qloop_122;
                const real_t q_tmp_3_7 = tmp_qloop_109*tmp_qloop_122;
                const real_t q_tmp_3_8 = tmp_qloop_110*tmp_qloop_122;
                const real_t q_tmp_3_9 = tmp_qloop_111*tmp_qloop_122;
                const real_t q_tmp_3_10 = tmp_qloop_112*tmp_qloop_122;
                const real_t q_tmp_3_11 = tmp_qloop_113*tmp_qloop_122;
                const real_t q_tmp_4_4 = tmp_qloop_55*(tmp_qloop_50*(tmp_qloop_94*tmp_qloop_94) + tmp_qloop_51*((tmp_qloop_95 + tmp_qloop_96)*(tmp_qloop_95 + tmp_qloop_96)));
                const real_t q_tmp_4_5 = tmp_qloop_55*(tmp_qloop_103*tmp_qloop_50*tmp_qloop_94 + tmp_qloop_106*tmp_qloop_123);
                const real_t q_tmp_4_6 = tmp_qloop_107*tmp_qloop_124;
                const real_t q_tmp_4_7 = tmp_qloop_109*tmp_qloop_124;
                const real_t q_tmp_4_8 = tmp_qloop_110*tmp_qloop_124;
                const real_t q_tmp_4_9 = tmp_qloop_111*tmp_qloop_124;
                const real_t q_tmp_4_10 = tmp_qloop_112*tmp_qloop_124;
                const real_t q_tmp_4_11 = tmp_qloop_113*tmp_qloop_124;
                const real_t q_tmp_5_5 = tmp_qloop_55*((tmp_qloop_103*tmp_qloop_103)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_104 + tmp_qloop_105)*(tmp_qloop_104 + tmp_qloop_105)));
                const real_t q_tmp_5_6 = tmp_qloop_125*tmp_qloop_126;
                const real_t q_tmp_5_7 = tmp_qloop_126*tmp_qloop_127;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_128;
                const real_t q_tmp_5_9 = tmp_qloop_126*tmp_qloop_129;
                const real_t q_tmp_5_10 = tmp_qloop_126*tmp_qloop_130;
                const real_t q_tmp_5_11 = tmp_qloop_113*tmp_qloop_126*tmp_qloop_66;
                const real_t q_tmp_6_6 = tmp_qloop_55*((tmp_qloop_131*tmp_qloop_131)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_52 + tmp_qloop_53)*(tmp_qloop_52 + tmp_qloop_53)));
                const real_t q_tmp_6_7 = tmp_qloop_55*(tmp_qloop_109*tmp_qloop_125 + tmp_qloop_132*tmp_qloop_133);
                const real_t q_tmp_6_8 = tmp_qloop_55*(tmp_qloop_110*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_134);
                const real_t q_tmp_6_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_135);
                const real_t q_tmp_6_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_136);
                const real_t q_tmp_6_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_125 + tmp_qloop_133*tmp_qloop_137);
                const real_t q_tmp_7_7 = tmp_qloop_55*((tmp_qloop_132*tmp_qloop_132)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_58 + tmp_qloop_60)*(tmp_qloop_58 + tmp_qloop_60)));
                const real_t q_tmp_7_8 = tmp_qloop_55*(tmp_qloop_110*tmp_qloop_127 + tmp_qloop_134*tmp_qloop_138);
                const real_t q_tmp_7_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_127 + tmp_qloop_135*tmp_qloop_138);
                const real_t q_tmp_7_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_127 + tmp_qloop_136*tmp_qloop_138);
                const real_t q_tmp_7_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_127 + tmp_qloop_137*tmp_qloop_138);
                const real_t q_tmp_8_8 = tmp_qloop_55*((tmp_qloop_134*tmp_qloop_134)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_70 + tmp_qloop_72)*(tmp_qloop_70 + tmp_qloop_72)));
                const real_t q_tmp_8_9 = tmp_qloop_55*(tmp_qloop_111*tmp_qloop_128 + tmp_qloop_135*tmp_qloop_139);
                const real_t q_tmp_8_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_128 + tmp_qloop_136*tmp_qloop_139);
                const real_t q_tmp_8_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_128 + tmp_qloop_137*tmp_qloop_139);
                const real_t q_tmp_9_9 = tmp_qloop_55*((tmp_qloop_135*tmp_qloop_135)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_80 + tmp_qloop_84)*(tmp_qloop_80 + tmp_qloop_84)));
                const real_t q_tmp_9_10 = tmp_qloop_55*(tmp_qloop_112*tmp_qloop_129 + tmp_qloop_136*tmp_qloop_140);
                const real_t q_tmp_9_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_129 + tmp_qloop_137*tmp_qloop_140);
                const real_t q_tmp_10_10 = tmp_qloop_55*((tmp_qloop_136*tmp_qloop_136)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_91 + tmp_qloop_93)*(tmp_qloop_91 + tmp_qloop_93)));
                const real_t q_tmp_10_11 = tmp_qloop_55*(tmp_qloop_113*tmp_qloop_130 + tmp_qloop_136*tmp_qloop_137*tmp_qloop_50);
                const real_t q_tmp_11_11 = tmp_qloop_55*((tmp_qloop_137*tmp_qloop_137)*tmp_qloop_50 + tmp_qloop_51*((tmp_qloop_100 + tmp_qloop_102)*(tmp_qloop_100 + tmp_qloop_102)));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const bool tmp_kernel_op_0 = pow((nx_dof_0*nx_dof_0) + (ny_dof_0*ny_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_1 = ((tmp_kernel_op_0) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_2 = ((tmp_kernel_op_0) ? (-ny_dof_0): (1.0));
             const real_t tmp_kernel_op_3 = q_acc_0_6*tmp_kernel_op_2 + q_acc_6_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_4 = q_acc_0_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_5 = q_acc_0_0*tmp_kernel_op_2 + tmp_kernel_op_4;
             const bool tmp_kernel_op_6 = pow((nx_dof_1*nx_dof_1) + (ny_dof_1*ny_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_7 = ((tmp_kernel_op_6) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_8 = q_acc_0_7*tmp_kernel_op_2 + q_acc_6_7*tmp_kernel_op_1;
             const real_t tmp_kernel_op_9 = ((tmp_kernel_op_6) ? (-ny_dof_1): (1.0));
             const real_t tmp_kernel_op_10 = q_acc_0_1*tmp_kernel_op_2 + q_acc_1_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_11 = pow((nx_dof_2*nx_dof_2) + (ny_dof_2*ny_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_12 = ((tmp_kernel_op_11) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_13 = q_acc_0_8*tmp_kernel_op_2 + q_acc_6_8*tmp_kernel_op_1;
             const real_t tmp_kernel_op_14 = ((tmp_kernel_op_11) ? (-ny_dof_2): (1.0));
             const real_t tmp_kernel_op_15 = q_acc_0_2*tmp_kernel_op_2 + q_acc_2_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_16 = pow((nx_dof_3*nx_dof_3) + (ny_dof_3*ny_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_17 = ((tmp_kernel_op_16) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_18 = q_acc_0_9*tmp_kernel_op_2 + q_acc_6_9*tmp_kernel_op_1;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_16) ? (-ny_dof_3): (1.0));
             const real_t tmp_kernel_op_20 = q_acc_0_3*tmp_kernel_op_2 + q_acc_3_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_21 = pow((nx_dof_4*nx_dof_4) + (ny_dof_4*ny_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_21) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_23 = q_acc_0_10*tmp_kernel_op_2 + q_acc_6_10*tmp_kernel_op_1;
             const real_t tmp_kernel_op_24 = ((tmp_kernel_op_21) ? (-ny_dof_4): (1.0));
             const real_t tmp_kernel_op_25 = q_acc_0_4*tmp_kernel_op_2 + q_acc_4_6*tmp_kernel_op_1;
             const bool tmp_kernel_op_26 = pow((nx_dof_5*nx_dof_5) + (ny_dof_5*ny_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_26) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_28 = q_acc_0_11*tmp_kernel_op_2 + q_acc_6_11*tmp_kernel_op_1;
             const real_t tmp_kernel_op_29 = ((tmp_kernel_op_26) ? (-ny_dof_5): (1.0));
             const real_t tmp_kernel_op_30 = q_acc_0_5*tmp_kernel_op_2 + q_acc_5_6*tmp_kernel_op_1;
             const real_t tmp_kernel_op_31 = ((tmp_kernel_op_0) ? (ny_dof_0): (1.0));
             const real_t tmp_kernel_op_32 = ((tmp_kernel_op_6) ? (ny_dof_1): (1.0));
             const real_t tmp_kernel_op_33 = ((tmp_kernel_op_11) ? (ny_dof_2): (1.0));
             const real_t tmp_kernel_op_34 = ((tmp_kernel_op_16) ? (ny_dof_3): (1.0));
             const real_t tmp_kernel_op_35 = ((tmp_kernel_op_21) ? (ny_dof_4): (1.0));
             const real_t tmp_kernel_op_36 = ((tmp_kernel_op_26) ? (ny_dof_5): (1.0));
             const real_t tmp_kernel_op_37 = q_acc_1_6*tmp_kernel_op_9 + q_acc_6_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_38 = q_acc_0_1*tmp_kernel_op_9 + q_acc_0_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_39 = q_acc_1_7*tmp_kernel_op_9 + q_acc_7_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_40 = q_acc_1_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_41 = q_acc_1_1*tmp_kernel_op_9 + tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = q_acc_1_8*tmp_kernel_op_9 + q_acc_7_8*tmp_kernel_op_7;
             const real_t tmp_kernel_op_43 = q_acc_1_2*tmp_kernel_op_9 + q_acc_2_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_44 = q_acc_1_9*tmp_kernel_op_9 + q_acc_7_9*tmp_kernel_op_7;
             const real_t tmp_kernel_op_45 = q_acc_1_3*tmp_kernel_op_9 + q_acc_3_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_46 = q_acc_1_10*tmp_kernel_op_9 + q_acc_7_10*tmp_kernel_op_7;
             const real_t tmp_kernel_op_47 = q_acc_1_4*tmp_kernel_op_9 + q_acc_4_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_48 = q_acc_1_11*tmp_kernel_op_9 + q_acc_7_11*tmp_kernel_op_7;
             const real_t tmp_kernel_op_49 = q_acc_1_5*tmp_kernel_op_9 + q_acc_5_7*tmp_kernel_op_7;
             const real_t tmp_kernel_op_50 = q_acc_2_6*tmp_kernel_op_14 + q_acc_6_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_51 = q_acc_0_2*tmp_kernel_op_14 + q_acc_0_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_52 = q_acc_2_7*tmp_kernel_op_14 + q_acc_7_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_53 = q_acc_1_2*tmp_kernel_op_14 + q_acc_1_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_54 = q_acc_2_8*tmp_kernel_op_14 + q_acc_8_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_55 = q_acc_2_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_56 = q_acc_2_2*tmp_kernel_op_14 + tmp_kernel_op_55;
             const real_t tmp_kernel_op_57 = q_acc_2_9*tmp_kernel_op_14 + q_acc_8_9*tmp_kernel_op_12;
             const real_t tmp_kernel_op_58 = q_acc_2_3*tmp_kernel_op_14 + q_acc_3_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_59 = q_acc_2_10*tmp_kernel_op_14 + q_acc_8_10*tmp_kernel_op_12;
             const real_t tmp_kernel_op_60 = q_acc_2_4*tmp_kernel_op_14 + q_acc_4_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_61 = q_acc_2_11*tmp_kernel_op_14 + q_acc_8_11*tmp_kernel_op_12;
             const real_t tmp_kernel_op_62 = q_acc_2_5*tmp_kernel_op_14 + q_acc_5_8*tmp_kernel_op_12;
             const real_t tmp_kernel_op_63 = q_acc_3_6*tmp_kernel_op_19 + q_acc_6_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_64 = q_acc_0_3*tmp_kernel_op_19 + q_acc_0_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_65 = q_acc_3_7*tmp_kernel_op_19 + q_acc_7_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_66 = q_acc_1_3*tmp_kernel_op_19 + q_acc_1_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_67 = q_acc_3_8*tmp_kernel_op_19 + q_acc_8_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_68 = q_acc_2_3*tmp_kernel_op_19 + q_acc_2_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_69 = q_acc_3_9*tmp_kernel_op_19 + q_acc_9_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_70 = q_acc_3_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_71 = q_acc_3_3*tmp_kernel_op_19 + tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = q_acc_3_10*tmp_kernel_op_19 + q_acc_9_10*tmp_kernel_op_17;
             const real_t tmp_kernel_op_73 = q_acc_3_4*tmp_kernel_op_19 + q_acc_4_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_74 = q_acc_3_11*tmp_kernel_op_19 + q_acc_9_11*tmp_kernel_op_17;
             const real_t tmp_kernel_op_75 = q_acc_3_5*tmp_kernel_op_19 + q_acc_5_9*tmp_kernel_op_17;
             const real_t tmp_kernel_op_76 = q_acc_4_6*tmp_kernel_op_24 + q_acc_6_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_77 = q_acc_0_10*tmp_kernel_op_22 + q_acc_0_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_78 = q_acc_4_7*tmp_kernel_op_24 + q_acc_7_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_79 = q_acc_1_10*tmp_kernel_op_22 + q_acc_1_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_80 = q_acc_4_8*tmp_kernel_op_24 + q_acc_8_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_81 = q_acc_2_10*tmp_kernel_op_22 + q_acc_2_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_82 = q_acc_4_9*tmp_kernel_op_24 + q_acc_9_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_83 = q_acc_3_10*tmp_kernel_op_22 + q_acc_3_4*tmp_kernel_op_24;
             const real_t tmp_kernel_op_84 = q_acc_10_10*tmp_kernel_op_22 + q_acc_4_10*tmp_kernel_op_24;
             const real_t tmp_kernel_op_85 = q_acc_4_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_86 = q_acc_4_4*tmp_kernel_op_24 + tmp_kernel_op_85;
             const real_t tmp_kernel_op_87 = q_acc_10_11*tmp_kernel_op_22 + q_acc_4_11*tmp_kernel_op_24;
             const real_t tmp_kernel_op_88 = q_acc_4_5*tmp_kernel_op_24 + q_acc_5_10*tmp_kernel_op_22;
             const real_t tmp_kernel_op_89 = q_acc_5_6*tmp_kernel_op_29 + q_acc_6_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_90 = q_acc_0_11*tmp_kernel_op_27 + q_acc_0_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_91 = q_acc_5_7*tmp_kernel_op_29 + q_acc_7_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_92 = q_acc_1_11*tmp_kernel_op_27 + q_acc_1_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_93 = q_acc_5_8*tmp_kernel_op_29 + q_acc_8_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_94 = q_acc_2_11*tmp_kernel_op_27 + q_acc_2_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_95 = q_acc_5_9*tmp_kernel_op_29 + q_acc_9_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_96 = q_acc_3_11*tmp_kernel_op_27 + q_acc_3_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_97 = q_acc_10_11*tmp_kernel_op_27 + q_acc_5_10*tmp_kernel_op_29;
             const real_t tmp_kernel_op_98 = q_acc_4_11*tmp_kernel_op_27 + q_acc_4_5*tmp_kernel_op_29;
             const real_t tmp_kernel_op_99 = q_acc_11_11*tmp_kernel_op_27 + q_acc_5_11*tmp_kernel_op_29;
             const real_t tmp_kernel_op_100 = q_acc_5_11*tmp_kernel_op_27;
             const real_t tmp_kernel_op_101 = q_acc_5_5*tmp_kernel_op_29 + tmp_kernel_op_100;
             const real_t tmp_kernel_op_102 = q_acc_6_6*tmp_kernel_op_31 + tmp_kernel_op_4;
             const real_t tmp_kernel_op_103 = q_acc_0_0*tmp_kernel_op_1 + q_acc_0_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_104 = q_acc_0_7*tmp_kernel_op_1 + q_acc_6_7*tmp_kernel_op_31;
             const real_t tmp_kernel_op_105 = q_acc_0_1*tmp_kernel_op_1 + q_acc_1_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_106 = q_acc_0_8*tmp_kernel_op_1 + q_acc_6_8*tmp_kernel_op_31;
             const real_t tmp_kernel_op_107 = q_acc_0_2*tmp_kernel_op_1 + q_acc_2_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_108 = q_acc_0_9*tmp_kernel_op_1 + q_acc_6_9*tmp_kernel_op_31;
             const real_t tmp_kernel_op_109 = q_acc_0_3*tmp_kernel_op_1 + q_acc_3_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_110 = q_acc_0_10*tmp_kernel_op_1 + q_acc_6_10*tmp_kernel_op_31;
             const real_t tmp_kernel_op_111 = q_acc_0_4*tmp_kernel_op_1 + q_acc_4_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_112 = q_acc_0_11*tmp_kernel_op_1 + q_acc_6_11*tmp_kernel_op_31;
             const real_t tmp_kernel_op_113 = q_acc_0_5*tmp_kernel_op_1 + q_acc_5_6*tmp_kernel_op_31;
             const real_t tmp_kernel_op_114 = q_acc_1_6*tmp_kernel_op_7 + q_acc_6_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_115 = q_acc_0_1*tmp_kernel_op_7 + q_acc_0_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_116 = q_acc_7_7*tmp_kernel_op_32 + tmp_kernel_op_40;
             const real_t tmp_kernel_op_117 = q_acc_1_1*tmp_kernel_op_7 + q_acc_1_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_118 = q_acc_1_8*tmp_kernel_op_7 + q_acc_7_8*tmp_kernel_op_32;
             const real_t tmp_kernel_op_119 = q_acc_1_2*tmp_kernel_op_7 + q_acc_2_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_120 = q_acc_1_9*tmp_kernel_op_7 + q_acc_7_9*tmp_kernel_op_32;
             const real_t tmp_kernel_op_121 = q_acc_1_3*tmp_kernel_op_7 + q_acc_3_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_122 = q_acc_1_10*tmp_kernel_op_7 + q_acc_7_10*tmp_kernel_op_32;
             const real_t tmp_kernel_op_123 = q_acc_1_4*tmp_kernel_op_7 + q_acc_4_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_124 = q_acc_1_11*tmp_kernel_op_7 + q_acc_7_11*tmp_kernel_op_32;
             const real_t tmp_kernel_op_125 = q_acc_1_5*tmp_kernel_op_7 + q_acc_5_7*tmp_kernel_op_32;
             const real_t tmp_kernel_op_126 = q_acc_2_6*tmp_kernel_op_12 + q_acc_6_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_127 = q_acc_0_2*tmp_kernel_op_12 + q_acc_0_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_128 = q_acc_2_7*tmp_kernel_op_12 + q_acc_7_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_129 = q_acc_1_2*tmp_kernel_op_12 + q_acc_1_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_130 = q_acc_8_8*tmp_kernel_op_33 + tmp_kernel_op_55;
             const real_t tmp_kernel_op_131 = q_acc_2_2*tmp_kernel_op_12 + q_acc_2_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_132 = q_acc_2_9*tmp_kernel_op_12 + q_acc_8_9*tmp_kernel_op_33;
             const real_t tmp_kernel_op_133 = q_acc_2_3*tmp_kernel_op_12 + q_acc_3_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_134 = q_acc_2_10*tmp_kernel_op_12 + q_acc_8_10*tmp_kernel_op_33;
             const real_t tmp_kernel_op_135 = q_acc_2_4*tmp_kernel_op_12 + q_acc_4_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_136 = q_acc_2_11*tmp_kernel_op_12 + q_acc_8_11*tmp_kernel_op_33;
             const real_t tmp_kernel_op_137 = q_acc_2_5*tmp_kernel_op_12 + q_acc_5_8*tmp_kernel_op_33;
             const real_t tmp_kernel_op_138 = q_acc_3_6*tmp_kernel_op_17 + q_acc_6_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_139 = q_acc_0_3*tmp_kernel_op_17 + q_acc_0_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_140 = q_acc_3_7*tmp_kernel_op_17 + q_acc_7_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_141 = q_acc_1_3*tmp_kernel_op_17 + q_acc_1_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_142 = q_acc_3_8*tmp_kernel_op_17 + q_acc_8_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_143 = q_acc_2_3*tmp_kernel_op_17 + q_acc_2_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_144 = q_acc_9_9*tmp_kernel_op_34 + tmp_kernel_op_70;
             const real_t tmp_kernel_op_145 = q_acc_3_3*tmp_kernel_op_17 + q_acc_3_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_146 = q_acc_3_10*tmp_kernel_op_17 + q_acc_9_10*tmp_kernel_op_34;
             const real_t tmp_kernel_op_147 = q_acc_3_4*tmp_kernel_op_17 + q_acc_4_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_148 = q_acc_3_11*tmp_kernel_op_17 + q_acc_9_11*tmp_kernel_op_34;
             const real_t tmp_kernel_op_149 = q_acc_3_5*tmp_kernel_op_17 + q_acc_5_9*tmp_kernel_op_34;
             const real_t tmp_kernel_op_150 = q_acc_4_6*tmp_kernel_op_22 + q_acc_6_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_151 = q_acc_0_10*tmp_kernel_op_35 + q_acc_0_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_152 = q_acc_4_7*tmp_kernel_op_22 + q_acc_7_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_153 = q_acc_1_10*tmp_kernel_op_35 + q_acc_1_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_154 = q_acc_4_8*tmp_kernel_op_22 + q_acc_8_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_155 = q_acc_2_10*tmp_kernel_op_35 + q_acc_2_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_156 = q_acc_4_9*tmp_kernel_op_22 + q_acc_9_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_157 = q_acc_3_10*tmp_kernel_op_35 + q_acc_3_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_158 = q_acc_10_10*tmp_kernel_op_35 + tmp_kernel_op_85;
             const real_t tmp_kernel_op_159 = q_acc_4_10*tmp_kernel_op_35 + q_acc_4_4*tmp_kernel_op_22;
             const real_t tmp_kernel_op_160 = q_acc_10_11*tmp_kernel_op_35 + q_acc_4_11*tmp_kernel_op_22;
             const real_t tmp_kernel_op_161 = q_acc_4_5*tmp_kernel_op_22 + q_acc_5_10*tmp_kernel_op_35;
             const real_t tmp_kernel_op_162 = q_acc_5_6*tmp_kernel_op_27 + q_acc_6_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_163 = q_acc_0_11*tmp_kernel_op_36 + q_acc_0_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_164 = q_acc_5_7*tmp_kernel_op_27 + q_acc_7_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_165 = q_acc_1_11*tmp_kernel_op_36 + q_acc_1_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_166 = q_acc_5_8*tmp_kernel_op_27 + q_acc_8_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_167 = q_acc_2_11*tmp_kernel_op_36 + q_acc_2_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_168 = q_acc_5_9*tmp_kernel_op_27 + q_acc_9_11*tmp_kernel_op_36;
             const real_t tmp_kernel_op_169 = q_acc_3_11*tmp_kernel_op_36 + q_acc_3_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_170 = q_acc_10_11*tmp_kernel_op_36 + q_acc_5_10*tmp_kernel_op_27;
             const real_t tmp_kernel_op_171 = q_acc_4_11*tmp_kernel_op_36 + q_acc_4_5*tmp_kernel_op_27;
             const real_t tmp_kernel_op_172 = q_acc_11_11*tmp_kernel_op_36 + tmp_kernel_op_100;
             const real_t tmp_kernel_op_173 = q_acc_5_11*tmp_kernel_op_36 + q_acc_5_5*tmp_kernel_op_27;
             const real_t elMat_0_0 = tmp_kernel_op_1*tmp_kernel_op_3 + tmp_kernel_op_2*tmp_kernel_op_5;
             const real_t elMat_0_1 = tmp_kernel_op_10*tmp_kernel_op_9 + tmp_kernel_op_7*tmp_kernel_op_8;
             const real_t elMat_0_2 = tmp_kernel_op_12*tmp_kernel_op_13 + tmp_kernel_op_14*tmp_kernel_op_15;
             const real_t elMat_0_3 = tmp_kernel_op_17*tmp_kernel_op_18 + tmp_kernel_op_19*tmp_kernel_op_20;
             const real_t elMat_0_4 = tmp_kernel_op_22*tmp_kernel_op_23 + tmp_kernel_op_24*tmp_kernel_op_25;
             const real_t elMat_0_5 = tmp_kernel_op_27*tmp_kernel_op_28 + tmp_kernel_op_29*tmp_kernel_op_30;
             const real_t elMat_0_6 = tmp_kernel_op_1*tmp_kernel_op_5 + tmp_kernel_op_3*tmp_kernel_op_31;
             const real_t elMat_0_7 = tmp_kernel_op_10*tmp_kernel_op_7 + tmp_kernel_op_32*tmp_kernel_op_8;
             const real_t elMat_0_8 = tmp_kernel_op_12*tmp_kernel_op_15 + tmp_kernel_op_13*tmp_kernel_op_33;
             const real_t elMat_0_9 = tmp_kernel_op_17*tmp_kernel_op_20 + tmp_kernel_op_18*tmp_kernel_op_34;
             const real_t elMat_0_10 = tmp_kernel_op_22*tmp_kernel_op_25 + tmp_kernel_op_23*tmp_kernel_op_35;
             const real_t elMat_0_11 = tmp_kernel_op_27*tmp_kernel_op_30 + tmp_kernel_op_28*tmp_kernel_op_36;
             const real_t elMat_1_0 = tmp_kernel_op_1*tmp_kernel_op_37 + tmp_kernel_op_2*tmp_kernel_op_38;
             const real_t elMat_1_1 = tmp_kernel_op_39*tmp_kernel_op_7 + tmp_kernel_op_41*tmp_kernel_op_9;
             const real_t elMat_1_2 = tmp_kernel_op_12*tmp_kernel_op_42 + tmp_kernel_op_14*tmp_kernel_op_43;
             const real_t elMat_1_3 = tmp_kernel_op_17*tmp_kernel_op_44 + tmp_kernel_op_19*tmp_kernel_op_45;
             const real_t elMat_1_4 = tmp_kernel_op_22*tmp_kernel_op_46 + tmp_kernel_op_24*tmp_kernel_op_47;
             const real_t elMat_1_5 = tmp_kernel_op_27*tmp_kernel_op_48 + tmp_kernel_op_29*tmp_kernel_op_49;
             const real_t elMat_1_6 = tmp_kernel_op_1*tmp_kernel_op_38 + tmp_kernel_op_31*tmp_kernel_op_37;
             const real_t elMat_1_7 = tmp_kernel_op_32*tmp_kernel_op_39 + tmp_kernel_op_41*tmp_kernel_op_7;
             const real_t elMat_1_8 = tmp_kernel_op_12*tmp_kernel_op_43 + tmp_kernel_op_33*tmp_kernel_op_42;
             const real_t elMat_1_9 = tmp_kernel_op_17*tmp_kernel_op_45 + tmp_kernel_op_34*tmp_kernel_op_44;
             const real_t elMat_1_10 = tmp_kernel_op_22*tmp_kernel_op_47 + tmp_kernel_op_35*tmp_kernel_op_46;
             const real_t elMat_1_11 = tmp_kernel_op_27*tmp_kernel_op_49 + tmp_kernel_op_36*tmp_kernel_op_48;
             const real_t elMat_2_0 = tmp_kernel_op_1*tmp_kernel_op_50 + tmp_kernel_op_2*tmp_kernel_op_51;
             const real_t elMat_2_1 = tmp_kernel_op_52*tmp_kernel_op_7 + tmp_kernel_op_53*tmp_kernel_op_9;
             const real_t elMat_2_2 = tmp_kernel_op_12*tmp_kernel_op_54 + tmp_kernel_op_14*tmp_kernel_op_56;
             const real_t elMat_2_3 = tmp_kernel_op_17*tmp_kernel_op_57 + tmp_kernel_op_19*tmp_kernel_op_58;
             const real_t elMat_2_4 = tmp_kernel_op_22*tmp_kernel_op_59 + tmp_kernel_op_24*tmp_kernel_op_60;
             const real_t elMat_2_5 = tmp_kernel_op_27*tmp_kernel_op_61 + tmp_kernel_op_29*tmp_kernel_op_62;
             const real_t elMat_2_6 = tmp_kernel_op_1*tmp_kernel_op_51 + tmp_kernel_op_31*tmp_kernel_op_50;
             const real_t elMat_2_7 = tmp_kernel_op_32*tmp_kernel_op_52 + tmp_kernel_op_53*tmp_kernel_op_7;
             const real_t elMat_2_8 = tmp_kernel_op_12*tmp_kernel_op_56 + tmp_kernel_op_33*tmp_kernel_op_54;
             const real_t elMat_2_9 = tmp_kernel_op_17*tmp_kernel_op_58 + tmp_kernel_op_34*tmp_kernel_op_57;
             const real_t elMat_2_10 = tmp_kernel_op_22*tmp_kernel_op_60 + tmp_kernel_op_35*tmp_kernel_op_59;
             const real_t elMat_2_11 = tmp_kernel_op_27*tmp_kernel_op_62 + tmp_kernel_op_36*tmp_kernel_op_61;
             const real_t elMat_3_0 = tmp_kernel_op_1*tmp_kernel_op_63 + tmp_kernel_op_2*tmp_kernel_op_64;
             const real_t elMat_3_1 = tmp_kernel_op_65*tmp_kernel_op_7 + tmp_kernel_op_66*tmp_kernel_op_9;
             const real_t elMat_3_2 = tmp_kernel_op_12*tmp_kernel_op_67 + tmp_kernel_op_14*tmp_kernel_op_68;
             const real_t elMat_3_3 = tmp_kernel_op_17*tmp_kernel_op_69 + tmp_kernel_op_19*tmp_kernel_op_71;
             const real_t elMat_3_4 = tmp_kernel_op_22*tmp_kernel_op_72 + tmp_kernel_op_24*tmp_kernel_op_73;
             const real_t elMat_3_5 = tmp_kernel_op_27*tmp_kernel_op_74 + tmp_kernel_op_29*tmp_kernel_op_75;
             const real_t elMat_3_6 = tmp_kernel_op_1*tmp_kernel_op_64 + tmp_kernel_op_31*tmp_kernel_op_63;
             const real_t elMat_3_7 = tmp_kernel_op_32*tmp_kernel_op_65 + tmp_kernel_op_66*tmp_kernel_op_7;
             const real_t elMat_3_8 = tmp_kernel_op_12*tmp_kernel_op_68 + tmp_kernel_op_33*tmp_kernel_op_67;
             const real_t elMat_3_9 = tmp_kernel_op_17*tmp_kernel_op_71 + tmp_kernel_op_34*tmp_kernel_op_69;
             const real_t elMat_3_10 = tmp_kernel_op_22*tmp_kernel_op_73 + tmp_kernel_op_35*tmp_kernel_op_72;
             const real_t elMat_3_11 = tmp_kernel_op_27*tmp_kernel_op_75 + tmp_kernel_op_36*tmp_kernel_op_74;
             const real_t elMat_4_0 = tmp_kernel_op_1*tmp_kernel_op_76 + tmp_kernel_op_2*tmp_kernel_op_77;
             const real_t elMat_4_1 = tmp_kernel_op_7*tmp_kernel_op_78 + tmp_kernel_op_79*tmp_kernel_op_9;
             const real_t elMat_4_2 = tmp_kernel_op_12*tmp_kernel_op_80 + tmp_kernel_op_14*tmp_kernel_op_81;
             const real_t elMat_4_3 = tmp_kernel_op_17*tmp_kernel_op_82 + tmp_kernel_op_19*tmp_kernel_op_83;
             const real_t elMat_4_4 = tmp_kernel_op_22*tmp_kernel_op_84 + tmp_kernel_op_24*tmp_kernel_op_86;
             const real_t elMat_4_5 = tmp_kernel_op_27*tmp_kernel_op_87 + tmp_kernel_op_29*tmp_kernel_op_88;
             const real_t elMat_4_6 = tmp_kernel_op_1*tmp_kernel_op_77 + tmp_kernel_op_31*tmp_kernel_op_76;
             const real_t elMat_4_7 = tmp_kernel_op_32*tmp_kernel_op_78 + tmp_kernel_op_7*tmp_kernel_op_79;
             const real_t elMat_4_8 = tmp_kernel_op_12*tmp_kernel_op_81 + tmp_kernel_op_33*tmp_kernel_op_80;
             const real_t elMat_4_9 = tmp_kernel_op_17*tmp_kernel_op_83 + tmp_kernel_op_34*tmp_kernel_op_82;
             const real_t elMat_4_10 = tmp_kernel_op_22*tmp_kernel_op_86 + tmp_kernel_op_35*tmp_kernel_op_84;
             const real_t elMat_4_11 = tmp_kernel_op_27*tmp_kernel_op_88 + tmp_kernel_op_36*tmp_kernel_op_87;
             const real_t elMat_5_0 = tmp_kernel_op_1*tmp_kernel_op_89 + tmp_kernel_op_2*tmp_kernel_op_90;
             const real_t elMat_5_1 = tmp_kernel_op_7*tmp_kernel_op_91 + tmp_kernel_op_9*tmp_kernel_op_92;
             const real_t elMat_5_2 = tmp_kernel_op_12*tmp_kernel_op_93 + tmp_kernel_op_14*tmp_kernel_op_94;
             const real_t elMat_5_3 = tmp_kernel_op_17*tmp_kernel_op_95 + tmp_kernel_op_19*tmp_kernel_op_96;
             const real_t elMat_5_4 = tmp_kernel_op_22*tmp_kernel_op_97 + tmp_kernel_op_24*tmp_kernel_op_98;
             const real_t elMat_5_5 = tmp_kernel_op_101*tmp_kernel_op_29 + tmp_kernel_op_27*tmp_kernel_op_99;
             const real_t elMat_5_6 = tmp_kernel_op_1*tmp_kernel_op_90 + tmp_kernel_op_31*tmp_kernel_op_89;
             const real_t elMat_5_7 = tmp_kernel_op_32*tmp_kernel_op_91 + tmp_kernel_op_7*tmp_kernel_op_92;
             const real_t elMat_5_8 = tmp_kernel_op_12*tmp_kernel_op_94 + tmp_kernel_op_33*tmp_kernel_op_93;
             const real_t elMat_5_9 = tmp_kernel_op_17*tmp_kernel_op_96 + tmp_kernel_op_34*tmp_kernel_op_95;
             const real_t elMat_5_10 = tmp_kernel_op_22*tmp_kernel_op_98 + tmp_kernel_op_35*tmp_kernel_op_97;
             const real_t elMat_5_11 = tmp_kernel_op_101*tmp_kernel_op_27 + tmp_kernel_op_36*tmp_kernel_op_99;
             const real_t elMat_6_0 = tmp_kernel_op_1*tmp_kernel_op_102 + tmp_kernel_op_103*tmp_kernel_op_2;
             const real_t elMat_6_1 = tmp_kernel_op_104*tmp_kernel_op_7 + tmp_kernel_op_105*tmp_kernel_op_9;
             const real_t elMat_6_2 = tmp_kernel_op_106*tmp_kernel_op_12 + tmp_kernel_op_107*tmp_kernel_op_14;
             const real_t elMat_6_3 = tmp_kernel_op_108*tmp_kernel_op_17 + tmp_kernel_op_109*tmp_kernel_op_19;
             const real_t elMat_6_4 = tmp_kernel_op_110*tmp_kernel_op_22 + tmp_kernel_op_111*tmp_kernel_op_24;
             const real_t elMat_6_5 = tmp_kernel_op_112*tmp_kernel_op_27 + tmp_kernel_op_113*tmp_kernel_op_29;
             const real_t elMat_6_6 = tmp_kernel_op_1*tmp_kernel_op_103 + tmp_kernel_op_102*tmp_kernel_op_31;
             const real_t elMat_6_7 = tmp_kernel_op_104*tmp_kernel_op_32 + tmp_kernel_op_105*tmp_kernel_op_7;
             const real_t elMat_6_8 = tmp_kernel_op_106*tmp_kernel_op_33 + tmp_kernel_op_107*tmp_kernel_op_12;
             const real_t elMat_6_9 = tmp_kernel_op_108*tmp_kernel_op_34 + tmp_kernel_op_109*tmp_kernel_op_17;
             const real_t elMat_6_10 = tmp_kernel_op_110*tmp_kernel_op_35 + tmp_kernel_op_111*tmp_kernel_op_22;
             const real_t elMat_6_11 = tmp_kernel_op_112*tmp_kernel_op_36 + tmp_kernel_op_113*tmp_kernel_op_27;
             const real_t elMat_7_0 = tmp_kernel_op_1*tmp_kernel_op_114 + tmp_kernel_op_115*tmp_kernel_op_2;
             const real_t elMat_7_1 = tmp_kernel_op_116*tmp_kernel_op_7 + tmp_kernel_op_117*tmp_kernel_op_9;
             const real_t elMat_7_2 = tmp_kernel_op_118*tmp_kernel_op_12 + tmp_kernel_op_119*tmp_kernel_op_14;
             const real_t elMat_7_3 = tmp_kernel_op_120*tmp_kernel_op_17 + tmp_kernel_op_121*tmp_kernel_op_19;
             const real_t elMat_7_4 = tmp_kernel_op_122*tmp_kernel_op_22 + tmp_kernel_op_123*tmp_kernel_op_24;
             const real_t elMat_7_5 = tmp_kernel_op_124*tmp_kernel_op_27 + tmp_kernel_op_125*tmp_kernel_op_29;
             const real_t elMat_7_6 = tmp_kernel_op_1*tmp_kernel_op_115 + tmp_kernel_op_114*tmp_kernel_op_31;
             const real_t elMat_7_7 = tmp_kernel_op_116*tmp_kernel_op_32 + tmp_kernel_op_117*tmp_kernel_op_7;
             const real_t elMat_7_8 = tmp_kernel_op_118*tmp_kernel_op_33 + tmp_kernel_op_119*tmp_kernel_op_12;
             const real_t elMat_7_9 = tmp_kernel_op_120*tmp_kernel_op_34 + tmp_kernel_op_121*tmp_kernel_op_17;
             const real_t elMat_7_10 = tmp_kernel_op_122*tmp_kernel_op_35 + tmp_kernel_op_123*tmp_kernel_op_22;
             const real_t elMat_7_11 = tmp_kernel_op_124*tmp_kernel_op_36 + tmp_kernel_op_125*tmp_kernel_op_27;
             const real_t elMat_8_0 = tmp_kernel_op_1*tmp_kernel_op_126 + tmp_kernel_op_127*tmp_kernel_op_2;
             const real_t elMat_8_1 = tmp_kernel_op_128*tmp_kernel_op_7 + tmp_kernel_op_129*tmp_kernel_op_9;
             const real_t elMat_8_2 = tmp_kernel_op_12*tmp_kernel_op_130 + tmp_kernel_op_131*tmp_kernel_op_14;
             const real_t elMat_8_3 = tmp_kernel_op_132*tmp_kernel_op_17 + tmp_kernel_op_133*tmp_kernel_op_19;
             const real_t elMat_8_4 = tmp_kernel_op_134*tmp_kernel_op_22 + tmp_kernel_op_135*tmp_kernel_op_24;
             const real_t elMat_8_5 = tmp_kernel_op_136*tmp_kernel_op_27 + tmp_kernel_op_137*tmp_kernel_op_29;
             const real_t elMat_8_6 = tmp_kernel_op_1*tmp_kernel_op_127 + tmp_kernel_op_126*tmp_kernel_op_31;
             const real_t elMat_8_7 = tmp_kernel_op_128*tmp_kernel_op_32 + tmp_kernel_op_129*tmp_kernel_op_7;
             const real_t elMat_8_8 = tmp_kernel_op_12*tmp_kernel_op_131 + tmp_kernel_op_130*tmp_kernel_op_33;
             const real_t elMat_8_9 = tmp_kernel_op_132*tmp_kernel_op_34 + tmp_kernel_op_133*tmp_kernel_op_17;
             const real_t elMat_8_10 = tmp_kernel_op_134*tmp_kernel_op_35 + tmp_kernel_op_135*tmp_kernel_op_22;
             const real_t elMat_8_11 = tmp_kernel_op_136*tmp_kernel_op_36 + tmp_kernel_op_137*tmp_kernel_op_27;
             const real_t elMat_9_0 = tmp_kernel_op_1*tmp_kernel_op_138 + tmp_kernel_op_139*tmp_kernel_op_2;
             const real_t elMat_9_1 = tmp_kernel_op_140*tmp_kernel_op_7 + tmp_kernel_op_141*tmp_kernel_op_9;
             const real_t elMat_9_2 = tmp_kernel_op_12*tmp_kernel_op_142 + tmp_kernel_op_14*tmp_kernel_op_143;
             const real_t elMat_9_3 = tmp_kernel_op_144*tmp_kernel_op_17 + tmp_kernel_op_145*tmp_kernel_op_19;
             const real_t elMat_9_4 = tmp_kernel_op_146*tmp_kernel_op_22 + tmp_kernel_op_147*tmp_kernel_op_24;
             const real_t elMat_9_5 = tmp_kernel_op_148*tmp_kernel_op_27 + tmp_kernel_op_149*tmp_kernel_op_29;
             const real_t elMat_9_6 = tmp_kernel_op_1*tmp_kernel_op_139 + tmp_kernel_op_138*tmp_kernel_op_31;
             const real_t elMat_9_7 = tmp_kernel_op_140*tmp_kernel_op_32 + tmp_kernel_op_141*tmp_kernel_op_7;
             const real_t elMat_9_8 = tmp_kernel_op_12*tmp_kernel_op_143 + tmp_kernel_op_142*tmp_kernel_op_33;
             const real_t elMat_9_9 = tmp_kernel_op_144*tmp_kernel_op_34 + tmp_kernel_op_145*tmp_kernel_op_17;
             const real_t elMat_9_10 = tmp_kernel_op_146*tmp_kernel_op_35 + tmp_kernel_op_147*tmp_kernel_op_22;
             const real_t elMat_9_11 = tmp_kernel_op_148*tmp_kernel_op_36 + tmp_kernel_op_149*tmp_kernel_op_27;
             const real_t elMat_10_0 = tmp_kernel_op_1*tmp_kernel_op_150 + tmp_kernel_op_151*tmp_kernel_op_2;
             const real_t elMat_10_1 = tmp_kernel_op_152*tmp_kernel_op_7 + tmp_kernel_op_153*tmp_kernel_op_9;
             const real_t elMat_10_2 = tmp_kernel_op_12*tmp_kernel_op_154 + tmp_kernel_op_14*tmp_kernel_op_155;
             const real_t elMat_10_3 = tmp_kernel_op_156*tmp_kernel_op_17 + tmp_kernel_op_157*tmp_kernel_op_19;
             const real_t elMat_10_4 = tmp_kernel_op_158*tmp_kernel_op_22 + tmp_kernel_op_159*tmp_kernel_op_24;
             const real_t elMat_10_5 = tmp_kernel_op_160*tmp_kernel_op_27 + tmp_kernel_op_161*tmp_kernel_op_29;
             const real_t elMat_10_6 = tmp_kernel_op_1*tmp_kernel_op_151 + tmp_kernel_op_150*tmp_kernel_op_31;
             const real_t elMat_10_7 = tmp_kernel_op_152*tmp_kernel_op_32 + tmp_kernel_op_153*tmp_kernel_op_7;
             const real_t elMat_10_8 = tmp_kernel_op_12*tmp_kernel_op_155 + tmp_kernel_op_154*tmp_kernel_op_33;
             const real_t elMat_10_9 = tmp_kernel_op_156*tmp_kernel_op_34 + tmp_kernel_op_157*tmp_kernel_op_17;
             const real_t elMat_10_10 = tmp_kernel_op_158*tmp_kernel_op_35 + tmp_kernel_op_159*tmp_kernel_op_22;
             const real_t elMat_10_11 = tmp_kernel_op_160*tmp_kernel_op_36 + tmp_kernel_op_161*tmp_kernel_op_27;
             const real_t elMat_11_0 = tmp_kernel_op_1*tmp_kernel_op_162 + tmp_kernel_op_163*tmp_kernel_op_2;
             const real_t elMat_11_1 = tmp_kernel_op_164*tmp_kernel_op_7 + tmp_kernel_op_165*tmp_kernel_op_9;
             const real_t elMat_11_2 = tmp_kernel_op_12*tmp_kernel_op_166 + tmp_kernel_op_14*tmp_kernel_op_167;
             const real_t elMat_11_3 = tmp_kernel_op_168*tmp_kernel_op_17 + tmp_kernel_op_169*tmp_kernel_op_19;
             const real_t elMat_11_4 = tmp_kernel_op_170*tmp_kernel_op_22 + tmp_kernel_op_171*tmp_kernel_op_24;
             const real_t elMat_11_5 = tmp_kernel_op_172*tmp_kernel_op_27 + tmp_kernel_op_173*tmp_kernel_op_29;
             const real_t elMat_11_6 = tmp_kernel_op_1*tmp_kernel_op_163 + tmp_kernel_op_162*tmp_kernel_op_31;
             const real_t elMat_11_7 = tmp_kernel_op_164*tmp_kernel_op_32 + tmp_kernel_op_165*tmp_kernel_op_7;
             const real_t elMat_11_8 = tmp_kernel_op_12*tmp_kernel_op_167 + tmp_kernel_op_166*tmp_kernel_op_33;
             const real_t elMat_11_9 = tmp_kernel_op_168*tmp_kernel_op_34 + tmp_kernel_op_169*tmp_kernel_op_17;
             const real_t elMat_11_10 = tmp_kernel_op_170*tmp_kernel_op_35 + tmp_kernel_op_171*tmp_kernel_op_22;
             const real_t elMat_11_11 = tmp_kernel_op_172*tmp_kernel_op_36 + tmp_kernel_op_173*tmp_kernel_op_27;
         
             std::vector< uint_t > _data_rowIdx( 12 );
             std::vector< uint_t > _data_colIdx( 12 );
             std::vector< real_t > _data_mat( 144 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[7] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[8] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[11] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_1_0));
             _data_mat[13] = ((real_t)(elMat_1_1));
             _data_mat[14] = ((real_t)(elMat_1_2));
             _data_mat[15] = ((real_t)(elMat_1_3));
             _data_mat[16] = ((real_t)(elMat_1_4));
             _data_mat[17] = ((real_t)(elMat_1_5));
             _data_mat[18] = ((real_t)(elMat_1_6));
             _data_mat[19] = ((real_t)(elMat_1_7));
             _data_mat[20] = ((real_t)(elMat_1_8));
             _data_mat[21] = ((real_t)(elMat_1_9));
             _data_mat[22] = ((real_t)(elMat_1_10));
             _data_mat[23] = ((real_t)(elMat_1_11));
             _data_mat[24] = ((real_t)(elMat_2_0));
             _data_mat[25] = ((real_t)(elMat_2_1));
             _data_mat[26] = ((real_t)(elMat_2_2));
             _data_mat[27] = ((real_t)(elMat_2_3));
             _data_mat[28] = ((real_t)(elMat_2_4));
             _data_mat[29] = ((real_t)(elMat_2_5));
             _data_mat[30] = ((real_t)(elMat_2_6));
             _data_mat[31] = ((real_t)(elMat_2_7));
             _data_mat[32] = ((real_t)(elMat_2_8));
             _data_mat[33] = ((real_t)(elMat_2_9));
             _data_mat[34] = ((real_t)(elMat_2_10));
             _data_mat[35] = ((real_t)(elMat_2_11));
             _data_mat[36] = ((real_t)(elMat_3_0));
             _data_mat[37] = ((real_t)(elMat_3_1));
             _data_mat[38] = ((real_t)(elMat_3_2));
             _data_mat[39] = ((real_t)(elMat_3_3));
             _data_mat[40] = ((real_t)(elMat_3_4));
             _data_mat[41] = ((real_t)(elMat_3_5));
             _data_mat[42] = ((real_t)(elMat_3_6));
             _data_mat[43] = ((real_t)(elMat_3_7));
             _data_mat[44] = ((real_t)(elMat_3_8));
             _data_mat[45] = ((real_t)(elMat_3_9));
             _data_mat[46] = ((real_t)(elMat_3_10));
             _data_mat[47] = ((real_t)(elMat_3_11));
             _data_mat[48] = ((real_t)(elMat_4_0));
             _data_mat[49] = ((real_t)(elMat_4_1));
             _data_mat[50] = ((real_t)(elMat_4_2));
             _data_mat[51] = ((real_t)(elMat_4_3));
             _data_mat[52] = ((real_t)(elMat_4_4));
             _data_mat[53] = ((real_t)(elMat_4_5));
             _data_mat[54] = ((real_t)(elMat_4_6));
             _data_mat[55] = ((real_t)(elMat_4_7));
             _data_mat[56] = ((real_t)(elMat_4_8));
             _data_mat[57] = ((real_t)(elMat_4_9));
             _data_mat[58] = ((real_t)(elMat_4_10));
             _data_mat[59] = ((real_t)(elMat_4_11));
             _data_mat[60] = ((real_t)(elMat_5_0));
             _data_mat[61] = ((real_t)(elMat_5_1));
             _data_mat[62] = ((real_t)(elMat_5_2));
             _data_mat[63] = ((real_t)(elMat_5_3));
             _data_mat[64] = ((real_t)(elMat_5_4));
             _data_mat[65] = ((real_t)(elMat_5_5));
             _data_mat[66] = ((real_t)(elMat_5_6));
             _data_mat[67] = ((real_t)(elMat_5_7));
             _data_mat[68] = ((real_t)(elMat_5_8));
             _data_mat[69] = ((real_t)(elMat_5_9));
             _data_mat[70] = ((real_t)(elMat_5_10));
             _data_mat[71] = ((real_t)(elMat_5_11));
             _data_mat[72] = ((real_t)(elMat_6_0));
             _data_mat[73] = ((real_t)(elMat_6_1));
             _data_mat[74] = ((real_t)(elMat_6_2));
             _data_mat[75] = ((real_t)(elMat_6_3));
             _data_mat[76] = ((real_t)(elMat_6_4));
             _data_mat[77] = ((real_t)(elMat_6_5));
             _data_mat[78] = ((real_t)(elMat_6_6));
             _data_mat[79] = ((real_t)(elMat_6_7));
             _data_mat[80] = ((real_t)(elMat_6_8));
             _data_mat[81] = ((real_t)(elMat_6_9));
             _data_mat[82] = ((real_t)(elMat_6_10));
             _data_mat[83] = ((real_t)(elMat_6_11));
             _data_mat[84] = ((real_t)(elMat_7_0));
             _data_mat[85] = ((real_t)(elMat_7_1));
             _data_mat[86] = ((real_t)(elMat_7_2));
             _data_mat[87] = ((real_t)(elMat_7_3));
             _data_mat[88] = ((real_t)(elMat_7_4));
             _data_mat[89] = ((real_t)(elMat_7_5));
             _data_mat[90] = ((real_t)(elMat_7_6));
             _data_mat[91] = ((real_t)(elMat_7_7));
             _data_mat[92] = ((real_t)(elMat_7_8));
             _data_mat[93] = ((real_t)(elMat_7_9));
             _data_mat[94] = ((real_t)(elMat_7_10));
             _data_mat[95] = ((real_t)(elMat_7_11));
             _data_mat[96] = ((real_t)(elMat_8_0));
             _data_mat[97] = ((real_t)(elMat_8_1));
             _data_mat[98] = ((real_t)(elMat_8_2));
             _data_mat[99] = ((real_t)(elMat_8_3));
             _data_mat[100] = ((real_t)(elMat_8_4));
             _data_mat[101] = ((real_t)(elMat_8_5));
             _data_mat[102] = ((real_t)(elMat_8_6));
             _data_mat[103] = ((real_t)(elMat_8_7));
             _data_mat[104] = ((real_t)(elMat_8_8));
             _data_mat[105] = ((real_t)(elMat_8_9));
             _data_mat[106] = ((real_t)(elMat_8_10));
             _data_mat[107] = ((real_t)(elMat_8_11));
             _data_mat[108] = ((real_t)(elMat_9_0));
             _data_mat[109] = ((real_t)(elMat_9_1));
             _data_mat[110] = ((real_t)(elMat_9_2));
             _data_mat[111] = ((real_t)(elMat_9_3));
             _data_mat[112] = ((real_t)(elMat_9_4));
             _data_mat[113] = ((real_t)(elMat_9_5));
             _data_mat[114] = ((real_t)(elMat_9_6));
             _data_mat[115] = ((real_t)(elMat_9_7));
             _data_mat[116] = ((real_t)(elMat_9_8));
             _data_mat[117] = ((real_t)(elMat_9_9));
             _data_mat[118] = ((real_t)(elMat_9_10));
             _data_mat[119] = ((real_t)(elMat_9_11));
             _data_mat[120] = ((real_t)(elMat_10_0));
             _data_mat[121] = ((real_t)(elMat_10_1));
             _data_mat[122] = ((real_t)(elMat_10_2));
             _data_mat[123] = ((real_t)(elMat_10_3));
             _data_mat[124] = ((real_t)(elMat_10_4));
             _data_mat[125] = ((real_t)(elMat_10_5));
             _data_mat[126] = ((real_t)(elMat_10_6));
             _data_mat[127] = ((real_t)(elMat_10_7));
             _data_mat[128] = ((real_t)(elMat_10_8));
             _data_mat[129] = ((real_t)(elMat_10_9));
             _data_mat[130] = ((real_t)(elMat_10_10));
             _data_mat[131] = ((real_t)(elMat_10_11));
             _data_mat[132] = ((real_t)(elMat_11_0));
             _data_mat[133] = ((real_t)(elMat_11_1));
             _data_mat[134] = ((real_t)(elMat_11_2));
             _data_mat[135] = ((real_t)(elMat_11_3));
             _data_mat[136] = ((real_t)(elMat_11_4));
             _data_mat[137] = ((real_t)(elMat_11_5));
             _data_mat[138] = ((real_t)(elMat_11_6));
             _data_mat[139] = ((real_t)(elMat_11_7));
             _data_mat[140] = ((real_t)(elMat_11_8));
             _data_mat[141] = ((real_t)(elMat_11_9));
             _data_mat[142] = ((real_t)(elMat_11_10));
             _data_mat[143] = ((real_t)(elMat_11_11));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
