/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

























#include "../P1ToP2ElementwiseGradient_2_0.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P1ToP2ElementwiseGradient_2_0::apply_macro_3D( real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_src, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN - jac_affine_2_1_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_2_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_2_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP - jac_affine_2_1_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_2_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_2_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN - jac_affine_2_1_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_2_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_2_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP - jac_affine_2_1_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_2_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_2_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN - jac_affine_2_1_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_2_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_2_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP - jac_affine_2_1_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_2_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_2_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_kernel_op_0 = 2.3416407864998736;
       const real_t tmp_kernel_op_1 = 0.55278640450004202;
       const real_t tmp_kernel_op_2 = 0.55278640450004202;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
       const real_t tmp_kernel_op_5 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_5*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_4);
       const real_t tmp_kernel_op_7 = 0.55278640450004202;
       const real_t tmp_kernel_op_8 = 0.55278640450004202;
       const real_t tmp_kernel_op_9 = 2.3416407864998736;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_8 + tmp_kernel_op_9;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_10 + tmp_kernel_op_7 - 3.0;
       const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_11);
       const real_t tmp_kernel_op_14 = 0.55278640450004202;
       const real_t tmp_kernel_op_15 = 2.3416407864998736;
       const real_t tmp_kernel_op_16 = 0.55278640450004202;
       const real_t tmp_kernel_op_17 = tmp_kernel_op_15 + tmp_kernel_op_16;
       const real_t tmp_kernel_op_18 = tmp_kernel_op_14 + tmp_kernel_op_17 - 3.0;
       const real_t tmp_kernel_op_19 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_19*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_18);
       const real_t tmp_kernel_op_21 = 0.55278640450004202;
       const real_t tmp_kernel_op_22 = 0.55278640450004202;
       const real_t tmp_kernel_op_23 = 0.55278640450004202;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_22 + tmp_kernel_op_23;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_21 + tmp_kernel_op_24 - 3.0;
       const real_t tmp_kernel_op_26 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_26*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_25);
       const real_t tmp_kernel_op_28 = 0.13819660112501053;
       const real_t tmp_kernel_op_29 = 0.13819660112501056;
       const real_t tmp_kernel_op_30 = 0.13819660112501056;
       const real_t tmp_kernel_op_31 = 0.5854101966249684;
       const real_t tmp_kernel_op_32 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_kernel_op_33 = tmp_kernel_op_32*tmp_kernel_op_5;
       const real_t tmp_kernel_op_34 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_kernel_op_35 = tmp_kernel_op_12*tmp_kernel_op_34;
       const real_t tmp_kernel_op_36 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_kernel_op_37 = tmp_kernel_op_19*tmp_kernel_op_36;
       const real_t tmp_kernel_op_38 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_kernel_op_39 = tmp_kernel_op_26*tmp_kernel_op_38;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_28*tmp_kernel_op_5;
       const real_t tmp_kernel_op_41 = tmp_kernel_op_12*tmp_kernel_op_29;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_19*tmp_kernel_op_30;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_26*tmp_kernel_op_31;
       const real_t tmp_kernel_op_44 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_kernel_op_45 = tmp_kernel_op_44*tmp_kernel_op_5;
       const real_t tmp_kernel_op_46 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_kernel_op_47 = tmp_kernel_op_12*tmp_kernel_op_46;
       const real_t tmp_kernel_op_48 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_kernel_op_49 = tmp_kernel_op_19*tmp_kernel_op_48;
       const real_t tmp_kernel_op_50 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_kernel_op_51 = tmp_kernel_op_26*tmp_kernel_op_50;
       const real_t tmp_kernel_op_52 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_kernel_op_53 = tmp_kernel_op_5*tmp_kernel_op_52;
       const real_t tmp_kernel_op_54 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_kernel_op_55 = tmp_kernel_op_12*tmp_kernel_op_54;
       const real_t tmp_kernel_op_56 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_kernel_op_57 = tmp_kernel_op_19*tmp_kernel_op_56;
       const real_t tmp_kernel_op_58 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_kernel_op_59 = tmp_kernel_op_26*tmp_kernel_op_58;
       const real_t tmp_kernel_op_60 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_61 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_5*(-tmp_kernel_op_60 - tmp_kernel_op_61);
       const real_t tmp_kernel_op_63 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_64 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_65 = tmp_kernel_op_12*(-tmp_kernel_op_63 - tmp_kernel_op_64);
       const real_t tmp_kernel_op_66 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_14;
       const real_t tmp_kernel_op_67 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_68 = tmp_kernel_op_19*(-tmp_kernel_op_66 - tmp_kernel_op_67);
       const real_t tmp_kernel_op_69 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_21;
       const real_t tmp_kernel_op_70 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_71 = tmp_kernel_op_26*(-tmp_kernel_op_69 - tmp_kernel_op_70);
       const real_t tmp_kernel_op_72 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_73 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_74 = tmp_kernel_op_5*(-tmp_kernel_op_72 - tmp_kernel_op_73);
       const real_t tmp_kernel_op_75 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_76 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_77 = tmp_kernel_op_12*(-tmp_kernel_op_75 - tmp_kernel_op_76);
       const real_t tmp_kernel_op_78 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_14;
       const real_t tmp_kernel_op_79 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_80 = tmp_kernel_op_19*(-tmp_kernel_op_78 - tmp_kernel_op_79);
       const real_t tmp_kernel_op_81 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_21;
       const real_t tmp_kernel_op_82 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_83 = tmp_kernel_op_26*(-tmp_kernel_op_81 - tmp_kernel_op_82);
       const real_t tmp_kernel_op_84 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_85 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_86 = tmp_kernel_op_5*(-tmp_kernel_op_84 - tmp_kernel_op_85);
       const real_t tmp_kernel_op_87 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_88 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_89 = tmp_kernel_op_12*(-tmp_kernel_op_87 - tmp_kernel_op_88);
       const real_t tmp_kernel_op_90 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_91 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_15;
       const real_t tmp_kernel_op_92 = tmp_kernel_op_19*(-tmp_kernel_op_90 - tmp_kernel_op_91);
       const real_t tmp_kernel_op_93 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_23;
       const real_t tmp_kernel_op_94 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_95 = tmp_kernel_op_26*(-tmp_kernel_op_93 - tmp_kernel_op_94);
       const real_t tmp_kernel_op_96 = tmp_kernel_op_5*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_kernel_op_60 + tmp_kernel_op_72);
       const real_t tmp_kernel_op_97 = tmp_kernel_op_12*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_kernel_op_63 + tmp_kernel_op_75);
       const real_t tmp_kernel_op_98 = tmp_kernel_op_19*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_kernel_op_66 + tmp_kernel_op_78);
       const real_t tmp_kernel_op_99 = tmp_kernel_op_26*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_kernel_op_69 + tmp_kernel_op_81);
       const real_t tmp_kernel_op_100 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_101 = tmp_kernel_op_5*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_kernel_op_61 + tmp_kernel_op_84);
       const real_t tmp_kernel_op_102 = tmp_kernel_op_7 - 4.0;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_12*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_kernel_op_64 + tmp_kernel_op_87);
       const real_t tmp_kernel_op_104 = tmp_kernel_op_14 - 4.0;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_19*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_kernel_op_67 + tmp_kernel_op_90);
       const real_t tmp_kernel_op_106 = tmp_kernel_op_21 - 4.0;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_26*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_kernel_op_70 + tmp_kernel_op_93);
       const real_t tmp_kernel_op_108 = tmp_kernel_op_5*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_kernel_op_73 + tmp_kernel_op_85);
       const real_t tmp_kernel_op_109 = tmp_kernel_op_12*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_kernel_op_76 + tmp_kernel_op_88);
       const real_t tmp_kernel_op_110 = tmp_kernel_op_19*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_kernel_op_79 + tmp_kernel_op_91);
       const real_t tmp_kernel_op_111 = tmp_kernel_op_26*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_kernel_op_82 + tmp_kernel_op_94);
       const real_t tmp_moved_constant_4 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_5 = tmp_moved_constant_4*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_4);
       const real_t tmp_moved_constant_6 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_7 = tmp_moved_constant_6*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_11 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_11 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_11);
       const real_t tmp_moved_constant_8 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_9 = tmp_moved_constant_8*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_18 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_18 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_18);
       const real_t tmp_moved_constant_10 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_11 = tmp_moved_constant_10*(-jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_25 - jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_25);
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_13 = tmp_moved_constant_12*tmp_moved_constant_4;
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_15 = tmp_moved_constant_14*tmp_moved_constant_6;
       const real_t tmp_moved_constant_16 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_moved_constant_17 = tmp_moved_constant_16*tmp_moved_constant_8;
       const real_t tmp_moved_constant_18 = jac_affine_inv_0_2_WHITE_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_19 = tmp_moved_constant_10*tmp_moved_constant_18;
       const real_t tmp_moved_constant_20 = tmp_kernel_op_28*tmp_moved_constant_4;
       const real_t tmp_moved_constant_21 = tmp_kernel_op_29*tmp_moved_constant_6;
       const real_t tmp_moved_constant_22 = tmp_kernel_op_30*tmp_moved_constant_8;
       const real_t tmp_moved_constant_23 = tmp_kernel_op_31*tmp_moved_constant_10;
       const real_t tmp_moved_constant_24 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_25 = tmp_moved_constant_24*tmp_moved_constant_4;
       const real_t tmp_moved_constant_26 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_27 = tmp_moved_constant_26*tmp_moved_constant_6;
       const real_t tmp_moved_constant_28 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_29 = tmp_moved_constant_28*tmp_moved_constant_8;
       const real_t tmp_moved_constant_30 = jac_affine_inv_1_2_WHITE_DOWN*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_moved_constant_31 = tmp_moved_constant_10*tmp_moved_constant_30;
       const real_t tmp_moved_constant_32 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_33 = tmp_moved_constant_32*tmp_moved_constant_4;
       const real_t tmp_moved_constant_34 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_moved_constant_35 = tmp_moved_constant_34*tmp_moved_constant_6;
       const real_t tmp_moved_constant_36 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_37 = tmp_moved_constant_36*tmp_moved_constant_8;
       const real_t tmp_moved_constant_38 = jac_affine_inv_2_2_WHITE_DOWN*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_moved_constant_39 = tmp_moved_constant_10*tmp_moved_constant_38;
       const real_t tmp_moved_constant_40 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_41 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_42 = tmp_moved_constant_4*(-tmp_moved_constant_40 - tmp_moved_constant_41);
       const real_t tmp_moved_constant_43 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_44 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_45 = tmp_moved_constant_6*(-tmp_moved_constant_43 - tmp_moved_constant_44);
       const real_t tmp_moved_constant_46 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_47 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_48 = tmp_moved_constant_8*(-tmp_moved_constant_46 - tmp_moved_constant_47);
       const real_t tmp_moved_constant_49 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_50 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_51 = tmp_moved_constant_10*(-tmp_moved_constant_49 - tmp_moved_constant_50);
       const real_t tmp_moved_constant_52 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_53 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_54 = tmp_moved_constant_4*(-tmp_moved_constant_52 - tmp_moved_constant_53);
       const real_t tmp_moved_constant_55 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_56 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_57 = tmp_moved_constant_6*(-tmp_moved_constant_55 - tmp_moved_constant_56);
       const real_t tmp_moved_constant_58 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_59 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_60 = tmp_moved_constant_8*(-tmp_moved_constant_58 - tmp_moved_constant_59);
       const real_t tmp_moved_constant_61 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_62 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_63 = tmp_moved_constant_10*(-tmp_moved_constant_61 - tmp_moved_constant_62);
       const real_t tmp_moved_constant_64 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_65 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_66 = tmp_moved_constant_4*(-tmp_moved_constant_64 - tmp_moved_constant_65);
       const real_t tmp_moved_constant_67 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_68 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_69 = tmp_moved_constant_6*(-tmp_moved_constant_67 - tmp_moved_constant_68);
       const real_t tmp_moved_constant_70 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_71 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_72 = tmp_moved_constant_8*(-tmp_moved_constant_70 - tmp_moved_constant_71);
       const real_t tmp_moved_constant_73 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_74 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_75 = tmp_moved_constant_10*(-tmp_moved_constant_73 - tmp_moved_constant_74);
       const real_t tmp_moved_constant_76 = tmp_moved_constant_4*(-jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_40 + tmp_moved_constant_52);
       const real_t tmp_moved_constant_77 = tmp_moved_constant_6*(-jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_43 + tmp_moved_constant_55);
       const real_t tmp_moved_constant_78 = tmp_moved_constant_8*(-jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_46 + tmp_moved_constant_58);
       const real_t tmp_moved_constant_79 = tmp_moved_constant_10*(-jac_affine_inv_2_2_WHITE_DOWN*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_49 + tmp_moved_constant_61);
       const real_t tmp_moved_constant_80 = tmp_moved_constant_4*(-jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_41 + tmp_moved_constant_64);
       const real_t tmp_moved_constant_81 = tmp_moved_constant_6*(-jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_44 + tmp_moved_constant_67);
       const real_t tmp_moved_constant_82 = tmp_moved_constant_8*(-jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_47 + tmp_moved_constant_70);
       const real_t tmp_moved_constant_83 = tmp_moved_constant_10*(-jac_affine_inv_1_2_WHITE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_50 + tmp_moved_constant_73);
       const real_t tmp_moved_constant_84 = tmp_moved_constant_4*(-jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_53 + tmp_moved_constant_65);
       const real_t tmp_moved_constant_85 = tmp_moved_constant_6*(-jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_56 + tmp_moved_constant_68);
       const real_t tmp_moved_constant_86 = tmp_moved_constant_8*(-jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_59 + tmp_moved_constant_71);
       const real_t tmp_moved_constant_87 = tmp_moved_constant_10*(-jac_affine_inv_0_2_WHITE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_62 + tmp_moved_constant_74);
       const real_t tmp_moved_constant_102 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_103 = tmp_moved_constant_102*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_4);
       const real_t tmp_moved_constant_104 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_105 = tmp_moved_constant_104*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_11);
       const real_t tmp_moved_constant_106 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_107 = tmp_moved_constant_106*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_18);
       const real_t tmp_moved_constant_108 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
       const real_t tmp_moved_constant_109 = tmp_moved_constant_108*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_25);
       const real_t tmp_moved_constant_110 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_111 = tmp_moved_constant_102*tmp_moved_constant_110;
       const real_t tmp_moved_constant_112 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_113 = tmp_moved_constant_104*tmp_moved_constant_112;
       const real_t tmp_moved_constant_114 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_moved_constant_115 = tmp_moved_constant_106*tmp_moved_constant_114;
       const real_t tmp_moved_constant_116 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_117 = tmp_moved_constant_108*tmp_moved_constant_116;
       const real_t tmp_moved_constant_118 = tmp_kernel_op_28*tmp_moved_constant_102;
       const real_t tmp_moved_constant_119 = tmp_kernel_op_29*tmp_moved_constant_104;
       const real_t tmp_moved_constant_120 = tmp_kernel_op_30*tmp_moved_constant_106;
       const real_t tmp_moved_constant_121 = tmp_kernel_op_31*tmp_moved_constant_108;
       const real_t tmp_moved_constant_122 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_123 = tmp_moved_constant_102*tmp_moved_constant_122;
       const real_t tmp_moved_constant_124 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_125 = tmp_moved_constant_104*tmp_moved_constant_124;
       const real_t tmp_moved_constant_126 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_127 = tmp_moved_constant_106*tmp_moved_constant_126;
       const real_t tmp_moved_constant_128 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_moved_constant_129 = tmp_moved_constant_108*tmp_moved_constant_128;
       const real_t tmp_moved_constant_130 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_131 = tmp_moved_constant_102*tmp_moved_constant_130;
       const real_t tmp_moved_constant_132 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_moved_constant_133 = tmp_moved_constant_104*tmp_moved_constant_132;
       const real_t tmp_moved_constant_134 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_135 = tmp_moved_constant_106*tmp_moved_constant_134;
       const real_t tmp_moved_constant_136 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_moved_constant_137 = tmp_moved_constant_108*tmp_moved_constant_136;
       const real_t tmp_moved_constant_138 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_139 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_140 = tmp_moved_constant_102*(-tmp_moved_constant_138 - tmp_moved_constant_139);
       const real_t tmp_moved_constant_141 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_7;
       const real_t tmp_moved_constant_142 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_143 = tmp_moved_constant_104*(-tmp_moved_constant_141 - tmp_moved_constant_142);
       const real_t tmp_moved_constant_144 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_145 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_146 = tmp_moved_constant_106*(-tmp_moved_constant_144 - tmp_moved_constant_145);
       const real_t tmp_moved_constant_147 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_21;
       const real_t tmp_moved_constant_148 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_149 = tmp_moved_constant_108*(-tmp_moved_constant_147 - tmp_moved_constant_148);
       const real_t tmp_moved_constant_150 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_151 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_152 = tmp_moved_constant_102*(-tmp_moved_constant_150 - tmp_moved_constant_151);
       const real_t tmp_moved_constant_153 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_7;
       const real_t tmp_moved_constant_154 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_155 = tmp_moved_constant_104*(-tmp_moved_constant_153 - tmp_moved_constant_154);
       const real_t tmp_moved_constant_156 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_157 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_158 = tmp_moved_constant_106*(-tmp_moved_constant_156 - tmp_moved_constant_157);
       const real_t tmp_moved_constant_159 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_21;
       const real_t tmp_moved_constant_160 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_161 = tmp_moved_constant_108*(-tmp_moved_constant_159 - tmp_moved_constant_160);
       const real_t tmp_moved_constant_162 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_163 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_164 = tmp_moved_constant_102*(-tmp_moved_constant_162 - tmp_moved_constant_163);
       const real_t tmp_moved_constant_165 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_166 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_167 = tmp_moved_constant_104*(-tmp_moved_constant_165 - tmp_moved_constant_166);
       const real_t tmp_moved_constant_168 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_169 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_170 = tmp_moved_constant_106*(-tmp_moved_constant_168 - tmp_moved_constant_169);
       const real_t tmp_moved_constant_171 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_172 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_173 = tmp_moved_constant_108*(-tmp_moved_constant_171 - tmp_moved_constant_172);
       const real_t tmp_moved_constant_174 = tmp_moved_constant_102*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_138 + tmp_moved_constant_150);
       const real_t tmp_moved_constant_175 = tmp_moved_constant_104*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_141 + tmp_moved_constant_153);
       const real_t tmp_moved_constant_176 = tmp_moved_constant_106*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_144 + tmp_moved_constant_156);
       const real_t tmp_moved_constant_177 = tmp_moved_constant_108*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_147 + tmp_moved_constant_159);
       const real_t tmp_moved_constant_178 = tmp_moved_constant_102*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_139 + tmp_moved_constant_162);
       const real_t tmp_moved_constant_179 = tmp_moved_constant_104*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_142 + tmp_moved_constant_165);
       const real_t tmp_moved_constant_180 = tmp_moved_constant_106*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_145 + tmp_moved_constant_168);
       const real_t tmp_moved_constant_181 = tmp_moved_constant_108*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_148 + tmp_moved_constant_171);
       const real_t tmp_moved_constant_182 = tmp_moved_constant_102*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_151 + tmp_moved_constant_163);
       const real_t tmp_moved_constant_183 = tmp_moved_constant_104*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_154 + tmp_moved_constant_166);
       const real_t tmp_moved_constant_184 = tmp_moved_constant_106*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_157 + tmp_moved_constant_169);
       const real_t tmp_moved_constant_185 = tmp_moved_constant_108*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_160 + tmp_moved_constant_172);
       const real_t tmp_moved_constant_200 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_201 = tmp_moved_constant_200*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_4);
       const real_t tmp_moved_constant_202 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_203 = tmp_moved_constant_202*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_11 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_11 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_11);
       const real_t tmp_moved_constant_204 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_205 = tmp_moved_constant_204*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_18 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_18 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_18);
       const real_t tmp_moved_constant_206 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_207 = tmp_moved_constant_206*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_25 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_25 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_25);
       const real_t tmp_moved_constant_208 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_209 = tmp_moved_constant_200*tmp_moved_constant_208;
       const real_t tmp_moved_constant_210 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_211 = tmp_moved_constant_202*tmp_moved_constant_210;
       const real_t tmp_moved_constant_212 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_moved_constant_213 = tmp_moved_constant_204*tmp_moved_constant_212;
       const real_t tmp_moved_constant_214 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_215 = tmp_moved_constant_206*tmp_moved_constant_214;
       const real_t tmp_moved_constant_216 = tmp_kernel_op_28*tmp_moved_constant_200;
       const real_t tmp_moved_constant_217 = tmp_kernel_op_29*tmp_moved_constant_202;
       const real_t tmp_moved_constant_218 = tmp_kernel_op_30*tmp_moved_constant_204;
       const real_t tmp_moved_constant_219 = tmp_kernel_op_31*tmp_moved_constant_206;
       const real_t tmp_moved_constant_220 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_221 = tmp_moved_constant_200*tmp_moved_constant_220;
       const real_t tmp_moved_constant_222 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_223 = tmp_moved_constant_202*tmp_moved_constant_222;
       const real_t tmp_moved_constant_224 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_225 = tmp_moved_constant_204*tmp_moved_constant_224;
       const real_t tmp_moved_constant_226 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_moved_constant_227 = tmp_moved_constant_206*tmp_moved_constant_226;
       const real_t tmp_moved_constant_228 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_229 = tmp_moved_constant_200*tmp_moved_constant_228;
       const real_t tmp_moved_constant_230 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_moved_constant_231 = tmp_moved_constant_202*tmp_moved_constant_230;
       const real_t tmp_moved_constant_232 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_233 = tmp_moved_constant_204*tmp_moved_constant_232;
       const real_t tmp_moved_constant_234 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_moved_constant_235 = tmp_moved_constant_206*tmp_moved_constant_234;
       const real_t tmp_moved_constant_236 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_237 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_238 = tmp_moved_constant_200*(-tmp_moved_constant_236 - tmp_moved_constant_237);
       const real_t tmp_moved_constant_239 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_240 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_241 = tmp_moved_constant_202*(-tmp_moved_constant_239 - tmp_moved_constant_240);
       const real_t tmp_moved_constant_242 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_243 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_244 = tmp_moved_constant_204*(-tmp_moved_constant_242 - tmp_moved_constant_243);
       const real_t tmp_moved_constant_245 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_246 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_247 = tmp_moved_constant_206*(-tmp_moved_constant_245 - tmp_moved_constant_246);
       const real_t tmp_moved_constant_248 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_249 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_250 = tmp_moved_constant_200*(-tmp_moved_constant_248 - tmp_moved_constant_249);
       const real_t tmp_moved_constant_251 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_252 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_253 = tmp_moved_constant_202*(-tmp_moved_constant_251 - tmp_moved_constant_252);
       const real_t tmp_moved_constant_254 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_255 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_256 = tmp_moved_constant_204*(-tmp_moved_constant_254 - tmp_moved_constant_255);
       const real_t tmp_moved_constant_257 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_258 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_259 = tmp_moved_constant_206*(-tmp_moved_constant_257 - tmp_moved_constant_258);
       const real_t tmp_moved_constant_260 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_261 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_262 = tmp_moved_constant_200*(-tmp_moved_constant_260 - tmp_moved_constant_261);
       const real_t tmp_moved_constant_263 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_264 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_265 = tmp_moved_constant_202*(-tmp_moved_constant_263 - tmp_moved_constant_264);
       const real_t tmp_moved_constant_266 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_267 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_268 = tmp_moved_constant_204*(-tmp_moved_constant_266 - tmp_moved_constant_267);
       const real_t tmp_moved_constant_269 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_270 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_271 = tmp_moved_constant_206*(-tmp_moved_constant_269 - tmp_moved_constant_270);
       const real_t tmp_moved_constant_272 = tmp_moved_constant_200*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_236 + tmp_moved_constant_248);
       const real_t tmp_moved_constant_273 = tmp_moved_constant_202*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_239 + tmp_moved_constant_251);
       const real_t tmp_moved_constant_274 = tmp_moved_constant_204*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_242 + tmp_moved_constant_254);
       const real_t tmp_moved_constant_275 = tmp_moved_constant_206*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_245 + tmp_moved_constant_257);
       const real_t tmp_moved_constant_276 = tmp_moved_constant_200*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_237 + tmp_moved_constant_260);
       const real_t tmp_moved_constant_277 = tmp_moved_constant_202*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_240 + tmp_moved_constant_263);
       const real_t tmp_moved_constant_278 = tmp_moved_constant_204*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_243 + tmp_moved_constant_266);
       const real_t tmp_moved_constant_279 = tmp_moved_constant_206*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_246 + tmp_moved_constant_269);
       const real_t tmp_moved_constant_280 = tmp_moved_constant_200*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_249 + tmp_moved_constant_261);
       const real_t tmp_moved_constant_281 = tmp_moved_constant_202*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_252 + tmp_moved_constant_264);
       const real_t tmp_moved_constant_282 = tmp_moved_constant_204*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_255 + tmp_moved_constant_267);
       const real_t tmp_moved_constant_283 = tmp_moved_constant_206*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_258 + tmp_moved_constant_270);
       const real_t tmp_moved_constant_298 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_299 = tmp_moved_constant_298*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_4);
       const real_t tmp_moved_constant_300 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_301 = tmp_moved_constant_300*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_11);
       const real_t tmp_moved_constant_302 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_303 = tmp_moved_constant_302*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_18);
       const real_t tmp_moved_constant_304 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
       const real_t tmp_moved_constant_305 = tmp_moved_constant_304*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_25);
       const real_t tmp_moved_constant_306 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_307 = tmp_moved_constant_298*tmp_moved_constant_306;
       const real_t tmp_moved_constant_308 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_309 = tmp_moved_constant_300*tmp_moved_constant_308;
       const real_t tmp_moved_constant_310 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_moved_constant_311 = tmp_moved_constant_302*tmp_moved_constant_310;
       const real_t tmp_moved_constant_312 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_313 = tmp_moved_constant_304*tmp_moved_constant_312;
       const real_t tmp_moved_constant_314 = tmp_kernel_op_28*tmp_moved_constant_298;
       const real_t tmp_moved_constant_315 = tmp_kernel_op_29*tmp_moved_constant_300;
       const real_t tmp_moved_constant_316 = tmp_kernel_op_30*tmp_moved_constant_302;
       const real_t tmp_moved_constant_317 = tmp_kernel_op_31*tmp_moved_constant_304;
       const real_t tmp_moved_constant_318 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_319 = tmp_moved_constant_298*tmp_moved_constant_318;
       const real_t tmp_moved_constant_320 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_321 = tmp_moved_constant_300*tmp_moved_constant_320;
       const real_t tmp_moved_constant_322 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_323 = tmp_moved_constant_302*tmp_moved_constant_322;
       const real_t tmp_moved_constant_324 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_moved_constant_325 = tmp_moved_constant_304*tmp_moved_constant_324;
       const real_t tmp_moved_constant_326 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_327 = tmp_moved_constant_298*tmp_moved_constant_326;
       const real_t tmp_moved_constant_328 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_moved_constant_329 = tmp_moved_constant_300*tmp_moved_constant_328;
       const real_t tmp_moved_constant_330 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_331 = tmp_moved_constant_302*tmp_moved_constant_330;
       const real_t tmp_moved_constant_332 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_moved_constant_333 = tmp_moved_constant_304*tmp_moved_constant_332;
       const real_t tmp_moved_constant_334 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_335 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_336 = tmp_moved_constant_298*(-tmp_moved_constant_334 - tmp_moved_constant_335);
       const real_t tmp_moved_constant_337 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_7;
       const real_t tmp_moved_constant_338 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_339 = tmp_moved_constant_300*(-tmp_moved_constant_337 - tmp_moved_constant_338);
       const real_t tmp_moved_constant_340 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_341 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_342 = tmp_moved_constant_302*(-tmp_moved_constant_340 - tmp_moved_constant_341);
       const real_t tmp_moved_constant_343 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_21;
       const real_t tmp_moved_constant_344 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_345 = tmp_moved_constant_304*(-tmp_moved_constant_343 - tmp_moved_constant_344);
       const real_t tmp_moved_constant_346 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_347 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_348 = tmp_moved_constant_298*(-tmp_moved_constant_346 - tmp_moved_constant_347);
       const real_t tmp_moved_constant_349 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_7;
       const real_t tmp_moved_constant_350 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_351 = tmp_moved_constant_300*(-tmp_moved_constant_349 - tmp_moved_constant_350);
       const real_t tmp_moved_constant_352 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_14;
       const real_t tmp_moved_constant_353 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_354 = tmp_moved_constant_302*(-tmp_moved_constant_352 - tmp_moved_constant_353);
       const real_t tmp_moved_constant_355 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_21;
       const real_t tmp_moved_constant_356 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_357 = tmp_moved_constant_304*(-tmp_moved_constant_355 - tmp_moved_constant_356);
       const real_t tmp_moved_constant_358 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_359 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_360 = tmp_moved_constant_298*(-tmp_moved_constant_358 - tmp_moved_constant_359);
       const real_t tmp_moved_constant_361 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_362 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_8;
       const real_t tmp_moved_constant_363 = tmp_moved_constant_300*(-tmp_moved_constant_361 - tmp_moved_constant_362);
       const real_t tmp_moved_constant_364 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_16;
       const real_t tmp_moved_constant_365 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_15;
       const real_t tmp_moved_constant_366 = tmp_moved_constant_302*(-tmp_moved_constant_364 - tmp_moved_constant_365);
       const real_t tmp_moved_constant_367 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_23;
       const real_t tmp_moved_constant_368 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_369 = tmp_moved_constant_304*(-tmp_moved_constant_367 - tmp_moved_constant_368);
       const real_t tmp_moved_constant_370 = tmp_moved_constant_298*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_334 + tmp_moved_constant_346);
       const real_t tmp_moved_constant_371 = tmp_moved_constant_300*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_337 + tmp_moved_constant_349);
       const real_t tmp_moved_constant_372 = tmp_moved_constant_302*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_340 + tmp_moved_constant_352);
       const real_t tmp_moved_constant_373 = tmp_moved_constant_304*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_343 + tmp_moved_constant_355);
       const real_t tmp_moved_constant_374 = tmp_moved_constant_298*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_335 + tmp_moved_constant_358);
       const real_t tmp_moved_constant_375 = tmp_moved_constant_300*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_338 + tmp_moved_constant_361);
       const real_t tmp_moved_constant_376 = tmp_moved_constant_302*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_341 + tmp_moved_constant_364);
       const real_t tmp_moved_constant_377 = tmp_moved_constant_304*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_344 + tmp_moved_constant_367);
       const real_t tmp_moved_constant_378 = tmp_moved_constant_298*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_347 + tmp_moved_constant_359);
       const real_t tmp_moved_constant_379 = tmp_moved_constant_300*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_350 + tmp_moved_constant_362);
       const real_t tmp_moved_constant_380 = tmp_moved_constant_302*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_353 + tmp_moved_constant_365);
       const real_t tmp_moved_constant_381 = tmp_moved_constant_304*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_356 + tmp_moved_constant_368);
       const real_t tmp_moved_constant_396 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_397 = tmp_moved_constant_396*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_4);
       const real_t tmp_moved_constant_398 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_399 = tmp_moved_constant_398*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_11 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_11 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_11);
       const real_t tmp_moved_constant_400 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_401 = tmp_moved_constant_400*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_18 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_18 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_18);
       const real_t tmp_moved_constant_402 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
       const real_t tmp_moved_constant_403 = tmp_moved_constant_402*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_25 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_25 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_25);
       const real_t tmp_moved_constant_404 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_1 - 1.0);
       const real_t tmp_moved_constant_405 = tmp_moved_constant_396*tmp_moved_constant_404;
       const real_t tmp_moved_constant_406 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_8 - 1.0);
       const real_t tmp_moved_constant_407 = tmp_moved_constant_398*tmp_moved_constant_406;
       const real_t tmp_moved_constant_408 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_15 - 1.0);
       const real_t tmp_moved_constant_409 = tmp_moved_constant_400*tmp_moved_constant_408;
       const real_t tmp_moved_constant_410 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_22 - 1.0);
       const real_t tmp_moved_constant_411 = tmp_moved_constant_402*tmp_moved_constant_410;
       const real_t tmp_moved_constant_412 = tmp_kernel_op_28*tmp_moved_constant_396;
       const real_t tmp_moved_constant_413 = tmp_kernel_op_29*tmp_moved_constant_398;
       const real_t tmp_moved_constant_414 = tmp_kernel_op_30*tmp_moved_constant_400;
       const real_t tmp_moved_constant_415 = tmp_kernel_op_31*tmp_moved_constant_402;
       const real_t tmp_moved_constant_416 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
       const real_t tmp_moved_constant_417 = tmp_moved_constant_396*tmp_moved_constant_416;
       const real_t tmp_moved_constant_418 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_9 - 1.0);
       const real_t tmp_moved_constant_419 = tmp_moved_constant_398*tmp_moved_constant_418;
       const real_t tmp_moved_constant_420 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
       const real_t tmp_moved_constant_421 = tmp_moved_constant_400*tmp_moved_constant_420;
       const real_t tmp_moved_constant_422 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_23 - 1.0);
       const real_t tmp_moved_constant_423 = tmp_moved_constant_402*tmp_moved_constant_422;
       const real_t tmp_moved_constant_424 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_0 - 1.0);
       const real_t tmp_moved_constant_425 = tmp_moved_constant_396*tmp_moved_constant_424;
       const real_t tmp_moved_constant_426 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_7 - 1.0);
       const real_t tmp_moved_constant_427 = tmp_moved_constant_398*tmp_moved_constant_426;
       const real_t tmp_moved_constant_428 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_14 - 1.0);
       const real_t tmp_moved_constant_429 = tmp_moved_constant_400*tmp_moved_constant_428;
       const real_t tmp_moved_constant_430 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_21 - 1.0);
       const real_t tmp_moved_constant_431 = tmp_moved_constant_402*tmp_moved_constant_430;
       const real_t tmp_moved_constant_432 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_433 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_434 = tmp_moved_constant_396*(-tmp_moved_constant_432 - tmp_moved_constant_433);
       const real_t tmp_moved_constant_435 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_436 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_437 = tmp_moved_constant_398*(-tmp_moved_constant_435 - tmp_moved_constant_436);
       const real_t tmp_moved_constant_438 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_439 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_440 = tmp_moved_constant_400*(-tmp_moved_constant_438 - tmp_moved_constant_439);
       const real_t tmp_moved_constant_441 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_442 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_443 = tmp_moved_constant_402*(-tmp_moved_constant_441 - tmp_moved_constant_442);
       const real_t tmp_moved_constant_444 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_445 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_446 = tmp_moved_constant_396*(-tmp_moved_constant_444 - tmp_moved_constant_445);
       const real_t tmp_moved_constant_447 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_7;
       const real_t tmp_moved_constant_448 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_449 = tmp_moved_constant_398*(-tmp_moved_constant_447 - tmp_moved_constant_448);
       const real_t tmp_moved_constant_450 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_14;
       const real_t tmp_moved_constant_451 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_452 = tmp_moved_constant_400*(-tmp_moved_constant_450 - tmp_moved_constant_451);
       const real_t tmp_moved_constant_453 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_21;
       const real_t tmp_moved_constant_454 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_455 = tmp_moved_constant_402*(-tmp_moved_constant_453 - tmp_moved_constant_454);
       const real_t tmp_moved_constant_456 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_457 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_458 = tmp_moved_constant_396*(-tmp_moved_constant_456 - tmp_moved_constant_457);
       const real_t tmp_moved_constant_459 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_460 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_8;
       const real_t tmp_moved_constant_461 = tmp_moved_constant_398*(-tmp_moved_constant_459 - tmp_moved_constant_460);
       const real_t tmp_moved_constant_462 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_16;
       const real_t tmp_moved_constant_463 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_15;
       const real_t tmp_moved_constant_464 = tmp_moved_constant_400*(-tmp_moved_constant_462 - tmp_moved_constant_463);
       const real_t tmp_moved_constant_465 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_23;
       const real_t tmp_moved_constant_466 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_467 = tmp_moved_constant_402*(-tmp_moved_constant_465 - tmp_moved_constant_466);
       const real_t tmp_moved_constant_468 = tmp_moved_constant_396*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_432 + tmp_moved_constant_444);
       const real_t tmp_moved_constant_469 = tmp_moved_constant_398*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_435 + tmp_moved_constant_447);
       const real_t tmp_moved_constant_470 = tmp_moved_constant_400*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_438 + tmp_moved_constant_450);
       const real_t tmp_moved_constant_471 = tmp_moved_constant_402*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_441 + tmp_moved_constant_453);
       const real_t tmp_moved_constant_472 = tmp_moved_constant_396*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_433 + tmp_moved_constant_456);
       const real_t tmp_moved_constant_473 = tmp_moved_constant_398*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_436 + tmp_moved_constant_459);
       const real_t tmp_moved_constant_474 = tmp_moved_constant_400*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_439 + tmp_moved_constant_462);
       const real_t tmp_moved_constant_475 = tmp_moved_constant_402*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_442 + tmp_moved_constant_465);
       const real_t tmp_moved_constant_476 = tmp_moved_constant_396*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_445 + tmp_moved_constant_457);
       const real_t tmp_moved_constant_477 = tmp_moved_constant_398*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_448 + tmp_moved_constant_460);
       const real_t tmp_moved_constant_478 = tmp_moved_constant_400*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_451 + tmp_moved_constant_463);
       const real_t tmp_moved_constant_479 = tmp_moved_constant_402*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_454 + tmp_moved_constant_466);
       for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
       for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
       {
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)))));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)))));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95)))));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99)))));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101),_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)))));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108),_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_0 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_1 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_2 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_3 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))));
                const __m256d tmp_moved_constant_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16)),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)))));
                const __m256d tmp_moved_constant_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)),_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22)),_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)),_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)))));
                const __m256d tmp_moved_constant_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)),_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22)),_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)),_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38)))));
                const __m256d tmp_moved_constant_92 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)))));
                const __m256d tmp_moved_constant_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60,tmp_moved_constant_60))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63,tmp_moved_constant_63)))));
                const __m256d tmp_moved_constant_94 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66,tmp_moved_constant_66)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69,tmp_moved_constant_69))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72,tmp_moved_constant_72))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75,tmp_moved_constant_75)))));
                const __m256d tmp_moved_constant_95 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76,tmp_moved_constant_76)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78,tmp_moved_constant_78))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79,tmp_moved_constant_79)))));
                const __m256d tmp_moved_constant_96 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81,tmp_moved_constant_81))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82,tmp_moved_constant_82))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83)))));
                const __m256d tmp_moved_constant_97 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86)))),_mm256_mul_pd(tmp_moved_constant_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))))),_mm256_mul_pd(tmp_moved_constant_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84))))),_mm256_mul_pd(tmp_moved_constant_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84,tmp_moved_constant_84)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85,tmp_moved_constant_85))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87,tmp_moved_constant_87)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_88,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_89,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_90,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_91,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_92,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_93,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_94,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_95,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_96,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_97,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                   }
                }
                const __m256d tmp_moved_constant_98 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_99 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_100 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_101 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103,tmp_moved_constant_103)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105,tmp_moved_constant_105))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109,tmp_moved_constant_109)))));
                const __m256d tmp_moved_constant_187 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115,tmp_moved_constant_115))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117,tmp_moved_constant_117))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111,tmp_moved_constant_111))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110)),_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112,tmp_moved_constant_112)),_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114,tmp_moved_constant_114)),_mm256_set_pd(tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121)))));
                const __m256d tmp_moved_constant_188 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127,tmp_moved_constant_127))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129,tmp_moved_constant_129))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123,tmp_moved_constant_123))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118)),_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119)),_mm256_set_pd(tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124,tmp_moved_constant_124))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120)),_mm256_set_pd(tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126,tmp_moved_constant_126))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121)),_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128)))));
                const __m256d tmp_moved_constant_189 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133,tmp_moved_constant_133)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135,tmp_moved_constant_135))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118,tmp_moved_constant_118)),_mm256_set_pd(tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130,tmp_moved_constant_130)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119)),_mm256_set_pd(tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132,tmp_moved_constant_132))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120,tmp_moved_constant_120)),_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121,tmp_moved_constant_121)),_mm256_set_pd(tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136,tmp_moved_constant_136)))));
                const __m256d tmp_moved_constant_190 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149)))));
                const __m256d tmp_moved_constant_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)))));
                const __m256d tmp_moved_constant_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173)))));
                const __m256d tmp_moved_constant_193 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174,tmp_moved_constant_174)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175,tmp_moved_constant_175))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177,tmp_moved_constant_177)))));
                const __m256d tmp_moved_constant_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178,tmp_moved_constant_178)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180,tmp_moved_constant_180))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181,tmp_moved_constant_181)))));
                const __m256d tmp_moved_constant_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_99,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184)))),_mm256_mul_pd(tmp_moved_constant_100,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183))))),_mm256_mul_pd(tmp_moved_constant_101,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))))),_mm256_mul_pd(tmp_moved_constant_98,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183,tmp_moved_constant_183))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184,tmp_moved_constant_184))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_186,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_187,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_188,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_189,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_190,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_191,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_192,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_193,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_194,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_195,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_196 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_197 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_198 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_199 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_284 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)))));
                const __m256d tmp_moved_constant_285 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208)),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212)),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214)),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)))));
                const __m256d tmp_moved_constant_286 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217)),_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226)))));
                const __m256d tmp_moved_constant_287 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217)),_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)),_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)))));
                const __m256d tmp_moved_constant_288 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247)))));
                const __m256d tmp_moved_constant_289 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259)))));
                const __m256d tmp_moved_constant_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271)))));
                const __m256d tmp_moved_constant_291 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275)))));
                const __m256d tmp_moved_constant_292 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)))));
                const __m256d tmp_moved_constant_293 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_197,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)))),_mm256_mul_pd(tmp_moved_constant_198,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))))),_mm256_mul_pd(tmp_moved_constant_199,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))))),_mm256_mul_pd(tmp_moved_constant_196,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_284,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_285,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_286,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_287,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_288,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_289,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_290,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_291,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_292,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_293,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_294 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_295 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_296 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_297 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301,tmp_moved_constant_301))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303,tmp_moved_constant_303))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305)))));
                const __m256d tmp_moved_constant_383 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309,tmp_moved_constant_309)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313,tmp_moved_constant_313))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307,tmp_moved_constant_307))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306,tmp_moved_constant_306)),_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308)),_mm256_set_pd(tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310,tmp_moved_constant_310)),_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312,tmp_moved_constant_312)),_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317)))));
                const __m256d tmp_moved_constant_384 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321,tmp_moved_constant_321)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325,tmp_moved_constant_325))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319,tmp_moved_constant_319))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314)),_mm256_set_pd(tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318,tmp_moved_constant_318)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315)),_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316)),_mm256_set_pd(tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322,tmp_moved_constant_322))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317)),_mm256_set_pd(tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324,tmp_moved_constant_324)))));
                const __m256d tmp_moved_constant_385 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331,tmp_moved_constant_331))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333,tmp_moved_constant_333))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327,tmp_moved_constant_327))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314)),_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315,tmp_moved_constant_315)),_mm256_set_pd(tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328,tmp_moved_constant_328))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316,tmp_moved_constant_316)),_mm256_set_pd(tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330,tmp_moved_constant_330))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317)),_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332)))));
                const __m256d tmp_moved_constant_386 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336,tmp_moved_constant_336)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339,tmp_moved_constant_339))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342,tmp_moved_constant_342))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345,tmp_moved_constant_345)))));
                const __m256d tmp_moved_constant_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348,tmp_moved_constant_348)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351,tmp_moved_constant_351))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354,tmp_moved_constant_354))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357,tmp_moved_constant_357)))));
                const __m256d tmp_moved_constant_388 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360,tmp_moved_constant_360)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363,tmp_moved_constant_363))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366,tmp_moved_constant_366))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369,tmp_moved_constant_369)))));
                const __m256d tmp_moved_constant_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370,tmp_moved_constant_370)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372,tmp_moved_constant_372))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373,tmp_moved_constant_373)))));
                const __m256d tmp_moved_constant_390 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375,tmp_moved_constant_375))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376,tmp_moved_constant_376))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377)))));
                const __m256d tmp_moved_constant_391 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_295,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380)))),_mm256_mul_pd(tmp_moved_constant_296,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379))))),_mm256_mul_pd(tmp_moved_constant_297,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378))))),_mm256_mul_pd(tmp_moved_constant_294,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378,tmp_moved_constant_378)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379,tmp_moved_constant_379))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381,tmp_moved_constant_381)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_382,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_383,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_384,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_385,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_386,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_387,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_388,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_389,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_390,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_391,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d tmp_moved_constant_392 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_393 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_394 = _mm256_loadu_pd(& _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d tmp_moved_constant_395 = _mm256_loadu_pd(& _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_moved_constant_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397,tmp_moved_constant_397)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399,tmp_moved_constant_399))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403,tmp_moved_constant_403)))));
                const __m256d tmp_moved_constant_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409,tmp_moved_constant_409))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411,tmp_moved_constant_411))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405,tmp_moved_constant_405))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404)),_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406,tmp_moved_constant_406)),_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_408,tmp_moved_constant_408,tmp_moved_constant_408,tmp_moved_constant_408)),_mm256_set_pd(tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415)))));
                const __m256d tmp_moved_constant_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421,tmp_moved_constant_421))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423,tmp_moved_constant_423))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417,tmp_moved_constant_417))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412)),_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413)),_mm256_set_pd(tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418,tmp_moved_constant_418))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414)),_mm256_set_pd(tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420,tmp_moved_constant_420))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415)),_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422)))));
                const __m256d tmp_moved_constant_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427,tmp_moved_constant_427)),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429,tmp_moved_constant_429))),_mm256_mul_pd(_mm256_set_pd(-0.1381966011250105,-0.1381966011250105,-0.1381966011250105,-0.1381966011250105),_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(_mm256_set_pd(-0.5854101966249684,-0.5854101966249684,-0.5854101966249684,-0.5854101966249684),_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412,tmp_moved_constant_412)),_mm256_set_pd(tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424,tmp_moved_constant_424)),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413)),_mm256_set_pd(tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426,tmp_moved_constant_426))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414,tmp_moved_constant_414)),_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428))),_mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415,tmp_moved_constant_415)),_mm256_set_pd(tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430,tmp_moved_constant_430)))));
                const __m256d tmp_moved_constant_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443)))));
                const __m256d tmp_moved_constant_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455)))));
                const __m256d tmp_moved_constant_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467)))));
                const __m256d tmp_moved_constant_487 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)))));
                const __m256d tmp_moved_constant_488 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475)))));
                const __m256d tmp_moved_constant_489 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_moved_constant_393,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478)))),_mm256_mul_pd(tmp_moved_constant_394,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))))),_mm256_mul_pd(tmp_moved_constant_395,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_mul_pd(_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))))),_mm256_mul_pd(tmp_moved_constant_392,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28),_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29),_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30),_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31),_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479)))));
                {
                   {
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_480,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_481,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_482,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(tmp_moved_constant_483,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_484,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_485,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(tmp_moved_constant_486,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_487,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(tmp_moved_constant_488,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(tmp_moved_constant_489,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
                const real_t src_dof_0 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_29 + tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_27*tmp_kernel_op_31 + tmp_kernel_op_28*tmp_kernel_op_6) + src_dof_1*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.5854101966249684 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_2*(tmp_kernel_op_13*0.5854101966249684 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_3*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684);
                const real_t elMatVec_1 = src_dof_0*(-tmp_kernel_op_32*tmp_kernel_op_40 - tmp_kernel_op_34*tmp_kernel_op_41 - tmp_kernel_op_36*tmp_kernel_op_42 - tmp_kernel_op_38*tmp_kernel_op_43) + src_dof_1*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.5854101966249684 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.5854101966249684 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_33*-0.5854101966249684 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105);
                const real_t elMatVec_2 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_44 - tmp_kernel_op_41*tmp_kernel_op_46 - tmp_kernel_op_42*tmp_kernel_op_48 - tmp_kernel_op_43*tmp_kernel_op_50) + src_dof_1*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.5854101966249684 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.5854101966249684 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_45*-0.5854101966249684 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105);
                const real_t elMatVec_3 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_52 - tmp_kernel_op_41*tmp_kernel_op_54 - tmp_kernel_op_42*tmp_kernel_op_56 - tmp_kernel_op_43*tmp_kernel_op_58) + src_dof_1*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.5854101966249684 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.5854101966249684 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_53*-0.5854101966249684 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105);
                const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_62 + tmp_kernel_op_29*tmp_kernel_op_65 + tmp_kernel_op_30*tmp_kernel_op_68 + tmp_kernel_op_31*tmp_kernel_op_71) + src_dof_1*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.5854101966249684 + tmp_kernel_op_71*0.1381966011250105) + src_dof_2*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.5854101966249684 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105) + src_dof_3*(tmp_kernel_op_62*0.5854101966249684 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105);
                const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_74 + tmp_kernel_op_29*tmp_kernel_op_77 + tmp_kernel_op_30*tmp_kernel_op_80 + tmp_kernel_op_31*tmp_kernel_op_83) + src_dof_1*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.5854101966249684 + tmp_kernel_op_83*0.1381966011250105) + src_dof_2*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.5854101966249684 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105) + src_dof_3*(tmp_kernel_op_74*0.5854101966249684 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105);
                const real_t elMatVec_6 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_86 + tmp_kernel_op_29*tmp_kernel_op_89 + tmp_kernel_op_30*tmp_kernel_op_92 + tmp_kernel_op_31*tmp_kernel_op_95) + src_dof_1*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.5854101966249684 + tmp_kernel_op_95*0.1381966011250105) + src_dof_2*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.5854101966249684 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105) + src_dof_3*(tmp_kernel_op_86*0.5854101966249684 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105);
                const real_t elMatVec_7 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_96 + tmp_kernel_op_29*tmp_kernel_op_97 + tmp_kernel_op_30*tmp_kernel_op_98 + tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_1*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.5854101966249684 + tmp_kernel_op_99*0.1381966011250105) + src_dof_2*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.5854101966249684 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105) + src_dof_3*(tmp_kernel_op_96*0.5854101966249684 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105);
                const real_t elMatVec_8 = src_dof_0*(tmp_kernel_op_101*tmp_kernel_op_28 + tmp_kernel_op_103*tmp_kernel_op_29 + tmp_kernel_op_105*tmp_kernel_op_30 + tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.5854101966249684 + tmp_kernel_op_107*0.1381966011250105) + src_dof_2*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.5854101966249684 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105) + src_dof_3*(tmp_kernel_op_101*0.5854101966249684 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105);
                const real_t elMatVec_9 = src_dof_0*(tmp_kernel_op_108*tmp_kernel_op_28 + tmp_kernel_op_109*tmp_kernel_op_29 + tmp_kernel_op_110*tmp_kernel_op_30 + tmp_kernel_op_111*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.5854101966249684 + tmp_kernel_op_111*0.1381966011250105) + src_dof_2*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.5854101966249684 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105) + src_dof_3*(tmp_kernel_op_108*0.5854101966249684 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_0 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_1 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_2 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_3 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_88 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_5 + tmp_kernel_op_29*tmp_moved_constant_7 + tmp_kernel_op_30*tmp_moved_constant_9 + tmp_kernel_op_31*tmp_moved_constant_11) + tmp_moved_constant_1*(tmp_moved_constant_11*0.1381966011250105 + tmp_moved_constant_5*0.1381966011250105 + tmp_moved_constant_7*0.1381966011250105 + tmp_moved_constant_9*0.5854101966249684) + tmp_moved_constant_2*(tmp_moved_constant_11*0.1381966011250105 + tmp_moved_constant_5*0.1381966011250105 + tmp_moved_constant_7*0.5854101966249684 + tmp_moved_constant_9*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_11*0.1381966011250105 + tmp_moved_constant_5*0.5854101966249684 + tmp_moved_constant_7*0.1381966011250105 + tmp_moved_constant_9*0.1381966011250105);
                const real_t tmp_moved_constant_89 = tmp_moved_constant_0*(-tmp_moved_constant_12*tmp_moved_constant_20 - tmp_moved_constant_14*tmp_moved_constant_21 - tmp_moved_constant_16*tmp_moved_constant_22 - tmp_moved_constant_18*tmp_moved_constant_23) + tmp_moved_constant_1*(tmp_moved_constant_13*-0.1381966011250105 + tmp_moved_constant_15*-0.1381966011250105 + tmp_moved_constant_17*-0.5854101966249684 + tmp_moved_constant_19*-0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_13*-0.1381966011250105 + tmp_moved_constant_15*-0.5854101966249684 + tmp_moved_constant_17*-0.1381966011250105 + tmp_moved_constant_19*-0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_13*-0.5854101966249684 + tmp_moved_constant_15*-0.1381966011250105 + tmp_moved_constant_17*-0.1381966011250105 + tmp_moved_constant_19*-0.1381966011250105);
                const real_t tmp_moved_constant_90 = tmp_moved_constant_0*(-tmp_moved_constant_20*tmp_moved_constant_24 - tmp_moved_constant_21*tmp_moved_constant_26 - tmp_moved_constant_22*tmp_moved_constant_28 - tmp_moved_constant_23*tmp_moved_constant_30) + tmp_moved_constant_1*(tmp_moved_constant_25*-0.1381966011250105 + tmp_moved_constant_27*-0.1381966011250105 + tmp_moved_constant_29*-0.5854101966249684 + tmp_moved_constant_31*-0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_25*-0.1381966011250105 + tmp_moved_constant_27*-0.5854101966249684 + tmp_moved_constant_29*-0.1381966011250105 + tmp_moved_constant_31*-0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_25*-0.5854101966249684 + tmp_moved_constant_27*-0.1381966011250105 + tmp_moved_constant_29*-0.1381966011250105 + tmp_moved_constant_31*-0.1381966011250105);
                const real_t tmp_moved_constant_91 = tmp_moved_constant_0*(-tmp_moved_constant_20*tmp_moved_constant_32 - tmp_moved_constant_21*tmp_moved_constant_34 - tmp_moved_constant_22*tmp_moved_constant_36 - tmp_moved_constant_23*tmp_moved_constant_38) + tmp_moved_constant_1*(tmp_moved_constant_33*-0.1381966011250105 + tmp_moved_constant_35*-0.1381966011250105 + tmp_moved_constant_37*-0.5854101966249684 + tmp_moved_constant_39*-0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_33*-0.1381966011250105 + tmp_moved_constant_35*-0.5854101966249684 + tmp_moved_constant_37*-0.1381966011250105 + tmp_moved_constant_39*-0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_33*-0.5854101966249684 + tmp_moved_constant_35*-0.1381966011250105 + tmp_moved_constant_37*-0.1381966011250105 + tmp_moved_constant_39*-0.1381966011250105);
                const real_t tmp_moved_constant_92 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_42 + tmp_kernel_op_29*tmp_moved_constant_45 + tmp_kernel_op_30*tmp_moved_constant_48 + tmp_kernel_op_31*tmp_moved_constant_51) + tmp_moved_constant_1*(tmp_moved_constant_42*0.1381966011250105 + tmp_moved_constant_45*0.1381966011250105 + tmp_moved_constant_48*0.5854101966249684 + tmp_moved_constant_51*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_42*0.1381966011250105 + tmp_moved_constant_45*0.5854101966249684 + tmp_moved_constant_48*0.1381966011250105 + tmp_moved_constant_51*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_42*0.5854101966249684 + tmp_moved_constant_45*0.1381966011250105 + tmp_moved_constant_48*0.1381966011250105 + tmp_moved_constant_51*0.1381966011250105);
                const real_t tmp_moved_constant_93 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_54 + tmp_kernel_op_29*tmp_moved_constant_57 + tmp_kernel_op_30*tmp_moved_constant_60 + tmp_kernel_op_31*tmp_moved_constant_63) + tmp_moved_constant_1*(tmp_moved_constant_54*0.1381966011250105 + tmp_moved_constant_57*0.1381966011250105 + tmp_moved_constant_60*0.5854101966249684 + tmp_moved_constant_63*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_54*0.1381966011250105 + tmp_moved_constant_57*0.5854101966249684 + tmp_moved_constant_60*0.1381966011250105 + tmp_moved_constant_63*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_54*0.5854101966249684 + tmp_moved_constant_57*0.1381966011250105 + tmp_moved_constant_60*0.1381966011250105 + tmp_moved_constant_63*0.1381966011250105);
                const real_t tmp_moved_constant_94 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_66 + tmp_kernel_op_29*tmp_moved_constant_69 + tmp_kernel_op_30*tmp_moved_constant_72 + tmp_kernel_op_31*tmp_moved_constant_75) + tmp_moved_constant_1*(tmp_moved_constant_66*0.1381966011250105 + tmp_moved_constant_69*0.1381966011250105 + tmp_moved_constant_72*0.5854101966249684 + tmp_moved_constant_75*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_66*0.1381966011250105 + tmp_moved_constant_69*0.5854101966249684 + tmp_moved_constant_72*0.1381966011250105 + tmp_moved_constant_75*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_66*0.5854101966249684 + tmp_moved_constant_69*0.1381966011250105 + tmp_moved_constant_72*0.1381966011250105 + tmp_moved_constant_75*0.1381966011250105);
                const real_t tmp_moved_constant_95 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_76 + tmp_kernel_op_29*tmp_moved_constant_77 + tmp_kernel_op_30*tmp_moved_constant_78 + tmp_kernel_op_31*tmp_moved_constant_79) + tmp_moved_constant_1*(tmp_moved_constant_76*0.1381966011250105 + tmp_moved_constant_77*0.1381966011250105 + tmp_moved_constant_78*0.5854101966249684 + tmp_moved_constant_79*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_76*0.1381966011250105 + tmp_moved_constant_77*0.5854101966249684 + tmp_moved_constant_78*0.1381966011250105 + tmp_moved_constant_79*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_76*0.5854101966249684 + tmp_moved_constant_77*0.1381966011250105 + tmp_moved_constant_78*0.1381966011250105 + tmp_moved_constant_79*0.1381966011250105);
                const real_t tmp_moved_constant_96 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_80 + tmp_kernel_op_29*tmp_moved_constant_81 + tmp_kernel_op_30*tmp_moved_constant_82 + tmp_kernel_op_31*tmp_moved_constant_83) + tmp_moved_constant_1*(tmp_moved_constant_80*0.1381966011250105 + tmp_moved_constant_81*0.1381966011250105 + tmp_moved_constant_82*0.5854101966249684 + tmp_moved_constant_83*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_80*0.1381966011250105 + tmp_moved_constant_81*0.5854101966249684 + tmp_moved_constant_82*0.1381966011250105 + tmp_moved_constant_83*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_80*0.5854101966249684 + tmp_moved_constant_81*0.1381966011250105 + tmp_moved_constant_82*0.1381966011250105 + tmp_moved_constant_83*0.1381966011250105);
                const real_t tmp_moved_constant_97 = tmp_moved_constant_0*(tmp_kernel_op_28*tmp_moved_constant_84 + tmp_kernel_op_29*tmp_moved_constant_85 + tmp_kernel_op_30*tmp_moved_constant_86 + tmp_kernel_op_31*tmp_moved_constant_87) + tmp_moved_constant_1*(tmp_moved_constant_84*0.1381966011250105 + tmp_moved_constant_85*0.1381966011250105 + tmp_moved_constant_86*0.5854101966249684 + tmp_moved_constant_87*0.1381966011250105) + tmp_moved_constant_2*(tmp_moved_constant_84*0.1381966011250105 + tmp_moved_constant_85*0.5854101966249684 + tmp_moved_constant_86*0.1381966011250105 + tmp_moved_constant_87*0.1381966011250105) + tmp_moved_constant_3*(tmp_moved_constant_84*0.5854101966249684 + tmp_moved_constant_85*0.1381966011250105 + tmp_moved_constant_86*0.1381966011250105 + tmp_moved_constant_87*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_88 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_89 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_90 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_91 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_92 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = tmp_moved_constant_93 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_94 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_95 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_96 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_97 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   }
                }
                const real_t tmp_moved_constant_98 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_99 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_100 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_101 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_186 = tmp_moved_constant_100*(tmp_moved_constant_103*0.1381966011250105 + tmp_moved_constant_105*0.5854101966249684 + tmp_moved_constant_107*0.1381966011250105 + tmp_moved_constant_109*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_103*0.5854101966249684 + tmp_moved_constant_105*0.1381966011250105 + tmp_moved_constant_107*0.1381966011250105 + tmp_moved_constant_109*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_103 + tmp_kernel_op_29*tmp_moved_constant_105 + tmp_kernel_op_30*tmp_moved_constant_107 + tmp_kernel_op_31*tmp_moved_constant_109) + tmp_moved_constant_99*(tmp_moved_constant_103*0.1381966011250105 + tmp_moved_constant_105*0.1381966011250105 + tmp_moved_constant_107*0.5854101966249684 + tmp_moved_constant_109*0.1381966011250105);
                const real_t tmp_moved_constant_187 = tmp_moved_constant_100*(tmp_moved_constant_111*-0.1381966011250105 + tmp_moved_constant_113*-0.5854101966249684 + tmp_moved_constant_115*-0.1381966011250105 + tmp_moved_constant_117*-0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_111*-0.5854101966249684 + tmp_moved_constant_113*-0.1381966011250105 + tmp_moved_constant_115*-0.1381966011250105 + tmp_moved_constant_117*-0.1381966011250105) + tmp_moved_constant_98*(-tmp_moved_constant_110*tmp_moved_constant_118 - tmp_moved_constant_112*tmp_moved_constant_119 - tmp_moved_constant_114*tmp_moved_constant_120 - tmp_moved_constant_116*tmp_moved_constant_121) + tmp_moved_constant_99*(tmp_moved_constant_111*-0.1381966011250105 + tmp_moved_constant_113*-0.1381966011250105 + tmp_moved_constant_115*-0.5854101966249684 + tmp_moved_constant_117*-0.1381966011250105);
                const real_t tmp_moved_constant_188 = tmp_moved_constant_100*(tmp_moved_constant_123*-0.1381966011250105 + tmp_moved_constant_125*-0.5854101966249684 + tmp_moved_constant_127*-0.1381966011250105 + tmp_moved_constant_129*-0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_123*-0.5854101966249684 + tmp_moved_constant_125*-0.1381966011250105 + tmp_moved_constant_127*-0.1381966011250105 + tmp_moved_constant_129*-0.1381966011250105) + tmp_moved_constant_98*(-tmp_moved_constant_118*tmp_moved_constant_122 - tmp_moved_constant_119*tmp_moved_constant_124 - tmp_moved_constant_120*tmp_moved_constant_126 - tmp_moved_constant_121*tmp_moved_constant_128) + tmp_moved_constant_99*(tmp_moved_constant_123*-0.1381966011250105 + tmp_moved_constant_125*-0.1381966011250105 + tmp_moved_constant_127*-0.5854101966249684 + tmp_moved_constant_129*-0.1381966011250105);
                const real_t tmp_moved_constant_189 = tmp_moved_constant_100*(tmp_moved_constant_131*-0.1381966011250105 + tmp_moved_constant_133*-0.5854101966249684 + tmp_moved_constant_135*-0.1381966011250105 + tmp_moved_constant_137*-0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_131*-0.5854101966249684 + tmp_moved_constant_133*-0.1381966011250105 + tmp_moved_constant_135*-0.1381966011250105 + tmp_moved_constant_137*-0.1381966011250105) + tmp_moved_constant_98*(-tmp_moved_constant_118*tmp_moved_constant_130 - tmp_moved_constant_119*tmp_moved_constant_132 - tmp_moved_constant_120*tmp_moved_constant_134 - tmp_moved_constant_121*tmp_moved_constant_136) + tmp_moved_constant_99*(tmp_moved_constant_131*-0.1381966011250105 + tmp_moved_constant_133*-0.1381966011250105 + tmp_moved_constant_135*-0.5854101966249684 + tmp_moved_constant_137*-0.1381966011250105);
                const real_t tmp_moved_constant_190 = tmp_moved_constant_100*(tmp_moved_constant_140*0.1381966011250105 + tmp_moved_constant_143*0.5854101966249684 + tmp_moved_constant_146*0.1381966011250105 + tmp_moved_constant_149*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_140*0.5854101966249684 + tmp_moved_constant_143*0.1381966011250105 + tmp_moved_constant_146*0.1381966011250105 + tmp_moved_constant_149*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_140 + tmp_kernel_op_29*tmp_moved_constant_143 + tmp_kernel_op_30*tmp_moved_constant_146 + tmp_kernel_op_31*tmp_moved_constant_149) + tmp_moved_constant_99*(tmp_moved_constant_140*0.1381966011250105 + tmp_moved_constant_143*0.1381966011250105 + tmp_moved_constant_146*0.5854101966249684 + tmp_moved_constant_149*0.1381966011250105);
                const real_t tmp_moved_constant_191 = tmp_moved_constant_100*(tmp_moved_constant_152*0.1381966011250105 + tmp_moved_constant_155*0.5854101966249684 + tmp_moved_constant_158*0.1381966011250105 + tmp_moved_constant_161*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_152*0.5854101966249684 + tmp_moved_constant_155*0.1381966011250105 + tmp_moved_constant_158*0.1381966011250105 + tmp_moved_constant_161*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_152 + tmp_kernel_op_29*tmp_moved_constant_155 + tmp_kernel_op_30*tmp_moved_constant_158 + tmp_kernel_op_31*tmp_moved_constant_161) + tmp_moved_constant_99*(tmp_moved_constant_152*0.1381966011250105 + tmp_moved_constant_155*0.1381966011250105 + tmp_moved_constant_158*0.5854101966249684 + tmp_moved_constant_161*0.1381966011250105);
                const real_t tmp_moved_constant_192 = tmp_moved_constant_100*(tmp_moved_constant_164*0.1381966011250105 + tmp_moved_constant_167*0.5854101966249684 + tmp_moved_constant_170*0.1381966011250105 + tmp_moved_constant_173*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_164*0.5854101966249684 + tmp_moved_constant_167*0.1381966011250105 + tmp_moved_constant_170*0.1381966011250105 + tmp_moved_constant_173*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_164 + tmp_kernel_op_29*tmp_moved_constant_167 + tmp_kernel_op_30*tmp_moved_constant_170 + tmp_kernel_op_31*tmp_moved_constant_173) + tmp_moved_constant_99*(tmp_moved_constant_164*0.1381966011250105 + tmp_moved_constant_167*0.1381966011250105 + tmp_moved_constant_170*0.5854101966249684 + tmp_moved_constant_173*0.1381966011250105);
                const real_t tmp_moved_constant_193 = tmp_moved_constant_100*(tmp_moved_constant_174*0.1381966011250105 + tmp_moved_constant_175*0.5854101966249684 + tmp_moved_constant_176*0.1381966011250105 + tmp_moved_constant_177*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_174*0.5854101966249684 + tmp_moved_constant_175*0.1381966011250105 + tmp_moved_constant_176*0.1381966011250105 + tmp_moved_constant_177*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_174 + tmp_kernel_op_29*tmp_moved_constant_175 + tmp_kernel_op_30*tmp_moved_constant_176 + tmp_kernel_op_31*tmp_moved_constant_177) + tmp_moved_constant_99*(tmp_moved_constant_174*0.1381966011250105 + tmp_moved_constant_175*0.1381966011250105 + tmp_moved_constant_176*0.5854101966249684 + tmp_moved_constant_177*0.1381966011250105);
                const real_t tmp_moved_constant_194 = tmp_moved_constant_100*(tmp_moved_constant_178*0.1381966011250105 + tmp_moved_constant_179*0.5854101966249684 + tmp_moved_constant_180*0.1381966011250105 + tmp_moved_constant_181*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_178*0.5854101966249684 + tmp_moved_constant_179*0.1381966011250105 + tmp_moved_constant_180*0.1381966011250105 + tmp_moved_constant_181*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_178 + tmp_kernel_op_29*tmp_moved_constant_179 + tmp_kernel_op_30*tmp_moved_constant_180 + tmp_kernel_op_31*tmp_moved_constant_181) + tmp_moved_constant_99*(tmp_moved_constant_178*0.1381966011250105 + tmp_moved_constant_179*0.1381966011250105 + tmp_moved_constant_180*0.5854101966249684 + tmp_moved_constant_181*0.1381966011250105);
                const real_t tmp_moved_constant_195 = tmp_moved_constant_100*(tmp_moved_constant_182*0.1381966011250105 + tmp_moved_constant_183*0.5854101966249684 + tmp_moved_constant_184*0.1381966011250105 + tmp_moved_constant_185*0.1381966011250105) + tmp_moved_constant_101*(tmp_moved_constant_182*0.5854101966249684 + tmp_moved_constant_183*0.1381966011250105 + tmp_moved_constant_184*0.1381966011250105 + tmp_moved_constant_185*0.1381966011250105) + tmp_moved_constant_98*(tmp_kernel_op_28*tmp_moved_constant_182 + tmp_kernel_op_29*tmp_moved_constant_183 + tmp_kernel_op_30*tmp_moved_constant_184 + tmp_kernel_op_31*tmp_moved_constant_185) + tmp_moved_constant_99*(tmp_moved_constant_182*0.1381966011250105 + tmp_moved_constant_183*0.1381966011250105 + tmp_moved_constant_184*0.5854101966249684 + tmp_moved_constant_185*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_186 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_187 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_188 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_189 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_190 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_191 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_192 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_193 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_194 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_195 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_196 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_197 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_198 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_199 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_284 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_201 + tmp_kernel_op_29*tmp_moved_constant_203 + tmp_kernel_op_30*tmp_moved_constant_205 + tmp_kernel_op_31*tmp_moved_constant_207) + tmp_moved_constant_197*(tmp_moved_constant_201*0.1381966011250105 + tmp_moved_constant_203*0.1381966011250105 + tmp_moved_constant_205*0.5854101966249684 + tmp_moved_constant_207*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_201*0.1381966011250105 + tmp_moved_constant_203*0.5854101966249684 + tmp_moved_constant_205*0.1381966011250105 + tmp_moved_constant_207*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_201*0.5854101966249684 + tmp_moved_constant_203*0.1381966011250105 + tmp_moved_constant_205*0.1381966011250105 + tmp_moved_constant_207*0.1381966011250105);
                const real_t tmp_moved_constant_285 = tmp_moved_constant_196*(-tmp_moved_constant_208*tmp_moved_constant_216 - tmp_moved_constant_210*tmp_moved_constant_217 - tmp_moved_constant_212*tmp_moved_constant_218 - tmp_moved_constant_214*tmp_moved_constant_219) + tmp_moved_constant_197*(tmp_moved_constant_209*-0.1381966011250105 + tmp_moved_constant_211*-0.1381966011250105 + tmp_moved_constant_213*-0.5854101966249684 + tmp_moved_constant_215*-0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_209*-0.1381966011250105 + tmp_moved_constant_211*-0.5854101966249684 + tmp_moved_constant_213*-0.1381966011250105 + tmp_moved_constant_215*-0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_209*-0.5854101966249684 + tmp_moved_constant_211*-0.1381966011250105 + tmp_moved_constant_213*-0.1381966011250105 + tmp_moved_constant_215*-0.1381966011250105);
                const real_t tmp_moved_constant_286 = tmp_moved_constant_196*(-tmp_moved_constant_216*tmp_moved_constant_220 - tmp_moved_constant_217*tmp_moved_constant_222 - tmp_moved_constant_218*tmp_moved_constant_224 - tmp_moved_constant_219*tmp_moved_constant_226) + tmp_moved_constant_197*(tmp_moved_constant_221*-0.1381966011250105 + tmp_moved_constant_223*-0.1381966011250105 + tmp_moved_constant_225*-0.5854101966249684 + tmp_moved_constant_227*-0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_221*-0.1381966011250105 + tmp_moved_constant_223*-0.5854101966249684 + tmp_moved_constant_225*-0.1381966011250105 + tmp_moved_constant_227*-0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_221*-0.5854101966249684 + tmp_moved_constant_223*-0.1381966011250105 + tmp_moved_constant_225*-0.1381966011250105 + tmp_moved_constant_227*-0.1381966011250105);
                const real_t tmp_moved_constant_287 = tmp_moved_constant_196*(-tmp_moved_constant_216*tmp_moved_constant_228 - tmp_moved_constant_217*tmp_moved_constant_230 - tmp_moved_constant_218*tmp_moved_constant_232 - tmp_moved_constant_219*tmp_moved_constant_234) + tmp_moved_constant_197*(tmp_moved_constant_229*-0.1381966011250105 + tmp_moved_constant_231*-0.1381966011250105 + tmp_moved_constant_233*-0.5854101966249684 + tmp_moved_constant_235*-0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_229*-0.1381966011250105 + tmp_moved_constant_231*-0.5854101966249684 + tmp_moved_constant_233*-0.1381966011250105 + tmp_moved_constant_235*-0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_229*-0.5854101966249684 + tmp_moved_constant_231*-0.1381966011250105 + tmp_moved_constant_233*-0.1381966011250105 + tmp_moved_constant_235*-0.1381966011250105);
                const real_t tmp_moved_constant_288 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_238 + tmp_kernel_op_29*tmp_moved_constant_241 + tmp_kernel_op_30*tmp_moved_constant_244 + tmp_kernel_op_31*tmp_moved_constant_247) + tmp_moved_constant_197*(tmp_moved_constant_238*0.1381966011250105 + tmp_moved_constant_241*0.1381966011250105 + tmp_moved_constant_244*0.5854101966249684 + tmp_moved_constant_247*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_238*0.1381966011250105 + tmp_moved_constant_241*0.5854101966249684 + tmp_moved_constant_244*0.1381966011250105 + tmp_moved_constant_247*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_238*0.5854101966249684 + tmp_moved_constant_241*0.1381966011250105 + tmp_moved_constant_244*0.1381966011250105 + tmp_moved_constant_247*0.1381966011250105);
                const real_t tmp_moved_constant_289 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_250 + tmp_kernel_op_29*tmp_moved_constant_253 + tmp_kernel_op_30*tmp_moved_constant_256 + tmp_kernel_op_31*tmp_moved_constant_259) + tmp_moved_constant_197*(tmp_moved_constant_250*0.1381966011250105 + tmp_moved_constant_253*0.1381966011250105 + tmp_moved_constant_256*0.5854101966249684 + tmp_moved_constant_259*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_250*0.1381966011250105 + tmp_moved_constant_253*0.5854101966249684 + tmp_moved_constant_256*0.1381966011250105 + tmp_moved_constant_259*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_250*0.5854101966249684 + tmp_moved_constant_253*0.1381966011250105 + tmp_moved_constant_256*0.1381966011250105 + tmp_moved_constant_259*0.1381966011250105);
                const real_t tmp_moved_constant_290 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_262 + tmp_kernel_op_29*tmp_moved_constant_265 + tmp_kernel_op_30*tmp_moved_constant_268 + tmp_kernel_op_31*tmp_moved_constant_271) + tmp_moved_constant_197*(tmp_moved_constant_262*0.1381966011250105 + tmp_moved_constant_265*0.1381966011250105 + tmp_moved_constant_268*0.5854101966249684 + tmp_moved_constant_271*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_262*0.1381966011250105 + tmp_moved_constant_265*0.5854101966249684 + tmp_moved_constant_268*0.1381966011250105 + tmp_moved_constant_271*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_262*0.5854101966249684 + tmp_moved_constant_265*0.1381966011250105 + tmp_moved_constant_268*0.1381966011250105 + tmp_moved_constant_271*0.1381966011250105);
                const real_t tmp_moved_constant_291 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_272 + tmp_kernel_op_29*tmp_moved_constant_273 + tmp_kernel_op_30*tmp_moved_constant_274 + tmp_kernel_op_31*tmp_moved_constant_275) + tmp_moved_constant_197*(tmp_moved_constant_272*0.1381966011250105 + tmp_moved_constant_273*0.1381966011250105 + tmp_moved_constant_274*0.5854101966249684 + tmp_moved_constant_275*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_272*0.1381966011250105 + tmp_moved_constant_273*0.5854101966249684 + tmp_moved_constant_274*0.1381966011250105 + tmp_moved_constant_275*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_272*0.5854101966249684 + tmp_moved_constant_273*0.1381966011250105 + tmp_moved_constant_274*0.1381966011250105 + tmp_moved_constant_275*0.1381966011250105);
                const real_t tmp_moved_constant_292 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_276 + tmp_kernel_op_29*tmp_moved_constant_277 + tmp_kernel_op_30*tmp_moved_constant_278 + tmp_kernel_op_31*tmp_moved_constant_279) + tmp_moved_constant_197*(tmp_moved_constant_276*0.1381966011250105 + tmp_moved_constant_277*0.1381966011250105 + tmp_moved_constant_278*0.5854101966249684 + tmp_moved_constant_279*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_276*0.1381966011250105 + tmp_moved_constant_277*0.5854101966249684 + tmp_moved_constant_278*0.1381966011250105 + tmp_moved_constant_279*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_276*0.5854101966249684 + tmp_moved_constant_277*0.1381966011250105 + tmp_moved_constant_278*0.1381966011250105 + tmp_moved_constant_279*0.1381966011250105);
                const real_t tmp_moved_constant_293 = tmp_moved_constant_196*(tmp_kernel_op_28*tmp_moved_constant_280 + tmp_kernel_op_29*tmp_moved_constant_281 + tmp_kernel_op_30*tmp_moved_constant_282 + tmp_kernel_op_31*tmp_moved_constant_283) + tmp_moved_constant_197*(tmp_moved_constant_280*0.1381966011250105 + tmp_moved_constant_281*0.1381966011250105 + tmp_moved_constant_282*0.5854101966249684 + tmp_moved_constant_283*0.1381966011250105) + tmp_moved_constant_198*(tmp_moved_constant_280*0.1381966011250105 + tmp_moved_constant_281*0.5854101966249684 + tmp_moved_constant_282*0.1381966011250105 + tmp_moved_constant_283*0.1381966011250105) + tmp_moved_constant_199*(tmp_moved_constant_280*0.5854101966249684 + tmp_moved_constant_281*0.1381966011250105 + tmp_moved_constant_282*0.1381966011250105 + tmp_moved_constant_283*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_284 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_285 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_286 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_287 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_288 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_289 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_290 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_291 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_292 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_293 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_294 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_295 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_296 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_297 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_382 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_299 + tmp_kernel_op_29*tmp_moved_constant_301 + tmp_kernel_op_30*tmp_moved_constant_303 + tmp_kernel_op_31*tmp_moved_constant_305) + tmp_moved_constant_295*(tmp_moved_constant_299*0.1381966011250105 + tmp_moved_constant_301*0.1381966011250105 + tmp_moved_constant_303*0.5854101966249684 + tmp_moved_constant_305*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_299*0.1381966011250105 + tmp_moved_constant_301*0.5854101966249684 + tmp_moved_constant_303*0.1381966011250105 + tmp_moved_constant_305*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_299*0.5854101966249684 + tmp_moved_constant_301*0.1381966011250105 + tmp_moved_constant_303*0.1381966011250105 + tmp_moved_constant_305*0.1381966011250105);
                const real_t tmp_moved_constant_383 = tmp_moved_constant_294*(-tmp_moved_constant_306*tmp_moved_constant_314 - tmp_moved_constant_308*tmp_moved_constant_315 - tmp_moved_constant_310*tmp_moved_constant_316 - tmp_moved_constant_312*tmp_moved_constant_317) + tmp_moved_constant_295*(tmp_moved_constant_307*-0.1381966011250105 + tmp_moved_constant_309*-0.1381966011250105 + tmp_moved_constant_311*-0.5854101966249684 + tmp_moved_constant_313*-0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_307*-0.1381966011250105 + tmp_moved_constant_309*-0.5854101966249684 + tmp_moved_constant_311*-0.1381966011250105 + tmp_moved_constant_313*-0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_307*-0.5854101966249684 + tmp_moved_constant_309*-0.1381966011250105 + tmp_moved_constant_311*-0.1381966011250105 + tmp_moved_constant_313*-0.1381966011250105);
                const real_t tmp_moved_constant_384 = tmp_moved_constant_294*(-tmp_moved_constant_314*tmp_moved_constant_318 - tmp_moved_constant_315*tmp_moved_constant_320 - tmp_moved_constant_316*tmp_moved_constant_322 - tmp_moved_constant_317*tmp_moved_constant_324) + tmp_moved_constant_295*(tmp_moved_constant_319*-0.1381966011250105 + tmp_moved_constant_321*-0.1381966011250105 + tmp_moved_constant_323*-0.5854101966249684 + tmp_moved_constant_325*-0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_319*-0.1381966011250105 + tmp_moved_constant_321*-0.5854101966249684 + tmp_moved_constant_323*-0.1381966011250105 + tmp_moved_constant_325*-0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_319*-0.5854101966249684 + tmp_moved_constant_321*-0.1381966011250105 + tmp_moved_constant_323*-0.1381966011250105 + tmp_moved_constant_325*-0.1381966011250105);
                const real_t tmp_moved_constant_385 = tmp_moved_constant_294*(-tmp_moved_constant_314*tmp_moved_constant_326 - tmp_moved_constant_315*tmp_moved_constant_328 - tmp_moved_constant_316*tmp_moved_constant_330 - tmp_moved_constant_317*tmp_moved_constant_332) + tmp_moved_constant_295*(tmp_moved_constant_327*-0.1381966011250105 + tmp_moved_constant_329*-0.1381966011250105 + tmp_moved_constant_331*-0.5854101966249684 + tmp_moved_constant_333*-0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_327*-0.1381966011250105 + tmp_moved_constant_329*-0.5854101966249684 + tmp_moved_constant_331*-0.1381966011250105 + tmp_moved_constant_333*-0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_327*-0.5854101966249684 + tmp_moved_constant_329*-0.1381966011250105 + tmp_moved_constant_331*-0.1381966011250105 + tmp_moved_constant_333*-0.1381966011250105);
                const real_t tmp_moved_constant_386 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_336 + tmp_kernel_op_29*tmp_moved_constant_339 + tmp_kernel_op_30*tmp_moved_constant_342 + tmp_kernel_op_31*tmp_moved_constant_345) + tmp_moved_constant_295*(tmp_moved_constant_336*0.1381966011250105 + tmp_moved_constant_339*0.1381966011250105 + tmp_moved_constant_342*0.5854101966249684 + tmp_moved_constant_345*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_336*0.1381966011250105 + tmp_moved_constant_339*0.5854101966249684 + tmp_moved_constant_342*0.1381966011250105 + tmp_moved_constant_345*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_336*0.5854101966249684 + tmp_moved_constant_339*0.1381966011250105 + tmp_moved_constant_342*0.1381966011250105 + tmp_moved_constant_345*0.1381966011250105);
                const real_t tmp_moved_constant_387 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_348 + tmp_kernel_op_29*tmp_moved_constant_351 + tmp_kernel_op_30*tmp_moved_constant_354 + tmp_kernel_op_31*tmp_moved_constant_357) + tmp_moved_constant_295*(tmp_moved_constant_348*0.1381966011250105 + tmp_moved_constant_351*0.1381966011250105 + tmp_moved_constant_354*0.5854101966249684 + tmp_moved_constant_357*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_348*0.1381966011250105 + tmp_moved_constant_351*0.5854101966249684 + tmp_moved_constant_354*0.1381966011250105 + tmp_moved_constant_357*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_348*0.5854101966249684 + tmp_moved_constant_351*0.1381966011250105 + tmp_moved_constant_354*0.1381966011250105 + tmp_moved_constant_357*0.1381966011250105);
                const real_t tmp_moved_constant_388 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_360 + tmp_kernel_op_29*tmp_moved_constant_363 + tmp_kernel_op_30*tmp_moved_constant_366 + tmp_kernel_op_31*tmp_moved_constant_369) + tmp_moved_constant_295*(tmp_moved_constant_360*0.1381966011250105 + tmp_moved_constant_363*0.1381966011250105 + tmp_moved_constant_366*0.5854101966249684 + tmp_moved_constant_369*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_360*0.1381966011250105 + tmp_moved_constant_363*0.5854101966249684 + tmp_moved_constant_366*0.1381966011250105 + tmp_moved_constant_369*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_360*0.5854101966249684 + tmp_moved_constant_363*0.1381966011250105 + tmp_moved_constant_366*0.1381966011250105 + tmp_moved_constant_369*0.1381966011250105);
                const real_t tmp_moved_constant_389 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_370 + tmp_kernel_op_29*tmp_moved_constant_371 + tmp_kernel_op_30*tmp_moved_constant_372 + tmp_kernel_op_31*tmp_moved_constant_373) + tmp_moved_constant_295*(tmp_moved_constant_370*0.1381966011250105 + tmp_moved_constant_371*0.1381966011250105 + tmp_moved_constant_372*0.5854101966249684 + tmp_moved_constant_373*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_370*0.1381966011250105 + tmp_moved_constant_371*0.5854101966249684 + tmp_moved_constant_372*0.1381966011250105 + tmp_moved_constant_373*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_370*0.5854101966249684 + tmp_moved_constant_371*0.1381966011250105 + tmp_moved_constant_372*0.1381966011250105 + tmp_moved_constant_373*0.1381966011250105);
                const real_t tmp_moved_constant_390 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_374 + tmp_kernel_op_29*tmp_moved_constant_375 + tmp_kernel_op_30*tmp_moved_constant_376 + tmp_kernel_op_31*tmp_moved_constant_377) + tmp_moved_constant_295*(tmp_moved_constant_374*0.1381966011250105 + tmp_moved_constant_375*0.1381966011250105 + tmp_moved_constant_376*0.5854101966249684 + tmp_moved_constant_377*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_374*0.1381966011250105 + tmp_moved_constant_375*0.5854101966249684 + tmp_moved_constant_376*0.1381966011250105 + tmp_moved_constant_377*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_374*0.5854101966249684 + tmp_moved_constant_375*0.1381966011250105 + tmp_moved_constant_376*0.1381966011250105 + tmp_moved_constant_377*0.1381966011250105);
                const real_t tmp_moved_constant_391 = tmp_moved_constant_294*(tmp_kernel_op_28*tmp_moved_constant_378 + tmp_kernel_op_29*tmp_moved_constant_379 + tmp_kernel_op_30*tmp_moved_constant_380 + tmp_kernel_op_31*tmp_moved_constant_381) + tmp_moved_constant_295*(tmp_moved_constant_378*0.1381966011250105 + tmp_moved_constant_379*0.1381966011250105 + tmp_moved_constant_380*0.5854101966249684 + tmp_moved_constant_381*0.1381966011250105) + tmp_moved_constant_296*(tmp_moved_constant_378*0.1381966011250105 + tmp_moved_constant_379*0.5854101966249684 + tmp_moved_constant_380*0.1381966011250105 + tmp_moved_constant_381*0.1381966011250105) + tmp_moved_constant_297*(tmp_moved_constant_378*0.5854101966249684 + tmp_moved_constant_379*0.1381966011250105 + tmp_moved_constant_380*0.1381966011250105 + tmp_moved_constant_381*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_382 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_383 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_384 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_385 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_386 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_387 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_388 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_389 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_390 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_391 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const real_t tmp_moved_constant_392 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_393 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_394 = _data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t tmp_moved_constant_395 = _data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t tmp_moved_constant_480 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_397 + tmp_kernel_op_29*tmp_moved_constant_399 + tmp_kernel_op_30*tmp_moved_constant_401 + tmp_kernel_op_31*tmp_moved_constant_403) + tmp_moved_constant_393*(tmp_moved_constant_397*0.1381966011250105 + tmp_moved_constant_399*0.1381966011250105 + tmp_moved_constant_401*0.5854101966249684 + tmp_moved_constant_403*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_397*0.1381966011250105 + tmp_moved_constant_399*0.5854101966249684 + tmp_moved_constant_401*0.1381966011250105 + tmp_moved_constant_403*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_397*0.5854101966249684 + tmp_moved_constant_399*0.1381966011250105 + tmp_moved_constant_401*0.1381966011250105 + tmp_moved_constant_403*0.1381966011250105);
                const real_t tmp_moved_constant_481 = tmp_moved_constant_392*(-tmp_moved_constant_404*tmp_moved_constant_412 - tmp_moved_constant_406*tmp_moved_constant_413 - tmp_moved_constant_408*tmp_moved_constant_414 - tmp_moved_constant_410*tmp_moved_constant_415) + tmp_moved_constant_393*(tmp_moved_constant_405*-0.1381966011250105 + tmp_moved_constant_407*-0.1381966011250105 + tmp_moved_constant_409*-0.5854101966249684 + tmp_moved_constant_411*-0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_405*-0.1381966011250105 + tmp_moved_constant_407*-0.5854101966249684 + tmp_moved_constant_409*-0.1381966011250105 + tmp_moved_constant_411*-0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_405*-0.5854101966249684 + tmp_moved_constant_407*-0.1381966011250105 + tmp_moved_constant_409*-0.1381966011250105 + tmp_moved_constant_411*-0.1381966011250105);
                const real_t tmp_moved_constant_482 = tmp_moved_constant_392*(-tmp_moved_constant_412*tmp_moved_constant_416 - tmp_moved_constant_413*tmp_moved_constant_418 - tmp_moved_constant_414*tmp_moved_constant_420 - tmp_moved_constant_415*tmp_moved_constant_422) + tmp_moved_constant_393*(tmp_moved_constant_417*-0.1381966011250105 + tmp_moved_constant_419*-0.1381966011250105 + tmp_moved_constant_421*-0.5854101966249684 + tmp_moved_constant_423*-0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_417*-0.1381966011250105 + tmp_moved_constant_419*-0.5854101966249684 + tmp_moved_constant_421*-0.1381966011250105 + tmp_moved_constant_423*-0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_417*-0.5854101966249684 + tmp_moved_constant_419*-0.1381966011250105 + tmp_moved_constant_421*-0.1381966011250105 + tmp_moved_constant_423*-0.1381966011250105);
                const real_t tmp_moved_constant_483 = tmp_moved_constant_392*(-tmp_moved_constant_412*tmp_moved_constant_424 - tmp_moved_constant_413*tmp_moved_constant_426 - tmp_moved_constant_414*tmp_moved_constant_428 - tmp_moved_constant_415*tmp_moved_constant_430) + tmp_moved_constant_393*(tmp_moved_constant_425*-0.1381966011250105 + tmp_moved_constant_427*-0.1381966011250105 + tmp_moved_constant_429*-0.5854101966249684 + tmp_moved_constant_431*-0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_425*-0.1381966011250105 + tmp_moved_constant_427*-0.5854101966249684 + tmp_moved_constant_429*-0.1381966011250105 + tmp_moved_constant_431*-0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_425*-0.5854101966249684 + tmp_moved_constant_427*-0.1381966011250105 + tmp_moved_constant_429*-0.1381966011250105 + tmp_moved_constant_431*-0.1381966011250105);
                const real_t tmp_moved_constant_484 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_434 + tmp_kernel_op_29*tmp_moved_constant_437 + tmp_kernel_op_30*tmp_moved_constant_440 + tmp_kernel_op_31*tmp_moved_constant_443) + tmp_moved_constant_393*(tmp_moved_constant_434*0.1381966011250105 + tmp_moved_constant_437*0.1381966011250105 + tmp_moved_constant_440*0.5854101966249684 + tmp_moved_constant_443*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_434*0.1381966011250105 + tmp_moved_constant_437*0.5854101966249684 + tmp_moved_constant_440*0.1381966011250105 + tmp_moved_constant_443*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_434*0.5854101966249684 + tmp_moved_constant_437*0.1381966011250105 + tmp_moved_constant_440*0.1381966011250105 + tmp_moved_constant_443*0.1381966011250105);
                const real_t tmp_moved_constant_485 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_446 + tmp_kernel_op_29*tmp_moved_constant_449 + tmp_kernel_op_30*tmp_moved_constant_452 + tmp_kernel_op_31*tmp_moved_constant_455) + tmp_moved_constant_393*(tmp_moved_constant_446*0.1381966011250105 + tmp_moved_constant_449*0.1381966011250105 + tmp_moved_constant_452*0.5854101966249684 + tmp_moved_constant_455*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_446*0.1381966011250105 + tmp_moved_constant_449*0.5854101966249684 + tmp_moved_constant_452*0.1381966011250105 + tmp_moved_constant_455*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_446*0.5854101966249684 + tmp_moved_constant_449*0.1381966011250105 + tmp_moved_constant_452*0.1381966011250105 + tmp_moved_constant_455*0.1381966011250105);
                const real_t tmp_moved_constant_486 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_458 + tmp_kernel_op_29*tmp_moved_constant_461 + tmp_kernel_op_30*tmp_moved_constant_464 + tmp_kernel_op_31*tmp_moved_constant_467) + tmp_moved_constant_393*(tmp_moved_constant_458*0.1381966011250105 + tmp_moved_constant_461*0.1381966011250105 + tmp_moved_constant_464*0.5854101966249684 + tmp_moved_constant_467*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_458*0.1381966011250105 + tmp_moved_constant_461*0.5854101966249684 + tmp_moved_constant_464*0.1381966011250105 + tmp_moved_constant_467*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_458*0.5854101966249684 + tmp_moved_constant_461*0.1381966011250105 + tmp_moved_constant_464*0.1381966011250105 + tmp_moved_constant_467*0.1381966011250105);
                const real_t tmp_moved_constant_487 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_468 + tmp_kernel_op_29*tmp_moved_constant_469 + tmp_kernel_op_30*tmp_moved_constant_470 + tmp_kernel_op_31*tmp_moved_constant_471) + tmp_moved_constant_393*(tmp_moved_constant_468*0.1381966011250105 + tmp_moved_constant_469*0.1381966011250105 + tmp_moved_constant_470*0.5854101966249684 + tmp_moved_constant_471*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_468*0.1381966011250105 + tmp_moved_constant_469*0.5854101966249684 + tmp_moved_constant_470*0.1381966011250105 + tmp_moved_constant_471*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_468*0.5854101966249684 + tmp_moved_constant_469*0.1381966011250105 + tmp_moved_constant_470*0.1381966011250105 + tmp_moved_constant_471*0.1381966011250105);
                const real_t tmp_moved_constant_488 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_472 + tmp_kernel_op_29*tmp_moved_constant_473 + tmp_kernel_op_30*tmp_moved_constant_474 + tmp_kernel_op_31*tmp_moved_constant_475) + tmp_moved_constant_393*(tmp_moved_constant_472*0.1381966011250105 + tmp_moved_constant_473*0.1381966011250105 + tmp_moved_constant_474*0.5854101966249684 + tmp_moved_constant_475*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_472*0.1381966011250105 + tmp_moved_constant_473*0.5854101966249684 + tmp_moved_constant_474*0.1381966011250105 + tmp_moved_constant_475*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_472*0.5854101966249684 + tmp_moved_constant_473*0.1381966011250105 + tmp_moved_constant_474*0.1381966011250105 + tmp_moved_constant_475*0.1381966011250105);
                const real_t tmp_moved_constant_489 = tmp_moved_constant_392*(tmp_kernel_op_28*tmp_moved_constant_476 + tmp_kernel_op_29*tmp_moved_constant_477 + tmp_kernel_op_30*tmp_moved_constant_478 + tmp_kernel_op_31*tmp_moved_constant_479) + tmp_moved_constant_393*(tmp_moved_constant_476*0.1381966011250105 + tmp_moved_constant_477*0.1381966011250105 + tmp_moved_constant_478*0.5854101966249684 + tmp_moved_constant_479*0.1381966011250105) + tmp_moved_constant_394*(tmp_moved_constant_476*0.1381966011250105 + tmp_moved_constant_477*0.5854101966249684 + tmp_moved_constant_478*0.1381966011250105 + tmp_moved_constant_479*0.1381966011250105) + tmp_moved_constant_395*(tmp_moved_constant_476*0.5854101966249684 + tmp_moved_constant_477*0.1381966011250105 + tmp_moved_constant_478*0.1381966011250105 + tmp_moved_constant_479*0.1381966011250105);
                {
                   {
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_480 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_481 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = tmp_moved_constant_482 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                      _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = tmp_moved_constant_483 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_484 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_485 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = tmp_moved_constant_486 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_487 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = tmp_moved_constant_488 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = tmp_moved_constant_489 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
             }
          }
          if (-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2 >= 0)
          {
             const real_t src_dof_0 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t src_dof_1 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t src_dof_2 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t src_dof_3 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_kernel_op_0 = 2.3416407864998736;
             const real_t tmp_kernel_op_1 = 0.55278640450004202;
             const real_t tmp_kernel_op_2 = 0.55278640450004202;
             const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
             const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
             const real_t tmp_kernel_op_5 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_6 = tmp_kernel_op_5*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_4);
             const real_t tmp_kernel_op_7 = 0.55278640450004202;
             const real_t tmp_kernel_op_8 = 0.55278640450004202;
             const real_t tmp_kernel_op_9 = 2.3416407864998736;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8 + tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_10 + tmp_kernel_op_7 - 3.0;
             const real_t tmp_kernel_op_12 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_13 = tmp_kernel_op_12*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_11);
             const real_t tmp_kernel_op_14 = 0.55278640450004202;
             const real_t tmp_kernel_op_15 = 2.3416407864998736;
             const real_t tmp_kernel_op_16 = 0.55278640450004202;
             const real_t tmp_kernel_op_17 = tmp_kernel_op_15 + tmp_kernel_op_16;
             const real_t tmp_kernel_op_18 = tmp_kernel_op_14 + tmp_kernel_op_17 - 3.0;
             const real_t tmp_kernel_op_19 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_20 = tmp_kernel_op_19*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_18);
             const real_t tmp_kernel_op_21 = 0.55278640450004202;
             const real_t tmp_kernel_op_22 = 0.55278640450004202;
             const real_t tmp_kernel_op_23 = 0.55278640450004202;
             const real_t tmp_kernel_op_24 = tmp_kernel_op_22 + tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_21 + tmp_kernel_op_24 - 3.0;
             const real_t tmp_kernel_op_26 = abs_det_jac_affine_WHITE_UP*0.041666666666666657;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_26*(-jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_25);
             const real_t tmp_kernel_op_28 = 0.13819660112501053;
             const real_t tmp_kernel_op_29 = 0.13819660112501056;
             const real_t tmp_kernel_op_30 = 0.13819660112501056;
             const real_t tmp_kernel_op_31 = 0.5854101966249684;
             const real_t tmp_kernel_op_32 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_kernel_op_33 = tmp_kernel_op_32*tmp_kernel_op_5;
             const real_t tmp_kernel_op_34 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_kernel_op_35 = tmp_kernel_op_12*tmp_kernel_op_34;
             const real_t tmp_kernel_op_36 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_15 - 1.0);
             const real_t tmp_kernel_op_37 = tmp_kernel_op_19*tmp_kernel_op_36;
             const real_t tmp_kernel_op_38 = jac_affine_inv_0_2_WHITE_UP*(tmp_kernel_op_22 - 1.0);
             const real_t tmp_kernel_op_39 = tmp_kernel_op_26*tmp_kernel_op_38;
             const real_t tmp_kernel_op_40 = tmp_kernel_op_28*tmp_kernel_op_5;
             const real_t tmp_kernel_op_41 = tmp_kernel_op_12*tmp_kernel_op_29;
             const real_t tmp_kernel_op_42 = tmp_kernel_op_19*tmp_kernel_op_30;
             const real_t tmp_kernel_op_43 = tmp_kernel_op_26*tmp_kernel_op_31;
             const real_t tmp_kernel_op_44 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_kernel_op_45 = tmp_kernel_op_44*tmp_kernel_op_5;
             const real_t tmp_kernel_op_46 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_kernel_op_47 = tmp_kernel_op_12*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_19*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = jac_affine_inv_1_2_WHITE_UP*(tmp_kernel_op_23 - 1.0);
             const real_t tmp_kernel_op_51 = tmp_kernel_op_26*tmp_kernel_op_50;
             const real_t tmp_kernel_op_52 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_kernel_op_53 = tmp_kernel_op_5*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_7 - 1.0);
             const real_t tmp_kernel_op_55 = tmp_kernel_op_12*tmp_kernel_op_54;
             const real_t tmp_kernel_op_56 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_14 - 1.0);
             const real_t tmp_kernel_op_57 = tmp_kernel_op_19*tmp_kernel_op_56;
             const real_t tmp_kernel_op_58 = jac_affine_inv_2_2_WHITE_UP*(tmp_kernel_op_21 - 1.0);
             const real_t tmp_kernel_op_59 = tmp_kernel_op_26*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
             const real_t tmp_kernel_op_61 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
             const real_t tmp_kernel_op_62 = tmp_kernel_op_5*(-tmp_kernel_op_60 - tmp_kernel_op_61);
             const real_t tmp_kernel_op_63 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_7;
             const real_t tmp_kernel_op_64 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_9;
             const real_t tmp_kernel_op_65 = tmp_kernel_op_12*(-tmp_kernel_op_63 - tmp_kernel_op_64);
             const real_t tmp_kernel_op_66 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_14;
             const real_t tmp_kernel_op_67 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_16;
             const real_t tmp_kernel_op_68 = tmp_kernel_op_19*(-tmp_kernel_op_66 - tmp_kernel_op_67);
             const real_t tmp_kernel_op_69 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_21;
             const real_t tmp_kernel_op_70 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_23;
             const real_t tmp_kernel_op_71 = tmp_kernel_op_26*(-tmp_kernel_op_69 - tmp_kernel_op_70);
             const real_t tmp_kernel_op_72 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_0;
             const real_t tmp_kernel_op_73 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_1;
             const real_t tmp_kernel_op_74 = tmp_kernel_op_5*(-tmp_kernel_op_72 - tmp_kernel_op_73);
             const real_t tmp_kernel_op_75 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_7;
             const real_t tmp_kernel_op_76 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_8;
             const real_t tmp_kernel_op_77 = tmp_kernel_op_12*(-tmp_kernel_op_75 - tmp_kernel_op_76);
             const real_t tmp_kernel_op_78 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_14;
             const real_t tmp_kernel_op_79 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_15;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_19*(-tmp_kernel_op_78 - tmp_kernel_op_79);
             const real_t tmp_kernel_op_81 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_21;
             const real_t tmp_kernel_op_82 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_22;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_26*(-tmp_kernel_op_81 - tmp_kernel_op_82);
             const real_t tmp_kernel_op_84 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_2;
             const real_t tmp_kernel_op_85 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_1;
             const real_t tmp_kernel_op_86 = tmp_kernel_op_5*(-tmp_kernel_op_84 - tmp_kernel_op_85);
             const real_t tmp_kernel_op_87 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9;
             const real_t tmp_kernel_op_88 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_8;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_12*(-tmp_kernel_op_87 - tmp_kernel_op_88);
             const real_t tmp_kernel_op_90 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_16;
             const real_t tmp_kernel_op_91 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_15;
             const real_t tmp_kernel_op_92 = tmp_kernel_op_19*(-tmp_kernel_op_90 - tmp_kernel_op_91);
             const real_t tmp_kernel_op_93 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_23;
             const real_t tmp_kernel_op_94 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_26*(-tmp_kernel_op_93 - tmp_kernel_op_94);
             const real_t tmp_kernel_op_96 = tmp_kernel_op_5*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_kernel_op_60 + tmp_kernel_op_72);
             const real_t tmp_kernel_op_97 = tmp_kernel_op_12*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_kernel_op_63 + tmp_kernel_op_75);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_19*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_kernel_op_66 + tmp_kernel_op_78);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_26*(-jac_affine_inv_2_2_WHITE_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_kernel_op_69 + tmp_kernel_op_81);
             const real_t tmp_kernel_op_100 = tmp_kernel_op_0 - 4.0;
             const real_t tmp_kernel_op_101 = tmp_kernel_op_5*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_kernel_op_61 + tmp_kernel_op_84);
             const real_t tmp_kernel_op_102 = tmp_kernel_op_7 - 4.0;
             const real_t tmp_kernel_op_103 = tmp_kernel_op_12*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_kernel_op_64 + tmp_kernel_op_87);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_14 - 4.0;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_19*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_kernel_op_67 + tmp_kernel_op_90);
             const real_t tmp_kernel_op_106 = tmp_kernel_op_21 - 4.0;
             const real_t tmp_kernel_op_107 = tmp_kernel_op_26*(-jac_affine_inv_1_2_WHITE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_kernel_op_70 + tmp_kernel_op_93);
             const real_t tmp_kernel_op_108 = tmp_kernel_op_5*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_kernel_op_73 + tmp_kernel_op_85);
             const real_t tmp_kernel_op_109 = tmp_kernel_op_12*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_kernel_op_76 + tmp_kernel_op_88);
             const real_t tmp_kernel_op_110 = tmp_kernel_op_19*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_kernel_op_79 + tmp_kernel_op_91);
             const real_t tmp_kernel_op_111 = tmp_kernel_op_26*(-jac_affine_inv_0_2_WHITE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_kernel_op_82 + tmp_kernel_op_94);
             const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_29 + tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_27*tmp_kernel_op_31 + tmp_kernel_op_28*tmp_kernel_op_6) + src_dof_1*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.5854101966249684 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_2*(tmp_kernel_op_13*0.5854101966249684 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_3*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684);
             const real_t elMatVec_1 = src_dof_0*(-tmp_kernel_op_32*tmp_kernel_op_40 - tmp_kernel_op_34*tmp_kernel_op_41 - tmp_kernel_op_36*tmp_kernel_op_42 - tmp_kernel_op_38*tmp_kernel_op_43) + src_dof_1*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.5854101966249684 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.5854101966249684 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_33*-0.5854101966249684 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105);
             const real_t elMatVec_2 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_44 - tmp_kernel_op_41*tmp_kernel_op_46 - tmp_kernel_op_42*tmp_kernel_op_48 - tmp_kernel_op_43*tmp_kernel_op_50) + src_dof_1*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.5854101966249684 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.5854101966249684 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_45*-0.5854101966249684 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105);
             const real_t elMatVec_3 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_52 - tmp_kernel_op_41*tmp_kernel_op_54 - tmp_kernel_op_42*tmp_kernel_op_56 - tmp_kernel_op_43*tmp_kernel_op_58) + src_dof_1*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.5854101966249684 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.5854101966249684 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_53*-0.5854101966249684 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105);
             const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_62 + tmp_kernel_op_29*tmp_kernel_op_65 + tmp_kernel_op_30*tmp_kernel_op_68 + tmp_kernel_op_31*tmp_kernel_op_71) + src_dof_1*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.5854101966249684 + tmp_kernel_op_71*0.1381966011250105) + src_dof_2*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.5854101966249684 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105) + src_dof_3*(tmp_kernel_op_62*0.5854101966249684 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105);
             const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_74 + tmp_kernel_op_29*tmp_kernel_op_77 + tmp_kernel_op_30*tmp_kernel_op_80 + tmp_kernel_op_31*tmp_kernel_op_83) + src_dof_1*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.5854101966249684 + tmp_kernel_op_83*0.1381966011250105) + src_dof_2*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.5854101966249684 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105) + src_dof_3*(tmp_kernel_op_74*0.5854101966249684 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105);
             const real_t elMatVec_6 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_86 + tmp_kernel_op_29*tmp_kernel_op_89 + tmp_kernel_op_30*tmp_kernel_op_92 + tmp_kernel_op_31*tmp_kernel_op_95) + src_dof_1*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.5854101966249684 + tmp_kernel_op_95*0.1381966011250105) + src_dof_2*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.5854101966249684 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105) + src_dof_3*(tmp_kernel_op_86*0.5854101966249684 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105);
             const real_t elMatVec_7 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_96 + tmp_kernel_op_29*tmp_kernel_op_97 + tmp_kernel_op_30*tmp_kernel_op_98 + tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_1*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.5854101966249684 + tmp_kernel_op_99*0.1381966011250105) + src_dof_2*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.5854101966249684 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105) + src_dof_3*(tmp_kernel_op_96*0.5854101966249684 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105);
             const real_t elMatVec_8 = src_dof_0*(tmp_kernel_op_101*tmp_kernel_op_28 + tmp_kernel_op_103*tmp_kernel_op_29 + tmp_kernel_op_105*tmp_kernel_op_30 + tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.5854101966249684 + tmp_kernel_op_107*0.1381966011250105) + src_dof_2*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.5854101966249684 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105) + src_dof_3*(tmp_kernel_op_101*0.5854101966249684 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105);
             const real_t elMatVec_9 = src_dof_0*(tmp_kernel_op_108*tmp_kernel_op_28 + tmp_kernel_op_109*tmp_kernel_op_29 + tmp_kernel_op_110*tmp_kernel_op_30 + tmp_kernel_op_111*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.5854101966249684 + tmp_kernel_op_111*0.1381966011250105) + src_dof_2*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.5854101966249684 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105) + src_dof_3*(tmp_kernel_op_108*0.5854101966249684 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105);
             {
                {
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = elMatVec_0 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = elMatVec_1 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = elMatVec_2 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2] = elMatVec_3 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_4 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_5 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_6 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_7 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_8 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatVec_9 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const real_t tmp_moved_constant_490 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_491 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_492 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_493 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_494 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_495 = tmp_moved_constant_494*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_4);
             const real_t tmp_moved_constant_496 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_497 = tmp_moved_constant_496*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_11);
             const real_t tmp_moved_constant_498 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_499 = tmp_moved_constant_498*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_18);
             const real_t tmp_moved_constant_500 = abs_det_jac_affine_BLUE_UP*0.041666666666666657;
             const real_t tmp_moved_constant_501 = tmp_moved_constant_500*(-jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_25);
             const real_t tmp_moved_constant_502 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_503 = tmp_moved_constant_494*tmp_moved_constant_502;
             const real_t tmp_moved_constant_504 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_505 = tmp_moved_constant_496*tmp_moved_constant_504;
             const real_t tmp_moved_constant_506 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_15 - 1.0);
             const real_t tmp_moved_constant_507 = tmp_moved_constant_498*tmp_moved_constant_506;
             const real_t tmp_moved_constant_508 = jac_affine_inv_0_2_BLUE_UP*(tmp_kernel_op_22 - 1.0);
             const real_t tmp_moved_constant_509 = tmp_moved_constant_500*tmp_moved_constant_508;
             const real_t tmp_moved_constant_510 = tmp_kernel_op_28*tmp_moved_constant_494;
             const real_t tmp_moved_constant_511 = tmp_kernel_op_29*tmp_moved_constant_496;
             const real_t tmp_moved_constant_512 = tmp_kernel_op_30*tmp_moved_constant_498;
             const real_t tmp_moved_constant_513 = tmp_kernel_op_31*tmp_moved_constant_500;
             const real_t tmp_moved_constant_514 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_515 = tmp_moved_constant_494*tmp_moved_constant_514;
             const real_t tmp_moved_constant_516 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_517 = tmp_moved_constant_496*tmp_moved_constant_516;
             const real_t tmp_moved_constant_518 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_519 = tmp_moved_constant_498*tmp_moved_constant_518;
             const real_t tmp_moved_constant_520 = jac_affine_inv_1_2_BLUE_UP*(tmp_kernel_op_23 - 1.0);
             const real_t tmp_moved_constant_521 = tmp_moved_constant_500*tmp_moved_constant_520;
             const real_t tmp_moved_constant_522 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_523 = tmp_moved_constant_494*tmp_moved_constant_522;
             const real_t tmp_moved_constant_524 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_7 - 1.0);
             const real_t tmp_moved_constant_525 = tmp_moved_constant_496*tmp_moved_constant_524;
             const real_t tmp_moved_constant_526 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_14 - 1.0);
             const real_t tmp_moved_constant_527 = tmp_moved_constant_498*tmp_moved_constant_526;
             const real_t tmp_moved_constant_528 = jac_affine_inv_2_2_BLUE_UP*(tmp_kernel_op_21 - 1.0);
             const real_t tmp_moved_constant_529 = tmp_moved_constant_500*tmp_moved_constant_528;
             const real_t tmp_moved_constant_530 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_531 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_532 = tmp_moved_constant_494*(-tmp_moved_constant_530 - tmp_moved_constant_531);
             const real_t tmp_moved_constant_533 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_7;
             const real_t tmp_moved_constant_534 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_535 = tmp_moved_constant_496*(-tmp_moved_constant_533 - tmp_moved_constant_534);
             const real_t tmp_moved_constant_536 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_14;
             const real_t tmp_moved_constant_537 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_538 = tmp_moved_constant_498*(-tmp_moved_constant_536 - tmp_moved_constant_537);
             const real_t tmp_moved_constant_539 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_21;
             const real_t tmp_moved_constant_540 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_23;
             const real_t tmp_moved_constant_541 = tmp_moved_constant_500*(-tmp_moved_constant_539 - tmp_moved_constant_540);
             const real_t tmp_moved_constant_542 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_543 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_544 = tmp_moved_constant_494*(-tmp_moved_constant_542 - tmp_moved_constant_543);
             const real_t tmp_moved_constant_545 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_7;
             const real_t tmp_moved_constant_546 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_547 = tmp_moved_constant_496*(-tmp_moved_constant_545 - tmp_moved_constant_546);
             const real_t tmp_moved_constant_548 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_14;
             const real_t tmp_moved_constant_549 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_15;
             const real_t tmp_moved_constant_550 = tmp_moved_constant_498*(-tmp_moved_constant_548 - tmp_moved_constant_549);
             const real_t tmp_moved_constant_551 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_21;
             const real_t tmp_moved_constant_552 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_22;
             const real_t tmp_moved_constant_553 = tmp_moved_constant_500*(-tmp_moved_constant_551 - tmp_moved_constant_552);
             const real_t tmp_moved_constant_554 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_555 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_556 = tmp_moved_constant_494*(-tmp_moved_constant_554 - tmp_moved_constant_555);
             const real_t tmp_moved_constant_557 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_558 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_559 = tmp_moved_constant_496*(-tmp_moved_constant_557 - tmp_moved_constant_558);
             const real_t tmp_moved_constant_560 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_561 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_15;
             const real_t tmp_moved_constant_562 = tmp_moved_constant_498*(-tmp_moved_constant_560 - tmp_moved_constant_561);
             const real_t tmp_moved_constant_563 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_23;
             const real_t tmp_moved_constant_564 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_22;
             const real_t tmp_moved_constant_565 = tmp_moved_constant_500*(-tmp_moved_constant_563 - tmp_moved_constant_564);
             const real_t tmp_moved_constant_566 = tmp_moved_constant_494*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_530 + tmp_moved_constant_542);
             const real_t tmp_moved_constant_567 = tmp_moved_constant_496*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_533 + tmp_moved_constant_545);
             const real_t tmp_moved_constant_568 = tmp_moved_constant_498*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_536 + tmp_moved_constant_548);
             const real_t tmp_moved_constant_569 = tmp_moved_constant_500*(-jac_affine_inv_2_2_BLUE_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_539 + tmp_moved_constant_551);
             const real_t tmp_moved_constant_570 = tmp_moved_constant_494*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_531 + tmp_moved_constant_554);
             const real_t tmp_moved_constant_571 = tmp_moved_constant_496*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_534 + tmp_moved_constant_557);
             const real_t tmp_moved_constant_572 = tmp_moved_constant_498*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_537 + tmp_moved_constant_560);
             const real_t tmp_moved_constant_573 = tmp_moved_constant_500*(-jac_affine_inv_1_2_BLUE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_540 + tmp_moved_constant_563);
             const real_t tmp_moved_constant_574 = tmp_moved_constant_494*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_543 + tmp_moved_constant_555);
             const real_t tmp_moved_constant_575 = tmp_moved_constant_496*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_546 + tmp_moved_constant_558);
             const real_t tmp_moved_constant_576 = tmp_moved_constant_498*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_549 + tmp_moved_constant_561);
             const real_t tmp_moved_constant_577 = tmp_moved_constant_500*(-jac_affine_inv_0_2_BLUE_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_552 + tmp_moved_constant_564);
             const real_t tmp_moved_constant_578 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_495 + tmp_kernel_op_29*tmp_moved_constant_497 + tmp_kernel_op_30*tmp_moved_constant_499 + tmp_kernel_op_31*tmp_moved_constant_501) + tmp_moved_constant_491*(tmp_moved_constant_495*0.1381966011250105 + tmp_moved_constant_497*0.1381966011250105 + tmp_moved_constant_499*0.5854101966249684 + tmp_moved_constant_501*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_495*0.1381966011250105 + tmp_moved_constant_497*0.5854101966249684 + tmp_moved_constant_499*0.1381966011250105 + tmp_moved_constant_501*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_495*0.5854101966249684 + tmp_moved_constant_497*0.1381966011250105 + tmp_moved_constant_499*0.1381966011250105 + tmp_moved_constant_501*0.1381966011250105);
             const real_t tmp_moved_constant_579 = tmp_moved_constant_490*(-tmp_moved_constant_502*tmp_moved_constant_510 - tmp_moved_constant_504*tmp_moved_constant_511 - tmp_moved_constant_506*tmp_moved_constant_512 - tmp_moved_constant_508*tmp_moved_constant_513) + tmp_moved_constant_491*(tmp_moved_constant_503*-0.1381966011250105 + tmp_moved_constant_505*-0.1381966011250105 + tmp_moved_constant_507*-0.5854101966249684 + tmp_moved_constant_509*-0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_503*-0.1381966011250105 + tmp_moved_constant_505*-0.5854101966249684 + tmp_moved_constant_507*-0.1381966011250105 + tmp_moved_constant_509*-0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_503*-0.5854101966249684 + tmp_moved_constant_505*-0.1381966011250105 + tmp_moved_constant_507*-0.1381966011250105 + tmp_moved_constant_509*-0.1381966011250105);
             const real_t tmp_moved_constant_580 = tmp_moved_constant_490*(-tmp_moved_constant_510*tmp_moved_constant_514 - tmp_moved_constant_511*tmp_moved_constant_516 - tmp_moved_constant_512*tmp_moved_constant_518 - tmp_moved_constant_513*tmp_moved_constant_520) + tmp_moved_constant_491*(tmp_moved_constant_515*-0.1381966011250105 + tmp_moved_constant_517*-0.1381966011250105 + tmp_moved_constant_519*-0.5854101966249684 + tmp_moved_constant_521*-0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_515*-0.1381966011250105 + tmp_moved_constant_517*-0.5854101966249684 + tmp_moved_constant_519*-0.1381966011250105 + tmp_moved_constant_521*-0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_515*-0.5854101966249684 + tmp_moved_constant_517*-0.1381966011250105 + tmp_moved_constant_519*-0.1381966011250105 + tmp_moved_constant_521*-0.1381966011250105);
             const real_t tmp_moved_constant_581 = tmp_moved_constant_490*(-tmp_moved_constant_510*tmp_moved_constant_522 - tmp_moved_constant_511*tmp_moved_constant_524 - tmp_moved_constant_512*tmp_moved_constant_526 - tmp_moved_constant_513*tmp_moved_constant_528) + tmp_moved_constant_491*(tmp_moved_constant_523*-0.1381966011250105 + tmp_moved_constant_525*-0.1381966011250105 + tmp_moved_constant_527*-0.5854101966249684 + tmp_moved_constant_529*-0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_523*-0.1381966011250105 + tmp_moved_constant_525*-0.5854101966249684 + tmp_moved_constant_527*-0.1381966011250105 + tmp_moved_constant_529*-0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_523*-0.5854101966249684 + tmp_moved_constant_525*-0.1381966011250105 + tmp_moved_constant_527*-0.1381966011250105 + tmp_moved_constant_529*-0.1381966011250105);
             const real_t tmp_moved_constant_582 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_532 + tmp_kernel_op_29*tmp_moved_constant_535 + tmp_kernel_op_30*tmp_moved_constant_538 + tmp_kernel_op_31*tmp_moved_constant_541) + tmp_moved_constant_491*(tmp_moved_constant_532*0.1381966011250105 + tmp_moved_constant_535*0.1381966011250105 + tmp_moved_constant_538*0.5854101966249684 + tmp_moved_constant_541*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_532*0.1381966011250105 + tmp_moved_constant_535*0.5854101966249684 + tmp_moved_constant_538*0.1381966011250105 + tmp_moved_constant_541*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_532*0.5854101966249684 + tmp_moved_constant_535*0.1381966011250105 + tmp_moved_constant_538*0.1381966011250105 + tmp_moved_constant_541*0.1381966011250105);
             const real_t tmp_moved_constant_583 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_544 + tmp_kernel_op_29*tmp_moved_constant_547 + tmp_kernel_op_30*tmp_moved_constant_550 + tmp_kernel_op_31*tmp_moved_constant_553) + tmp_moved_constant_491*(tmp_moved_constant_544*0.1381966011250105 + tmp_moved_constant_547*0.1381966011250105 + tmp_moved_constant_550*0.5854101966249684 + tmp_moved_constant_553*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_544*0.1381966011250105 + tmp_moved_constant_547*0.5854101966249684 + tmp_moved_constant_550*0.1381966011250105 + tmp_moved_constant_553*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_544*0.5854101966249684 + tmp_moved_constant_547*0.1381966011250105 + tmp_moved_constant_550*0.1381966011250105 + tmp_moved_constant_553*0.1381966011250105);
             const real_t tmp_moved_constant_584 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_556 + tmp_kernel_op_29*tmp_moved_constant_559 + tmp_kernel_op_30*tmp_moved_constant_562 + tmp_kernel_op_31*tmp_moved_constant_565) + tmp_moved_constant_491*(tmp_moved_constant_556*0.1381966011250105 + tmp_moved_constant_559*0.1381966011250105 + tmp_moved_constant_562*0.5854101966249684 + tmp_moved_constant_565*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_556*0.1381966011250105 + tmp_moved_constant_559*0.5854101966249684 + tmp_moved_constant_562*0.1381966011250105 + tmp_moved_constant_565*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_556*0.5854101966249684 + tmp_moved_constant_559*0.1381966011250105 + tmp_moved_constant_562*0.1381966011250105 + tmp_moved_constant_565*0.1381966011250105);
             const real_t tmp_moved_constant_585 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_566 + tmp_kernel_op_29*tmp_moved_constant_567 + tmp_kernel_op_30*tmp_moved_constant_568 + tmp_kernel_op_31*tmp_moved_constant_569) + tmp_moved_constant_491*(tmp_moved_constant_566*0.1381966011250105 + tmp_moved_constant_567*0.1381966011250105 + tmp_moved_constant_568*0.5854101966249684 + tmp_moved_constant_569*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_566*0.1381966011250105 + tmp_moved_constant_567*0.5854101966249684 + tmp_moved_constant_568*0.1381966011250105 + tmp_moved_constant_569*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_566*0.5854101966249684 + tmp_moved_constant_567*0.1381966011250105 + tmp_moved_constant_568*0.1381966011250105 + tmp_moved_constant_569*0.1381966011250105);
             const real_t tmp_moved_constant_586 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_570 + tmp_kernel_op_29*tmp_moved_constant_571 + tmp_kernel_op_30*tmp_moved_constant_572 + tmp_kernel_op_31*tmp_moved_constant_573) + tmp_moved_constant_491*(tmp_moved_constant_570*0.1381966011250105 + tmp_moved_constant_571*0.1381966011250105 + tmp_moved_constant_572*0.5854101966249684 + tmp_moved_constant_573*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_570*0.1381966011250105 + tmp_moved_constant_571*0.5854101966249684 + tmp_moved_constant_572*0.1381966011250105 + tmp_moved_constant_573*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_570*0.5854101966249684 + tmp_moved_constant_571*0.1381966011250105 + tmp_moved_constant_572*0.1381966011250105 + tmp_moved_constant_573*0.1381966011250105);
             const real_t tmp_moved_constant_587 = tmp_moved_constant_490*(tmp_kernel_op_28*tmp_moved_constant_574 + tmp_kernel_op_29*tmp_moved_constant_575 + tmp_kernel_op_30*tmp_moved_constant_576 + tmp_kernel_op_31*tmp_moved_constant_577) + tmp_moved_constant_491*(tmp_moved_constant_574*0.1381966011250105 + tmp_moved_constant_575*0.1381966011250105 + tmp_moved_constant_576*0.5854101966249684 + tmp_moved_constant_577*0.1381966011250105) + tmp_moved_constant_492*(tmp_moved_constant_574*0.1381966011250105 + tmp_moved_constant_575*0.5854101966249684 + tmp_moved_constant_576*0.1381966011250105 + tmp_moved_constant_577*0.1381966011250105) + tmp_moved_constant_493*(tmp_moved_constant_574*0.5854101966249684 + tmp_moved_constant_575*0.1381966011250105 + tmp_moved_constant_576*0.1381966011250105 + tmp_moved_constant_577*0.1381966011250105);
             {
                {
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_578 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_579 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_580 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_581 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = tmp_moved_constant_582 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_583 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_584 + _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = tmp_moved_constant_585 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = tmp_moved_constant_586 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_587 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const real_t tmp_moved_constant_588 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_589 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_590 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_591 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_592 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_593 = tmp_moved_constant_592*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_4);
             const real_t tmp_moved_constant_594 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_595 = tmp_moved_constant_594*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_11 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_11 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_11);
             const real_t tmp_moved_constant_596 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_597 = tmp_moved_constant_596*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_18 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_18 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_18);
             const real_t tmp_moved_constant_598 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_599 = tmp_moved_constant_598*(-jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_25 - jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_25 - jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_25);
             const real_t tmp_moved_constant_600 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_601 = tmp_moved_constant_592*tmp_moved_constant_600;
             const real_t tmp_moved_constant_602 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_603 = tmp_moved_constant_594*tmp_moved_constant_602;
             const real_t tmp_moved_constant_604 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_15 - 1.0);
             const real_t tmp_moved_constant_605 = tmp_moved_constant_596*tmp_moved_constant_604;
             const real_t tmp_moved_constant_606 = jac_affine_inv_0_2_BLUE_DOWN*(tmp_kernel_op_22 - 1.0);
             const real_t tmp_moved_constant_607 = tmp_moved_constant_598*tmp_moved_constant_606;
             const real_t tmp_moved_constant_608 = tmp_kernel_op_28*tmp_moved_constant_592;
             const real_t tmp_moved_constant_609 = tmp_kernel_op_29*tmp_moved_constant_594;
             const real_t tmp_moved_constant_610 = tmp_kernel_op_30*tmp_moved_constant_596;
             const real_t tmp_moved_constant_611 = tmp_kernel_op_31*tmp_moved_constant_598;
             const real_t tmp_moved_constant_612 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_613 = tmp_moved_constant_592*tmp_moved_constant_612;
             const real_t tmp_moved_constant_614 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_615 = tmp_moved_constant_594*tmp_moved_constant_614;
             const real_t tmp_moved_constant_616 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_617 = tmp_moved_constant_596*tmp_moved_constant_616;
             const real_t tmp_moved_constant_618 = jac_affine_inv_1_2_BLUE_DOWN*(tmp_kernel_op_23 - 1.0);
             const real_t tmp_moved_constant_619 = tmp_moved_constant_598*tmp_moved_constant_618;
             const real_t tmp_moved_constant_620 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_621 = tmp_moved_constant_592*tmp_moved_constant_620;
             const real_t tmp_moved_constant_622 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_7 - 1.0);
             const real_t tmp_moved_constant_623 = tmp_moved_constant_594*tmp_moved_constant_622;
             const real_t tmp_moved_constant_624 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_14 - 1.0);
             const real_t tmp_moved_constant_625 = tmp_moved_constant_596*tmp_moved_constant_624;
             const real_t tmp_moved_constant_626 = jac_affine_inv_2_2_BLUE_DOWN*(tmp_kernel_op_21 - 1.0);
             const real_t tmp_moved_constant_627 = tmp_moved_constant_598*tmp_moved_constant_626;
             const real_t tmp_moved_constant_628 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_629 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_630 = tmp_moved_constant_592*(-tmp_moved_constant_628 - tmp_moved_constant_629);
             const real_t tmp_moved_constant_631 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_7;
             const real_t tmp_moved_constant_632 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_633 = tmp_moved_constant_594*(-tmp_moved_constant_631 - tmp_moved_constant_632);
             const real_t tmp_moved_constant_634 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_14;
             const real_t tmp_moved_constant_635 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_636 = tmp_moved_constant_596*(-tmp_moved_constant_634 - tmp_moved_constant_635);
             const real_t tmp_moved_constant_637 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_21;
             const real_t tmp_moved_constant_638 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_23;
             const real_t tmp_moved_constant_639 = tmp_moved_constant_598*(-tmp_moved_constant_637 - tmp_moved_constant_638);
             const real_t tmp_moved_constant_640 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_641 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_642 = tmp_moved_constant_592*(-tmp_moved_constant_640 - tmp_moved_constant_641);
             const real_t tmp_moved_constant_643 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_7;
             const real_t tmp_moved_constant_644 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_645 = tmp_moved_constant_594*(-tmp_moved_constant_643 - tmp_moved_constant_644);
             const real_t tmp_moved_constant_646 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_14;
             const real_t tmp_moved_constant_647 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_15;
             const real_t tmp_moved_constant_648 = tmp_moved_constant_596*(-tmp_moved_constant_646 - tmp_moved_constant_647);
             const real_t tmp_moved_constant_649 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_21;
             const real_t tmp_moved_constant_650 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_22;
             const real_t tmp_moved_constant_651 = tmp_moved_constant_598*(-tmp_moved_constant_649 - tmp_moved_constant_650);
             const real_t tmp_moved_constant_652 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_653 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_654 = tmp_moved_constant_592*(-tmp_moved_constant_652 - tmp_moved_constant_653);
             const real_t tmp_moved_constant_655 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_656 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_657 = tmp_moved_constant_594*(-tmp_moved_constant_655 - tmp_moved_constant_656);
             const real_t tmp_moved_constant_658 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_659 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_15;
             const real_t tmp_moved_constant_660 = tmp_moved_constant_596*(-tmp_moved_constant_658 - tmp_moved_constant_659);
             const real_t tmp_moved_constant_661 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_23;
             const real_t tmp_moved_constant_662 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_22;
             const real_t tmp_moved_constant_663 = tmp_moved_constant_598*(-tmp_moved_constant_661 - tmp_moved_constant_662);
             const real_t tmp_moved_constant_664 = tmp_moved_constant_592*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_628 + tmp_moved_constant_640);
             const real_t tmp_moved_constant_665 = tmp_moved_constant_594*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_631 + tmp_moved_constant_643);
             const real_t tmp_moved_constant_666 = tmp_moved_constant_596*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_634 + tmp_moved_constant_646);
             const real_t tmp_moved_constant_667 = tmp_moved_constant_598*(-jac_affine_inv_2_2_BLUE_DOWN*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_637 + tmp_moved_constant_649);
             const real_t tmp_moved_constant_668 = tmp_moved_constant_592*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_629 + tmp_moved_constant_652);
             const real_t tmp_moved_constant_669 = tmp_moved_constant_594*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_632 + tmp_moved_constant_655);
             const real_t tmp_moved_constant_670 = tmp_moved_constant_596*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_635 + tmp_moved_constant_658);
             const real_t tmp_moved_constant_671 = tmp_moved_constant_598*(-jac_affine_inv_1_2_BLUE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_638 + tmp_moved_constant_661);
             const real_t tmp_moved_constant_672 = tmp_moved_constant_592*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_641 + tmp_moved_constant_653);
             const real_t tmp_moved_constant_673 = tmp_moved_constant_594*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_644 + tmp_moved_constant_656);
             const real_t tmp_moved_constant_674 = tmp_moved_constant_596*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_647 + tmp_moved_constant_659);
             const real_t tmp_moved_constant_675 = tmp_moved_constant_598*(-jac_affine_inv_0_2_BLUE_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_650 + tmp_moved_constant_662);
             const real_t tmp_moved_constant_676 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_593 + tmp_kernel_op_29*tmp_moved_constant_595 + tmp_kernel_op_30*tmp_moved_constant_597 + tmp_kernel_op_31*tmp_moved_constant_599) + tmp_moved_constant_589*(tmp_moved_constant_593*0.1381966011250105 + tmp_moved_constant_595*0.1381966011250105 + tmp_moved_constant_597*0.5854101966249684 + tmp_moved_constant_599*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_593*0.1381966011250105 + tmp_moved_constant_595*0.5854101966249684 + tmp_moved_constant_597*0.1381966011250105 + tmp_moved_constant_599*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_593*0.5854101966249684 + tmp_moved_constant_595*0.1381966011250105 + tmp_moved_constant_597*0.1381966011250105 + tmp_moved_constant_599*0.1381966011250105);
             const real_t tmp_moved_constant_677 = tmp_moved_constant_588*(-tmp_moved_constant_600*tmp_moved_constant_608 - tmp_moved_constant_602*tmp_moved_constant_609 - tmp_moved_constant_604*tmp_moved_constant_610 - tmp_moved_constant_606*tmp_moved_constant_611) + tmp_moved_constant_589*(tmp_moved_constant_601*-0.1381966011250105 + tmp_moved_constant_603*-0.1381966011250105 + tmp_moved_constant_605*-0.5854101966249684 + tmp_moved_constant_607*-0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_601*-0.1381966011250105 + tmp_moved_constant_603*-0.5854101966249684 + tmp_moved_constant_605*-0.1381966011250105 + tmp_moved_constant_607*-0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_601*-0.5854101966249684 + tmp_moved_constant_603*-0.1381966011250105 + tmp_moved_constant_605*-0.1381966011250105 + tmp_moved_constant_607*-0.1381966011250105);
             const real_t tmp_moved_constant_678 = tmp_moved_constant_588*(-tmp_moved_constant_608*tmp_moved_constant_612 - tmp_moved_constant_609*tmp_moved_constant_614 - tmp_moved_constant_610*tmp_moved_constant_616 - tmp_moved_constant_611*tmp_moved_constant_618) + tmp_moved_constant_589*(tmp_moved_constant_613*-0.1381966011250105 + tmp_moved_constant_615*-0.1381966011250105 + tmp_moved_constant_617*-0.5854101966249684 + tmp_moved_constant_619*-0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_613*-0.1381966011250105 + tmp_moved_constant_615*-0.5854101966249684 + tmp_moved_constant_617*-0.1381966011250105 + tmp_moved_constant_619*-0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_613*-0.5854101966249684 + tmp_moved_constant_615*-0.1381966011250105 + tmp_moved_constant_617*-0.1381966011250105 + tmp_moved_constant_619*-0.1381966011250105);
             const real_t tmp_moved_constant_679 = tmp_moved_constant_588*(-tmp_moved_constant_608*tmp_moved_constant_620 - tmp_moved_constant_609*tmp_moved_constant_622 - tmp_moved_constant_610*tmp_moved_constant_624 - tmp_moved_constant_611*tmp_moved_constant_626) + tmp_moved_constant_589*(tmp_moved_constant_621*-0.1381966011250105 + tmp_moved_constant_623*-0.1381966011250105 + tmp_moved_constant_625*-0.5854101966249684 + tmp_moved_constant_627*-0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_621*-0.1381966011250105 + tmp_moved_constant_623*-0.5854101966249684 + tmp_moved_constant_625*-0.1381966011250105 + tmp_moved_constant_627*-0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_621*-0.5854101966249684 + tmp_moved_constant_623*-0.1381966011250105 + tmp_moved_constant_625*-0.1381966011250105 + tmp_moved_constant_627*-0.1381966011250105);
             const real_t tmp_moved_constant_680 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_630 + tmp_kernel_op_29*tmp_moved_constant_633 + tmp_kernel_op_30*tmp_moved_constant_636 + tmp_kernel_op_31*tmp_moved_constant_639) + tmp_moved_constant_589*(tmp_moved_constant_630*0.1381966011250105 + tmp_moved_constant_633*0.1381966011250105 + tmp_moved_constant_636*0.5854101966249684 + tmp_moved_constant_639*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_630*0.1381966011250105 + tmp_moved_constant_633*0.5854101966249684 + tmp_moved_constant_636*0.1381966011250105 + tmp_moved_constant_639*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_630*0.5854101966249684 + tmp_moved_constant_633*0.1381966011250105 + tmp_moved_constant_636*0.1381966011250105 + tmp_moved_constant_639*0.1381966011250105);
             const real_t tmp_moved_constant_681 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_642 + tmp_kernel_op_29*tmp_moved_constant_645 + tmp_kernel_op_30*tmp_moved_constant_648 + tmp_kernel_op_31*tmp_moved_constant_651) + tmp_moved_constant_589*(tmp_moved_constant_642*0.1381966011250105 + tmp_moved_constant_645*0.1381966011250105 + tmp_moved_constant_648*0.5854101966249684 + tmp_moved_constant_651*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_642*0.1381966011250105 + tmp_moved_constant_645*0.5854101966249684 + tmp_moved_constant_648*0.1381966011250105 + tmp_moved_constant_651*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_642*0.5854101966249684 + tmp_moved_constant_645*0.1381966011250105 + tmp_moved_constant_648*0.1381966011250105 + tmp_moved_constant_651*0.1381966011250105);
             const real_t tmp_moved_constant_682 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_654 + tmp_kernel_op_29*tmp_moved_constant_657 + tmp_kernel_op_30*tmp_moved_constant_660 + tmp_kernel_op_31*tmp_moved_constant_663) + tmp_moved_constant_589*(tmp_moved_constant_654*0.1381966011250105 + tmp_moved_constant_657*0.1381966011250105 + tmp_moved_constant_660*0.5854101966249684 + tmp_moved_constant_663*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_654*0.1381966011250105 + tmp_moved_constant_657*0.5854101966249684 + tmp_moved_constant_660*0.1381966011250105 + tmp_moved_constant_663*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_654*0.5854101966249684 + tmp_moved_constant_657*0.1381966011250105 + tmp_moved_constant_660*0.1381966011250105 + tmp_moved_constant_663*0.1381966011250105);
             const real_t tmp_moved_constant_683 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_664 + tmp_kernel_op_29*tmp_moved_constant_665 + tmp_kernel_op_30*tmp_moved_constant_666 + tmp_kernel_op_31*tmp_moved_constant_667) + tmp_moved_constant_589*(tmp_moved_constant_664*0.1381966011250105 + tmp_moved_constant_665*0.1381966011250105 + tmp_moved_constant_666*0.5854101966249684 + tmp_moved_constant_667*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_664*0.1381966011250105 + tmp_moved_constant_665*0.5854101966249684 + tmp_moved_constant_666*0.1381966011250105 + tmp_moved_constant_667*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_664*0.5854101966249684 + tmp_moved_constant_665*0.1381966011250105 + tmp_moved_constant_666*0.1381966011250105 + tmp_moved_constant_667*0.1381966011250105);
             const real_t tmp_moved_constant_684 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_668 + tmp_kernel_op_29*tmp_moved_constant_669 + tmp_kernel_op_30*tmp_moved_constant_670 + tmp_kernel_op_31*tmp_moved_constant_671) + tmp_moved_constant_589*(tmp_moved_constant_668*0.1381966011250105 + tmp_moved_constant_669*0.1381966011250105 + tmp_moved_constant_670*0.5854101966249684 + tmp_moved_constant_671*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_668*0.1381966011250105 + tmp_moved_constant_669*0.5854101966249684 + tmp_moved_constant_670*0.1381966011250105 + tmp_moved_constant_671*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_668*0.5854101966249684 + tmp_moved_constant_669*0.1381966011250105 + tmp_moved_constant_670*0.1381966011250105 + tmp_moved_constant_671*0.1381966011250105);
             const real_t tmp_moved_constant_685 = tmp_moved_constant_588*(tmp_kernel_op_28*tmp_moved_constant_672 + tmp_kernel_op_29*tmp_moved_constant_673 + tmp_kernel_op_30*tmp_moved_constant_674 + tmp_kernel_op_31*tmp_moved_constant_675) + tmp_moved_constant_589*(tmp_moved_constant_672*0.1381966011250105 + tmp_moved_constant_673*0.1381966011250105 + tmp_moved_constant_674*0.5854101966249684 + tmp_moved_constant_675*0.1381966011250105) + tmp_moved_constant_590*(tmp_moved_constant_672*0.1381966011250105 + tmp_moved_constant_673*0.5854101966249684 + tmp_moved_constant_674*0.1381966011250105 + tmp_moved_constant_675*0.1381966011250105) + tmp_moved_constant_591*(tmp_moved_constant_672*0.5854101966249684 + tmp_moved_constant_673*0.1381966011250105 + tmp_moved_constant_674*0.1381966011250105 + tmp_moved_constant_675*0.1381966011250105);
             {
                {
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_676 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_677 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_678 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_679 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_680 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_681 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_682 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_683 + _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_684 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_685 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const real_t tmp_moved_constant_686 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_687 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_688 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_689 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_690 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_691 = tmp_moved_constant_690*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_4 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_4);
             const real_t tmp_moved_constant_692 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_693 = tmp_moved_constant_692*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_11 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_11 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_11);
             const real_t tmp_moved_constant_694 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_695 = tmp_moved_constant_694*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_18 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_18 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_18);
             const real_t tmp_moved_constant_696 = abs_det_jac_affine_GREEN_UP*0.041666666666666657;
             const real_t tmp_moved_constant_697 = tmp_moved_constant_696*(-jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_25 - jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_25 - jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_25);
             const real_t tmp_moved_constant_698 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_699 = tmp_moved_constant_690*tmp_moved_constant_698;
             const real_t tmp_moved_constant_700 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_701 = tmp_moved_constant_692*tmp_moved_constant_700;
             const real_t tmp_moved_constant_702 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_15 - 1.0);
             const real_t tmp_moved_constant_703 = tmp_moved_constant_694*tmp_moved_constant_702;
             const real_t tmp_moved_constant_704 = jac_affine_inv_0_2_GREEN_UP*(tmp_kernel_op_22 - 1.0);
             const real_t tmp_moved_constant_705 = tmp_moved_constant_696*tmp_moved_constant_704;
             const real_t tmp_moved_constant_706 = tmp_kernel_op_28*tmp_moved_constant_690;
             const real_t tmp_moved_constant_707 = tmp_kernel_op_29*tmp_moved_constant_692;
             const real_t tmp_moved_constant_708 = tmp_kernel_op_30*tmp_moved_constant_694;
             const real_t tmp_moved_constant_709 = tmp_kernel_op_31*tmp_moved_constant_696;
             const real_t tmp_moved_constant_710 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_711 = tmp_moved_constant_690*tmp_moved_constant_710;
             const real_t tmp_moved_constant_712 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_713 = tmp_moved_constant_692*tmp_moved_constant_712;
             const real_t tmp_moved_constant_714 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_715 = tmp_moved_constant_694*tmp_moved_constant_714;
             const real_t tmp_moved_constant_716 = jac_affine_inv_1_2_GREEN_UP*(tmp_kernel_op_23 - 1.0);
             const real_t tmp_moved_constant_717 = tmp_moved_constant_696*tmp_moved_constant_716;
             const real_t tmp_moved_constant_718 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_719 = tmp_moved_constant_690*tmp_moved_constant_718;
             const real_t tmp_moved_constant_720 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_7 - 1.0);
             const real_t tmp_moved_constant_721 = tmp_moved_constant_692*tmp_moved_constant_720;
             const real_t tmp_moved_constant_722 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_14 - 1.0);
             const real_t tmp_moved_constant_723 = tmp_moved_constant_694*tmp_moved_constant_722;
             const real_t tmp_moved_constant_724 = jac_affine_inv_2_2_GREEN_UP*(tmp_kernel_op_21 - 1.0);
             const real_t tmp_moved_constant_725 = tmp_moved_constant_696*tmp_moved_constant_724;
             const real_t tmp_moved_constant_726 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_727 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_728 = tmp_moved_constant_690*(-tmp_moved_constant_726 - tmp_moved_constant_727);
             const real_t tmp_moved_constant_729 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_7;
             const real_t tmp_moved_constant_730 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_731 = tmp_moved_constant_692*(-tmp_moved_constant_729 - tmp_moved_constant_730);
             const real_t tmp_moved_constant_732 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_14;
             const real_t tmp_moved_constant_733 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_734 = tmp_moved_constant_694*(-tmp_moved_constant_732 - tmp_moved_constant_733);
             const real_t tmp_moved_constant_735 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_21;
             const real_t tmp_moved_constant_736 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_23;
             const real_t tmp_moved_constant_737 = tmp_moved_constant_696*(-tmp_moved_constant_735 - tmp_moved_constant_736);
             const real_t tmp_moved_constant_738 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_0;
             const real_t tmp_moved_constant_739 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_740 = tmp_moved_constant_690*(-tmp_moved_constant_738 - tmp_moved_constant_739);
             const real_t tmp_moved_constant_741 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_7;
             const real_t tmp_moved_constant_742 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_743 = tmp_moved_constant_692*(-tmp_moved_constant_741 - tmp_moved_constant_742);
             const real_t tmp_moved_constant_744 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_14;
             const real_t tmp_moved_constant_745 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_15;
             const real_t tmp_moved_constant_746 = tmp_moved_constant_694*(-tmp_moved_constant_744 - tmp_moved_constant_745);
             const real_t tmp_moved_constant_747 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_21;
             const real_t tmp_moved_constant_748 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_22;
             const real_t tmp_moved_constant_749 = tmp_moved_constant_696*(-tmp_moved_constant_747 - tmp_moved_constant_748);
             const real_t tmp_moved_constant_750 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_2;
             const real_t tmp_moved_constant_751 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_1;
             const real_t tmp_moved_constant_752 = tmp_moved_constant_690*(-tmp_moved_constant_750 - tmp_moved_constant_751);
             const real_t tmp_moved_constant_753 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_9;
             const real_t tmp_moved_constant_754 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_8;
             const real_t tmp_moved_constant_755 = tmp_moved_constant_692*(-tmp_moved_constant_753 - tmp_moved_constant_754);
             const real_t tmp_moved_constant_756 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_16;
             const real_t tmp_moved_constant_757 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_15;
             const real_t tmp_moved_constant_758 = tmp_moved_constant_694*(-tmp_moved_constant_756 - tmp_moved_constant_757);
             const real_t tmp_moved_constant_759 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_23;
             const real_t tmp_moved_constant_760 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_22;
             const real_t tmp_moved_constant_761 = tmp_moved_constant_696*(-tmp_moved_constant_759 - tmp_moved_constant_760);
             const real_t tmp_moved_constant_762 = tmp_moved_constant_690*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_726 + tmp_moved_constant_738);
             const real_t tmp_moved_constant_763 = tmp_moved_constant_692*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_729 + tmp_moved_constant_741);
             const real_t tmp_moved_constant_764 = tmp_moved_constant_694*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_732 + tmp_moved_constant_744);
             const real_t tmp_moved_constant_765 = tmp_moved_constant_696*(-jac_affine_inv_2_2_GREEN_UP*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_735 + tmp_moved_constant_747);
             const real_t tmp_moved_constant_766 = tmp_moved_constant_690*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_727 + tmp_moved_constant_750);
             const real_t tmp_moved_constant_767 = tmp_moved_constant_692*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_730 + tmp_moved_constant_753);
             const real_t tmp_moved_constant_768 = tmp_moved_constant_694*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_733 + tmp_moved_constant_756);
             const real_t tmp_moved_constant_769 = tmp_moved_constant_696*(-jac_affine_inv_1_2_GREEN_UP*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_736 + tmp_moved_constant_759);
             const real_t tmp_moved_constant_770 = tmp_moved_constant_690*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_739 + tmp_moved_constant_751);
             const real_t tmp_moved_constant_771 = tmp_moved_constant_692*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_742 + tmp_moved_constant_754);
             const real_t tmp_moved_constant_772 = tmp_moved_constant_694*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_745 + tmp_moved_constant_757);
             const real_t tmp_moved_constant_773 = tmp_moved_constant_696*(-jac_affine_inv_0_2_GREEN_UP*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_748 + tmp_moved_constant_760);
             const real_t tmp_moved_constant_774 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_691 + tmp_kernel_op_29*tmp_moved_constant_693 + tmp_kernel_op_30*tmp_moved_constant_695 + tmp_kernel_op_31*tmp_moved_constant_697) + tmp_moved_constant_687*(tmp_moved_constant_691*0.1381966011250105 + tmp_moved_constant_693*0.1381966011250105 + tmp_moved_constant_695*0.5854101966249684 + tmp_moved_constant_697*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_691*0.1381966011250105 + tmp_moved_constant_693*0.5854101966249684 + tmp_moved_constant_695*0.1381966011250105 + tmp_moved_constant_697*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_691*0.5854101966249684 + tmp_moved_constant_693*0.1381966011250105 + tmp_moved_constant_695*0.1381966011250105 + tmp_moved_constant_697*0.1381966011250105);
             const real_t tmp_moved_constant_775 = tmp_moved_constant_686*(-tmp_moved_constant_698*tmp_moved_constant_706 - tmp_moved_constant_700*tmp_moved_constant_707 - tmp_moved_constant_702*tmp_moved_constant_708 - tmp_moved_constant_704*tmp_moved_constant_709) + tmp_moved_constant_687*(tmp_moved_constant_699*-0.1381966011250105 + tmp_moved_constant_701*-0.1381966011250105 + tmp_moved_constant_703*-0.5854101966249684 + tmp_moved_constant_705*-0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_699*-0.1381966011250105 + tmp_moved_constant_701*-0.5854101966249684 + tmp_moved_constant_703*-0.1381966011250105 + tmp_moved_constant_705*-0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_699*-0.5854101966249684 + tmp_moved_constant_701*-0.1381966011250105 + tmp_moved_constant_703*-0.1381966011250105 + tmp_moved_constant_705*-0.1381966011250105);
             const real_t tmp_moved_constant_776 = tmp_moved_constant_686*(-tmp_moved_constant_706*tmp_moved_constant_710 - tmp_moved_constant_707*tmp_moved_constant_712 - tmp_moved_constant_708*tmp_moved_constant_714 - tmp_moved_constant_709*tmp_moved_constant_716) + tmp_moved_constant_687*(tmp_moved_constant_711*-0.1381966011250105 + tmp_moved_constant_713*-0.1381966011250105 + tmp_moved_constant_715*-0.5854101966249684 + tmp_moved_constant_717*-0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_711*-0.1381966011250105 + tmp_moved_constant_713*-0.5854101966249684 + tmp_moved_constant_715*-0.1381966011250105 + tmp_moved_constant_717*-0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_711*-0.5854101966249684 + tmp_moved_constant_713*-0.1381966011250105 + tmp_moved_constant_715*-0.1381966011250105 + tmp_moved_constant_717*-0.1381966011250105);
             const real_t tmp_moved_constant_777 = tmp_moved_constant_686*(-tmp_moved_constant_706*tmp_moved_constant_718 - tmp_moved_constant_707*tmp_moved_constant_720 - tmp_moved_constant_708*tmp_moved_constant_722 - tmp_moved_constant_709*tmp_moved_constant_724) + tmp_moved_constant_687*(tmp_moved_constant_719*-0.1381966011250105 + tmp_moved_constant_721*-0.1381966011250105 + tmp_moved_constant_723*-0.5854101966249684 + tmp_moved_constant_725*-0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_719*-0.1381966011250105 + tmp_moved_constant_721*-0.5854101966249684 + tmp_moved_constant_723*-0.1381966011250105 + tmp_moved_constant_725*-0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_719*-0.5854101966249684 + tmp_moved_constant_721*-0.1381966011250105 + tmp_moved_constant_723*-0.1381966011250105 + tmp_moved_constant_725*-0.1381966011250105);
             const real_t tmp_moved_constant_778 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_728 + tmp_kernel_op_29*tmp_moved_constant_731 + tmp_kernel_op_30*tmp_moved_constant_734 + tmp_kernel_op_31*tmp_moved_constant_737) + tmp_moved_constant_687*(tmp_moved_constant_728*0.1381966011250105 + tmp_moved_constant_731*0.1381966011250105 + tmp_moved_constant_734*0.5854101966249684 + tmp_moved_constant_737*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_728*0.1381966011250105 + tmp_moved_constant_731*0.5854101966249684 + tmp_moved_constant_734*0.1381966011250105 + tmp_moved_constant_737*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_728*0.5854101966249684 + tmp_moved_constant_731*0.1381966011250105 + tmp_moved_constant_734*0.1381966011250105 + tmp_moved_constant_737*0.1381966011250105);
             const real_t tmp_moved_constant_779 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_740 + tmp_kernel_op_29*tmp_moved_constant_743 + tmp_kernel_op_30*tmp_moved_constant_746 + tmp_kernel_op_31*tmp_moved_constant_749) + tmp_moved_constant_687*(tmp_moved_constant_740*0.1381966011250105 + tmp_moved_constant_743*0.1381966011250105 + tmp_moved_constant_746*0.5854101966249684 + tmp_moved_constant_749*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_740*0.1381966011250105 + tmp_moved_constant_743*0.5854101966249684 + tmp_moved_constant_746*0.1381966011250105 + tmp_moved_constant_749*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_740*0.5854101966249684 + tmp_moved_constant_743*0.1381966011250105 + tmp_moved_constant_746*0.1381966011250105 + tmp_moved_constant_749*0.1381966011250105);
             const real_t tmp_moved_constant_780 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_752 + tmp_kernel_op_29*tmp_moved_constant_755 + tmp_kernel_op_30*tmp_moved_constant_758 + tmp_kernel_op_31*tmp_moved_constant_761) + tmp_moved_constant_687*(tmp_moved_constant_752*0.1381966011250105 + tmp_moved_constant_755*0.1381966011250105 + tmp_moved_constant_758*0.5854101966249684 + tmp_moved_constant_761*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_752*0.1381966011250105 + tmp_moved_constant_755*0.5854101966249684 + tmp_moved_constant_758*0.1381966011250105 + tmp_moved_constant_761*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_752*0.5854101966249684 + tmp_moved_constant_755*0.1381966011250105 + tmp_moved_constant_758*0.1381966011250105 + tmp_moved_constant_761*0.1381966011250105);
             const real_t tmp_moved_constant_781 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_762 + tmp_kernel_op_29*tmp_moved_constant_763 + tmp_kernel_op_30*tmp_moved_constant_764 + tmp_kernel_op_31*tmp_moved_constant_765) + tmp_moved_constant_687*(tmp_moved_constant_762*0.1381966011250105 + tmp_moved_constant_763*0.1381966011250105 + tmp_moved_constant_764*0.5854101966249684 + tmp_moved_constant_765*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_762*0.1381966011250105 + tmp_moved_constant_763*0.5854101966249684 + tmp_moved_constant_764*0.1381966011250105 + tmp_moved_constant_765*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_762*0.5854101966249684 + tmp_moved_constant_763*0.1381966011250105 + tmp_moved_constant_764*0.1381966011250105 + tmp_moved_constant_765*0.1381966011250105);
             const real_t tmp_moved_constant_782 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_766 + tmp_kernel_op_29*tmp_moved_constant_767 + tmp_kernel_op_30*tmp_moved_constant_768 + tmp_kernel_op_31*tmp_moved_constant_769) + tmp_moved_constant_687*(tmp_moved_constant_766*0.1381966011250105 + tmp_moved_constant_767*0.1381966011250105 + tmp_moved_constant_768*0.5854101966249684 + tmp_moved_constant_769*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_766*0.1381966011250105 + tmp_moved_constant_767*0.5854101966249684 + tmp_moved_constant_768*0.1381966011250105 + tmp_moved_constant_769*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_766*0.5854101966249684 + tmp_moved_constant_767*0.1381966011250105 + tmp_moved_constant_768*0.1381966011250105 + tmp_moved_constant_769*0.1381966011250105);
             const real_t tmp_moved_constant_783 = tmp_moved_constant_686*(tmp_kernel_op_28*tmp_moved_constant_770 + tmp_kernel_op_29*tmp_moved_constant_771 + tmp_kernel_op_30*tmp_moved_constant_772 + tmp_kernel_op_31*tmp_moved_constant_773) + tmp_moved_constant_687*(tmp_moved_constant_770*0.1381966011250105 + tmp_moved_constant_771*0.1381966011250105 + tmp_moved_constant_772*0.5854101966249684 + tmp_moved_constant_773*0.1381966011250105) + tmp_moved_constant_688*(tmp_moved_constant_770*0.1381966011250105 + tmp_moved_constant_771*0.5854101966249684 + tmp_moved_constant_772*0.1381966011250105 + tmp_moved_constant_773*0.1381966011250105) + tmp_moved_constant_689*(tmp_moved_constant_770*0.5854101966249684 + tmp_moved_constant_771*0.1381966011250105 + tmp_moved_constant_772*0.1381966011250105 + tmp_moved_constant_773*0.1381966011250105);
             {
                {
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_774 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_775 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_776 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_777 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_778 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_779 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_780 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = tmp_moved_constant_781 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_782 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_783 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const real_t tmp_moved_constant_784 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_785 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_786 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const real_t tmp_moved_constant_787 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const real_t tmp_moved_constant_788 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_789 = tmp_moved_constant_788*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_4 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_4);
             const real_t tmp_moved_constant_790 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_791 = tmp_moved_constant_790*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_11 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_11 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_11);
             const real_t tmp_moved_constant_792 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_793 = tmp_moved_constant_792*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_18 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_18 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_18);
             const real_t tmp_moved_constant_794 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657;
             const real_t tmp_moved_constant_795 = tmp_moved_constant_794*(-jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_25 - jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_25 - jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_25);
             const real_t tmp_moved_constant_796 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_1 - 1.0);
             const real_t tmp_moved_constant_797 = tmp_moved_constant_788*tmp_moved_constant_796;
             const real_t tmp_moved_constant_798 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_8 - 1.0);
             const real_t tmp_moved_constant_799 = tmp_moved_constant_790*tmp_moved_constant_798;
             const real_t tmp_moved_constant_800 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_15 - 1.0);
             const real_t tmp_moved_constant_801 = tmp_moved_constant_792*tmp_moved_constant_800;
             const real_t tmp_moved_constant_802 = jac_affine_inv_0_2_GREEN_DOWN*(tmp_kernel_op_22 - 1.0);
             const real_t tmp_moved_constant_803 = tmp_moved_constant_794*tmp_moved_constant_802;
             const real_t tmp_moved_constant_804 = tmp_kernel_op_28*tmp_moved_constant_788;
             const real_t tmp_moved_constant_805 = tmp_kernel_op_29*tmp_moved_constant_790;
             const real_t tmp_moved_constant_806 = tmp_kernel_op_30*tmp_moved_constant_792;
             const real_t tmp_moved_constant_807 = tmp_kernel_op_31*tmp_moved_constant_794;
             const real_t tmp_moved_constant_808 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_2 - 1.0);
             const real_t tmp_moved_constant_809 = tmp_moved_constant_788*tmp_moved_constant_808;
             const real_t tmp_moved_constant_810 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_9 - 1.0);
             const real_t tmp_moved_constant_811 = tmp_moved_constant_790*tmp_moved_constant_810;
             const real_t tmp_moved_constant_812 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_16 - 1.0);
             const real_t tmp_moved_constant_813 = tmp_moved_constant_792*tmp_moved_constant_812;
             const real_t tmp_moved_constant_814 = jac_affine_inv_1_2_GREEN_DOWN*(tmp_kernel_op_23 - 1.0);
             const real_t tmp_moved_constant_815 = tmp_moved_constant_794*tmp_moved_constant_814;
             const real_t tmp_moved_constant_816 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_0 - 1.0);
             const real_t tmp_moved_constant_817 = tmp_moved_constant_788*tmp_moved_constant_816;
             const real_t tmp_moved_constant_818 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_7 - 1.0);
             const real_t tmp_moved_constant_819 = tmp_moved_constant_790*tmp_moved_constant_818;
             const real_t tmp_moved_constant_820 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_14 - 1.0);
             const real_t tmp_moved_constant_821 = tmp_moved_constant_792*tmp_moved_constant_820;
             const real_t tmp_moved_constant_822 = jac_affine_inv_2_2_GREEN_DOWN*(tmp_kernel_op_21 - 1.0);
             const real_t tmp_moved_constant_823 = tmp_moved_constant_794*tmp_moved_constant_822;
             const real_t tmp_moved_constant_824 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_825 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_826 = tmp_moved_constant_788*(-tmp_moved_constant_824 - tmp_moved_constant_825);
             const real_t tmp_moved_constant_827 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_7;
             const real_t tmp_moved_constant_828 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_829 = tmp_moved_constant_790*(-tmp_moved_constant_827 - tmp_moved_constant_828);
             const real_t tmp_moved_constant_830 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_14;
             const real_t tmp_moved_constant_831 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_832 = tmp_moved_constant_792*(-tmp_moved_constant_830 - tmp_moved_constant_831);
             const real_t tmp_moved_constant_833 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_21;
             const real_t tmp_moved_constant_834 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_23;
             const real_t tmp_moved_constant_835 = tmp_moved_constant_794*(-tmp_moved_constant_833 - tmp_moved_constant_834);
             const real_t tmp_moved_constant_836 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_0;
             const real_t tmp_moved_constant_837 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_838 = tmp_moved_constant_788*(-tmp_moved_constant_836 - tmp_moved_constant_837);
             const real_t tmp_moved_constant_839 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_7;
             const real_t tmp_moved_constant_840 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_841 = tmp_moved_constant_790*(-tmp_moved_constant_839 - tmp_moved_constant_840);
             const real_t tmp_moved_constant_842 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_14;
             const real_t tmp_moved_constant_843 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_15;
             const real_t tmp_moved_constant_844 = tmp_moved_constant_792*(-tmp_moved_constant_842 - tmp_moved_constant_843);
             const real_t tmp_moved_constant_845 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_21;
             const real_t tmp_moved_constant_846 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_22;
             const real_t tmp_moved_constant_847 = tmp_moved_constant_794*(-tmp_moved_constant_845 - tmp_moved_constant_846);
             const real_t tmp_moved_constant_848 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_2;
             const real_t tmp_moved_constant_849 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_1;
             const real_t tmp_moved_constant_850 = tmp_moved_constant_788*(-tmp_moved_constant_848 - tmp_moved_constant_849);
             const real_t tmp_moved_constant_851 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_9;
             const real_t tmp_moved_constant_852 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_8;
             const real_t tmp_moved_constant_853 = tmp_moved_constant_790*(-tmp_moved_constant_851 - tmp_moved_constant_852);
             const real_t tmp_moved_constant_854 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_16;
             const real_t tmp_moved_constant_855 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_15;
             const real_t tmp_moved_constant_856 = tmp_moved_constant_792*(-tmp_moved_constant_854 - tmp_moved_constant_855);
             const real_t tmp_moved_constant_857 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_23;
             const real_t tmp_moved_constant_858 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_22;
             const real_t tmp_moved_constant_859 = tmp_moved_constant_794*(-tmp_moved_constant_857 - tmp_moved_constant_858);
             const real_t tmp_moved_constant_860 = tmp_moved_constant_788*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_3 - 0.68328157299974723) + tmp_moved_constant_824 + tmp_moved_constant_836);
             const real_t tmp_moved_constant_861 = tmp_moved_constant_790*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_10 + 2.8944271909999157) + tmp_moved_constant_827 + tmp_moved_constant_839);
             const real_t tmp_moved_constant_862 = tmp_moved_constant_792*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_17 + 2.8944271909999157) + tmp_moved_constant_830 + tmp_moved_constant_842);
             const real_t tmp_moved_constant_863 = tmp_moved_constant_794*(-jac_affine_inv_2_2_GREEN_DOWN*(-tmp_kernel_op_24 + 2.8944271909999157) + tmp_moved_constant_833 + tmp_moved_constant_845);
             const real_t tmp_moved_constant_864 = tmp_moved_constant_788*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_1 - tmp_kernel_op_100 - 1.105572809000084) + tmp_moved_constant_825 + tmp_moved_constant_848);
             const real_t tmp_moved_constant_865 = tmp_moved_constant_790*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_8 - 4.6832815729997472) + tmp_moved_constant_828 + tmp_moved_constant_851);
             const real_t tmp_moved_constant_866 = tmp_moved_constant_792*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_15 - 1.105572809000084) + tmp_moved_constant_831 + tmp_moved_constant_854);
             const real_t tmp_moved_constant_867 = tmp_moved_constant_794*(-jac_affine_inv_1_2_GREEN_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_22 - 1.105572809000084) + tmp_moved_constant_834 + tmp_moved_constant_857);
             const real_t tmp_moved_constant_868 = tmp_moved_constant_788*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_100 - tmp_kernel_op_2 - 1.105572809000084) + tmp_moved_constant_837 + tmp_moved_constant_849);
             const real_t tmp_moved_constant_869 = tmp_moved_constant_790*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_102 - tmp_kernel_op_9 - 1.105572809000084) + tmp_moved_constant_840 + tmp_moved_constant_852);
             const real_t tmp_moved_constant_870 = tmp_moved_constant_792*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_104 - tmp_kernel_op_16 - 4.6832815729997472) + tmp_moved_constant_843 + tmp_moved_constant_855);
             const real_t tmp_moved_constant_871 = tmp_moved_constant_794*(-jac_affine_inv_0_2_GREEN_DOWN*(-tmp_kernel_op_106 - tmp_kernel_op_23 - 1.105572809000084) + tmp_moved_constant_846 + tmp_moved_constant_858);
             const real_t tmp_moved_constant_872 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_789 + tmp_kernel_op_29*tmp_moved_constant_791 + tmp_kernel_op_30*tmp_moved_constant_793 + tmp_kernel_op_31*tmp_moved_constant_795) + tmp_moved_constant_785*(tmp_moved_constant_789*0.1381966011250105 + tmp_moved_constant_791*0.1381966011250105 + tmp_moved_constant_793*0.5854101966249684 + tmp_moved_constant_795*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_789*0.1381966011250105 + tmp_moved_constant_791*0.5854101966249684 + tmp_moved_constant_793*0.1381966011250105 + tmp_moved_constant_795*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_789*0.5854101966249684 + tmp_moved_constant_791*0.1381966011250105 + tmp_moved_constant_793*0.1381966011250105 + tmp_moved_constant_795*0.1381966011250105);
             const real_t tmp_moved_constant_873 = tmp_moved_constant_784*(-tmp_moved_constant_796*tmp_moved_constant_804 - tmp_moved_constant_798*tmp_moved_constant_805 - tmp_moved_constant_800*tmp_moved_constant_806 - tmp_moved_constant_802*tmp_moved_constant_807) + tmp_moved_constant_785*(tmp_moved_constant_797*-0.1381966011250105 + tmp_moved_constant_799*-0.1381966011250105 + tmp_moved_constant_801*-0.5854101966249684 + tmp_moved_constant_803*-0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_797*-0.1381966011250105 + tmp_moved_constant_799*-0.5854101966249684 + tmp_moved_constant_801*-0.1381966011250105 + tmp_moved_constant_803*-0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_797*-0.5854101966249684 + tmp_moved_constant_799*-0.1381966011250105 + tmp_moved_constant_801*-0.1381966011250105 + tmp_moved_constant_803*-0.1381966011250105);
             const real_t tmp_moved_constant_874 = tmp_moved_constant_784*(-tmp_moved_constant_804*tmp_moved_constant_808 - tmp_moved_constant_805*tmp_moved_constant_810 - tmp_moved_constant_806*tmp_moved_constant_812 - tmp_moved_constant_807*tmp_moved_constant_814) + tmp_moved_constant_785*(tmp_moved_constant_809*-0.1381966011250105 + tmp_moved_constant_811*-0.1381966011250105 + tmp_moved_constant_813*-0.5854101966249684 + tmp_moved_constant_815*-0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_809*-0.1381966011250105 + tmp_moved_constant_811*-0.5854101966249684 + tmp_moved_constant_813*-0.1381966011250105 + tmp_moved_constant_815*-0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_809*-0.5854101966249684 + tmp_moved_constant_811*-0.1381966011250105 + tmp_moved_constant_813*-0.1381966011250105 + tmp_moved_constant_815*-0.1381966011250105);
             const real_t tmp_moved_constant_875 = tmp_moved_constant_784*(-tmp_moved_constant_804*tmp_moved_constant_816 - tmp_moved_constant_805*tmp_moved_constant_818 - tmp_moved_constant_806*tmp_moved_constant_820 - tmp_moved_constant_807*tmp_moved_constant_822) + tmp_moved_constant_785*(tmp_moved_constant_817*-0.1381966011250105 + tmp_moved_constant_819*-0.1381966011250105 + tmp_moved_constant_821*-0.5854101966249684 + tmp_moved_constant_823*-0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_817*-0.1381966011250105 + tmp_moved_constant_819*-0.5854101966249684 + tmp_moved_constant_821*-0.1381966011250105 + tmp_moved_constant_823*-0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_817*-0.5854101966249684 + tmp_moved_constant_819*-0.1381966011250105 + tmp_moved_constant_821*-0.1381966011250105 + tmp_moved_constant_823*-0.1381966011250105);
             const real_t tmp_moved_constant_876 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_826 + tmp_kernel_op_29*tmp_moved_constant_829 + tmp_kernel_op_30*tmp_moved_constant_832 + tmp_kernel_op_31*tmp_moved_constant_835) + tmp_moved_constant_785*(tmp_moved_constant_826*0.1381966011250105 + tmp_moved_constant_829*0.1381966011250105 + tmp_moved_constant_832*0.5854101966249684 + tmp_moved_constant_835*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_826*0.1381966011250105 + tmp_moved_constant_829*0.5854101966249684 + tmp_moved_constant_832*0.1381966011250105 + tmp_moved_constant_835*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_826*0.5854101966249684 + tmp_moved_constant_829*0.1381966011250105 + tmp_moved_constant_832*0.1381966011250105 + tmp_moved_constant_835*0.1381966011250105);
             const real_t tmp_moved_constant_877 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_838 + tmp_kernel_op_29*tmp_moved_constant_841 + tmp_kernel_op_30*tmp_moved_constant_844 + tmp_kernel_op_31*tmp_moved_constant_847) + tmp_moved_constant_785*(tmp_moved_constant_838*0.1381966011250105 + tmp_moved_constant_841*0.1381966011250105 + tmp_moved_constant_844*0.5854101966249684 + tmp_moved_constant_847*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_838*0.1381966011250105 + tmp_moved_constant_841*0.5854101966249684 + tmp_moved_constant_844*0.1381966011250105 + tmp_moved_constant_847*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_838*0.5854101966249684 + tmp_moved_constant_841*0.1381966011250105 + tmp_moved_constant_844*0.1381966011250105 + tmp_moved_constant_847*0.1381966011250105);
             const real_t tmp_moved_constant_878 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_850 + tmp_kernel_op_29*tmp_moved_constant_853 + tmp_kernel_op_30*tmp_moved_constant_856 + tmp_kernel_op_31*tmp_moved_constant_859) + tmp_moved_constant_785*(tmp_moved_constant_850*0.1381966011250105 + tmp_moved_constant_853*0.1381966011250105 + tmp_moved_constant_856*0.5854101966249684 + tmp_moved_constant_859*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_850*0.1381966011250105 + tmp_moved_constant_853*0.5854101966249684 + tmp_moved_constant_856*0.1381966011250105 + tmp_moved_constant_859*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_850*0.5854101966249684 + tmp_moved_constant_853*0.1381966011250105 + tmp_moved_constant_856*0.1381966011250105 + tmp_moved_constant_859*0.1381966011250105);
             const real_t tmp_moved_constant_879 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_860 + tmp_kernel_op_29*tmp_moved_constant_861 + tmp_kernel_op_30*tmp_moved_constant_862 + tmp_kernel_op_31*tmp_moved_constant_863) + tmp_moved_constant_785*(tmp_moved_constant_860*0.1381966011250105 + tmp_moved_constant_861*0.1381966011250105 + tmp_moved_constant_862*0.5854101966249684 + tmp_moved_constant_863*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_860*0.1381966011250105 + tmp_moved_constant_861*0.5854101966249684 + tmp_moved_constant_862*0.1381966011250105 + tmp_moved_constant_863*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_860*0.5854101966249684 + tmp_moved_constant_861*0.1381966011250105 + tmp_moved_constant_862*0.1381966011250105 + tmp_moved_constant_863*0.1381966011250105);
             const real_t tmp_moved_constant_880 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_864 + tmp_kernel_op_29*tmp_moved_constant_865 + tmp_kernel_op_30*tmp_moved_constant_866 + tmp_kernel_op_31*tmp_moved_constant_867) + tmp_moved_constant_785*(tmp_moved_constant_864*0.1381966011250105 + tmp_moved_constant_865*0.1381966011250105 + tmp_moved_constant_866*0.5854101966249684 + tmp_moved_constant_867*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_864*0.1381966011250105 + tmp_moved_constant_865*0.5854101966249684 + tmp_moved_constant_866*0.1381966011250105 + tmp_moved_constant_867*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_864*0.5854101966249684 + tmp_moved_constant_865*0.1381966011250105 + tmp_moved_constant_866*0.1381966011250105 + tmp_moved_constant_867*0.1381966011250105);
             const real_t tmp_moved_constant_881 = tmp_moved_constant_784*(tmp_kernel_op_28*tmp_moved_constant_868 + tmp_kernel_op_29*tmp_moved_constant_869 + tmp_kernel_op_30*tmp_moved_constant_870 + tmp_kernel_op_31*tmp_moved_constant_871) + tmp_moved_constant_785*(tmp_moved_constant_868*0.1381966011250105 + tmp_moved_constant_869*0.1381966011250105 + tmp_moved_constant_870*0.5854101966249684 + tmp_moved_constant_871*0.1381966011250105) + tmp_moved_constant_786*(tmp_moved_constant_868*0.1381966011250105 + tmp_moved_constant_869*0.5854101966249684 + tmp_moved_constant_870*0.1381966011250105 + tmp_moved_constant_871*0.1381966011250105) + tmp_moved_constant_787*(tmp_moved_constant_868*0.5854101966249684 + tmp_moved_constant_869*0.1381966011250105 + tmp_moved_constant_870*0.1381966011250105 + tmp_moved_constant_871*0.1381966011250105);
             {
                {
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_872 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_873 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1] = tmp_moved_constant_874 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2] = tmp_moved_constant_875 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_876 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_877 + _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = tmp_moved_constant_878 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_879 + _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = tmp_moved_constant_880 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = tmp_moved_constant_881 + _data_dstEdge[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
          } 
          const real_t src_dof_0 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const real_t src_dof_1 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
          const real_t src_dof_2 = _data_src[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const real_t src_dof_3 = _data_src[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_13*tmp_kernel_op_29 + tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_27*tmp_kernel_op_31 + tmp_kernel_op_28*tmp_kernel_op_6) + src_dof_1*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.5854101966249684 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_2*(tmp_kernel_op_13*0.5854101966249684 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105) + src_dof_3*(tmp_kernel_op_13*0.1381966011250105 + tmp_kernel_op_20*0.1381966011250105 + tmp_kernel_op_27*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684);
          const real_t elMatVec_1 = src_dof_0*(-tmp_kernel_op_32*tmp_kernel_op_40 - tmp_kernel_op_34*tmp_kernel_op_41 - tmp_kernel_op_36*tmp_kernel_op_42 - tmp_kernel_op_38*tmp_kernel_op_43) + src_dof_1*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.5854101966249684 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_33*-0.1381966011250105 + tmp_kernel_op_35*-0.5854101966249684 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_33*-0.5854101966249684 + tmp_kernel_op_35*-0.1381966011250105 + tmp_kernel_op_37*-0.1381966011250105 + tmp_kernel_op_39*-0.1381966011250105);
          const real_t elMatVec_2 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_44 - tmp_kernel_op_41*tmp_kernel_op_46 - tmp_kernel_op_42*tmp_kernel_op_48 - tmp_kernel_op_43*tmp_kernel_op_50) + src_dof_1*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.5854101966249684 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_45*-0.1381966011250105 + tmp_kernel_op_47*-0.5854101966249684 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_45*-0.5854101966249684 + tmp_kernel_op_47*-0.1381966011250105 + tmp_kernel_op_49*-0.1381966011250105 + tmp_kernel_op_51*-0.1381966011250105);
          const real_t elMatVec_3 = src_dof_0*(-tmp_kernel_op_40*tmp_kernel_op_52 - tmp_kernel_op_41*tmp_kernel_op_54 - tmp_kernel_op_42*tmp_kernel_op_56 - tmp_kernel_op_43*tmp_kernel_op_58) + src_dof_1*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.5854101966249684 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_2*(tmp_kernel_op_53*-0.1381966011250105 + tmp_kernel_op_55*-0.5854101966249684 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105) + src_dof_3*(tmp_kernel_op_53*-0.5854101966249684 + tmp_kernel_op_55*-0.1381966011250105 + tmp_kernel_op_57*-0.1381966011250105 + tmp_kernel_op_59*-0.1381966011250105);
          const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_62 + tmp_kernel_op_29*tmp_kernel_op_65 + tmp_kernel_op_30*tmp_kernel_op_68 + tmp_kernel_op_31*tmp_kernel_op_71) + src_dof_1*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.5854101966249684 + tmp_kernel_op_71*0.1381966011250105) + src_dof_2*(tmp_kernel_op_62*0.1381966011250105 + tmp_kernel_op_65*0.5854101966249684 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105) + src_dof_3*(tmp_kernel_op_62*0.5854101966249684 + tmp_kernel_op_65*0.1381966011250105 + tmp_kernel_op_68*0.1381966011250105 + tmp_kernel_op_71*0.1381966011250105);
          const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_74 + tmp_kernel_op_29*tmp_kernel_op_77 + tmp_kernel_op_30*tmp_kernel_op_80 + tmp_kernel_op_31*tmp_kernel_op_83) + src_dof_1*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.5854101966249684 + tmp_kernel_op_83*0.1381966011250105) + src_dof_2*(tmp_kernel_op_74*0.1381966011250105 + tmp_kernel_op_77*0.5854101966249684 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105) + src_dof_3*(tmp_kernel_op_74*0.5854101966249684 + tmp_kernel_op_77*0.1381966011250105 + tmp_kernel_op_80*0.1381966011250105 + tmp_kernel_op_83*0.1381966011250105);
          const real_t elMatVec_6 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_86 + tmp_kernel_op_29*tmp_kernel_op_89 + tmp_kernel_op_30*tmp_kernel_op_92 + tmp_kernel_op_31*tmp_kernel_op_95) + src_dof_1*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.5854101966249684 + tmp_kernel_op_95*0.1381966011250105) + src_dof_2*(tmp_kernel_op_86*0.1381966011250105 + tmp_kernel_op_89*0.5854101966249684 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105) + src_dof_3*(tmp_kernel_op_86*0.5854101966249684 + tmp_kernel_op_89*0.1381966011250105 + tmp_kernel_op_92*0.1381966011250105 + tmp_kernel_op_95*0.1381966011250105);
          const real_t elMatVec_7 = src_dof_0*(tmp_kernel_op_28*tmp_kernel_op_96 + tmp_kernel_op_29*tmp_kernel_op_97 + tmp_kernel_op_30*tmp_kernel_op_98 + tmp_kernel_op_31*tmp_kernel_op_99) + src_dof_1*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.5854101966249684 + tmp_kernel_op_99*0.1381966011250105) + src_dof_2*(tmp_kernel_op_96*0.1381966011250105 + tmp_kernel_op_97*0.5854101966249684 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105) + src_dof_3*(tmp_kernel_op_96*0.5854101966249684 + tmp_kernel_op_97*0.1381966011250105 + tmp_kernel_op_98*0.1381966011250105 + tmp_kernel_op_99*0.1381966011250105);
          const real_t elMatVec_8 = src_dof_0*(tmp_kernel_op_101*tmp_kernel_op_28 + tmp_kernel_op_103*tmp_kernel_op_29 + tmp_kernel_op_105*tmp_kernel_op_30 + tmp_kernel_op_107*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.5854101966249684 + tmp_kernel_op_107*0.1381966011250105) + src_dof_2*(tmp_kernel_op_101*0.1381966011250105 + tmp_kernel_op_103*0.5854101966249684 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105) + src_dof_3*(tmp_kernel_op_101*0.5854101966249684 + tmp_kernel_op_103*0.1381966011250105 + tmp_kernel_op_105*0.1381966011250105 + tmp_kernel_op_107*0.1381966011250105);
          const real_t elMatVec_9 = src_dof_0*(tmp_kernel_op_108*tmp_kernel_op_28 + tmp_kernel_op_109*tmp_kernel_op_29 + tmp_kernel_op_110*tmp_kernel_op_30 + tmp_kernel_op_111*tmp_kernel_op_31) + src_dof_1*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.5854101966249684 + tmp_kernel_op_111*0.1381966011250105) + src_dof_2*(tmp_kernel_op_108*0.1381966011250105 + tmp_kernel_op_109*0.5854101966249684 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105) + src_dof_3*(tmp_kernel_op_108*0.5854101966249684 + tmp_kernel_op_109*0.1381966011250105 + tmp_kernel_op_110*0.1381966011250105 + tmp_kernel_op_111*0.1381966011250105);
          {
             {
                {
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = elMatVec_0 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                   _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1] = elMatVec_2 + _data_dstVertex[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1] = elMatVec_3 + _data_dstVertex[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_4 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_5 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_6 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_7 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_8 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatVec_9 + _data_dstEdge[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
