/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P1ToP2VectorElementwiseGradientRotationIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P1ToP2VectorElementwiseGradientRotationIcosahedralShellMap::toMatrix_macro_3D( idx_t * RESTRICT  _data_dst_edge_0, idx_t * RESTRICT  _data_dst_edge_1, idx_t * RESTRICT  _data_dst_edge_2, idx_t * RESTRICT  _data_dst_vertex_0, idx_t * RESTRICT  _data_dst_vertex_1, idx_t * RESTRICT  _data_dst_vertex_2, real_t * RESTRICT  _data_nxEdge, real_t * RESTRICT  _data_nxVertex, real_t * RESTRICT  _data_nyEdge, real_t * RESTRICT  _data_nyVertex, real_t * RESTRICT  _data_nzEdge, real_t * RESTRICT  _data_nzVertex, idx_t * RESTRICT  _data_src, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       {
          /* CellType.WHITE_UP */
          const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
          const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
          const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
          const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
          const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
          const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
          const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
          const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
          const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
          const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
          const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
          const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
          const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
          const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
          const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
          const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
          const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
          const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
          const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
          const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
          const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
          const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
          const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
          const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
          const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
          const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_129 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_127 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_129 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_127 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_129 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_127 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_WHITE_UP*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_162 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_166 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_162 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_166 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_162 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_166 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_190 + jac_affine_inv_0_1_WHITE_UP*tmp_qloop_189 + jac_affine_inv_0_2_WHITE_UP*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_190 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_189 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_190 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_189 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* CellType.WHITE_DOWN */
          const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
          const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
          const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
          const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
          const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
          const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
          const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
          const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
          const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
          const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
          const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
          const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
          const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
          const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
          const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
          const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
          const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
          const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
          const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
          const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
          const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
          const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
          const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
          const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
          const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
          const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
          const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
          const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
          const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
          const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
          const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
          const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
          const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
          const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
          const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_129 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_127 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_129 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_127 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_129 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_127 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_WHITE_DOWN*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_166 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_166 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_162 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_166 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_190 + jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_189 + jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_190 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_189 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_190 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_189 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* CellType.BLUE_UP */
          const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
          const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
          const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
          const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
          const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
          const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
          const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
          const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
          const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
          const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
          const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
          const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
          const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
          const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
          const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
          const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
          const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
          const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
          const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
          const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
          const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
          const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
          const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
          const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
          const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
          const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
          const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
          const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
          const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
          const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
          const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
          const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
          const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
          const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
          const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_129 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_127 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_129 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_127 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_129 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_127 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_BLUE_UP*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_162 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_166 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_162 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_166 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_162 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_166 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_190 + jac_affine_inv_0_1_BLUE_UP*tmp_qloop_189 + jac_affine_inv_0_2_BLUE_UP*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_190 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_189 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_190 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_189 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* CellType.BLUE_DOWN */
          const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
          const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
          const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
          const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
          const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
          const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
          const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
          const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
          const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
          const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
          const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
          const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
          const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
          const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
          const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
          const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
          const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
          const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
          const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
          const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
          const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
          const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
          const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
          const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
          const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
          const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
          const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
          const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
          const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
          const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
          const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
          const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
          const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
          const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
          const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_129 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_127 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_129 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_127 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_129 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_127 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_BLUE_DOWN*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_166 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_166 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_162 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_166 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_190 + jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_189 + jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_190 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_189 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_190 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_189 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* CellType.GREEN_UP */
          const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
          const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
          const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
          const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
          const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
          const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
          const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
          const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
          const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
          const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
          const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
          const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
          const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
          const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
          const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
          const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
          const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
          const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
          const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
          const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
          const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
          const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
          const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
          const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
          const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
          const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
          const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
          const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
          const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
          const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
          const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
          const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_129 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_127 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_129 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_127 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_129 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_127 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_GREEN_UP*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_162 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_166 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_162 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_166 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_162 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_166 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_190 + jac_affine_inv_0_1_GREEN_UP*tmp_qloop_189 + jac_affine_inv_0_2_GREEN_UP*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_190 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_189 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_190 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_189 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       {
          /* CellType.GREEN_DOWN */
          const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
          const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
          const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
          const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
          const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
          const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
          const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
          const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
          const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
          const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
          const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
          const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
          const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
          const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
          const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
          const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
          const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
          const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
          const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
          const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
          const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
          const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
          const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
          const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
          const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
          const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
          const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
          const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
          const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
          const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
          const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
          const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
          const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
          const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
          const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
          const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
          const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
          const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
          const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
          const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
          const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
          const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2));
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*((real_t)(ctr_2 + 1));
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*((real_t)(ctr_1 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*((real_t)(ctr_2 + 1));
             const real_t nx_dof_0 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_1 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_2 = _data_nxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nx_dof_3 = _data_nxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nx_dof_4 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_5 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_6 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nx_dof_7 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nx_dof_8 = _data_nxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nx_dof_9 = _data_nxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_0 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_1 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_2 = _data_nyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ny_dof_3 = _data_nyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ny_dof_4 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_5 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_6 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ny_dof_7 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ny_dof_8 = _data_nyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ny_dof_9 = _data_nyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_0 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_1 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_2 = _data_nzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t nz_dof_3 = _data_nzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t nz_dof_4 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_5 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_6 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t nz_dof_7 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t nz_dof_8 = _data_nzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t nz_dof_9 = _data_nzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_10_0 = 0.0;
             real_t q_acc_10_1 = 0.0;
             real_t q_acc_10_2 = 0.0;
             real_t q_acc_10_3 = 0.0;
             real_t q_acc_11_0 = 0.0;
             real_t q_acc_11_1 = 0.0;
             real_t q_acc_11_2 = 0.0;
             real_t q_acc_11_3 = 0.0;
             real_t q_acc_12_0 = 0.0;
             real_t q_acc_12_1 = 0.0;
             real_t q_acc_12_2 = 0.0;
             real_t q_acc_12_3 = 0.0;
             real_t q_acc_13_0 = 0.0;
             real_t q_acc_13_1 = 0.0;
             real_t q_acc_13_2 = 0.0;
             real_t q_acc_13_3 = 0.0;
             real_t q_acc_14_0 = 0.0;
             real_t q_acc_14_1 = 0.0;
             real_t q_acc_14_2 = 0.0;
             real_t q_acc_14_3 = 0.0;
             real_t q_acc_15_0 = 0.0;
             real_t q_acc_15_1 = 0.0;
             real_t q_acc_15_2 = 0.0;
             real_t q_acc_15_3 = 0.0;
             real_t q_acc_16_0 = 0.0;
             real_t q_acc_16_1 = 0.0;
             real_t q_acc_16_2 = 0.0;
             real_t q_acc_16_3 = 0.0;
             real_t q_acc_17_0 = 0.0;
             real_t q_acc_17_1 = 0.0;
             real_t q_acc_17_2 = 0.0;
             real_t q_acc_17_3 = 0.0;
             real_t q_acc_18_0 = 0.0;
             real_t q_acc_18_1 = 0.0;
             real_t q_acc_18_2 = 0.0;
             real_t q_acc_18_3 = 0.0;
             real_t q_acc_19_0 = 0.0;
             real_t q_acc_19_1 = 0.0;
             real_t q_acc_19_2 = 0.0;
             real_t q_acc_19_3 = 0.0;
             real_t q_acc_20_0 = 0.0;
             real_t q_acc_20_1 = 0.0;
             real_t q_acc_20_2 = 0.0;
             real_t q_acc_20_3 = 0.0;
             real_t q_acc_21_0 = 0.0;
             real_t q_acc_21_1 = 0.0;
             real_t q_acc_21_2 = 0.0;
             real_t q_acc_21_3 = 0.0;
             real_t q_acc_22_0 = 0.0;
             real_t q_acc_22_1 = 0.0;
             real_t q_acc_22_2 = 0.0;
             real_t q_acc_22_3 = 0.0;
             real_t q_acc_23_0 = 0.0;
             real_t q_acc_23_1 = 0.0;
             real_t q_acc_23_2 = 0.0;
             real_t q_acc_23_3 = 0.0;
             real_t q_acc_24_0 = 0.0;
             real_t q_acc_24_1 = 0.0;
             real_t q_acc_24_2 = 0.0;
             real_t q_acc_24_3 = 0.0;
             real_t q_acc_25_0 = 0.0;
             real_t q_acc_25_1 = 0.0;
             real_t q_acc_25_2 = 0.0;
             real_t q_acc_25_3 = 0.0;
             real_t q_acc_26_0 = 0.0;
             real_t q_acc_26_1 = 0.0;
             real_t q_acc_26_2 = 0.0;
             real_t q_acc_26_3 = 0.0;
             real_t q_acc_27_0 = 0.0;
             real_t q_acc_27_1 = 0.0;
             real_t q_acc_27_2 = 0.0;
             real_t q_acc_27_3 = 0.0;
             real_t q_acc_28_0 = 0.0;
             real_t q_acc_28_1 = 0.0;
             real_t q_acc_28_2 = 0.0;
             real_t q_acc_28_3 = 0.0;
             real_t q_acc_29_0 = 0.0;
             real_t q_acc_29_1 = 0.0;
             real_t q_acc_29_2 = 0.0;
             real_t q_acc_29_3 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
                const real_t tmp_qloop_1 = -rayVertex_0;
                const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
                const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
                const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
                const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
                const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
                const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
                const real_t tmp_qloop_8 = -rayVertex_1;
                const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
                const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
                const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
                const real_t tmp_qloop_12 = -rayVertex_2;
                const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
                const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
                const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
                const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
                const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
                const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
                const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
                const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
                const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 - _data_q_p_0[q] - _data_q_p_1[q] - _data_q_p_2[q];
                const real_t tmp_qloop_105 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_106 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_108 = tmp_qloop_106 + tmp_qloop_107;
                const real_t tmp_qloop_109 = tmp_qloop_105 + tmp_qloop_108 - 3.0;
                const real_t tmp_qloop_110 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_111 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_112 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_113 = tmp_qloop_112*tmp_qloop_50;
                const real_t tmp_qloop_114 = tmp_qloop_110*tmp_qloop_111;
                const real_t tmp_qloop_115 = tmp_qloop_114*tmp_qloop_52;
                const real_t tmp_qloop_116 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_117 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_118 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = tmp_qloop_110*tmp_qloop_111*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_110*tmp_qloop_111*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_113*tmp_qloop_115*tmp_qloop_86 - tmp_qloop_114*tmp_qloop_119*tmp_qloop_36 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_123 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
                const real_t tmp_qloop_124 = tmp_qloop_122*tmp_qloop_123;
                const real_t tmp_qloop_125 = tmp_qloop_124*tmp_qloop_52;
                const real_t tmp_qloop_126 = tmp_qloop_125*tmp_qloop_25;
                const real_t tmp_qloop_127 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_126 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_128 = tmp_qloop_121*(-tmp_qloop_112*tmp_qloop_125*tmp_qloop_22 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_129 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_124*tmp_qloop_59 - tmp_qloop_119*tmp_qloop_124);
                const real_t tmp_qloop_130 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_129 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_127 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_131 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_129 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_127 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_132 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_129 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_127 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_128;
                const real_t tmp_qloop_133 = abs_det_jac_affine_GREEN_DOWN*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_134 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_130 - tmp_qloop_109*tmp_qloop_131 - tmp_qloop_109*tmp_qloop_132);
                const real_t tmp_qloop_135 = tmp_qloop_104*tmp_qloop_133;
                const real_t tmp_qloop_136 = tmp_qloop_106 - 1.0;
                const real_t tmp_qloop_137 = tmp_qloop_130*tmp_qloop_136;
                const real_t tmp_qloop_138 = tmp_qloop_133*tmp_qloop_137;
                const real_t tmp_qloop_139 = tmp_qloop_107 - 1.0;
                const real_t tmp_qloop_140 = tmp_qloop_131*tmp_qloop_139;
                const real_t tmp_qloop_141 = tmp_qloop_133*tmp_qloop_140;
                const real_t tmp_qloop_142 = tmp_qloop_105 - 1.0;
                const real_t tmp_qloop_143 = tmp_qloop_132*tmp_qloop_142;
                const real_t tmp_qloop_144 = tmp_qloop_133*tmp_qloop_143;
                const real_t tmp_qloop_145 = tmp_qloop_107*tmp_qloop_132;
                const real_t tmp_qloop_146 = tmp_qloop_105*tmp_qloop_131;
                const real_t tmp_qloop_147 = tmp_qloop_133*(-tmp_qloop_145 - tmp_qloop_146);
                const real_t tmp_qloop_148 = tmp_qloop_106*tmp_qloop_132;
                const real_t tmp_qloop_149 = tmp_qloop_105*tmp_qloop_130;
                const real_t tmp_qloop_150 = tmp_qloop_133*(-tmp_qloop_148 - tmp_qloop_149);
                const real_t tmp_qloop_151 = tmp_qloop_106*tmp_qloop_131;
                const real_t tmp_qloop_152 = tmp_qloop_107*tmp_qloop_130;
                const real_t tmp_qloop_153 = tmp_qloop_133*(-tmp_qloop_151 - tmp_qloop_152);
                const real_t tmp_qloop_154 = -tmp_qloop_108 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_155 = tmp_qloop_133*(-tmp_qloop_132*tmp_qloop_154 + tmp_qloop_146 + tmp_qloop_149);
                const real_t tmp_qloop_156 = tmp_qloop_105 - 4.0;
                const real_t tmp_qloop_157 = -tmp_qloop_106 - tmp_qloop_156 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_158 = tmp_qloop_133*(-tmp_qloop_131*tmp_qloop_157 + tmp_qloop_145 + tmp_qloop_152);
                const real_t tmp_qloop_159 = -tmp_qloop_107 - tmp_qloop_156 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_160 = tmp_qloop_133*(-tmp_qloop_130*tmp_qloop_159 + tmp_qloop_148 + tmp_qloop_151);
                const real_t tmp_qloop_161 = tmp_qloop_124*tmp_qloop_18;
                const real_t tmp_qloop_162 = tmp_qloop_121*(-tmp_qloop_116*tmp_qloop_161*tmp_qloop_43 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_163 = tmp_qloop_124*tmp_qloop_36;
                const real_t tmp_qloop_164 = tmp_qloop_163*1.0;
                const real_t tmp_qloop_165 = tmp_qloop_121*(-tmp_qloop_118*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0);
                const real_t tmp_qloop_166 = tmp_qloop_121*(tmp_qloop_116*tmp_qloop_163 - tmp_qloop_125*tmp_qloop_50*tmp_qloop_86);
                const real_t tmp_qloop_167 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_166 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_166 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_169 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_162 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_166 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_165;
                const real_t tmp_qloop_170 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_167 - tmp_qloop_109*tmp_qloop_168 - tmp_qloop_109*tmp_qloop_169);
                const real_t tmp_qloop_171 = tmp_qloop_136*tmp_qloop_167;
                const real_t tmp_qloop_172 = tmp_qloop_133*tmp_qloop_171;
                const real_t tmp_qloop_173 = tmp_qloop_139*tmp_qloop_168;
                const real_t tmp_qloop_174 = tmp_qloop_133*tmp_qloop_173;
                const real_t tmp_qloop_175 = tmp_qloop_142*tmp_qloop_169;
                const real_t tmp_qloop_176 = tmp_qloop_133*tmp_qloop_175;
                const real_t tmp_qloop_177 = tmp_qloop_107*tmp_qloop_169;
                const real_t tmp_qloop_178 = tmp_qloop_105*tmp_qloop_168;
                const real_t tmp_qloop_179 = tmp_qloop_133*(-tmp_qloop_177 - tmp_qloop_178);
                const real_t tmp_qloop_180 = tmp_qloop_106*tmp_qloop_169;
                const real_t tmp_qloop_181 = tmp_qloop_105*tmp_qloop_167;
                const real_t tmp_qloop_182 = tmp_qloop_133*(-tmp_qloop_180 - tmp_qloop_181);
                const real_t tmp_qloop_183 = tmp_qloop_106*tmp_qloop_168;
                const real_t tmp_qloop_184 = tmp_qloop_107*tmp_qloop_167;
                const real_t tmp_qloop_185 = tmp_qloop_133*(-tmp_qloop_183 - tmp_qloop_184);
                const real_t tmp_qloop_186 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_169 + tmp_qloop_178 + tmp_qloop_181);
                const real_t tmp_qloop_187 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_168 + tmp_qloop_177 + tmp_qloop_184);
                const real_t tmp_qloop_188 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_167 + tmp_qloop_180 + tmp_qloop_183);
                const real_t tmp_qloop_189 = tmp_qloop_121*(-tmp_qloop_117*tmp_qloop_164 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0);
                const real_t tmp_qloop_190 = tmp_qloop_121*(-tmp_qloop_113*tmp_qloop_161 + tmp_qloop_122*tmp_qloop_123*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0);
                const real_t tmp_qloop_191 = tmp_qloop_121*(tmp_qloop_112*tmp_qloop_163 - tmp_qloop_126*tmp_qloop_18*tmp_qloop_43);
                const real_t tmp_qloop_192 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_190 + jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_189 + jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_193 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_190 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_189 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_194 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_190 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_189 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_191;
                const real_t tmp_qloop_195 = tmp_qloop_133*(-tmp_qloop_109*tmp_qloop_192 - tmp_qloop_109*tmp_qloop_193 - tmp_qloop_109*tmp_qloop_194);
                const real_t tmp_qloop_196 = tmp_qloop_136*tmp_qloop_192;
                const real_t tmp_qloop_197 = tmp_qloop_133*tmp_qloop_196;
                const real_t tmp_qloop_198 = tmp_qloop_139*tmp_qloop_193;
                const real_t tmp_qloop_199 = tmp_qloop_133*tmp_qloop_198;
                const real_t tmp_qloop_200 = tmp_qloop_142*tmp_qloop_194;
                const real_t tmp_qloop_201 = tmp_qloop_133*tmp_qloop_200;
                const real_t tmp_qloop_202 = tmp_qloop_107*tmp_qloop_194;
                const real_t tmp_qloop_203 = tmp_qloop_105*tmp_qloop_193;
                const real_t tmp_qloop_204 = tmp_qloop_133*(-tmp_qloop_202 - tmp_qloop_203);
                const real_t tmp_qloop_205 = tmp_qloop_106*tmp_qloop_194;
                const real_t tmp_qloop_206 = tmp_qloop_105*tmp_qloop_192;
                const real_t tmp_qloop_207 = tmp_qloop_133*(-tmp_qloop_205 - tmp_qloop_206);
                const real_t tmp_qloop_208 = tmp_qloop_106*tmp_qloop_193;
                const real_t tmp_qloop_209 = tmp_qloop_107*tmp_qloop_192;
                const real_t tmp_qloop_210 = tmp_qloop_133*(-tmp_qloop_208 - tmp_qloop_209);
                const real_t tmp_qloop_211 = tmp_qloop_133*(-tmp_qloop_154*tmp_qloop_194 + tmp_qloop_203 + tmp_qloop_206);
                const real_t tmp_qloop_212 = tmp_qloop_133*(-tmp_qloop_157*tmp_qloop_193 + tmp_qloop_202 + tmp_qloop_209);
                const real_t tmp_qloop_213 = tmp_qloop_133*(-tmp_qloop_159*tmp_qloop_192 + tmp_qloop_205 + tmp_qloop_208);
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_104*tmp_qloop_134;
                const real_t q_tmp_0_1 = tmp_qloop_134*_data_q_p_0[q];
                const real_t q_tmp_0_2 = tmp_qloop_134*_data_q_p_1[q];
                const real_t q_tmp_0_3 = tmp_qloop_134*_data_q_p_2[q];
                const real_t q_tmp_1_0 = -tmp_qloop_135*tmp_qloop_137;
                const real_t q_tmp_1_1 = -tmp_qloop_138*_data_q_p_0[q];
                const real_t q_tmp_1_2 = -tmp_qloop_138*_data_q_p_1[q];
                const real_t q_tmp_1_3 = -tmp_qloop_138*_data_q_p_2[q];
                const real_t q_tmp_2_0 = -tmp_qloop_135*tmp_qloop_140;
                const real_t q_tmp_2_1 = -tmp_qloop_141*_data_q_p_0[q];
                const real_t q_tmp_2_2 = -tmp_qloop_141*_data_q_p_1[q];
                const real_t q_tmp_2_3 = -tmp_qloop_141*_data_q_p_2[q];
                const real_t q_tmp_3_0 = -tmp_qloop_135*tmp_qloop_143;
                const real_t q_tmp_3_1 = -tmp_qloop_144*_data_q_p_0[q];
                const real_t q_tmp_3_2 = -tmp_qloop_144*_data_q_p_1[q];
                const real_t q_tmp_3_3 = -tmp_qloop_144*_data_q_p_2[q];
                const real_t q_tmp_4_0 = tmp_qloop_104*tmp_qloop_147;
                const real_t q_tmp_4_1 = tmp_qloop_147*_data_q_p_0[q];
                const real_t q_tmp_4_2 = tmp_qloop_147*_data_q_p_1[q];
                const real_t q_tmp_4_3 = tmp_qloop_147*_data_q_p_2[q];
                const real_t q_tmp_5_0 = tmp_qloop_104*tmp_qloop_150;
                const real_t q_tmp_5_1 = tmp_qloop_150*_data_q_p_0[q];
                const real_t q_tmp_5_2 = tmp_qloop_150*_data_q_p_1[q];
                const real_t q_tmp_5_3 = tmp_qloop_150*_data_q_p_2[q];
                const real_t q_tmp_6_0 = tmp_qloop_104*tmp_qloop_153;
                const real_t q_tmp_6_1 = tmp_qloop_153*_data_q_p_0[q];
                const real_t q_tmp_6_2 = tmp_qloop_153*_data_q_p_1[q];
                const real_t q_tmp_6_3 = tmp_qloop_153*_data_q_p_2[q];
                const real_t q_tmp_7_0 = tmp_qloop_104*tmp_qloop_155;
                const real_t q_tmp_7_1 = tmp_qloop_155*_data_q_p_0[q];
                const real_t q_tmp_7_2 = tmp_qloop_155*_data_q_p_1[q];
                const real_t q_tmp_7_3 = tmp_qloop_155*_data_q_p_2[q];
                const real_t q_tmp_8_0 = tmp_qloop_104*tmp_qloop_158;
                const real_t q_tmp_8_1 = tmp_qloop_158*_data_q_p_0[q];
                const real_t q_tmp_8_2 = tmp_qloop_158*_data_q_p_1[q];
                const real_t q_tmp_8_3 = tmp_qloop_158*_data_q_p_2[q];
                const real_t q_tmp_9_0 = tmp_qloop_104*tmp_qloop_160;
                const real_t q_tmp_9_1 = tmp_qloop_160*_data_q_p_0[q];
                const real_t q_tmp_9_2 = tmp_qloop_160*_data_q_p_1[q];
                const real_t q_tmp_9_3 = tmp_qloop_160*_data_q_p_2[q];
                const real_t q_tmp_10_0 = tmp_qloop_104*tmp_qloop_170;
                const real_t q_tmp_10_1 = tmp_qloop_170*_data_q_p_0[q];
                const real_t q_tmp_10_2 = tmp_qloop_170*_data_q_p_1[q];
                const real_t q_tmp_10_3 = tmp_qloop_170*_data_q_p_2[q];
                const real_t q_tmp_11_0 = -tmp_qloop_135*tmp_qloop_171;
                const real_t q_tmp_11_1 = -tmp_qloop_172*_data_q_p_0[q];
                const real_t q_tmp_11_2 = -tmp_qloop_172*_data_q_p_1[q];
                const real_t q_tmp_11_3 = -tmp_qloop_172*_data_q_p_2[q];
                const real_t q_tmp_12_0 = -tmp_qloop_135*tmp_qloop_173;
                const real_t q_tmp_12_1 = -tmp_qloop_174*_data_q_p_0[q];
                const real_t q_tmp_12_2 = -tmp_qloop_174*_data_q_p_1[q];
                const real_t q_tmp_12_3 = -tmp_qloop_174*_data_q_p_2[q];
                const real_t q_tmp_13_0 = -tmp_qloop_135*tmp_qloop_175;
                const real_t q_tmp_13_1 = -tmp_qloop_176*_data_q_p_0[q];
                const real_t q_tmp_13_2 = -tmp_qloop_176*_data_q_p_1[q];
                const real_t q_tmp_13_3 = -tmp_qloop_176*_data_q_p_2[q];
                const real_t q_tmp_14_0 = tmp_qloop_104*tmp_qloop_179;
                const real_t q_tmp_14_1 = tmp_qloop_179*_data_q_p_0[q];
                const real_t q_tmp_14_2 = tmp_qloop_179*_data_q_p_1[q];
                const real_t q_tmp_14_3 = tmp_qloop_179*_data_q_p_2[q];
                const real_t q_tmp_15_0 = tmp_qloop_104*tmp_qloop_182;
                const real_t q_tmp_15_1 = tmp_qloop_182*_data_q_p_0[q];
                const real_t q_tmp_15_2 = tmp_qloop_182*_data_q_p_1[q];
                const real_t q_tmp_15_3 = tmp_qloop_182*_data_q_p_2[q];
                const real_t q_tmp_16_0 = tmp_qloop_104*tmp_qloop_185;
                const real_t q_tmp_16_1 = tmp_qloop_185*_data_q_p_0[q];
                const real_t q_tmp_16_2 = tmp_qloop_185*_data_q_p_1[q];
                const real_t q_tmp_16_3 = tmp_qloop_185*_data_q_p_2[q];
                const real_t q_tmp_17_0 = tmp_qloop_104*tmp_qloop_186;
                const real_t q_tmp_17_1 = tmp_qloop_186*_data_q_p_0[q];
                const real_t q_tmp_17_2 = tmp_qloop_186*_data_q_p_1[q];
                const real_t q_tmp_17_3 = tmp_qloop_186*_data_q_p_2[q];
                const real_t q_tmp_18_0 = tmp_qloop_104*tmp_qloop_187;
                const real_t q_tmp_18_1 = tmp_qloop_187*_data_q_p_0[q];
                const real_t q_tmp_18_2 = tmp_qloop_187*_data_q_p_1[q];
                const real_t q_tmp_18_3 = tmp_qloop_187*_data_q_p_2[q];
                const real_t q_tmp_19_0 = tmp_qloop_104*tmp_qloop_188;
                const real_t q_tmp_19_1 = tmp_qloop_188*_data_q_p_0[q];
                const real_t q_tmp_19_2 = tmp_qloop_188*_data_q_p_1[q];
                const real_t q_tmp_19_3 = tmp_qloop_188*_data_q_p_2[q];
                const real_t q_tmp_20_0 = tmp_qloop_104*tmp_qloop_195;
                const real_t q_tmp_20_1 = tmp_qloop_195*_data_q_p_0[q];
                const real_t q_tmp_20_2 = tmp_qloop_195*_data_q_p_1[q];
                const real_t q_tmp_20_3 = tmp_qloop_195*_data_q_p_2[q];
                const real_t q_tmp_21_0 = -tmp_qloop_135*tmp_qloop_196;
                const real_t q_tmp_21_1 = -tmp_qloop_197*_data_q_p_0[q];
                const real_t q_tmp_21_2 = -tmp_qloop_197*_data_q_p_1[q];
                const real_t q_tmp_21_3 = -tmp_qloop_197*_data_q_p_2[q];
                const real_t q_tmp_22_0 = -tmp_qloop_135*tmp_qloop_198;
                const real_t q_tmp_22_1 = -tmp_qloop_199*_data_q_p_0[q];
                const real_t q_tmp_22_2 = -tmp_qloop_199*_data_q_p_1[q];
                const real_t q_tmp_22_3 = -tmp_qloop_199*_data_q_p_2[q];
                const real_t q_tmp_23_0 = -tmp_qloop_135*tmp_qloop_200;
                const real_t q_tmp_23_1 = -tmp_qloop_201*_data_q_p_0[q];
                const real_t q_tmp_23_2 = -tmp_qloop_201*_data_q_p_1[q];
                const real_t q_tmp_23_3 = -tmp_qloop_201*_data_q_p_2[q];
                const real_t q_tmp_24_0 = tmp_qloop_104*tmp_qloop_204;
                const real_t q_tmp_24_1 = tmp_qloop_204*_data_q_p_0[q];
                const real_t q_tmp_24_2 = tmp_qloop_204*_data_q_p_1[q];
                const real_t q_tmp_24_3 = tmp_qloop_204*_data_q_p_2[q];
                const real_t q_tmp_25_0 = tmp_qloop_104*tmp_qloop_207;
                const real_t q_tmp_25_1 = tmp_qloop_207*_data_q_p_0[q];
                const real_t q_tmp_25_2 = tmp_qloop_207*_data_q_p_1[q];
                const real_t q_tmp_25_3 = tmp_qloop_207*_data_q_p_2[q];
                const real_t q_tmp_26_0 = tmp_qloop_104*tmp_qloop_210;
                const real_t q_tmp_26_1 = tmp_qloop_210*_data_q_p_0[q];
                const real_t q_tmp_26_2 = tmp_qloop_210*_data_q_p_1[q];
                const real_t q_tmp_26_3 = tmp_qloop_210*_data_q_p_2[q];
                const real_t q_tmp_27_0 = tmp_qloop_104*tmp_qloop_211;
                const real_t q_tmp_27_1 = tmp_qloop_211*_data_q_p_0[q];
                const real_t q_tmp_27_2 = tmp_qloop_211*_data_q_p_1[q];
                const real_t q_tmp_27_3 = tmp_qloop_211*_data_q_p_2[q];
                const real_t q_tmp_28_0 = tmp_qloop_104*tmp_qloop_212;
                const real_t q_tmp_28_1 = tmp_qloop_212*_data_q_p_0[q];
                const real_t q_tmp_28_2 = tmp_qloop_212*_data_q_p_1[q];
                const real_t q_tmp_28_3 = tmp_qloop_212*_data_q_p_2[q];
                const real_t q_tmp_29_0 = tmp_qloop_104*tmp_qloop_213;
                const real_t q_tmp_29_1 = tmp_qloop_213*_data_q_p_0[q];
                const real_t q_tmp_29_2 = tmp_qloop_213*_data_q_p_1[q];
                const real_t q_tmp_29_3 = tmp_qloop_213*_data_q_p_2[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_10_0 = q_acc_10_0 + q_tmp_10_0;
                q_acc_10_1 = q_acc_10_1 + q_tmp_10_1;
                q_acc_10_2 = q_acc_10_2 + q_tmp_10_2;
                q_acc_10_3 = q_acc_10_3 + q_tmp_10_3;
                q_acc_11_0 = q_acc_11_0 + q_tmp_11_0;
                q_acc_11_1 = q_acc_11_1 + q_tmp_11_1;
                q_acc_11_2 = q_acc_11_2 + q_tmp_11_2;
                q_acc_11_3 = q_acc_11_3 + q_tmp_11_3;
                q_acc_12_0 = q_acc_12_0 + q_tmp_12_0;
                q_acc_12_1 = q_acc_12_1 + q_tmp_12_1;
                q_acc_12_2 = q_acc_12_2 + q_tmp_12_2;
                q_acc_12_3 = q_acc_12_3 + q_tmp_12_3;
                q_acc_13_0 = q_acc_13_0 + q_tmp_13_0;
                q_acc_13_1 = q_acc_13_1 + q_tmp_13_1;
                q_acc_13_2 = q_acc_13_2 + q_tmp_13_2;
                q_acc_13_3 = q_acc_13_3 + q_tmp_13_3;
                q_acc_14_0 = q_acc_14_0 + q_tmp_14_0;
                q_acc_14_1 = q_acc_14_1 + q_tmp_14_1;
                q_acc_14_2 = q_acc_14_2 + q_tmp_14_2;
                q_acc_14_3 = q_acc_14_3 + q_tmp_14_3;
                q_acc_15_0 = q_acc_15_0 + q_tmp_15_0;
                q_acc_15_1 = q_acc_15_1 + q_tmp_15_1;
                q_acc_15_2 = q_acc_15_2 + q_tmp_15_2;
                q_acc_15_3 = q_acc_15_3 + q_tmp_15_3;
                q_acc_16_0 = q_acc_16_0 + q_tmp_16_0;
                q_acc_16_1 = q_acc_16_1 + q_tmp_16_1;
                q_acc_16_2 = q_acc_16_2 + q_tmp_16_2;
                q_acc_16_3 = q_acc_16_3 + q_tmp_16_3;
                q_acc_17_0 = q_acc_17_0 + q_tmp_17_0;
                q_acc_17_1 = q_acc_17_1 + q_tmp_17_1;
                q_acc_17_2 = q_acc_17_2 + q_tmp_17_2;
                q_acc_17_3 = q_acc_17_3 + q_tmp_17_3;
                q_acc_18_0 = q_acc_18_0 + q_tmp_18_0;
                q_acc_18_1 = q_acc_18_1 + q_tmp_18_1;
                q_acc_18_2 = q_acc_18_2 + q_tmp_18_2;
                q_acc_18_3 = q_acc_18_3 + q_tmp_18_3;
                q_acc_19_0 = q_acc_19_0 + q_tmp_19_0;
                q_acc_19_1 = q_acc_19_1 + q_tmp_19_1;
                q_acc_19_2 = q_acc_19_2 + q_tmp_19_2;
                q_acc_19_3 = q_acc_19_3 + q_tmp_19_3;
                q_acc_20_0 = q_acc_20_0 + q_tmp_20_0;
                q_acc_20_1 = q_acc_20_1 + q_tmp_20_1;
                q_acc_20_2 = q_acc_20_2 + q_tmp_20_2;
                q_acc_20_3 = q_acc_20_3 + q_tmp_20_3;
                q_acc_21_0 = q_acc_21_0 + q_tmp_21_0;
                q_acc_21_1 = q_acc_21_1 + q_tmp_21_1;
                q_acc_21_2 = q_acc_21_2 + q_tmp_21_2;
                q_acc_21_3 = q_acc_21_3 + q_tmp_21_3;
                q_acc_22_0 = q_acc_22_0 + q_tmp_22_0;
                q_acc_22_1 = q_acc_22_1 + q_tmp_22_1;
                q_acc_22_2 = q_acc_22_2 + q_tmp_22_2;
                q_acc_22_3 = q_acc_22_3 + q_tmp_22_3;
                q_acc_23_0 = q_acc_23_0 + q_tmp_23_0;
                q_acc_23_1 = q_acc_23_1 + q_tmp_23_1;
                q_acc_23_2 = q_acc_23_2 + q_tmp_23_2;
                q_acc_23_3 = q_acc_23_3 + q_tmp_23_3;
                q_acc_24_0 = q_acc_24_0 + q_tmp_24_0;
                q_acc_24_1 = q_acc_24_1 + q_tmp_24_1;
                q_acc_24_2 = q_acc_24_2 + q_tmp_24_2;
                q_acc_24_3 = q_acc_24_3 + q_tmp_24_3;
                q_acc_25_0 = q_acc_25_0 + q_tmp_25_0;
                q_acc_25_1 = q_acc_25_1 + q_tmp_25_1;
                q_acc_25_2 = q_acc_25_2 + q_tmp_25_2;
                q_acc_25_3 = q_acc_25_3 + q_tmp_25_3;
                q_acc_26_0 = q_acc_26_0 + q_tmp_26_0;
                q_acc_26_1 = q_acc_26_1 + q_tmp_26_1;
                q_acc_26_2 = q_acc_26_2 + q_tmp_26_2;
                q_acc_26_3 = q_acc_26_3 + q_tmp_26_3;
                q_acc_27_0 = q_acc_27_0 + q_tmp_27_0;
                q_acc_27_1 = q_acc_27_1 + q_tmp_27_1;
                q_acc_27_2 = q_acc_27_2 + q_tmp_27_2;
                q_acc_27_3 = q_acc_27_3 + q_tmp_27_3;
                q_acc_28_0 = q_acc_28_0 + q_tmp_28_0;
                q_acc_28_1 = q_acc_28_1 + q_tmp_28_1;
                q_acc_28_2 = q_acc_28_2 + q_tmp_28_2;
                q_acc_28_3 = q_acc_28_3 + q_tmp_28_3;
                q_acc_29_0 = q_acc_29_0 + q_tmp_29_0;
                q_acc_29_1 = q_acc_29_1 + q_tmp_29_1;
                q_acc_29_2 = q_acc_29_2 + q_tmp_29_2;
                q_acc_29_3 = q_acc_29_3 + q_tmp_29_3;
             }
             const real_t tmp_kernel_op_0 = 1.0*(abs(nx_dof_0)*abs(nx_dof_0));
             const real_t tmp_kernel_op_1 = 1.0*(abs(ny_dof_0)*abs(ny_dof_0));
             const real_t tmp_kernel_op_2 = pow(tmp_kernel_op_0 + tmp_kernel_op_1, 0.50000000000000000);
             const real_t tmp_kernel_op_3 = 1.0*(abs(nz_dof_0)*abs(nz_dof_0));
             const real_t tmp_kernel_op_4 = pow(tmp_kernel_op_1 + tmp_kernel_op_3, 0.50000000000000000);
             const real_t tmp_kernel_op_5 = tmp_kernel_op_4 + 1.0e-10;
             const real_t tmp_kernel_op_6 = pow(tmp_kernel_op_0 + tmp_kernel_op_3, 0.50000000000000000);
             const bool tmp_kernel_op_7 = tmp_kernel_op_2 < tmp_kernel_op_5 && tmp_kernel_op_6 < tmp_kernel_op_5;
             const real_t tmp_kernel_op_8 = 1.0 / (tmp_kernel_op_6);
             const real_t tmp_kernel_op_9 = nz_dof_0*1.0;
             const real_t tmp_kernel_op_10 = tmp_kernel_op_8*tmp_kernel_op_9;
             const real_t tmp_kernel_op_11 = tmp_kernel_op_6 + 1.0e-10;
             const bool tmp_kernel_op_12 = tmp_kernel_op_2 < tmp_kernel_op_11 && tmp_kernel_op_4 < tmp_kernel_op_11;
             const real_t tmp_kernel_op_13 = 1.0 / (tmp_kernel_op_2);
             const real_t tmp_kernel_op_14 = tmp_kernel_op_13*1.0;
             const real_t tmp_kernel_op_15 = (nx_dof_0*nx_dof_0);
             const real_t tmp_kernel_op_16 = (ny_dof_0*ny_dof_0);
             const real_t tmp_kernel_op_17 = (nz_dof_0*nz_dof_0);
             const bool tmp_kernel_op_18 = pow(tmp_kernel_op_15 + tmp_kernel_op_16 + tmp_kernel_op_17, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_19 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (0.0): ((tmp_kernel_op_12) ? (-tmp_kernel_op_10): (ny_dof_0*tmp_kernel_op_14)))): (1.0));
             const real_t tmp_kernel_op_20 = 1.0 / (tmp_kernel_op_4);
             const real_t tmp_kernel_op_21 = tmp_kernel_op_20*tmp_kernel_op_9;
             const real_t tmp_kernel_op_22 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (tmp_kernel_op_21): ((tmp_kernel_op_12) ? (0.0): (-nx_dof_0*tmp_kernel_op_14)))): (0.0));
             const real_t tmp_kernel_op_23 = tmp_kernel_op_20*1.0;
             const real_t tmp_kernel_op_24 = ny_dof_0*tmp_kernel_op_23;
             const real_t tmp_kernel_op_25 = tmp_kernel_op_8*1.0;
             const real_t tmp_kernel_op_26 = nx_dof_0*tmp_kernel_op_25;
             const real_t tmp_kernel_op_27 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_24): ((tmp_kernel_op_12) ? (tmp_kernel_op_26): (0.0)))): (0.0));
             const real_t tmp_kernel_op_28 = 1.0*(abs(ny_dof_1)*abs(ny_dof_1));
             const real_t tmp_kernel_op_29 = 1.0*(abs(nz_dof_1)*abs(nz_dof_1));
             const real_t tmp_kernel_op_30 = pow(tmp_kernel_op_28 + tmp_kernel_op_29, 0.50000000000000000);
             const real_t tmp_kernel_op_31 = 1.0 / (tmp_kernel_op_30);
             const real_t tmp_kernel_op_32 = nz_dof_1*1.0;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_31*tmp_kernel_op_32;
             const real_t tmp_kernel_op_34 = 1.0*(abs(nx_dof_1)*abs(nx_dof_1));
             const real_t tmp_kernel_op_35 = pow(tmp_kernel_op_28 + tmp_kernel_op_34, 0.50000000000000000);
             const real_t tmp_kernel_op_36 = tmp_kernel_op_30 + 1.0e-10;
             const real_t tmp_kernel_op_37 = pow(tmp_kernel_op_29 + tmp_kernel_op_34, 0.50000000000000000);
             const bool tmp_kernel_op_38 = tmp_kernel_op_35 < tmp_kernel_op_36 && tmp_kernel_op_37 < tmp_kernel_op_36;
             const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + 1.0e-10;
             const bool tmp_kernel_op_40 = tmp_kernel_op_30 < tmp_kernel_op_39 && tmp_kernel_op_35 < tmp_kernel_op_39;
             const real_t tmp_kernel_op_41 = 1.0 / (tmp_kernel_op_35);
             const real_t tmp_kernel_op_42 = tmp_kernel_op_41*1.0;
             const real_t tmp_kernel_op_43 = (nx_dof_1*nx_dof_1);
             const real_t tmp_kernel_op_44 = (ny_dof_1*ny_dof_1);
             const real_t tmp_kernel_op_45 = (nz_dof_1*nz_dof_1);
             const bool tmp_kernel_op_46 = pow(tmp_kernel_op_43 + tmp_kernel_op_44 + tmp_kernel_op_45, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_47 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (tmp_kernel_op_33): ((tmp_kernel_op_40) ? (0.0): (-nx_dof_1*tmp_kernel_op_42)))): (0.0));
             const real_t tmp_kernel_op_48 = 1.0 / (tmp_kernel_op_37);
             const real_t tmp_kernel_op_49 = tmp_kernel_op_32*tmp_kernel_op_48;
             const real_t tmp_kernel_op_50 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (0.0): ((tmp_kernel_op_40) ? (-tmp_kernel_op_49): (ny_dof_1*tmp_kernel_op_42)))): (1.0));
             const real_t tmp_kernel_op_51 = tmp_kernel_op_31*1.0;
             const real_t tmp_kernel_op_52 = ny_dof_1*tmp_kernel_op_51;
             const real_t tmp_kernel_op_53 = tmp_kernel_op_48*1.0;
             const real_t tmp_kernel_op_54 = nx_dof_1*tmp_kernel_op_53;
             const real_t tmp_kernel_op_55 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_52): ((tmp_kernel_op_40) ? (tmp_kernel_op_54): (0.0)))): (0.0));
             const real_t tmp_kernel_op_56 = 1.0*(abs(ny_dof_2)*abs(ny_dof_2));
             const real_t tmp_kernel_op_57 = 1.0*(abs(nz_dof_2)*abs(nz_dof_2));
             const real_t tmp_kernel_op_58 = pow(tmp_kernel_op_56 + tmp_kernel_op_57, 0.50000000000000000);
             const real_t tmp_kernel_op_59 = 1.0 / (tmp_kernel_op_58);
             const real_t tmp_kernel_op_60 = nz_dof_2*1.0;
             const real_t tmp_kernel_op_61 = tmp_kernel_op_59*tmp_kernel_op_60;
             const real_t tmp_kernel_op_62 = 1.0*(abs(nx_dof_2)*abs(nx_dof_2));
             const real_t tmp_kernel_op_63 = pow(tmp_kernel_op_56 + tmp_kernel_op_62, 0.50000000000000000);
             const real_t tmp_kernel_op_64 = tmp_kernel_op_58 + 1.0e-10;
             const real_t tmp_kernel_op_65 = pow(tmp_kernel_op_57 + tmp_kernel_op_62, 0.50000000000000000);
             const bool tmp_kernel_op_66 = tmp_kernel_op_63 < tmp_kernel_op_64 && tmp_kernel_op_65 < tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = tmp_kernel_op_65 + 1.0e-10;
             const bool tmp_kernel_op_68 = tmp_kernel_op_58 < tmp_kernel_op_67 && tmp_kernel_op_63 < tmp_kernel_op_67;
             const real_t tmp_kernel_op_69 = 1.0 / (tmp_kernel_op_63);
             const real_t tmp_kernel_op_70 = tmp_kernel_op_69*1.0;
             const real_t tmp_kernel_op_71 = (nx_dof_2*nx_dof_2);
             const real_t tmp_kernel_op_72 = (ny_dof_2*ny_dof_2);
             const real_t tmp_kernel_op_73 = (nz_dof_2*nz_dof_2);
             const bool tmp_kernel_op_74 = pow(tmp_kernel_op_71 + tmp_kernel_op_72 + tmp_kernel_op_73, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_75 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (tmp_kernel_op_61): ((tmp_kernel_op_68) ? (0.0): (-nx_dof_2*tmp_kernel_op_70)))): (0.0));
             const real_t tmp_kernel_op_76 = tmp_kernel_op_59*1.0;
             const real_t tmp_kernel_op_77 = ny_dof_2*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = 1.0 / (tmp_kernel_op_65);
             const real_t tmp_kernel_op_79 = tmp_kernel_op_78*1.0;
             const real_t tmp_kernel_op_80 = nx_dof_2*tmp_kernel_op_79;
             const real_t tmp_kernel_op_81 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_77): ((tmp_kernel_op_68) ? (tmp_kernel_op_80): (0.0)))): (0.0));
             const real_t tmp_kernel_op_82 = tmp_kernel_op_60*tmp_kernel_op_78;
             const real_t tmp_kernel_op_83 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (0.0): ((tmp_kernel_op_68) ? (-tmp_kernel_op_82): (ny_dof_2*tmp_kernel_op_70)))): (1.0));
             const real_t tmp_kernel_op_84 = 1.0*(abs(ny_dof_3)*abs(ny_dof_3));
             const real_t tmp_kernel_op_85 = 1.0*(abs(nz_dof_3)*abs(nz_dof_3));
             const real_t tmp_kernel_op_86 = pow(tmp_kernel_op_84 + tmp_kernel_op_85, 0.50000000000000000);
             const real_t tmp_kernel_op_87 = 1.0 / (tmp_kernel_op_86);
             const real_t tmp_kernel_op_88 = nz_dof_3*1.0;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_87*tmp_kernel_op_88;
             const real_t tmp_kernel_op_90 = 1.0*(abs(nx_dof_3)*abs(nx_dof_3));
             const real_t tmp_kernel_op_91 = pow(tmp_kernel_op_84 + tmp_kernel_op_90, 0.50000000000000000);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_86 + 1.0e-10;
             const real_t tmp_kernel_op_93 = pow(tmp_kernel_op_85 + tmp_kernel_op_90, 0.50000000000000000);
             const bool tmp_kernel_op_94 = tmp_kernel_op_91 < tmp_kernel_op_92 && tmp_kernel_op_93 < tmp_kernel_op_92;
             const real_t tmp_kernel_op_95 = tmp_kernel_op_93 + 1.0e-10;
             const bool tmp_kernel_op_96 = tmp_kernel_op_86 < tmp_kernel_op_95 && tmp_kernel_op_91 < tmp_kernel_op_95;
             const real_t tmp_kernel_op_97 = 1.0 / (tmp_kernel_op_91);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_97*1.0;
             const real_t tmp_kernel_op_99 = (nx_dof_3*nx_dof_3);
             const real_t tmp_kernel_op_100 = (ny_dof_3*ny_dof_3);
             const real_t tmp_kernel_op_101 = (nz_dof_3*nz_dof_3);
             const bool tmp_kernel_op_102 = pow(tmp_kernel_op_100 + tmp_kernel_op_101 + tmp_kernel_op_99, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_103 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (tmp_kernel_op_89): ((tmp_kernel_op_96) ? (0.0): (-nx_dof_3*tmp_kernel_op_98)))): (0.0));
             const real_t tmp_kernel_op_104 = tmp_kernel_op_87*1.0;
             const real_t tmp_kernel_op_105 = ny_dof_3*tmp_kernel_op_104;
             const real_t tmp_kernel_op_106 = 1.0 / (tmp_kernel_op_93);
             const real_t tmp_kernel_op_107 = tmp_kernel_op_106*1.0;
             const real_t tmp_kernel_op_108 = nx_dof_3*tmp_kernel_op_107;
             const real_t tmp_kernel_op_109 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_105): ((tmp_kernel_op_96) ? (tmp_kernel_op_108): (0.0)))): (0.0));
             const real_t tmp_kernel_op_110 = tmp_kernel_op_106*tmp_kernel_op_88;
             const real_t tmp_kernel_op_111 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (0.0): ((tmp_kernel_op_96) ? (-tmp_kernel_op_110): (ny_dof_3*tmp_kernel_op_98)))): (1.0));
             const real_t tmp_kernel_op_112 = 1.0*(abs(ny_dof_4)*abs(ny_dof_4));
             const real_t tmp_kernel_op_113 = 1.0*(abs(nz_dof_4)*abs(nz_dof_4));
             const real_t tmp_kernel_op_114 = pow(tmp_kernel_op_112 + tmp_kernel_op_113, 0.50000000000000000);
             const real_t tmp_kernel_op_115 = 1.0 / (tmp_kernel_op_114);
             const real_t tmp_kernel_op_116 = nz_dof_4*1.0;
             const real_t tmp_kernel_op_117 = tmp_kernel_op_115*tmp_kernel_op_116;
             const real_t tmp_kernel_op_118 = 1.0*(abs(nx_dof_4)*abs(nx_dof_4));
             const real_t tmp_kernel_op_119 = pow(tmp_kernel_op_112 + tmp_kernel_op_118, 0.50000000000000000);
             const real_t tmp_kernel_op_120 = tmp_kernel_op_114 + 1.0e-10;
             const real_t tmp_kernel_op_121 = pow(tmp_kernel_op_113 + tmp_kernel_op_118, 0.50000000000000000);
             const bool tmp_kernel_op_122 = tmp_kernel_op_119 < tmp_kernel_op_120 && tmp_kernel_op_121 < tmp_kernel_op_120;
             const real_t tmp_kernel_op_123 = tmp_kernel_op_121 + 1.0e-10;
             const bool tmp_kernel_op_124 = tmp_kernel_op_114 < tmp_kernel_op_123 && tmp_kernel_op_119 < tmp_kernel_op_123;
             const real_t tmp_kernel_op_125 = 1.0 / (tmp_kernel_op_119);
             const real_t tmp_kernel_op_126 = tmp_kernel_op_125*1.0;
             const real_t tmp_kernel_op_127 = (nx_dof_4*nx_dof_4);
             const real_t tmp_kernel_op_128 = (ny_dof_4*ny_dof_4);
             const real_t tmp_kernel_op_129 = (nz_dof_4*nz_dof_4);
             const bool tmp_kernel_op_130 = pow(tmp_kernel_op_127 + tmp_kernel_op_128 + tmp_kernel_op_129, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_131 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (tmp_kernel_op_117): ((tmp_kernel_op_124) ? (0.0): (-nx_dof_4*tmp_kernel_op_126)))): (0.0));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_115*1.0;
             const real_t tmp_kernel_op_133 = ny_dof_4*tmp_kernel_op_132;
             const real_t tmp_kernel_op_134 = 1.0 / (tmp_kernel_op_121);
             const real_t tmp_kernel_op_135 = tmp_kernel_op_134*1.0;
             const real_t tmp_kernel_op_136 = nx_dof_4*tmp_kernel_op_135;
             const real_t tmp_kernel_op_137 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_133): ((tmp_kernel_op_124) ? (tmp_kernel_op_136): (0.0)))): (0.0));
             const real_t tmp_kernel_op_138 = tmp_kernel_op_116*tmp_kernel_op_134;
             const real_t tmp_kernel_op_139 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (0.0): ((tmp_kernel_op_124) ? (-tmp_kernel_op_138): (ny_dof_4*tmp_kernel_op_126)))): (1.0));
             const real_t tmp_kernel_op_140 = 1.0*(abs(ny_dof_5)*abs(ny_dof_5));
             const real_t tmp_kernel_op_141 = 1.0*(abs(nz_dof_5)*abs(nz_dof_5));
             const real_t tmp_kernel_op_142 = pow(tmp_kernel_op_140 + tmp_kernel_op_141, 0.50000000000000000);
             const real_t tmp_kernel_op_143 = 1.0 / (tmp_kernel_op_142);
             const real_t tmp_kernel_op_144 = nz_dof_5*1.0;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_143*tmp_kernel_op_144;
             const real_t tmp_kernel_op_146 = 1.0*(abs(nx_dof_5)*abs(nx_dof_5));
             const real_t tmp_kernel_op_147 = pow(tmp_kernel_op_140 + tmp_kernel_op_146, 0.50000000000000000);
             const real_t tmp_kernel_op_148 = tmp_kernel_op_142 + 1.0e-10;
             const real_t tmp_kernel_op_149 = pow(tmp_kernel_op_141 + tmp_kernel_op_146, 0.50000000000000000);
             const bool tmp_kernel_op_150 = tmp_kernel_op_147 < tmp_kernel_op_148 && tmp_kernel_op_149 < tmp_kernel_op_148;
             const real_t tmp_kernel_op_151 = tmp_kernel_op_149 + 1.0e-10;
             const bool tmp_kernel_op_152 = tmp_kernel_op_142 < tmp_kernel_op_151 && tmp_kernel_op_147 < tmp_kernel_op_151;
             const real_t tmp_kernel_op_153 = 1.0 / (tmp_kernel_op_147);
             const real_t tmp_kernel_op_154 = tmp_kernel_op_153*1.0;
             const real_t tmp_kernel_op_155 = (nx_dof_5*nx_dof_5);
             const real_t tmp_kernel_op_156 = (ny_dof_5*ny_dof_5);
             const real_t tmp_kernel_op_157 = (nz_dof_5*nz_dof_5);
             const bool tmp_kernel_op_158 = pow(tmp_kernel_op_155 + tmp_kernel_op_156 + tmp_kernel_op_157, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_159 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (tmp_kernel_op_145): ((tmp_kernel_op_152) ? (0.0): (-nx_dof_5*tmp_kernel_op_154)))): (0.0));
             const real_t tmp_kernel_op_160 = tmp_kernel_op_143*1.0;
             const real_t tmp_kernel_op_161 = ny_dof_5*tmp_kernel_op_160;
             const real_t tmp_kernel_op_162 = 1.0 / (tmp_kernel_op_149);
             const real_t tmp_kernel_op_163 = tmp_kernel_op_162*1.0;
             const real_t tmp_kernel_op_164 = nx_dof_5*tmp_kernel_op_163;
             const real_t tmp_kernel_op_165 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_161): ((tmp_kernel_op_152) ? (tmp_kernel_op_164): (0.0)))): (0.0));
             const real_t tmp_kernel_op_166 = tmp_kernel_op_144*tmp_kernel_op_162;
             const real_t tmp_kernel_op_167 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (0.0): ((tmp_kernel_op_152) ? (-tmp_kernel_op_166): (ny_dof_5*tmp_kernel_op_154)))): (1.0));
             const real_t tmp_kernel_op_168 = 1.0*(abs(ny_dof_6)*abs(ny_dof_6));
             const real_t tmp_kernel_op_169 = 1.0*(abs(nz_dof_6)*abs(nz_dof_6));
             const real_t tmp_kernel_op_170 = pow(tmp_kernel_op_168 + tmp_kernel_op_169, 0.50000000000000000);
             const real_t tmp_kernel_op_171 = 1.0 / (tmp_kernel_op_170);
             const real_t tmp_kernel_op_172 = nz_dof_6*1.0;
             const real_t tmp_kernel_op_173 = tmp_kernel_op_171*tmp_kernel_op_172;
             const real_t tmp_kernel_op_174 = 1.0*(abs(nx_dof_6)*abs(nx_dof_6));
             const real_t tmp_kernel_op_175 = pow(tmp_kernel_op_168 + tmp_kernel_op_174, 0.50000000000000000);
             const real_t tmp_kernel_op_176 = tmp_kernel_op_170 + 1.0e-10;
             const real_t tmp_kernel_op_177 = pow(tmp_kernel_op_169 + tmp_kernel_op_174, 0.50000000000000000);
             const bool tmp_kernel_op_178 = tmp_kernel_op_175 < tmp_kernel_op_176 && tmp_kernel_op_177 < tmp_kernel_op_176;
             const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + 1.0e-10;
             const bool tmp_kernel_op_180 = tmp_kernel_op_170 < tmp_kernel_op_179 && tmp_kernel_op_175 < tmp_kernel_op_179;
             const real_t tmp_kernel_op_181 = 1.0 / (tmp_kernel_op_175);
             const real_t tmp_kernel_op_182 = tmp_kernel_op_181*1.0;
             const real_t tmp_kernel_op_183 = (nx_dof_6*nx_dof_6);
             const real_t tmp_kernel_op_184 = (ny_dof_6*ny_dof_6);
             const real_t tmp_kernel_op_185 = (nz_dof_6*nz_dof_6);
             const bool tmp_kernel_op_186 = pow(tmp_kernel_op_183 + tmp_kernel_op_184 + tmp_kernel_op_185, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_187 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (tmp_kernel_op_173): ((tmp_kernel_op_180) ? (0.0): (-nx_dof_6*tmp_kernel_op_182)))): (0.0));
             const real_t tmp_kernel_op_188 = tmp_kernel_op_171*1.0;
             const real_t tmp_kernel_op_189 = ny_dof_6*tmp_kernel_op_188;
             const real_t tmp_kernel_op_190 = 1.0 / (tmp_kernel_op_177);
             const real_t tmp_kernel_op_191 = tmp_kernel_op_190*1.0;
             const real_t tmp_kernel_op_192 = nx_dof_6*tmp_kernel_op_191;
             const real_t tmp_kernel_op_193 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_189): ((tmp_kernel_op_180) ? (tmp_kernel_op_192): (0.0)))): (0.0));
             const real_t tmp_kernel_op_194 = tmp_kernel_op_172*tmp_kernel_op_190;
             const real_t tmp_kernel_op_195 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (0.0): ((tmp_kernel_op_180) ? (-tmp_kernel_op_194): (ny_dof_6*tmp_kernel_op_182)))): (1.0));
             const real_t tmp_kernel_op_196 = 1.0*(abs(ny_dof_7)*abs(ny_dof_7));
             const real_t tmp_kernel_op_197 = 1.0*(abs(nz_dof_7)*abs(nz_dof_7));
             const real_t tmp_kernel_op_198 = pow(tmp_kernel_op_196 + tmp_kernel_op_197, 0.50000000000000000);
             const real_t tmp_kernel_op_199 = 1.0 / (tmp_kernel_op_198);
             const real_t tmp_kernel_op_200 = nz_dof_7*1.0;
             const real_t tmp_kernel_op_201 = tmp_kernel_op_199*tmp_kernel_op_200;
             const real_t tmp_kernel_op_202 = 1.0*(abs(nx_dof_7)*abs(nx_dof_7));
             const real_t tmp_kernel_op_203 = pow(tmp_kernel_op_196 + tmp_kernel_op_202, 0.50000000000000000);
             const real_t tmp_kernel_op_204 = tmp_kernel_op_198 + 1.0e-10;
             const real_t tmp_kernel_op_205 = pow(tmp_kernel_op_197 + tmp_kernel_op_202, 0.50000000000000000);
             const bool tmp_kernel_op_206 = tmp_kernel_op_203 < tmp_kernel_op_204 && tmp_kernel_op_205 < tmp_kernel_op_204;
             const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + 1.0e-10;
             const bool tmp_kernel_op_208 = tmp_kernel_op_198 < tmp_kernel_op_207 && tmp_kernel_op_203 < tmp_kernel_op_207;
             const real_t tmp_kernel_op_209 = 1.0 / (tmp_kernel_op_203);
             const real_t tmp_kernel_op_210 = tmp_kernel_op_209*1.0;
             const real_t tmp_kernel_op_211 = (nx_dof_7*nx_dof_7);
             const real_t tmp_kernel_op_212 = (ny_dof_7*ny_dof_7);
             const real_t tmp_kernel_op_213 = (nz_dof_7*nz_dof_7);
             const bool tmp_kernel_op_214 = pow(tmp_kernel_op_211 + tmp_kernel_op_212 + tmp_kernel_op_213, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_215 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (tmp_kernel_op_201): ((tmp_kernel_op_208) ? (0.0): (-nx_dof_7*tmp_kernel_op_210)))): (0.0));
             const real_t tmp_kernel_op_216 = tmp_kernel_op_199*1.0;
             const real_t tmp_kernel_op_217 = ny_dof_7*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = 1.0 / (tmp_kernel_op_205);
             const real_t tmp_kernel_op_219 = tmp_kernel_op_218*1.0;
             const real_t tmp_kernel_op_220 = nx_dof_7*tmp_kernel_op_219;
             const real_t tmp_kernel_op_221 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_217): ((tmp_kernel_op_208) ? (tmp_kernel_op_220): (0.0)))): (0.0));
             const real_t tmp_kernel_op_222 = tmp_kernel_op_200*tmp_kernel_op_218;
             const real_t tmp_kernel_op_223 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (0.0): ((tmp_kernel_op_208) ? (-tmp_kernel_op_222): (ny_dof_7*tmp_kernel_op_210)))): (1.0));
             const real_t tmp_kernel_op_224 = 1.0*(abs(ny_dof_8)*abs(ny_dof_8));
             const real_t tmp_kernel_op_225 = 1.0*(abs(nz_dof_8)*abs(nz_dof_8));
             const real_t tmp_kernel_op_226 = pow(tmp_kernel_op_224 + tmp_kernel_op_225, 0.50000000000000000);
             const real_t tmp_kernel_op_227 = 1.0 / (tmp_kernel_op_226);
             const real_t tmp_kernel_op_228 = nz_dof_8*1.0;
             const real_t tmp_kernel_op_229 = tmp_kernel_op_227*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = 1.0*(abs(nx_dof_8)*abs(nx_dof_8));
             const real_t tmp_kernel_op_231 = pow(tmp_kernel_op_224 + tmp_kernel_op_230, 0.50000000000000000);
             const real_t tmp_kernel_op_232 = tmp_kernel_op_226 + 1.0e-10;
             const real_t tmp_kernel_op_233 = pow(tmp_kernel_op_225 + tmp_kernel_op_230, 0.50000000000000000);
             const bool tmp_kernel_op_234 = tmp_kernel_op_231 < tmp_kernel_op_232 && tmp_kernel_op_233 < tmp_kernel_op_232;
             const real_t tmp_kernel_op_235 = tmp_kernel_op_233 + 1.0e-10;
             const bool tmp_kernel_op_236 = tmp_kernel_op_226 < tmp_kernel_op_235 && tmp_kernel_op_231 < tmp_kernel_op_235;
             const real_t tmp_kernel_op_237 = 1.0 / (tmp_kernel_op_231);
             const real_t tmp_kernel_op_238 = tmp_kernel_op_237*1.0;
             const real_t tmp_kernel_op_239 = (nx_dof_8*nx_dof_8);
             const real_t tmp_kernel_op_240 = (ny_dof_8*ny_dof_8);
             const real_t tmp_kernel_op_241 = (nz_dof_8*nz_dof_8);
             const bool tmp_kernel_op_242 = pow(tmp_kernel_op_239 + tmp_kernel_op_240 + tmp_kernel_op_241, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_243 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (tmp_kernel_op_229): ((tmp_kernel_op_236) ? (0.0): (-nx_dof_8*tmp_kernel_op_238)))): (0.0));
             const real_t tmp_kernel_op_244 = tmp_kernel_op_227*1.0;
             const real_t tmp_kernel_op_245 = ny_dof_8*tmp_kernel_op_244;
             const real_t tmp_kernel_op_246 = 1.0 / (tmp_kernel_op_233);
             const real_t tmp_kernel_op_247 = tmp_kernel_op_246*1.0;
             const real_t tmp_kernel_op_248 = nx_dof_8*tmp_kernel_op_247;
             const real_t tmp_kernel_op_249 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_245): ((tmp_kernel_op_236) ? (tmp_kernel_op_248): (0.0)))): (0.0));
             const real_t tmp_kernel_op_250 = tmp_kernel_op_228*tmp_kernel_op_246;
             const real_t tmp_kernel_op_251 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (0.0): ((tmp_kernel_op_236) ? (-tmp_kernel_op_250): (ny_dof_8*tmp_kernel_op_238)))): (1.0));
             const real_t tmp_kernel_op_252 = 1.0*(abs(ny_dof_9)*abs(ny_dof_9));
             const real_t tmp_kernel_op_253 = 1.0*(abs(nz_dof_9)*abs(nz_dof_9));
             const real_t tmp_kernel_op_254 = pow(tmp_kernel_op_252 + tmp_kernel_op_253, 0.50000000000000000);
             const real_t tmp_kernel_op_255 = 1.0 / (tmp_kernel_op_254);
             const real_t tmp_kernel_op_256 = nz_dof_9*1.0;
             const real_t tmp_kernel_op_257 = tmp_kernel_op_255*tmp_kernel_op_256;
             const real_t tmp_kernel_op_258 = 1.0*(abs(nx_dof_9)*abs(nx_dof_9));
             const real_t tmp_kernel_op_259 = pow(tmp_kernel_op_252 + tmp_kernel_op_258, 0.50000000000000000);
             const real_t tmp_kernel_op_260 = tmp_kernel_op_254 + 1.0e-10;
             const real_t tmp_kernel_op_261 = pow(tmp_kernel_op_253 + tmp_kernel_op_258, 0.50000000000000000);
             const bool tmp_kernel_op_262 = tmp_kernel_op_259 < tmp_kernel_op_260 && tmp_kernel_op_261 < tmp_kernel_op_260;
             const real_t tmp_kernel_op_263 = tmp_kernel_op_261 + 1.0e-10;
             const bool tmp_kernel_op_264 = tmp_kernel_op_254 < tmp_kernel_op_263 && tmp_kernel_op_259 < tmp_kernel_op_263;
             const real_t tmp_kernel_op_265 = 1.0 / (tmp_kernel_op_259);
             const real_t tmp_kernel_op_266 = tmp_kernel_op_265*1.0;
             const real_t tmp_kernel_op_267 = (nx_dof_9*nx_dof_9);
             const real_t tmp_kernel_op_268 = (ny_dof_9*ny_dof_9);
             const real_t tmp_kernel_op_269 = (nz_dof_9*nz_dof_9);
             const bool tmp_kernel_op_270 = pow(tmp_kernel_op_267 + tmp_kernel_op_268 + tmp_kernel_op_269, 0.50000000000000000) > 0.5;
             const real_t tmp_kernel_op_271 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (tmp_kernel_op_257): ((tmp_kernel_op_264) ? (0.0): (-nx_dof_9*tmp_kernel_op_266)))): (0.0));
             const real_t tmp_kernel_op_272 = tmp_kernel_op_255*1.0;
             const real_t tmp_kernel_op_273 = ny_dof_9*tmp_kernel_op_272;
             const real_t tmp_kernel_op_274 = 1.0 / (tmp_kernel_op_261);
             const real_t tmp_kernel_op_275 = tmp_kernel_op_274*1.0;
             const real_t tmp_kernel_op_276 = nx_dof_9*tmp_kernel_op_275;
             const real_t tmp_kernel_op_277 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_273): ((tmp_kernel_op_264) ? (tmp_kernel_op_276): (0.0)))): (0.0));
             const real_t tmp_kernel_op_278 = tmp_kernel_op_256*tmp_kernel_op_274;
             const real_t tmp_kernel_op_279 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (0.0): ((tmp_kernel_op_264) ? (-tmp_kernel_op_278): (ny_dof_9*tmp_kernel_op_266)))): (1.0));
             const real_t tmp_kernel_op_280 = tmp_kernel_op_13*tmp_kernel_op_9;
             const real_t tmp_kernel_op_281 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (-tmp_kernel_op_16*tmp_kernel_op_23 - tmp_kernel_op_17*tmp_kernel_op_23): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_26): (nx_dof_0*tmp_kernel_op_280)))): (0.0));
             const real_t tmp_kernel_op_282 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_24): ((tmp_kernel_op_12) ? (-tmp_kernel_op_15*tmp_kernel_op_25 - tmp_kernel_op_17*tmp_kernel_op_25): (ny_dof_0*tmp_kernel_op_280)))): (1.0));
             const real_t tmp_kernel_op_283 = ((tmp_kernel_op_18) ? (((tmp_kernel_op_7) ? (nx_dof_0*tmp_kernel_op_21): ((tmp_kernel_op_12) ? (ny_dof_0*tmp_kernel_op_10): (-tmp_kernel_op_14*tmp_kernel_op_15 - tmp_kernel_op_14*tmp_kernel_op_16)))): (0.0));
             const real_t tmp_kernel_op_284 = tmp_kernel_op_32*tmp_kernel_op_41;
             const real_t tmp_kernel_op_285 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_52): ((tmp_kernel_op_40) ? (-tmp_kernel_op_43*tmp_kernel_op_53 - tmp_kernel_op_45*tmp_kernel_op_53): (ny_dof_1*tmp_kernel_op_284)))): (1.0));
             const real_t tmp_kernel_op_286 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (-tmp_kernel_op_44*tmp_kernel_op_51 - tmp_kernel_op_45*tmp_kernel_op_51): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_54): (nx_dof_1*tmp_kernel_op_284)))): (0.0));
             const real_t tmp_kernel_op_287 = ((tmp_kernel_op_46) ? (((tmp_kernel_op_38) ? (nx_dof_1*tmp_kernel_op_33): ((tmp_kernel_op_40) ? (ny_dof_1*tmp_kernel_op_49): (-tmp_kernel_op_42*tmp_kernel_op_43 - tmp_kernel_op_42*tmp_kernel_op_44)))): (0.0));
             const real_t tmp_kernel_op_288 = tmp_kernel_op_60*tmp_kernel_op_69;
             const real_t tmp_kernel_op_289 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_77): ((tmp_kernel_op_68) ? (-tmp_kernel_op_71*tmp_kernel_op_79 - tmp_kernel_op_73*tmp_kernel_op_79): (ny_dof_2*tmp_kernel_op_288)))): (1.0));
             const real_t tmp_kernel_op_290 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (nx_dof_2*tmp_kernel_op_61): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_82): (-tmp_kernel_op_70*tmp_kernel_op_71 - tmp_kernel_op_70*tmp_kernel_op_72)))): (0.0));
             const real_t tmp_kernel_op_291 = ((tmp_kernel_op_74) ? (((tmp_kernel_op_66) ? (-tmp_kernel_op_72*tmp_kernel_op_76 - tmp_kernel_op_73*tmp_kernel_op_76): ((tmp_kernel_op_68) ? (ny_dof_2*tmp_kernel_op_80): (nx_dof_2*tmp_kernel_op_288)))): (0.0));
             const real_t tmp_kernel_op_292 = tmp_kernel_op_88*tmp_kernel_op_97;
             const real_t tmp_kernel_op_293 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_105): ((tmp_kernel_op_96) ? (-tmp_kernel_op_101*tmp_kernel_op_107 - tmp_kernel_op_107*tmp_kernel_op_99): (ny_dof_3*tmp_kernel_op_292)))): (1.0));
             const real_t tmp_kernel_op_294 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (nx_dof_3*tmp_kernel_op_89): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_110): (-tmp_kernel_op_100*tmp_kernel_op_98 - tmp_kernel_op_98*tmp_kernel_op_99)))): (0.0));
             const real_t tmp_kernel_op_295 = ((tmp_kernel_op_102) ? (((tmp_kernel_op_94) ? (-tmp_kernel_op_100*tmp_kernel_op_104 - tmp_kernel_op_101*tmp_kernel_op_104): ((tmp_kernel_op_96) ? (ny_dof_3*tmp_kernel_op_108): (nx_dof_3*tmp_kernel_op_292)))): (0.0));
             const real_t tmp_kernel_op_296 = tmp_kernel_op_116*tmp_kernel_op_125;
             const real_t tmp_kernel_op_297 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_133): ((tmp_kernel_op_124) ? (-tmp_kernel_op_127*tmp_kernel_op_135 - tmp_kernel_op_129*tmp_kernel_op_135): (ny_dof_4*tmp_kernel_op_296)))): (1.0));
             const real_t tmp_kernel_op_298 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (nx_dof_4*tmp_kernel_op_117): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_138): (-tmp_kernel_op_126*tmp_kernel_op_127 - tmp_kernel_op_126*tmp_kernel_op_128)))): (0.0));
             const real_t tmp_kernel_op_299 = ((tmp_kernel_op_130) ? (((tmp_kernel_op_122) ? (-tmp_kernel_op_128*tmp_kernel_op_132 - tmp_kernel_op_129*tmp_kernel_op_132): ((tmp_kernel_op_124) ? (ny_dof_4*tmp_kernel_op_136): (nx_dof_4*tmp_kernel_op_296)))): (0.0));
             const real_t tmp_kernel_op_300 = tmp_kernel_op_144*tmp_kernel_op_153;
             const real_t tmp_kernel_op_301 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_161): ((tmp_kernel_op_152) ? (-tmp_kernel_op_155*tmp_kernel_op_163 - tmp_kernel_op_157*tmp_kernel_op_163): (ny_dof_5*tmp_kernel_op_300)))): (1.0));
             const real_t tmp_kernel_op_302 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (nx_dof_5*tmp_kernel_op_145): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_166): (-tmp_kernel_op_154*tmp_kernel_op_155 - tmp_kernel_op_154*tmp_kernel_op_156)))): (0.0));
             const real_t tmp_kernel_op_303 = ((tmp_kernel_op_158) ? (((tmp_kernel_op_150) ? (-tmp_kernel_op_156*tmp_kernel_op_160 - tmp_kernel_op_157*tmp_kernel_op_160): ((tmp_kernel_op_152) ? (ny_dof_5*tmp_kernel_op_164): (nx_dof_5*tmp_kernel_op_300)))): (0.0));
             const real_t tmp_kernel_op_304 = tmp_kernel_op_172*tmp_kernel_op_181;
             const real_t tmp_kernel_op_305 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_189): ((tmp_kernel_op_180) ? (-tmp_kernel_op_183*tmp_kernel_op_191 - tmp_kernel_op_185*tmp_kernel_op_191): (ny_dof_6*tmp_kernel_op_304)))): (1.0));
             const real_t tmp_kernel_op_306 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (nx_dof_6*tmp_kernel_op_173): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_194): (-tmp_kernel_op_182*tmp_kernel_op_183 - tmp_kernel_op_182*tmp_kernel_op_184)))): (0.0));
             const real_t tmp_kernel_op_307 = ((tmp_kernel_op_186) ? (((tmp_kernel_op_178) ? (-tmp_kernel_op_184*tmp_kernel_op_188 - tmp_kernel_op_185*tmp_kernel_op_188): ((tmp_kernel_op_180) ? (ny_dof_6*tmp_kernel_op_192): (nx_dof_6*tmp_kernel_op_304)))): (0.0));
             const real_t tmp_kernel_op_308 = tmp_kernel_op_200*tmp_kernel_op_209;
             const real_t tmp_kernel_op_309 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_217): ((tmp_kernel_op_208) ? (-tmp_kernel_op_211*tmp_kernel_op_219 - tmp_kernel_op_213*tmp_kernel_op_219): (ny_dof_7*tmp_kernel_op_308)))): (1.0));
             const real_t tmp_kernel_op_310 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (nx_dof_7*tmp_kernel_op_201): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_222): (-tmp_kernel_op_210*tmp_kernel_op_211 - tmp_kernel_op_210*tmp_kernel_op_212)))): (0.0));
             const real_t tmp_kernel_op_311 = ((tmp_kernel_op_214) ? (((tmp_kernel_op_206) ? (-tmp_kernel_op_212*tmp_kernel_op_216 - tmp_kernel_op_213*tmp_kernel_op_216): ((tmp_kernel_op_208) ? (ny_dof_7*tmp_kernel_op_220): (nx_dof_7*tmp_kernel_op_308)))): (0.0));
             const real_t tmp_kernel_op_312 = tmp_kernel_op_228*tmp_kernel_op_237;
             const real_t tmp_kernel_op_313 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_245): ((tmp_kernel_op_236) ? (-tmp_kernel_op_239*tmp_kernel_op_247 - tmp_kernel_op_241*tmp_kernel_op_247): (ny_dof_8*tmp_kernel_op_312)))): (1.0));
             const real_t tmp_kernel_op_314 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (nx_dof_8*tmp_kernel_op_229): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_250): (-tmp_kernel_op_238*tmp_kernel_op_239 - tmp_kernel_op_238*tmp_kernel_op_240)))): (0.0));
             const real_t tmp_kernel_op_315 = ((tmp_kernel_op_242) ? (((tmp_kernel_op_234) ? (-tmp_kernel_op_240*tmp_kernel_op_244 - tmp_kernel_op_241*tmp_kernel_op_244): ((tmp_kernel_op_236) ? (ny_dof_8*tmp_kernel_op_248): (nx_dof_8*tmp_kernel_op_312)))): (0.0));
             const real_t tmp_kernel_op_316 = tmp_kernel_op_256*tmp_kernel_op_265;
             const real_t tmp_kernel_op_317 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_273): ((tmp_kernel_op_264) ? (-tmp_kernel_op_267*tmp_kernel_op_275 - tmp_kernel_op_269*tmp_kernel_op_275): (ny_dof_9*tmp_kernel_op_316)))): (1.0));
             const real_t tmp_kernel_op_318 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (nx_dof_9*tmp_kernel_op_257): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_278): (-tmp_kernel_op_266*tmp_kernel_op_267 - tmp_kernel_op_266*tmp_kernel_op_268)))): (0.0));
             const real_t tmp_kernel_op_319 = ((tmp_kernel_op_270) ? (((tmp_kernel_op_262) ? (-tmp_kernel_op_268*tmp_kernel_op_272 - tmp_kernel_op_269*tmp_kernel_op_272): ((tmp_kernel_op_264) ? (ny_dof_9*tmp_kernel_op_276): (nx_dof_9*tmp_kernel_op_316)))): (0.0));
             const real_t tmp_kernel_op_320 = ((tmp_kernel_op_18) ? (nx_dof_0): (0.0));
             const real_t tmp_kernel_op_321 = ((tmp_kernel_op_18) ? (ny_dof_0): (0.0));
             const real_t tmp_kernel_op_322 = ((tmp_kernel_op_18) ? (nz_dof_0): (1.0));
             const real_t tmp_kernel_op_323 = ((tmp_kernel_op_46) ? (ny_dof_1): (0.0));
             const real_t tmp_kernel_op_324 = ((tmp_kernel_op_46) ? (nx_dof_1): (0.0));
             const real_t tmp_kernel_op_325 = ((tmp_kernel_op_46) ? (nz_dof_1): (1.0));
             const real_t tmp_kernel_op_326 = ((tmp_kernel_op_74) ? (ny_dof_2): (0.0));
             const real_t tmp_kernel_op_327 = ((tmp_kernel_op_74) ? (nz_dof_2): (1.0));
             const real_t tmp_kernel_op_328 = ((tmp_kernel_op_74) ? (nx_dof_2): (0.0));
             const real_t tmp_kernel_op_329 = ((tmp_kernel_op_102) ? (ny_dof_3): (0.0));
             const real_t tmp_kernel_op_330 = ((tmp_kernel_op_102) ? (nz_dof_3): (1.0));
             const real_t tmp_kernel_op_331 = ((tmp_kernel_op_102) ? (nx_dof_3): (0.0));
             const real_t tmp_kernel_op_332 = ((tmp_kernel_op_130) ? (ny_dof_4): (0.0));
             const real_t tmp_kernel_op_333 = ((tmp_kernel_op_130) ? (nz_dof_4): (1.0));
             const real_t tmp_kernel_op_334 = ((tmp_kernel_op_130) ? (nx_dof_4): (0.0));
             const real_t tmp_kernel_op_335 = ((tmp_kernel_op_158) ? (ny_dof_5): (0.0));
             const real_t tmp_kernel_op_336 = ((tmp_kernel_op_158) ? (nz_dof_5): (1.0));
             const real_t tmp_kernel_op_337 = ((tmp_kernel_op_158) ? (nx_dof_5): (0.0));
             const real_t tmp_kernel_op_338 = ((tmp_kernel_op_186) ? (ny_dof_6): (0.0));
             const real_t tmp_kernel_op_339 = ((tmp_kernel_op_186) ? (nz_dof_6): (1.0));
             const real_t tmp_kernel_op_340 = ((tmp_kernel_op_186) ? (nx_dof_6): (0.0));
             const real_t tmp_kernel_op_341 = ((tmp_kernel_op_214) ? (ny_dof_7): (0.0));
             const real_t tmp_kernel_op_342 = ((tmp_kernel_op_214) ? (nz_dof_7): (1.0));
             const real_t tmp_kernel_op_343 = ((tmp_kernel_op_214) ? (nx_dof_7): (0.0));
             const real_t tmp_kernel_op_344 = ((tmp_kernel_op_242) ? (ny_dof_8): (0.0));
             const real_t tmp_kernel_op_345 = ((tmp_kernel_op_242) ? (nz_dof_8): (1.0));
             const real_t tmp_kernel_op_346 = ((tmp_kernel_op_242) ? (nx_dof_8): (0.0));
             const real_t tmp_kernel_op_347 = ((tmp_kernel_op_270) ? (ny_dof_9): (0.0));
             const real_t tmp_kernel_op_348 = ((tmp_kernel_op_270) ? (nz_dof_9): (1.0));
             const real_t tmp_kernel_op_349 = ((tmp_kernel_op_270) ? (nx_dof_9): (0.0));
             const real_t elMat_0_0 = q_acc_0_0*tmp_kernel_op_19 + q_acc_10_0*tmp_kernel_op_22 + q_acc_20_0*tmp_kernel_op_27;
             const real_t elMat_0_1 = q_acc_0_1*tmp_kernel_op_19 + q_acc_10_1*tmp_kernel_op_22 + q_acc_20_1*tmp_kernel_op_27;
             const real_t elMat_0_2 = q_acc_0_2*tmp_kernel_op_19 + q_acc_10_2*tmp_kernel_op_22 + q_acc_20_2*tmp_kernel_op_27;
             const real_t elMat_0_3 = q_acc_0_3*tmp_kernel_op_19 + q_acc_10_3*tmp_kernel_op_22 + q_acc_20_3*tmp_kernel_op_27;
             const real_t elMat_1_0 = q_acc_11_0*tmp_kernel_op_47 + q_acc_1_0*tmp_kernel_op_50 + q_acc_21_0*tmp_kernel_op_55;
             const real_t elMat_1_1 = q_acc_11_1*tmp_kernel_op_47 + q_acc_1_1*tmp_kernel_op_50 + q_acc_21_1*tmp_kernel_op_55;
             const real_t elMat_1_2 = q_acc_11_2*tmp_kernel_op_47 + q_acc_1_2*tmp_kernel_op_50 + q_acc_21_2*tmp_kernel_op_55;
             const real_t elMat_1_3 = q_acc_11_3*tmp_kernel_op_47 + q_acc_1_3*tmp_kernel_op_50 + q_acc_21_3*tmp_kernel_op_55;
             const real_t elMat_2_0 = q_acc_12_0*tmp_kernel_op_75 + q_acc_22_0*tmp_kernel_op_81 + q_acc_2_0*tmp_kernel_op_83;
             const real_t elMat_2_1 = q_acc_12_1*tmp_kernel_op_75 + q_acc_22_1*tmp_kernel_op_81 + q_acc_2_1*tmp_kernel_op_83;
             const real_t elMat_2_2 = q_acc_12_2*tmp_kernel_op_75 + q_acc_22_2*tmp_kernel_op_81 + q_acc_2_2*tmp_kernel_op_83;
             const real_t elMat_2_3 = q_acc_12_3*tmp_kernel_op_75 + q_acc_22_3*tmp_kernel_op_81 + q_acc_2_3*tmp_kernel_op_83;
             const real_t elMat_3_0 = q_acc_13_0*tmp_kernel_op_103 + q_acc_23_0*tmp_kernel_op_109 + q_acc_3_0*tmp_kernel_op_111;
             const real_t elMat_3_1 = q_acc_13_1*tmp_kernel_op_103 + q_acc_23_1*tmp_kernel_op_109 + q_acc_3_1*tmp_kernel_op_111;
             const real_t elMat_3_2 = q_acc_13_2*tmp_kernel_op_103 + q_acc_23_2*tmp_kernel_op_109 + q_acc_3_2*tmp_kernel_op_111;
             const real_t elMat_3_3 = q_acc_13_3*tmp_kernel_op_103 + q_acc_23_3*tmp_kernel_op_109 + q_acc_3_3*tmp_kernel_op_111;
             const real_t elMat_4_0 = q_acc_14_0*tmp_kernel_op_131 + q_acc_24_0*tmp_kernel_op_137 + q_acc_4_0*tmp_kernel_op_139;
             const real_t elMat_4_1 = q_acc_14_1*tmp_kernel_op_131 + q_acc_24_1*tmp_kernel_op_137 + q_acc_4_1*tmp_kernel_op_139;
             const real_t elMat_4_2 = q_acc_14_2*tmp_kernel_op_131 + q_acc_24_2*tmp_kernel_op_137 + q_acc_4_2*tmp_kernel_op_139;
             const real_t elMat_4_3 = q_acc_14_3*tmp_kernel_op_131 + q_acc_24_3*tmp_kernel_op_137 + q_acc_4_3*tmp_kernel_op_139;
             const real_t elMat_5_0 = q_acc_15_0*tmp_kernel_op_159 + q_acc_25_0*tmp_kernel_op_165 + q_acc_5_0*tmp_kernel_op_167;
             const real_t elMat_5_1 = q_acc_15_1*tmp_kernel_op_159 + q_acc_25_1*tmp_kernel_op_165 + q_acc_5_1*tmp_kernel_op_167;
             const real_t elMat_5_2 = q_acc_15_2*tmp_kernel_op_159 + q_acc_25_2*tmp_kernel_op_165 + q_acc_5_2*tmp_kernel_op_167;
             const real_t elMat_5_3 = q_acc_15_3*tmp_kernel_op_159 + q_acc_25_3*tmp_kernel_op_165 + q_acc_5_3*tmp_kernel_op_167;
             const real_t elMat_6_0 = q_acc_16_0*tmp_kernel_op_187 + q_acc_26_0*tmp_kernel_op_193 + q_acc_6_0*tmp_kernel_op_195;
             const real_t elMat_6_1 = q_acc_16_1*tmp_kernel_op_187 + q_acc_26_1*tmp_kernel_op_193 + q_acc_6_1*tmp_kernel_op_195;
             const real_t elMat_6_2 = q_acc_16_2*tmp_kernel_op_187 + q_acc_26_2*tmp_kernel_op_193 + q_acc_6_2*tmp_kernel_op_195;
             const real_t elMat_6_3 = q_acc_16_3*tmp_kernel_op_187 + q_acc_26_3*tmp_kernel_op_193 + q_acc_6_3*tmp_kernel_op_195;
             const real_t elMat_7_0 = q_acc_17_0*tmp_kernel_op_215 + q_acc_27_0*tmp_kernel_op_221 + q_acc_7_0*tmp_kernel_op_223;
             const real_t elMat_7_1 = q_acc_17_1*tmp_kernel_op_215 + q_acc_27_1*tmp_kernel_op_221 + q_acc_7_1*tmp_kernel_op_223;
             const real_t elMat_7_2 = q_acc_17_2*tmp_kernel_op_215 + q_acc_27_2*tmp_kernel_op_221 + q_acc_7_2*tmp_kernel_op_223;
             const real_t elMat_7_3 = q_acc_17_3*tmp_kernel_op_215 + q_acc_27_3*tmp_kernel_op_221 + q_acc_7_3*tmp_kernel_op_223;
             const real_t elMat_8_0 = q_acc_18_0*tmp_kernel_op_243 + q_acc_28_0*tmp_kernel_op_249 + q_acc_8_0*tmp_kernel_op_251;
             const real_t elMat_8_1 = q_acc_18_1*tmp_kernel_op_243 + q_acc_28_1*tmp_kernel_op_249 + q_acc_8_1*tmp_kernel_op_251;
             const real_t elMat_8_2 = q_acc_18_2*tmp_kernel_op_243 + q_acc_28_2*tmp_kernel_op_249 + q_acc_8_2*tmp_kernel_op_251;
             const real_t elMat_8_3 = q_acc_18_3*tmp_kernel_op_243 + q_acc_28_3*tmp_kernel_op_249 + q_acc_8_3*tmp_kernel_op_251;
             const real_t elMat_9_0 = q_acc_19_0*tmp_kernel_op_271 + q_acc_29_0*tmp_kernel_op_277 + q_acc_9_0*tmp_kernel_op_279;
             const real_t elMat_9_1 = q_acc_19_1*tmp_kernel_op_271 + q_acc_29_1*tmp_kernel_op_277 + q_acc_9_1*tmp_kernel_op_279;
             const real_t elMat_9_2 = q_acc_19_2*tmp_kernel_op_271 + q_acc_29_2*tmp_kernel_op_277 + q_acc_9_2*tmp_kernel_op_279;
             const real_t elMat_9_3 = q_acc_19_3*tmp_kernel_op_271 + q_acc_29_3*tmp_kernel_op_277 + q_acc_9_3*tmp_kernel_op_279;
             const real_t elMat_10_0 = q_acc_0_0*tmp_kernel_op_281 + q_acc_10_0*tmp_kernel_op_282 + q_acc_20_0*tmp_kernel_op_283;
             const real_t elMat_10_1 = q_acc_0_1*tmp_kernel_op_281 + q_acc_10_1*tmp_kernel_op_282 + q_acc_20_1*tmp_kernel_op_283;
             const real_t elMat_10_2 = q_acc_0_2*tmp_kernel_op_281 + q_acc_10_2*tmp_kernel_op_282 + q_acc_20_2*tmp_kernel_op_283;
             const real_t elMat_10_3 = q_acc_0_3*tmp_kernel_op_281 + q_acc_10_3*tmp_kernel_op_282 + q_acc_20_3*tmp_kernel_op_283;
             const real_t elMat_11_0 = q_acc_11_0*tmp_kernel_op_285 + q_acc_1_0*tmp_kernel_op_286 + q_acc_21_0*tmp_kernel_op_287;
             const real_t elMat_11_1 = q_acc_11_1*tmp_kernel_op_285 + q_acc_1_1*tmp_kernel_op_286 + q_acc_21_1*tmp_kernel_op_287;
             const real_t elMat_11_2 = q_acc_11_2*tmp_kernel_op_285 + q_acc_1_2*tmp_kernel_op_286 + q_acc_21_2*tmp_kernel_op_287;
             const real_t elMat_11_3 = q_acc_11_3*tmp_kernel_op_285 + q_acc_1_3*tmp_kernel_op_286 + q_acc_21_3*tmp_kernel_op_287;
             const real_t elMat_12_0 = q_acc_12_0*tmp_kernel_op_289 + q_acc_22_0*tmp_kernel_op_290 + q_acc_2_0*tmp_kernel_op_291;
             const real_t elMat_12_1 = q_acc_12_1*tmp_kernel_op_289 + q_acc_22_1*tmp_kernel_op_290 + q_acc_2_1*tmp_kernel_op_291;
             const real_t elMat_12_2 = q_acc_12_2*tmp_kernel_op_289 + q_acc_22_2*tmp_kernel_op_290 + q_acc_2_2*tmp_kernel_op_291;
             const real_t elMat_12_3 = q_acc_12_3*tmp_kernel_op_289 + q_acc_22_3*tmp_kernel_op_290 + q_acc_2_3*tmp_kernel_op_291;
             const real_t elMat_13_0 = q_acc_13_0*tmp_kernel_op_293 + q_acc_23_0*tmp_kernel_op_294 + q_acc_3_0*tmp_kernel_op_295;
             const real_t elMat_13_1 = q_acc_13_1*tmp_kernel_op_293 + q_acc_23_1*tmp_kernel_op_294 + q_acc_3_1*tmp_kernel_op_295;
             const real_t elMat_13_2 = q_acc_13_2*tmp_kernel_op_293 + q_acc_23_2*tmp_kernel_op_294 + q_acc_3_2*tmp_kernel_op_295;
             const real_t elMat_13_3 = q_acc_13_3*tmp_kernel_op_293 + q_acc_23_3*tmp_kernel_op_294 + q_acc_3_3*tmp_kernel_op_295;
             const real_t elMat_14_0 = q_acc_14_0*tmp_kernel_op_297 + q_acc_24_0*tmp_kernel_op_298 + q_acc_4_0*tmp_kernel_op_299;
             const real_t elMat_14_1 = q_acc_14_1*tmp_kernel_op_297 + q_acc_24_1*tmp_kernel_op_298 + q_acc_4_1*tmp_kernel_op_299;
             const real_t elMat_14_2 = q_acc_14_2*tmp_kernel_op_297 + q_acc_24_2*tmp_kernel_op_298 + q_acc_4_2*tmp_kernel_op_299;
             const real_t elMat_14_3 = q_acc_14_3*tmp_kernel_op_297 + q_acc_24_3*tmp_kernel_op_298 + q_acc_4_3*tmp_kernel_op_299;
             const real_t elMat_15_0 = q_acc_15_0*tmp_kernel_op_301 + q_acc_25_0*tmp_kernel_op_302 + q_acc_5_0*tmp_kernel_op_303;
             const real_t elMat_15_1 = q_acc_15_1*tmp_kernel_op_301 + q_acc_25_1*tmp_kernel_op_302 + q_acc_5_1*tmp_kernel_op_303;
             const real_t elMat_15_2 = q_acc_15_2*tmp_kernel_op_301 + q_acc_25_2*tmp_kernel_op_302 + q_acc_5_2*tmp_kernel_op_303;
             const real_t elMat_15_3 = q_acc_15_3*tmp_kernel_op_301 + q_acc_25_3*tmp_kernel_op_302 + q_acc_5_3*tmp_kernel_op_303;
             const real_t elMat_16_0 = q_acc_16_0*tmp_kernel_op_305 + q_acc_26_0*tmp_kernel_op_306 + q_acc_6_0*tmp_kernel_op_307;
             const real_t elMat_16_1 = q_acc_16_1*tmp_kernel_op_305 + q_acc_26_1*tmp_kernel_op_306 + q_acc_6_1*tmp_kernel_op_307;
             const real_t elMat_16_2 = q_acc_16_2*tmp_kernel_op_305 + q_acc_26_2*tmp_kernel_op_306 + q_acc_6_2*tmp_kernel_op_307;
             const real_t elMat_16_3 = q_acc_16_3*tmp_kernel_op_305 + q_acc_26_3*tmp_kernel_op_306 + q_acc_6_3*tmp_kernel_op_307;
             const real_t elMat_17_0 = q_acc_17_0*tmp_kernel_op_309 + q_acc_27_0*tmp_kernel_op_310 + q_acc_7_0*tmp_kernel_op_311;
             const real_t elMat_17_1 = q_acc_17_1*tmp_kernel_op_309 + q_acc_27_1*tmp_kernel_op_310 + q_acc_7_1*tmp_kernel_op_311;
             const real_t elMat_17_2 = q_acc_17_2*tmp_kernel_op_309 + q_acc_27_2*tmp_kernel_op_310 + q_acc_7_2*tmp_kernel_op_311;
             const real_t elMat_17_3 = q_acc_17_3*tmp_kernel_op_309 + q_acc_27_3*tmp_kernel_op_310 + q_acc_7_3*tmp_kernel_op_311;
             const real_t elMat_18_0 = q_acc_18_0*tmp_kernel_op_313 + q_acc_28_0*tmp_kernel_op_314 + q_acc_8_0*tmp_kernel_op_315;
             const real_t elMat_18_1 = q_acc_18_1*tmp_kernel_op_313 + q_acc_28_1*tmp_kernel_op_314 + q_acc_8_1*tmp_kernel_op_315;
             const real_t elMat_18_2 = q_acc_18_2*tmp_kernel_op_313 + q_acc_28_2*tmp_kernel_op_314 + q_acc_8_2*tmp_kernel_op_315;
             const real_t elMat_18_3 = q_acc_18_3*tmp_kernel_op_313 + q_acc_28_3*tmp_kernel_op_314 + q_acc_8_3*tmp_kernel_op_315;
             const real_t elMat_19_0 = q_acc_19_0*tmp_kernel_op_317 + q_acc_29_0*tmp_kernel_op_318 + q_acc_9_0*tmp_kernel_op_319;
             const real_t elMat_19_1 = q_acc_19_1*tmp_kernel_op_317 + q_acc_29_1*tmp_kernel_op_318 + q_acc_9_1*tmp_kernel_op_319;
             const real_t elMat_19_2 = q_acc_19_2*tmp_kernel_op_317 + q_acc_29_2*tmp_kernel_op_318 + q_acc_9_2*tmp_kernel_op_319;
             const real_t elMat_19_3 = q_acc_19_3*tmp_kernel_op_317 + q_acc_29_3*tmp_kernel_op_318 + q_acc_9_3*tmp_kernel_op_319;
             const real_t elMat_20_0 = q_acc_0_0*tmp_kernel_op_320 + q_acc_10_0*tmp_kernel_op_321 + q_acc_20_0*tmp_kernel_op_322;
             const real_t elMat_20_1 = q_acc_0_1*tmp_kernel_op_320 + q_acc_10_1*tmp_kernel_op_321 + q_acc_20_1*tmp_kernel_op_322;
             const real_t elMat_20_2 = q_acc_0_2*tmp_kernel_op_320 + q_acc_10_2*tmp_kernel_op_321 + q_acc_20_2*tmp_kernel_op_322;
             const real_t elMat_20_3 = q_acc_0_3*tmp_kernel_op_320 + q_acc_10_3*tmp_kernel_op_321 + q_acc_20_3*tmp_kernel_op_322;
             const real_t elMat_21_0 = q_acc_11_0*tmp_kernel_op_323 + q_acc_1_0*tmp_kernel_op_324 + q_acc_21_0*tmp_kernel_op_325;
             const real_t elMat_21_1 = q_acc_11_1*tmp_kernel_op_323 + q_acc_1_1*tmp_kernel_op_324 + q_acc_21_1*tmp_kernel_op_325;
             const real_t elMat_21_2 = q_acc_11_2*tmp_kernel_op_323 + q_acc_1_2*tmp_kernel_op_324 + q_acc_21_2*tmp_kernel_op_325;
             const real_t elMat_21_3 = q_acc_11_3*tmp_kernel_op_323 + q_acc_1_3*tmp_kernel_op_324 + q_acc_21_3*tmp_kernel_op_325;
             const real_t elMat_22_0 = q_acc_12_0*tmp_kernel_op_326 + q_acc_22_0*tmp_kernel_op_327 + q_acc_2_0*tmp_kernel_op_328;
             const real_t elMat_22_1 = q_acc_12_1*tmp_kernel_op_326 + q_acc_22_1*tmp_kernel_op_327 + q_acc_2_1*tmp_kernel_op_328;
             const real_t elMat_22_2 = q_acc_12_2*tmp_kernel_op_326 + q_acc_22_2*tmp_kernel_op_327 + q_acc_2_2*tmp_kernel_op_328;
             const real_t elMat_22_3 = q_acc_12_3*tmp_kernel_op_326 + q_acc_22_3*tmp_kernel_op_327 + q_acc_2_3*tmp_kernel_op_328;
             const real_t elMat_23_0 = q_acc_13_0*tmp_kernel_op_329 + q_acc_23_0*tmp_kernel_op_330 + q_acc_3_0*tmp_kernel_op_331;
             const real_t elMat_23_1 = q_acc_13_1*tmp_kernel_op_329 + q_acc_23_1*tmp_kernel_op_330 + q_acc_3_1*tmp_kernel_op_331;
             const real_t elMat_23_2 = q_acc_13_2*tmp_kernel_op_329 + q_acc_23_2*tmp_kernel_op_330 + q_acc_3_2*tmp_kernel_op_331;
             const real_t elMat_23_3 = q_acc_13_3*tmp_kernel_op_329 + q_acc_23_3*tmp_kernel_op_330 + q_acc_3_3*tmp_kernel_op_331;
             const real_t elMat_24_0 = q_acc_14_0*tmp_kernel_op_332 + q_acc_24_0*tmp_kernel_op_333 + q_acc_4_0*tmp_kernel_op_334;
             const real_t elMat_24_1 = q_acc_14_1*tmp_kernel_op_332 + q_acc_24_1*tmp_kernel_op_333 + q_acc_4_1*tmp_kernel_op_334;
             const real_t elMat_24_2 = q_acc_14_2*tmp_kernel_op_332 + q_acc_24_2*tmp_kernel_op_333 + q_acc_4_2*tmp_kernel_op_334;
             const real_t elMat_24_3 = q_acc_14_3*tmp_kernel_op_332 + q_acc_24_3*tmp_kernel_op_333 + q_acc_4_3*tmp_kernel_op_334;
             const real_t elMat_25_0 = q_acc_15_0*tmp_kernel_op_335 + q_acc_25_0*tmp_kernel_op_336 + q_acc_5_0*tmp_kernel_op_337;
             const real_t elMat_25_1 = q_acc_15_1*tmp_kernel_op_335 + q_acc_25_1*tmp_kernel_op_336 + q_acc_5_1*tmp_kernel_op_337;
             const real_t elMat_25_2 = q_acc_15_2*tmp_kernel_op_335 + q_acc_25_2*tmp_kernel_op_336 + q_acc_5_2*tmp_kernel_op_337;
             const real_t elMat_25_3 = q_acc_15_3*tmp_kernel_op_335 + q_acc_25_3*tmp_kernel_op_336 + q_acc_5_3*tmp_kernel_op_337;
             const real_t elMat_26_0 = q_acc_16_0*tmp_kernel_op_338 + q_acc_26_0*tmp_kernel_op_339 + q_acc_6_0*tmp_kernel_op_340;
             const real_t elMat_26_1 = q_acc_16_1*tmp_kernel_op_338 + q_acc_26_1*tmp_kernel_op_339 + q_acc_6_1*tmp_kernel_op_340;
             const real_t elMat_26_2 = q_acc_16_2*tmp_kernel_op_338 + q_acc_26_2*tmp_kernel_op_339 + q_acc_6_2*tmp_kernel_op_340;
             const real_t elMat_26_3 = q_acc_16_3*tmp_kernel_op_338 + q_acc_26_3*tmp_kernel_op_339 + q_acc_6_3*tmp_kernel_op_340;
             const real_t elMat_27_0 = q_acc_17_0*tmp_kernel_op_341 + q_acc_27_0*tmp_kernel_op_342 + q_acc_7_0*tmp_kernel_op_343;
             const real_t elMat_27_1 = q_acc_17_1*tmp_kernel_op_341 + q_acc_27_1*tmp_kernel_op_342 + q_acc_7_1*tmp_kernel_op_343;
             const real_t elMat_27_2 = q_acc_17_2*tmp_kernel_op_341 + q_acc_27_2*tmp_kernel_op_342 + q_acc_7_2*tmp_kernel_op_343;
             const real_t elMat_27_3 = q_acc_17_3*tmp_kernel_op_341 + q_acc_27_3*tmp_kernel_op_342 + q_acc_7_3*tmp_kernel_op_343;
             const real_t elMat_28_0 = q_acc_18_0*tmp_kernel_op_344 + q_acc_28_0*tmp_kernel_op_345 + q_acc_8_0*tmp_kernel_op_346;
             const real_t elMat_28_1 = q_acc_18_1*tmp_kernel_op_344 + q_acc_28_1*tmp_kernel_op_345 + q_acc_8_1*tmp_kernel_op_346;
             const real_t elMat_28_2 = q_acc_18_2*tmp_kernel_op_344 + q_acc_28_2*tmp_kernel_op_345 + q_acc_8_2*tmp_kernel_op_346;
             const real_t elMat_28_3 = q_acc_18_3*tmp_kernel_op_344 + q_acc_28_3*tmp_kernel_op_345 + q_acc_8_3*tmp_kernel_op_346;
             const real_t elMat_29_0 = q_acc_19_0*tmp_kernel_op_347 + q_acc_29_0*tmp_kernel_op_348 + q_acc_9_0*tmp_kernel_op_349;
             const real_t elMat_29_1 = q_acc_19_1*tmp_kernel_op_347 + q_acc_29_1*tmp_kernel_op_348 + q_acc_9_1*tmp_kernel_op_349;
             const real_t elMat_29_2 = q_acc_19_2*tmp_kernel_op_347 + q_acc_29_2*tmp_kernel_op_348 + q_acc_9_2*tmp_kernel_op_349;
             const real_t elMat_29_3 = q_acc_19_3*tmp_kernel_op_347 + q_acc_29_3*tmp_kernel_op_348 + q_acc_9_3*tmp_kernel_op_349;
         
             std::vector< uint_t > _data_rowIdx( 30 );
             std::vector< uint_t > _data_colIdx( 4 );
             std::vector< real_t > _data_mat( 120 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[12] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[13] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[14] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[15] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[16] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[17] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[18] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[19] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[20] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[21] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[22] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[23] = ((uint64_t)(_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[24] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[25] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[26] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[27] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[28] = ((uint64_t)(_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[29] = ((uint64_t)(_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_1_0));
             _data_mat[5] = ((real_t)(elMat_1_1));
             _data_mat[6] = ((real_t)(elMat_1_2));
             _data_mat[7] = ((real_t)(elMat_1_3));
             _data_mat[8] = ((real_t)(elMat_2_0));
             _data_mat[9] = ((real_t)(elMat_2_1));
             _data_mat[10] = ((real_t)(elMat_2_2));
             _data_mat[11] = ((real_t)(elMat_2_3));
             _data_mat[12] = ((real_t)(elMat_3_0));
             _data_mat[13] = ((real_t)(elMat_3_1));
             _data_mat[14] = ((real_t)(elMat_3_2));
             _data_mat[15] = ((real_t)(elMat_3_3));
             _data_mat[16] = ((real_t)(elMat_4_0));
             _data_mat[17] = ((real_t)(elMat_4_1));
             _data_mat[18] = ((real_t)(elMat_4_2));
             _data_mat[19] = ((real_t)(elMat_4_3));
             _data_mat[20] = ((real_t)(elMat_5_0));
             _data_mat[21] = ((real_t)(elMat_5_1));
             _data_mat[22] = ((real_t)(elMat_5_2));
             _data_mat[23] = ((real_t)(elMat_5_3));
             _data_mat[24] = ((real_t)(elMat_6_0));
             _data_mat[25] = ((real_t)(elMat_6_1));
             _data_mat[26] = ((real_t)(elMat_6_2));
             _data_mat[27] = ((real_t)(elMat_6_3));
             _data_mat[28] = ((real_t)(elMat_7_0));
             _data_mat[29] = ((real_t)(elMat_7_1));
             _data_mat[30] = ((real_t)(elMat_7_2));
             _data_mat[31] = ((real_t)(elMat_7_3));
             _data_mat[32] = ((real_t)(elMat_8_0));
             _data_mat[33] = ((real_t)(elMat_8_1));
             _data_mat[34] = ((real_t)(elMat_8_2));
             _data_mat[35] = ((real_t)(elMat_8_3));
             _data_mat[36] = ((real_t)(elMat_9_0));
             _data_mat[37] = ((real_t)(elMat_9_1));
             _data_mat[38] = ((real_t)(elMat_9_2));
             _data_mat[39] = ((real_t)(elMat_9_3));
             _data_mat[40] = ((real_t)(elMat_10_0));
             _data_mat[41] = ((real_t)(elMat_10_1));
             _data_mat[42] = ((real_t)(elMat_10_2));
             _data_mat[43] = ((real_t)(elMat_10_3));
             _data_mat[44] = ((real_t)(elMat_11_0));
             _data_mat[45] = ((real_t)(elMat_11_1));
             _data_mat[46] = ((real_t)(elMat_11_2));
             _data_mat[47] = ((real_t)(elMat_11_3));
             _data_mat[48] = ((real_t)(elMat_12_0));
             _data_mat[49] = ((real_t)(elMat_12_1));
             _data_mat[50] = ((real_t)(elMat_12_2));
             _data_mat[51] = ((real_t)(elMat_12_3));
             _data_mat[52] = ((real_t)(elMat_13_0));
             _data_mat[53] = ((real_t)(elMat_13_1));
             _data_mat[54] = ((real_t)(elMat_13_2));
             _data_mat[55] = ((real_t)(elMat_13_3));
             _data_mat[56] = ((real_t)(elMat_14_0));
             _data_mat[57] = ((real_t)(elMat_14_1));
             _data_mat[58] = ((real_t)(elMat_14_2));
             _data_mat[59] = ((real_t)(elMat_14_3));
             _data_mat[60] = ((real_t)(elMat_15_0));
             _data_mat[61] = ((real_t)(elMat_15_1));
             _data_mat[62] = ((real_t)(elMat_15_2));
             _data_mat[63] = ((real_t)(elMat_15_3));
             _data_mat[64] = ((real_t)(elMat_16_0));
             _data_mat[65] = ((real_t)(elMat_16_1));
             _data_mat[66] = ((real_t)(elMat_16_2));
             _data_mat[67] = ((real_t)(elMat_16_3));
             _data_mat[68] = ((real_t)(elMat_17_0));
             _data_mat[69] = ((real_t)(elMat_17_1));
             _data_mat[70] = ((real_t)(elMat_17_2));
             _data_mat[71] = ((real_t)(elMat_17_3));
             _data_mat[72] = ((real_t)(elMat_18_0));
             _data_mat[73] = ((real_t)(elMat_18_1));
             _data_mat[74] = ((real_t)(elMat_18_2));
             _data_mat[75] = ((real_t)(elMat_18_3));
             _data_mat[76] = ((real_t)(elMat_19_0));
             _data_mat[77] = ((real_t)(elMat_19_1));
             _data_mat[78] = ((real_t)(elMat_19_2));
             _data_mat[79] = ((real_t)(elMat_19_3));
             _data_mat[80] = ((real_t)(elMat_20_0));
             _data_mat[81] = ((real_t)(elMat_20_1));
             _data_mat[82] = ((real_t)(elMat_20_2));
             _data_mat[83] = ((real_t)(elMat_20_3));
             _data_mat[84] = ((real_t)(elMat_21_0));
             _data_mat[85] = ((real_t)(elMat_21_1));
             _data_mat[86] = ((real_t)(elMat_21_2));
             _data_mat[87] = ((real_t)(elMat_21_3));
             _data_mat[88] = ((real_t)(elMat_22_0));
             _data_mat[89] = ((real_t)(elMat_22_1));
             _data_mat[90] = ((real_t)(elMat_22_2));
             _data_mat[91] = ((real_t)(elMat_22_3));
             _data_mat[92] = ((real_t)(elMat_23_0));
             _data_mat[93] = ((real_t)(elMat_23_1));
             _data_mat[94] = ((real_t)(elMat_23_2));
             _data_mat[95] = ((real_t)(elMat_23_3));
             _data_mat[96] = ((real_t)(elMat_24_0));
             _data_mat[97] = ((real_t)(elMat_24_1));
             _data_mat[98] = ((real_t)(elMat_24_2));
             _data_mat[99] = ((real_t)(elMat_24_3));
             _data_mat[100] = ((real_t)(elMat_25_0));
             _data_mat[101] = ((real_t)(elMat_25_1));
             _data_mat[102] = ((real_t)(elMat_25_2));
             _data_mat[103] = ((real_t)(elMat_25_3));
             _data_mat[104] = ((real_t)(elMat_26_0));
             _data_mat[105] = ((real_t)(elMat_26_1));
             _data_mat[106] = ((real_t)(elMat_26_2));
             _data_mat[107] = ((real_t)(elMat_26_3));
             _data_mat[108] = ((real_t)(elMat_27_0));
             _data_mat[109] = ((real_t)(elMat_27_1));
             _data_mat[110] = ((real_t)(elMat_27_2));
             _data_mat[111] = ((real_t)(elMat_27_3));
             _data_mat[112] = ((real_t)(elMat_28_0));
             _data_mat[113] = ((real_t)(elMat_28_1));
             _data_mat[114] = ((real_t)(elMat_28_2));
             _data_mat[115] = ((real_t)(elMat_28_3));
             _data_mat[116] = ((real_t)(elMat_29_0));
             _data_mat[117] = ((real_t)(elMat_29_1));
             _data_mat[118] = ((real_t)(elMat_29_2));
             _data_mat[119] = ((real_t)(elMat_29_3));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
